glpi-smartcities
================

GLPI for Smart Cities by Juan Fernando Villa Hernández | GLPI Evangelist aKa @elitelinux
link to GLPI: https://fr.wikipedia.org/wiki/Gestion_libre_de_parc_informatique

License
========
See link: https://es.wikipedia.org/wiki/GNU_General_Public_License

What is a Smart City?
=========
Smart City is a "Buzzword".

What is a Buzzword?
===================
check here: 
- http://www.urbandictionary.com/define.php?term=buzz+words.
- http://projects.wsj.com/buzzwords2014/
- http://en.wikipedia.org/wiki/Buzzword

Seriously. What is a Smart City?
================================
According to wikipedia this is a smart city: See link http://en.wikipedia.org/wiki/Smart_city
From another perspective academic a Smart City is one city where their services and products are aimed at improving the quality of life of its habitants, increase their welfare and security, economic prosperity through the use of best practices and standards, assuming e implementing a model of technocratic government. In that city, the use of comparative advantages is done to achieve various surplus needed to generate the necessary human capital and sustain investments in diverse areas needed and involve becoming a Smart City.

Easy right? and this is just the beginning.

Why GLPI?
=========
GLPI is an excellent software that has been undervalued and is little known or used. Many of the things you normally need to do, do not require platforms such as SAP, Groupwares, Some CRMs and ERPs . In GLPI is enough. Take a look at what can do a properly configured GLPI.

Improvements in this version compared to the original version
=============================================================
Improvements in:
- Security in htaccess - by Juan Fernando Villa link: https://github.com/elitelinux/killer-htaccess
- Styles in GUI and Look and feel in CSS and html5 - by Stevenes Donato link: http://sourceforge.net/projects/glpibootstrap/
- Full Pack of Plugins and another addons

The True
========
The GLPI is complex to parameterize . You will need patience, a team of multi-disciplinary, will need skilled people in:
- Open Source
- Programming languages
- Project management
- Information management
- Knowledge management
- Resource management
- Network systems
- High availability systems
- High performance systems
- Database management
- Information security
- Protocols
- Methods
- Standards

Although you may not believe... And of course...
* GNU/LINUX 🐧 (are you mad bro?😜)

Profile of the Team
===================
People with this knowledge or certifications will acellerate the process
- A+
- Network+
- ITIL (foundation)
- Project Management
- Web programmer (PHP, Shell, Python)
- Knowledge Management
- Linux+
- CISM - CISA
- Quality Systems Expert

Terms of implementation
=======================
The estimated duration for projects with GLPI phases: 
- GLPI installation - 1 Week
- Learn curve - 6-10 weeks
- Audit (initial investigation) – 4-8 weeks
- Design and description of a single process – 3-4 weeks
- Automation of a single process – 1-3 months
- Working smooth in many aspects - 1 year

How much is this software?
==========================
How much is this software? It depends. The software is "Open Source" and "Free" where they must comply with the GPL license with which this comes.
On the other hand if you do not want to pay for support or seek a professional You MUST do it all by yourself. and believe me you take long have ready the GLPI. You need to hire a group of people with knowledge and technical skills for this activity, you need to buy your cloud computing and adjust the equipment and the necessary infrastructure to carry out this project.

Where is the magic?
===================
One of these features is to manage smart cities.
Yes. You've read it correctly. After the thick haze of commercial words are always the same tasks that can be performed with known methods and tools but in an innovative way and according to current needs.
Remember: Change the dress but not the bride. Good Luck!

First
=====
The system must be configured, to be adapted and should be parameterized according to your needs to make " Magic"
-This is not a turnkey solution-
Know the naked GLPI: http://demo.glpi-project.org/ User: admin_en Password: admin

Documentation
=============
Basic documentation about GLPI
https://forge.indepnet.net/attachments/download/1901/glpidoc-0.85-en-partial.pdf

Some Features
=============
-  Track everything. Capture and organize issues, plan and assign work, and follow team activity.
-  Service and support for IT teams.
-  Give your team one place to share, find, and collaborate on information and activities they need to get work done.
-  Knowledge Base / FAQ
-  Customizable dimensional support

General
=======
Part of the features of GLPI:
- Multi-entities management (multi-park, multi-structure) 
- Multi-users management 
- Multiple Authentication System (local, LDAP, AD, Pop/Imap, CAS, x509...) and multiple servers 
- Multilingual management (45 languages available ) 
- Permissions and profiles system 
- Pagination system 
- Complex search module 
- Bookmark search system 
- Publishing system for public or personal reminders 
- Publishing system for public or personal RSS feeds 
- Configurability of display fields in lists 
- Export System in PDF, CSV, SLK (spreadsheet), PNG and SVG 
- Saving/restoration module of the database to the SQL format 
- Exportation of the database to the XML format 
- Configurable dropdowns 
- Dictionary 
- System of notifications on events (consumable stock, expiry of contracts and licenses), customizable and by entity 
- Customizable cron tasks 
- Updates check system 
- UTF8 interface 
- HTML 4.01 compatibility

Inventory
=========

- Import inventory’s datas from OCS Inventory NG servers with the plugin OCS Inventory NG 
- Import inventory’s datas from FusionInventory agents with the plugin FusionInventory 
- Inventory of the computers fleet with management of its components, disk space and TCO management 
- Inventory of the monitors with management of the connections to the computers 
- Inventory of the network hardware fleet with management of the connections to the devices (IP, Mac addresses, VLANs...). 
- Inventory of printers fleet with management of connections to the computers and management of consumable associated and consumption and the thresholds of alarm.
- Inventory of the external devices (scanners, graphical tables...) with management of the connections to the computers - Inventory of the telephones fleet with management of connections to the computers 
- Inventory if the software fleet with license and expiration dates management 
- Assignment of the hardware by geographic area (room, floor...) 
- Typing models management to make the insertion of equal configurations easier 
- Administrative and financial Information management (purchase, guarantee and extension, damping) 
- Filing of the materials left the inventory 
- Management of the status of the hardwares 
- Management of the various states for the materials (in repair...) - Management of generic peripherals and monitors being able to be associated several computers 
- Management of external bonds towards other applications 
- History of the modifications on the elements of the inventory

Servicedesk ITIL compliant
==========================

- Management of the tracking requests for all the types of material of the inventory 
- Management of recurrent tracking requests for regular maintenance 
- Problems management 
- Change management 
- Project management with Gantt graphs 
- Tracking requests opened using web interface or email 
- Business rules when opening tickets (customizable by entity) 
- SLA with escalation (customizable by entity)

Final user
==========

- Final user front-end for intervention demand 
- Mail tracking of the intervention demand feature 
- Interventions history consultation 
- Possibility of adding comments at the request of intervention using web interface or email 
- Approval of the solution 
- Satisfaction survey

Technicians
===========
Technical aspects:
- Interventions demands priority management 
- Interventions demands templates with management of hidden, mandatory and predefined fields 
- Tracking of interventions demands 
- Link between interventions demands management 
- Mail tracking of interventions 
- Request validation 
- Assignment of interventions demands 
- Opening/Closing/Re-opening of interventions 
- Assignment of a real time of interventions 
- History of done interventions 
- Displaying of the interventions to do by a technician 
- Displaying of the history of the interventions for a given hardware 
- Posting of the interventions to be realized by technician 
- Check availability of technicians before assignment of an intervention 
- Posting of the history of the interventions for a given material 
- Management of planning of intervention 
- Define the solution

Statistics
==========
Statistics reports by month, year, total in PNG, SVG or CSV.
- Global 
- By technician or enterprise 
- By hardware, location or type 
- By user 
- By category 
- By priority

General Management
==========

- Management of enterprises (manufacturers, suppliers, conveyors, people receiving benefits...) and associated contacts 
- Management of the contracts (loan, hiring, leasing, insurance, maintenance and service) 
- Management of the documents related to the elements of inventories, contracts... 
- Management of the types of authorized documents 
- Budget management

ITSM processes
==============
- Configuration Management
- Incident Management
- Service Request Management
- Problem Management
- SLA Management
- Knowledge Management
- Accounting Management
- Budget Management
- Supplier Management
- Contact Management
- Contract Management
- Document Management

Reservation
===========
Make by the easy way the reservations:
- Management of the reservations for the material in affected inventory with the park of loan 
- User interface (calendar) for reservation

Knowledge Database
==================
Make your own KB system for Knowledge management.
- Management of a basic system of knowledge hierarchical 
- Management of a public FAQ 
- Content management by targets

Reports
=======
Reports generation about the devices
- By device-type 
- By associated contract 
- By commercial informations
- Network Reports

Quality Process
===============
- Projects
- Help in the making of the Manuals and protocols
- Document control
- Control of records
- Responsibility and authority
- Management review
- Help in the making of the DAFO for Training, competency and awareness
- Infrastructure
- Location and Work environment
- Design and development
- Purchasing and outsourcing
- Control of measuring equipment
- Internal audit
- Corrective action
- Preventive action
- Operational controls
- Special process validation
- Incoming inspection

Adaptable to Standards
======================
- Quality management ISO 9000 Link: https://www.iso.org/obp/ui/#iso:std:iso:9001:ed-4:v2:en 
- Environmental management ISO 14001 Link: https://www.iso.org/obp/ui/#iso:std:iso:14001:ed-2:v1:en
- Information and documentation ISO 15489 Link: https://www.iso.org/obp/ui/#iso:std:iso:15489:-1:ed-1:v1:en
- Quality Managemen Systems ISO 18091 link: https://www.iso.org/obp/ui/#iso:std:iso:18091:ed-1:v1:en
- Service management ISO 20000 Link: https://www.iso.org/obp/ui/#iso:std:iso-iec:20000:-1:ed-2:v1:en
- Sustainable events ISO 20121 Link: https://www.iso.org/obp/ui/#iso:std:iso:20121:ed-1:v1:en
- Guidance on Project Management ISO 21500 Link: https://www.iso.org/obp/ui/#iso:std:iso:21500:ed-1:v1:en
- Social responsibility ISO 26000 Link: https://www.iso.org/obp/ui/#iso:std:iso:26000:ed-1:v1:en
- Information Security Management ISO 27001 Link: https://www.iso.org/obp/ui/#iso:std:iso-iec:27001:ed-2:v1:en
- Information Security Management System ISO 27002 link: https://www.iso.org/obp/ui/#iso:std:iso-iec:27002:ed-2:v1:en
- Management systems for records ISO 30300 Link: https://www.iso.org/obp/ui/#iso:std:iso:30300:ed-1:v1:en
- Risk management ISO 31000 Link: https://www.iso.org/obp/ui/#iso:std:iso:31000:ed-1:v1:en
- Sustainable development of communities ISO 37120 Link: https://www.iso.org/obp/ui/#iso:std:iso:37120:ed-1:v1:en
- Smart community infrastructures ISO 37150 Link : https://www.iso.org/obp/ui/#iso:std:iso:tr:37150:ed-1:v1:en
- Occupational Health and Safety Management Standard ISO 45000 Link: https://www.iso.org/obp/ui/#iso:std:iso:45000:ed-1:v1:en

Check a Complete collection link: https://www.iso.org/obp/ui/#iso:pub:PUB200013:en

Check another possible compliants: link: http://en.wikipedia.org/wiki/List_of_International_Organization_for_Standardization_standards

Adaptable or Compliant to Methods
=================================
- 8Ds Link: http://en.wikipedia.org/wiki/Eight_Disciplines_Problem_Solving
- 9R Link: ?
- ITIL Link: http://en.wikipedia.org/wiki/Information_Technology_Infrastructure_Library
- 5W2H Link: http://healthit.ahrq.gov/health-it-tools-and-resources/workflow-assessment-health-it-toolkit/all-workflow-tools/5w2h
- PDCA Link: http://en.wikipedia.org/wiki/PDCA
- PMBOK Link: http://en.wikipedia.org/wiki/A_Guide_to_the_Project_Management_Body_of_Knowledge
- Six Sigma link: http://en.wikipedia.org/wiki/Six_Sigma
- Kaizen Link: http://en.wikipedia.org/wiki/Kaizen
- Hackathons link: http://en.wikipedia.org/wiki/Hackathon
- GTD Link: http://en.wikipedia.org/wiki/Getting_Things_Done
- Life Hacking link: http://en.wikipedia.org/wiki/Life_hacking

Adaptable or Compliant to Frameworks
====================================
- Cybersecurity Framework link: http://www.nist.gov/cyberframework/
- Cyber Risk and Resilience Management link: http://cert.org/resilience/
 
Potentials
==========
Other Features of the GLPI in their core:
- CMS link: http://en.wikipedia.org/wiki/Content_management_system
- CMDB link: http://en.wikipedia.org/wiki/Configuration_management_database
- CRM Parts: http://en.wikipedia.org/wiki/Customer_relationship_management
- FAQ System: http://en.wikipedia.org/wiki/FAQ
- Ticket System: (also issue tracking system, ITS, trouble ticket system, support ticket, request management or incident ticket system): http://en.wikipedia.org/wiki/Issue_tracking_system
- Helpdesk Support: http://en.wikipedia.org/wiki/Help_desk
- Collaborative software: http://en.wikipedia.org/wiki/Collaborative_software
- Datawarehouse: http://en.wikipedia.org/wiki/Data_warehouse
- Wiki System: http://en.wikipedia.org/wiki/Wiki

Integrations
============

- Nagios Link: http://www.nagios.org/
- FusionInventory Link: http://www.fusioninventory.org/
- Shinken Link: http://www.shinken-monitoring.org/
- OCS Inventory NG link - http://www.ocsinventory-ng.org/
- Zabbix link: http://www.zabbix.com/
- Mantis link: http://www.mantisbt.org/

Other applications integrable to GLPI:
- AD/LDAP
- Mail system
- SMTP plataforms
- CRM systems
- ERP systems
- CMS

Plugins
=======
List of the Plugins:
- Accounts link: https://forge.indepnet.net/projects/accounts
- Additional Alerts link: https://forge.indepnet.net/projects/additionalalerts
- Badges link: https://forge.indepnet.net/projects/badges
- Barscode	link: https://forge.indepnet.net/projects/barscode
- Behaviors link:	https://forge.indepnet.net/projects/behaviors
- Certificates link: https://forge.indepnet.net/projects/certificates
- Chat link: http://sourceforge.net/projects/glpichat/files/0.85/
- Custom Colors link:https://github.com/TECLIB/custom/releases
- Custom Fields link: https://forge.indepnet.net/projects/customfields
- Dashboard	link:https://forge.indepnet.net/projects/dashboard
- Data Injection link: https://forge.indepnet.net/projects/datainjection
- Enviroment link: https://forge.indepnet.net/projects/environment
- Financials Reports link: https://forge.indepnet.net/projects/financialreports
- Form Creator link: https://github.com/TECLIB/formcreator/releases
- Fusion Inventory link:http://forge.fusioninventory.org/projects/fusioninventory-for-glpi
- Groupead	link: https://forge.indepnet.net/projects/groupead
- Monitoring (Nagios-Shinken)link https://forge.indepnet.net/projects/monitoring
- OCS Inventory link: https://forge.indepnet.net/projects/ocsinventoryng/
- Racks link: https://forge.indepnet.net/projects/racks
- Reforme	link: https://forge.indepnet.net/projects/reforme
- ShellCommands link: https://forge.indepnet.net/projects/shellcommands
- SIM Card link: https://github.com/pluginsGLPI/simcard
- Talk link: https://github.com/TECLIB/talk/releases
- Twins	link: https://forge.indepnet.net/projects/twins
- Webapplications link: https://forge.indepnet.net/projects/webapplications
- Webnotifications link:	https://forge.indepnet.net/projects/webnotifications
- Webservice link: http://sourceforge.net/projects/glpiwebservices/files/

Extras
======
Rules:
* https://www.siprossii.com/sites/default/files/rules_manufacturer_dictionnary_20140825.xml
* https://www.siprossii.com/sites/default/files/rules_software_dictionnary_20140825.xml
 
Templates
=========
Normal
* http://sourceforge.net/projects/glpithemes/files/

Bootstrap
* http://sourceforge.net/projects/glpibootstrap/files/


Android Client
=========
* http://sourceforge.net/projects/glpiandroid/files/
* https://github.com/elitelinux/GOATS

Internet of things
==================
Capabilities to become a IOT Monitoring and Inventory system
- IOT/IOE link: http://en.wikipedia.org/wiki/Internet_of_Things
- M2M link: http://en.wikipedia.org/wiki/Machine_to_machine

TECHNICALS ASPECTS
==================
GLPI use the following technologies :
- PHP  Link: http://php.net/manual/en/install.php - http://www.w3schools.com/php/default.asp
- MySQL/MariaDB for the database Link: MySQL http://dev.mysql.com/doc/refman/5.7/en/installing-source-distribution.html MariaDB https://mariadb.com/kb/en/mariadb/documentation/getting-started/compiling-mariadb-from-source/ - http://www.w3schools.com/sql/default.asp
- HTML for the Web pages Link html: http://www.w3schools.com/html/default.asp
- CSS for style sheets  Link CSS3: http://www.w3schools.com/css/default.asp
- Javascript for some task Link Javascript: http://www.w3schools.com/js/default.asp
- Jquery for some task Link Jquery: http://www.w3schools.com/jquery/default.asp
- XML for report generation Link XML: http://www.w3schools.com/xml/default.asp
 
Work Better in
==============
- Linux
- xBSD
 
Comparison
==========
- Issue Tracking system Link: http://en.wikipedia.org/wiki/Comparison_of_issue-tracking_systems
- Help Desk system Link: http://en.wikipedia.org/wiki/Comparison_of_help_desk_issue_tracking_software


Compatible with
===============
- - A/UX
- - AIX
- - BSD/OS
- - DSPnano
- - HP-UX
- - INTEGRITY
- - IRIX
- - LynxOS
- - MPE/iX
- - OS X Yosemite
- - QNX
- - RTEMS
- - Solaris
- - Tru64
- - Unison RTOS
- - UnixWare
- - BeOS
- - Haiku
- - Contiki
- - Darwin
- - FreeBSD
- - illumos
- - GNU/Linux LSB
- - MINIX3
- - NetBSD
- - Nucleus
- - RTOS
- - NuttX
- - OpenBSD
- - OpenSolaris
- - PikeOS RTOS
- - RTEMS
- – Sanos
- - SkyOS
- - Syllable
- - VSTa
- - VxWorks
- - Android
