/*
* CanvasXpress 4.5 - JavaScript Canvas Library
*
* Copyright (c) 2009-2010 Isaac Neuhaus
*
* imnphd@gmail.com
*
*
* Redistributions of this source code must retain this copyright
* notice and the following disclaimer.
*
* CanvasXpress is licensed under the terms of the Open Source
* LGPL 3.0 license.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
* Commercial use is permitted to the extent that this source code
* do NOT become part of any other Open Source or Commercially licensed
* development library or toolkit without explicit permission.
*
* Network graphs were implemented based on the HeyGraph by Tom Martin
* <http://www.heychinaski.com>.
*
* Thanks to Mingyi Liu for his contributions in extending the Ext panel
* and adding major capabilities to the network graphs and animations.
*
*/

function str_repeat(b,a){for(var c=[];a>0;c[--a]=b){}return(c.join(""))}function sprintf(){var g=0,e,h=arguments[g++],k=[],d,j,l,b;while(h){if(d=/^[^\x25]+/.exec(h)){k.push(d[0])}else{if(d=/^\x25{2}/.exec(h)){k.push("%")}else{if(d=/^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(h)){if(((e=arguments[d[1]||g++])==null)||(e==undefined)){throw ("Too few arguments.")}if(/[^s]/.test(d[7])&&(typeof(e)!="number")){throw ("Expecting number but found "+typeof(e))}switch(d[7]){case"b":e=e.toString(2);break;case"c":e=String.fromCharCode(e);break;case"d":e=parseInt(e);break;case"e":e=d[6]?e.toExponential(d[6]):e.toExponential();break;case"f":e=d[6]?parseFloat(e).toFixed(d[6]):parseFloat(e);break;case"o":e=e.toString(8);break;case"s":e=((e=String(e))&&d[6]?e.substring(0,d[6]):e);break;case"u":e=Math.abs(e);break;case"x":e=e.toString(16);break;case"X":e=e.toString(16).toUpperCase();break}e=(/[def]/.test(d[7])&&d[2]&&e>0?"+"+e:e);l=d[3]?d[3]=="0"?"0":d[3].charAt(1):" ";b=d[5]-String(e).length;j=d[5]?str_repeat(l,b):"";k.push(d[4]?e+j:j+e)}else{throw ("Huh ?!")}}}h=h.substring(d[0].length)}return k.join("")};var dateFormat=function(){var a=/d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,b=/\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,d=/[^-+\dA-Z]/g,c=function(f,e){f=String(f);e=e||2;while(f.length<e){f="0"+f}return f};return function(i,v,q){var g=dateFormat;if(arguments.length==1&&Object.prototype.toString.call(i)=="[object String]"&&!/\d/.test(i)){v=i;i=undefined}i=i?new Date(i):new Date;if(isNaN(i)){throw SyntaxError("invalid date")}v=String(g.masks[v]||v||g.masks["default"]);if(v.slice(0,4)=="UTC:"){v=v.slice(4);q=true}var t=q?"getUTC":"get",l=i[t+"Date"](),e=i[t+"Day"](),j=i[t+"Month"](),p=i[t+"FullYear"](),r=i[t+"Hours"](),k=i[t+"Minutes"](),u=i[t+"Seconds"](),n=i[t+"Milliseconds"](),f=q?0:i.getTimezoneOffset(),h={d:l,dd:c(l),ddd:g.i18n.dayNames[e],dddd:g.i18n.dayNames[e+7],m:j+1,mm:c(j+1),mmm:g.i18n.monthNames[j],mmmm:g.i18n.monthNames[j+12],yy:String(p).slice(2),yyyy:p,h:r%12||12,hh:c(r%12||12),H:r,HH:c(r),M:k,MM:c(k),s:u,ss:c(u),l:c(n,3),L:c(n>99?Math.round(n/10):n),t:r<12?"a":"p",tt:r<12?"am":"pm",T:r<12?"A":"P",TT:r<12?"AM":"PM",Z:q?"UTC":(String(i).match(b)||[""]).pop().replace(d,""),o:(f>0?"-":"+")+c(Math.floor(Math.abs(f)/60)*100+Math.abs(f)%60,4),S:["th","st","nd","rd"][l%10>3?0:(l%100-l%10!=10)*l%10]};return v.replace(a,function(m){return m in h?h[m]:m.slice(1,m.length-1)})}}();dateFormat.masks={"default":"ddd mmm dd yyyy HH:MM:ss",shortDate:"m/d/yy",mediumDate:"mmm d, yyyy",longDate:"mmmm d, yyyy",fullDate:"dddd, mmmm d, yyyy",shortTime:"h:MM TT",mediumTime:"h:MM:ss TT",longTime:"h:MM:ss TT Z",isoDate:"yyyy-mm-dd",isoTime:"HH:MM:ss",isoDateTime:"yyyy-mm-dd'T'HH:MM:ss",isoUtcDateTime:"UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"};dateFormat.i18n={dayNames:["Sun","Mon","Tue","Wed","Thu","Fri","Sat","Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],monthNames:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec","January","February","March","April","May","June","July","August","September","October","November","December"]};Date.prototype.format=function(a,b){return dateFormat(this,a,b)};if(typeof(CanvasXpress)=="undefined"){CanvasXpress={}}var CanvasXpress=function(f,d,a,b,c,e){if(!f){f=this.createNewTarget()}else{if(typeof(f)=="object"){d=f.data||false;a=f.config||false;b=f.events||false;c=f.hidden||false;e=f.info||false;f=f.renderTo||this.createNewTarget()}}this.validateParameters=function(){this.validateData();this.validateConfig();this.validateEvents();this.validateInfo()};this.validateData=function(){if(d&&!this.subBrowser){try{JSON.stringify(d)}catch(g){alert("Data object malformed:\n"+g)}}};this.validateConfig=function(){if(!a){a={}}else{if(!this.subBrowser){try{JSON.stringify(a)}catch(g){alert("Config object malformed:\n"+g)}}}this.userConfig=a};this.validateEvents=function(){};this.validateInfo=function(){if(!e){e=""}};this.createNewTarget=function(){var k=document.createElement("canvas");var j=0;var g="canvasXpress"+j;var h=document.getElementById(g);while(h){j++;g="canvasXpress"+j;h=document.getElementById(g)}k.id=g;document.body.appendChild(k);return g};this.insertTarget=function(j,l,i,k,g){if(j&&l){var m=document.getElementById(j);if(m){return}else{m=document.createElement("canvas")}m.id=j;m.width=i;m.height=k;if(g){l.parentNode.insertBefore(m,l.nextSibling)}else{l.parentNode.insertBefore(m,l)}}};this.removeTarget=function(g){var h=document.getElementById(g);if(h){h.parentNode.removeChild(h)}};this.setSkin=function(h){if(!h){h=this.skin}for(var g=0;g<this.skinProperties.length;g++){if(h=="blue"){this[this.skinProperties[g]]=this.skinPropertiesBlue[g]}else{this[this.skinProperties[g]]=this.skinPropertiesGrey[g]}}};this.setConfig=function(g){if(a.graphType=="Network"){if(!a.backgroundType){this.backgroundType="gradient";this.nodeFontColor=this.background}}if(a){for(var h=0;h<g.length;h++){var j=g[h];if(a.hasOwnProperty(j)){this[j]=a[j]}}}if(this.isVML){this.showAnimation=false}};this.setInitialConfig=function(){if(a){for(var g in a){this[g]=a[g]}}};this.resetConfig=function(g){var j={};for(var h=0;h<g.length;h++){j[g[h]]=this[g[h]]}this.initConfig(true);for(var h in j){this[h]=j[h]}};this.updateConfig=function(h){if(h){this.userConfig=h;for(var g in h){this[g]=h[g]}}};this.getConfig=function(){var k={};for(var h=0;h<this.config.length;h++){var g=this.config[h];if(this[g]!=undefined){k[g]=this[g]}}return k};this.getUserConfig=function(){return this.userConfig};this.updateData=function(g){this.initData(g);this.initEvents();this.initGraph()};this.save=function(){return{renderTo:this.target,data:this.data,config:this.getConfig(),events:this.events}};this.print=function(g){return function(h){g.resetConfigurator();alert("A new window will open so you can right click on the graph and save it");if(g.isIE){var j=g.canvas.parentNode.childNodes[0];return window.open().document.write("<html><body>"+j.innerHTML+"</body></html>")}else{var i=g.canvas.toDataURL("image/png");return window.open().document.write('<html><body><img src="'+i+'" /></body></html>')}}}(this);this.exportToExcel=function(j){var h="";for(var g=0;g<j.length;g++){h+=j[g].join("%09")+"%0D"}return window.open("data:text/tab-separeted-values,"+h)};this.exporttoHTML=function(j){var h="<table>";for(var g=0;g<j.length;g++){h+="<tr><td>";h+=j[g].join("</td><td>");h+="</td></tr>"}h+="</table>";return window.open().document.write(h)};this.prettyJSON=function(g,p){var q=function(i){if(typeof(i)=="object"){if(i===null){return"null"}if(i.constructor==(new Array).constructor){return"array"}if(i.constructor==(new Date).constructor){return"date"}if(i.constructor==(new RegExp).constructor){return"regex"}return"object"}return typeof(i)};if(!p){p=""}var r;var m="  ";var h=q(g);var j=0;if(h=="array"){if(g.length==0){return"[]"}r="["}else{for(var n in g){j++;break}if(j==0){return"{}"}r="{"}j=0;for(var l in g){v=g[l];if(j>0){r+=","}if(h=="array"){r+=("\n"+p+m)}else{r+=("\n"+p+m+'"'+l+'": ')}switch(q(v)){case"array":case"object":r+=this.prettyJSON(v,(p+m));break;case"boolean":case"number":r+=v.toString();break;case"null":r+="null";break;case"string":r+=('"'+v+'"');break;default:r+=("TYPEOF: "+typeof(v))}j++}if(h=="array"){r+=("\n"+p+"]")}else{r+=("\n"+p+"}")}return r};this.dumpToConsole=function(g){console.log(this.target);console.log(this.prettyJSON(g))};this.profile=function(i){var g=new Date().getTime();var h=this.profileTime||this.startTime;if(!i){i=""}console.log(this.target+": "+i+": "+(g-h));this.profileTime=g};this.stack=function(){if(this.debug){for(var g in this){if(arguments.callee.caller===this[g]){CanvasXpress.stack[this.target].push(g);return}}}};this.setCanvas=function(){this.version=4.5;this.target=f;this.events=b;this.info=e;this.startTime=new Date().getTime();var g=document.getElementById("wrapper-"+this.target);if(!g){var i=document.createElement("div");i.id="wrapper-"+this.target;i.style.position="relative";i.style.cssFloat="left";if(c){i.style.display="none"}var j=document.getElementById(this.target);var h=j.parentNode;h.insertBefore(i,j);i.appendChild(j.parentNode.appendChild(j))}this.canvas=this.browser=="Explorer"&&(this.browserVersion<9&&navigator.userAgent.toLowerCase().indexOf("chromeframe")<0)?window.G_vmlCanvasManager.initElement(j):j;this.ctx=this.canvas.getContext("2d")};this.setPath=function(){var j=document.getElementsByTagName("script");if(j){for(var h=0;h<j.length;h++){if(!j[h].src){continue}var k=j[h].src;var g=k.lastIndexOf("/");var m=k.substring(0,g+1);var l=k.substring(g+1);if(l.match(/canvasXpress/)){this.path=m}}}};this.initialize=function(){this.initBrowser();this.validateParameters();this.addCSS();this.setPath();this.setCanvas();this.initConfig();this.isGoogleChromeFrame();this.initData(d);this.initLayout();this.initEvents();this.initAnimation();this.initRemote();this.initGraph()};this.initialize();CanvasXpress.references.push(this);CanvasXpress.stack[this.target]=[]};CanvasXpress.references=[];CanvasXpress.cacheImages={};CanvasXpress.stack={};CanvasXpress.prototype.addCSS=function(){var a="table.shorts {margin: 2px 3px; padding: 2px 3px; border: 1px solid; border-collapse: collapse; font-size: x-small}";a+="td.k {text-align: center; padding: 2px 5px; margin: 2px 5px; border: 1px solid;}";a+="td.d {padding: 2px 5px; margin: 2px 5px; border: 1px solid;}";a+="th.d {padding: 2px 5px; margin: 2px 5px; border: 1px solid;}";a+="th.cxx, th.cxz, th.cxb, th.cxs, th.cxv, td.cxx, td.cxz, td.cxb, td.cxs, td.cxv {border: 1px solid; valign: center;}";a+="td.cxx, td.cxz, td.cxb, td.cxs, td.cxv {background: #fefefe}";a+="td.cxy {border: 1px solid; valign: center; text-align: right;}";a+="div.cxc {overflow: hidden;}";var b=document.createElement("style");b.type="text/css";if(b.styleSheet){b.styleSheet.cssText=a}else{b.appendChild(document.createTextNode(a))}document.getElementsByTagName("head")[0].appendChild(b)};CanvasXpress.prototype.initBrowser=function(){this.isGoogleChromeFrame=function(){if(this.browser=="Explorer"&&this.checkGoogleChromeFrame){if(navigator.userAgent.toLowerCase().indexOf("chromeframe")<0){try{var b=document.createElement("script");b.type="text/javascript";b.src="http://ajax.googleapis.com/ajax/libs/chrome-frame/1/CFInstall.min.js";document.getElementsByTagName("head")[0].appendChild(b);CFInstall.check({mode:"overlay"})}catch(a){alert("CanvasXpress works much faster in fully HTML 5 compliant browsers.\nPlease consider installing Google chrome frame to make this browser compliant.")}}}};this.dataBrowser=[{string:navigator.userAgent,subString:"Chrome",identity:"Chrome"},{string:navigator.userAgent,subString:"OmniWeb",versionSearch:"OmniWeb/",identity:"OmniWeb"},{string:navigator.vendor,subString:"Apple",identity:"Safari",versionSearch:"Version"},{prop:window.opera,identity:"Opera"},{string:navigator.vendor,subString:"iCab",identity:"iCab"},{string:navigator.vendor,subString:"KDE",identity:"Konqueror"},{string:navigator.userAgent,subString:"Firefox",identity:"Firefox"},{string:navigator.vendor,subString:"Camino",identity:"Camino"},{string:navigator.userAgent,subString:"Netscape",identity:"Netscape"},{string:navigator.userAgent,subString:"MSIE",identity:"Explorer",versionSearch:"MSIE"},{string:navigator.userAgent,subString:"Gecko",identity:"Mozilla",versionSearch:"rv"},{string:navigator.userAgent,subString:"Mozilla",identity:"Netscape",versionSearch:"Mozilla"},{string:navigator.platform,subString:"iPhone",identity:"iPhone"},{string:navigator.platform,subString:"iPod",identity:"iPod"},{string:navigator.userAgent,subString:"iPad",identity:"iPad"},{string:navigator.userAgent,subString:"Android",identity:"Android"},{string:navigator.userAgent,subString:"BlackBerry",identity:"BlackBerry"}];this.dataOS=[{string:navigator.platform,subString:"Win",identity:"Windows"},{string:navigator.platform,subString:"Mac",identity:"Mac"},{string:navigator.platform,subString:"iPhone",identity:"iPhone"},{string:navigator.platform,subString:"iPod",identity:"iPod"},{string:navigator.userAgent,subString:"iPad",identity:"iPad"},{string:navigator.userAgent,subString:"Android",identity:"Android"},{string:navigator.userAgent,subString:"BlackBerry",identity:"BlackBerry"},{string:navigator.platform,subString:"Linux",identity:"Linux"}];this.isSubstandardBrowser=function(){if((this.browser=="Firefox"&&this.browserVersion>4)||(this.browser=="Opera"&&this.browserVersion>9)||(this.browser=="Safari"&&this.browserVersion>4)||(this.browser=="Chrome"&&this.browserVersion>1)){return false}else{return true}};this.isMobileApp=function(){if(this.browser.match(/iPhone|iPod|iPad|Android|BlackBerry/i)){return true}else{return false}};this.searchString=function(d){for(var a=0;a<d.length;a++){var b=d[a].string;var c=d[a].prop;this.versionSearchString=d[a].versionSearch||d[a].identity;if(b){if(b.indexOf(d[a].subString)!=-1){return d[a].identity}}else{if(c){return d[a].identity}}}};this.searchVersion=function(b){var a=b.indexOf(this.versionSearchString);if(a==-1){return}return parseFloat(b.substring(a+this.versionSearchString.length+1))};this.initializeBrowser=function(){this.browser=this.searchString(this.dataBrowser)||"An unknown browser";this.browserVersion=this.searchVersion(navigator.userAgent)||this.searchVersion(navigator.appVersion)||"an unknown version";this.browserOS=this.searchString(this.dataOS)||"an unknown OS";if(this.browser=="Explorer"){this.isIE=true;this.subBrowser=true;this.mobileApp=false;if(this.browserVersion>=9){this.isVML=false}else{if(navigator.userAgent.toLowerCase().indexOf("chromeframe")<0){this.isVML=true}else{this.isVML=false}}}else{this.isIE=false;this.subBrowser=this.isSubstandardBrowser();this.mobileApp=this.isMobileApp();this.isVML=false}};this.initializeBrowser()};CanvasXpress.prototype.initConfig=function(a){this.config=[];this.graphType="Bar";this.config.push("graphType");this.graphOrientation="horizontal";this.config.push("graphOrientation");this.foreground="rgb(0,0,0)";this.config.push("foreground");this.foregroundWindow="rgb(0,0,0)";this.config.push("foregroundWindow");this.background="rgb(255,255,255)";this.config.push("background");this.backgroundWindow="rgb(220,220,220)";this.config.push("backgroundWindow");this.backgroundType="solid";this.config.push("backgroundType");this.backgroundImage=false;this.config.push("backgroundImage");this.gradientOrientation="vertical";this.config.push("gradientOrientation");this.backgroundWindowGradientOrientation="vertical";this.config.push("backgroundWindowGradientOrientation");this.backgroundGradient1Color="rgb(0,0,200)";this.config.push("backgroundGradient1Color");this.backgroundGradient2Color="rgb(0,0,36)";this.config.push("backgroundGradient2Color");this.backgroundWindowGradient1Color="rgb(0,0,200)";this.config.push("backgroundWindowGradient1Color");this.backgroundWindowGradient2Color="rgb(0,0,36)";this.config.push("backgroundWindowGradient2Color");this.gradient=false;this.config.push("gradient");this.gradientType="radial";this.config.push("gradientType");this.gradientRatio=1.3;this.config.push("gradientRatio");this.transparency=null;this.config.push("transparency");this.margin=5;this.config.push("margin");this.marginLeft=20;this.config.push("marginLeft");this.marginTop=20;this.config.push("marginTop");this.marginBottom=20;this.config.push("marginBottom");this.marginRight=20;this.config.push("marginRight");this.showShadow=false;this.config.push("showShadow");this.shadowOffsetX=3;this.config.push("shadowOffsetX");this.shadowOffsetY=3;this.config.push("shadowOffsetY");this.shadowBlur=2;this.config.push("shadowBlur");this.shadowColor="rgba(0,0,0,0.5)";this.config.push("shadowColor");this.canvasBox=true;this.config.push("canvasBox");this.canvasBoxColor="rgb(0,0,0)";this.config.push("canvasBoxColor");this.autoAdjust=true;this.config.push("autoAdjust");this.functions=[];this.fonts=this.isVML||this.subBrowser?["Gentilis","Helvetiker","Optimer"]:["Gentilis","Helvetiker","Optimer","Verdana, sans-serif"];this.fontName=this.isVML?"Gentilis":this.subBrowser?"Optimer":"Verdana, sans-serif";this.config.push("fontName");this.fontStyle=false;this.config.push("fontStyle");this.fontSize=12;this.config.push("fontSize");this.font=this.fontStyle?this.fontStyle+this.fontSize+"pt "+this.fontName:this.fontSize+"pt "+this.fontName;this.align="center";this.config.push("align");this.baseline="middle";this.config.push("baseline");this.maxTextSize=14;this.config.push("maxTextSize");this.minTextSize=4;this.config.push("minTextSize");this.autoScaleFont=true;this.config.push("autoScaleFont");this.scaleTextConstantMult=40;this.scaleTextConstantAdd=2.5;this.title=false;this.config.push("title");this.titleHeight=30;this.config.push("titleHeight");this.titleColor="rgb(0,0,0)";this.config.push("titleColor");this.subtitle=false;this.config.push("subtitle");this.subtitleHeight=16;this.config.push("subtitleHeight");this.subtitleColor="rgb(0,0,0)";this.config.push("subtitleColor");this.citation=false;this.config.push("citation");this.citationColor="rgb(0,0,0)";this.config.push("citationColor");this.citationFontSize=6;this.config.push("citationSize");this.citationFont=(this.citationFontSize)+"Pt "+this.fontName;this.dashLength=8;this.config.push("dashLength");this.dotLength=5;this.config.push("dotLength");this.arrowPointSize=10;this.config.push("arrowPointSize");this.capType="butt";this.config.push("capType");this.outlineWidth=1;this.config.push("outlineWidth");this.lines=[];this.colorScheme="user";this.config.push("colorScheme");this.colors=["rgb(255,0,0)","rgb(0,0,255)","rgb(0,255,0)","rgb(255,255,0)","rgb(0,255,255)","rgb(255,0,255)","rgb(153,51,0)","rgb(0,0,128)","rgb(128,128,0)","rgb(255,102,0)","rgb(0,128,128)","rgb(102,0,102)","rgb(255,153,204)","rgb(102,102,153)","rgb(51,51,0)","rgb(255,204,153)","rgb(204,255,255)","rgb(153,153,255)","rgb(255,128,128)","rgb(51,102,255)","rgb(51,153,102)","rgb(255,204,0)","rgb(0,204,255)","rgb(208,32,144)","rgb(153,51,102)","rgb(0,102,204)","rgb(153,204,0)","rgb(255,153,0)","rgb(51,204,204)","rgb(204,153,255)","rgb(128,0,0)","rgb(51,51,153)","rgb(0,128,0)","rgb(255,255,204)","rgb(153,204,255)","rgb(128,0,128)"];this.colors0=["rgb(0,0,255)","rgb(255,0,77)","rgb(255,191,0)","rgb(116,255,0)","rgb(164,0,255)","rgb(255,116,0)","rgb(255,255,0)","rgb(0,255,255)","rgb(255,0,0)","rgb(255,211,0)","rgb(61,0,255)","rgb(0,255,0)","rgb(255,0,255)","rgb(255,146,0)","rgb(211,255,0)","rgb(0,144,255)","rgb(109,0,255)","rgb(255,73,0)","rgb(255,232,0)","rgb(0,255,146)","rgb(255,0,144)","rgb(255,170,0)","rgb(170,255,0)","rgb(0,77,255)"];this.colors1=["rgb(60,60,157)","rgb(157,60,90)","rgb(157,133,60)","rgb(104,157,60)","rgb(122,60,157)","rgb(157,104,60)","rgb(157,157,60)","rgb(60,157,157)","rgb(157,60,60)","rgb(157,140,60)","rgb(83,60,157)","rgb(60,157,60)","rgb(157,60,157)","rgb(157,115,60)","rgb(140,157,60)","rgb(60,115,157)","rgb(102,60,157)","rgb(157,88,60)","rgb(157,148,60)","rgb(60,157,115)","rgb(157,60,115)","rgb(157,125,60)","rgb(125,157,60)","rgb(60,90,157)"];this.colors2=["rgb(0,0,117)","rgb(117,0,36)","rgb(117,88,0)","rgb(53,117,0)","rgb(76,0,117)","rgb(117,53,0)","rgb(117,117,0)","rgb(0,117,117)","rgb(117,0,0)","rgb(117,97,0)","rgb(28,0,117)","rgb(0,117,0)","rgb(117,0,117)","rgb(117,67,0)","rgb(97,117,0)","rgb(0,66,117)","rgb(50,0,117)","rgb(117,33,0)","rgb(117,107,0)","rgb(0,117,67)","rgb(117,0,66)","rgb(117,78,0)","rgb(78,117,0)","rgb(0,36,117)"];this.colors3=["rgb(101,101,255)","rgb(255,101,147)","rgb(255,216,101)","rgb(171,255,101)","rgb(200,101,255)","rgb(255,171,101)","rgb(255,255,101)","rgb(101,255,255)","rgb(255,101,101)","rgb(255,229,101)","rgb(137,101,255)","rgb(101,255,101)","rgb(255,101,255)","rgb(255,189,101)","rgb(229,255,101)","rgb(101,188,255)","rgb(167,101,255)","rgb(255,145,101)","rgb(255,241,101)","rgb(101,255,189)","rgb(255,101,188)","rgb(255,204,101)","rgb(204,255,101)","rgb(101,147,255)"];this.colors4=["rgb(181,181,255)","rgb(255,181,203)","rgb(255,237,181)","rgb(215,255,181)","rgb(229,181,255)","rgb(255,215,181)","rgb(255,255,181)","rgb(181,255,255)","rgb(255,181,181)","rgb(255,242,181)","rgb(199,181,255)","rgb(181,255,181)","rgb(255,181,255)","rgb(255,223,181)","rgb(242,255,181)","rgb(181,223,255)","rgb(213,181,255)","rgb(255,202,181)","rgb(255,248,181)","rgb(181,255,223)","rgb(255,181,223)","rgb(255,230,181)","rgb(230,255,181)","rgb(181,203,255)"];this.config.push("colors");this.colorHSV=[0,0,1];this.colorRGB=[1,1,1];this.shapes=["sphere","square","triangle","star","rhombus","octagon","oval","plus","minus","pacman","mdavid","rect2","rect3","arc","rectangle","image"];this.config.push("shapes");this.sizes=[4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34];this.config.push("sizes");this.images=[];this.config.push("images");this.timeFormat="isoDate";this.config.push("timeFormat");this.oddColor=this.background;this.config.push("oddColor");this.evenColor="rgb(240,240,240)";this.config.push("evenColor");this.maxSmpStringLen=50;this.config.push("maxSmpStringLen");this.smpLabelDescription=false;this.config.push("smpLabelDescription");this.smpTitle=false;this.config.push("smpTitle");this.smpTitleFontSize=10;this.config.push("smpTitleFontSize");this.smpTitleFont=(this.smpTitleFontSize)+"Pt "+this.fontName;this.smpTitleColor=this.foreground;this.config.push("smpTitleColor");this.smpTitleScaleFontFactor=1;this.config.push("smpTitleScaleFontFactor");this.smpLabelFontSize=10;this.config.push("smpLabelFontSize");this.smpLabelFont=(this.smpLabelFontSize)+"Pt "+this.fontName;this.smpLabelColor=this.foreground;this.config.push("smpLabelColor");this.smpLabelScaleFontFactor=1;this.config.push("smpLabelScaleFontFactor");this.smpLabelRotate=0;this.config.push("smpLabelRotate");this.showSampleNames=true;this.config.push("showSampleNames");this.highlightSmp=[];this.config.push("highlightSmp");this.smpHighlightColor="rgb(255,0,0)";this.config.push("smpHighlightColor");this.maxVarStringLen=30;this.config.push("maxVarStringLen");this.varLabelDescription=false;this.config.push("varLabelDescription");this.varTitle=false;this.config.push("varTitle");this.varTitleFontSize=10;this.config.push("varTitleFontSize");this.varTitleFont=(this.varTitleFontSize)+"Pt "+this.fontName;this.varTitleColor=this.foreground;this.config.push("varTitleColor");this.varTitleScaleFontFactor=1;this.config.push("varTitleScaleFontFactor");this.varLabelFontSize=10;this.config.push("varLabelFontSize");this.varLabelFont=(this.varLabelFontSize)+"Pt "+this.fontName;this.varLabelColor=this.foreground;this.config.push("varLabelColor");this.varLabelScaleFontFactor=1;this.config.push("varLabelScaleFontFactor");this.varLabelRotate=0;this.config.push("varLabelRotate");this.showVariableNames=true;this.config.push("showVariableNames");this.varTitleLabelOverlayPosition="bottom";this.config.push("varTitleLabelOverlayPosition");this.highlightVar=[];this.config.push("highlightVar");this.varHighlightColor="rgb(255,0,0)";this.config.push("varHighlightColor");this.overlaysWidth=30;this.config.push("overlaysWidth");this.smpOverlays=[];this.config.push("smpOverlays");this.varOverlays=[];this.config.push("varOverlays");this.showOverlays=true;this.config.push("showOverlays");this.overlayFontSize=6;this.config.push("overlayFontSize");this.overlayFont=(this.overlayFontSize)+"Pt "+this.fontName;this.overlayFontColor=this.foreground;this.config.push("overlayFontColor");this.overlayScaleFontFactor=1;this.config.push("overlayScaleFontFactor");this.showLegend=true;this.config.push("showLegend");this.legendPosition="right";this.config.push("legendPosition");this.legendColor=this.foreground;this.config.push("legendColor");this.legendBox=true;this.config.push("legendBox");this.legendBoxColor="rgb(0,0,0)";this.config.push("legendBoxColor");this.legendBackgroundColor=this.background;this.config.push("legendBackgroundColor");this.legendFontSize=10;this.config.push("legendFontSize");this.legendFont=(this.legendFontSize)+"Pt "+this.fontName;this.legendScaleFontFactor=1;this.config.push("legendScaleFontFactor");this.showIndicators=true;this.config.push("showIndicators");this.indicatorsPosition="bottom";this.config.push("indicatorsPosition");this.showDecorations=false;this.config.push("showDecorations");this.decorationsPosition="bottom";this.config.push("decorationsPosition");this.decorationsColor=this.foreground;this.config.push("decorationsColor");this.decorationFontSize=10;this.config.push("decorationFontSize");this.decorationFont=(this.decorationFontSize)+"Pt "+this.fontName;this.decorationScaleFontFactor=1;this.config.push("decorationScaleFontFactor");this.decorationsWidth=10;this.config.push("decorationsWidth");this.decorationsHeight=20;this.config.push("decorationsHeight");this.decorationsType="bar";this.config.push("decorationsType");this.decorations=[];this.config.push("decorations");this.decorationsColors=[];this.config.push("decorationsColors");this.decorationsProperties={};this.config.push("decorationsProperties");this.axisTickColor=this.foreground;this.config.push("axisTickColor");this.axisTickFontSize=10;this.config.push("axisTickFontSize");this.axisTickFont=(this.axisTickFontSize)+"Pt "+this.fontName;this.tickScaleFontFactor=1;this.config.push("tickScaleFontFactor");this.tickRotate=0;this.config.push("tickRotate");this.axisTitleColor=this.foreground;this.config.push("axisTitleColor");this.axisTitleFontSize=10;this.config.push("axisTitleFontSize");this.axisTitleFont=(this.axisTitleFontSize)+"Pt "+this.fontName;this.axisTitleScaleFontFactor=1;this.config.push("axisTitleScaleFontFactor");this.isGroupedData=false;this.isTransformedData=false;this.isBoxPlotCalc=false;this.isMarketDataFormated=false;this.isMarketSwitched=false;this.isGraphTime=false;this.config.push("isGraphTime");this.groupingFactors=[];this.config.push("groupingFactors");this.segregateSamplesBy=false;this.config.push("segregateSamplesBy");this.segregateVariablesBy=false;this.config.push("segregateVariablesBy");this.isLogData=false;this.config.push("isLogData");this.smpSort=-1;this.varSort=-1;this.tmpAsciiArray=[];this.sortDir="ascending";this.config.push("sortDir");this.transformBase=2;this.config.push("transformBase");this.transformType=false;this.config.push("transformType");this.ratioReference=0;this.config.push("ratioReference");this.zscoreAxis="samples";this.config.push("zscoreAxis");this.showErrorBars=true;this.config.push("showErrorBars");this.randomData=false;this.config.push("randomData");this.randomDataMean=100;this.config.push("randomDataMean");this.randomDataSigma=50;this.config.push("randomDataSigma");this.randomDataVariables=6;this.config.push("randomDataVariables");this.randomDataSamples=12;this.config.push("randomDataSamples");this.randomDataVariableAnnotations=2;this.config.push("randomDataVariableAnnotations");this.randomDataSampleAnnotations=3;this.config.push("randomDataSampleAnnotations");this.randomDataVariableAnnotationRatio=2;this.config.push("randomDataVariableAnnotationRatio");this.randomDataSampleAnnotationRatio=2;this.config.push("randomDataSampleAnnotationRatio");this.randomMissingDataPercentage=0;this.config.push("randomMissingDataPercentage");this.missingDataColor="rgb(255,255,0)";this.config.push("missingDataColor");this.zoom=1;this.config.push("zoom");this.zoomGlobal=1;this.zoomStep=0.2;this.config.push("zoomStep");this.panningX=0;this.config.push("panningX");this.panningY=0;this.config.push("panningY");this.panningGlobalX=0;this.panningGlobalY=0;this.panningStep=0.2;this.config.push("panningStep");this.distance="euclidian";this.config.push("distance");this.linkage="single";this.config.push("linkage");this.clusterAxis="samples";this.config.push("clusterAxis");this.kmeansClusters=3;this.config.push("kmeansClusters");this.maxIterations=10;this.config.push("maxIterations");this.imputeMethod="mean";this.config.push("imputeMethod");this.centerData=false;this.config.push("centerData");this.useSmpVarIndexOnClustering=false;this.config.push("useSmpVarIndexOnClustering");this.xAxisAbsMax=null;this.xAxisAbsMin=null;this.xAxis2AbsMax=null;this.xAxis2AbsMin=null;this.yAxisAbsMax=null;this.yAxisAbsMin=null;this.zAxisAbsMax=null;this.zAxisAbsMin=null;this.xAxisMaxStrLength=false;this.xAxis2MaxStrLength=false;this.yAxisMaxStrLength=false;this.zAxisMaxStrLength=false;this.setMax=null;this.config.push("setMax");this.setMin=null;this.config.push("setMin");this.setMax2=null;this.config.push("setMax2");this.setMin2=null;this.config.push("setMin2");this.setMaxX=null;this.config.push("setMaxX");this.setMinX=null;this.config.push("setMinX");this.setMaxY=null;this.config.push("setMaxY");this.setMinY=null;this.config.push("setMinY");this.setMaxZ=null;this.config.push("setMaxZ");this.setMinZ=null;this.config.push("setMinZ");this.xAxisCurrent=0;this.config.push("xAxisCurrent");this.yAxisCurrent=0;this.config.push("yAxisCurrent");this.zAxisCurrent=0;this.config.push("zAxisCurrent");this.xAxisTitle=false;this.config.push("xAxisTitle");this.yAxisTitle=false;this.config.push("yAxisTitle");this.zAxisTitle=false;this.config.push("zAxisTitle");this.xAxis=[];this.config.push("xAxis");this.xAxis2=[];this.config.push("xAxis2");this.yAxis=[];this.config.push("yAxis");this.zAxis=[];this.config.push("zAxis");this.xAxisTickStyle="solid";this.config.push("xAxisTickStyle");this.yAxisTickStyle="solid";this.config.push("yAxisTickStyle");this.zAxisTickStyle="solid";this.config.push("zAxisTickStyle");this.xAxisTickFormat=false;this.config.push("xAxisTickFormat");this.xAxis2TickFormat=false;this.config.push("xAxis2TickFormat");this.yAxisTickFormat=false;this.config.push("yAxisTickFormat");this.zAxisTickFormat=false;this.config.push("zAxisTickFormat");this.xAxisTickColor="rgb(220,220,220)";this.config.push("xAxisTickColor");this.yAxisTickColor="rgb(220,220,220)";this.config.push("yAxisTickColor");this.zAxisTickColor="rgb(220,220,220)";this.config.push("zAxisTickColor");this.axisExtension=0.1;this.config.push("axisExtension");this.axisExact=false;this.config.push("axisExact");this.xAxisExact=false;this.config.push("xAxisExact");this.xAxis2Exact=false;this.config.push("xAxis2Exact");this.yAxisExact=false;this.config.push("yAxisExact");this.zAxisExact=false;this.config.push("zAxisExact");this.timeValues=[];this.config.push("timeValues");this.timeValueIndices=[];this.config.push("timeValueIndices");this.xAxisValues=[];this.config.push("xAxisValues");this.xAxis2Values=[];this.config.push("xAxis2Values");this.yAxisValues=[];this.config.push("yAxisValues");this.zAxisValues=[];this.config.push("zAxisValues");this.xAxisMinorValues=[];this.config.push("xAxisMinorValues");this.xAxis2MinorValues=[];this.config.push("xAxis2MinorValues");this.yAxisMinorValues=[];this.config.push("yAxisMinorValues");this.zAxisMinorValues=[];this.config.push("zAxisMinorValues");this.xAxisTransform=false;this.config.push("xAxisTransform");this.yAxisTransform=false;this.config.push("yAxisTransform");this.zAxisTransform=false;this.config.push("zAxisTransform");this.xAxisTransformTicks=true;this.config.push("xAxisTransformTicks");this.yAxisTransformTicks=true;this.config.push("yAxisTransformTicks");this.zAxisTransformTicks=true;this.config.push("zAxisTransformTicks");this.xAxisShow=true;this.config.push("xAxisShow");this.yAxisShow=true;this.config.push("yAxisShow");this.zAxisShow=true;this.config.push("zAxisShow");this.ticks=50;this.config.push("ticks");this.timeTicksFirst=false;this.config.push("timeTicksFirst");this.xAxisTicks=5;this.config.push("xAxisTicks");this.xAxis2Ticks=5;this.config.push("xAxis2Ticks");this.yAxisTicks=5;this.config.push("yAxisTicks");this.zAxisTicks=5;this.config.push("zAxisTicks");this.xAxisMinorTicks=true;this.config.push("xAxisMinorTicks");this.xAxis2MinorTicks=true;this.config.push("xAxis2MinorTicks");this.yAxisMinorTicks=true;this.config.push("yAxisMinorTicks");this.zAxisMinorTicks=false;this.config.push("zAxisMinorTicks");this.smpHairline="dotted";this.config.push("smpHairline");this.smpHairlineColor="rgb(220,220,220)";this.config.push("smpHairlineColor");this.blockContrast=false;this.config.push("blockContrast");this.seriesSeparationFactor=2;this.config.push("seriesSeparationFactor");this.blockSeparationFactor=1;this.config.push("blockSeparationFactor");this.blockFactor=1;this.config.push("blockFactor");this.showDataValues=false;this.config.push("showDataValues");this.lineDecoration="symbol";this.config.push("lineDecoration");this.coordinateLineColor=true;this.config.push("coordinateLineColor");this.lineThickness=1;this.config.push("lineThickness");this.lineType="rect";this.config.push("lineType");this.tension=0.3;this.config.push("tension");this.areaIsCumulative=false;this.config.push("areaIsCumulative");this.colorBy=false;this.config.push("colorBy");this.shapeBy=false;this.config.push("shapeBy");this.sizeBy=false;this.config.push("sizeBy");this.scatterType=false;this.config.push("scatterType");this.scatterSeries="y";this.config.push("scatterSeries");this.selectDataPoint=[];this.hideDataPoint=[];this.isSelectDataPoints=0;this.isHistogram=false;this.config.push("isHistogram");this.histogramBarWidth=0.5;this.config.push("histogramBarWidth");this.histogramBins=20;this.config.push("histogramBins");this.isCreateHistogram=false;this.allVsAll=false;this.config.push("allVsAll");this.allVsAllType="both";this.config.push("allVsAllType");this.functionIntervals=20;this.config.push("functionIntervals");this.xRotate=45;this.config.push("xRotate");this.yRotate=0;this.config.push("yRotate");this.zRotate=0;this.config.push("zRotate");this.minRotate=null;this.config.push("minRotate");this.maxRotate=null;this.config.push("maxRotate");this.show3DGrid=true;this.config.push("show3DGrid");this.rotationDelay=100;this.config.push("rotationDelay");this.rotationSensitivity=45;this.config.push("rotationSensitivity");this.rotationStep=2;this.config.push("rotationStep");this.indicatorCenter="white";this.config.push("indicatorCenter");this.indicatorHeight=8;this.config.push("indicatorHeight");this.indicatorWidth=1;this.config.push("indicatorWidth");this.heatmapType="blue-red";this.config.push("heatmapType");this.varIndicesStart=-1;this.smpIndicesStart=-1;this.correlationAxis="samples";this.config.push("correlationAxis");this.correlationAnchorLegend=false;this.config.push("correlationAnchorLegend");this.correlationAnchorLegendAlignWidth=40;this.config.push("correlationAnchorLegendAlignWidth");this.showSmpDendrogram=false;this.config.push("showSmpDendrogram");this.showVarDendrogram=false;this.config.push("showVarDendrogram");this.varDendrogramPosition="top";this.config.push("varDendrogramPosition");this.smpDendrogramPosition="left";this.config.push("smpDendrogramPosition");this.dendrogramSpace=6;this.config.push("dendrogramSpace");this.dendrogramHang=false;this.config.push("dendrogramHang");this.dendrogramHeight=false;this.config.push("dendrogramHeight");this.vennGroups=4;this.config.push("vennGroups");this.vennCompartments=["A","B","AB","C","AC","BC","ABC","D","AD","BD","CD","ABD","ACD","BCD","ABCD"];this.vennColors=[];this.config.push("vennColors");this.pieType="separated";this.config.push("pieType");this.pieSegmentPrecision=0;this.config.push("pieSegmentPrecision");this.pieSegmentSeparation=3;this.config.push("pieSegmentSeparation");this.pieSegmentLabels="inside";this.config.push("pieSegmentLabels");this.maxPieSectors=20;this.config.push("maxPieSectors");this.showPieGrid=true;this.config.push("showPieGrid");this.showPieValues=true;this.config.push("showPieValues");this.showPieSampleLabel=true;this.config.push("showPieSampleLabel");this.startPieSectors=0;this.config.push("startPieSectors");this.showVolume=true;this.config.push("showVolume");this.stockIndicators=["Sma5","Sma10","Sma25"];this.config.push("stockIndicators");this.sma5Color="rgb(255,0,0)";this.config.push("sma5Color");this.sma10Color="rgb(0,255,0)";this.config.push("sma1Color");this.sma20Color="rgb(0,0,255)";this.config.push("sma20Color");this.sma25Color="rgb(255,0,255)";this.config.push("sma25Color");this.sma50Color="rgb(0,0,0)";this.config.push("sma50Color");this.calculateLayout=true;this.config.push("calculateLayout");this.networkFreeze=false;this.config.push("networkFreeze");this.networkFreezeOnLoad=false;this.config.push("networkFreezeOnLoad");this.networkStack=[];this.networkStack[0]=[];this.networkStack[1]=[];this.subNetworks=false;this.networkStackStates=5;this.config.push("networkStackStates");this.approximateNodePositions=false;this.config.push("approximateNodePositions");this.networkLayoutType="forceDirected";this.config.push("networkLayoutType");this.networkForceConstant=0;this.config.push("networkForceConstant");this.temperature=0;this.config.push("temperature");this.initialTemperature=0;this.config.push("initialTemperature");this.networkNodeMinDistance=4;this.config.push("networkNodeMinDistance");this.attractiveForceFunction="FruchtermanReingold";this.config.push("attractiveForceFunction");this.repulsiveForceFunction="square";this.config.push("repulsiveForceFunction");this.networkRoot=false;this.config.push("networkRoot");this.showNetworkRadialLayout=false;this.config.push("showNetworkRadialLayout");this.networkDepth=0;this.networkDivisions=0;this.preScaleNetwork=false;this.config.push("preScaleNetwork");this.showNetworkNodesLegend=true;this.config.push("showNetworkNodesLegend");this.showNetworkEdgesLegend=true;this.config.push("showNetworkEdgesLegend");this.showNetworkTextLegend=true;this.config.push("showNetworkTextLegend");this.showNetworkDecorationsLegend=true;this.config.push("showNetworkDecorationsLegend");this.highlightNode=[];this.config.push("highlightNode");this.nodeHighlightColor="rgb(255,0,0)";this.config.push("nodeHighlightColor");this.selectNode={};this.isSelectNodes=0;this.showNodeNameThreshold=50;this.config.push("showNodeNameThreshold");this.showHiddenChildEdges=true;this.config.push("showHiddenChildEdges");this.nodeSize=this.preScaleNetwork?10:20;this.config.push("nodeSize");this.edgeWidth=1;this.config.push("edgeWidth");this.layoutTime=15;this.config.push("layoutTime");this.nodeFontSize=this.nodeSize;this.config.push("nodeFontSize");this.nodeFont=this.nodeFontSize+"Pt "+this.fontName;this.nodeFontColor=this.foreground;this.config.push("nodeFontColor");this.nodeScaleFontFactor=1;this.config.push("nodeScaleFontFactor");this.randomNetwork=false;this.config.push("randomNetwork");this.reduceRandomNetwork=false;this.config.push("reduceRandomNetwork");this.randomNetworkNodes=50;this.config.push("randomNetworkNodes");this.randomNetworkNodeEdgesMax=5;this.config.push("randomNetworkNodeEdgesMax");this.colorNodeBy=false;this.config.push("colorNodeBy");this.shapeNodeBy=false;this.config.push("shapeNodeBy");this.sizeNodeBy=false;this.config.push("sizeNodeBy");this.colorEdgeBy=false;this.config.push("colorEdgeBy");this.shapeEdgeBy=false;this.config.push("shapeEdgeBy");this.sizeEdgeBy=false;this.config.push("sizeEdgeBy");this.sizeDecorationBy=false;this.config.push("sizeDecorationBy");this.is3DNetwork=false;this.config.push("is3DNetwork");this.network2DRotate=0;this.skipClick=false;this.autoHideOnDecorationsCenter=false;this.config.push("autoHideOnDecorationsCenter");this.networkNodesOnTop=true;this.config.push("networkNodesOnTop");this.overrideEventlessNodes=false;this.config.push("overrideEventlessNodes");this.nodeConfigurableProperties=["x","y","z","shape","color","outline","size","width","height","pattern","rotate","outlineWidth","imagePath","zIndex","eventless"];this.config.push("nodeConfigurableProperties");this.edgeConfigurableProperties=["width","cap","exact","type"];this.config.push("edgeConfigurableProperties");this.trackNameFontSize=10;this.config.push("trackNameFontSize");this.trackNameFont=(this.trackNameFontSize)+"Pt "+this.fontName;this.trackNameFontColor=this.background;this.config.push("trackNameFontColor");this.showFeatureNameThereshold=20;this.config.push("showFeatureNameThereshold ");this.featureNameFontSize=8;this.config.push("featureNameFontSize");this.featureNameFont=(this.featureNameFontSize)+"Pt "+this.fontName;this.featureNameFontColor=this.background;this.config.push("featureNameFontColor");this.maxFeatureStringLen=50;this.config.push("maxFeatureStringLen");this.featureWidthDefault=3;this.config.push("featureWidthDefault");this.featureHeightDefault=14;this.config.push("featureHeightDefault");this.featureTraceHeight=40;this.config.push("featureTraceHeight");this.featureTraceTrim=1;this.config.push("featureTraceTrim");this.featureTracesShow=true;this.config.push("featureTracesShow");this.featureQualityHeight=12;this.config.push("featureQualityHeight");this.featureQualityValues=false;this.config.push("featureQualityValues");this.featureQualityShow=true;this.config.push("featureQualityShow");this.featureSignalToNoiseHeight=12;this.config.push("featureSignalToNoiseHeight");this.featureSignalToNoiseValues=false;this.config.push("featureSignalToNoiseValues");this.featureSignalToNoiseShow=true;this.config.push("featureSignalToNoiseShow");this.featureCoordinateHeight=12;this.config.push("featureCoordinateHeight");this.featureCoordinateShow=true;this.config.push("featureCoordinateShow");this.featureTranslateHeight=12;this.config.push("featureTranslateHeight");this.featureTranslateShow=true;this.config.push("featureTranslateShow");this.featureTypeDefault="line";this.config.push("featureTypeDefault");this.featureStaggered=false;this.config.push("featureStaggered");this.sequenceFontSize=10;this.config.push("sequenceFontSize");this.sequenceFont=(this.sequenceFontSize)+"Pt "+this.fontName;this.sequenceAColor="rgb(0,255,0)";this.config.push("sequenceAColor");this.sequenceCColor="rgb(0,0,255)";this.config.push("sequenceCColor");this.sequenceGColor="rgb(0,0,0)";this.config.push("sequenceGColor");this.sequenceTColor="rgb(255,0,0)";this.config.push("sequenceTColor");this.sequenceMColor="rgb(255,0,255)";this.config.push("sequenceMColor");this.sequenceStartColor="rgb(0,255,0)";this.config.push("sequenceStartColor");this.sequenceEndColor="rgb(255,0,0)";this.config.push("sequenceEndColor");this.wireColor=this.isVML?"rgb(220,220,220)":"rgba(220,220,220,0.1)";this.config.push("wireColor");this.periodTicksLabels=5;this.config.push("periodTicksLabels");this.genomeResolution="low";this.trackConfigurableProperties=["name","type","height","fill","outline","hide","highlight"];this.config.push("trackConfigurableProperties");this.featureConfigurableProperties=["id","fill","outline","dir","offset","data","subtype","quality","signalToNoise","coordinate","sequence","trace","gaps","translate","hide","counter"];this.config.push("featureConfigurableProperties");this.debug=false;this.config.push("debug");this.showVersion=true;this.config.push("showVersion");this.showCode=false;this.config.push("showCode");this.codeType="pretty";this.config.push("codeType");this.checkGoogleChromeFrame=true;this.config.push("checkGoogleChromeFrame");this.skin="blue";this.config.push("skin");this.skinProperties=["skinBackgroundColor","skinBorderColor","skinColor","skinShadowColor"];this.skinPropertiesBlue=["rgb(223,232,246)","rgb(153,187,232)","rgb(68,68,68)","rgb(204,204,204)"];this.skinPropertiesGrey=["rgb(238,238,238)","rgb(0,0,0)","rgb(68,68,68)","rgb(204,204,204)"];this.selectedBackgroundColor="rgb(255,0,0)";this.config.push("selectedBackgroundColor");this.disableConfigurator=false;this.config.push("disableConfigurator");this.resizable=true;this.config.push("resizable");this.showAdvancedConfiguration=false;this.config.push("showAdvancedConfiguration");this.configuratorWidth=350;this.config.push("configuratorWidth");this.disableEvents=false;this.config.push("disableEvents");this.eventKeys=true;this.config.push("eventKeys");this.eventArrowKeys=true;this.config.push("eventArrowKeys");this.eventPlusMinusKeys=false;this.config.push("eventPlusMinusKeys");this.helpKeyEvents=true;this.config.push("helpKeyEvents");this.infoTimeOut=3000;this.config.push("infoTimeOut");this.infoStartTime=new Date().getTime();this.infoTimeIn=50;this.config.push("infoTimeIn");this.modelEvent="global";this.config.push("modelEvent");this.dataEvent=[];this.broadcast=true;this.config.push("broadcast");this.broadcastType="var";this.config.push("broadcastType");this.destroyAllOnClose=true;this.config.push("destroyAllOnClose");this.resizerBackgroundColor=this.isIE?"rgb(210,210,210)":"rgba(210,210,210,0.7)";this.config.push("resizerBackgroundColor");this.resizerBackgroundColorCurrent="rgb(237,247,255)";this.config.push("resizerBackgroundColorCurrent");this.resizerBackgroundColorOutlineCurrent="rgb(59,138,229)";this.config.push("resizerBackgroundColorOutlineCurrent");this.resizerTransparency=true;this.config.push("resizerTransparency");this.resizerType=false;this.config.push("resizerType");this.resizerDraw=false;this.config.push("resizerDraw");this.resizerPosition="bottom";this.config.push("resizerPosition");this.resizerWidth=50;this.config.push("resizerWidth");this.resizerBackgroundImage=false;this.config.push("resizerBackgroundImage");this.resizerDataIndex=0;this.config.push("resizerDataIndex");this.resizerEventData={};this.showAnimation=false;this.config.push("showAnimation");this.showAnimationFontSize=10;this.config.push("showAnimationFontSize");this.showAnimationFont=(this.showAnimationFontSize)+"Pt "+this.fontName;this.showAnimationFontColor=this.background;this.config.push("showAnimationFontColor");this.animationTime=30;this.config.push("animationTime");this.animationType="grow";this.config.push("animationType");this.animationCycles=20;this.config.push("animationCycles");this.snapshotCopyChangeOnly=true;this.config.push("snapshotCopyChangeOnly");this.snapshots=[];this.isAnimation=false;this.weight=1;this.scaleX=1;this.scaleY=1;this.translateX=0;this.translateY=0;this.offsetX=0;this.offsetY=0;this.layoutWidth=0;this.layoutHeight=0;this.layout="1X1";this.config.push("layout");this.layoutComb=false;this.config.push("layoutComb");this.layoutAdjust=false;this.config.push("layoutAdjust");this.layoutCurrent=0;this.layoutMaxVarLegend=0;this.layoutMulticolor=true;this.config.push("layoutMulticolor");this.layoutAxis=3;this.imageDir="http://canvasxpress.org/images/";this.config.push("imageDir");this.playButton="control_play_blue.png";this.config.push("playButton");this.stopButton="control_stop_blue.png";this.config.push("stopButton");this.previousButton="control_rewind_blue.png";this.config.push("previousButton");this.nextButton="control_forward_blue.png";this.config.push("nextButton");this.remoteService=false;this.config.push("remoteService");this.remoteParams={};this.config.push("remoteParams");this.remoteDirection="next";this.config.push("remoteDirection");this.remoteDataIndex=0;this.remoteWindow=1;this.config.push("remoteWindow");this.remoteAutoPlay=false;this.config.push("remoteAutoPlay");this.remoteAutoPlayDelay=3000;this.config.push("remoteAutoPlayDelay");this.remoteUpdating=false;this.showDataTable=false;this.config.push("showDataTable");this.dataTableTransposed=true;this.config.push("dataTableTransposed");this.maxRows=10;this.config.push("maxRows");this.maxCols=10;this.config.push("maxCols");this.colWidth=50;this.config.push("colWidth");this.rowHeight=15;this.config.push("rowHeight");this.freezeColLeft=0;this.config.push("freezeColLeft");this.freezeColRight=0;this.config.push("freezeColRight");this.freezeRowTop=0;this.config.push("freezeRowTop");this.freezeRowBottom=0;this.config.push("freezeRowBottom");this.refresehDataTableOnDraw=false;this.config.push("refresehDataTableOnDraw");this.showDataTableOnSelect=true;this.config.push("showDataTableOnSelect");this.networkShowDataTable="nodes";this.config.push("networkShowDataTable");this.startCol=1;this.startRow=1;this.dataTableColumnWidth=[];this.dataTableRowHeight=[];if(!a){this.setSkin();this.setConfig(this.config);this.initDimensions();this.initUtils();this.initPlotUtils();this.initConfigUtils();this.initLegendUtils();this.init3dUtils();this.initApi();this.initText();this.initTime();this.initColor();this.initAttributes()}};CanvasXpress.prototype.initDimensions=function(){this.resizeCanvas=function(c,a,b){if(this.ctx){this.disableGradientTransparency();if(c||a||b){if(a||b){if(a){this.width=a;this.originalWidth=a}if(b){this.height=b;this.originalHeight=b}}else{if(c){this.width=this.originalWidth;this.height=this.originalHeight}}this.top=this.margin;if(this.title){this.top+=this.titleHeight+this.margin;if(this.subtitle){this.top+=this.subtitleHeight+this.margin}}this.left=this.margin;this.right=this.margin;this.bottom=this.margin;this.resetMap()}this.canvas.width=this.width;this.canvas.height=this.height;if(this.backgroundType=="image"||this.backgroundType=="windowImage"){this.ctx.save();this.ctx.translate(0,0);this.drawImage(CanvasXpress.cacheImages[this.backgroundImage],0,0,this.width,this.height);this.ctx.restore()}else{if(this.backgroundType=="solid"||this.backgroundType=="window"||this.backgroundType=="windowSolidGradient"){this.rectangle(0,0,this.width,this.height,this.background,this.background)}else{this.setLinearGradient(0,0,0,this.height,this.backgroundGradient1Color,this.backgroundGradient2Color);this.ctx.fillRect(0,0,this.width,this.height)}}this.enableGradientTransparency()}};this.setWidth=function(a){if(!a){a=1000}this.draw(a)};this.setHeight=function(a){if(!a){a=8000}this.draw(false,a)};this.setDimensions=function(a,b){if(!a){a=1000}if(!b){b=1000}this.draw(a,b)};this.initializeDimensions=function(){if(this.canvas.width){this.originalWidth=this.canvas.width;this.width=this.canvas.width}else{if(this.width){this.originalWidth=this.width;this.canvas.width=this.width}else{this.width=600;this.originalWidth=this.width;this.canvas.width=this.width}}if(this.canvas.height){this.originalHeight=this.canvas.height;this.height=this.canvas.height}else{if(this.height){this.originalHeight=this.height;this.canvas.height=this.height}else{this.height=600;this.originalHeight=this.height;this.canvas.height=this.height}}this.top=this.margin;if(this.title){this.top+=this.titleHeight+this.margin;if(this.subtitle){this.top+=this.subtitleHeight+this.margin}}this.left=this.margin;this.right=this.margin;this.bottom=this.margin;this.x=this.width-(this.leftMargin+this.left+this.rightMargin+this.right);this.y=this.height-(this.topMargin+this.top+this.bottomMargin+this.bottom)};this.initializeDimensions()};CanvasXpress.prototype.initPlotUtils=function(){this.drawCanvasBox=function(){if(this.canvasBox&&this.graphType!="Network"){this.rectangle(0,0,this.width-1,this.height-1,false,this.canvasBoxColor,"open")}};this.drawPlotWindow=function(){if(this.backgroundType.match("window")){this.disableGradientTransparency();var a=this.marginLeft+this.offsetX;var b=this.marginTop+this.offsetY;if(this.backgroundType=="windowGradient2"||this.backgroundType=="windowSolidGradient"){this.ctx.save();if(this.backgroundWindowGradientOrientation=="horizontal"){this.setLinearGradient(a+this.left,b,a+this.left+this.x,b,this.backgroundWindowGradient1Color,this.backgroundWindowGradient2Color)}else{this.setLinearGradient(a,b+this.top,a,b+this.top+this.y,this.backgroundWindowGradient1Color,this.backgroundWindowGradient2Color)}this.ctx.fillRect(a+this.left,b+this.top,this.x,this.y)}else{this.rectangle(a+this.left,b+this.top,this.x,this.y,this.backgroundWindow,this.backgroundWindow)}this.enableGradientTransparency()}};this.maskArea=function(p){this.disableGradientTransparency();var m=function(i,e,t,l){this.ctx.fillRect(i,e,t,l)};var q;var f=this.marginLeft+this.offsetX;var s=this.marginTop+this.offsetY;var n=this.outlineWidth+1;var a=[0,0,this.width,this.marginTop];var h=[0,0,this.marginLeft,this.height];var r=[0,this.height-this.marginBottom,this.width,this.marginBottom];var c=[this.width-this.marginRight,0,this.marginRight,this.height];var g=p?[f,s,this.left,this.top-n]:[f,s,(this.left+this.x+this.right),this.top-n];var o=p?[f,s+this.top+this.y,this.left-n,this.bottom]:[f,s,this.left-n,(this.top+this.y+this.bottom)];var b=p?[f+this.left+this.x,s+this.top+this.y+n,this.right,this.bottom]:[f,s+this.top+this.y+n,(this.left+this.x+this.right),this.bottom];var k=p?[f+this.left+this.x+n,s,this.right,this.top]:[f+this.left+this.x+n,s,this.right,(this.top+this.y+this.bottom)];var d=[a,h,r,c,g,o,b,k];if(this.backgroundType=="image"||this.backgroundType=="windowImage"){this.ctx.save();this.ctx.translate(0,0);for(var j=0;j<d.length;j++){d[j].unshift(CanvasXpress.cacheImages[this.backgroundImage])}q=this.drawImage}else{if(this.backgroundType=="solid"||this.backgroundType=="window"||this.backgroundType=="windowSolidGradient"){for(var j=0;j<d.length;j++){d[j].push(this.background);d[j].push(this.background)}q=this.rectangle}else{this.setLinearGradient(0,0,0,this.height,this.backgroundGradient1Color,this.backgroundGradient2Color);q=m}}if(this.marginTop){q.apply(this,a)}if(this.marginLeft){q.apply(this,h)}if(this.marginBottom){q.apply(this,r)}if(this.marginRight){q.apply(this,c)}q.apply(this,g);q.apply(this,o);q.apply(this,b);q.apply(this,k);if(this.backgroundType=="image"||this.backgroundType=="windowImage"){this.ctx.restore()}this.enableGradientTransparency()};this.maskPlotArea=function(){this.maskArea()};this.maskTreeArea=function(){this.maskArea(true)}};CanvasXpress.prototype.initColor=function(){this.validateColor=function(b,a){if(b.match(/^rgba?\((\d{1,3},\d{1,3},\d{1,3})(?:,([0-9\.]+))?/i)){if(RegExp.$2){b="rgba("+RegExp.$1+","+RegExp.$2+")"}else{b="rgb("+RegExp.$1+")"}}else{if(b.match(/^#?[0-9abcdef]/i)){b=this.hexToRgb(b)}else{b=false}}return b&&a!=null?this.addColorTransparency(b,a):b};this.darkenLightenColor=function(j,e){j=this.rgbToHex(j).substring(1,7);var i=parseInt(j,16);var h=(i>>16)+e;h=h>255?255:h<0?0:h;var f=((i>>8)&255)+e;f=f>255?255:f<0?0:f;var d=(i&255)+e;d=d>255?255:d<0?0:d;j=d|(f<<8)|(h<<16);return this.hexToRgb(j.toString(16))};this.rgbToHex=function(b){var a=function(c){c=parseInt(c,10);if(isNaN(c)){return"00"}c=Math.max(0,Math.min(c,255));return"0123456789ABCDEF".charAt((c-c%16)/16)+"0123456789ABCDEF".charAt(c%16)};if(b.substr(0,1)==="#"){return b}if(b.match(/^rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)/)){return"#"+a(RegExp.$1)+a(RegExp.$2)+a(RegExp.$3)}else{return b}};this.hexToRgb=function(c){var b=function(){return parseInt(c.substring(0,2),16)};var a=function(){return parseInt(c.substring(2,4),16)};var d=function(){return parseInt(c.substring(4,6),16)};c=c.charAt(0)=="#"?c.substring(1,7):c;return"rgb("+b()+","+a()+","+d()+")"};this.addColorTransparency=function(b,a){if(b.match(/^rgba?\((\d{1,3},\d{1,3},\d{1,3})(?:,([0-9\.]+))?/i)){if(RegExp.$2){return"rgba("+RegExp.$1+","+a+")"}else{return"rgba("+RegExp.$1+","+a+")"}}else{return false}};this.disableGradientTransparency=function(){this.gradientTemp=this.gradient;this.transparencyTemp=this.transparency;this.gradient=false;this.transparency=null};this.enableGradientTransparency=function(){this.gradient=this.gradientTemp;this.transparency=this.transparencyTemp};this.getGradientColor=function(h){if(h.match(/^rgba?\((\d{1,3}),(\d{1,3}),(\d{1,3})(?:,([0-9\.]+))?/i)){var f=Math.floor(parseInt(RegExp.$1)/this.gradientRatio);var e=Math.floor(parseInt(RegExp.$2)/this.gradientRatio);var a=Math.floor(parseInt(RegExp.$3)/this.gradientRatio);var d=RegExp.$4?parseFloat(RegExp.$4):false;if(d){return"rgba("+f+","+e+","+a+","+d+")"}else{return"rgb("+f+","+e+","+a+")"}}else{return false}};this.setGradient=function(e,d,c,b,a){if(this.gradientType=="radial"){this.setRadialGradient(e,d,c,b,false,false,true)}else{this.setLinearGradient(e,d,c,b,a,false,true)}};this.setLinearGradient=function(c,i,a,f,e,b,d){if(!d){this.ctx.save()}var h=this.ctx.createLinearGradient(c,i,a,f);if(!b){b=this.getGradientColor(e);h.addColorStop(0,b);h.addColorStop(0.6,e);h.addColorStop(1,e)}else{h.addColorStop(0,e);h.addColorStop(1,b)}this.ctx.fillStyle=h};this.setRadialGradient=function(j,h,a,e,d,c,i){if(!i){this.ctx.save()}var b=a/5.5;var f=this.ctx.createRadialGradient(j-b,h-b,1,j,h,a);if(!d){if(this.transparency!=null){d="rgba(0,0,0,"+this.transparency+")"}else{d="rgb(0,0,0)"}}if(!c){c="rgba(0,0,0,0)"}f.addColorStop(0,e);f.addColorStop(1,d);f.addColorStop(1,c);this.ctx.fillStyle=f}};CanvasXpress.prototype.initUtils=function(){this.modifyObjectArray=function(f,b,g){var a=this[g];if(b){var d={};var c=[];if(this.isArray(f)){for(var e=0;e<f.length;e++){d[f[e]]=1}}else{d[f]=1}for(var e=0;e<a.length;e++){if(!d.hasOwnProperty(a[e])){c.push(a[e])}}this[g]=c}else{if(this.isArray(f)){for(var e=0;e<f.length;e++){a.push(f[e])}}else{a.push(f)}}};this.getObjectArray=function(a){var b={};if(a&&this.isArray(a)){for(var c=0;c<a.length;c++){b[a[c]]=1}}return b};this.isInArray=function(d,b){if(b&&!(b.propertyIsEnumerable("length"))&&typeof b==="object"&&typeof b.length==="number"){for(var c=0;c<b.length;c++){if(b[c]==d){return true}}}return false};this.isArray=function(a){if(a&&!(a.propertyIsEnumerable("length"))&&typeof a==="object"&&typeof a.length==="number"){return true}else{return false}};this.isObject=function(a){return a instanceof Object};this.toArray=function(a){return this.isArray(a)?a:[a]};this.getKeys=function(c){var b=[];if(this.isObject(c)){for(var a in c){b.push(a)}}return b};this.toNumber=function(b,e){var g=[];var c=this.isArray(b);b=this.toArray(b);for(var d=0;d<b.length;d++){if(e){g.push(parseFloat(b[d]))}else{g.push(parseInt(b[d]))}}return c?g:g[0]};this.cloneObject=function(c){if(c==null||typeof(c)!="object"){return c}var a=new c.constructor();for(var b in c){a[b]=this.cloneObject(c[b])}return a};this.isSameObject=function(d,c){if(d===c){return true}if(typeof(d)!="object"||typeof(c)!="object"){return false}for(var e in d){if(d[e]===c[e]){continue}if(c[e]===undefined||typeof(d[e])!=typeof(c[e])){return false}if(!this.isSameObject(d[e],c[e])){return false}}for(var e in c){if(d[e]===undefined){return false}}return true}};CanvasXpress.prototype.initConfigUtils=function(){this.getPixelImage=function(){if(navigator.onLine){return this.imageDir+"canvasXpress.gif"}else{if(this.path){return this.path+"canvasXpress.gif"}else{alert("Dude! I couldn't find canvasXpress.js")}}};this.drawTitle=function(){var c;var b;var a;if(this.title){b=this.titleHeight/2;c=this.scaleTextToFont(this.title,this.titleHeight-b,this.x);this.drawText(this.title,this.width/2,this.marginTop+(this.titleHeight/2),c,this.titleColor,"center","middle");if(this.subtitle){a=this.subtitleHeight/4;c=this.scaleTextToFont(this.subtitle,this.subtitleHeight-a,this.x);this.drawText(this.subtitle,this.width/2,(this.marginTop+this.titleHeight)+(this.subtitleHeight/2),c,this.subtitleColor,"center","middle")}}};this.drawCitation=function(a,d,b){if(this.citation){var c=this.citationFont;if(!a){a=this.width-this.margin}if(!d){d=this.height-this.margin}if(b){c=(this.citationFont*b)+"Pt "+this.fontName}this.drawText(this.citation,a,d,c,this.citationColor,"right","bottom")}};this.drawSelectedBackground=function(f,i,j,b,d,e,c,a,g){if(this.isInSelectedDataPoints(f,i)){this.drawShape(j,b,d,e+12,c+12,this.selectedBackgroundColor,this.foreground,"closed",a,1,g)}};this.isInSelectedDataPoints=function(a,b){if(this.isSelectDataPoints){if(this.selectDataPoint[a]){if(this.broadcastType=="var"){return true}else{if(this.selectDataPoint[a].hasOwnProperty(b)){return true}}}}return false};this.isVisibleSelectedDataPoint=function(a,b){if(this.isSelectDataPoints){if(this.hideDataPoint.length>0&&this.hideDataPoint[a]){if(this.hideDataPoint[a].hasOwnProperty(b)){return false}}}return true};this.getVarColor=function(a){if(this.isArray(this.highlightVar)){for(var b=0;b<this.highlightVar.length;b++){if(this.highlightVar[b]==a){return this.varHighlightColor}}}else{if(this.highlightVar==a){return this.varHighlightColor}}return this.varLabelColor};this.getSmpColor=function(b){if(this.isArray(this.highlightSmp)){for(var a=0;a<this.highlightSmp.length;a++){if(this.highlightSmp[a]==b){return this.smpHighlightColor}}}else{if(this.highlightSmp==b){return this.smpHighlightColor}}return this.smpLabelColor};this.getNodeColor=function(c,a){if(this.isArray(this.highlightNode)){for(var b=0;b<this.highlightNode.length;b++){if(this.highlightNode[b]==c){return this.nodeHighlightColor}}}else{if(this.highlightNode==c){return this.nodeHighlightColor}}return this.selectNode.hasOwnProperty(c)?this.nodeHighlightColor:a?a:this.nodeFontColor};this.getTechnicalIndicatorColor=function(a){return this[a.toLowerCase()+"Color"]?this[a.toLowerCase()+"Color"]:"rgb(255,255,0)"};this.setPieData=function(g,a){var f={no:0,idso:[],ids:[],data:{},oprc:0,tot:this.sum(g)};for(var c=0;c<g.length;c++){var b=a?this.varIndices[c]:c;var e=g[b]/f.tot;f.data[b]=e;if(c>=this.maxPieSectors-1){f.oprc+=e;f.idso.push(b);f.no++}else{f.ids.push(b)}}if(f.no){f.ids.push(-1)}return f};this.drawPie=function(u,h,g,t,J){var q=function(){for(var a=0;a<u.ids.length;a++){if(isNaN(u.data[a])){return false}}return true};var o=this.startPieSectors?(this.startPieSectors*Math.PI/180)%360:0;var A=this.pieSegmentLabels=="inside"?t-(t/3):t+(t/10);var H=0;var D=this.layoutComb?this.smpIndices[0]:this.xAxisIndices?this.xAxisIndices[0]:0;var m=this.ctx.lineWidth;var z,e;if(q()){for(var E=0;E<u.ids.length;E++){var n=u.ids[E];var v=n>-1?u.data[n]:u.oprc;var f=E%this.colors.length;z=e!=null?e:(Math.PI*(2*H))-o;if(z>(Math.PI*2)){z=z%(Math.PI*2)}e=z+(Math.PI*(2*(v)));if(e>(Math.PI*2)){e=e%(Math.PI*2)}var I=(z+e)/2;var C=(e-z)/32;var G=this.transparency!=null?this.validateColor(this.colors[f],this.transparency):this.colors[f];if(this.gradient){this.setRadialGradient(h,g,t*1.3,G)}else{this.ctx.fillStyle=G}this.ctx.beginPath();this.ctx.lineWidth=this.pieSegmentSeparation;this.ctx.strokeStyle=this.pieType=="separated"?this.background:this.pieType=="solid"?this.foreground:this.foreground;if(this.showShadow){this.ctx.shadowOffsetX=this.shadowOffsetX;this.ctx.shadowOffsetY=this.shadowOffsetY;this.ctx.shadowBlur=this.shadowBlur;this.ctx.shadowColor=this.shadowColor}this.ctx.moveTo(h,g);this.ctx.arc(h,g,t,z,e,false);this.ctx.lineTo(h,g);this.ctx.closePath();this.ctx.fill();if(this.graphType!="Network"){this.ctx.stroke()}if(this.showShadow){this.ctx.restore();this.ctx.shadowOffsetX=0;this.ctx.shadowOffsetY=0;this.ctx.shadowBlur=0;this.ctx.shadowColor=this.background}var F=h-Math.sin(I-(Math.PI/2))*A;var d=g+Math.cos(I-(Math.PI/2))*A;if(this.graphType!="Network"&&this.showPieValues){this.drawText(sprintf("%."+this.pieSegmentPrecision+"f",v*100)+"%",F,d,this.axisTickFont,this.axisTickColor,"center","middle")}if(J){F=h+t*Math.cos(z);d=g+t*Math.sin(z);var b=["poly",h,g,F,d];var o=z;for(var B=0;B<32;B++){o+=C;F=h+t*Math.cos(o);d=g+t*Math.sin(o);b.push(F);b.push(d)}b.push(h);b.push(g);if(n>-1){this.addArea(b,[n,D])}else{u.idso.push(D);this.addArea(b,u.idso)}}H+=v}this.ctx.lineWidth=m}};this.drawBarPlot=function(K,J,F,x,k,C,p,g,E,D,L,N){var n,j,I,B;var M=this.backgroundType.match(/window/i)?this.foregroundWindow:this.foreground;var A=this.seriesSeparationFactor/2;var H=k/2;if(D=="vertical"){for(var G=0;G<K.length;G++){n=((K[G]-E)*p)-g;if(!isNaN(n)){this.addArea(this.rectangle(F+A,x,k-this.seriesSeparationFactor,-n,L[G],L[G],"closed",false,false,true),N[G]);I=x-n;B=F+H;if(J[G]&&!isNaN(J[G])){j=(((J[G]-E)/2)*p)-(g/2);this.errorBar(B,I,B,I+j,-H,M);this.errorBar(B,I,B,I-j,-H,M)}if(this.showDataValues){this.drawText(K[G],B,x-(j+this.overlayFontSize),this.overlayFont,L[G],"center","bottom")}}F+=C}}else{for(var G=0;G<K.length;G++){n=((K[G]-E)*p)-g;if(!isNaN(n)){this.addArea(this.rectangle(F,x+A,n,k-this.seriesSeparationFactor,L[G],L[G],"closed",false,false,true),N[G]);I=F+n;B=x+H;if(J[G]&&!isNaN(J[G])){j=(((J[G]-E)/2)*p)-(g/2);this.errorBar(I,B,I+j,B,H,M);this.errorBar(I,B,I-j,B,H,M)}if(this.showDataValues){this.drawText(K[G],K+j+this.overlayFontSize,B,this.overlayFont,L[G],"left","middle")}}x+=C}}};this.drawLinePlot=function(M,L,F,y,v,H,x,E,C,N,A,P){var B,K,J,I,j,g,f;var r=v/2;var q=v/3;var O=this.backgroundType.match(/window/i)?this.foregroundWindow:this.foreground;var D=M.length-1;var k=[[],[]];if(C=="vertical"){K=F;J=F+H;for(var G=1;G<M.length;G++){B=G-1;j=y-((M[B]-E)*x);g=y-((M[G]-E)*x);if(!isNaN(j)){if(this.lineDecoration&&A){this.addArea(this.drawShape(A,K,j,q,q,N,O,"closed",false,false,true),P[B])}if(L[B]&&!isNaN(L[B])){f=((L[B]-E)/2)*x;this.errorBar(K,j,K,j+f,-r,N);this.errorBar(K,j,K,j-f,-r,N)}if(this.lineType=="spline"){k[0].push(K);k[1].push(j)}}if(this.lineType!="spline"&&!isNaN(j)&&!isNaN(g)){this.drawLine("line",K,j,J,g,N,this.lineThickness,"butt",false,false,true)}else{if(this.lineType=="spline"&&isNaN(g)){this.drawLine("spline",k[0],k[1],false,false,N,this.lineThickness);k=[[],[]]}}K+=H;J+=H}if(!isNaN(g)){if(this.lineDecoration&&A){this.addArea(this.drawShape(A,K,g,q,q,N,O,"closed",false,false,true),P[D])}if(L[D]&&!isNaN(L[D])){f=((L[D]-E)/2)*x;this.errorBar(K,g,K,g+f,-r,N);this.errorBar(K,g,K,g-f,-r,N)}if(this.lineType=="spline"){k[0].push(K);k[1].push(g)}}if(this.lineType=="spline"){this.drawLine("spline",k[0],k[1],false,false,N,this.lineThickness)}}else{j=y;g=y+H;for(var G=1;G<M.length;G++){B=G-1;K=F+((M[B]-E)*x);J=F+((M[G]-E)*x);if(!isNaN(K)){if(this.lineDecoration&&A){this.addArea(this.drawShape(A,K,j,q,q,N,O,"closed",false,false,true),P[B])}if(L[B]&&!isNaN(L[B])){I=((L[B]-E)/2)*x;this.errorBar(K,j,K+I,j,r,N);this.errorBar(K,j,K-I,j,r,N)}if(this.lineType=="spline"){k[0].push(K);k[1].push(j)}}if(this.lineType!="spline"&&!isNaN(K)&&!isNaN(J)){this.drawLine("line",J,g,K,j,N,this.lineThickness,"butt",false,false,true)}else{if(this.lineType=="spline"&&isNaN(J)){this.drawLine("spline",k[0],k[1],false,false,N,this.lineThickness);k=[[],[]]}}j+=H;g+=H}if(!isNaN(J)){if(this.lineDecoration&&A){this.addArea(this.drawShape(A,J,j,q,q,N,O,"closed",false,false,true),P[D])}if(L[D]&&!isNaN(L[D])){I=((L[D]-E)/2)*x;this.errorBar(J,j,J+I,j,-r,N);this.errorBar(J,j,J-I,j,-r,N)}if(this.lineType=="spline"){k[0].push(J);k[1].push(j)}}if(this.lineType=="spline"){this.drawLine("spline",k[0],k[1],false,false,N,this.lineThickness)}}};this.drawStackedPlot=function(k,f,x,q,b,j,s,e,m,n){if(e=="vertical"){for(var h=0;h<k.length;h++){var r=b?(k[h]*100/j)*s:k[h]*s;this.addArea(this.rectangle(f,x,q,-r,m[h]),n[h]);x-=r}}else{for(var h=0;h<k.length;h++){var r=b?(k[h]*100/j)*s:k[h]*s;this.addArea(this.rectangle(f,x,r,q,m[h]),n[h]);f+=r}}};this.drawAreaPlot=function(T,M,E,B,Q,F,D,L,J,S,U,V){var I=S?"open":"close";var K=T.length-1;var N=S&&this.lineType=="rect"?"path":this.lineType=="rect"?"polygon":"spline";var R=[];var G=[];if(this.graphOrientation=="vertical"){for(var P=0;P<T[0].length;P++){R[P]=E}for(var P=0;P<T.length;P++){var H=M;var A=S?[]:[M];var e=S?[]:[E];for(var O=0;O<T[0].length;O++){var C=!isNaN(T[P][O])?(T[P][O]-L)*D:0;A.push(H);if(this.areaIsCumulative){e.push(R[O]-C);R[O]-=C}else{e.push(E-C)}H+=F}if(!S){A.push(M+B);e.push(E)}G.push([A,e])}}else{for(var P=0;P<T[0].length;P++){R[P]=M}for(var P=0;P<T.length;P++){var H=E;var A=S?[]:[M];var e=S?[]:[E];for(var O=0;O<T[0].length;O++){var C=!isNaN(T[P][O])?(T[P][O]-L)*D:0;e.push(H);if(this.areaIsCumulative){A.push(R[O]+C);R[O]+=C}else{A.push(M+C)}H+=F}if(!S){A.push(M);e.push(E+Q)}G.push([A,e])}}while(K>=0){var b=G.pop();if(S&&this.lineType=="spline"){this.addArea(this.drawLine(N,b[0],b[1],false,false,U[K],this.lineThickness),V[K])}else{this.addArea(this.drawShape(N,b[0],b[1],false,false,U[K],U[K],I),V[K])}K--}};this.drawBoxPlot=function(I,D,p,g,A,n,C,B,J,L){var e=function(a){return B=="vertical"?p-((a-C)*n):D+((a-C)*n)};var K=this.backgroundType.match(/window/i)?this.foregroundWindow:this.foreground;var x=this.seriesSeparationFactor/2;var G=g/2;var H=g/3;if(B=="vertical"){for(var F=0;F<I.length;F++){var y=D+G;var k=[];for(var E=0;E<5;E++){k.push(e(I[F][E]))}this.addArea(this.rectangle(D+x,k[2],g-this.seriesSeparationFactor,k[3]-k[2],J,J,"closed",false,false,true),L[F]);this.drawLine("line",D+x,k[4],D+(g-x),k[4],K,false,"butt",false,false,true);this.errorBar(y,k[2],y,k[0],-G,K);this.errorBar(y,k[3],y,k[1],-G,K);if(I[F][5]){for(var E=0;E<I[F][5].length;E++){this.drawShape("sphere",y,e(I[F][5][E]),H,H,J,K,"closed",false,false,true)}}D+=A}}else{for(var F=0;F<I.length;F++){var y=p+G;var k=[];for(var E=0;E<5;E++){k.push(e(I[F][E]))}this.addArea(this.rectangle(k[2],p+x,k[3]-k[2],g-this.seriesSeparationFactor,J,J,"closed",false,false,true),L[F]);this.drawLine("line",k[4],p+x,k[4],p+(g-x),K,false,"butt",false,false,true);this.errorBar(k[2],y,k[0],y,G,K);this.errorBar(k[3],y,k[1],y,G,K);if(I[F][5]){for(var E=0;E<I[F][5].length;E++){this.drawShape("sphere",e(I[F][5][E]),y,H,H,J,K,"closed",false,false,true)}}p+=A}}};this.drawCandlestickPlot=function(G,B,q,f,F,n,A,x,y,H,J){var e=function(a){return y=="vertical"?q-((a-A)*n):B+((a-A)*n)};var I=this.backgroundType.match(/window/i)?this.foregroundWindow:this.foreground;var E=f/2;if(y=="vertical"){for(var D=0;D<G.length;D++){var s=B+E;var k=[];for(var C=0;C<G[D].length;C++){k.push(e(G[D][C]))}if(x){if(k[0]>k[1]){this.addArea(this.rectangle(B,k[0],f,k[1]-k[0],false,H,"open",false,false,true),J[D]);this.drawLine("line",s,k[1],s,k[2],H,false,"butt",false,false,true);this.drawLine("line",s,k[3],s,k[0],H,false,"butt",false,false,true)}else{this.addArea(this.rectangle(B,k[0],f,k[1]-k[0],H,H,"closed",false,false,true),J[D]);this.drawLine("line",s,k[3],s,k[1],H,false,"butt",false,false,true);this.drawLine("line",s,k[0],s,k[2],H,false,"butt",false,false,true)}}else{this.addArea(this.rectangle(B,k[0],f,q-k[0],H,H,"closed",false,false,true),J[D])}B+=F}}else{for(var D=0;D<G.length;D++){var s=q+E;var k=[];for(var C=0;C<G[D].length;C++){k.push(e(G[D][C]))}if(x){if(k[1]>k[0]){this.addArea(this.rectangle(k[0],q,k[1]-k[0],f,false,H,"open",false,false,true),J[D]);this.drawLine("line",k[1],s,k[2],s,H,false,"butt",false,false,true);this.drawLine("line",k[3],s,k[0],s,H,false,"butt",false,false,true)}else{this.addArea(this.rectangle(k[0],q,k[1]-k[0],f,H,H,"closed",false,false,true),J[D]);this.drawLine("line",k[3],s,k[1],s,H,false,"butt",false,false,true);this.drawLine("line",k[0],s,k[2],s,H,false,"butt",false,false,true)}}else{this.addArea(this.rectangle(B,q,k[0]-B,f,H,H,"closed",false,false,true),J[D])}q+=F}}};this.drawDotPlot=function(H,G,C,r,g,F,y,n,B,x,A,I,z,K){var k,f;var J=this.backgroundType.match(/window/i)?this.foregroundWindow:this.foreground;if(A=="vertical"){for(var E=0;E<H.length;E++){for(var D=0;D<H[E].length;D++){k=r-((H[E][D]-B)*n);if(!isNaN(k)){this.addArea(this.drawShape(z,C,k,x,x,I,J,"closed",false,false,true),K[E]);if(G[E]&&!isNaN(G[E])){f=((G[E]-B)/2)*n;this.errorBar(C,k,C,k+f,-F,I);this.errorBar(C,k,C,k-f,-F,I)}}}C+=y}}else{for(var E=0;E<H.length;E++){for(var D=0;D<H[E].length;D++){k=C+((H[E][D]-B)*n);if(!isNaN(k)){this.addArea(this.drawShape(z,k,r,x,x,I,J,"closed",false,false,true),K[E]);if(G[E]&&!isNaN(G[E])){f=((G[E]-B)/2)*n;this.errorBar(k,r,k+f,r,F,I);this.errorBar(k,r,k-f,r,F,I)}}}r+=y}}};this.drawHeatmap=function(u,k,D,B,q,j,A,s,z,r){var g=this.backgroundType.match(/window/i)?this.foregroundWindow:this.foreground;var b=this.graphType=="Network"?false:true;for(var m=0;m<u.length;m++){var C=u[m];var y=!isNaN(C)?this.getHeatmapColor(j,A,C):this.missingDataColor;g=s?y:g;this.addArea(this.rectangleHM(k,D,B,q,y,g,"closed",false,false,b),z[m],r);if(this.showDataValues){this.drawText(C,(k+B)-2,(D+q)-2,this.overlayFont,this.foreground,"right","bottom")}k+=B}}};CanvasXpress.prototype.init3dUtils=function(){this.set3DRotation=function(){var a;var c=0;var b=0;if(this.graphType=="Network"){c=this.maxRotate!=null?this.maxRotate:360;b=this.minRotate!=null?this.minRotate:360}else{if(this.graphType=="Scatter3D"){c=this.maxRotate!=null?this.maxRotate:90;b=this.minRotate!=null?this.minRotate:0}}if(this.xRotate>c){this.xRotate=c}if(this.xRotate<0){this.xRotate=b}if(this.yRotate>c){this.yRotate=c}if(this.yRotate<0){this.yRotate=b}if(this.zRotate>c){this.zRotate=c}if(this.zRotate<0){this.zRotate=b}if(this.xRotate>0){a=180/this.xRotate;this.ry=Math.PI/a}else{this.ry=0}if(this.yRotate>0){a=180/this.yRotate;this.rx=Math.PI/a}else{this.rx=0}if(this.zRotate>0){a=180/this.zRotate;this.rz=Math.PI/a}else{this.rz=0}};this.set3DParams=function(){this.perspective=this.x*1.5;this.len=this.x/4*this.zoom;this.pad=this.x/2};this.get3DTransfrom=function(e,f,g){var d,c,b;var a=[];c=f;b=g;f=c*Math.cos(this.rx)-b*Math.sin(this.rx);g=c*Math.sin(this.rx)+b*Math.cos(this.rx);d=e;b=g;e=b*Math.sin(this.ry)+d*Math.cos(this.ry);g=b*Math.cos(this.ry)-d*Math.sin(this.ry);d=e;c=f;e=d*Math.cos(this.rz)-c*Math.sin(this.rz);f=d*Math.sin(this.rz)+c*Math.cos(this.rz);e=e*(this.perspective/(g+this.perspective));f=f*(this.perspective/(g+this.perspective));g=g*(this.perspective/(g+this.perspective));a.push(e+this.pad);a.push(f+this.pad);a.push(g+this.pad);return a};this.backfaceCulling=function(s){var y=[];var w=[];var u=[];var r=[];var q=[];var p=[];for(var o=0;o<s.length;o++){var k=s[o][1][0]-s[o][0][0];var x=s[o][1][1]-s[o][0][1];var n=s[o][1][2]-s[o][0][2];var j=s[o][2][0]-s[o][0][0];var v=s[o][2][1]-s[o][0][1];var m=s[o][2][2]-s[o][0][2];var h=s[o][3][0]-s[o][0][0];var t=s[o][3][1]-s[o][0][1];var l=s[o][3][2]-s[o][0][2];y[o]=x*m-v*n;w[o]=j*n-k*m;u[o]=k*v-j*x;r[o]=t*m-v*l;q[o]=j*l-h*m;p[o]=h*v-j*t}return[y,w,u,r,q,p]}};CanvasXpress.prototype.initLegendUtils=function(){this.drawDecorationData=function(){var T=this.marginLeft+this.offsetX+this.left;var K=this.marginTop+this.offsetY+this.top;var aa=this.data.d;if(this.showDecorations&&aa){if(aa.nlfit){var X,w,Z;var h=this.smpIndices;var s,a;for(var W=0;W<aa.nlfit.length;W++){var E=[];var D=[];var m=W%this.colors.length;var R=aa.nlfit[W].param[0];var P=aa.nlfit[W].param[1];var N=aa.nlfit[W].param[2];var L=aa.nlfit[W].param[3];var F=this.xAxisIndices[W];if(this.xAxisTransform=="percentile"){X=this.getAxisRangeBySample(F);Z=X[0];w=X[1]}var G=this.data.y.data[F];h.sort(function(i,d){return G[i]-G[d]});m=aa.nlfit[W].color?aa.nlfit[W].color:this.colors[m];for(var V=0;V<h.length;V++){var o=h[V];var J=this.getDataAtPos(F,o,false,this.xAxisTransform,Z,w);var I;var p=[];if(J>0){if(V>0){var b=h[V-1];var H=this.getDataAtPos(F,b,false,this.xAxisTransform,Z,w);if(H>0){var c=(J-H)/this.functionIntervals;for(var U=0;U<this.functionIntervals;U++){p.push(H);H+=c}}}else{p=[J]}for(var U=0;U<p.length;U++){if(aa.nlfit[W].type=="reg"){I=R+((P-R)/(1+N/(Math.pow(p[U],L))))}else{I=R+((P-R)/(1+(Math.pow((p[U]/N),L))))}s=T+((p[U]-this.xAxisMin)*this.xAxisUnit);a=(K+this.y)-((I-this.yAxisMin)*this.yAxisUnit);E.push(s);D.push(a)}}}if(E.length>0){this.drawShape("path",E,D,false,false,m,m,"open");if(aa.nlfit[W].type=="reg"){I=R+((P-R)/(1+N/(Math.pow(N,L))))}else{I=R+((P-R)/(1+(Math.pow((N/N),L))))}s=T+((N-this.xAxisMin)*this.xAxisUnit);a=(K+this.y)-((I-this.yAxisMin)*this.yAxisUnit);this.drawLine("dashedLine",T,a,s,a,m);this.drawLine("dashedLine",s,a,s,(K+this.y),m)}}}if(aa.line){for(var W=0;W<aa.line.length;W++){if(aa.line[W].x||aa.line[W].y){var m=aa.line[W].color?aa.line[W].color:this.colors[W%this.colors.length];var ac=aa.line[W].type?aa.line[W].type:"line";var J=aa.line[W].x?aa.line[W].x:false;var I=aa.line[W].y?aa.line[W].y:false;var s,a,q,ad;if(J){s=T+(J*this.xAxisUnit)-(this.xAxisMin*this.xAxisUnit);a=K;q=s;ad=a+this.y;this.drawLine(ac,s,a,q,ad,m)}if(I){s=T;a=K+(I*this.yAxisUnit)+(this.yAxisMin*this.yAxisUnit);q=s+this.x;ad=a;this.drawLine(ac,s,a,q,ad,m)}}}}if(aa.reg){for(var W=0;W<aa.reg.length;W++){if(aa.reg[W].slope&&aa.reg[W].intercept){var m=W%this.colors.length;var ac=aa.reg[W].type?aa.reg[W].type:"line";var v=aa.reg[W].slope;var Q=aa.reg[W].intercept;var f=aa.reg[W].cor;var s=aa.reg[W].start?aa.reg[W].start:this.xAxisMin;var a=(v*s)+Q;var q=aa.reg[W].end?aa.reg[W].end:this.xAxisMax;var ad=(v*q)+Q;s=T+(s*this.xAxisUnit)-(this.xAxisMin*this.xAxisUnit);a=(K+this.y)-(a*this.yAxisUnit)+(this.yAxisMin*this.yAxisUnit);q=T+(q*this.xAxisUnit)-(this.xAxisMin*this.xAxisUnit);ad=(K+this.y)-(ad*this.yAxisUnit)+(this.yAxisMin*this.yAxisUnit);m=aa.reg[W].color?aa.reg[W].color:this.colors[m];this.drawLine(ac,s,a,q,ad,m)}}}if(aa.nor){for(var W=0;W<aa.nor.length;W++){if(aa.nor[W].mu&&aa.nor[W].sigma){var S=[];var O=[];var C=[];var s,a;var m=W%this.colors.length;var n=aa.nor[W].mu;var e=aa.nor[W].sigma;var A=aa.nor[W].start?aa.nor[W].start:aa.nor[W].yAxis?this.yAxisMin:this.xAxisMin;var u=aa.nor[W].end?aa.nor[W].end:aa.nor[W].yAxis?this.yAxisMax:this.xAxisMax;var g=120;if(A<n&&n<u){var H,r,z,Y;var c=(n-A)/g;var ab=e*e;var M=ab*2;var B=1/Math.sqrt(2*Math.PI*ab);if(aa.nor[W].yAxis){z=aa.nor[W].max?aa.nor[W].max*this.xAxisUnit:this.x-(this.x*this.axisExtension);Y=z/B;H=A;for(var V=0;V<g-1;V++){r=(B*Math.pow(Math.E,-Math.pow(H-n,2)/ab));C.push([H,r]);s=T+(r*Y);a=(K+this.y)-(H*this.yAxisUnit)+(this.yAxisMin*this.yAxisUnit);S.push(s);O.push(a);H+=c}c=(u-n)/g;H=n;for(var V=0;V<g;V++){r=(B*Math.pow(Math.E,-Math.pow(H-n,2)/ab));C.push([H,r]);s=T+(r*Y);a=(K+this.y)-(H*this.yAxisUnit)+(this.yAxisMin*this.yAxisUnit);S.push(s);O.push(a);H+=c}m=aa.nor[W].color?aa.nor[W].color:this.colors[m];this.drawShape("path",S,O,false,false,m,m,"open")}else{z=aa.nor[W].max?aa.nor[W].max*this.yAxisUnit:this.y-(this.y*this.axisExtension);Y=z/B;H=A;for(var V=0;V<g-1;V++){r=(B*Math.pow(Math.E,-Math.pow(H-n,2)/ab));C.push([H,r]);s=T+(H*this.xAxisUnit)-(this.xAxisMin*this.xAxisUnit);a=(K+this.y)-(r*Y);S.push(s);O.push(a);H+=c}c=(u-n)/g;H=n;for(var V=0;V<g;V++){r=(B*Math.pow(Math.E,-Math.pow(H-n,2)/ab));C.push([H,r]);s=T+(H*this.xAxisUnit)-(this.xAxisMin*this.xAxisUnit);a=(K+this.y)-(r*Y);S.push(s);O.push(a);H+=c}m=aa.nor[W].color?aa.nor[W].color:this.colors[m];this.drawShape("path",S,O,false,false,m,m,"open")}}}}}if(aa.area){for(var W=0;W<aa.area.length;W++){if(aa.area[W].type&&aa.area[W].x&&aa.area[W].y&&aa.area[W].size){if(this.isValidShape(aa.area[W].type)){var s=T+(aa.area[W].x*this.xAxisUnit)-(this.xAxisMin*this.xAxisUnit);var a=(K+this.y)-(aa.area[W].y*this.yAxisUnit)+(this.yAxisMin*this.yAxisUnit);var m=aa.area[W].color?aa.area[W].color:this.colors[W%this.colors.length];this[aa.area[W].type](s,a,m,aa.area[W].size)}}}}}};this.setDecorationLegendDimension=function(){this.legendDecorationWidth=0;this.legendDecorationHeight=0;var f=this.data.d;if(this.showDecorations&&f){var k=this.getFontPt(this.decorationFont);var j=0;var g=0;var j=0;var b=0;if(f.nlfit){var a=this.measureText(sprintf("%75s","X"),this.decorationFont)+(this.margin*4);var h=0;for(var e=0;e<f.nlfit.length;e++){var c=this.measureText(f.nlfit[e].label,this.decorationFont);h=Math.max(c,h)}j=this.margin+h+this.margin+a+this.margin;this.legendDecorationHeight=(f.nlfit.length*k*2)+k+this.margin}if(f.line){var h=0;for(var e=0;e<f.line.length;e++){var c=this.measureText(f.line[e].label,this.decorationFont);h=Math.max(c,h)}b=this.margin+h+this.margin;this.legendDecorationHeight+=(f.line.length*k*2)+this.margin}if(f.reg){var a=this.measureText(sprintf("%45s","X"),this.decorationFont)+(this.margin*2);var h=0;for(var e=0;e<f.reg.length;e++){var c=this.measureText(f.reg[e].label,this.decorationFont);h=Math.max(c,h)}g=this.margin+h+this.margin+a+this.margin;this.legendDecorationHeight+=(f.reg.length*k*2)+k+this.margin}if(f.nor){var a=this.measureText(sprintf("%30s","X"),this.decorationFont)+(this.margin*1);var h=0;for(var e=0;e<f.nor.length;e++){var c=this.measureText(f.nor[e].label,this.decorationFont);h=Math.max(c,h)}j=this.margin+h+this.margin+a+this.margin;this.legendDecorationHeight+=(f.nor.length*k*2)+k+this.margin}if(f.area){var h=0;for(var e=0;e<f.area.length;e++){var c=this.measureText(f.area[e].label,this.decorationFont);h=Math.max(c,h)}b=this.margin+h+this.margin;this.legendDecorationHeight+=(f.area.length*k*2)+this.margin}this.legendDecorationWidth=Math.max(Math.max(Math.max(j,g),j),b)}};this.drawDecorationLegend=function(){var e=this.marginLeft+this.offsetX+this.left;var p=this.marginTop+this.offsetY+this.top;var k=this.data.d;if(this.showDecorations&&k){var q=this.getFontPt(this.decorationFont);var c=this.measureText(sprintf("%15s","X"),this.decorationFont);var a,o,m,n;if(this.decorationsPosition=="right"){o=p+(q/2)+((this.y-this.legendDecorationHeight)/2)}else{o=(p+this.y+this.bottom)-this.legendDecorationHeight}if(k.nlfit){n=(this.margin*5)+(5*c);if(this.decorationsPosition=="right"){m=(e+this.x+this.right+c)-n}else{m=e+((this.x-this.legendDecorationWidth)/2)+(this.legendDecorationWidth-n)+c}a=m;this.drawText("Min",a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;this.drawText("Max",a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;this.drawText("EC50",a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;this.drawText("Slope",a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;this.drawText("p-Val",a,o,this.decorationFont,this.decorationsColor,"right","middle");o+=q+q;for(var h=0;h<k.nlfit.length;h++){var f=h%this.colors.length;f=k.nlfit[h].color?k.nlfit[h].color:this.colors[f];a=(m+this.margin)-c;if(this.graphType=="ScatterBubble2D"&&this.decorationsPosition=="right"&&this.zAxisShow){a+=this.margin+this.getFontPt(this.axisTitleFont)+this.margin}this.drawText(k.nlfit[h].label,a,o,this.decorationFont,f,"right","middle");a=m;for(var g=0;g<5;g++){var b=k.nlfit[h].param[g];this.drawText(this.formatNumber(b),a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin}o+=q+q}}if(k.line){for(var h=0;h<k.line.length;h++){if(k.line[h].label){if(this.decorationsPosition=="right"){a=e+this.x+this.margin}else{a=e+((this.x-this.legendDecorationWidth)/2)+this.margin}for(var h=0;h<k.line.length;h++){var f=k.line[h].color?k.line[h].color:this.colors[h%this.colors.length];if(this.graphType=="ScatterBubble2D"&&this.decorationsPosition=="right"&&this.zAxisShow){a+=this.margin+this.getFontPt(this.axisTitleFont)+this.margin}this.drawText(k.line[h].label,a,o,this.decorationFont,f,"left","middle");o+=q+q}}}}if(k.reg){n=(this.margin*3)+(3*c);if(this.decorationsPosition=="right"){m=(e+this.x+this.right)-n}else{m=e+((this.x-this.legendDecorationWidth)/2)+(this.legendDecorationWidth-n)+c}a=m;this.drawText("Slope",a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;this.drawText("Int",a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;this.drawText("Cor",a,o,this.decorationFont,this.decorationsColor,"right","middle");o+=q+q;for(var h=0;h<k.reg.length;h++){var f=h%this.colors.length;f=k.reg[h].color?k.reg[h].color:this.colors[f];a=(m+this.margin)-c;if(this.graphType=="ScatterBubble2D"&&this.decorationsPosition=="right"&&this.zAxisShow){a+=this.margin+this.getFontPt(this.axisTitleFont)+this.margin}this.drawText(k.reg[h].label,a,o,this.decorationFont,f,"right","middle");a=m;this.drawText(this.formatNumber(k.reg[h].slope),a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;this.drawText(this.formatNumber(k.reg[h].intercept),a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;this.drawText(this.formatNumber(k.reg[h].cor),a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;o+=q+q}}if(k.nor){n=(this.margin*2)+(2*c);if(this.decorationsPosition=="right"){m=(e+this.x+this.right)-n}else{m=e+((this.x-this.legendDecorationWidth)/2)+(this.legendDecorationWidth-n)+c}a=m;this.drawText("Mu",a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;this.drawText("Sigma",a,o,this.decorationFont,this.decorationsColor,"right","middle");o+=q+q;for(var h=0;h<k.nor.length;h++){var f=h%this.colors.length;f=k.nor[h].color?k.nor[h].color:this.colors[f];a=(m+this.margin)-c;if(this.graphType=="ScatterBubble2D"&&this.decorationsPosition=="right"&&this.zAxisShow){a+=this.margin+this.getFontPt(this.axisTitleFont)+this.margin}this.drawText(k.nor[h].label,a,o,this.decorationFont,f,"right","middle");a=m;this.drawText(this.formatNumber(k.nor[h].mu),a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;this.drawText(this.formatNumber(k.nor[h].sigma),a,o,this.decorationFont,this.decorationsColor,"right","middle");a+=c+this.margin;o+=q+q}}if(k.area){for(var h=0;h<k.area.length;h++){if(k.area[h].label){if(this.decorationsPosition=="right"){a=e+this.x+this.margin}else{a=e+((this.x-this.legendDecorationWidth)/2)+this.margin}for(var h=0;h<k.area.length;h++){var f=k.area[h].color?k.area[h].color:this.colors[h%this.colors.length];if(this.graphType=="ScatterBubble2D"&&this.decorationsPosition=="right"&&this.zAxisShow){a+=this.margin+this.getFontPt(this.axisTitleFont)+this.margin}this.drawText(k.area[h].label,a,o,this.decorationFont,f,"left","middle");o+=q+q}}}}}};this.setLegendFont=function(){if(this.autoScaleFont){if(this.layoutComb){this.legendFont=(parseInt(Math.max(this.minTextSize,this.legendFontSize-Math.min(this.layoutRows,this.layoutCols))*this.legendScaleFontFactor))}else{this.legendFont=(parseInt(this.legendFontSize*this.legendScaleFontFactor))}this.legendFont=this.legendFont+"Pt "+this.fontName}else{this.legendFont=parseInt(this.legendFontSize)+"Pt "+this.fontName}};this.setSampleLegendDimension=function(){this.legendSampleWidth=0;this.legendSampleHeight=0;if(this.xAxisIndices.length!=this.yAxisIndices.length||this.xAxisIndices.length>1){var d=this.getFontPt(this.legendFont);var b=0;if(this.xAxisIndices.length==this.yAxisIndices.length&&this.xAxisIndices.length>1){for(var c=0;c<this.xAxisIndices.length;c++){var a=this.measureText(this.shortenText(this.xAxis[c],this.maxSmpStringLen)+" vs "+this.shortenText(this.yAxis[c],this.maxSmpStringLen),this.legendFont);b=Math.max(a,b)}}else{if(this.xAxisIndices.length>this.yAxisIndices.length){b=this.measureText(this.shortenText(this.getMaxText(this.xAxis),this.maxSmpStringLen)+" vs "+this.shortenText(this.yAxis[0],this.maxSmpStringLen),this.legendFont)}else{if(this.yAxisIndices.length>this.xAxisIndices.length){b=this.measureText(this.shortenText(this.getMaxText(this.yAxis),this.maxSmpStringLen)+" vs "+this.shortenText(this.xAxis[0],this.maxSmpStringLen),this.legendFont)}}}this.legendSampleWidth=(d-1)+b+(this.margin*3);this.legendSampleHeight=(Math.max(this.xAxisIndices.length,this.yAxisIndices.length)*(d+this.margin))+this.margin}};this.drawSampleLegend=function(b,j){var h=b;var d=j;var o=this.getFontPt(this.legendFont);var n=(o-1)/2;j+=this.margin+n;if(this.legendBox){this.disableGradientTransparency();this.rectangle(h,d,this.legendSampleWidth,this.legendSampleHeight,this.legendBackgroundColor,this.legendBoxColor);this.enableGradientTransparency()}var l=Math.max(this.xAxisIndices.length,this.yAxisIndices.length);for(var f=0;f<l;f++){var c=f%this.colors.length;var m=0;var g=this.xAxisIndices.length==this.yAxisIndices.length?this.yAxis[f]:this.xAxisIndices.length>this.yAxisIndices.length?this.yAxis[0]:this.xAxis[0];var k=this.shortenText(this.xAxisIndices.length<this.yAxisIndices.length?this.yAxis[f]:this.xAxis[f],this.maxSmpStringLen)+" vs "+this.shortenText(g,this.maxSmpStringLen);var e=b+n+this.margin;var a=j+n+this.margin;if(this.colorBy){this.drawShape(this.shapes[m],e,j,o-1,o-1,this.background,this.colors[c],"open")}else{this.drawShape(this.shapes[m],e,j,o-1,o-1,this.colors[c],this.foreground,"closed")}this.drawText(k,e+n+this.margin,j,this.legendFont,this.legendColor,"left","middle");j+=o+this.margin}if(this.legendBox){this.rectangle(h,d,this.legendSampleWidth,this.legendSampleHeight,false,this.legendBoxColor,"open")}this.addArea(["rect",h,d,h+this.legendSampleWidth,d+this.legendSampleHeight],[-1],"-legend-sample")};this.setVariableLegendDimension=function(){this.legendVariableWidth=0;this.legendVariableHeight=0;if((this.colorBy&&this.colorBy=="variable")||(this.shapeBy&&this.shapeBy=="variable")||(this.sizeBy&&this.sizeBy=="variable")){var a=this.sizeBy&&this.sizeBy=="variable"?Math.max(this.sizes[this.varIndices.length-1],this.getFontPt(this.legendFont)):this.getFontPt(this.legendFont);var b=this.shortenText(this.maxVarNameStr,this.maxVarStringLen);this.legendVariableWidth=(a-1)+this.measureText(b,this.legendFont)+(this.margin*3);this.legendVariableHeight=(this.varIndices.length*(a+this.margin))+this.margin}};this.drawVariableLegend=function(c,l){if((this.colorBy&&this.colorBy=="variable")||(this.shapeBy&&this.shapeBy=="variable")||(this.sizeBy&&this.sizeBy=="variable")){var j=c;var e=l;var p=this.getFontPt(this.legendFont);var k=this.sizeBy&&this.sizeBy=="variable"?Math.max(this.sizes[this.varIndices.length-1],p):p;l+=this.margin+(k/2);if(this.legendBox&&this.legendBackgroundColor){this.disableGradientTransparency();this.rectangle(j,e,this.legendVariableWidth,this.legendVariableHeight,this.legendBackgroundColor,this.legendBoxColor);this.enableGradientTransparency()}for(var g=0;g<this.varIndices.length;g++){var m=this.varIndices[g];var d=this.colorBy&&this.colorBy=="variable"?g%this.colors.length:0;var o=this.shapeBy&&this.shapeBy=="variable"?g%this.shapes.length:0;var b=this.sizeBy&&this.sizeBy=="variable"?this.sizes[g%this.sizes.length]:k;var n=k/2;var f=c+n+this.margin;var a=l+n+this.margin;var h=this.shortenText(this.data.y.vars[m],this.maxVarStringLen);if(this.colorBy&&this.colorBy!="variable"){this.drawShape(this.shapes[o],f,l,b,b,this.background,this.foreground,"open")}else{this.drawShape(this.shapes[o],f,l,b,b,this.colors[d],this.foreground,"closed")}this.drawText(h,f+n+this.margin,l,this.legendFont,this.legendColor,"left","middle");l+=k+this.margin}if(this.legendBox){this.rectangle(j,e,this.legendVariableWidth,this.legendVariableHeight,false,this.legendBoxColor,"open")}this.addArea(["rect",j,e,j+this.legendVariableWidth,e+this.legendVariableHeight],[-1],"-legend-variable")}};this.setColorLegendIndicatorDimensions=function(){var a=this.heatmapType.split("-");if(this.heatmapType.split("-").length>1){this.legendColorIndicatorWidth=parseInt(2*256*this.indicatorWidth/this.indicatorBins)+(this.margin*4)+1}else{this.legendColorIndicatorWidth=parseInt(1*256*this.indicatorWidth/this.indicatorBins)+(this.margin*4)+1}this.legendColorIndicatorHeight=this.indicatorHeight+(this.margin*3)+this.getFontPt(this.legendFont);if(this.colorBy){this.legendColorIndicatorHeight+=this.getFontPt(this.legendFont)+this.margin}};this.getHeatmapColor=function(d,c,e){var b=Math.abs(d);d+=b;c+=b;e+=b;var a=(e*this.heatmapColors.length/c).toFixed()-1;return this.heatmapColors[Math.max(0,Math.min(this.heatmapColors.length-1,a))]};this.drawColorIndicator=function(b,m,e,k,g){var j=b;var d=m;var a=this.indicatorHeight;var l=this.indicatorHeight;if(this.indicatorsPosition=="bottom"){for(var f=0;f<this.heatmapColors.length;f++){var h=this.transparency!=null?this.addColorTransparency(this.heatmapColors[f],this.transparency):this.heatmapColors[f];this.drawLine("line",b,m,b,m+l,h,this.indicatorWidth+0.5);b+=this.indicatorWidth}b=j-(this.indicatorWidth/2);m+=l+this.margin;this.drawText(sprintf("%."+g+"f",e),b,m,this.legendFont,this.legendColor,"center","top");b+=(this.heatmapColors.length*this.indicatorWidth/2)-(this.indicatorWidth/2);if(this.heatmapColors.length>=10){this.drawText(sprintf("%."+g+"f",(e+k)/2),b,m,this.legendFont,this.legendColor,"center","top")}if(this.colorBy){this.drawText(this.colorBy,b,m+this.margin+this.getFontPt(this.legendFont),this.legendFont,this.legendColor,"center","top")}b+=(this.heatmapColors.length*this.indicatorWidth/2)-(this.indicatorWidth/2);this.drawText(sprintf("%."+g+"f",k),b,m,this.legendFont,this.legendColor,"center","top");this.addArea(["rect",j-(this.margin*2),d-this.margin,b+(this.margin*2),m+this.getFontPt(this.legendFont)+this.margin],[-1],"-legend-indicator-color")}else{for(var f=0;f<this.heatmapColors.length;f++){var h=this.transparency!=null?this.addColorTransparency(this.heatmapColors[f],this.transparency):this.heatmapColors[f];this.drawLine("line",b,m,b+a,m,h,this.indicatorWidth+0.5);m-=this.indicatorWidth}b+=a+this.margin;m=d-(this.indicatorWidth/2);this.drawText(sprintf("%."+g+"f",e),b,m,this.legendFont,this.legendColor,"center","top",-Math.PI/2);m-=(this.heatmapColors.length*this.indicatorWidth/2)-(this.indicatorWidth/2);if(this.heatmapColors.length>=10){this.drawText(sprintf("%."+g+"f",(e+k)/2),b,m,this.legendFont,this.legendColor,"center","top",-Math.PI/2)}if(this.colorBy){this.drawText(this.colorBy,b+this.margin+this.getFontPt(this.legendFont),m,this.legendFont,this.legendColor,"center","top",-Math.PI/2)}m-=(this.heatmapColors.length*this.indicatorWidth/2)-(this.indicatorWidth/2);this.drawText(sprintf("%."+g+"f",k),b,m,this.legendFont,this.legendColor,"center","top",-Math.PI/2);this.addArea(["rect",j-this.margin,m-(this.margin*2),b+this.margin+this.getFontPt(this.legendFont),d+(this.margin*2)],[-1],"-legend-indicator-color")}};this.setShapeLegendIndicatorDimensions=function(){this.legendShapeIndicatorWidth=(10*(this.indicatorHeight+this.margin))+(this.margin*2);this.legendShapeIndicatorHeight=this.indicatorHeight+(this.margin*3)+this.getFontPt(this.legendFont);if(this.shapeBy){this.legendShapeIndicatorHeight+=this.getFontPt(this.legendFont)+this.margin}};this.drawShapeIndicator=function(b,m,e,l,g){var k=b;var c=m;var j=this.indicatorHeight/2;var d=b;var a=m;if(this.indicatorsPosition=="bottom"){for(var f=0;f<10;f++){this.drawShape("pie"+f,d,a+this.margin,this.indicatorHeight,this.indicatorHeight,this.background,this.foreground,"open");d+=this.indicatorHeight+j}b=k;m+=this.indicatorHeight+this.margin;this.drawText(sprintf("%."+g+"f",e),b,m,this.legendFont,this.legendColor,"center","top");b+=this.indicatorHeight*7;this.drawText(sprintf("%."+g+"f",(e+l)/2),b,m,this.legendFont,this.legendColor,"center","top");if(this.shapeBy){this.drawText(this.shapeBy,b,m+this.margin+this.getFontPt(this.legendFont),this.legendFont,this.legendColor,"center","top")}b+=this.indicatorHeight*7;this.drawText(sprintf("%."+g+"f",l),b,m,this.legendFont,this.legendColor,"center","top");this.addArea(["rect",k-(this.margin*2),c-this.margin,b+(this.margin*2),m+this.getFontPt(this.legendFont)+this.margin],[-1],"-legend-indicator-shape")}else{for(var f=0;f<10;f++){this.drawShape("pie"+f,d+this.margin,a,this.indicatorHeight,this.indicatorHeight,this.background,this.foreground,"open");a-=this.indicatorHeight+j}b+=this.indicatorHeight+this.margin;m=c;this.drawText(sprintf("%."+g+"f",e),b,m,this.legendFont,this.legendColor,"center","top",-Math.PI/2);m-=this.indicatorHeight*7;if(this.heatmapColors.length>=10){this.drawText(sprintf("%."+g+"f",(e+l)/2),b,m,this.legendFont,this.legendColor,"center","top",-Math.PI/2)}if(this.shapeBy){this.drawText(this.shapeBy,b+this.margin+this.getFontPt(this.legendFont),m,this.legendFont,this.legendColor,"center","top",-Math.PI/2)}m-=this.indicatorHeight*7;this.drawText(sprintf("%."+g+"f",l),b,m,this.legendFont,this.legendColor,"center","top",-Math.PI/2);this.addArea(["rect",k-this.margin,m-(this.margin*2),b+this.margin+this.getFontPt(this.legendFont),c+(this.margin*2)],[-1],"-legend-indicator-shape")}};this.setSizeLegendIndicatorDimensions=function(){var a=0;var c=this.indicatorHeight/2;for(var b=0;b<10;b++){a+=this.sizes[b]+c}this.legendSizeIndicatorWidth=(a-(this.sizes[0]+this.sizes[9]))+(this.margin*4);this.legendSizeIndicatorHeight=this.sizes[9]+(this.margin*3)+this.getFontPt(this.legendFont);if(this.sizeBy){this.legendSizeIndicatorHeight+=this.getFontPt(this.legendFont)+this.margin}};this.drawSizeIndicator=function(d,p,g,o,k){var n=d;var e=p;var l=this.indicatorHeight/2;var q=this.sizes[9];var f=d;var a=p;var m=d;var c=p;if(this.indicatorsPosition=="bottom"){for(var j=0;j<10;j++){var b=this.sizes[j];this.drawShape("sphere",f,a+(q/2),b,b,this.background,this.foreground,"open");f+=b+l;if(j<4){m+=b+l}else{if(j==5){m+=(b+l)/2}}}p+=q+this.margin;this.drawText(sprintf("%."+k+"f",g),n,p,this.legendFont,this.legendColor,"center","top");this.drawText(sprintf("%."+k+"f",(g+o)/2),m,p,this.legendFont,this.legendColor,"center","top");if(this.sizeBy){this.drawText(this.sizeBy,n+(this.legendColorIndicatorWidth/2),p+this.margin+this.getFontPt(this.legendFont),this.legendFont,this.legendColor,"center","top")}this.drawText(sprintf("%."+k+"f",o),f-(q+l),p,this.legendFont,this.legendColor,"center","top");this.addArea(["rect",n-(this.margin*2),e-this.margin,(f-q)+(this.margin*2),p+this.getFontPt(this.legendFont)+this.margin],[-1],"-legend-indicator-size")}else{for(var j=0;j<10;j++){var b=this.sizes[j];this.drawShape("sphere",f+(q/2),a,b,b,this.background,this.foreground,"open");a-=(b+l);if(j<4){c-=(b+l)}else{if(j==5){c-=((b+l)/2)}}}d+=q+this.margin;this.drawText(sprintf("%."+k+"f",g),d,p,this.legendFont,this.legendColor,"center","top",-Math.PI/2);this.drawText(sprintf("%."+k+"f",(g+o)/2),d,c,this.legendFont,this.legendColor,"center","top",-Math.PI/2);if(this.sizeBy){this.drawText(this.sizeBy,d+this.margin+this.getFontPt(this.legendFont),e-(this.legendColorIndicatorWidth/2),this.legendFont,this.legendColor,"center","top",-Math.PI/2)}this.drawText(sprintf("%."+k+"f",o),d,a+(q+l),this.legendFont,this.legendColor,"center","top",-Math.PI/2);this.addArea(["rect",n-this.margin,(a+(q+l))-(this.margin*2),d+this.margin+this.getFontPt(this.legendFont),e+(this.margin*2)],[-1],"-legend-indicator-size")}};this.setDataColorShapeSizeIndicatorDimensions=function(){this.setColorLegendIndicatorDimensions();this.setShapeLegendIndicatorDimensions();this.setSizeLegendIndicatorDimensions()};this.getDiameterLegend=function(){return this.x>=600?10:this.x>=400?8:this.x>=200?6:4};this.setColorLegendDimensions=function(a){this.legendColorWidth=0;this.legendColorHeight=0;if(this.colorBy){var f,e;var i=this.getDiameterLegend();if(a&&this.data.x.hasOwnProperty(this.colorBy)){f=this.setMaxSmpStringAnnt(this.colorBy);e=this.setMaxSmpStringLabel(this.colorBy)}else{if(this.data.z.hasOwnProperty(this.colorBy)){f=this.setMaxVarStringAnnt(this.colorBy);e=this.setMaxVarStringLabel(this.colorBy)}}var b=this.measureText(f,this.legendFont);var c=this.measureText(e,this.legendFont)+i+this.margin;this.legendColorWidth=Math.max(b,c)+(this.margin*2);var h=this.getFontPt(this.legendFont);var g=Math.max(i,h);this.legendColorHeight=(this.legendColorsN*(g+this.margin))+h+(this.margin*3)}};this.drawColorLegend=function(c,e){if(this.colorBy&&((this.data.x&&this.data.x.hasOwnProperty(this.colorBy))||(this.data.z&&this.data.z.hasOwnProperty(this.colorBy)))){var h=this.getDiameterLegend();var f=this.getFontPt(this.legendFont);var i=f/2;var g=e+this.margin+i;var a=Math.max(h,f);this.disableGradientTransparency();if(this.legendBackgroundColor){this.rectangle(c,e,this.legendColorWidth,this.legendColorHeight,this.legendBackgroundColor)}else{this.rectangle(c,e,this.legendColorWidth,this.legendColorHeight,false,this.foreground,"open")}this.enableGradientTransparency();this.drawText(this.colorBy,c+(this.legendColorWidth/2),g,this.legendFont,this.colorLegend,"center","middle");g+=i+this.margin;this.drawLine("line",c,g,c+this.legendColorWidth,g,this.foreground);g+=this.margin+(a/2);for(var b in this.legendColors){this.drawShape("circle",c+this.margin+(h/2),g,h,h,this.legendColors[b],this.foreground,"closed");this.drawText(b,c+(this.margin*2)+h,g,this.legendFont,this.colorLegend,"left","middle");g+=this.margin+a}this.addArea(["rect",c,e,c+this.legendColorWidth,e+this.legendColorHeight],[-1],"-legend-color")}};this.setShapeLegendDimensions=function(){this.legendShapeWidth=0;this.legendShapeHeight=0;if(this.shapeBy&&this.data.z.hasOwnProperty(this.shapeBy)){var h=this.getDiameterLegend();var e=this.setMaxVarStringAnnt(this.shapeBy);var c=this.setMaxVarStringLabel(this.shapeBy);var a=this.measureText(e,this.legendFont);var b=this.measureText(c,this.legendFont)+h+this.margin;this.legendShapeWidth=Math.max(a,b)+(this.margin*2);var g=this.getFontPt(this.legendFont);var f=Math.max(h,g);this.legendShapeHeight=(this.legendShapesN*(f+this.margin))+g+(this.margin*3)}};this.drawShapeLegend=function(b,c){if(this.shapeBy&&this.data.z.hasOwnProperty(this.shapeBy)){var h=this.getDiameterLegend();var e=this.getFontPt(this.legendFont);var i=e/2;var g=c+this.margin+i;var a=Math.max(h,e);this.disableGradientTransparency();if(this.legendBackgroundColor){this.rectangle(b,c,this.legendShapeWidth,this.legendShapeHeight,this.legendBackgroundColor)}else{this.rectangle(b,c,this.legendShapeWidth,this.legendShapeHeight,false,this.foreground,"open")}this.enableGradientTransparency();this.drawText(this.shapeBy,b+(this.legendShapeWidth/2),g,this.legendFont,this.colorLegend,"center","middle");g+=i+this.margin;this.drawLine("line",b,g,b+this.legendShapeWidth,g,this.foreground);g+=this.margin+(a/2);for(var f in this.legendShapes){this.drawShape(this.legendShapes[f],b+this.margin+(h/2),g,h,h,this.background,this.foreground,"closed");this.drawText(f,b+(this.margin*2)+h,g,this.legendFont,this.colorLegend,"left","middle");g+=this.margin+a}this.addArea(["rect",b,c,b+this.legendShapeWidth,c+this.legendShapeHeight],[-1],"-legend-shape")}};this.setSizeLegendDimensions=function(){this.legendSizeWidth=0;this.legendSizeHeight=0;if(this.sizeBy&&this.data.z.hasOwnProperty(this.sizeBy)){var h=this.sizes[this.legendSizesN-1];var e=this.setMaxVarStringAnnt(this.sizeBy);var c=this.setMaxVarStringLabel(this.sizeBy);var a=this.measureText(e,this.legendFont);var b=this.measureText(c,this.legendFont)+h+this.margin;this.legendSizeWidth=Math.max(a,b)+(this.margin*2);var g=this.getFontPt(this.legendFont);var f=Math.max(h,g);this.legendSizeHeight=(this.legendSizesN*(f+this.margin))+g+(this.margin*3)}};this.drawSizeLegend=function(c,e){if(this.sizeBy&&this.data.z.hasOwnProperty(this.sizeBy)){var h=this.sizes[this.legendSizesN-1];var f=this.getFontPt(this.legendFont);var i=f/2;var g=e+this.margin+i;var a=Math.max(h,f);this.disableGradientTransparency();if(this.legendBackgroundColor){this.rectangle(c,e,this.legendSizeWidth,this.legendSizeHeight,this.legendBackgroundColor)}else{this.rectangle(c,e,this.legendSizeWidth,this.legendSizeHeight,false,this.foreground,"open")}this.enableGradientTransparency();this.drawText(this.sizeBy,c+(this.legendSizeWidth/2),g,this.legendFont,this.colorLegend,"center","middle");g+=i+this.margin;this.drawLine("line",c,g,c+this.legendSizeWidth,g,this.foreground);g+=this.margin+(a/2);for(var b in this.legendSizes){this.drawShape("circle",c+this.margin+(h/2),g,this.legendSizes[b],this.legendSizes[b],this.background,this.foreground,"closed");this.drawText(b,c+(this.margin*2)+h,g,this.legendFont,this.colorLegend,"left","middle");g+=this.margin+a}this.addArea(["rect",c,e,c+this.legendSizeWidth,e+this.legendSizeHeight],[-1],"-legend-size")}};this.setDataColorShapeSizeDimensions=function(){this.setColorLegendDimensions();this.setShapeLegendDimensions();this.setSizeLegendDimensions()};this.setDataColor=function(d){if(this.colorBy){var a=0;var b={};this.dataColors=[];this.legendColors={};this.legendColorsN=0;if(d){if(!this.isGroupedData&&this.data.x&&this.data.x.hasOwnProperty(this.colorBy)){if(this.isNumeric(this.data.x[this.colorBy],true)){var c=this.range(this.data.x[this.colorBy],true);for(var f=0;f<this.smpIndices.length;f++){var g=this.smpIndices[f];var h=this.data.x[this.colorBy][g];var e=!isNaN(h)?this.getHeatmapColor(c[0],c[1],h):this.missingDataColor;this.dataColors.push(e)}this.legendColorsN=-1;this.legendColorRange=c;this.legendColorDecs=this.getAxisDecimals(this.getAxisIncrements(c[0],c[1],this.heatmapColors.length));this.setColorLegendIndicatorDimensions()}else{for(var f=0;f<this.smpIndices.length;f++){var g=this.smpIndices[f];var e=this.data.x[this.colorBy][g];if(!b.hasOwnProperty(e)){b[e]=a%this.colors.length;this.legendColors[e]=this.colors[b[e]];a++}this.dataColors.push(this.colors[b[e]])}this.legendColorsN=a;this.setColorLegendDimensions(d)}}}else{if(this.data.z&&this.data.z.hasOwnProperty(this.colorBy)){if(this.isNumeric(this.data.z[this.colorBy],false,true)){var c=this.range(this.data.z[this.colorBy],false,true);for(var f=0;f<this.varIndices.length;f++){var g=this.varIndices[f];var h=this.data.z[this.colorBy][g];if(!isNaN(h)){this.dataColors.push(this.getHeatmapColor(c[0],c[1],h))}else{this.dataColors.push(this.missingDataColor)}}this.legendColorRange=c;this.legendColorDecs=this.getAxisDecimals(this.getAxisIncrements(c[0],c[1],this.heatmapColors.length));this.setColorLegendIndicatorDimensions()}else{for(var f=0;f<this.varIndices.length;f++){var g=this.varIndices[f];var e=this.data.z[this.colorBy][g];if(!b.hasOwnProperty(e)){b[e]=a%this.colors.length;this.legendColors[e]=this.colors[b[e]];a++}this.dataColors.push(this.colors[b[e]])}this.legendColorsN=a;this.setColorLegendDimensions()}}else{if(this.getSampleIndices(this.colorBy)>-1){a=this.getSampleIndices(this.colorBy);var c=this.getAxisRangeBySample(a);if(!this.scatterType||this.scatterType!="function"){for(var f=0;f<this.varIndices.length;f++){var g=this.varIndices[f];var h=this.getDataAtPos(g,a);if(!isNaN(h)){this.dataColors.push(this.getHeatmapColor(c[0],c[1],h))}else{this.dataColors.push(this.missingDataColor)}}}this.legendColorRange=c;this.legendColorDecs=this.getAxisDecimals(this.getAxisIncrements(c[0],c[1],this.heatmapColors.length));this.setColorLegendIndicatorDimensions()}else{if(this.colorBy=="variable"){for(var f=0;f<this.varIndices.length;f++){var e=f%this.colors.length;this.dataColors.push(this.colors[e])}this.setVariableLegendDimension()}else{for(var f=0;f<this.varIndices.length;f++){this.dataColors.push(this.colors[0])}}}}}}};this.setDataShape=function(){if(this.shapeBy){var f=0;var a={};var j="square";this.dataShapes=[];this.legendShapes={};this.legendShapesN=0;if(this.data.z&&this.data.z.hasOwnProperty(this.shapeBy)){if(this.isNumeric(this.data.z[this.shapeBy],false,true)){var e=this.range(this.data.z[this.shapeBy],false,true);for(var d=0;d<this.varIndices.length;d++){var g=this.varIndices[d];var b=this.data.z[this.shapeBy][g];if(!isNaN(b)){var c=this.percentile(e[0],e[1],b);var h=parseInt(c/10);if(h>0){h--}this.dataShapes.push("pie"+h)}else{this.dataShapes.push(j)}}this.legendShapeRange=e;this.legendShapeDecs=this.getAxisDecimals(this.getAxisIncrements(e[0],e[1],10));this.setShapeLegendIndicatorDimensions()}else{for(var d=0;d<this.varIndices.length;d++){var g=this.varIndices[d];var h=this.data.z[this.shapeBy][g];if(!a.hasOwnProperty(h)){a[h]=f%this.shapes.length;this.legendShapes[h]=this.shapes[a[h]];f++}this.dataShapes.push(this.shapes[a[h]])}this.legendShapesN=f;this.setShapeLegendDimensions()}}else{if(this.getSampleIndices(this.shapeBy)>-1){f=this.getSampleIndices(this.shapeBy);var e=this.getAxisRangeBySample(f);for(var d=0;d<this.varIndices.length;d++){var g=this.varIndices[d];var b=this.getDataAtPos(g,f);if(!isNaN(b)){var c=this.percentile(e[0],e[1],b);var h=parseInt(c/10);if(h>0){h--}this.dataShapes.push("pie"+h)}else{this.dataShapes.push(j)}}this.legendShapeRange=e;this.legendShapeDecs=this.getAxisDecimals(this.getAxisIncrements(e[0],e[1],10));this.setShapeLegendIndicatorDimensions()}else{if(this.shapeBy=="variable"){for(var d=0;d<this.varIndices.length;d++){var h=d%this.shapes.length;this.dataShapes.push(this.shapes[h])}this.setVariableLegendDimension()}else{for(var d=0;d<this.varIndices.length;d++){this.dataShapes.push(this.shapes[0])}}}}}};this.setDataSize=function(){if(this.sizeBy){var a=0;var c={};this.dataSizes=[];this.legendSizes={};this.legendSizesN=0;if(this.data.z&&this.data.z.hasOwnProperty(this.sizeBy)){if(this.isNumeric(this.data.z[this.sizeBy],false,true)){var d=this.range(this.data.z[this.sizeBy],false,true);for(var e=0;e<this.varIndices.length;e++){var f=this.varIndices[e];var g=this.data.z[this.sizeBy][f];if(!isNaN(g)){var h=this.percentile(d[0],d[1],g);var b=parseInt(h/10);if(b>0){b--}this.dataSizes.push(this.sizes[b])}else{this.dataSizes.push(0)}}this.legendSizeRange=d;this.legendSizeDecs=this.getAxisDecimals(this.getAxisIncrements(d[0],d[1],10));this.setSizeLegendIndicatorDimensions()}else{for(var e=0;e<this.varIndices.length;e++){var f=this.varIndices[e];var b=this.data.z[this.sizeBy][f];if(!c.hasOwnProperty(b)){c[b]=a%this.sizes.length;this.legendSizes[b]=this.sizes[c[b]];a++}this.dataSizes.push(this.sizes[c[b]])}this.legendSizesN=a;this.setSizeLegendDimensions()}}else{if(this.getSampleIndices(this.sizeBy)>-1){a=this.getSampleIndices(this.sizeBy);var d=this.getAxisRangeBySample(a);for(var e=0;e<this.varIndices.length;e++){var f=this.varIndices[e];var g=this.getDataAtPos(f,a);if(!isNaN(g)){var h=this.percentile(d[0],d[1],g);var b=parseInt(h/10);if(b>0){b--}this.dataSizes.push(this.sizes[b])}else{this.dataSizes.push(0)}}this.legendSizeRange=d;this.legendSizeDecs=this.getAxisDecimals(this.getAxisIncrements(d[0],d[1],10));this.setSizeLegendIndicatorDimensions()}else{if(this.sizeBy=="variable"){for(var e=0;e<this.varIndices.length;e++){var b=e%this.sizes.length;this.dataSizes.push(this.sizes[b])}this.setVariableLegendDimension()}else{for(var e=0;e<this.varIndices.length;e++){this.dataSizes.push(this.scatterPointSize)}}}}}};this.setDataColorShapeSize=function(){this.resetLegends();this.setLegendFont();this.setDataColor();this.setDataShape();this.setDataSize();if(!this.allVsAll&&(this.graphType=="Scatter2D"||this.graphType=="ScatterBubble2d")){this.setSampleLegendDimension()}};this.resetLegends=function(){var a=["Color","Shape","Size"];for(var c=0;c<a.length;c++){this["legend"+a[c]+"IndicatorWidth"]=0;this["legend"+a[c]+"IndicatorHeight"]=0;this["data"+a[c]+"s"]=[];this["legend"+a[c]+"s"]={};this["legend"+a[c]+"sN"]=0}var b=this.allVsAll?["Color","Shape","Size","Variable"]:["Color","Shape","Size","Variable","Sample"];for(var c=0;c<b.length;c++){this["legend"+b[c]+"Width"]=0;this["legend"+b[c]+"Height"]=0}};this.setLegendDimensions=function(){this.legendLayout=[];var a=this.margin;var l=this.margin;if(this.showIndicators){var f=["Color","Shape","Size"];for(var c=0;c<f.length;c++){var j=this["legend"+f[c]+"IndicatorWidth"];var d=this["legend"+f[c]+"IndicatorHeight"];if(j){if(this.indicatorsPosition=="bottom"){l+=this.margin+d}else{a+=this.margin+d}}}}var b=0;var k=0;var g=0;if(this.showLegend){var e=this.allVsAll?["Color","Shape","Size","Variable"]:["Color","Shape","Size","Variable","Sample"];for(var c=0;c<e.length;c++){var j=this["legend"+e[c]+"Width"];var d=this["legend"+e[c]+"Height"];if(j>0){if(this.legendPosition=="right"){if(k+this.margin+d>this.height){a+=this.margin+j;b=j;k=d;g++;this.legendLayout[g]=[e[c]]}else{if(j>b){a+=(j-b);b=j}k+=d;if(!this.legendLayout[g]){this.legendLayout[g]=[]}this.legendLayout[g].push(e[c])}}else{if(b+this.margin+j>this.width){l+=this.margin+d;b=j;k=d;g++;this.legendLayout[c]=[e[c]]}else{if(d>k){l+=(d-k);k=d}b+=j;if(!this.legendLayout[g]){this.legendLayout[g]=[]}this.legendLayout[g].push(e[c])}}}}}this.legendWidth=a+this.margin;this.legendHeight=l+this.margin};this.getXYLegendCoords=function(o,a,q){var n,e,m,g;var k=0;var c=0;var p=-1;var f=-1;if(this.legendLayout){for(var d=0;d<this.legendLayout.length;d++){n=0;e=0;for(var b=0;b<this.legendLayout[d].length;b++){if(this.legendLayout[d][b]==o){f=b}n+=this["legend"+this.legendLayout[d][b]+"Width"]+this.margin;e+=this["legend"+this.legendLayout[d][b]+"Height"]+this.margin;k=Math.max(k,n);c=Math.max(c,e)}if(f>-1){p=d;break}}if(this.legendPosition=="right"){q=f==0&&this.allVsAll?this.marginTop+this.layoutTop:f==0?this.marginTop+this.offsetY+this.top:q;m=a;g=f==0&&this.allVsAll?(this.height-c)/2:f==0?this.marginTop+this.offsetY+this.top+((this.y-c)/2):q;a=f==this.legendLayout[p].length-1?a+k:a;q=g+this["legend"+this.legendLayout[p][f]+"Height"]+this.margin}else{a=f==0&&this.allVsAll?this.marginLeft+this.layoutLeft:f==0?this.marginLeft+this.offsetX+this.left:a;m=f==0&&this.allVsAll?(this.width-k)/2:f==0?this.marginLeft+this.offsetX+this.left+((this.x-k)/2)+this.margin:a+this.margin;g=q;a=m+this["legend"+this.legendLayout[p][f]+"Width"]+this.margin;q=f==this.legendLayout[p].length-1?q+c:q}}return[m,g,a,q]};this.drawScatterLegend=function(){var c=this.allVsAll?this.width-(this.marginRight+this.layoutRight):this.marginLeft+this.offsetX+this.left+this.x;var k=this.allVsAll?this.height-(this.marginBottom+this.layoutBottom):this.marginTop+this.offsetY+this.top+this.y;if(this.showIndicators){var o,g;var a,n;if(!this.allVsAll&&(this.graphType=="Scatter2D"||this.graphType=="ScatterBubble2D")){c+=(this.margin*2);k+=this.get2DXAxisHeight()+this.margin;if(this.graphType=="ScatterBubble2D"&&this.zAxisShow){c+=this.getFontPt(this.axisTitleFont)+(this.margin*2)}}else{c+=(this.margin*1);k+=(this.margin*1)}var l=["Color","Shape","Size"];for(var e=0;e<l.length;e++){o=this["legend"+l[e]+"IndicatorWidth"];g=this["legend"+l[e]+"IndicatorHeight"];if(o){var b="draw"+l[e]+"Indicator";var f=this["legend"+l[e]+"Range"];var d=this["legend"+l[e]+"Decs"];if(this.indicatorsPosition=="bottom"){a=this.allVsAll?(this.width-o)/2:this.marginLeft+this.offsetX+this.left+((this.x-o)/2);n=k;this[b](a,n,f[0],f[1],d);k+=g+this.margin}else{a=c;n=this.allVsAll?(this.height-g)/2:this.marginTop+this.offsetY+this.top+(this.y-((this.y-o)/2));this[b](a,n,f[0],f[1],d);c+=g+this.margin}}}}if(this.showLegend){var j=this.allVsAll?["Color","Shape","Size","Variable"]:["Color","Shape","Size","Variable","Sample"];for(var e=0;e<j.length;e++){o=this["legend"+j[e]+"Width"];g=this["legend"+j[e]+"Height"];if(o>0){var b="draw"+j[e]+"Legend";var m=this.getXYLegendCoords(j[e],c,k);this[b](m[0],m[1]);if(this.legendPosition=="right"){k=m[3]+this.margin}else{c=m[2]+this.margin}}}}}};CanvasXpress.prototype.initApi=function(){this.getValidGraphTypes=function(){return this.validGraphTypes};this.setHeatmapScheme=function(){this.initializeAttributes()};this.hasIndicator=function(){if(this.graphType.match(/Scatter/)||this.graphType=="Bar"){return true}else{return false}};this.hasLegend=function(){if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Correlation"&&this.graphType!="Heatmap"){return true}else{return false}};this.hasLegendProperties=function(){if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Correlation"&&this.graphType!="Heatmap"&&this.graphType!="Pie"){return true}else{return false}};this.hasData=function(){if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Venn"){return true}else{return false}};this.hasDataSamples=function(){if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Venn"&&this.graphType!="Pie"&&!this.graphType.match(/Scatter/)){if(this.graphType=="Correlation"&&this.correlationAxis!="samples"){return false}return true}else{return false}};this.hasDataGroups=function(){if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Venn"&&this.graphType!="Pie"&&!this.graphType.match(/Scatter/)){if(this.graphType=="Correlation"&&this.correlationAxis!="samples"){return false}if(this.data.x){return true}else{return false}}else{return false}};this.hasDataVariables=function(){if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Venn"){if(this.graphType=="Correlation"&&this.correlationAxis!="variables"){return false}return true}else{return false}};this.hasDataProperties=function(){if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Heatmap"&&this.graphType!="Venn"&&this.graphType!="Pie"&&this.graphType!="Correlation"){return true}else{return false}};this.hasOrientation=function(){if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Venn"&&this.graphType!="Pie"&&this.graphType!="Correlation"&&!this.graphType.match(/Scatter/)){return true}else{return false}};this.hasOverlays=function(){if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Venn"&&this.graphType!="Pie"&&this.graphType!="Correlation"&&!this.graphType.match(/Scatter/)){return true}else{return false}};this.hasDendrograms=function(){if(this.graphType!="Heatmap"&&(this.data.t.smps||this.data.t.vars)){return true}else{return false}};this.hasDecorations=function(){return this.data.d&&(this.data.d.nlfit||this.data.d.line||this.data.d.reg||this.data.d.nor||this.data.d.area)?true:false};this.isSegregable=function(){if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Venn"&&this.graphType!="Pie"&&this.graphType!="Correlation"&&!this.graphType.match(/Scatter/)){return true}else{return false}};this.getLineTypes=function(){var e=["line"];var c=["","dashed","dotted","bezierY","bezierX","curved"];var a=["arrow","arrowHead","arrowTail","arrowHeadSquareTail","arrowTailSquareHead","square","squareHead","squareTail","squareHeadArrowTail","squareTailArrowHead"];for(var d=0;d<a.length;d++){e.push(a[d]+"Line")}for(var d=1;d<c.length;d++){for(var b=0;b<a.length;b++){e.push(c[d]+this.capitalize(a[b])+"Line")}}return e};this.isValidShape=function(b){for(var a=0;a<this.shapes.length;a++){if(this.shapes[a]==b){return true}}return false};this.modifyHighlights=function(c,b,d){var a=d?"highlightVar":"highlightSmp";this.modifyObjectArray(c,b,a)};this.getHighlights=function(b){var a=b?this.highlightVar:this.highlightSmp;return this.getObjectArray(a)};this.modifySmpOverlays=function(b,a){this.modifyObjectArray(b,a,"smpOverlays")};this.modifyVarOverlays=function(b,a){this.modifyObjectArray(b,a,"varOverlays")};this.getSmpOverlays=function(){return this.getObjectArray(this.smpOverlays)};this.getVarOverlays=function(){return this.getObjectArray(this.varOverlays)};this.getXData=function(){var b=[];if(this.data.x){for(var a in this.data.x){b.push(a)}}return b};this.getZData=function(){var b=[];if(this.data.z){for(var a in this.data.z){b.push(a)}}return b};this.getSamplesAsArray=function(){var d=this.getSamples();var b=[];for(var c=0;c<d.length;c++){b.push(d[c].name)}return b};this.getVariablesAsArray=function(){var d=this.getVariables();var b=[];for(var c=0;c<d.length;c++){b.push(d[c].name)}return b};this.clusterSamples=function(){this.clusterAxis="samples";this.showSmpDendrogram=true;if(!this.data.t){this.data.t={}}this.data.t.smps=this.cluster();this.draw()};this.clusterVariables=function(){this.clusterAxis="variables";this.showVarDendrogram=true;if(!this.data.t){this.data.t={}}this.data.t.vars=this.cluster();this.draw()};this.kmeansSamples=function(){this.clusterAxis="samples";this.showOverlays=true;if(!this.data.x){this.data.x={}}this.data.x["k-Means"]=this.kmeans();if(!this.isInArray("k-Means",this.smpOverlays)){this.smpOverlays.push("k-Means")}this.draw()};this.kmeansVariables=function(){this.clusterAxis="variables";this.showOverlays=true;if(!this.data.z){this.data.z={}}this.data.z["k-Means"]=this.kmeans();if(!this.isInArray("k-Means",this.varOverlays)){this.varOverlays.push("k-Means")}this.draw()};this.reset=function(){this.masterReset()};this.setFunctions=function(){this.functions.push("clusterSamples");this.functions.push("clusterVariables");this.functions.push("transpose");this.functions.push("transform");this.functions.push("sortSamplesByCategory");this.functions.push("sortSamplesByVariable");this.functions.push("sortVariablesByCategory");this.functions.push("sortVariablesByCategory");this.functions.push("hideUnhideSmps");this.functions.push("hideUnhideVars");this.functions.push("desegregateSamples");this.functions.push("segregateSamples");this.functions.push("groupSamples");this.functions.push("ungroupSamples");this.functions.push("desegregateVariables");this.functions.push("segregateVariables");this.functions.push("kmeansSamples");this.functions.push("kmeansVariables");this.functions.push("showCodeDiv");this.functions.push("hideCodeDiv");this.functions.push("showInfoDiv");this.functions.push("hideInfoDiv");this.functions.push("updateCodeDiv");this.functions.push("createHistogram");this.functions.push("removeHistogram");this.functions.push("addRegressionLine");this.functions.push("addNormalDistributionLine");this.functions.push("recalculateLayout");this.functions.push("setSkin");this.functions.push("createRandomData");this.functions.push("draw");this.functions.push("reset");this.functions.push("print")};this.initializeApi=function(){this.setFunctions()};this.initializeApi()};CanvasXpress.prototype.initText=function(){this.drawTextMultiple=function(v,u,p,n,o,r,q,d,e,w){var h=v.split(/\n/);if(!n){n=this.font}var k=this.getFontPt(n)+4;if(h.length%2){p-=(parseInt(h.length/2)*k)+(k/2)}else{p=(p-parseInt(h.length/2)*k)}for(var j=0;j<h.length;j++){this.drawText(h[j],u,p,n,o,r,q,d,e,w);p+=k}};this.drawText=function(l,j,i,u,z,B,A,g,o,n){var p=function(c){c.shift();var f=[];var m=(Math.PI/2)+g==0?-Math.PI/2:g-Math.PI/2;var b=["poly"];var t=c.shift()-j;var h=c.shift()-i;var a=c.shift()-j;var s=c.shift()-i;f.push((h*Math.sin(m))-(t*Math.cos(m)));f.push((h*Math.cos(m))+(t*Math.sin(m)));f.push((s*Math.sin(m))-(t*Math.cos(m)));f.push((s*Math.cos(m))+(t*Math.sin(m)));f.push((s*Math.sin(m))-(a*Math.cos(m)));f.push((s*Math.cos(m))+(a*Math.sin(m)));f.push((h*Math.sin(m))-(a*Math.cos(m)));f.push((h*Math.cos(m))+(a*Math.sin(m)));while(f.length>1){b.push(f.shift()+j);b.push(f.shift()+i)}return b};var C=[];if(!l){return}if(this.isMultipleLines(l)){return this.drawTextMultiple(l,j,i,u,z,B,A,g,o,n)}if(!this.ctx){if(this.debug){alert("Dude, there is no canvas")}return}if(isNaN(j)||isNaN(i)){if(this.debug){alert("Not a valid coordinate ("+j+", "+i+") to draw "+l)}return}if(g<(Math.PI/-2)||g>(Math.PI/2)){if(this.debug){alert("Dude, you can only rotate between -PI/2 and PI/2")}return}if(!isNaN(l)){l=this.formatNumber(l)}if(!j){j=0}if(!i){i=0}if(!u){u=this.font}if(!z){z=this.foreground}if(!B){B=this.align}if(!A){A=this.baseline}var k=this.measureText(l,u);var q=this.getFontPt(u);if(o){while(k>o){l=l.substring(0,l.length-1);k=this.measureText(l,u)}}var v,e,r,d;if(B=="left"){v=j;r=v+k}else{if(B=="right"){v=j-k;r=j}else{v=j-(k/2);r=j+(k/2)}}if(A=="top"){e=i;d=e+q}else{if(A=="bottom"){e=i-q;d=i}else{e=i-(q/2);d=i+(q/2)}}C=["rect",v,e,r,d];if(g){C=p(C)}this.ctx.save();this.ctx.strokeStyle=z;this.ctx.fillStyle=z;this.ctx.font=u;this.ctx.save();this.ctx.translate(j,i);this.ctx.textAlign=B;this.ctx.textBaseline=A;if(this.showShadow){this.ctx.shadowOffsetX=this.shadowOffsetX;this.ctx.shadowOffsetY=this.shadowOffsetY;this.ctx.shadowBlur=this.shadowBlur;this.ctx.shadowColor=this.shadowColor}if(g){this.ctx.rotate(g)}if(n){this.ctx.strokeText(l,0,0)}else{this.ctx.fillText(l,0,0)}this.ctx.restore();if(this.showShadow){this.ctx.shadowOffsetX=0;this.ctx.shadowOffsetY=0;this.ctx.shadowBlur=0;this.ctx.shadowColor=this.background}return C};this.isMultipleLines=function(b){var a=b.toString().split(/\n/);return a.length-1};this.capitalize=function(a){if(a){return a.charAt(0).toUpperCase()+a.slice(1)}};this.measureTextMultiple=function(d,e){var b=d.split(/\n/);var a=0;if(!this.ctx){return 0}if(!e){e=this.font}this.ctx.font=e;for(var c=0;c<b.length;c++){a=Math.max(a,this.ctx.measureText(b[c]).width)}return a};this.measureText=function(a,b){a=a.toString();if(!this.ctx){return 0}if(!b){b=this.font}this.ctx.font=b;if(this.isMultipleLines(a)){return this.measureTextMultiple(a,b)}else{return this.ctx.measureText(a).width}};this.scaleTextToFont=function(b,d,a){var c=d+"pt "+this.fontName;if(b){while(this.measureText(b,c)>a&&d>=this.minTextSize){d-=2;c=d+"pt "+this.fontName}}return c};this.getFontPt=function(a){return parseInt(a.match(/^\d+/)[0])};this.scaleTextToSize=function(a){var d=this.scaleTextConstantMult;if(!a){a=1}return Math.ceil(1/Math.sqrt(a)*d)};this.formatNumber=function(c){if(c.toString().length>=7){var b=sprintf("%.2e",Number(c));var a=sprintf("%.2f",Number(c));if(a.toString().length>b.toString().length){return b.toString()}else{return a.toString()}}else{return c.toString()}};this.getMaxText=function(d){var f="";var b=0;for(var e=0;e<d.length;e++){var g=this.measureText(d[e].toString(),this.font);if(g>b){f=d[e].toString();b=g}}return f};this.shortenText=function(b,a){b=b.toString();if(b.length<=a){return b}else{return b.substring(0,a-3)+" ..."}};this.convertToNumber=function(a){if(!isNaN(a)){return parseFloat(a)}else{return a}}};CanvasXpress.prototype.initTime=function(){Date.prototype.getWeek=function(){var a=new Date(this.getFullYear(),0,1);return Math.ceil((((this-a)/86400000)+a.getDay()+1)/7)};this.getYearWeek=function(a){return a.getFullYear()+"-"+a.getWeek()};this.getYearMonth=function(a){return a.getFullYear()+"-"+a.getMonth()};this.getYear=function(a){return a.getFullYear()};this.times={second:1000,minute:60000,hour:3600000,day:86400000,week:604800000,month:2592000000,year:31556952000};this.parseDate=function(c){var e=parseInt(c.toString().substring(0,4));var a=parseInt(c.toString().substring(4,6).replace(/^0/,""));var b=parseInt(c.toString().substring(6,8).replace(/^0/,""));return new Date(e,a-1,b,0,0)};this.setTimeAxis=function(){var h=this.validateTimeAxis();if(h){var g=Date.parse(h[h.length-1])-Date.parse(h[0]);var d;var b={};var c=[];this.timeValues=[];this.timeValueIndices=[];if(g>this.times.year*2){d="getYear"}else{if(g>this.times.month*2){d="getYearMonth"}else{if(g>this.times.week*2){d="getYearWeek"}else{d=false}}}if(d){if(this.timeTicksFirst){for(var a=0;a<h.length;a++){var e=this[d](h[a]);if(!b.hasOwnProperty(e)){c.push(h[a]);this.timeValueIndices.push(a);b[e]=true}}}else{for(var a=h.length-1;a>=0;a--){var e=this[d](h[a]);if(!b.hasOwnProperty(e)){c.unshift(h[a]);this.timeValueIndices.unshift(a);b[e]=true}}}}else{for(var a=0;a<h.length;a++){this.timeValues.push(dateFormat(h[a],this.timeFormat));this.timeValueIndices.push(a)}}var g=Date.parse(c[c.length-1])-Date.parse(c[c.length-2]);if(d=="getYear"&&g<this.times.month*3){this.timeValues.pop();this.timeValueIndices.pop()}else{if(d=="getYearMonth"&&g<this.times.week*4){this.timeValues.pop();this.timeValueIndices.pop()}else{if(d=="getYearWeek"&&g<this.times.day*7){this.timeValues.pop();this.timeValueIndices.pop()}}}for(var a=0;a<c.length;a++){this.timeValues.push(dateFormat(c[a],this.timeFormat))}}};this.createRandomTimes=function(b){var e;var g=new Date();var a=g.getTime();var f=[new Date(a)];var h=this.isGroupedData?this.data.w:this.data.y;if(!b||!this.times[b]){b="day"}for(var c=0;c<h.smps.length;c++){e=Date.parse(h.smps[c]);if(!isNaN(e)){a=e}else{a-=this.times[b]}f.unshift(new Date(a))}return f};this.validateTimeAxis=function(){var f=this.isGroupedData?this.data.w:this.data.y;var a=false;var e=[];for(var b=0;b<this.smpIndices.length;b++){var c=this.smpIndices.length!=f.smps.length?Date.parse(f.smps[this.smpIndices[b]]):Date.parse(f.smps[b]);if(isNaN(c)){if(this.isExample){e=this.createRandomTimes();return e}else{a=true;break}}else{e.push(new Date(c))}}return a?false:e}};CanvasXpress.prototype.initAttributes=function(){this.validateNumbers=function(b){for(var c=0;c<b.length;c++){if(isNaN(b[c])){return false}}return true};this.lineTo=function(b,d,a,c){if(b==a){b=Math.round(b)+0.5;a=b}else{if(d==c){d=Math.round(d)+0.5;c=d}}this.ctx.moveTo(b,d);this.ctx.lineTo(a,c);this.ctx.stroke()};this.clip=function(q,f,i){var d,c,n,k,g,m,q;var o,e,a,j;var p=[];if(i&&i.length==4){e=i[0];o=i[1];a=e+i[2];j=o+i[3]}else{e=this.marginLeft+this.offsetX+this.left;o=this.marginTop+this.offsetY+this.top;a=e+this.x;j=o+this.y}if(q=="rect"){d=parseInt(f[0]);n=parseInt(f[1]);c=parseInt(d+f[2]);k=parseInt(n+f[3]);if(d>a+this.outlineWidth||k>j+this.outlineWidth||c<e||n<o){return false}if(d<e){d=e}if(c>a){c=a}if(k<o){k=o}if(n>j){n=j}p=[d,n,c-d,k-n]}else{if(q=="poly"){}else{if(q=="circle"){d=parseInt(f[0]);n=parseInt(f[1]);if(d>a||d<e||n<o||n>j){return false}p=[d,n]}else{if(q=="line"){d=parseFloat(f[0]);n=parseFloat(f[1]);c=parseFloat(f[2]);k=parseFloat(f[3]);if(d==c){if(d<e||d>a){return false}else{if(n>k){if(n<o){return false}else{if(n>j){n=j}}if(k>j){return false}else{if(k<o){k=o}}}else{if(n>j){return false}else{if(n<o){n=o}}if(k<o){return false}else{if(k>j){k=j}}}}}else{if(n==k){if(n<o||n>j){return false}else{if(d>c){if(d<e){return false}else{if(d>a){d=a}}if(c>a){return false}else{if(c<e){c=e}}}else{if(d>a){return false}else{if(d<e){d=e}}if(c<e){return false}else{if(c>a){c=a}}}}}else{if(d>c){if(d<e||c>a){return false}else{if(n>k){if(n<o||k>j){return false}else{g=n-k;m=d-c;if(d>a){n-=(d-a)*g/m;d=a}if(n>j){d-=(n-j)*m/g;n=j}if(c<e){k+=(e-c)*g/m;c=e}if(k<o){c+=(o-k)*m/g;k=o}}}else{if(k<o||n>j){return false}else{g=k-n;m=d-c;if(d>a){n+=(d-a)*g/m;d=a}if(n<o){d-=(o-n)*m/g;n=o}if(c<e){k-=(e-c)*g/m;c=e}if(k>j){c+=(k-j)*m/g;k=j}}}}}else{if(c<e||d>a){return false}else{if(n>k){if(n<o||k>j){return false}else{g=n-k;m=c-d;if(d<e){n-=(e-d)*g/m;d=e}if(n>j){d+=(n-j)*m/g;n=j}if(c>a){k+=(c-a)*g/m;c=a}if(k<o){c-=(o-k)*m/g;k=o}}}else{if(k<o||n>j){return false}else{g=k-n;m=c-d;if(d<e){n+=(e-d)*g/m;d=e}if(n<o){d+=(o-n)*m/g;n=o}if(c>a){k-=(c-a)*g/m;c=a}if(k>j){c-=(k-j)*m/g;k=j}}}}}}}p=[d,n,c,k]}else{return false}}}}return p};this.lineLength=function(b,d,a,c){return Math.sqrt(Math.pow(a-b,2)+Math.pow(c-d,2))};this.shortenLine=function(b,j,a,i,k,f,l){if(this.validateNumbers([b,j,a,i,k,f])){if(l.match(/bezier/)){if(l.match(/beziery/i)){return i>j?[b,j+k,a,i-f]:[b,j-k,a,i+f]}else{return a>b?[b+k,j,a-f,i]:[b-k,j,a+f,i]}}else{if(l.match(/curved/)){return[b,j,a,i]}else{var c=Math.atan2(i-j,a-b);var d=Math.cos(c);var h=Math.sin(c);var g=this.lineLength(b,j,a,i);if(g){while(g<(k+f)){k/=1.1;f/=1.1}b+=d*k;j+=h*k;a-=d*f;i-=h*f}}}return[b,j,a,i]}};this.errorBar=function(e,g,d,f,a,h){if(!this.isGroupedData&&this.isRawData){return}if(this.showErrorBars&&this.validateNumbers([a])){var b=this.drawLine("line",e,g,d,f,h,false,false,false,false,true);if(a>0){this.drawLine("line",d,f-a/2,d,f+a/2,h,false,false,false,false,true)}else{this.drawLine("line",d-a/2,f,d+a/2,f,h,false,false,false,false,true)}return b}};this.splineControlPoint=function(e,m,d,l,c,k){var n=Math.sqrt(Math.pow(d-e,2)+Math.pow(l-m,2));var h=Math.sqrt(Math.pow(c-d,2)+Math.pow(k-l,2));var g=this.tension*n/(n+h);var f=this.tension-g;var b=d+g*(e-c);var a=l+g*(m-k);var j=d-f*(e-c);var i=l-f*(m-k);return[b,a,j,i]};this.drawLine=function(Y,E,a,B,aq,ak,X,ac,aa,am,an,ap){var R=this;var af;var L=[];var T=false;var u=false;var r=false;var S=function(){R.ctx.save();if(R.transparency!=null){if(ak){ak=R.validateColor(ak,R.transparency)||R.addColorTransparency(R.foreground,R.transparency)}else{ak=R.addColorTransparency(R.foreground,R.transparency)}}else{if(ak){ak=R.validateColor(ak)||R.foreground}else{ak=R.foreground}}R.ctx.fillStyle=ak;R.ctx.strokeStyle=ak;R.ctx.lineWidth=X?X:R.outlineWidth;R.ctx.lineCap=ac?ac:R.capType;if(R.showShadow){R.ctx.shadowOffsetX=R.shadowOffsetX;R.ctx.shadowOffsetY=R.shadowOffsetY;R.ctx.shadowBlur=R.shadowBlur;R.ctx.shadowColor=R.shadowColor}};var G=function(){if(R.showShadow){R.ctx.shadowOffsetX=0;R.ctx.shadowOffsetY=0;R.ctx.shadowBlur=0;R.ctx.shadowColor=R.background}R.ctx.restore()};var F=function(y){var w=function(aA,aD,ay,aE){var az=[];for(var aB=0;aB<aA.length;aB++){az.push([(aA[aB][0]*Math.cos(aD))-(aA[aB][1]*Math.sin(aD)),(aA[aB][0]*Math.sin(aD))+(aA[aB][1]*Math.cos(aD))])}var aC=[];for(var aB=0;aB<az.length;aB++){aC.push([az[aB][0]+ay,az[aB][1]+aE])}return aC};var t=R.arrowPointSize;var s=Math.max((t/2)-1,1);var n=y?[[0,-t],[0,t]]:[[Math.floor((t/2.5)),0],[-t,-s],[-t,s]];var ax=B-E;var av=aq-a;if(u){if(u=="Y"){if(Math.abs(av)>Math.abs(ax)){ax=0}else{ax=B>E?R.arrowPointSize:-R.arrowPointSize}}else{if(Math.abs(ax)>Math.abs(av)){av=0}else{av=aq>a?R.arrowPointSize:-R.arrowPointSize}}}else{if(r){var at=R.lineLength(E,a,B,aq);var f=R.shortenLine(E,a,B,aq,0,at/2,"line");var p=f[2];var b=f[3];var aw=at/2;var ar=r/aw;var au=B>E?Math.asin((b-a)/aw):Math.asin(-(b-a)/aw);var c=au-(Math.PI/20);if(B>E){E=p+aw*Math.cos(c-ar);a=b+aw*Math.sin(c-ar);B=p+aw*Math.cos(au-ar);aq=b+aw*Math.sin(au-ar)}else{E=p+aw*Math.cos((c-ar)+Math.PI);a=b+aw*Math.sin((c-ar)+Math.PI);B=p+aw*Math.cos((au-ar)+Math.PI);aq=b+aw*Math.sin((au-ar)+Math.PI)}ax=B-E;av=aq-a}}var e=w(n,Math.atan2(av,ax),B,aq);S();R.ctx.beginPath();R.ctx.moveTo(e[0][0],e[0][1]);for(var x=1;x<e.length;x++){if(!isNaN(e[x][0])&&!isNaN(e[x][1])){R.ctx.lineTo(e[x][0],e[x][1])}}if(!y){if(!isNaN(e[0][0])&&!isNaN(e[0][1])){R.ctx.lineTo(e[0][0],e[0][1])}R.ctx.closePath();R.ctx.fill()}else{R.ctx.closePath();R.ctx.stroke()}G()};if(Y=="spline"){if(E.length<3){return false}var Z=[];var ao=[];var ab=[];var ae=0;L=["poly"];for(var ai=0;ai<E.length;ai++){if(this.validateNumbers([E[ai],a[ai]])){ao.push(E[ai],a[ai]);L.push(E[ai],a[ai]-2);ab.push(a[ai]+2,E[ai]);ae+=2}else{return false}}L=L.concat(ab.reverse());S();for(var ai=0;ai<ae-4;ai+=2){Z=Z.concat(this.splineControlPoint(ao[ai],ao[ai+1],ao[ai+2],ao[ai+3],ao[ai+4],ao[ai+5]))}this.ctx.beginPath();this.ctx.moveTo(ao[0],ao[1]);this.ctx.quadraticCurveTo(Z[0],Z[1],ao[2],ao[3]);for(var ai=2;ai<ae-5;ai+=2){this.ctx.bezierCurveTo(Z[2*ai-2],Z[2*ai-1],Z[2*ai],Z[2*ai+1],ao[ai+2],ao[ai+3])}this.ctx.moveTo(ao[ae-2],ao[ae-1]);this.ctx.quadraticCurveTo(Z[2*ae-10],Z[2*ae-9],ao[ae-4],ao[ae-3]);this.ctx.stroke();G();return L}else{if(this.validateNumbers([E,a,B,aq])){if(!aa){aa=0}if(!am){am=0}if(Y.match(/bezier/i)){if(Y.match(/beziery/i)){af="bezierLine";u="Y";T="Y";if(aa||am){if(aq>a){if(a+aa>aq-am){Y=Y.replace(/beziery/i,"");af="line";u=false;T=false}}else{if(a-aa<aq+am){Y=Y.replace(/beziery/i,"");af="line";u=false;T=false}}}}else{af="bezierLine";u="X";T="X";if(aa||am){if(B>E){if(E+aa>B-am){Y=Y.replace(/bezier[x]?/i,"");af="line";u=false;T=false}}else{if(E-aa<B+am){Y=Y.replace(/bezier[x]?/i,"");af="line";u=false;T=false}}}}}else{if(Y.match(/curved/i)){if(Y.match(/curvedc/i)){af="curvedLine";r=true;T=true}else{af="curvedLine";r=true;T=false}}else{if(Y.match(/dashed/i)){af="dashedLine"}else{if(Y.match(/dotted/i)){af="dottedLine"}else{af="line"}}}}if(aa||am){var ad=this.shortenLine(E,a,B,aq,aa,am,Y);E=ad[0];a=ad[1];B=ad[2];aq=ad[3]}if(an){var J=this.clip("line",[E,a,B,aq],ap);if(J){E=J[0];a=J[1];B=J[2];aq=J[3]}else{return false}}switch(af){case"dashedLine":var k=Math.atan2(aq-a,B-E);var P=Math.cos(k);var H=Math.sin(k);var K=this.lineLength(E,a,B,aq);var ah=Math.floor(K/(this.dashLength*2));if(ah){var V=P*this.dashLength;var U=H*this.dashLength;var g=E;var al=a;var d=B;var aj=aq;d=g+V;aj=al+U;for(var ai=0;ai<ah;ai++){this.drawLine("line",g,al,d,aj,ak,X,ac);g+=(V*2);al+=(U*2);d=g+V;aj=al+U}this.drawLine("line",g,al,d,aj,ak,X,ac);L=["poly",E+2,a,B+2,aq,B-2,aq,E-2,a]}else{return false}break;case"dottedLine":var k=Math.atan2(aq-a,B-E);var P=Math.cos(k);var H=Math.sin(k);var K=this.lineLength(E,a,B,aq);var ah=Math.ceil(K/(this.dotLength*2));var Q=K/ah;if(ah){var V=P*Q;var U=H*Q;var g=E;var al=a;var d=B;var aj=aq;g+=V;al+=U;for(var ai=0;ai<ah-1;ai++){this.drawShape("circle",g,al,2,2,ak,ak,"closed");g+=V;al+=U}L=["poly",E+2,a,B+2,aq,B-2,aq,E-2,a]}else{return false}break;case"bezierLine":if(E==B||a==aq){return this.drawLine("line",E,a,B,aq,ak,X,ac,aa,am,an,ap)}E=parseInt(E)+0.5;a=parseInt(a)+0.5;B=parseInt(B)+0.5;aq=parseInt(aq)+0.5;T=T=="Y"?"Y":"X";var N=B>E?true:false;var m=(E+B)/2;var l=(a+aq)/2;if(N){if(T=="X"){L=["poly",E,a-2,m+2,a-2,m+2,aq-2,B,aq-2,B,aq+2,m-2,aq+2,m-2,a+2,E,a+2]}else{L=["poly",E-2,a,E-2,l+2,B-2,l+2,B-2,aq,B+2,aq,B+2,l-2,E+2,l-2,E+2,a]}}else{if(T=="X"){L=["poly",E,a-2,m-2,a-2,m-2,aq-2,B,aq-2,B,aq+2,m+2,aq+2,m+2,a+2,E,a+2]}else{L=["poly",E-2,a,E-2,l-2,B-2,l-2,B-2,aq,B+2,aq,B+2,l+2,E+2,l+2,E+2,a]}}S();this.ctx.moveTo(E,a);if(T=="Y"){this.ctx.bezierCurveTo(E,aq,B,a,B,aq)}else{this.ctx.bezierCurveTo(B,a,E,aq,B,aq)}this.ctx.stroke();G();break;case"curvedLine":var m=12;var q=1;var K=this.lineLength(E,a,B,aq);var D=this.shortenLine(E,a,B,aq,0,K/2,"line");var O=D[2];var C=D[3];var W=K/2;var M=aa/W;var I=am/W;var j=(O-E);var h=(C-a);var A=T&&E>B?false:!T&&B>=E?true:T;var o=B>=E?Math.asin(h/W):Math.asin(-h/W);var ag=o+Math.PI;var z=Math.PI/m;var v=B>=E?0:Math.PI;L=["poly"];for(var ai=q;ai<=m-q;ai++){L.push(O-(W+2)*Math.cos(o+((z*ai))-v));L.push(C-(W+2)*Math.sin(o+((z*ai))-v))}for(var ai=m-q;ai>=q;ai--){L.push(O-(W-2)*Math.cos(o+((z*ai))-v));L.push(C-(W-2)*Math.sin(o+((z*ai))-v))}S();this.ctx.beginPath();if(B>=E){this.ctx.arc(O,C,W,o-I,ag+M,A)}else{this.ctx.arc(O,C,W,o+M,ag-I,A)}this.ctx.stroke();G();break;case"line":L=["poly",E+2,a,B+2,aq,B-2,aq,E-2,a];S();this.ctx.beginPath();this.lineTo(E,a,B,aq);G();break}if(Y.match(/arrowheadsquaretail|squaretailarrowhead/i)){r=r?am:false;F(false,u,r);r=r?aa:false;F(true,u,r)}else{if(Y.match(/arrowtailsquarehead|squareheadarrowtail/i)){r=r?am:false;F(true,u,r);r=r?aa:false;F(false,u,r)}else{if(Y.match(/arrowhead/i)){r=r?am:false;F(false,u,r)}else{if(Y.match(/squarehead/i)){r=r?am:false;F(true,u,r)}else{if(Y.match(/arrowtail/i)){r=r?aa:false;F(false,u,r)}else{if(Y.match(/squaretail/i)){r=r?aa:false;F(true,u,r)}else{if(Y.match(/arrow/i)){r=r?am:false;F(false,u,r);r=r?aa:false;F(false,u,r)}else{if(Y.match(/square/i)){r=r?aa:false;F(true,u,r);r=r?am:false;F(true,u,r)}}}}}}}}return L}else{return false}}};this.rectangle=function(n,m,q,g,i,e,d,a,k,j,l){return this.drawShape("rectangle",n+(q/2),m+(g/2),q,g,i,e,d,a,k,j,l)};this.rectangleHM=function(n,m,q,g,i,e,d,a,k,j,l){return this.drawShape("rectangleHM",n+(q/2),m+(g/2),q,g,i,e,d,a,k,j,l)};this.drawShape=function(L,H,G,J,Y,Z,S,R,N,F,af,ah,M,ac,K,ae){var E=this;var P=function(){E.ctx.save();E.ctx.translate(H,G);if(N){E.ctx.rotate(N)}if(E.transparency!=null){if(Z){Z=E.validateColor(Z,E.transparency)||E.addColorTransparency(E.foreground,E.transparency)}else{Z=E.addColorTransparency(E.foreground,E.transparency)}}else{if(Z){Z=E.validateColor(Z)||E.foreground}else{Z=E.foreground}}if(E.gradient){if(E.gradientType=="radial"){E.setGradient(0,0,Math.max(Math.abs(J),Math.abs(Y)),Z)}else{E.setGradient(0,0,J,Y,Z)}}else{E.ctx.fillStyle=Z}if(S){S=E.validateColor(S)||E.foreground}E.ctx.strokeStyle=S?S:E.foreground;E.ctx.lineWidth=F?F:E.outlineWidth;if(E.showShadow){E.ctx.shadowOffsetX=E.shadowOffsetX;E.ctx.shadowOffsetY=E.shadowOffsetY;E.ctx.shadowBlur=E.shadowBlur;E.ctx.shadowColor=E.shadowColor}};var ak=function(f,d,o){if(L=="image"){}else{if(L=="rectangleHM"){if(f){f[0][0]=Math.round(f[0][0])+0.5;f[3][0]=f[0][0];f[1][0]=Math.round(f[1][0])+1.5;f[2][0]=f[1][0];f[0][1]=Math.round(f[0][1])+0.5;f[1][1]=f[0][1];f[2][1]=Math.round(f[2][1])+1.5;f[3][1]=f[2][1];E.ctx.beginPath();E.ctx.moveTo(f[0][0],f[0][1]);for(var e=1;e<f.length;e++){E.ctx.lineTo(f[e][0],f[e][1])}if(!d){E.ctx.closePath()}if(R&&R=="open"){E.ctx.stroke()}else{E.ctx.stroke();E.ctx.fill()}}}else{if(L=="spline"){var h=[];var c=[];var b=[];c.push(o.shift());c.push(o.shift());b.push(o.pop());b.unshift(o.pop());var p=o.length;for(var e=0;e<p-4;e+=2){h=h.concat(E.splineControlPoint(o[e],o[e+1],o[e+2],o[e+3],o[e+4],o[e+5]))}E.ctx.beginPath();E.ctx.moveTo(c[0],c[1]);E.ctx.lineTo(o[0],o[1]);E.ctx.quadraticCurveTo(h[0],h[1],o[2],o[3]);for(var e=2;e<p-5;e+=2){E.ctx.bezierCurveTo(h[2*e-2],h[2*e-1],h[2*e],h[2*e+1],o[e+2],o[e+3])}E.ctx.quadraticCurveTo(h[2*p-10],h[2*p-9],o[p-2],o[p-1]);E.ctx.lineTo(b[0],b[1]);E.ctx.lineTo(c[0],c[1]);if(R&&R=="open"){E.ctx.stroke()}else{E.ctx.stroke();E.ctx.fill()}}else{if(f){E.ctx.beginPath();E.ctx.moveTo(f[0][0]+0.5,f[0][1]+0.5);for(var e=1;e<f.length;e++){E.ctx.lineTo(f[e][0]+0.5,f[e][1]+0.5)}if(!d){E.ctx.closePath()}}if(R&&R=="open"){E.ctx.stroke()}else{E.ctx.stroke();E.ctx.fill()}}}}if(E.showShadow){E.ctx.shadowOffsetX=0;E.ctx.shadowOffsetY=0;E.ctx.shadowBlur=0;E.ctx.shadowColor=E.background}E.ctx.restore()};var aa=function(p){if(p){if(p[0]=="circle"){return p}var e=p.shift();var i=[];if(e=="rect"){var o=p.shift()-H;var r=p.shift()-G;var d=p.shift()-H;var f=p.shift()-G;i.push((r*Math.sin(N))-(o*Math.cos(N)));i.push((r*Math.cos(N))+(o*Math.sin(N)));i.push((f*Math.sin(N))-(o*Math.cos(N)));i.push((f*Math.cos(N))+(o*Math.sin(N)));i.push((f*Math.sin(N))-(d*Math.cos(N)));i.push((f*Math.cos(N))+(d*Math.sin(N)));i.push((r*Math.sin(N))-(d*Math.cos(N)));i.push((r*Math.cos(N))+(d*Math.sin(N)))}else{while(p.length>1){var h=p.shift()-H;var b=p.shift()-G;i.push((b*Math.sin(N))-(h*Math.cos(N)));i.push((b*Math.cos(N))+(h*Math.sin(N)))}}var c=["poly"];while(i.length>1){c.push(i.shift()+H);c.push(i.shift()+G)}return c}};var C,D;if(L=="polygon"||L=="path"||L=="spline"){var V=Number.MAX_VALUE;var A=Number.MAX_VALUE*-1;var U=Number.MAX_VALUE;var v=Number.MAX_VALUE*-1;var B=L=="polygon"?false:true;var Q=[];var ag=[];C=[];D=["poly"];if(H.length==G.length){if(L=="spline"&&H.length<5){return false}for(var X=0;X<H.length;X++){if(this.validateNumbers([H[X],G[X]])){V=Math.min(V,H[X]);A=Math.max(A,H[X]);U=Math.min(U,G[X]);v=Math.max(v,G[X]);C.push([H[X],G[X]]);if(L=="spline"){D.push(H[X],G[X]-2);Q.push(G[X]+2,H[X])}else{D.push(H[X],G[X])}}else{return false}}H=(V+A)/2;G=(U+v)/2;for(var X=0;X<C.length;X++){C[X][0]-=H;C[X][1]-=G;ag.push(C[X][0],C[X][1])}if(N){D=aa(D)}if(C){if(L=="spline"){D=D.concat(Q.reverse())}P(B);ak(C,B,ag);return D}else{return false}}else{return false}}else{if(this.validateNumbers([H,G,J,Y])){if(af){C=L.match(/rectangle/)?this.clip("rect",[H-(J/2),G-(Y/2),J,Y],ah):this.clip("circle",[H,G],ah);if(C){if(L.match(/rectangle/)){J=C[2];Y=C[3];H=C[0]+(J/2);G=C[1]+(Y/2)}else{H=C[0];G=C[1]}}else{return false}}var j=J/2;var ai=Y/2;var O=Y/J;var T=1.5;var D=["rect",H-j,G-ai,H+j,G+ai];switch(L){case"image":C=false;this.ctx.save();this.ctx.translate(H,G);if(N){this.ctx.rotate(N)}this.drawImage(CanvasXpress.cacheImages[K],-j*this.zoom,-ai*this.zoom,J*this.zoom,Y*this.zoom);D=["rect",H-(j*this.zoom),G-(ai*this.zoom),H+(j*this.zoom),G+(ai*this.zoom)];this.ctx.restore();break;case"circle":case"sphere":D=["circle",H,G,J/2];C=false;P();this.ctx.beginPath();this.ctx.arc(0,0,J/2,0,Math.PI*2,true);this.ctx.closePath();ak();break;case"box":case"rect":case"rectangle":case"rectangleHM":C=[[-j,-ai],[j,-ai],[j,ai],[-j,ai]];break;case"rect2":return this.drawShape("rectangle",H,G,J,J/2,Z,S,R,N,F,af,ah,M,ac,K,ae);break;case"rect3":return this.drawShape("rectangle",H,G,J,J/3,Z,S,R,N,F,af,ah,M,ac,K,ae);break;case"roundrect":var I=J>Y?Y/4:J/4;C=false;P();this.ctx.beginPath();ctx.moveTo(-j,-ai+I);ctx.lineTo(-j,ai-I);ctx.quadraticCurveTo(-j,ai,-j+I,ai);ctx.lineTo(j-I,ai);ctx.quadraticCurveTo(j,ai,j,ai-I);ctx.lineTo(j,-ai+I);ctx.quadraticCurveTo(j,-ai,j-I,-ai);ctx.lineTo(-j+I,-ai);ctx.quadraticCurveTo(-j,-ai,-j,-ai+I);this.ctx.closePath();ak();break;case"square":C=[[-j,-j],[j,-j],[j,j],[-j,j]];break;case"triangle":if(J==Y){return this.drawShape("equilateral",H,G,J,Y,Z,S,R,N,F,af,ah,M,ac,K,ae)}D=["poly",H,G-ai,H+j,G+ai,H-j,G+ai];C=[[0,-ai],[j,ai],[-j,ai]];break;case"equilateral":var I=J*Math.sqrt(3)/6;var g=I/2;var n=Math.sqrt((I*I)-(g*g));D=["poly",H,G-I,H+n,G+g,H-n,G+g];C=[[0,-ai],[j,ai],[-j,ai]];break;case"diamond":case"rhombus":D=["poly",H,G-ai,H+j,G,H,G+ai,H-j,G];C=[[0,-ai],[j,0],[0,ai],[-j,0]];break;case"hexagon":var ad=J/3;var l=ad-j;C=[[l,-ai],[-l,-ai],[j,0],[-l,ai],[l,ai],[-j,0]];break;case"octagon":var aj=J/4;var W=Y/4;C=[[-aj,-ai],[aj,-ai],[j,-W],[j,W],[aj,ai],[-aj,ai],[-j,W],[-j,-W]];break;case"oval":C=false;P();this.ctx.scale(1,O);this.ctx.beginPath();this.ctx.arc(0,0,J/2,0,Math.PI*2,true);this.ctx.closePath();ak();break;case"oval2":return this.drawShape("oval",H,G,J,J/2,Z,S,R,N,F,af,ah,M,ac,K,ae);break;case"oval3":return this.drawShape("oval",H,G,J,J/3,Z,S,R,N,F,af,ah,M,ac,K,ae);break;case"arc":C=false;P();this.ctx.scale(1,O);this.ctx.beginPath();this.ctx.arc(0,0,J/2,0,Math.PI,true);if(R!="open"){this.ctx.closePath()}ak();break;case"ellipse":var a=j*0.5522848;var ab=ai*0.5522848;C=false;P();this.ctx.beginPath();this.ctx.moveTo(0,ai);this.ctx.bezierCurveTo(0,ai-ab,j-a,0,j,0);this.ctx.bezierCurveTo(j+a,0,J,ai-ab,J,ai);this.ctx.bezierCurveTo(J,ai+ab,j+a,Y,j,Y);this.ctx.bezierCurveTo(j-a,Y,0,ai+ab,0,ai);this.ctx.closePath();ak();break;case"ellipse2":return this.drawShape("ellipse",H,G,J,J/2,Z,S,R,N,F,af,ah,M,ac,K,ae);break;case"ellipse3":return this.drawShape("ellipse",H,G,J,J/3,Z,S,R,N,F,af,ah,M,ac,K,ae);break;case"plus":C=[[-T,-ai],[T,-ai],[T,-T],[j,-T],[j,T],[T,T],[T,ai],[-T,ai],[-T,T],[-j,T],[-j,-T],[-T,-T],[-T,-ai]];break;case"minus":C=[[-j,-T],[j,-T],[j,T],[-j,T],[-j,-T]];break;case"mdavid":var ad=J/3;var m=Math.PI/6;D=["circle",H,G,J/2];C=false;P();this.ctx.beginPath();this.ctx.moveTo(ad,0);for(var X=0;X<11;X++){this.ctx.rotate(m);if(X%2==0){this.ctx.lineTo((ad/0.55),0)}else{this.ctx.lineTo(ad,0)}this.ctx.closePath()}ak();break;case"star":var k=J/4;var q=Math.PI/5;D=["circle",H,G,J/2];C=false;P();this.ctx.rotate(q*0.45);this.ctx.beginPath();this.ctx.moveTo(k,0);for(var X=0;X<9;X++){this.ctx.rotate(q);if(X%2==0){this.ctx.lineTo((k/0.35),0)}else{this.ctx.lineTo(k,0)}}this.ctx.closePath();ak();break;case"pie":if(typeof(M)=="undefined"){M=0}if(typeof(ac)=="undefined"){ac=Math.PI*2}C=false;P();this.ctx.scale(1,O);this.ctx.beginPath();this.ctx.arc(0,0,J/2,M,ac,false);this.ctx.closePath();ak();break;case"pie0":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,0,Math.PI/5,K,ae);break;case"pie1":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,0,Math.PI/3.5,K,ae);break;case"pie2":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,0,Math.PI/2,K,ae);break;case"pie3":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,0,Math.PI/1.5,K,ae);break;case"pie4":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,0,Math.PI,K,ae);break;case"pie5":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,0,Math.PI*1.2,K,ae);break;case"pie6":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,0,Math.PI*1.4,K,ae);break;case"pie7":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,0,Math.PI*1.6,K,ae);break;case"pie8":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,0,Math.PI*1.8,K,ae);break;case"pie9":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,0,Math.PI*2,K,ae);break;case"pacman":return this.drawShape("pie",H,G,J,J/2,Z,S,R,N,F,af,ah,Math.PI*5/4,Math.PI*3/4,K,ae);break}if(N){D=aa(D)}if(C){P();ak(C)}return D}else{return false}}};this.drawImage=function(d,b,c,a,f){try{this.ctx.drawImage(d,b,c,a,f)}catch(g){}};this.setRGB=function(){this.reds=[];this.greens=[];this.blues=[];this.yellows=[];this.cyans=[];this.purples=[];this.greys=[];this.indicatorBins=this.allVsAll?Math.min(this.x,this.y)/(this.layoutRows*2):Math.min(this.x,this.y)/4;this.indicatorBins=this.indicatorBins>512?1:this.indicatorBins>256?2:this.indicatorBins>128?4:8;var e=this.indicatorBins;var c=parseInt(256/e);var d;var b=255;for(var a=0;a<c;a++){this.greys.push("rgb("+b+","+b+","+b+")");b-=e}if(this.indicatorCenter=="rainbow-green"){d=e-1;b=255;for(var a=0;a<c;a++){this.greens.push("rgb(0,255,"+d+")");this.cyans.push("rgb(0,"+b+",255)");this.blues.push("rgb("+d+",0,255)");this.purples.push("rgb(255,0,"+b+")");this.reds.push("rgb(255,"+d+",0)");this.yellows.push("rgb("+b+",255,0)");d+=e;b-=e}}else{if(this.indicatorCenter.match("rainbow")){d=e-1;b=255;for(var a=0;a<c;a++){this.reds.push("rgb(255,0,"+d+")");this.purples.push("rgb("+b+",0,255)");this.blues.push("rgb(0,"+d+",255)");this.cyans.push("rgb(0,255,"+b+")");this.greens.push("rgb("+d+",255,0)");this.yellows.push("rgb(255,"+b+",0)");d+=e;b-=e}}else{if(this.indicatorCenter=="black"){d=255;for(var a=0;a<c;a++){this.reds.push("rgb("+d+",0,0)");this.purples.push("rgb("+d+",0,"+d+")");this.blues.push("rgb(0,0,"+d+")");this.cyans.push("rgb(0,"+d+","+d+")");this.greens.push("rgb(0,"+d+",0)");this.yellows.push("rgb("+d+","+d+",0)");d-=e}}else{this.reds.push("rgb(255,0,0)");this.purples.push("rgb(255,0,255)");this.blues.push("rgb(0,0,255)");this.cyans.push("rgb(0,255,255)");this.greens.push("rgb(0,255,0)");this.yellows.push("rgb(255,255,0)");d=e-1;for(var a=0;a<c-1;a++){this.reds.push("rgb(255,"+d+","+d+")");this.purples.push("rgb(255,"+d+",255)");this.blues.push("rgb("+d+","+d+",255)");this.cyans.push("rgb("+d+",255,255)");this.greens.push("rgb("+d+",255,"+d+")");this.yellows.push("rgb(255,255,"+d+")");d+=e}}}}};this.setLineTypes=function(){this.lines=this.getLineTypes()};this.setCodonTable=function(){this.codon={TTT:["F","Phe","Phenylalanine"],TCT:["S","Ser","Serine"],TAT:["Y","Tyr","Tyrosine"],TGT:["C","Cys","Cysteine"],TTC:["F","Phe","Phenylalanine"],TCC:["S","Ser","Serine"],TAC:["Y","Tyr","Tyrosine"],TGC:["C","Cys","Cysteine"],TTA:["L","Leu","Leucine"],TCA:["S","Ser","Serine"],TAA:["*","Stop","Ochre"],TGA:["*","Stop","Opal"],TTG:["L","Leu","Leucine"],TCG:["S","Ser","Serine"],TAG:["*","Stop","Amber"],TGG:["W","Trp","Tryptophan"],CTT:["L","Leu","Leucine"],CCT:["P","Pro","Proline"],CAT:["H","His","Histidine"],CGT:["R","Arg","Arginine"],CTC:["L","Leu","Leucine"],CCC:["P","Pro","Proline"],CAC:["H","His","Histidine"],CGC:["R","Arg","Arginine"],CTA:["L","Leu","Leucine"],CCA:["P","Pro","Proline"],CAA:["Q","Gln","Glutamine"],CGA:["R","Arg","Arginine"],CTG:["L","Leu","Leucine"],CCG:["P","Pro","Proline"],CAG:["Q","Gln","Glutamine"],CGG:["R","Arg","Arginine"],ATT:["I","Ile","Isoleucine"],ACT:["T","Thr","Threonine"],AAT:["N","Asn","Asparagine"],AGT:["S","Ser","Serine"],ATC:["I","Ile","Isoleucine"],ACC:["T","Thr","Threonine"],AAC:["N","Asn","Asparagine"],AGC:["S","Ser","Serine"],ATA:["I","Ile","Isoleucine"],ACA:["T","Thr","Threonine"],AAA:["K","Lys","Lysine"],AGA:["R","Arg","Arginine"],ATG:["M","Met","Methionine"],ACG:["T","Thr","Threonine"],AAG:["K","Lys","Lysine"],AGG:["R","Arg","Arginine"],GTT:["V","Val","Valine"],GCT:["A","Ala","Alanine"],GAT:["D","Asp","Aspartic acid"],GGT:["G","Gly","Glycine"],GTC:["V","Val","Valine"],GCC:["A","Ala","Alanine"],GAC:["D","Asp","Aspartic acid"],GGC:["G","Gly","Glycine"],GTA:["V","Val","Valine"],GCA:["A","Ala","Alanine"],GAA:["E","Glu","Glutamic acid"],GGA:["G","Gly","Glycine"],GTG:["V","Val","Valine"],GCG:["A","Ala","Alanine"],GAG:["E","Glu","Glutamic acid"],GGG:["G","Gly","Glycine"]}};this.setReverseComplement=function(){this.reverseComplement={a:"t",c:"g",g:"c",t:"a",u:"a",A:"T",C:"G",G:"C",T:"A","/":"/","[":"[","]":"]"}};this.initializeAttributes=function(){this.setLineTypes();this.setRGB();this.setCodonTable();this.setReverseComplement()};this.initializeAttributes()};CanvasXpress.prototype.initLayout=function(){this.isValidLayout=function(){var a=this.layout.split(/X/i);if(this.autoAdjust){if(a.length==2){this.layoutRows=a[0];this.layoutCols=a[1]}else{this.layoutRows=1;this.layoutCols=1;this.layoutValid=false}if(!this.graphType.match(/Scatter/)&&this.layoutComb&&this.data.l&&(this.data.l.vars||this.data.l.smps)&&this.data.l.weight&&this.data.l.type){this.data.l.comp=[];if(this.data.l.vars&&this.data.l.smps){var f=0;for(var d=0;d<this.data.l.smps.length;d++){for(var b=0;b<this.data.l.vars.length;b++){this.data.l.comp[f]=[this.getVariableIndices(this.data.l.vars[b]),this.getSampleIndices(this.data.l.smps[d])];f++}}this.layoutRows=this.data.l.smps.length;this.layoutCols=this.data.l.vars.length}else{if(this.data.l.vars){for(var d=0;d<this.data.l.vars.length;d++){this.data.l.comp[d]=this.getVariableIndices(this.data.l.vars[d])}}else{for(var d=0;d<this.data.l.smps.length;d++){this.data.l.comp[d]=this.getSampleIndices(this.data.l.smps[d])}}if(this.graphType!="Pie"){if(this.graphOrientation=="vertical"){this.layoutRows=this.data.l.comp.length}else{this.layoutCols=this.data.l.comp.length}}}this.layoutValid=true;this.layoutAdjust=true}else{if(this.layoutComb&&this.data.l&&this.data.l.smps&&this.data.l.weight&&this.data.l.type){this.data.l.comp=[];var e=this.getVariableIndices(this.data.y.vars);for(var d=0;d<this.data.l.type.length;d++){this.data.l.comp[d]=e}this.layoutValid=true}else{if(this.data.l&&this.data.l.comp){if(this.data.l.comp.length<=(this.layoutRows*this.layoutCols)){this.layoutValid=true}else{this.layoutValid=false}}else{this.layoutValid=false}}}}else{this.layoutRows=1;this.layoutCols=1;this.layoutValid=false}};this.setLayout=function(a){};this.addLayoutResizer=function(b){var a=0;if(this.resizerType&&this.resizerPosition==b){a+=this.resizerWidth+(this.margin*2);if(this.resizerType=="samples"){a+=14+this.margin}}return a};this.getLayoutResizerDimensions=function(){if(this.resizerType){var u,j,e,d;var f=this.data.l.comp.length-1;var k=this.resizerWidth;var z=this.resizerWidth;var B=this.marginTop+this.layoutTop;var c=this.marginRight+this.layoutRight;var q=this.marginBottom+this.layoutBottom;var g=this.marginLeft+this.layoutLeft;var A=this.getAxesVals(0);var s=0;var m=0;switch(this.resizerPosition){case"right":u="xAxis";j="y";e="v";d="r";B+=this["subGraphTop"+0];g=this.resizerType=="samples"?this.width-((this.margin*2)+this.resizerWidth+14):this.width-(this.margin+this.resizerWidth);k=this.height-(B+q+this["subGraphBottom"+f]);break;case"left":u="xAxis";j="y";e="v";d="l";B+=this["subGraphTop"+0];g=this.resizerType=="samples"&&this.graphOrientation=="horizontal"?(this.margin*2):this.margin;k=this.height-(B+q+this["subGraphBottom"+f]);break;case"top":u="xAxis";j="x";e="h";d="t";B=this.resizerType=="samples"?(this.margin*2)+14:this.margin;g+=this["subGraphLeft"+0];z=this.width-(g+c+this["subGraphRight"+f]);m+=this.resizerWidth;break;case"bottom":u="xAxis";j="x";e="h";d="b";B=this.resizerType=="samples"&&this.graphOrientation=="vertical"?this.height-((this.margin*2)+this.resizerWidth+14):this.width-(this.margin+this.resizerWidth);g+=this["subGraphLeft"+0];z=this.width-(g+c+this["subGraphRight"+f]);m+=this.resizerWidth;break}if(e=="v"){return([u,g+s,g+s+z,B+m,B+m+k,j,e,d,A,g+14,B,z,k])}else{return([u,g+s,g+s+z,B+m,B+m+k,j,e,d,A,g,B,z,k])}}};this.drawLayoutResizer=function(){if(this.resizerType){var a=this.getLayoutResizerDimensions();this.showAxesResizer(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],"",0,0,0);this.drawAxesResizerBackgroundData(a[9],a[10],a[11],a[12]);this.drawAxesResizerMasks()}};this.getLayoutMaxLegend=function(){if(this.data.l.vars){var a=0;if(this.data.l.comp){for(var b=0;b<this.data.l.comp.length;b++){a=Math.max(a,this.data.l.comp[b].length)}}return a}else{return this.varIndices.length}};this.setLayoutLeft=function(){var a=0;if(this.graphOrientation!="vertical"&&this.segregateSamplesBy&&this.segregateVariablesBy){this.set1DVarSmpLabelFont();a=this.fontSize+(this.margin*4)+this.measureText(this.maxSmpNameStr,this.smpLabelFont)+this.getSmpOverlaysLength()}else{if(this.graphOrientation!="vertical"&&this.segregateVariablesBy){this.set1DVarSmpLabelFont();a=(this.margin*2)+this.measureText(this.maxSmpNameStr,this.smpLabelFont)+this.getSmpOverlaysLength()}else{if((this.segregateSamplesBy||this.segregateVariablesBy)&&this.graphOrientation=="vertical"){a=this.fontSize+(this.margin*2)}else{if(this.graphType=="Candlestick"&&this.graphOrientation!="vertical"){this.setTimeAxis();this.set1DVarSmpLabelFont();a=this.getSampleLabelLength()+this.getSmpOverlaysLength()}else{if(this.graphType=="Pie"){a=(this.margin*2)+this.measureText("XX",this.smpLabelFont)}}}}}return a+this.addLayoutResizer("left")};this.setLayoutRight=function(){var a=0;if(this.graphType=="Pie"&&this.showLegend){var b=this.getPieLegendDimensions();a=b[0]}else{if(this.graphType.match(/Scatter/)&&(this.showLegend||this.showIndicators)){if(this.xAxis&&this.yAxis){this.setDataColorShapeSize()}this.setLegendDimensions();a=this.legendWidth}}return a+this.addLayoutResizer("right")};this.setLayoutTop=function(){var a=0;if(((this.segregateSamplesBy||this.segregateVariablesBy)&&this.graphOrientation!="vertical")||(this.segregateSamplesBy&&this.segregateVariablesBy)||(this.graphType=="Pie")){a=this.fontSize+(this.margin*2)}return a+this.addLayoutResizer("top")};this.setLayoutBottom=function(){var a=0;if(this.segregateSamplesBy&&this.segregateVariablesBy){a=this.getLegendHeight()}else{if(this.segregateVariablesBy&&this.graphOrientation=="vertical"){this.set1DVarSmpLabelFont();a=(this.margin*2)+this.measureText(this.maxSmpNameStr,this.smpLabelFont)+this.getSmpOverlaysLength()}else{if(this.graphType=="Candlestick"&&this.graphOrientation=="vertical"){this.setTimeAxis();this.set1DVarSmpLabelFont();a=this.getSampleLabelLength()+this.getSmpOverlaysLength()}else{if(this.graphType.match(/Scatter/)&&(this.showLegend||this.showIndicators)){if(this.xAxis&&this.yAxis){this.setDataColorShapeSize()}this.setLegendDimensions();a=this.legendHeight}}}}return a+this.addLayoutResizer("bottom")};this.drawLayoutSampleOverlays=function(b){var a=this.smpIndices;this.smpIndices=b;this.set1DVarSmpLabelFont();this.smpIndices=a;this.showSampleNames=true;this.showOverlays=true;this.draw1DYLayout()};this.drawLayoutVariableLegend=function(){this.showLegend=true;if(this.graphType=="Pie"){this.drawPieLegend()}else{this.draw1DLegend()}this.showLegend=false};this.setLayoutDimensions=function(){this.offsetX=0;this.offsetY=0;this.layoutLeft=this.setLayoutLeft();this.layoutRight=this.setLayoutRight();this.layoutTop=this.setLayoutTop();this.layoutBottom=this.setLayoutBottom()};this.drawLabelsLayout=function(){var q=0;var p=0;var o=0;var f=0;var k=this.width-(this.marginLeft+this.layoutLeft+this.layoutRight+this.marginRight);var d=this.height-(this.marginTop+this.layoutTop+this.layoutBottom+this.marginBottom);if(this.resizerType){if(this.resizerPosition=="top"){p=this.resizerType=="samples"?(this.margin*2)+this.resizerWidth+14:this.margin+this.resizerWidth;f=p}else{if(this.resizerPosition=="left"){q=this.resizerType=="samples"?(this.margin*2)+this.resizerWidth+14:this.margin+this.resizerWidth;o=q}}}if(this.segregateSamplesBy&&this.segregateVariablesBy){p+=this.fontSize+(this.margin*4);q=this.marginLeft+this.layoutLeft;for(var s=0;s<this.data.l.vars.length;s++){var l=s*this.data.l.smps.length;var r=k*this["subGraphWeight"+l][0];q+=(r/2);this.drawText(this.data.l.name[l][0],q,p,this.font,this.foreground,"center","middle");q+=(r/2)}q=o+this.fontSize+(this.margin*4);p=this.marginTop+this.layoutTop;for(var l=0;l<this.data.l.smps.length;l++){var m=d*this["subGraphWeight"+l][1];p+=(m/2);this.drawText(this.data.l.name[l][1],q,p,this.font,this.foreground,"center","middle",-Math.PI/2);p+=(m/2)}}else{if((this.segregateSamplesBy||this.segregateVariablesBy)&&this.graphOrientation=="vertical"&&this.data.l.name){q+=this.fontSize+(this.margin*4);p+=this.marginTop+this.layoutTop;for(var l=0;l<this.data.l.name.length;l++){var m=d*this["subGraphWeight"+l];p+=(m/2);this.drawText(this.data.l.name[l],q,p,this.font,this.foreground,"center","middle",-Math.PI/2);p+=(m/2)}}else{if((this.segregateSamplesBy||this.segregateVariablesBy)&&this.graphOrientation=="horizontal"&&this.data.l.name){p+=this.fontSize+(this.margin*4);q+=this.marginLeft+this.layoutLeft;for(var l=0;l<this.data.l.name.length;l++){var r=k*this["subGraphWeight"+l];q+=(r/2);this.drawText(this.data.l.name[l],q,p,this.font,this.foreground,"center","middle");q+=(r/2)}}else{if(this.graphType=="Pie"&&(this.showPieGrid||this.showPieSampleLabel)){var m,r;var n=0;var t=this.getFontPt(this.font);var b=this.marginTop+this.layoutTop;var e=this.marginLeft+this.layoutLeft;var a=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];for(var l=0;l<this.layoutRows;l++){m=d*this["subGraphWeight"+n][1];q=(this.marginLeft+this.layoutLeft)-this.margin;b+=m;if(this.showPieGrid){this.drawText(a[l],q,(b+(t/2))-(m/2),this.font,this.foreground,"right","middle")}for(var g=0;g<this.layoutCols;g++){if(this.xAxis.length<=n){break}r=k*this["subGraphWeight"+n][0];e+=r;p=(this.marginTop+this.layoutTop)-this.margin;if(l==0){if(this.showPieGrid){this.drawText(g+1,(e+(t/2))-(r/2),p,this.font,this.foreground,"center","bottom")}}if(this.showPieSampleLabel){this.drawText(this.xAxis[n],e-(r/1.1),b-(m/5),this.legendFont,this.foreground,"center","middle")}n++}e=this.marginLeft+this.layoutLeft}}}}}};this.setLayoutGraphAttributes=function(){var g=0;for(var d=0;d<this.layoutRows;d++){for(var b=0;b<this.layoutCols;b++){var e="subGraphType"+g;if(!this[e]){if(this.data.l.type&&this.data.l.type[g]){this[e]=this.data.l.type[g]}else{this[e]=this.graphType}}var f="subSummaryType"+g;if(this[e]=="Boxplot"||this.summaryType=="iqr"){this[f]="iqr"}else{if(this.summaryType=="median"){this[f]="median"}else{if(this.summaryType=="sum"){this[f]="sum"}else{if(this[e]=="Correlation"){this[f]="cor"}else{if(this[e]=="Candlestick"){if((this.graphOrientation=="vertical"&&d>0)||(this.graphOrientation=="horizontal"&&b==0)){this[f]="volume"}else{this[f]="candle"}}else{this[f]="mean"}}}}}var a="subTransformType"+g;if(!this[a]){if(this.data.l.transform&&this.data.l.transform[g]){this[a]=this.data.l.transform[g]}else{this[a]=this.subTransformType}}g++}}};this.setLayoutWeights=function(){if(this.data.l.weight){var d=0;var e=0;var a;var b;if(this.allVsAll){for(var c=0;c<this.layoutRows;c++){a="subGraphWeight"+c;b=this[a]?this[a]:this.data.l.weight[c];d+=b}for(var c=0;c<this.data.l.weight.length;c++){a="subGraphWeight"+c;b=this[a]?this[a]:this.data.l.weight[c];this.data.l.weight[c]=b/d;this[a]=this.data.l.weight[c]}}else{if(this.data.l.vars&&this.data.l.smps){for(var c=0;c<this.data.l.weight.length;c++){a="subGraphWeight"+c;b=this[a]?this[a]:this.data.l.weight[c];d+=b[0];e+=b[1]}for(var c=0;c<this.data.l.weight.length;c++){a="subGraphWeight"+c;b=this[a]?this[a]:this.data.l.weight[c];this.data.l.weight[c][0]=b[0]/d*this.data.l.smps.length;this.data.l.weight[c][1]=b[1]/e*this.data.l.vars.length;this[a]=this.data.l.weight[c]}}else{if(this.graphType=="Pie"){for(var c=0;c<this.data.l.comp.length;c++){a="subGraphWeight"+c;this[a]=this.data.l.weight[c]}}else{for(var c=0;c<this.data.l.weight.length;c++){a="subGraphWeight"+c;b=this[a]?this[a]:this.data.l.weight[c];d+=b}for(var c=0;c<this.data.l.weight.length;c++){a="subGraphWeight"+c;b=this[a]?this[a]:this.data.l.weight[c];this.data.l.weight[c]=b/d;this[a]=this.data.l.weight[c]}}}}}else{if(this.data.l.comp){this.data.l.weight=[];for(var c=0;c<this.data.l.comp.length;c++){a="subGraphWeight"+c;this.data.l.weight[c]=this.data.l.comp.length;this[a]=this.data.l.weight[c]}}else{alert("Wuz going on dude? This aint't gonna work!")}}};this.setMinimumLayoutAxisFonts=function(){var h=0;var e=Number.MAX_VALUE;for(var d=0;d<this.layoutRows;d++){for(var b=0;b<this.layoutCols;b++){var g,f,a;if(this.data.l.desc&&this.data.l.desc[h]){g=this.data.l.desc[h]}else{g="NA"}a=this.graphOrientation=="vertical"?this.height*this["subGraphWeight"+h]:this.width*this["subGraphWeight"+h];this.setAxisFont(g,a);f=this.getFontPt(this.axisTitleFont);if(f<e){e=f;this.minLayoutAxis=e;this.minLayoutAxisTitle=g}h++}}};this.getLayoutSummaryTypes=function(){var g=0;var a={};var e=[];for(var d=0;d<this.layoutRows;d++){for(var b=0;b<this.layoutCols;b++){var f="subSummaryType"+g;if(!a.hasOwnProperty(this[f])){e.push(this[f]);a[this[f]]=true}g++}}return e};this.validateLayoutSummaryGrouping=function(){if(this.isGroupedData){var b=this.getLayoutSummaryTypes();for(var a=0;a<b.length;a++){if(!this.isValidPlotData(b[a])){this.groupSamples(this.groupingFactors,b);break}}}};this.resetLayout=function(){delete (this.data.l);delete (this.layoutParams);this.offsetX=0;this.offsetY=0;this.layoutValidN=false;this.layoutValidR=false;this.layoutValidC=false;this.layoutComb=false;this.layout="1X1"};this.drawLayoutCompartments=function(g){var a=[];var z=0;var s=0;var x=this.varIndices;var u=this.smpIndices;var r=this.showSampleNames;var o=this.showOverlays;var h=this.showLegend;var w=this.showIndicators;var d=this.getObjectArray(x);var f=this.getObjectArray(u);var C=false;var B=["left","right","top","bottom","x","y","width","height","weight","offsetX","offsetY","varIndices","smpIndices","grpIndices","graphType","summaryType","transformType","varIndicesStart","smpIndicesStart","minData","maxData","xAxisMin","xAxisMax","xAxis2Min","xAxis2Max","yAxisMin","yAxisMax","zAxisMin","zAxisMax","xAxisAbsMin","xAxisAbsMax","xAxis2AbsMin","xAxis2AbsMax","yAxisAbsMin","yAxisAbsMax","zAxisAbsMin","zAxisAbsMax","xAxisUnit","xAxis2Unit","yAxisUnit","zAxisUnit","setMin","setMax","setMin2","setMax2","setMinX","setMaxX","setMinY","setMaxY","setMinZ","setMaxZ"];var n=["graphType","transformType","varIndicesStart","smpIndicesStart","setMin","setMax","setMin2","setMax2","setMinX","setMaxX","setMinY","setMaxY","setMinZ","setMaxZ"];var q;if(this.layoutComb){if(!this.graphType.match(/Scatter/)){this.layoutMaxVarLegend=this.getLayoutMaxLegend()}if(this.graphType.match(/Scatter/)){this.xAxis=this.data.y.smps;this.yAxis=this.data.y.smps;this.initAxes(true)}else{this.initAxes(false,true)}this.setLayoutDimensions();var D=this.marginLeft+this.layoutLeft+this.layoutRight+this.marginRight;var e=this.marginTop+this.layoutTop+this.layoutBottom+this.marginBottom;if(this.graphType.match(/Scatter/)){this.draw2DLegend()}if(this.layoutParams&&this.layoutValidN>-1){q=this.layoutParams;if(q[this.layoutValidN]){for(var y=0;y<B.length;y++){q[this.layoutValidN][B[y]]=this[B[y]]}}}this.offsetX=this.layoutLeft;this.offsetY=this.layoutTop;this.layoutMaxVarLegendLabel=this.data.l.vars?this.maxVarNameStr:this.maxSmpNameStr;this.layoutParams=[];if(!this.graphType.match(/Scatter/)){if(this.data.l.vars&&this.data.l.smps){this.layoutRows=this.data.l.smps.length;this.layoutCols=this.data.l.vars.length;this.layoutMaxSamples=this.smpIndices.length*this.layoutCols/this.layoutRows;this.legendPosition="bottom"}else{z=Math.max(this.layoutRows,this.layoutCols);if(this.graphType!="Pie"){if(this.graphOrientation=="vertical"){this.layoutRows=z;this.layoutCols=1;this.legendPosition="right"}else{this.layoutRows=1;this.layoutCols=z;this.legendPosition="bottom"}}}}this.setLayoutWeights();this.setMinimumLayoutAxisFonts();this.setLayoutGraphAttributes();this.validateLayoutSummaryGrouping();var A=0;for(var y=0;y<this.layoutRows;y++){for(var v=0;v<this.layoutCols;v++){this.layoutCurrent=A;if(this.graphType=="Pie"){if(this.data.l.smps.length<=A){break}}if(q){for(var t=0;t<n.length;t++){this[n[t]]=q[A][n[t]]}}this.weight=this["subGraphWeight"+A];this.graphType=this["subGraphType"+A];this.summaryType=this["subSummaryType"+A];this.transformType=this["subTransformType"+A];if(this["subTransformType"+A]){this.isTransformedData=true}if(this.data.l.log&&this.data.l.log[A]){this.isLogData=this.data.l.log[A]}if(this.graphType.match(/Scatter/)){if(this.data.l.smps[A].xAxis&&this.data.l.smps[A].yAxis){this.xAxis=this.data.l.smps[A].xAxis;this.yAxis=this.data.l.smps[A].yAxis;this.xAxisIndices=this.getSampleIndices(this.xAxis);this.yAxisIndices=this.getSampleIndices(this.yAxis)}else{this.xAxis=false;this.yAxis=false;this.xAxisIndices=false;this.yAxisIndices=false}this.layoutWidth=(this.width-D)*this["subGraphWeight"+A];this.layoutHeight=(this.height-e)*this["subGraphWeight"+A];this.varIndices=this.data.l.comp[A];if(this.graphType.match(/Scatter/)&&this.layoutAdjust&&this.xAxis&&this.yAxis){this.initAxes(true);this.layoutAxis=3}else{if(this.graphType.match(/Scatter/)){this.layoutAxis=v==0?2:0;this.layoutAxis=y==this.layoutRows&&this.layoutAxis?3:y==this.layoutRows?1:0}}this.showLegend=false;this.showIndicators=false}else{if(this.data.l.vars&&this.data.l.smps){C=this.graphOrientation=="vertical"?true:false;this.showLegend=false}else{if(this.graphType=="Pie"){C=false;this.showLegend=false}else{C=this.data.l.smps?true:false}}this.showSampleNames=C;this.showOverlays=C;this.xAxisTitle=this.data.l.desc&&this.data.l.desc[A]?this.data.l.desc[A]:false;if(this.data.l.vars&&this.data.l.smps){this.layoutHeight=(this.height-e)*this["subGraphWeight"+A][1];this.layoutWidth=(this.width-D)*this["subGraphWeight"+A][0];a=[];for(var t=0;t<this.data.l.comp[A][0].length;t++){if(d.hasOwnProperty(this.data.l.comp[A][0][t])){a.push(this.data.l.comp[A][0][t])}}this.varIndices=a;a=[];for(var t=0;t<this.data.l.comp[A][1].length;t++){if(f.hasOwnProperty(this.data.l.comp[A][1][t])){a.push(this.data.l.comp[A][1][t])}}this.smpIndices=a}else{if(this.graphType=="Pie"){this.layoutWidth=(this.width-D)*this["subGraphWeight"+A][0];this.layoutHeight=(this.height-e)*this["subGraphWeight"+A][1]}else{if(this.graphOrientation=="vertical"){this.layoutHeight=(this.height-e)*this["subGraphWeight"+A];this.layoutWidth=this.width-D}else{this.layoutWidth=(this.width-D)*this["subGraphWeight"+A];this.layoutHeight=this.height-e}}a=[];if(this.data.l.vars){for(var t=0;t<this.data.l.comp[A].length;t++){if(d.hasOwnProperty(this.data.l.comp[A][t])){a.push(this.data.l.comp[A][t])}}this.varIndices=a}else{for(var t=0;t<this.data.l.comp[A].length;t++){if(f.hasOwnProperty(this.data.l.comp[A][t])){a.push(this.data.l.comp[A][t])}}this.smpIndices=a}}if(this.layoutAdjust){this.layoutAxis=3;this.initAxes(true)}}g.call(this);this["subGraphTop"+A]=this.top;this["subGraphBottom"+A]=this.bottom;this["subGraphRight"+A]=this.right;this["subGraphLeft"+A]=this.left;this["subGraphX"+A]=this.x;this["subGraphY"+A]=this.y;var l=["rect",this.marginLeft+this.offsetX+this.left,this.marginTop+this.offsetY+this.top,this.marginLeft+this.offsetX+this.left+this.x,this.marginTop+this.offsetY+this.top+this.y];if(this.graphType.match(/Scatter/)){if(y==v){var p=this.scaleTextToFont(this.maxSmpNameStr,this.maxTextSize,(this.width-D)*0.8/this.layoutCols);this.drawText(this.data.y.smps[y],this.marginLeft+this.offsetX+this.left+(this.x/2),this.marginTop+this.offsetY+this.top+(this.y/2),p,this.foreground,"center","middle")}else{this.addGlobalArea(l,true)}}else{if(!C){this.addGlobalArea(l,true);if(this.data.l.vars&&this.data.l.smps){if(this.graphOrientation!="vertical"&&A%this.data.l.vars.length==0){this.drawLayoutSampleOverlays(u)}if(A>=this.data.l.vars.length*(this.data.l.smps.length-1)){this.drawLayoutVariableLegend()}}else{if(this.graphType!="Pie"){if((this.graphOrientation=="vertical"&&(A+1)==z)||(this.graphOrientation!="vertical"&&A==0)){this.drawLayoutSampleOverlays(u)}}else{if(this.graphType=="Pie"&&A==0){if(h){this.drawLayoutVariableLegend()}}}}}else{if(this.data.l.vars&&this.data.l.smps){this.addGlobalArea(l,true);if(A>=this.data.l.vars.length*(this.data.l.smps.length-1)){this.drawLayoutVariableLegend()}}}}var b={};for(var t=0;t<B.length;t++){b[B[t]]=this[B[t]]}b.width=this.layoutWidth;b.height=this.layoutHeight;b.subGraphType=this.graphType;b.subSummaryType=this.SummaryType;b.subTransformType=this.transformType;this.layoutParams.push(b);if(this.graphType.match(/Scatter/)||(this.data.l.vars&&this.data.l.smps)){this.offsetX+=this.layoutWidth}else{if(this.graphOrientation=="vertical"){this.offsetY+=this.layoutHeight}else{this.offsetX+=this.layoutWidth}}A++}if(this.graphType.match(/Scatter|Pie/)||(this.data.l.vars&&this.data.l.smps)){this.offsetX=this.layoutLeft;this.offsetY+=this.layoutHeight}}this.drawLabelsLayout();this.drawLayoutResizer();this.varIndices=x;this.smpIndices=u;this.showSampleNames=r;this.showOverlays=o;this.showLegend=h;this.showIndicators=w}};this.initializeLayout=function(){this.isValidLayout()};this.initializeLayout()};CanvasXpress.prototype.initConfigurator=function(){this.addConfigurator=function(a){return function(ab,M,F,E){if(!ab){ab=window.event}var ag=document.getElementById(a.target+"canvasXpressConfigurator");if(ag){var ai=F!=null&&E!=null?{x:F,y:E}:a.adjustedCoordinates(ab);if(ai){F=ai.x;E=ai.y}ag.style.left=F+"px";ag.style.top=E+"px";return}var J="Enter property name or function";if(a.isVML||a.disableConfigurator){return}a.configuringOn=true;if(M){if(a.isArray(M)){M=M[0]}if(a.graphType=="Network"){a.configuringNetwork=M;if(a.data.nodes.length>M){J="Configure "+(a.data.nodes[M].label||a.data.nodes[M].name||a.data.nodes[M].id)}else{var t=a.data.edges[M-a.data.nodes.length];var D=a.data.nodes[a.data.nodeIndices[t.id1]];var B=a.data.nodes[a.data.nodeIndices[t.id2]];J="Configure "+(D.label||D.name||D.id)+" - "+(B.label||D.name||B.id)}}else{if(a.graphType=="Genome"){a.configuringGenome=M;J="Configure track "+M}}}var ai=F!=null&&E!=null?{x:F,y:E}:a.adjustedCoordinates(ab);if(ai){F=ai.x;E=ai.y;var ag=document.createElement("div");ag.id=a.target+"canvasXpressConfigurator";ag.className="draggable";ag.style.cursor="move";ag.style.left=F+"px";ag.style.top=E+"px";ag.style.padding="10px";ag.style.color=this.skinColor;ag.style.border="1px solid "+this.skinBorderColor;ag.style.backgroundColor=this.skinBackgroundColor;ag.style.boxShadow="2px 2px 2px "+this.skinShadowColor;ag.style.MozBoxShadow="2px 2px 2px "+this.skinShadowColor;ag.style.borderRadius="8px";ag.style.position="absolute";ag.style.zIndex=10000;var W=document.createElement("div");W.id=a.target+"canvasXpressConfiguratorKeyText";W.style.cursor="default";W.style.display="block";W.style.margin="5px 5px 8px 5px";W.style.width=this.configuratorWidth+"px";W.style.fontWeight="bold";var Z=document.createElement("span");Z.id=a.target+"canvasXpressConfiguratorKeyTextSpan";Z.innerHTML=J;var Y=document.createElement("img");Y.id=a.target+"canvasXpressConfiguratorKeyHelp";Y.src=this.imageDir+"help1.png";Y.alt="Help";Y.title="Help";Y.style.margin="2px";Y.style.cssFloat="right";var U=document.createElement("img");U.id=a.target+"canvasXpressConfiguratorKeySave";U.src=this.imageDir+"disk.png";U.alt="Save as png";U.title="Save as png";U.style.margin="2px";U.style.cssFloat="right";var N=document.createElement("img");N.id=a.target+"canvasXpressConfiguratorKeyData";N.src=this.imageDir+"table.png";U.alt="Show data";N.title="Show data";N.style.margin="2px";N.style.cssFloat="right";var af=document.createElement("img");af.id=a.target+"canvasXpressConfiguratorKeyAdvanced";af.src=this.showAdvancedConfiguration?this.imageDir+"lightbulb.png":this.imageDir+"lightbulb_off.png";af.alt=this.showAdvancedConfiguration?"Show basic configuaration properties":"Show advanced configuaration properties";af.title=this.showAdvancedConfiguration?"Show basic configuaration properties":"Show advanced configuaration properties";af.style.margin="2px";af.style.cssFloat="right";var aa=document.createElement("img");aa.id=a.target+"canvasXpressConfiguratorKeySearch";aa.src=this.imageDir+"find.png";aa.style.margin="2px";aa.alt="Browse properties by category";aa.title="Browse properties by category";aa.style.cssFloat="right";var T=document.createElement("img");T.id=a.target+"canvasXpressConfiguratorKeyClose";T.src=this.imageDir+"cancel1.png";T.alt="Close";T.title="Close";T.style.margin="2px";T.style.cssFloat="right";var V=document.createElement("input");V.id=a.target+"canvasXpressConfiguratorKey";V.type="text";V.style.cursor="default";V.style.display="block";V.style.margin="5px";V.style.width=this.configuratorWidth+"px";V.style.borderRadius="4px";V.style.MozBorderRadius="4px";var S=document.createElement("select");S.id=a.target+"canvasXpressConfiguratorCategories";S.style.cursor="default";S.style.display="none";S.style.margin="5px";S.style.width=this.configuratorWidth+"px";S.style.borderRadius="4px";S.style.MozBorderRadius="4px";S.size=5;var L=document.createElement("div");L.id=a.target+"canvasXpressConfiguratorSugestionsText";L.style.cursor="default";L.style.display="none";L.style.margin="5px";L.style.width=this.configuratorWidth+"px";L.innerHTML="Select property";L.style.fontWeight="bold";var K=document.createElement("select");K.id=a.target+"canvasXpressConfiguratorSugestions";K.style.cursor="default";K.style.display="none";K.style.margin="5px";K.style.width=this.configuratorWidth+"px";K.style.borderRadius="4px";K.style.MozBorderRadius="4px";K.size=5;var ae=document.createElement("div");ae.id=a.target+"canvasXpressConfiguratorSugestionsDescription";ae.style.cursor="default";ae.style.display="none";ae.style.backgroundColor=this.skinBackgroundColor;ae.style.margin="5px";ae.style.width=this.configuratorWidth+"px";ae.style.minHeight="56px";ae.style.overflow="auto";var I=document.createElement("div");I.id=a.target+"canvasXpressConfiguratorValueText";I.style.cursor="default";I.style.display="none";I.style.margin="5px";I.style.width=this.configuratorWidth+"px";I.innerHTML="Current value";I.style.fontWeight="bold";var aj=document.createElement("div");aj.id=a.target+"canvasXpressConfiguratorSeeAlso";aj.style.cursor="default";aj.style.display="none";aj.style.margin="5px";aj.style.backgroundColor=this.skinBackgroundColor;aj.style.width=this.configuratorWidth+"px";aj.style.minHeight="20px";aj.style.overflow="auto";var H=document.createElement("input");H.id=a.target+"canvasXpressConfiguratorValue";H.type="text";H.style.cursor="default";H.style.display="none";H.style.margin="5px";H.style.width=this.configuratorWidth+"px";H.style.borderRadius="4px";H.style.MozBorderRadius="4px";var A=document.createElement("input");A.id=a.target+"canvasXpressConfiguratorApply";A.value="Apply";A.type="button";A.style.cursor="default";A.style.display="none";A.style.margin="5px";A.style.cssFloat="left";A.style.width=((this.configuratorWidth/2)-5)+"px";A.style.borderRadius="4px";A.style.MozBorderRadius="4px";var ah=document.createElement("input");ah.id=a.target+"canvasXpressConfiguratorButton";ah.value="Draw";ah.type="button";ah.style.cursor="default";ah.style.display="none";ah.style.margin="5px";ah.style.cssFloat="left";ah.style.width=((this.configuratorWidth/2)-5)+"px";ah.style.borderRadius="4px";ah.style.MozBorderRadius="4px";var O=document.createElement("img");O.id=a.target+"canvasXpressConfiguratorOptionsClose";O.src=this.imageDir+"cancel1.png";O.style.cssFloat="right";O.style.cursor="default";var C=document.createElement("div");C.id=a.target+"canvasXpressConfiguratorOptions";C.className="draggable";C.style.cursor="move";C.style.display="none";C.style.padding="10px";C.style.border="1px solid "+this.skinBorderColor;C.style.backgroundColor=this.skinBackgroundColor;C.style.boxShadow="2px 2px 2px "+this.skinShadowColor;C.style.MozBoxShadow="2px 2px 2px "+this.skinShadowColor;C.style.borderRadius="8px";C.style.position="absolute";C.style.fontWeight="bold";C.style.zIndex=10001;var X=document.createElement("img");X.id=a.target+"canvasXpressConfiguratorHelpClose";X.src=this.imageDir+"cancel1.png";X.style.cssFloat="right";X.style.cursor="default";var G=document.createElement("div");G.id=a.target+"canvasXpressConfiguratorHelp";G.className="draggable";G.style.cursor="move";G.style.display="none";G.style.padding="10px";G.style.border="1px solid "+this.skinBorderColor;G.style.backgroundColor=this.skinBackgroundColor;G.style.boxShadow="2px 2px 2px "+this.skinShadowColor;G.style.MozBoxShadow="2px 2px 2px "+this.skinShadowColor;G.style.borderRadius="8px";G.style.fontWeight="bold";G.style.position="absolute";G.style.zIndex=10002;var Q=document.createElement("div");Q.id=a.target+"canvasXpressConfiguratorColorCurrent";Q.style.width="181px";Q.style.height="16px";Q.style.cssFloat="left";Q.style.fontSize="x-small";Q.style.border="1px solid "+a.configuratorBorderColor;Q.style.cursor="default";var P=document.createElement("img");P.id=a.target+"canvasXpressConfiguratorColorClose";P.src=this.imageDir+"cancel1.png";P.style.clear="none";P.style.cssFloat="right";P.style.cursor="default";var R=document.createElement("div");R.id=a.target+"canvasXpressConfiguratorColor";R.className="draggable";R.style.cursor="move";R.style.display="none";R.style.padding="10px";R.style.border="1px solid "+this.skinBorderColor;R.style.backgroundColor=this.skinBackgroundColor;R.style.boxShadow="2px 2px 2px "+this.skinShadowColor;R.style.MozBoxShadow="2px 2px 2px "+this.skinShadowColor;R.style.borderRadius="8px";R.style.minWidth="108px";R.style.position="absolute";R.style.zIndex=10002;W.appendChild(Z);W.appendChild(T);W.appendChild(af);W.appendChild(aa);W.appendChild(U);W.appendChild(N);W.appendChild(Y);C.appendChild(document.createTextNode("Select option ..."));C.appendChild(O);C.appendChild(document.createElement("br"));G.appendChild(document.createTextNode("Help"));G.appendChild(X);G.appendChild(document.createElement("br"));R.appendChild(Q);R.appendChild(P);R.appendChild(document.createElement("br"));ag.appendChild(W);ag.appendChild(V);ag.appendChild(S);ag.appendChild(L);ag.appendChild(K);ag.appendChild(ae);ag.appendChild(aj);ag.appendChild(I);ag.appendChild(H);ag.appendChild(A);ag.appendChild(ah);ag.appendChild(C);ag.appendChild(G);ag.appendChild(R);a.canvas.parentNode.appendChild(ag);a.addRemoveConfiguratorListeners("addEvtListener");if(a.configuringNetwork||a.configuringGenome){a.selectConfig(false,true)}setTimeout(function(){V.focus()},300)}}}(this);this.addRemoveConfiguratorListeners=function(g){var E=document.getElementById(this.target+"canvasXpressConfigurator");var v=document.getElementById(this.target+"canvasXpressConfiguratorCategories");var j=document.getElementById(this.target+"canvasXpressConfiguratorSugestions");var a=document.getElementById(this.target+"canvasXpressConfiguratorApply");var F=document.getElementById(this.target+"canvasXpressConfiguratorButton");var x=document.getElementById(this.target+"canvasXpressConfiguratorKeyClose");var D=document.getElementById(this.target+"canvasXpressConfiguratorKeyAdvanced");var B=document.getElementById(this.target+"canvasXpressConfiguratorKeyHelp");var C=document.getElementById(this.target+"canvasXpressConfiguratorKeySearch");var y=document.getElementById(this.target+"canvasXpressConfiguratorKeySave");var k=document.getElementById(this.target+"canvasXpressConfiguratorKeyData");var d=document.getElementById(this.target+"canvasXpressConfiguratorOptions");var o=document.getElementById(this.target+"canvasXpressConfiguratorOptionsClose");var e=document.getElementById(this.target+"canvasXpressConfiguratorHelp");var A=document.getElementById(this.target+"canvasXpressConfiguratorHelpClose");var u=document.getElementById(this.target+"canvasXpressConfiguratorColor");var r=document.getElementById(this.target+"canvasXpressConfiguratorColorClose");if(E&&v&&j&&F&&a&&x&&D&&B&&C&&y&&k&&d&&o&&e&&A&&u&&r){this[g](E,"mousedown",this.registerMousemove,false);this[g](v,"change",this.changeCategory,false);this[g](v,"click",this.changeCategory,false);this[g](j,"change",this.clickSuggestions,false);this[g](j,"click",this.clickSuggestions,false);this[g](a,"click",this.clickApplyConfigurator,false);this[g](F,"click",this.clickConfigurator,false);this[g](B,"click",this.clickHelp,false);this[g](k,"click",this.clickDataTable,false);this[g](y,"click",this.print,false);this[g](C,"click",this.clickSearch,false);this[g](D,"click",this.clickAdvanced,false);this[g](x,"click",this.closeConfigurator,false);this[g](d,"mousedown",this.registerMousemove,false);this[g](o,"click",this.closePropertyOptions,false);this[g](e,"mousedown",this.registerMousemove,false);this[g](A,"click",this.closeHelp,false);this[g](u,"mousedown",this.registerMousemove,false);this[g](r,"click",this.closePropertyColor,false)}};this.getConfigurableProperties=function(){if(this.configuringNetwork){if(this.data.nodes.length>this.configuringNetwork){return this.getNodeConfigurableProperties(this.configuringNetwork)}else{return this.getEdgeConfigurableProperties(this.configuringNetwork-this.data.nodes.length)}}else{if(this.configuringGenome){if(!isNaN(this.configuringGenome)||this.configuringGenome.match(/:/)){return this.featureConfigurableProperties}else{if(this.configuringGenome.match(/track/)){return this.trackConfigurableProperties}else{this.configuringGenome=false}}}}var e=[];for(var d in CanvasXpress.doc.P){var a=CanvasXpress.doc.P[d].M;var b=CanvasXpress.doc.P[d].U;if(CanvasXpress.doc.M[a].U){if(CanvasXpress.doc.M[a].U.hasOwnProperty(this.graphType)){if(this.showAdvancedConfiguration){e.push(d)}else{if(!CanvasXpress.doc.P[d].A){e.push(d)}}}}else{if(this.showAdvancedConfiguration){if(b){if(b.hasOwnProperty(this.graphType)){e.push(d)}}else{e.push(d)}}else{if(!CanvasXpress.doc.P[d].A){if(b){if(b.hasOwnProperty(this.graphType)){e.push(d)}else{e.push(d)}}}}}}return e};this.getConfigurableObjectDoc=function(a){if(this.configuringNetwork){if(this.data.nodes.length>this.configuringNetwork){return CanvasXpress.doc.N[a]?CanvasXpress.doc.N[a]:false}else{return CanvasXpress.doc.E[a]?CanvasXpress.doc.E[a]:false}}else{if(this.configuringGenome){if(!isNaN(this.configuringGenome)||this.configuringGenome.match(/:/)){return CanvasXpress.doc.F[a]?CanvasXpress.doc.F[a]:false}else{if(this.configuringGenome.match(/track/)){return CanvasXpress.doc.G[a]?CanvasXpress.doc.G[a]:false}else{this.configuringGenome=false;return CanvasXpress.doc.P[a]?CanvasXpress.doc.P[a]:false}}}else{return CanvasXpress.doc.P[a]?CanvasXpress.doc.P[a]:false}}};this.selectConfig=function(D,F){var z=document.getElementById(this.target+"canvasXpressConfiguratorKey");var q=document.getElementById(this.target+"canvasXpressConfiguratorSugestionsText");var n=document.getElementById(this.target+"canvasXpressConfiguratorSugestions");var E=document.getElementById(this.target+"canvasXpressConfiguratorSugestionsDescription");var l=document.getElementById(this.target+"canvasXpressConfiguratorValueText");var H=document.getElementById(this.target+"canvasXpressConfiguratorSeeAlso");var j=document.getElementById(this.target+"canvasXpressConfiguratorValue");var f=document.getElementById(this.target+"canvasXpressConfiguratorApply");var G=document.getElementById(this.target+"canvasXpressConfiguratorButton");var B=document.getElementById(this.target+"canvasXpressConfiguratorValueHREF");var m=document.activeElement;var y=this.getConfigurableProperties();var w=[];this.resetHelpOptionColors();if(this.getKeyCode(D)==13){if(this.editingDescriptionOn){this.submitEditPropertyDescription()}else{if(n&&j&&j.value){var g=false;for(var A=0;A<y.length;A++){if(n.value==y[A]){g=true;break}}if(g){this.clickConfigurator(D,n,j)}else{this.resetConfigurator()}}}}else{if(m.id==z.id||F){this.resetEditPropertyDescription();for(var A=0;A<y.length;A++){if(y[A].toLowerCase().indexOf(z.value.toLowerCase())>=0){w.push(y[A])}}if(w.length>0&&q&&n&&E&&l&&H&&j&&G&&f){this.resetSugestions();if(!this.configuringNetwork&&!this.configuringGenome){w.sort(function(e,d){return CanvasXpress.doc.P[e].M>CanvasXpress.doc.P[d].M?1:CanvasXpress.doc.P[d].M>CanvasXpress.doc.P[e].M?-1:e>d?1:d>e?-1:0});for(var A=0;A<w.length;A++){var y=document.createElement("option");y.text=CanvasXpress.doc.P[w[A]].M?CanvasXpress.doc.P[w[A]].M+" : "+w[A]:"NA : "+w[A];y.value=w[A];try{n.add(y,null)}catch(C){n.add(y)}}}else{w.sort();for(var A=0;A<w.length;A++){var y=document.createElement("option");y.text=w[A];y.value=w[A];try{n.add(y,null)}catch(C){n.add(y)}}}n.options[0].selected=true;this.setConfiguratorPropertyValue(n,E,l,H,j);q.innerHTML="Select property ("+w.length+")";q.style.display="block";n.style.display="block";E.style.display="block";l.style.display="block";H.style.display="block";j.style.display="block";G.style.display="block";f.style.display="block"}else{z.value=z.value.slice(0,z.value.length-1)}}else{if(m.id==j.id){this.resetEditPropertyDescription();if(B&&B.innerHTML=="color"){B.style.color=j.value?this.rgbToHex(this.validateColor(j.value.replace(/[\'\"]/g,""))):this.foreground}}}}return false};this.clickHelp=function(a){return function(d){if(!d){d=window.event}var b=document.getElementById(a.target+"canvasXpressConfiguratorHelp");a.resetHelpEditOptionColors();if(b){a.addHelp(b);b.style.display="block";b.style.left=d.layerX+"px";b.style.top=d.layerY+"px"}return false}}(this);this.addHelp=function(n){if(!this.helpOn){var j=document.createElement("div");j.style.width=this.configuratorWidth+"px";j.style.fontWeight="normal";j.appendChild(document.createElement("br"));var q=document.createElement("p");q.innerHTML="This widget allows you to customize this graph. You may enter the name of the property you wish to customize in the text box (which filters as you type) or browse through a number of categories.";j.appendChild(q);var o=document.createElement("p");o.innerHTML="You will find a short description for the property you select along with its category and links to other relevant properties.";j.appendChild(o);var m=document.createElement("p");m.innerHTML="You will also see the current value for the seleced property along with a link to an additional widget to help you specifying the new value.";j.appendChild(m);var e=document.createElement("img");e.src=this.imageDir+"help1.png";j.appendChild(e);j.appendChild(document.createTextNode(" Show help on this configurator"));j.appendChild(document.createElement("br"));var b=document.createElement("img");b.src=this.imageDir+"disk.png";j.appendChild(b);j.appendChild(document.createTextNode(" Save the image as a 'png' file"));j.appendChild(document.createElement("br"));var f=document.createElement("img");f.src=this.imageDir+"table.png";j.appendChild(f);j.appendChild(document.createTextNode(" Show the data used for this visualization"));j.appendChild(document.createElement("br"));var l=document.createElement("img");l.src=this.imageDir+"lightbulb.png";j.appendChild(l);j.appendChild(document.createTextNode(" Show or hide advanced customizations"));j.appendChild(document.createElement("br"));var r=document.createElement("img");r.src=this.imageDir+"find.png";j.appendChild(r);j.appendChild(document.createTextNode(" Search by categories of the customization"));j.appendChild(document.createElement("br"));var g=document.createElement("img");g.src=this.imageDir+"cancel1.png";j.appendChild(g);j.appendChild(document.createTextNode(" Hide the help on this configurator"));j.appendChild(document.createElement("br"));j.appendChild(document.createElement("br"));var k=document.createElement("a");k.href="http://canvasxpress.org";k.target="_blank";k.innerHTML="canvasXpress";j.appendChild(document.createTextNode("Additional documentation at "));j.appendChild(k);j.appendChild(document.createElement("br"));n.appendChild(j);this.helpOn=true}};this.closeHelp=function(a){return function(b){if(!b){b=window.event}a.handleHideDiv(a.target+"canvasXpressConfiguratorHelp")}}(this);this.clickDataTable=function(a){return function(b){if(!b){b=window.event}a.resetConfigurator();a.updateDataTable();return false}}(this);this.clickSearch=function(a){return function(I){if(!I){I=window.event}a.configuringNetwork=false;a.configuringGenome=false;a.resetHelpEditOptionColors();var G=document.getElementById(a.target+"canvasXpressConfiguratorKeyTextSpan");var E=document.getElementById(a.target+"canvasXpressConfiguratorKey");var C=document.getElementById(a.target+"canvasXpressConfiguratorCategories");var y=document.getElementById(a.target+"canvasXpressConfiguratorSugestionsText");var x=document.getElementById(a.target+"canvasXpressConfiguratorSugestions");var J=document.getElementById(a.target+"canvasXpressConfiguratorSugestionsDescription");var t=document.getElementById(a.target+"canvasXpressConfiguratorValueText");var L=document.getElementById(a.target+"canvasXpressConfiguratorSeeAlso");var q=document.getElementById(a.target+"canvasXpressConfiguratorValue");var K=document.getElementById(a.target+"canvasXpressConfiguratorButton");var f=document.getElementById(a.target+"canvasXpressConfiguratorApply");var h=document.getElementById(a.target+"canvasXpressConfiguratorOptions");var j=document.getElementById(a.target+"canvasXpressConfiguratorHelp");var B=document.getElementById(a.target+"canvasXpressConfiguratorColor");var D=a.getKeys(CanvasXpress.doc.M).sort();var p=[];if(E&&E.style.display=="none"){if(G){G.innerText="Enter property name or function"}if(C){C.style.display="none"}E.value="";E.style.display="block"}else{if(G){for(var F=0;F<D.length;F++){if(CanvasXpress.doc.M[D[F]].U){if(CanvasXpress.doc.M[D[F]].U.hasOwnProperty(a.graphType)){if(a.showAdvancedConfiguration){p.push(D[F])}else{if(CanvasXpress.doc.M[D[F]].B){p.push(D[F])}}}}else{if(a.showAdvancedConfiguration){p.push(D[F])}else{if(CanvasXpress.doc.M[D[F]].B){p.push(D[F])}}}G.innerText="Select category ("+p.length+")"}}if(E){E.style.display="none"}if(C){a.resetCategories();for(var F=0;F<p.length;F++){var A=document.createElement("option");A.text=p[F];A.value=p[F];try{C.add(A,null)}catch(H){C.add(A)}}C.style.display="block"}}if(y&&x&&J&&t&&L&&q&&K&&f&&h&&j&&B){y.style.display="none";x.style.display="none";J.style.display="none";t.style.display="none";L.style.display="none";q.style.display="none";K.style.display="none";f.style.display="none";h.style.display="none";j.style.display="none";B.style.dysplay="none"}return false}}(this);this.clickAdvanced=function(a){return function(f){if(!f){f=window.event}var b=document.getElementById(a.target+"canvasXpressConfiguratorKey");var d=document.getElementById(a.target+"canvasXpressConfiguratorKeyAdvanced");if(d){if(a.showAdvancedConfiguration){a.showAdvancedConfiguration=false;d.src=a.imageDir+"lightbulb_off.png";d.alt="Show advanced configuaration properties";d.title="Show advanced configuaration properties"}else{a.showAdvancedConfiguration=true;d.src=a.imageDir+"lightbulb.png";d.alt="Show basic configuaration properties";d.title="Show basic configuaration properties"}if(b&&b.style.display=="none"){b.value="";b.style.display="block";a.clickSearch()}else{a.resetHelpEditOptionColors();a.resetEditPropertyDescription();a.resetPropertySeeAlsoLinks();a.selectConfig(false,true)}}return false}}(this);this.closeConfigurator=function(a){return function(b){if(!b){b=window.event}a.resetConfigurator();return false}}(this);this.changeCategory=function(a){return function(H,E){if(!H){H=window.event}a.resetHelpEditOptionColors();var D=document.getElementById(a.target+"canvasXpressConfiguratorCategories");var y=document.getElementById(a.target+"canvasXpressConfiguratorSugestionsText");var t=document.getElementById(a.target+"canvasXpressConfiguratorSugestions");var I=document.getElementById(a.target+"canvasXpressConfiguratorSugestionsDescription");var q=document.getElementById(a.target+"canvasXpressConfiguratorValueText");var K=document.getElementById(a.target+"canvasXpressConfiguratorSeeAlso");var l=document.getElementById(a.target+"canvasXpressConfiguratorValue");var f=document.getElementById(a.target+"canvasXpressConfiguratorApply");var J=document.getElementById(a.target+"canvasXpressConfiguratorButton");var g=document.getElementById(a.target+"canvasXpressConfiguratorOptions");var k=document.getElementById(a.target+"canvasXpressConfiguratorHelp");var C=document.getElementById(a.target+"canvasXpressConfiguratorColor");var h=CanvasXpress.doc.M;if(D&&D.value&&y&&t&&I&&q&&K&&l&&J&&g&&k&&C){var A=a.showAdvancedConfiguration?h[D.value].P.sort():h[D.value].B.sort();a.resetSugestions();for(var F=0;F<A.length;F++){var B=document.createElement("option");B.text=A[F];B.value=A[F];try{t.add(B,null)}catch(G){t.add(B)}}t.options[E||0].selected=true;y.innerHTML="Select property ("+A.length+")";a.setConfiguratorPropertyValue(t,I,q,K,l);y.style.display="block";t.style.display="block";I.style.display="block";q.style.display="block";K.style.display="block";l.style.display="block";f.style.display="block";J.style.display="block";g.style.display="none";k.style.display="none";C.style.display="none"}return false}}(this);this.resetCategories=function(){var a=document.getElementById(this.target+"canvasXpressConfiguratorCategories");if(a){if(a.hasChildNodes()){while(a.childNodes.length>=1){a.removeChild(a.firstChild)}}a.style.display="none"}};this.clickSuggestions=function(a){return function(b){if(!b){b=window.event}a.resetHelpEditOptionColors();a.setConfiguratorPropertyValue();return false}}(this);this.setConfiguratorPropertyValue=function(m,f,k,h,j){if(!m){m=document.getElementById(this.target+"canvasXpressConfiguratorSugestions")}if(!f){f=document.getElementById(this.target+"canvasXpressConfiguratorSugestionsDescription")}if(!k){k=document.getElementById(this.target+"canvasXpressConfiguratorValueText")}if(!h){h=document.getElementById(this.target+"canvasXpressConfiguratorSeeAlso")}if(!j){j=document.getElementById(this.target+"canvasXpressConfiguratorValue")}var l;var g=document.getElementById(this.target+"canvasXpressConfiguratorOptions");var e=this.getConfigurableObjectDoc(m.value);j.value="";j.style.readonly=false;if(this.configuringNetwork){if(typeof(this[m.value])=="function"){j.style.disabled="disabled";j.style.readonly=false}else{if(this.configuringNetwork<this.data.nodes.length){l=this.data.nodes[this.configuringNetwork][m.value]}else{l=this.data.edges[this.configuringNetwork-this.data.nodes.length][m.value]}}}else{if(this.configuringGenome){var b=this.subtracksInfo;if(!isNaN(this.configuringGenome)){l=this.data.tracks[b[this.configuringGenome].track].data[b[this.configuringGenome].index][m.value]}else{if(this.configuringGenome.match(/:/)){l=parseInt(this.configuringGenome.split(":")[1]);l=this.data.tracks[b[l].track].data[b[l].index][m.value]}else{l=parseInt(this.configuringGenome.replace("track-",""));l=this.data.tracks[b[l].track][m.value]}}}else{if(typeof(this[m.value])=="function"){k.innerHTML="Current&nbsp;value&nbsp;[&nbsp;<i>function</i>&nbsp;]&nbsp;"+this[m.value].length+"&nbsp;parameter(s)";if(this[m.value].length==0){j.style.disabled="disabled";j.style.readonly=false}}else{l=this[m.value]}}}j.value=l?JSON.stringify(l):"";this.addPropertyDescription(f,e);this.addPropertySeeAlsoLinks(h,e);this.addPropertyOptions(k,g,e,m.value,l)};this.resetSugestions=function(){var a=document.getElementById(this.target+"canvasXpressConfiguratorSugestions");if(a){if(a.hasChildNodes()){while(a.childNodes.length>=1){a.removeChild(a.firstChild)}}a.style.display="none"}};this.addPropertyDescription=function(l,k){var n=k&&k.C?k.C:"";var f=k&&k.M?k.M:"";this.resetPropertyDescription(l);var j=document.createElement("img");j.id=this.target+"canvasXpressConfiguratorSugestionsDescriptionEdit";j.src=this.imageDir+"pencil.png";j.style.margin="2px";j.style.width="10px";j.style.height="10px";j.alt="Edit description";j.title="Edit description";var h=document.createElement("span");h.id=this.target+"canvasXpressConfiguratorSugestionsDescriptionEditSpan";h.innerHTML=n;var g=document.createElement("i");g.innerHTML=f;var a=document.createElement("b");a.appendChild(document.createTextNode("Description [ "));a.appendChild(g);a.appendChild(document.createTextNode(" ]"));l.appendChild(a);l.appendChild(document.createElement("br"));l.appendChild(h);l.appendChild(j);this.addEvtListener(j,"click",this.clickEditPropertyDescription,false)};this.resetPropertyDescription=function(b,a){if(!b){b=document.getElementById(this.target+"canvasXpressConfiguratorSugestionsDescription")}if(!a){a=document.getElementById(this.target+"canvasXpressConfiguratorSugestionsDescriptionEdit")}if(b&&a){this.removeEvtListener(a,"click",this.clickEditPropertyDescription,false);while(b.childNodes.length>0){var f=b.childNodes[0];b.removeChild(f)}}};this.clickEditPropertyDescription=function(a){return function(h){if(!h){h=window.event}a.resetPropertyColor();var f=document.getElementById(a.target+"canvasXpressConfigurator");var g=document.getElementById(a.target+"canvasXpressConfiguratorSugestions");var u=document.getElementById(a.target+"canvasXpressConfiguratorSugestionsDescriptionEditSpan");var m=document.getElementById(a.target+"canvasXpressConfiguratorOptions");if(f&&g&&u&&m){m.style.display="none";var t=a.adjustedCoordinates(h,g);if(t){a.editingDescriptionOn=true;var r=t.x;var o=t.y;var j=document.createElement("div");j.id=a.target+"canvasXpressConfiguratorEditForm";j.className="draggable";j.style.cursor="move";j.style.left=r+"px";j.style.top=o+"px";j.style.padding="10px";j.style.color=a.skinColor;j.style.border="1px solid "+a.skinBorderColor;j.style.backgroundColor=a.skinBackgroundColor;j.style.boxShadow="2px 2px 2px "+a.skinShadowColor;j.style.MozBoxShadow="2px 2px 2px "+a.skinShadowColor;j.style.borderRadius="8px";j.style.position="absolute";j.style.zIndex=20000;j.style.fontWeight="bold";var l=document.createElement("img");l.id=a.target+"canvasXpressConfiguratorEditFormClose";l.style.cursor="default";l.src=a.imageDir+"cancel1.png";l.alt="Close";l.title="Close";l.style.margin="2px";l.style.cssFloat="right";var q=document.createElement("textarea");q.id=a.target+"canvasXpressConfiguratorEditFormValue";q.style.cursor="default";q.style.margin="5px";q.cols=30;q.rows=10;q.value=u.innerHTML;var n=document.createElement("input");n.id=a.target+"canvasXpressConfiguratorEditFormButton";n.value="Submit";n.type="button";n.style.cursor="default";n.style.margin="5px";n.style.width="100%";n.style.borderRadius="4px";n.style.MozBorderRadius="4px";j.appendChild(document.createTextNode("Editing "+g.value));j.appendChild(l);j.appendChild(document.createElement("br"));j.appendChild(q);j.appendChild(n);a.addEvtListener(l,"click",a.closeEditPropertyDescription,false);a.addEvtListener(n,"click",a.submitEditPropertyDescription,false);f.appendChild(j)}}}}(this);this.submitEditPropertyDescription=function(a){return function(g){if(!g){g=window.event}var d=document.getElementById(a.target+"canvasXpressConfiguratorSugestions");var b=document.getElementById(a.target+"canvasXpressConfiguratorEditFormValue");var f=document.getElementById(a.target+"canvasXpressConfiguratorSugestionsDescriptionEditSpan");if(d&&b&&f){b.value=b.value.replace(/\n/g,"");CanvasXpress.doc.P[d.value].C=b.value;f.innerHTML=b.value;alert("New description for:\n - "+d.value+" -\nwas submitted and may apppear\nin new versions of CanvasXpress\nThank you for your contribution")}a.resetEditPropertyDescription()}}(this);this.closeEditPropertyDescription=function(a){return function(b){if(!b){b=window.event}a.resetEditPropertyDescription()}}(this);this.resetEditPropertyDescription=function(){var e=document.getElementById(this.target+"canvasXpressConfiguratorEditForm");var f=document.getElementById(this.target+"canvasXpressConfiguratorEditFormClose");var a=document.getElementById(this.target+"canvasXpressConfiguratorEditFormButton");if(e&&f&&a){this.addEvtListener(f,"click",this.closeEditPropertyDescription,false);this.addEvtListener(a,"click",this.submitEditPropertyDescription,false);e.parentNode.removeChild(e)}this.editingDescriptionOn=false};this.addPropertySeeAlsoLinks=function(e,g){this.resetPropertySeeAlsoLinks(e);var d=document.createElement("b");d.appendChild(document.createTextNode("See Also: "));e.appendChild(d);if(g&&g.S){for(var f=0;f<g.S.length;f++){var h=document.createElement("a");h.href="javascript:void(0)";h.innerHTML=g.S[f];this.addEvtListener(h,"click",this.clickPropertySeeAlsoLinks,false);e.appendChild(h);if(f<g.S.length-1){e.appendChild(document.createTextNode(", "))}}}};this.clickPropertySeeAlsoLinks=function(a){return function(j){if(!j){j=window.event}var g=document.getElementById(a.target+"canvasXpressConfiguratorKey");var b=document.getElementById(a.target+"canvasXpressConfiguratorCategories");var h=document.getElementById(a.target+"canvasXpressConfiguratorSugestions");var f=j.target||j.srcElement;if(b&&b.style.display=="block"){var n=CanvasXpress.doc.P[f.innerHTML];var l=CanvasXpress.doc.M[n.M].P.sort();b.value=n.M;for(i=0;i<l.length;i++){if(l[i]==f.innerHTML){a.changeCategory(j,i);return false}}a.changeCategory(j)}else{if(g){g.value=f.innerHTML;a.selectConfig(j,true)}}return false}}(this);this.resetPropertySeeAlsoLinks=function(b){if(!b){b=document.getElementById(this.target+"canvasXpressConfiguratorSeeAlso")}if(b&&b.childNodes){while(b.childNodes.length>0){var d=b.childNodes[0];if(d.nodeName.toLowerCase()=="a"){this.removeEvtListener(d,"click",this.clickPropertySeeAlsoLinks,false)}b.removeChild(d)}}};this.addPropertyOptions=function(w,p,f,g,s){this.resetPropertyOptions(w,p);var q=document.createElement("b");var l=document.createElement("i");q.appendChild(document.createTextNode("Current value"));if(f&&f.T&&(f.T=="option"||f.T=="array"||f.T=="boolean")){var x=document.createElement("div");x.id=this.target+"canvasXpressConfiguratorOptionsContainer";x.style.height='expression(this.scrollHeight > 99 ? "100px" : "auto")';x.style.maxHeight="100px";x.style.overflow="auto";x.style.cursor="default";x.style.width="180px";x.style.marginTop="8px";x.style.fontWeight="normal";var r=document.createElement("a");r.href="javascript:void(0)";r.innerHTML=f.T;this.addEvtListener(r,"click",this.clickPropertyOptions,false);q.appendChild(document.createTextNode(" ["));l.appendChild(r);q.appendChild(document.createTextNode(" "));q.appendChild(l);q.appendChild(document.createTextNode(" ]"));if(f.T=="array"){var n=f.X?this[f.X]():f.O?f.O:[];var m=this.getObjectArray(s);if(n.length>0){for(var h=0;h<n.length;h++){var g=document.createElement("input");g.type="checkbox";g.value=n[h];g.checked=m.hasOwnProperty(n[h])?true:false;g.style.marginLeft="0px";this.addEvtListener(g,"change",this.updatePropertyValue,false);x.appendChild(document.createTextNode((h+1)+". "));x.appendChild(g);x.appendChild(document.createTextNode(n[h]));x.appendChild(document.createElement("br"))}}else{x.appendChild(document.createElement("br"));x.appendChild(document.createTextNode("This array is user defined"));x.appendChild(document.createElement("br"))}}else{var n=f.T=="boolean"?["true","false"]:f.X?this[f.X]():f.O?f.O:[];if(f.X&&f.O){n=n.concat(f.O)}for(var h=0;h<n.length;h++){var g=document.createElement("a");g.href="javascript:void(0)";g.innerHTML=n[h];g.style.padding="2px";this.addEvtListener(g,"click",this.updatePropertyValue,false);x.appendChild(document.createTextNode((h+1)+". "));x.appendChild(g);x.appendChild(document.createElement("br"))}}p.appendChild(x)}else{if(f&&f.T){q.appendChild(document.createTextNode(" ["));if(f.T=="color"){var n;if(this.configuringNetwork){if(this.configuringNetwork<this.data.nodes.length){n=this.data.nodes[this.configuringNetwork][g]}else{n=this.data.edges[this.configuringNetwork-this.data.nodes.length][g]}}else{if(this.configuringGenome){var e=this.subtracksInfo;if(!isNaN(this.configuringGenome)){n=this.data.tracks[e[this.configuringGenome].track].data[e[this.configuringGenome].index]}else{if(this.configuringGenome.match(/:/)){n=parseInt(this.configuringGenome.split(":")[1]);n=this.data.tracks[e[n].track].data[e[n].index]}else{n=parseInt(this.configuringGenome.replace("track-",""));n=this.data.tracks[e[n].track]}}}else{n=this[g]}}var r=document.createElement("a");r.id=this.target+"canvasXpressConfiguratorValueHREF";r.href="javascript:void(0)";r.innerHTML=f.T;r.style.color=n?this.rgbToHex(this.validateColor(n)):this.foreground;this.addEvtListener(r,"click",this.addPropertyColor,false);l.appendChild(r)}else{l.appendChild(document.createTextNode(f.T))}q.appendChild(document.createTextNode(" "));q.appendChild(l);q.appendChild(document.createTextNode(" ]"))}}w.appendChild(q)};this.clickPropertyOptions=function(a){return function(b){if(!b){b=window.event}a.resetEditPropertyDescription();var d=document.getElementById(a.target+"canvasXpressConfiguratorOptions");if(d){d.style.display="block";d.style.left=b.layerX+"px";d.style.top=b.layerY+"px"}return false}}(this);this.closePropertyOptions=function(a){return function(b){if(!b){b=window.event}a.handleHideDiv(a.target+"canvasXpressConfiguratorOptions")}}(this);this.resetPropertyOptions=function(a,e,b){if(!a){a=document.getElementById(this.target+"canvasXpressConfiguratorValueText")}if(!e){e=document.getElementById(this.target+"canvasXpressConfiguratorOptions")}if(a&&a.childNodes&&!b){while(a.childNodes.length>0){var f=a.childNodes[0];if(f.nodeName.toLowerCase()=="a"){this.removeEvtListener(f,"click",this.clickPropertyOptions,false)}a.removeChild(f)}}if(e){var d=document.getElementById(this.target+"canvasXpressConfiguratorOptionsContainer");if(d){while(d.childNodes.length>0){var f=d.childNodes[0];if(f.nodeName.toLowerCase()=="a"){this.removeEvtListener(f,"click",this.updatePropertyValue,false)}else{if(f.nodeName.toLowerCase()=="input"&&f.type=="checkbox"){this.removeEvtListener(f,"change",this.updatePropertyValue,false)}}d.removeChild(f)}e.removeChild(d)}e.style.display="none"}};this.addPropertyColor=function(a){return function(j){if(!j){j=window.event}a.resetEditPropertyDescription();var d=document.getElementById(a.target+"canvasXpressConfiguratorColor");var t=document.getElementById(a.target+"canvasXpressConfiguratorValue");if(d&&t){var g=t.value?a.rgbToHex(a.validateColor(t.value.replace(/[\'\"]/g,""))):a.foreground;a.colorRGBfromString(g);var r=Math.round(a.colorHSV[0]/6*180);var q=Math.round((1-a.colorHSV[1])*100);var m=Math.round((1-a.colorHSV[2])*100);var l=document.createElement("div");l.id=a.target+"canvasXpressConfiguratorColorContainer";l.style.width="210px";l.style.height="101px";l.style.marginTop="7px";var b=document.createElement("div");b.id=a.target+"canvasXpressConfiguratorColorPalette";b.style.position="relative";b.style.left="0px";b.style.top="0px";b.style.width="181px";b.style.height="101px";b.style.backgroundImage="url('"+a.imageDir+"color.png')";b.style.backgroundRepeat="no-repeat";b.style.border="1px solid "+a.skinBorderColor;b.style.cursor="crosshair";var o=document.createElement("div");o.id=a.target+"canvasXpressConfiguratorColorPaletteCurrent";o.style.position="relative";o.style.left=(r-7)+"px";o.style.top=(q-7)+"px";o.style.width="195px";o.style.height="115px";o.style.cursor="crosshair";o.style.backgroundImage="url('"+a.imageDir+"cross.gif')";o.style.backgroundRepeat="no-repeat";b.appendChild(o);var w=document.createElement("div");w.id=a.target+"canvasXpressConfiguratorColorSaturation";w.style.position="relative";w.style.left="188px";w.style.top="-102px";w.style.width="15px";w.style.height="100px";w.style.border="1px solid "+a.skinBorderColor;w.style.cursor="crosshair";for(var f=0;f<100;f+=4){var u=document.createElement("div");u.style.height="4px";u.style.position="relative";u.style.left="0px";u.style.cursor="crosshair";w.appendChild(u)}var k=document.createElement("div");k.id=a.target+"canvasXpressConfiguratorColorSaturationCurrent";k.style.position="relative";k.style.left="0px";k.style.top=(m-108)+"px";k.style.width="29px";k.style.height="115px";k.style.cursor="crosshair";k.style.backgroundImage="url('"+a.imageDir+"cross.gif')";k.style.backgroundRepeat="no-repeat";k.style.overflow="hidden";w.appendChild(k);l.appendChild(b);l.appendChild(w);d.appendChild(l);a.colorizeSaturationColorDiv();a.addEvtListener(b,"mousedown",a.registerPalette,false);a.addEvtListener(w,"mousedown",a.registerSaturation,false);d.style.display="block";d.style.left=j.layerX+"px";d.style.top=j.layerY+"px"}return false}}(this);this.registerPalette=function(a){return function(b){if(!b){b=window.event}a.changingColorOn="palette";if(a.colorHSV[2]==0){a.colorFromHsv(null,null,1);var d=document.getElementById(a.target+"canvasXpressConfiguratorColorSaturationCurrent");if(d){d.style.top="-108px"}}a.updateColorValue(b);a.colorizeSaturationColorDiv();return false}}(this);this.registerSaturation=function(a){return function(b){if(!b){b=window.event}a.changingColorOn="saturation";a.updateColorValue(b);return false}}(this);this.updateColorValue=function(h){if(this.changingColorOn){if(this.changingColorOn=="palette"){var g=document.getElementById(this.target+"canvasXpressConfiguratorColorPalette");var b=document.getElementById(this.target+"canvasXpressConfiguratorColorPaletteCurrent");if(g&&b){var f=this.adjustedCoordinates(h,g);if(f){var a=Math.min(Math.max(0,f.x),181);var k=Math.min(Math.max(0,f.y),101);b.style.left=(a-7)+"px";b.style.top=(k-7)+"px";this.colorFromHsv(a*6/180,1-k/100,null);this.colorizeSaturationColorDiv()}}}else{var d=document.getElementById(this.target+"canvasXpressConfiguratorColorSaturation");var j=document.getElementById(this.target+"canvasXpressConfiguratorColorSaturationCurrent");if(d&&j){var f=this.adjustedCoordinates(h,d);if(f){var k=Math.min(Math.max(0,f.y),101);j.style.top=(k-108)+"px";this.colorFromHsv(null,null,1-k/100)}}}}};this.colorFromHsv=function(d,b,a){if(d!=null){this.colorHSV[0]=Math.min(Math.max(0,d),6)}if(b!=null){this.colorHSV[1]=Math.min(Math.max(0,b),1)}if(a!=null){this.colorHSV[2]=Math.min(Math.max(0,a),1)}this.colorRGB=this.hsvFromRgb(this.colorHSV[0],this.colorHSV[1],this.colorHSV[2]);this.colorizeCurrentColorDiv()};this.hsvFromRgb=function(g,e,b){if(g==null){return[b,b,b]}var d=Math.floor(g);var j=d%2?g-d:1-(g-d);var a=b*(1-e);var k=b*(1-e*j);switch(d){case 0:return[b,k,a];case 1:return[k,b,a];case 2:return[a,b,k];case 3:return[a,k,b];case 4:return[k,a,b];case 5:return[b,a,k];case 6:}};this.colorFromRgb=function(f,e,a){if(f!=null){this.colorRGB[0]=Math.min(Math.max(0,f),1)}if(e!=null){this.colorRGB[1]=Math.min(Math.max(0,e),1)}if(a!=null){this.colorRGB[2]=Math.min(Math.max(0,a),1)}var d=this.rgbFromHsv(this.colorRGB[0],this.colorRGB[1],this.colorRGB[2]);if(d[0]!=null){this.colorHSV[0]=d[0]}if(d[2]!=0){this.colorHSV[1]=d[1]}this.colorHSV[2]=d[2];this.colorizeCurrentColorDiv()};this.rgbFromHsv=function(k,j,d){var l=Math.min(Math.min(k,j),d);var e=Math.max(Math.max(k,j),d);var a=e-l;if(a==0){return[null,0,e]}else{var f=k==l?3+(d-j)/a:(j==l?5+(k-d)/a:1+(j-k)/a);return[f==6?0:f,a/e,e]}};this.colorRGBToString=function(){return(256|Math.round(255*this.colorRGB[0])).toString(16).substr(1)+(256|Math.round(255*this.colorRGB[1])).toString(16).substr(1)+(256|Math.round(255*this.colorRGB[2])).toString(16).substr(1)};this.colorRGBfromString=function(b){var a=b.match(/^\W*([0-9A-F]{3}([0-9A-F]{3})?)\W*$/i);if(!a){return false}else{if(a[1].length===6){this.colorFromRgb(parseInt(a[1].substr(0,2),16)/255,parseInt(a[1].substr(2,2),16)/255,parseInt(a[1].substr(4,2),16)/255)}else{this.colorFromRgb(parseInt(a[1].charAt(0)+a[1].charAt(0),16)/255,parseInt(a[1].charAt(1)+a[1].charAt(1),16)/255,parseInt(a[1].charAt(2)+a[1].charAt(2),16)/255)}return true}};this.colorizeCurrentColorDiv=function(){var f=document.getElementById(this.target+"canvasXpressConfiguratorColorCurrent");var a=document.getElementById(this.target+"canvasXpressConfiguratorValue");var d=document.getElementById(this.target+"canvasXpressConfiguratorValueHREF");if(f&&a&&d){var e=this.colorRGBToString();var b=this.hexToRgb("#"+e);f.style.backgroundColor="#"+e;f.innerHTML="&nbsp;&nbsp;"+b;a.value='"'+b+'"';d.style.color="#"+e}};this.colorizeSaturationColorDiv=function(){var b=function(n,m,h,k,j){return"rgb("+(n*(1-k/j)*100)+"%,"+(m*(1-k/j)*100)+"%,"+(h*(1-k/j)*100)+"%)"};var e=document.getElementById(this.target+"canvasXpressConfiguratorColorSaturation");if(e){var f=e.childNodes;var a=this.hsvFromRgb(this.colorHSV[0],this.colorHSV[1],1);for(var d=0;d<f.length-1;d++){f[d].style.backgroundColor=b(a[0],a[1],a[2],d,f.length-1)}}};this.endColorChange=function(a){this.changingColorOn=false};this.closePropertyColor=function(a){return function(b){if(!b){b=window.event}a.handleHideDiv(a.target+"canvasXpressConfiguratorColor");a.resetPropertyColor()}}(this);this.resetPropertyColor=function(){var d=document.getElementById(this.target+"canvasXpressConfiguratorColor");var b=document.getElementById(this.target+"canvasXpressConfiguratorColorPalette");var a=document.getElementById(this.target+"canvasXpressConfiguratorColorSaturation");if(d&&b&&a){if(d&&d.childNodes){while(d.childNodes.length>3){d.removeChild(d.childNodes[3])}this.addEvtListener(b,"mousedown",this.registerPalette,false);this.addEvtListener(a,"mousedown",this.registerSaturation,false)}d.style.display="none"}};this.updatePropertyValue=function(a){return function(h){if(!h){h=window.event}a.resetEditPropertyDescription();var f=document.getElementById(a.target+"canvasXpressConfiguratorValue");var j=document.getElementById(a.target+"canvasXpressConfiguratorOptions");var d=h.target||h.srcElement;if(d.nodeName.toLowerCase()=="input"){var b=[];for(var g=0;g<d.parentNode.childNodes.length;g++){var k=d.parentNode.childNodes[g];if(k.checked){b.push(k.value)}}f.value=b.length>0?'["'+b.join('", "')+'"]':"[]"}else{if(f&&j){if(d.innerHTML=="true"){f.value=d.innerHTML}else{if(d.innerHTML=="false"){f.value=d.innerHTML}else{if(d.innerHTML=="null"){f.value=d.innerHTML}else{f.value='"'+d.innerHTML+'"'}}}j.style.display="none"}}return false}}(this);this.clickApplyConfigurator=function(a){return function(b){return a.clickConfigurator(b,false,false,true)}}(this);this.clickConfigurator=function(a){return function(h,g,d,b){if(!h){h=window.event}if(!g){g=document.getElementById(a.target+"canvasXpressConfiguratorSugestions")}if(!d){d=document.getElementById(a.target+"canvasXpressConfiguratorValue")}if(g&&d){if(a.configuringNetwork){if(a.configuringNetwork<a.data.nodes.length){if(typeof(a[g.value])=="function"){a[g.value](a.data.nodes[a.configuringNetwork])}else{a.data.nodes[a.configuringNetwork][g.value]=JSON.parse(d.value)}}else{if(typeof(a[g.value])=="function"){a[g.value](a.data.edges[a.configuringNetwork-a.data.nodes.length])}else{a.data.edges[a.configuringNetwork-a.data.nodes.length][g.value]=JSON.parse(d.value)}}}else{if(a.configuringGenome){var f=a.subtracksInfo;if(!isNaN(a.configuringGenome)){a.data.tracks[f[a.configuringGenome].track].data[f[a.configuringGenome].index][g.value]=JSON.parse(d.value)}else{if(a.configuringGenome.match(/:/)){var j=parseInt(a.configuringGenome.split(":")[1]);a.data.tracks[f[j].track].data[f[j].index][g.value]=JSON.parse(d.value)}else{var j=parseInt(a.configuringGenome.replace("track-",""));a.data.tracks[f[c].track][g.value]=JSON.parse(d.value)}}}else{if(typeof(a[g.value])=="function"){if(a[g.value].length>0&&d&&d.value){var b=JSON.parse(d.value);a[g.value](b)}else{a[g.value]()}a.resetConfigurator();return false}else{a[g.value]=JSON.parse(d.value);a.userConfig[g.value]=a[g.value]}}}if(!b){a.resetConfigurator()}a.draw()}return false}}(this);this.handleHideDiv=function(a){var b=document.getElementById(a);if(b){b.style.display="none"}return false};this.resetHelpOptionColors=function(){this.closeHelp();this.resetPropertyOptions(false,false,true);this.resetPropertyColor()};this.resetHelpEditOptionColors=function(){this.closeHelp();this.resetEditPropertyDescription();this.resetPropertyOptions(false,false,true);this.resetPropertyColor()};this.resetConfigurator=function(){var a=document.getElementById(this.target+"canvasXpressImage");if(a){a.style.zIndex=9000;this.helpOn=false;this.configuringOn=false;this.configuringNetwork=false;this.configuringGenome=false;this.editingDescriptionOn=false}this.resetHelpEditOptionColors();this.resetPropertyDescription();this.resetPropertySeeAlsoLinks();this.addRemoveConfiguratorListeners("removeEvtListener");this.removeTarget(this.target+"canvasXpressConfigurator")}};CanvasXpress.prototype.initCodeInfo=function(){this.addInfoCodeDiv=function(){if(document.getElementById(this.target+"canvasXpressCode")){return}var a=document.createElement("div");a.id=this.target+"canvasXpressInfoDiv";a.style.display="none";var d=document.createElement("div");d.id=this.target+"canvasXpressCode";d.style.display="none";var b=document.getElementById("canvasXpressRemoteWindow");if(b){b.parentNode.insertBefore(a,b);b.parentNode.appendChild(d)}else{this.canvas.parentNode.parentNode.insertBefore(a,this.canvas.parentNode);this.canvas.parentNode.parentNode.appendChild(d)}};this.clearCodeDiv=function(){var d=document.getElementById(this.target+"canvasXpressCode");if(d){var b=d.childNodes;if(b){for(var a=0;a<b.length;a++){d.removeChild(b[a])}}}d.style.display="none"};this.updateCodeDiv=function(){var f=document.getElementById(this.target+"canvasXpressCode");var e=this.cloneObject(this.data);var b=this.codeType=="pretty"?this.prettyJSON(e):JSON.stringify(e);var d=this.codeType=="pretty"?this.prettyJSON(this.userConfig):JSON.stringify(this.userConfig);if(f){this.clearCodeDiv();var e;var a="";if(this.codeType=="tab"){e=document.createElement("span");a=this.target+"\t"+b+"\t"+d+"\n"}else{if(this.codeType=="compact"){e=document.createElement("span");a='new CanvasXpress("'+this.target+'", '+b+", "+d+")\n"}else{e=document.createElement("pre");a='new CanvasXpress("'+this.target+'", '+b+", "+d+")\n"}}e.style.clear="both";e.innerHTML=a;f.appendChild(e);f.style.display="block"}};this.updateInfoDiv=function(a){var b=document.getElementById(this.target+"canvasXpressInfoDiv");if(b&&a){b.innerHTML=a}};this.showDiv=function(a){var b=document.getElementById(this.target+"canvasXpress"+a);if(b){b.style.display="block"}};this.hideDiv=function(a){var b=document.getElementById(this.target+"canvasXpress"+a);if(b){b.style.display="none"}};this.showCodeDiv=function(){this.showDiv("Code")};this.hideCodeDiv=function(){this.hideDiv("Code")};this.showInfoDiv=function(){this.showDiv("InfoDiv")};this.hideInfoDiv=function(){this.hideDiv("InfoDiv")};this.initializeCodeInfo=function(){this.addInfoCodeDiv()};this.initializeCodeInfo()};CanvasXpress.prototype.initDataTable=function(){this.addDataTableDiv=function(A,C){if(document.getElementById(this.target+"canvasXpressDataTable")){return}var k=this;var J=function(n,d,b){var o=d==0||b==0?document.createElement("th"):document.createElement("td");o.id=k.target+"canvasXpressDataTableCell."+d+"."+b;if(!k.isIE){o.style.width=this.colWidth+"px";o.style.height=this.rowHeight+"px"}if(d==0||b==0){o.style.backgroundColor=k.skinBackgroundColor}n.appendChild(o)};if(!C){this.setDataTableDimensions(A)}var y=20;var f=42;this.dataTableLastScrollLeft=0;this.dataTableLastScrollTop=0;var H=document.createElement("div");H.id=this.target+"canvasXpressDataTable";H.style.top=-parseInt(this.height*0.9)+"px";H.style.left=parseInt(this.width*0.1)+"px";H.style.width=(this.dataTableColsWidth+y)+"px";H.style.height=(this.dataTableRowsHeight+f)+"px";H.style.minWidth=((this.colWidth*3)+y)+"px";H.style.minHeight=((this.rowHeight*3)+f)+"px";H.style.zIndex=20000;H.style.overflow="hidden";H.style.position="relative";H.style.display="none";H.style.border="2px groove "+this.skinBorderColor;H.style.background=this.skinBackgroundColor;H.style.clear="both";H.className="draggable-container";var h=document.createElement("div");h.id=this.target+"canvasXpressDataTableToolbar";h.style.left="0px";h.style.top="0px";h.style.width=(this.dataTableColsWidth+y)+"px";h.style.minWidth=((this.colWidth*3)+y)+"px";h.style.height=19+"px";h.style.position="absolute";h.style.cursor="move";h.style.background=this.skinBackgroundColor;h.className="draggable";var g=document.createElement("img");g.id=this.target+"canvasXpressDataTableSaveImage";g.src=this.imageDir+"disk.png";g.style.left="4px";g.style.top="2px";g.style.cssFloat="left";g.style.position="relative";g.style.cursor="default";g.style.zIndex=20001;var q=document.createElement("img");q.id=this.target+"canvasXpressDataTableIconifyImage";q.src=this.imageDir+"iconify_w.png";q.style.right="2px";q.style.top="2px";q.style.cssFloat="right";q.style.position="relative";q.style.cursor="default";q.style.zIndex=20001;var m=document.createElement("img");m.id=this.target+"canvasXpressDataTableMinimizeImage";m.src=this.imageDir+"minimize_w.png";m.style.right="2px";m.style.top="2px";m.style.cssFloat="right";m.style.position="relative";m.style.cursor="default";m.style.zIndex=20001;m.style.display="none";var a=document.createElement("img");a.id=this.target+"canvasXpressDataTableMaximizeImage";a.src=this.imageDir+"maximize_w.png";a.style.right="2px";a.style.top="2px";a.style.cssFloat="right";a.style.position="relative";a.style.cursor="default";a.style.zIndex=20001;var B=document.createElement("img");B.id=this.target+"canvasXpressDataTableCloseImage";B.src=this.imageDir+"close_w.png";B.style.right="2px";B.style.top="2px";B.style.cssFloat="right";B.style.position="relative";B.style.cursor="default";B.style.zIndex=20001;var D=document.createElement("div");D.id=this.target+"canvasXpressDataTableContainer";D.style.left="0px";D.style.top="20px";D.style.width=(this.dataTableColsWidth+y)+"px";D.style.height=(this.dataTableRowsHeight+24)+"px";D.style.minWidth=((this.colWidth*3)+y)+"px";D.style.minHeight=((this.rowHeight*3)+f)+"px";D.style.position="absolute";D.style.display="block";var z=document.createElement("div");z.id=this.target+"canvasXpressDataTableTable";z.style.left="2px";z.style.top="1px";z.style.width=this.dataTableColsWidth+"px";z.style.height=this.dataTableRowsHeight+"px";z.style.minWidth=(this.colWidth*3)+"px";z.style.minHeight=(this.rowHeight*3)+"px";z.style.position="absolute";var v=document.createElement("div");v.id=this.target+"canvasXpressDataTableVer";v.style.overflow="auto";v.style.right="2px";v.style.top="1px";v.style.width="18px";v.style.height=this.dataTableRowsHeight+"px";v.style.position="absolute";var e=document.createElement("img");e.id=this.target+"canvasXpressDataTableVerImage";e.src=this.getPixelImage();e.width=1;e.height=this.dataTableTotalHeight;v.appendChild(e);var G=document.createElement("div");G.id=this.target+"canvasXpressDataTableHor";G.style.overflow="auto";G.style.left="2px";G.style.bottom="4px";G.style.width=this.dataTableColsWidth+"px";G.style.height="18px";G.style.position="absolute";var u=document.createElement("img");u.id=this.target+"canvasXpressDataTableHorImage";u.src=this.getPixelImage();u.width=this.dataTableTotalWidth;u.height=1;G.appendChild(u);var l=document.createElement("div");l.id=this.target+"canvasXpressDataTableResizer";l.style.right="0px";l.style.bottom="2px";l.style.width="13px";l.style.height="13px";l.style.position="absolute";l.style.cursor="se-resize";l.style.backgroundImage="url('"+this.imageDir+"resize_w.png')";l.style.backgroundRepeat="no-repeat";l.className="resizable";var s=document.createElement("table");s.id=this.target+"canvasXpressTable";s.style.tableLayout="fixed";s.style.border="2px groove";s.style.borderCollapse="collapse";s.style.fontSize="x-small";s.style.left="0px";s.style.top="0px";s.style.width=this.dataTableColsWidth+"px";s.style.height=this.dataTableRowsHeight+"px";s.style.minWidth=(this.colWidth*3)+"px";s.style.minHeight=(this.rowHeight*3)+"px";s.style.position="absolute";s.style.background="#fefefe";var I=document.createElement("tbody");for(var F=0;F<this.maxRows;F++){var x=document.createElement("tr");for(var E=0;E<this.maxCols;E++){J(x,F,E)}I.appendChild(x)}h.appendChild(g);h.appendChild(B);h.appendChild(a);h.appendChild(m);h.appendChild(q);s.appendChild(I);z.appendChild(s);D.appendChild(z);D.appendChild(v);D.appendChild(G);D.appendChild(l);H.appendChild(h);H.appendChild(D);var p=document.getElementById("canvasXpressRemoteWindow");if(p){p.parentNode.appendChild(H)}else{this.canvas.parentNode.parentNode.appendChild(H)}this.addRemoveDataTableListeners("addEvtListener")};this.fineAdjustDataTable=function(){var h=document.getElementById(this.target+"canvasXpressDataTable");var j=document.getElementById(this.target+"canvasXpressDataTableContainer");var g=document.getElementById(this.target+"canvasXpressDataTableTable");var m=document.getElementById(this.target+"canvasXpressTable");var l=document.getElementById(this.target+"canvasXpressDataTableVer");var f=document.getElementById(this.target+"canvasXpressDataTableVerImage");if(h&&j&&g&&m&&l&&f){var k=g.scrollHeight-g.clientHeight;var a=m.scrollWidth-m.clientWidth;if(k){var b=this.dataTableRowsHeight+k;h.style.height=(b+42)+"px";j.style.height=(b+22)+"px";g.style.height=b+"px";m.style.height=b+"px";l.style.height=b+"px";f.height=this.dataTableTotalHeight+k}if(a){}}};this.addRemoveDataTableListeners=function(d,f){var g=document.getElementById(this.target+"canvasXpressDataTableHor");var n=document.getElementById(this.target+"canvasXpressDataTableVer");var p=document.getElementById(this.target+"canvasXpressDataTableToolbar");var q=document.getElementById(this.target+"canvasXpressDataTableSaveImage");var e=document.getElementById(this.target+"canvasXpressDataTableIconifyImage");var b=document.getElementById(this.target+"canvasXpressDataTableMinimizeImage");var l=document.getElementById(this.target+"canvasXpressDataTableMaximizeImage");var k=document.getElementById(this.target+"canvasXpressDataTableCloseImage");var a=document.getElementById(this.target+"canvasXpressDataTableResizer");var j=0;if(g){this[d](g,"scroll",this.scrollTable,false)}if(n){this[d](n,"scroll",this.scrollTable,false)}if(p){this[d](p,"mousedown",this.registerMousemove,false)}if(q){this[d](q,"click",this.saveTable,false)}if(e){this[d](e,"click",this.dockTable,false)}if(b){this[d](b,"click",this.minimizeTable,false)}if(l){this[d](l,"click",this.maximizeTable,false)}if(k){this[d](k,"click",this.hideTable,false)}if(a){this[d](a,"mousedown",this.mousedownDataTableResizer,false)}if(f){j=f[1]}else{j=this.maxCols}for(var o=0;o<j;o++){f=document.getElementById(this.target+"canvasXpressDataTableCell.0."+o);if(f){this[d](f,"mousemove",this.mousemoveDataTableHeader,false);this[d](f,"mousedown",this.mousedownDataTableHeader,false)}}};this.setDataTableDimensions=function(e,l){var b=0;var q=0;var h=0;var m=false;var k=function(){for(var a=0;a<e.w.grps.length;a++){h+=e.w.grps[a].length}return h};if(!e){e=this.data}var u=0;if(e.x){for(var j in e.x){u++}}var p=0;if(e.z){for(var j in e.z){p++}}var s=this.getAllNetworkAttributes(e);var w=this.getVennCompartments(e);var d=document.getElementById(this.target+"canvasXpressDataTableTable");var y=this.getDataTableDimensions();if(y[0]!=this.maxRows||y[1]!=this.maxCols){this.initialMaxRows=this.maxRows;this.initialMaxCols=this.maxCols}if(this.graphType=="Network"){b=this.dataTableTransposed?1+e[this.networkShowDataTable].length:1+s[1];q=this.dataTableTransposed?1+s[1]:1+e[this.networkShowDataTable].length}else{if(this.graphType=="Genome"){b=1;q=1}else{if(this.graphType=="Venn"){b=this.dataTableTransposed?1+w[1]:2;q=this.dataTableTransposed?2:1+w[1]}else{if(this.graphType=="Correlation"){b=this.correlationAxis=="samples"?1+e.y.smps.length:1+e.y.vars.length;q=b}else{if(this.graphType=="Candlestick"){if(e.y){b=this.dataTableTransposed?1+(e.y.smps.length*e.y.vars.length):6;q=this.dataTableTransposed?6:1+(e.y.smps.length*e.y.vars.length)}else{if(e.market){b=this.dataTableTransposed?1+(e.market.smps.length*e.market.vars.length):6;q=this.dataTableTransposed?6:1+(e.market.smps.length*e.market.vars.length)}}}else{if(e.y&&e.y.vars&&e.y.smps){b=this.dataTableTransposed?1+p+e.y.smps.length:1+u+e.y.vars.length;q=this.dataTableTransposed?1+u+e.y.vars.length:1+p+e.y.smps.length}else{if(e.w&&e.w.vars&&e.w.grps){h=k();b=this.dataTableTransposed?1+p+h:1+u+e.w.vars.length;q=this.dataTableTransposed?1+u+e.w.vars.length:1+p+h}}}}}}}if(this.maxRows>b){this.initialMaxRows=this.maxRows;this.maxRows=b}if(this.maxCols>q){this.initialMaxCols=this.maxCols;this.maxCols=q}if(this.totalRows==null||this.totalCols==null){this.totalRows=b;this.totalCols=q}else{if(l||b!=this.totalRows||q!=this.totalCols||y[0]!=this.maxRows||y[1]!=this.maxCols||y[2]!=this.rowHeight||y[3]!=this.colWidth){this.totalRows=b;this.totalCols=q;m=true}else{this.totalRows=b;this.totalCols=q;if(this.showDataTable){this.hideUnhideDataTable()}}}this.dataTableTotalHeight=0;for(var j=0;j<=this.totalRows;j++){this.dataTableTotalHeight+=this.setDataTableRowHeight(j)}this.dataTableTotalWidth=0;for(var j=0;j<=this.totalCols;j++){this.dataTableTotalWidth+=this.setDataTableColumnWidth(j)}this.dataTableRowsHeight=this.setDataTableRowHeight(0);for(var j=this.startRow;j<=this.startRow+this.maxRows;j++){this.dataTableRowsHeight+=this.setDataTableRowHeight(j)}this.dataTableColsWidth=this.setDataTableColumnWidth(0);for(var j=this.startCol;j<=this.startCol+this.maxCols;j++){this.dataTableColsWidth+=this.setDataTableColumnWidth(j)}if(m){this.resetDataTable(true,y)}};this.setDataTableColumnWidth=function(b,a){if(!this.dataTableColumnWidth[b]){this.dataTableColumnWidth[b]=this.colWidth}else{if(a){this.dataTableColumnWidth[b]=Math.max(a,this.colWidth)}}return this.dataTableColumnWidth[b]};this.setDataTableRowHeight=function(a,b){if(!this.dataTableRowHeight[a]){this.dataTableRowHeight[a]=this.rowHeight}else{if(b){this.dataTableRowHeight[a]=Math.max(b,this.rowHeight)}}return this.dataTableRowHeight[a]};this.getAllNetworkAttributes=function(h){var b={};var j=0;var g=["x","y","z"];if(h[this.networkShowDataTable]){for(var f=0;f<h[this.networkShowDataTable].length;f++){for(var d in h[this.networkShowDataTable][f]){if(b.hasOwnProperty(d)){b[d]++}else{b[d]=1;j++}}}}for(var f=0;f<g.length;f++){if(!b.hasOwnProperty(g[f])){b[g[f]]=b.id;j++}}return[b,j]};this.getVennCompartments=function(d){var b={};var e=0;if(d.venn&&d.venn.data){for(var a in d.venn.data){b[a]=1;e++}}return[b,e]};this.getDataTableDimensions=function(){var f=0;var j=0;var e=0;var b=0;var d=document.getElementById(this.target+"canvasXpressDataTableTable");var g=document.getElementById(this.target+"canvasXpressDataTableCell.0.0");if(d){var a=d.childNodes[0].childNodes[0].rows;if(a){f=a.length;j=a[0].cells.length;e=g&&g.firstChild&&g.firstChild.style?parseInt(g.firstChild.style.height):0;b=g&&g.firstChild&&g.firstChild.style?parseInt(g.firstChild.style.width):0}}return[f,j,e,b]};this.resetDataTable=function(b,a){this.addRemoveDataTableListeners("removeEvtListener",a);this.removeTarget(this.target+"canvasXpressDataTable");this.addDataTableDiv(false,b)};this.hideUnhideDataTable=function(a){this.currentDataTableData=null;if(this.initialMaxRows){this.maxRows=this.initialMaxRows}if(this.initialMaxCols){this.maxCols=this.initialMaxCols}var b=document.getElementById(this.target+"canvasXpressDataTable");if(b){if(a==true){b.style.display="none"}else{b.style.display="block"}}};this.scrollTable=function(a){return function(b){if(!b){b=window.event}a.resizeDataTable();return false}}(this);this.resizeDataTable=function(n){var g=document.getElementById(this.target+"canvasXpressDataTable");var l=document.getElementById(this.target+"canvasXpressDataTableVer");var f=document.getElementById(this.target+"canvasXpressDataTableHor");var k=document.getElementById(this.target+"canvasXpressDataTableContainer");if(n){if(k){var m=0;this.maxCols=1;for(var e=this.startCol;e<this.totalCols;e++){m+=this.dataTableColumnWidth[e];if(parseInt(k.style.width)<m){break}else{this.maxCols++}}if(parseInt(k.style.width)>=this.dataTableTotalWidth){this.maxCols=(this.totalCols-this.startCol)+1}this.maxCols=Math.max(3,Math.min(this.maxCols,(this.totalCols-this.startCol)+1));var b=0;this.maxRows=1;for(var e=this.startRow;e<this.totalRows;e++){b+=this.dataTableRowHeight[e];if(parseInt(k.style.height)<b){break}else{this.maxRows++}}if(parseInt(k.style.height)>=this.dataTableTotalHeight){this.totalRows=(this.totalRows-this.startRow)+1}this.maxRows=Math.max(3,Math.min(this.maxRows,(this.totalRows-this.startRow)+1));this.updateDataTable(false,true)}}else{if(g&&l&&f){var j=f.scrollLeft==0?1:Math.ceil(f.scrollLeft*this.totalCols/this.dataTableTotalWidth)+2;j=Math.max(1,Math.min(j,this.totalCols+1-this.maxCols));var a=l.scrollTop==0?1:Math.ceil(l.scrollTop*this.totalRows/this.dataTableTotalHeight)+2;a=Math.max(1,Math.min(a,this.totalRows+1-this.maxRows));if(j!=this.startCol||a!=this.startRow){this.startCol=j;this.startRow=a;this.updateDataTable()}}}};this.updateDataTable=function(x,D,E){var h=0;var b=0;var w=0;var q=0;var F=[];var G=[];var u=[];var t=[];if(!x){x=this.currentDataTableData?this.currentDataTableData:this.data}else{if(this.isGroupedData){var B=this.getVariableIndices(x.w.vars);var C=[];for(var A=0;A<x.w.grps.length;A++){C=C.concat(x.w.grps[A])}this.isGroupedData=false;x=this.extractDataObject(C,B);this.isGroupedData=true}}if(!E){this.setDataTableDimensions(x,D)}this.startRow--;this.startCol--;if(this.graphType=="Network"){var H=this.getAllNetworkAttributes(x);u.push("");t.push("cxb");if(this.dataTableTransposed){for(var B in H[0]){if(b<this.maxCols&&q>=this.startCol){u.push(B);t.push("cxx");b++}q++}F.push(u);G.push(t);for(var B=0;B<x[this.networkShowDataTable].length;B++){if(h<this.maxRows&&w>=this.startRow){b=0;q=0;u=[B+1];t=["cxz"];for(var A in H[0]){if(b<this.maxCols&&q>=this.startCol){var p=x[this.networkShowDataTable][B][A];u.push(p?p:"");t.push("cxy");b++}q++}F.push(u);G.push(t);h++}w++}}else{for(var B=0;B<x[this.networkShowDataTable].length;B++){if(b<this.maxCols&&q>=this.startCol){u.push(B+1);t.push("cxz");b++}q++}F.push(u);G.push(t);for(var B in H[0]){if(h<this.maxRows&&w>=this.startRow){b=0;q=0;u=[B];t=["cxx"];for(var A=0;A<x[this.networkShowDataTable].length;A++){if(b<this.maxCols&&q>=this.startCol){var p=x[this.networkShowDataTable][A][B];u.push(p?p:"");t.push("cxy");b++}q++}F.push(u);G.push(t);h++}w++}}}else{if(this.graphType=="Genome"){F=[["Not implemented"]];G=[["cxb"]]}else{if(this.graphType=="Venn"){var p=this.getVennCompartments(x);u.push("");t.push("cxb");if(this.dataTableTransposed){u.push("No");t.push("cxz");F.push(u);G.push(t);for(var B in p[0]){if(h<this.maxRows&&w>=this.startRow){b=0;q=0;u=[B];t=["cxx"];if(b<this.maxCols&&q>=this.startCol){u.push(x.venn.data[B]);t.push("cxy");b++}q++;F.push(u);G.push(t);h++}w++}}else{for(var B in p[0]){if(b<this.maxCols&&q>=this.startCol){u.push(B);t.push("cxx");b++}q++}F.push(u);G.push(t);if(h<this.maxRows&&w>=this.startRow){b=0;q=0;u=["No"];t=["cxz"];for(var B in p[0]){if(b<this.maxCols&&q>=this.startCol){u.push(x.venn.data[B]);t.push("cxy");b++}q++}F.push(u);G.push(t)}}}else{if(this.graphType=="Correlation"){var n=this.correlationAxis=="samples"?x.y.smps:x.y.vars;var m=this.correlationAxis=="samples"?"cxs":"cxv";u.push("");t.push("cxb");for(var B=0;B<n.length;B++){if(b<this.maxCols&&q>=this.startCol){u.push(n[B]);t.push(m);b++}q++}F.push(u);G.push(t);for(var B=0;B<n.length;B++){if(h<this.maxRows&&w>=this.startRow){b=0;q=0;u=[n[B]];t=[m];for(var A=0;A<n.length;A++){if(b<this.maxCols&&q>=this.startCol){if(x.y.cor){u.push(x.y.cor[B][A])}else{u.push(B==A?1:x.y.data)}t.push("cxy");b++}q++}F.push(u);G.push(t);h++}w++}}else{if(this.graphType=="Candlestick"){var H=["open","low","high","close","volume"];u.push("");t.push("cxb");if(this.dataTableTransposed){for(var B=0;B<x.y.vars.length;B++){for(var A=0;A<H.length;A++){if(b<this.maxCols&&q>=this.startCol){var y=x.y.vars.length>1?x.y.vars[B]+":"+H[A]:H[A];u.push(y);t.push("cxv");b++}q++}}F.push(u);G.push(t);for(var B=0;B<x.y.smps.length;B++){if(h<this.maxRows&&w>=this.startRow){b=0;q=0;u=[x.y.smps[B]];t=["cxs"];for(var A=0;A<x.y.vars.length;A++){for(var z=0;z<H.length;z++){if(b<this.maxCols&&q>=this.startCol){u.push(x.y[H[z]][A][B]!=null?x.y[H[z]][A][B]:x.y[H[z]][B]);t.push("cxy");b++}q++}}F.push(u);G.push(t);h++}w++}}else{for(var B=0;B<x.y.smps.length;B++){if(b<this.maxCols&&q>=this.startCol){u.push(x.y.smps[B]);t.push("cxs");b++}q++}F.push(u);G.push(t);for(var B=0;B<x.y.vars.length;B++){for(var A=0;A<H.length;A++){if(h<this.maxRows&&w>=this.startRow){b=0;q=0;var y=x.y.vars.length>1?x.y.vars[B]+":"+H[A]:H[A];u=[y];t=["cxv"];for(var z=0;z<x.y.smps.length;z++){if(b<this.maxCols&&q>=this.startCol){u.push(x.y[H[A]][B][z]!=null?x.y[H[A]][B][z]:x.y[H[A]][z]);t.push("cxy");b++}q++}F.push(u);G.push(t);h++}w++}}}}else{if(x.y.vars&&x.y.smps){u.push("");t.push("cxb");if(this.dataTableTransposed){if(x.x){for(var B in x.x){if(b<this.maxCols&&q>=this.startCol){u.push(B);t.push("cxx");b++}q++}}for(var B=0;B<x.y.vars.length;B++){if(b<this.maxCols&&q>=this.startCol){u.push(x.y.vars[B]);t.push("cxv");b++}q++}F.push(u);G.push(t);if(x.z){for(var B in x.z){if(h<this.maxRows&&w>=this.startRow){b=0;q=0;u=[B];t=["cxz"];if(x.x){for(var A in x.x){if(b<this.maxCols&&q>=this.startCol){u.push("");t.push("cxb");b++}q++}}for(var A=0;A<x.y.vars.length;A++){if(b<this.maxCols&&q>=this.startCol){u.push(x.z[B][A]);t.push("cxz");b++}q++}F.push(u);G.push(t);h++}w++}}for(var B=0;B<x.y.smps.length;B++){if(h<this.maxRows&&w>=this.startRow){b=0;q=0;u=[x.y.smps[B]];t=["cxs"];if(x.x){for(var A in x.x){if(b<this.maxCols&&q>=this.startCol){u.push(x.x[A][B]);t.push("cxx");b++}q++}}for(var A=0;A<x.y.vars.length;A++){if(b<this.maxCols&&q>=this.startCol){u.push(x.y.data[A][B]!=null?x.y.data[A][B]:x.y.data[B]);t.push("cxy");b++}q++}F.push(u);G.push(t);h++}w++}}else{if(x.z){for(var B in x.z){if(b<this.maxCols&&q>=this.startCol){u.push(B);t.push("cxz");b++}q++}}for(var B=0;B<x.y.smps.length;B++){if(b<this.maxCols&&q>=this.startCol){u.push(x.y.smps[B]);t.push("cxs");b++}q++}F.push(u);G.push(t);if(x.x){for(var B in x.x){if(h<this.maxRows&&w>=this.startRow){b=0;q=0;u=[B];t=["cxx"];if(x.z){for(var A in x.z){if(b<this.maxCols&&q>=this.startCol){u.push("");t.push("cxb");b++}q++}}for(var A=0;A<x.y.smps.length;A++){if(b<this.maxCols&&q>=this.startCol){u.push(x.x[B][A]);t.push("cxx");b++}q++}F.push(u);G.push(t);h++}w++}}for(var B=0;B<x.y.vars.length;B++){if(h<this.maxRows&&w>=this.startRow){b=0;q=0;u=[x.y.vars[B]];t=["cxv"];if(x.z){for(var A in x.z){if(b<this.maxCols&&q>=this.startCol){u.push(x.z[A][B]);t.push("cxz");b++}q++}}for(var A=0;A<x.y.smps.length;A++){if(b<this.maxCols&&q>=this.startCol){u.push(x.y.data[B][A]!=null?x.y.data[B][A]:x.y.data[A]);t.push("cxy");b++}q++}F.push(u);G.push(t);h++}w++}}}}}}}}this.startRow++;this.startCol++;if(E){return F}else{this.loadDataTableValues(F,G,x)}};this.loadDataTableValues=function(l,m,a){var p=document.getElementById(this.target+"canvasXpressDataTable");if(p){var n=this.startRow;for(var g=0;g<l.length;g++){var h=this.startCol;for(var f=0;f<l[g].length;f++){var k=document.getElementById(this.target+"canvasXpressDataTableCell."+g+"."+f);if(k){if(k.hasChildNodes()){while(k.childNodes.length>=1){k.removeChild(k.firstChild)}}var b=document.createElement("div");b.className="cxc";if(g!=0){b.style.height=this.setDataTableRowHeight(n)+"px";k.style.height=this.setDataTableRowHeight(n)+"px"}else{b.style.height=this.setDataTableRowHeight(0)+"px";k.style.height=this.setDataTableRowHeight(0)+"px"}if(f!=0){b.style.width=this.setDataTableColumnWidth(h)+"px";k.style.width=this.setDataTableColumnWidth(h)+"px"}else{b.style.width=this.setDataTableColumnWidth(0)+"px";k.style.width=this.setDataTableColumnWidth(0)+"px"}b.appendChild(document.createTextNode(l[g][f]));k.appendChild(b);k.className=m[g][f];k.title=l[g][f];k.alt=l[g][f];h++}}n++}p.style.display="block";this.currentDataTableData=a;this.fineAdjustDataTable()}};this.saveTable=function(a){return function(h){if(!h){h=window.event}var b=a.maxCols;var g=a.maxRows;var f=a.startCol;var k=a.startRow;a.maxCols=a.totalCols;a.maxRows=a.totalRows;a.startCol=1;a.startRow=1;var j=a.updateDataTable(false,false,true);a.exportToExcel(j);a.maxCols=b;a.maxRows=g;a.startCol=f;a.startRow=k;return false}}(this);this.dockTable=function(a){return function(b){if(!b){b=window.event}a.moveDataTableDiv("dock");return false}}(this);this.moveDataTableDiv=function(b,a,g){if(!b){return}var e=document.getElementById(this.target+"canvasXpressDataTable");if(e){var f=document.getElementById(this.target+"canvasXpressDataTableContainer");if(b=="dock"){this.dataTableLastHeight=e.style.height;e.style.left="0px";e.style.top="0px";e.style.height="19px";e.style.minHeight="";if(f){f.style.display="none"}}else{if(b=="min"){}else{if(b=="max"){e.style.left=this.dataTableLastX+"px";e.style.top=this.dataTableLastY+"px";e.style.height=this.dataTableLastHeight||(this.dataTableRowsHeight+42)+"px";e.style.minHeight=((this.rowHeight*3)+42)+"px";if(f){f.style.display="block"}}}}}};this.minimizeTable=function(a){return function(b){if(!b){b=window.event}a.moveDataTableDiv("min");return false}}(this);this.maximizeTable=function(a){return function(b){if(!b){b=window.event}a.moveDataTableDiv("max");return false}}(this);this.hideTable=function(a){return function(b){if(!b){b=window.event}a.showDataTable=false;a.hideUnhideDataTable(true);return false}}(this);this.mousedownDataTableResizer=function(a){return function(b){if(!b){b=window.event}a.registerDataTableResizer(b);return false}}(this);this.registerDataTableResizer=function(b){if(!b){b=window.event}var a=b.target||b.srcElement;if(a.className="resizable"){var d=document.getElementById(this.target+"canvasXpressDataTable");if(d){this.dataTableTarget=d;this.xMouseDown=b.clientX;this.yMouseDown=b.clientY;this.dataTableWidth=parseInt(this.dataTableTarget.style.width)||0;this.dataTableHeight=parseInt(this.dataTableTarget.style.height)||0;this.resizingDataTableOn=true}}};this.updateDataTableResizerDiv=function(b){if(!b){b=window.event}if(this.dataTableTarget&&this.dataTableTarget.style){var f=document.getElementById(this.target+"canvasXpressDataTableContainer");if(f){var a=Math.abs(this.dataTableWidth)-(this.xMouseDown-b.clientX);var d=Math.abs(this.dataTableHeight)-(this.yMouseDown-b.clientY);this.dataTableTarget.style.width=a+"px";this.dataTableTarget.style.height=d+"px";f.style.width=a+"px";f.style.height=(d-18)+"px";this.dataTableLastWidth=a;this.dataTableLastHeight=d}}};this.endDataTableResizerDiv=function(a){if(this.dataTableTarget!=null){var b=document.getElementById(this.target+"canvasXpressDataTable");this.resizeDataTable(true);this.xMouseDown=null;this.yMouseDown=null;this.dataTableWidth=null;this.dataTableHeight=null;this.dataTableTarget=false;this.resizingDataTableOn=false}};this.mousemoveDataTableHeader=function(a){return function(m){if(!m){m=window.event}var d=a.resizingDataTableColumnOn?a.dataTableColumnTarget:m.target||m.srcElement;var g=document.getElementById(a.target+"canvasXpressDataTable");var n=document.getElementById(a.target+"canvasXpressDataTableContainer");var k=document.getElementById(a.target+"canvasXpressDataTableTable");var q=a.adjustedCoordinates(m,d);if(q&&n&&g&&k){if(a.resizingDataTableColumnOn){var b=a.dataTableColumnTarget.id.split(".");var j=parseInt(b[2]);var p=q.x-a.xMouseDown;var o=Math.max(a.colWidth,(a.dataTableColumnWidth[a.startCol+j]||a.colWidth)+p);a.dataTableColumnTarget.style.width=o+"px";a.dataTableColumnTarget.firstChild.style.width=o+"px";for(var l=a.startRow;l<a.startRow+a.totalRows;l++){var f=document.getElementById(a.target+"canvasXpressDataTableCell."+l+"."+j);if(f){f.style.width=o+"px";f.firstChild.style.width=o+"px"}}if(o>a.colWidth){g.style.width=(parseInt(g.style.width)+p)+"px";n.style.width=(parseInt(n.style.width)+p)+"px";k.style.width=(parseInt(g.style.width)+p)+"px"}a.dataTableColumnWidth[a.startCol+j]=o;a.xMouseDown=q.x;a.yMouseDown=q.y;document.body.style.cursor="ew-resize"}else{var h=(d.offsetLeft+d.clientWidth)-q.x;if(h<5&&d.nodeName.toLowerCase()=="th"){d.style.cursor="ew-resize"}else{d.style.cursor="default"}}}return false}}(this);this.mousedownDataTableHeader=function(a){return function(f){if(!f){f=window.event}var b=f.target||f.srcElement;var d=a.adjustedCoordinates(f,b);if(d){var g=(b.offsetLeft+b.clientWidth)-d.x;if(g<5&&b.nodeName.toLowerCase()=="th"){a.dataTableColumnTarget=b;a.xMouseDown=d.x;a.yMouseDown=d.y;a.resizingDataTableColumnOn=true;document.body.style.cursor="ew-resize"}}return false}}(this);this.endDataTableColumnResize=function(a){this.resizeDataTable(true,this.getDataTableDimensions());this.xMouseDown=null;this.yMouseDown=null;this.resizingDataTableColumnOn=false;this.dataTableColumnTarget=false;document.body.style.cursor="default"};this.initializeDataTableEvents=function(){this.addDataTableDiv()};this.initializeDataTableEvents()};CanvasXpress.prototype.initDendrogramEvents=function(){this.modifyDendrogram=function(g){var e=g.t.t=="varDendrogram"?this.varIndicesStart:this.smpIndicesStart;var c=g.t.t.replace("Dendrogram","s");var f=this[g.t.t].object;var h=g.t.d+"-"+g.t.o;var d=this.findDendrogramBranch(f,h);var b=this.reverseDendrogramBranch(d);var a=this.writeNewick(f,true);this.data.t[c]=a;this.draw()};this.findDendrogramBranch=function(b,c,a){if(b.id==c){a=b}if(!a){if(b.left){a=this.findDendrogramBranch(b.left,c,a)}if(b.right){a=this.findDendrogramBranch(b.right,c,a)}}else{return a}return a};this.reverseDendrogramBranch=function(b){if(b&&b.right&&b.left){b.right=this.reverseDendrogramBranch(b.right);b.left=this.reverseDendrogramBranch(b.left);var a=b.left;b.left=b.right;b.right=a;if(b.mid){b.mid=b.mid.reverse()}}return b}};CanvasXpress.prototype.initSelectEvents=function(){this.showHideSelectedDataPoint=function(f,j){this.stopEvent(f);if(j==45||j==46){var g=this.layoutComb?this.layoutValidN:0;var d=this.layoutComb?this.layoutParams[g].graphType:this.graphType;if(d=="Network"){var b=[];var a=j==45?false:true;for(var h in this.selectNode){b.push(h)}if(b.length>0){this.hideUnhideNodes(b,a)}}else{if(d.match(/Scatter/)){if(j==45){this.selectDataPoint=this.hideDataPoint;this.hideDataPoint=[]}else{this.hideDataPoint=this.selectDataPoint;this.selectDataPoint=[]}}}this.draw()}};this.addRemoveToSelectedDataPoints=function(h,f){var b=this.broadcast?CanvasXpress.references:[this];for(var e=0;e<b.length;e++){var g=b[e];if(!h){var j=g.layoutComb?g.layoutValidN:0;h=g.layoutComb?g.layoutParams[j].graphType:g.graphType}if(h=="Network"){var a=parseInt(f.join(", "));if(a<g.data.nodes.length){var d=g.data.nodes[a].id;if(g.selectNode.hasOwnProperty(d)){g.isSelectNodes--;delete g.selectNode[d]}else{g.isSelectNodes++;g.selectNode[d]=true}}}else{if(h.match(/Scatter/)){var d;if(!g.selectDataPoint[f[0]]){g.selectDataPoint[f[0]]={}}if(h=="Scatter3D"){d=f[1]+":"+f[2]+":"+f[3]}else{d=f[1]+":"+f[2]}if(g.selectDataPoint[f[0]].hasOwnProperty(d)){g.isSelectDataPoints--;delete g.selectDataPoint[f[0]][d]}else{g.isSelectDataPoints++;g.selectDataPoint[f[0]][d]=true}}}}};this.resetSelectedDataPoints=function(){if(this.isSelectDataPoints){this.selectDataPoint=[];this.hideDataPoint=[];this.isSelectDataPoints=0}};this.resetSelectedNodes=function(){if(this.isSelectNodes){this.selectNode={};this.isSelectNodes=0}}};CanvasXpress.prototype.initKeyEvents=function(){this.isInFocus=function(){var b=document.activeElement;var a=b.getElementsByTagName("img");if(!a||a.length==0){a=b.parentNode.getElementsByTagName("img")}if(!a||a.length==0){a=b.parentNode.parentNode.getElementsByTagName("img")}for(i=0;i<a.length;i++){if(a[i].id.match(this.target)){return true}}return false};this.isInView=function(e){if(e&&e.id&&e.id.match(this.target)){return true}else{if(!this.isInFocus()){return false}}var c=e.offsetTop;var b=e.offsetLeft;var a=e.offsetWidth;var d=e.offsetHeight;while(e.offsetParent){e=e.offsetParent;c+=e.offsetTop;b+=e.offsetLeft}return(c<(window.pageYOffset+window.innerHeight)&&b<(window.pageXOffset+window.innerWidth)&&(c+d)>window.pageYOffset&&(b+a)>window.pageXOffset)};this.getKeyCode=function(a){if(a){if((a.charCode)&&(a.keyCode==0)){return a.charCode}else{return a.keyCode}}};this.registerKey=function(a){if(!a){a=window.event}var b=this.getKeyCode(a);if(this.eventKeys||(a.ctrlKey&&a.altKey&&b==107)){if(b==27){if(this.animationOn){this.animationOn=false;return false}this.masterReset(a)}else{if(this.configuringOn){return}else{if(b==16&&this.helpKeyEvents){if(a.ctrlKey&&a.altKey){this.showCtrlShiftAltShorts()}else{if(a.ctrlKey){this.showCtrlShiftShorts()}else{if(a.altKey){this.showShiftAltShorts()}else{this.showShiftShorts()}}}}else{if(b==17&&this.helpKeyEvents){if(a.shiftKey&&a.altKey){this.showCtrlShiftAltShorts()}else{if(a.shiftKey){this.showCtrlShiftShorts()}else{if(a.altKey){this.showCtrlAltShorts()}else{this.showCtrlShorts()}}}}else{if((b==18||b==224)&&this.helpKeyEvents){if(a.ctrlKey&&a.shiftKey){this.showCtrlShiftAltShorts()}else{if(a.ctrlKey){this.showCtrlAltShorts()}else{if(a.shiftKey){this.showShiftAltShorts()}else{this.showAltShorts()}}}}else{if(a.ctrlKey&&a.shiftKey){if(b==80){this.print()}if(b>=33&&b<=40){this.arrowMove(b,true)}else{if(b==90&&this.graphType=="Network"){this.alignDistributeSelectedNodes(a,b)}}document.defaultAction=true}else{if(a.ctrlKey&&a.altKey){if(b==80){this.print()}document.defaultAction=true}else{if(a.shiftKey&&a.altKey){if(b>=50&&b<90){this.setGraphType(b)}document.defaultAction=true}else{if(a.ctrlKey){if(b>=33&&b<=40){this.arrowMove(b)}else{if(b==45||b==46){this.showHideSelectedDataPoint(a,b)}else{if(b>=48&&b<58){this.setLayout(b-48)}else{if(b>=65&&b<=90){if(b==80){this.print()}if(this.graphType=="Network"){this.alignDistributeSelectedNodes(a,b)}}}}}document.defaultAction=true}else{if(b==107||b==109||b==61||b==187||b==189){if(this.eventPlusMinusKeys){if(b==109||b==189){this.handleWheelEvent(a,-1)}else{this.handleWheelEvent(a,1)}}}else{if(b>=33&&b<=40){if(this.eventArrowKeys){this.handlePanning(a,b)}}else{if(a.shiftKey){document.defaultAction=true}else{if(a.altKey){document.defaultAction=true}}}}}}}}}}}}}}};this.handlePanning=function(f,j){if(this.graphType=="Network"){this.cancelEvent(f);var m=Math.abs(this.x*this.panningStep);var k=Math.abs(this.y*this.panningStep);if(j==33){this.panningY-=k*5}else{if(j==34){this.panningY+=k*5}else{if(j==35){this.panningX=m*20;this.panningY=k*20}else{if(j==36){this.panningX=0;this.panningY=0}else{if(j==37){this.panningX-=m}else{if(j==38){this.panningY-=k}else{if(j==39){this.panningX+=m}else{if(j==40){this.panningY+=k}}}}}}}}this.draw(false,false,false,true)}else{if(this.graphType=="Genome"){var p=this.genomeResolution=="high"?1:this.xAxisRange*this.panningStep;if(this.setMin==null){this.setMin=this.xAxisMin}if(this.setMax==null){this.setMax=this.xAxisMax}this.cancelEvent(f);if(j==37||j==38){this.setMin-=p;this.setMax-=p}else{if(j==39||j==40){this.setMin+=p;this.setMax+=p}else{if(j==33){this.setMin+=this.xAxisRange*0.95;this.setMax+=this.xAxisRange*0.95}else{if(j==34){this.setMin-=this.xAxisRange*0.95;this.setMax-=this.xAxisRange*0.95}else{if(j==35){this.setMax=null}else{if(j==36){this.setMin=null}}}}}}this.draw()}else{if(this.graphType=="Heatmap"){this.cancelEvent(f);this.resetAxesResizer(f);var g=this.layoutComb?this.layoutValidN:0;var q;var n=this.layoutComb?this.layoutParams[g].varIndices:this.varIndices;if(this.isGroupedData){q=this.layoutComb?this.layoutParams[g].grpIndices:this.grpIndices}else{q=this.layoutComb?this.layoutParams[g].smpIndices:this.smpIndices}this.setOriginalIndices(j,n,q);if(j==35){return false}else{if(j==36){this.varIndicesStart=-1;this.smpIndicesStart=-1;this.varIndices=this.startingVarIndices[g];if(this.isGroupedData){this.grpIndices=this.startingSmpIndices[g]}else{this.smpIndices=this.startingSmpIndices[g]}this.draw()}else{if(j==37){if(this.varIndicesStart>0){this.varIndices.unshift(this.startingVarIndices[g][this.varIndicesStart-1]);this.varIndices.pop();this.varIndicesStart--;this.draw()}}else{if(j==38||j==33){var o=j==33?5:1;var h=false;var a=this.isGroupedData?this.grpIndices:this.smpIndices;for(var b=0;b<o;b++){if(this.smpIndicesStart>0){a.unshift(this.startingSmpIndices[g][this.smpIndicesStart-1]);a.pop();this.smpIndicesStart--;h=true}}if(h){this.draw()}}else{if(j==39){if(this.varIndicesStart>-1&&this.varIndicesStart+n.length<this.startingVarIndices[g].length){this.varIndices.push(this.startingVarIndices[g][this.varIndicesStart+this.varIndices.length]);this.varIndices.shift();this.varIndicesStart++;this.draw()}}else{if(j==40||j==34){var o=j==34?5:1;var h=false;var a=this.isGroupedData?this.grpIndices:this.smpIndices;for(var b=0;b<o;b++){if(this.smpIndicesStart>-1&&this.smpIndicesStart+q.length<this.startingSmpIndices[g].length){a.push(this.startingSmpIndices[g][this.smpIndicesStart+a.length]);a.shift();this.smpIndicesStart++;h=true}}if(h){this.draw()}}}}}}}}}}return false};this.showCtrlShiftAltShorts=function(){var a="<table class=shorts>";a+="<tr><th colspan=2>Ctrl + Shift + Alt</th></tr>";a+="<tr><td class=k>&nbsp;</td><td class=d>&nbsp;</td></tr>";a+="</table>";this.showInfoSpan(false,a)};this.showCtrlShiftShorts=function(){var a="<table class=shorts>";a+="<tr><th colspan=2>Shift + Ctrl</th></tr>";if(this.graphType=="Network"){if(this.is3DNetwork){a+="<tr><td class=k>&rarr;</td><td class=d>Rotate clockwise "+(this.rotationStep*1)+"&deg; continuously</td></tr>";a+="<tr><td class=k>&larr;</td><td class=d>Rotate anti-clockwise "+(this.rotationStep*1)+"&deg; continuously</td></tr>";a+="<tr><td class=k>&darr;</td><td class=d>Rotate forward "+(this.rotationStep*1)+"&deg; continuously</td></tr>";a+="<tr><td class=k>&uarr;</td><td class=d>Rotate backward "+(this.rotationStep*1)+"&deg; continuously</td></tr>";a+="<tr><td class=k>PgUp</td><td class=d>Rotate anti-clockwise and backward "+(this.rotationStep*3)+"&deg; continuously</td></tr>";a+="<tr><td class=k>PgDn</td><td class=d>Rotate clockwise and forward "+(this.rotationStep*3)+"&deg; continuously</td></tr>"}else{a+="<tr><td class=k>&rarr; or &darr;</td><td class=d>Rotate clockwise "+(this.rotationStep*1)+"&deg; continuously</td></tr>";a+="<tr><td class=k>&larr; or &uarr;</td><td class=d>Rotate anti-clockwise "+(this.rotationStep*1)+"&deg; continuously</td></tr>";a+="<tr><td class=k>PgUp</td><td class=d>Rotate anti-clockwise "+(this.rotationStep*3)+"&deg; continuously</td></tr>";a+="<tr><td class=k>PgDn</td><td class=d>Rotate clockwise "+(this.rotationStep*3)+"&deg; continuously</td></tr>"}}else{if(this.graphType=="Scatter2D"||this.graphType=="ScatterBubble2D"){if(this.type2D=="XYZ"){if(this.xAxis.length>1){a+="<tr><td class=k>&rarr; or &darr; or &larr; or &uarr;</td><td class=d>Update samples in X, Y and Z axes continuously (1x)</td></tr>";a+="<tr><td class=k>PgUp or PgDn</td><td class=d>Update samples in X, Y and Z axes continuously (2x)</td></tr>"}}else{if(this.type2D=="XY"){if(this.zAxis.length>1){a+="<tr><td class=k>&rarr; or &darr; or &larr; or &uarr;</td><td class=d>Update sample in Z axis continuously (1x)</td></tr>";a+="<tr><td class=k>PgUp or PgDn</td><td class=d>Update sample in Z axis continuously (2x)</td></tr>"}}else{if(this.type2D=="X"){if(this.yAxis.length>1){a+="<tr><td class=k>&rarr; or &darr; or &larr; or &uarr;</td><td class=d>Update samples in Y and Z axes continuously (1x)</td></tr>";a+="<tr><td class=k>PgUp or PgDn</td><td class=d>Update samples in Y and Z axes continuously (2x)</td></tr>"}}else{if(this.xAxis.length>1){a+="<tr><td class=k>&rarr; or &darr; or &larr; or &uarr;</td><td class=d>Update samples in X and Z axes continuously (1x)</td></tr>";a+="<tr><td class=k>PgUp or PgDn</td><td class=d>Update samples in X and Z axes continuously (2x)</td></tr>"}}}}}else{if(this.graphType=="Scatter3D"){a+="<tr><td class=k>&rarr; or &darr; or &larr; or &uarr;</td><td class=d>Rotate continuously</td></tr>";a+="<tr><td class=k>PgUp or PgDn</td><td class=d>Rotate continuously</td></tr>"}}}a+="<tr><td class=k>P</td><td class=d>Print</td></tr>";a+="</table>";this.showInfoSpan(false,a)};this.showCtrlAltShorts=function(){var a="<table class=shorts>";a+="<tr><th colspan=2>Ctrl + Alt</th></tr>";a+="<tr><td class=k>P</td><td class=d>Print</td></tr>";a+="</table>";this.showInfoSpan(false,a)};this.showShiftAltShorts=function(){var a="<table class=shorts>";a+="<tr><th colspan=2>Shift + Alt</th></tr>";a+="<tr><td class=k>2</td><td class=d>Scatter2D</td></tr>";a+="<tr><td class=k>3</td><td class=d>Scatter3D</td></tr>";a+="<tr><td class=k>4</td><td class=d>ScatterBubble2D</td></tr>";a+="<tr><td class=k>A</td><td class=d>Area</td></tr>";a+="<tr><td class=k>B</td><td class=d>Bar</td></tr>";a+="<tr><td class=k>C</td><td class=d>BarLine</td></tr>";a+="<tr><td class=k>D</td><td class=d>Dotplot</td></tr>";a+="<tr><td class=k>G</td><td class=d>Genome</td></tr>";a+="<tr><td class=k>H</td><td class=d>Heatmap</td></tr>";a+="<tr><td class=k>I</td><td class=d>Boxplot</td></tr>";a+="<tr><td class=k>L</td><td class=d>Line</td></tr>";a+="<tr><td class=k>M</td><td class=d>Candlestick</td></tr>";a+="<tr><td class=k>N</td><td class=d>Network</td></tr>";a+="<tr><td class=k>P</td><td class=d>Pie</td></tr>";a+="<tr><td class=k>S</td><td class=d>Stacked</td></tr>";a+="<tr><td class=k>U</td><td class=d>StackedLine</td></tr>";a+="<tr><td class=k>T</td><td class=d>StackedPercent</td></tr>";a+="<tr><td class=k>W</td><td class=d>StackedPercentLine</td></tr>";a+="<tr><td class=k>V</td><td class=d>Venn</td></tr>";a+="<tr><td class=k>X</td><td class=d>Correlation</td></tr>";a+="</table>";this.showInfoSpan(false,a)};this.showCtrlShorts=function(){var a="<table class=shorts>";a+="<tr><th colspan=2>Ctrl</th></tr>";if(this.graphType=="Network"){if(this.is3DNetwork){a+="<tr><td class=k>&rarr;</td><td class=d>Rotate clockwise "+(this.rotationStep*1)+"&deg;</td></tr>";a+="<tr><td class=k>&larr;</td><td class=d>Rotate anti-clockwise "+(this.rotationStep*1)+"&deg;</td></tr>";a+="<tr><td class=k>&darr;</td><td class=d>Rotate forward "+(this.rotationStep*1)+"&deg;</td></tr>";a+="<tr><td class=k>&uarr;</td><td class=d>Rotate backward "+(this.rotationStep*1)+"&deg;</td></tr>";a+="<tr><td class=k>PgUp</td><td class=d>Rotate anti-clockwise and backward "+(this.rotationStep*3)+"&deg;</td></tr>";a+="<tr><td class=k>PgDn</td><td class=d>Rotate clockwise and forward "+(this.rotationStep*3)+"&deg;</td></tr>"}else{a+="<tr><td class=k>&rarr; or &darr;</td><td class=d>Rotate clockwise "+(this.rotationStep*1)+"&deg;</td></tr>";a+="<tr><td class=k>&larr; or &uarr;</td><td class=d>Rotate anti-clockwise "+(this.rotationStep*1)+"&deg;</td></tr>";a+="<tr><td class=k>PgUp</td><td class=d>Rotate anti-clockwise "+(this.rotationStep*3)+"&deg;</td></tr>";a+="<tr><td class=k>PgDn</td><td class=d>Rotate clockwise "+(this.rotationStep*3)+"&deg;</td></tr>"}a+="<tr><td class=k>click</td><td class=d>Select/Unselect node</td></tr>";if(this.isSelectNodes){a+="<tr><td class=k>Delete</td><td class=d>Hide selected nodes</td></tr>";a+="<tr><td class=k>Insert</td><td class=d>Show selected-hidden nodes</td></tr>";a+="<tr><td class=k>t</td><td class=d>Align top</td></tr>";a+="<tr><td class=k>r</td><td class=d>Align right</td></tr>";a+="<tr><td class=k>b</td><td class=d>Align bottom</td></tr>";a+="<tr><td class=k>l</td><td class=d>Align left</td></tr>";a+="<tr><td class=k>v</td><td class=d>Distribute verticaly</td></tr>";a+="<tr><td class=k>h</td><td class=d>Distribute Horizontaly</td></tr>";a+="<tr><td class=k>z</td><td class=d>Undo</td></tr>";a+="<tr><td class=k>y</td><td class=d>Redo</td></tr>"}}else{if(this.graphType=="Scatter2D"||this.graphType=="ScatterBubble2D"){if(this.type2D=="XYZ"){if(this.xAxis.length>1){a+="<tr><td class=k>&rarr; or &darr; or &larr; or &uarr;</td><td class=d>Update samples in X, Y and Z axes (1x)</td></tr>";a+="<tr><td class=k>PgUp or PgDn</td><td class=d>Update samples in X, Y and Z axes (2x)</td></tr>"}}else{if(this.type2D=="XY"){if(this.zAxis.length>1){a+="<tr><td class=k>&rarr; or &darr; or &larr; or &uarr;</td><td class=d>Update sample in Z axis (1x)</td></tr>";a+="<tr><td class=k>PgUp or PgDn</td><td class=d>Update sample in Z axis (2x)</td></tr>"}}else{if(this.type2D=="X"){if(this.yAxis.length>1){a+="<tr><td class=k>&rarr; or &darr; or &larr; or &uarr;</td><td class=d>Update samples in Y and Z axes (1x)</td></tr>";a+="<tr><td class=k>PgUp or PgDn</td><td class=d>Update samples in Y and Z axes (2x)</td></tr>"}}else{if(this.xAxis.length>1){a+="<tr><td class=k>&rarr; or &darr; or &larr; or &uarr;</td><td class=d>Update samples in X and Z axes (1x)</td></tr>";a+="<tr><td class=k>PgUp or PgDn</td><td class=d>Update samples in X and Z axes (2x)</td></tr>"}}}}if(this.isSelectDataPoints){a+="<tr><td class=k>Delete</td><td class=d>Hide selected nodes</td></tr>";a+="<tr><td class=k>Insert</td><td class=d>Show selected-hidden nodes</td></tr>"}}else{if(this.graphType=="Scatter3D"){a+="<tr><td class=k>&rarr;</td><td class=d>Rotate clockwise "+(this.rotationStep*1)+"&deg;</td></tr>";a+="<tr><td class=k>&larr;</td><td class=d>Rotate anti-clockwise "+(this.rotationStep*1)+"&deg;</td></tr>";a+="<tr><td class=k>&darr;</td><td class=d>Rotate forward "+(this.rotationStep*1)+"&deg;</td></tr>";a+="<tr><td class=k>&uarr;</td><td class=d>Rotate backward "+(this.rotationStep*1)+"&deg;</td></tr>";a+="<tr><td class=k>PgUp</td><td class=d>Rotate anti-clockwise and backward "+(this.rotationStep*3)+"&deg;</td></tr>";a+="<tr><td class=k>PgDn</td><td class=d>Rotate clockwise and forward "+(this.rotationStep*3)+"&deg;</td></tr>";a+="<tr><td class=k>click</td><td class=d>Select/Unselect data points</td></tr>";if(this.isSelectDataPoints){a+="<tr><td class=k>Delete</td><td class=d>Hide selected nodes</td></tr>";a+="<tr><td class=k>Insert</td><td class=d>Show selected-hidden nodes</td></tr>"}}else{if(this.isSegregable()){}}}}a+="<tr><td class=k>P</td><td class=d>Print</td></tr>";a+="</table>";this.showInfoSpan(false,a)};this.showShiftShorts=function(){var a="<table class=shorts>";a+="<tr><th colspan=2>Shift</th></tr>";if(this.isSegregable()){a+="<tr><td class=k>Click and Drag</td><td class=d>Select Samples</td></tr>"}else{a+="<tr><td class=k>&nbsp;</td><td class=d>&nbsp;</td></tr>"}a+="</table>";this.showInfoSpan(false,a)};this.showAltShorts=function(){var a="<table class=shorts>";a+="<tr><th colspan=2>Alt</th></tr>";a+="<tr><td class=k>&nbsp;</td><td class=d>&nbsp;</td></tr>";a+="</table>";this.showInfoSpan(false,a)};this.arrowMove=function(g,b){switch(this.graphType){case"Network":if(this.is3DNetwork){if(g==33){this.xRotate+=(this.rotationStep*3);this.yRotate-=(this.rotationStep*3)}else{if(g==34){this.xRotate-=(this.rotationStep*3);this.yRotate+=(this.rotationStep*3)}else{if(g==37){this.xRotate+=this.rotationStep}else{if(g==38){this.yRotate-=this.rotationStep}else{if(g==39){this.xRotate-=this.rotationStep}else{if(g==40){this.yRotate+=this.rotationStep}}}}}}}else{if(g==33){this.network2DRotate-=(this.rotationStep*3)}else{if(g==34){this.network2DRotate+=(this.rotationStep*3)}else{if(g==37||g==38){this.network2DRotate-=this.rotationStep}else{if(g==39||g==40){this.network2DRotate+=this.rotationStep}}}}}break;case"Scatter2D":case"ScatterBubble2D":var e;var f;if(this.type2D=="XYZ"){e=["xAxisCurrent","yAxisCurrent","zAxisCurrent"];f=["xAxis","yAxis","zAxis"]}else{if(this.type2D=="XY"){e=["zAxisCurrent"];f=["zAxis"]}else{if(this.type2D=="X"){e=["yAxisCurrent","zAxisCurrent"];f=["yAxis","zAxis"]}else{e=["xAxisCurrent","zAxisCurrent"];f=["xAxis","zAxis"]}}}if(g==33){for(var d=0;d<e.length;d++){this[e[d]]+=2}}else{if(g==34){for(var d=0;d<e.length;d++){this[e[d]]-=2}}else{if(g==35){for(var d=0;d<e.length;d++){this[e[d]]=this[f[d]].length-1}}else{if(g==36){for(var d=0;d<e.length;d++){this[e[d]]=0}}else{if(g==37||g==40){for(var d=0;d<e.length;d++){this[e[d]]--}}else{if(g==38||g==39){for(var d=0;d<e.length;d++){this[e[d]]++}}}}}}}this.xAxisCurrent=this.xAxisCurrent<0?this.xAxis.length-1:this.xAxisCurrent>this.xAxis.length-1?0:this.xAxisCurrent;this.yAxisCurrent=this.yAxisCurrent<0?this.xAxis.length-1:this.yAxisCurrent>this.yAxis.length-1?0:this.yAxisCurrent;this.zAxisCurrent=this.zAxisCurrent<0?this.xAxis.length-1:this.zAxisCurrent>this.zAxis.length-1?0:this.zAxisCurrent;break;case"Scatter3D":if(g==33){this.xRotate+=(this.rotationStep*3);this.yRotate-=(this.rotationStep*3)}else{if(g==34){this.xRotate-=(this.rotationStep*3);this.yRotate+=(this.rotationStep*3)}else{if(g==35){this.xRotate=0;this.yRotate=0;this.zRotate=45}else{if(g==36){this.xRotate=45;this.yRotate=0;this.zRotate=0}else{if(g==37){this.xRotate+=this.rotationStep}else{if(g==38){this.yRotate-=this.rotationStep}else{if(g==39){this.xRotate-=this.rotationStep}else{if(g==40){this.yRotate+=this.rotationStep}}}}}}}}break}if(b&&!this.animationOn){this.animationOn=true;this.animate(g)}else{this.draw(false,false,false,true)}};this.animate=function(d){var a=this;var b=function(){this.update=function(){if(!a.animationOn){clearInterval(c)}a.arrowMove(d);switch(a.graphType){case"Network":if(this.is3DNetwork){if(d==33){this.xRotate+=(this.rotationStep*3);this.yRotate-=(this.rotationStep*3)}else{if(d==34){this.xRotate-=(this.rotationStep*3);this.yRotate+=(this.rotationStep*3)}else{if(d==37){this.xRotate-=this.rotationStep}else{if(d==38){this.yRotate-=this.rotationStep}else{if(d==39){this.xRotate+=this.rotationStep}else{if(d==40){this.yRotate+=this.rotationStep}}}}}}}else{if(d==33){this.network2DRotate+=(this.rotationStep*3)}else{if(d==34){this.network2DRotate-=(this.rotationStep*3)}else{if(d==37||d==38){this.network2DRotate-=this.rotationStep}else{if(d==39||d==40){this.network2DRotate+=this.rotationStep}}}}}break;case"Scatter2D":case"ScatterBubble2D":if(d!=37){if(a.graphType=="ScatterBubble2D"&&a.xAxisIndices.length>1&&a.xAxisIndices.length==a.yAxisIndices.length&&a.xAxisIndices.length==a.zAxisIndices.length){if(a.xAxisCurrent>=a.xAxis.length-1){a.xAxisCurrent=a.xAxis.length-1;a.yAxisCurrent=a.yAxis.length-1;a.zAxisCurrent=a.zAxis.length-1;d=37}}else{if(a.xAxisIndices.length>1&&a.xAxisIndices.length==a.yAxisIndices.length){if(a.zAxisCurrent>=a.zAxis.length-1){a.zAxisCurrent=a.zAxis.length-1;d=37}}else{if(a.xAxisIndices.length>a.yAxisIndices.length){if(a.yAxisCurrent>=a.yAxis.length-1){a.yAxisCurrent=a.yAxis.length-1}if(a.zAxisCurrent>=a.zAxis.length-1){a.zAxisCurrent=a.zAxis.length-1}if(a.yAxisCurrent>=a.yAxis.length-1&&a.zAxisCurrent>=a.zAxis.length-1){d=37}}else{if(a.xAxisCurrent>=a.xAxis.length-1){a.xAxisCurrent=a.xAxis.length-1}if(a.zAxisCurrent>=a.zAxis.length-1){a.zAxisCurrent=a.zAxis.length-1}if(a.xAxisCurrent>=a.xAxis.length-1&&a.zAxisCurrent>=a.zAxis.length-1){d=37}}}}}else{if(d!=39){if(a.graphType=="ScatterBubble2D"&&a.xAxisIndices.length>1&&a.xAxisIndices.length==a.yAxisIndices.length&&a.xAxisIndices.length==a.zAxisIndices.length){if(a.xAxisCurrent<=0){a.xAxisCurrent=0;a.yAxisCurrent=0;a.zAxisCurrent=0;d=39}}else{if(a.xAxisIndices.length>1&&a.xAxisIndices.length==a.yAxisIndices.length){if(a.zAxisCurrent<=0){a.zAxisCurrent=0;d=39}}else{if(a.xAxisIndices.length>a.yAxisIndices.length){if(a.yAxisCurrent<=0){a.yAxisCurrent=0}if(a.zAxisCurrent<=0){a.zAxisCurrent=0}if(a.yAxisCurrent<=0&&a.zAxisCurrent<=0){d=39}}else{if(a.xAxisCurrent<=0){a.xAxisCurrent=0}if(a.zAxisCurrent<=0){a.zAxisCurrent=0}if(a.xAxisCurrent<=0&&a.zAxisCurrent<=0){d=39}}}}}}break;case"Scatter3D":if(a.xRotate<=0&&(d==39||d<37)){a.xRotate=0;a.yRotate=0;d=40}else{if(a.xRotate>=90&&(d==37||d<37)){a.xRotate=90;a.yRotate=90;d=38}else{if(a.yRotate<=0&&(d==38||d<37)){a.yRotate=0;a.xRotate=90;d=39}else{if(a.yRotate>=90&&(d==40||d<37)){a.yRotate=90;a.xRotate=0;d=37}}}}break}};var c=setInterval(this.update,a.animationTime)};b.call()};this.setGraphType=function(b){var a;if(b==66){a="Bar"}else{if(b==76){a="Line"}else{if(b==65){a="Area"}else{if(b==67){a="BarLine"}else{if(b==73){a="Boxplot"}else{if(b==68){a="Dotplot"}else{if(b==72){a="Heatmap"}else{if(b==83){a="Stacked"}else{if(b==85){a="StackedLine"}else{if(b==84){a="StackedPercent"}else{if(b==87){a="StackedPercentLine"}else{if(b==50){a="Scatter2D"}else{if(b==52){a="ScatterBubble2D"}else{if(b==51){a="Scatter3D"}else{if(b==88){a="Correlation"}else{if(b==86){a="Venn"}else{if(b==80){a="Pie"}else{if(b==78){a="Network"}else{if(b==71){a="Genome"}else{if(b==77){a="Candlestick"}}}}}}}}}}}}}}}}}}}}if(a&&this.isValidGraphType(a)){this.graphType=a;this.draw()}else{alert("Dude! You cannot plot this data in a "+a+" graph")}};this.redraw=function(){this.setInitialConfig();switch(this.graphType){case"Area":case"AreaLine":case"Stacked":case"StackedLine":case"StackedPercent":case"StackedPercentLine":case"Correlation":case"Venn":case"Pie":this.setAllVariablesVisible();this.setAllSamplesVisible();return true;case"Bar":case"Line":case"BarLine":case"Boxplot":case"Dotplot":case"Genome":case"Candlestick":this.setAllVariablesVisible();this.setAllSamplesVisible();this.setMin=null;this.setMax=null;this.setMin2=null;this.setMax2=null;break;case"Scatter2D":case"ScatterBubble2D":this.resetSelectedDataPoints();this.setAllVariablesVisible();this.setAllSamplesVisible();this.setMinX=null;this.setMaxX=null;this.setMinY=null;this.setMaxY=null;break;case"Scatter3D":this.resetSelectedDataPoints();this.setAllVariablesVisible();this.setAllSamplesVisible();this.xRotate=45;this.yRotate=0;break;case"Heatmap":this.setAllVariablesVisible();this.setAllSamplesVisible();this.varIndicesStart=-1;this.smpIndicesStart=-1;break;case"Network":this.resetSelectedNodes();this.setAllNodesVisible();this.network2DRotate=0;if(this.randomNetwork){this.layoutDone=false}this.ctx.translate(-this.offsetX,-this.offsetY);this.ctx.scale(1/this.scaleFactor,1/this.scaleFactor);break}this.draw();return true};this.resetZoomPan=function(){this.zoom=1;this.panningX=0;this.panningY=0;this.panningGlobalX=0;this.panningGlobalY=0};this.masterReset=function(a){this.resetDragDiv(a);this.resetSelectedDataPoints();this.resetSelectedNodes();this.hideUnhideDataTable(true);this.resetConfigurator();this.resetAxesResizer(a);this.resetFlags(a);this.resetZoomPan();this.redraw()}};CanvasXpress.prototype.initDraggingEvents=function(){this.addDragDiv=function(){if(document.getElementById(this.target+"canvasXpressDrag")){return}var a=document.createElement("div");a.id=this.target+"canvasXpressDrag";a.style.width="0.5px";a.style.height="0.5px";a.style.opacity=0.5;a.style.filter="alpha(opacity = 50)";a.style.backgroundColor=this.skinBackgroundColor;a.style.position="absolute";a.style.zIndex=9000;this.canvas.parentNode.appendChild(a)};this.registerDragDivNetwork=function(k){var d,h,g;var j=this.modelEvent!="local"?this.isEvent(k,true):false;var b=k.target||k.srcElement;var a=this.modelEvent!="local"?j[1]:b.id;var c=false;if(a&&a.match(/-legend-/)){if(a.match(/-legend-Nodes/)){this.moveLegend="Nodes"}else{if(a.match(/-legend-Edges/)){this.moveLegend="Edges"}else{if(a.match(/-legend-Decorations/)){this.moveLegend="Decorations"}else{this.moveLegend=a.split(/-legend-/)[1]}}}c=true}else{if(a&&a.match(/-lab$/)){if(k.shiftKey){d=this.modelEvent!="local"?j[0][0]:parseInt(a.split(/-lab/)[0].replace(this.target,""));h=true}else{if(this.modelEvent!="local"){d=j[0][0]}else{d=this.isEvent(k);d=parseInt(d.split(/-/)[0].replace(this.target,""))}}}else{if(a&&a.match(/-dec$/)){if(k.shiftKey){d=this.modelEvent!="local"?j[0][0]:parseInt(a.split(/-dec/)[0].replace(this.target,""));g=true}else{this.resetDragDiv(k);this.resetFlags(k)}}else{if(this.modelEvent!="local"){d=j?j[0][0]:"NaN"}else{d=this.isEvent(k);if(d){d=parseInt(d.split(/-/)[0].replace(this.target,""))}else{d=parseInt(a.replace(this.target,""))}}}}if(!isNaN(d)&&d<this.data.nodes.length){b.style.cursor="move";this.moveNode=true;this.moveNodeIndex=d;if(h){this.moveNodeLab=true}else{if(g){this.moveNodeDec=true}}var f=this.data.nodes[this.moveNodeIndex];this.moveNodeW=f.width?f.width:f.size?(this.nodeSize*f.size):this.nodeSize;this.moveNodeH=f.height?f.height:f.size?(this.nodeSize*f.size):this.nodeSize;if(this.moveNodeLab){this.moveNodeX=f.labelX!=null?f.labelX-((this.xMouseDown/this.scaleFactor)-this.offsetX):0;this.moveNodeY=f.labelY!=null?f.labelY-((this.yMouseDown/this.scaleFactor)-this.offsetY):0}else{if(this.moveNodeDec){this.moveNodeX=f.decorationsX?f.decorationsX-((this.xMouseDown/this.scaleFactor)-this.offsetX):0;this.moveNodeY=f.decorationsY?f.decorationsY-((this.yMouseDown/this.scaleFactor)-this.offsetY):0}else{if(this.is3DNetwork){this.moveNodeX=f.x3d-((this.xMouseDown/this.scaleFactor)-this.offsetX);this.moveNodeY=f.y3d-((this.yMouseDown/this.scaleFactor)-this.offsetY)}else{this.moveNodeX=f.x-((this.xMouseDown/this.scaleFactor)-this.offsetX);this.moveNodeY=f.y-((this.yMouseDown/this.scaleFactor)-this.offsetY)}}}c=true}}if(c){this.addToNetworkStack()}};this.registerDragDivGenome=function(b){var a=this.modelEvent!="local"?this.isEvent(b,true):false;if(a&&isNaN(a[0][0])){this.moveGenome=a[0][0]}else{this.moveGenome=false}};this.registerDragDiv=function(k){if(!k){k=window.event}if(this.isCanvasResize(k)){this.resizingCanvasOn=true}else{if(!k){return}var p=this.adjustedCoordinates(k);if(p){var a=p.x;var q=p.y;var o=0;for(var f=0;f<this.layoutRows;f++){for(var b=0;b<this.layoutCols;b++){var h=this.layoutComb?this.layoutParams[o].graphType:this.graphType;if(h.match(/Correlation|Pie|Venn|Stacked|Area/)){return false}else{if(h=="Genome"){this.registerDragDivGenome(k)}}var n=this.getBoundsXY(o);if(a>=n[0]&&a<=n[1]&&q>=n[2]&&q<=n[3]||this.moveGenome){this.skipClick=false;this.draggingOn=true;this.xMouseDown=a;this.yMouseDown=q;var m=document.getElementById(this.target+"canvasXpressDrag");if(h=="Network"){this.registerDragDivNetwork(k)}if((!h.match(/Scatter|Heatmap|Network|Genome/)&&this.graphOrientation=="vertical"&&!k.shiftKey)||(!h.match(/Scatter|Heatmap|Network|Genome/)&&this.graphOrientation!="vertical"&&k.shiftKey)){m.style.left=n[0]+"px"}else{m.style.left=this.xMouseDown+"px"}if((!h.match(/Scatter|Heatmap|Network|Genome/)&&this.graphOrientation!="vertical"&&!k.shiftKey)||(!h.match(/Scatter|Heatmap|Network|Genome/)&&this.graphOrientation=="vertical"&&k.shiftKey)||h=="Genome"){m.style.top=n[2]+"px"}else{m.style.top=this.yMouseDown+"px"}if(this.layoutValid){this.layoutValidR=f;this.layoutValidC=b;this.layoutValidN=o}return false}o++}}}}};this.updateDragDivScatter3D=function(d,u,g,e,m){if(!this.rotatingOn){this.rotatingOn=new Date().getTime();var k=this;var b=this.xMouseDown;var o=this.yMouseDown;var a=d;var n=u;var f=this.lineLength(b,o,a,n);var r=this.layoutComb?this.layoutParams[m].x:this.x;var h=this.layoutComb?this.layoutParams[m].y:this.y;var v=((a-b)*this.rotationSensitivity)/r;var s=((n-o)*this.rotationSensitivity)/h;var q=(f*this.rotationSensitivity)/r;this.xRotate-=v;this.yRotate+=s;this.zRotate-=q;this.draw();this.rotatingOn=true;this.skipClick=false;var p=function(){this.update=function(){var j=new Date().getTime();if(j-k.rotatingOn>k.rotationDelay){k.rotatingOn=false;clearInterval(c)}};var c=setInterval(this.update,20)};p.call()}};this.updateDragDivNetwork=function(n,f,v,k,g,o){this.movingOn=true;var q=f;var p=v;var d,z,u,s;var a=n.target||n.srcElement;if(this.moveNode||this.moveLegend){if(this.moveLegend){if(this.moveLegend=="Nodes"){z=this.data.legend.pos.nodes.x-((q/this.scaleFactor)-this.offsetX);u=this.data.legend.pos.nodes.y-((p/this.scaleFactor)-this.offsetY);this.data.legend.pos.nodes.x-=z;this.data.legend.pos.nodes.y-=u}else{if(this.moveLegend=="Edges"){z=this.data.legend.pos.edges.x-((q/this.scaleFactor)-this.offsetX);u=this.data.legend.pos.edges.y-((p/this.scaleFactor)-this.offsetY);this.data.legend.pos.edges.x-=z;this.data.legend.pos.edges.y-=u}else{if(this.moveLegend=="Decorations"){z=this.data.legend.pos.decorations.x-((q/this.scaleFactor)-this.offsetX);u=this.data.legend.pos.decorations.y-((p/this.scaleFactor)-this.offsetY);this.data.legend.pos.decorations.x-=z;this.data.legend.pos.decorations.y-=u}else{s=parseInt(this.moveLegend.replace("Text",""));z=this.data.legend.text[s].x-((q/this.scaleFactor)-this.offsetX);u=this.data.legend.text[s].y-((p/this.scaleFactor)-this.offsetY);this.data.legend.text[s].x-=z;this.data.legend.text[s].y-=u}}}}else{if(this.data.nodes[this.moveNodeIndex]){d=this.data.nodes[this.moveNodeIndex];if(this.is3DNetwork){z=(d.x3d-((q/this.scaleFactor)-this.offsetX))-this.moveNodeX;u=(d.y3d-((p/this.scaleFactor)-this.offsetY))-this.moveNodeY}else{z=(d.x-((q/this.scaleFactor)-this.offsetX))-this.moveNodeX;u=(d.y-((p/this.scaleFactor)-this.offsetY))-this.moveNodeY}if(this.moveNodeLab){z=d.labelX!=null?(d.labelX-((q/this.scaleFactor)-this.offsetX))-this.moveNodeX:z;u=d.labelY!=null?(d.labelY-((p/this.scaleFactor)-this.offsetY))-this.moveNodeY:u;this.modifyXYNodeLab(d.id,z,u)}else{if(this.moveNodeDec){z=d.decorationsX?(d.decorationsX-((q/this.scaleFactor)-this.offsetX))-this.moveNodeX:z;u=d.decorationsY?(d.decorationsY-((p/this.scaleFactor)-this.offsetY))-this.moveNodeY:u;this.modifyXYNodeDec(d.id,z,u)}else{if(n.shiftKey){var r=(this.moveNodeW-z)+((f-this.xMouseDown)/this.scaleFactor);var m=(this.moveNodeH-u)+((v-this.yMouseDown)/this.scaleFactor);this.modifyNodeSize(d.id,Math.abs(r),Math.abs(m));for(var s in this.selectNode){if(s!=d.id){this.modifyNodeSize(s,r,m)}}}else{this.modifyXYNode(d.id,z,u);for(var s in this.selectNode){if(s!=d.id){this.modifyXYNode(s,z,u)}}}}}}}}else{this.panningX=((f-this.xMouseDown)/this.scaleFactor);this.panningY=((v-this.yMouseDown)/this.scaleFactor)}this.skipClick=z!=null||u!=null?true:false;this.draw(false,false,false,true);if(this.is3DNetwork&&d){this.moveNodeIndex=this.data.nodeIndices[d.id]}var b=document.getElementById(a.id);if(b){b.style.cursor=n.shiftKey?"se-resize":"move"}};this.updateDragDivGenome=function(h,a,g,f,b,m){this.movingOn=true;var k=document.getElementById(this.target+"canvasXpressDrag");k.style.left="0px";k.style.width=this.width+"px";k.style.top=g+"px";k.style.height="3px"};this.updateDragDiv=function(k){if(this.draggingOn){if(!k){k=window.event}if(this.resetOn){this.resetOn=false;this.stopEvent(k);return}var p=this.adjustedCoordinates(k);if(p){var a=p.x;var q=p.y;var f=this.layoutValidR;var b=this.layoutValidC;var o=this.layoutValidN;var h=this.layoutComb?this.layoutParams[o].graphType:this.graphType;if(h.match(/Correlation|Pie|Venn|Stacked|Area/)){return false}if(h=="Scatter3D"&&!k.shiftKey){this.updateDragDivScatter3D(a,q,f,b,o)}else{if(h=="Network"&&((this.moveNode||this.moveLegend)||(!k.ctrlKey&&!k.shiftKey&&!k.altKey))){this.updateDragDivNetwork(k,a,q,f,b,o)}else{if(h=="Genome"&&this.moveGenome){this.updateDragDivGenome(k,a,q,f,b,o)}else{var n=this.getBoundsXY(o);var m=document.getElementById(this.target+"canvasXpressDrag");this.skipClick=true;if((!h.match(/Scatter|Heatmap|Network|Genome/)&&this.graphOrientation=="vertical"&&!k.shiftKey)||(!h.match(/Scatter|Heatmap|Network|Genome/)&&this.graphOrientation!="vertical"&&k.shiftKey)){m.style.width=(n[1]-n[0])+"px"}else{if(a>this.xMouseDown){if(a>n[1]){m.style.width=(n[1]-this.xMouseDown)+"px"}else{m.style.width=(a-this.xMouseDown)+"px"}}else{if(a<n[0]){m.style.left=n[0]+"px";m.style.width=(this.xMouseDown-n[0])+"px"}else{m.style.left=a+"px";m.style.width=(this.xMouseDown-a)+"px"}}}if((!h.match(/Scatter|Heatmap|Network|Genome/)&&this.graphOrientation!="vertical"&&!k.shiftKey)||(!h.match(/Scatter|Heatmap|Network|Genome/)&&this.graphOrientation=="vertical"&&k.shiftKey)||h=="Genome"){m.style.height=(n[3]-n[2])+"px"}else{if(q>this.yMouseDown){if(q>n[3]){m.style.height=(n[3]-this.yMouseDown)+"px"}else{m.style.height=(q-this.yMouseDown)+"px"}}else{if(q<n[2]){m.style.top=n[2]+"px";m.style.height=(this.yMouseDown-n[2])+"px"}else{m.style.top=q+"px";m.style.height=(this.yMouseDown-q)+"px"}}}}}}}this.movingOn=true;this.resetOn=false}};this.endDragDiv=function(z){if(this.draggingOn){var b=this.layoutComb?this.layoutParams[this.layoutValidN].graphType:this.graphType;if(b.match(/Correlation|Pie|Venn|Stacked|Area/)){return false}if(!z){z=window.event}var j=document.getElementById(this.target+"canvasXpressImage");if(j){j.style.cursor="default";var w=z.target||z.srcElement;if(w&&w.style){w.style.cursor="default"}}this.panningGlobalX+=this.panningX;this.panningGlobalY+=this.panningY;this.panningX=0;this.panningY=0;if(b=="Scatter3D"&&!z.shiftKey){this.resetDragDiv(z)}else{if(b=="Network"&&(this.moveNode||this.moveLegend)){if(j){if(this.isSelectNodes&&this.movingOn){this.resetSelectedNodes();this.draw()}if(this.userEvents.enddragnode&&this.movingOn){var m;if(this.moveLegend){m={legend:this.moveLegend}}else{var p=this.moveNodeIndex;var k=this.findChildrenNodeIndices(this.data.nodes[p].id);if(k){k.push(p)}else{k=[p]}m=this.extractDataObject(k)}this.resetDragDiv(z);this.userEvents.enddragnode.call(this,m)}else{this.resetDragDiv(z)}}}else{if(b=="Genome"&&(this.moveGenome)){if(this.movingOn){var B=this.adjustedCoordinates(z);var C=[];if(B){var n=B.y;if(n!=this.yMouseDown){var A=this.moveGenome.replace("track-","").split(":");var a=parseInt(A[0]);var u=A.length>1?parseInt(A[1]):null;for(var v=0;v<this.subtracksInfo.length;v++){var q=this.subtracksInfo[v].start;var h=this.subtracksInfo[v].track;var g=this.subtracksInfo[v].index;if(q>n){if(a!=h&&a!=h-1){if(h>a){h--}var o=this.data.tracks.splice(a,1)[0];this.data.tracks.splice(h,0,o);this.draw()}else{if(u!=null){if(a==h-1){g=this.subtracksInfo[v-1].index;g++}u=this.subtracksInfo[u].index;if(u!=g){if(g>u){g--}var o=this.data.tracks[a].data.splice(u,1)[0];this.data.tracks[a].data.splice(g,0,o);this.draw()}}}break}}}}}this.resetDragDiv(z)}else{if(this.movingOn){var B=this.adjustedCoordinates(z);if(B){var r=B.x;var n=B.y;if(r!=this.xMouseDown||n!=this.yMouseDown){var A=document.getElementById(this.target+"canvasXpressDrag");var y=parseInt(A.style.left);var f=parseInt(A.style.top);var x=y+parseInt(A.style.width);var c=f+parseInt(A.style.height);this.handleDragEvent(z,y,f,x,c);this.resetDragDiv(z)}}}else{this.resetDragDiv(z)}}}}}else{this.resetDragDiv(z)}};this.validateMinMax=function(b,a){if(!isNaN(b)&&!isNaN(a)){if(b>a){return false}return true}else{return false}};this.isObjectInsideCoordiantes=function(b,g,d,m,c,j){var k,h;switch(b){case"rect":k=(g[0]+g[2])/2;h=(g[1]+g[3])/2;break;case"circle":k=g[0];h=g[1];break;case"poly":var e=[];var a=[];for(var f=0;f<g.length;f++){if(f%2){a.push(g[f])}else{e.push(g[f])}}e.sort(function(o,n){return(o-n)});a.sort(function(o,n){return(o-n)});k=(e[0]+e[e.length-1])/2;h=(a[0]+a[a.length-1])/2;break}return this.isPointInsideArea("rect",k,h,[d,m,c,j])};this.handleDragEventNetwork=function(r,f,z,c,x){var g={};var p=[];var B=[];var A=[];var u=[];var y={};if(this.modelEvent=="local"){var j=document.getElementById(this.target+"canvasXpressMap");if(j){var v=j.childNodes;for(var o=0;o<v.length;o++){var k=this.toNumber(v[o].id.replace(this.target,""));var q=this.toNumber(v[o].coords.split(","));var b=v[o].shape;if(this.isObjectInsideCoordiantes(b,q,f,z,c,x)){if(k<this.data.nodes.length){g[k]=1}}}}}else{for(var o=0;o<this.dataEvent.length;o++){var k=this.dataEvent[o][0];var b=this.dataEvent[o][1];var q=this.dataEvent[o][2];if(this.isObjectInsideCoordiantes(b,q,f,z,c,x)){if(k<this.data.nodes.length){g[k]=1}}}}for(var o=0;o<this.data.nodes.length;o++){if(!g[o]){p.push(this.data.nodes[o].id)}else{B.push(this.data.nodes[o].id);A.push(o)}}if(p.length<this.data.nodes.length){if(r.shiftKey){this.setSelectNodes(B);this.isSelectNodes=B.length;this.draw();this.draggingOn=false;this.showInfoSpan(r,"While mouse-over nodes:<br>1. Press Shift and drag mouse to resize nodes<br>2. Drag mouse to move nodes")}else{this.resetZoomPan();this.hideUnhideNodes(p,true);this.ctx.translate(-this.offsetX,-this.offsetY);this.ctx.scale(1/this.scaleFactor,1/this.scaleFactor);this.draw(false,false,false,true)}if(this.showDataTableOnSelect){if(this.networkShowDataTable=="edges"){for(var o=0;o<B.length;o++){y[B[o]]=1}for(var o=0;o<this.data.edges.length;o++){if(y[this.data.edges[o].id1]||y[this.data.edges[o].id2]){u.push(this.data.nodes.length+o)}}this.updateDataTable(this.extractDataObject(u))}else{this.updateDataTable(this.extractDataObject(A))}}}};this.setOriginalIndices=function(e,d,a){if(!d){d=this.layoutComb?this.layoutParams[e].varIndices:this.varIndices}if(!a){if(this.isGroupedData){a=this.layoutComb?this.layoutParams[e].grpIndices:this.grpIndices}else{a=this.layoutComb?this.layoutParams[e].smpIndices:this.smpIndices}}if(!this.startingVarIndices){this.startingVarIndices=[]}if(!this.startingSmpIndices){this.startingSmpIndices=[]}if(!this.startingVarIndices[e]){this.startingVarIndices[e]=[];for(var b=0;b<d.length;b++){this.startingVarIndices[e][b]=d[b]}}if(!this.startingSmpIndices[e]){this.startingSmpIndices[e]=[];for(var b=0;b<a.length;b++){this.startingSmpIndices[e][b]=a[b]}}};this.handleDragEventHeatmap=function(k,e,q,b,p){var r=[];var w=[];var u;this.resetAxesResizer();var t=this.layoutComb?this.layoutParams[k].varIndices:this.varIndices;if(this.isGroupedData){u=this.layoutComb?this.layoutParams[k].grpIndices:this.grpIndices}else{u=this.layoutComb?this.layoutParams[k].smpIndices:this.smpIndices}this.setOriginalIndices(k,t,u);if(this.layoutComb){this.varIndicesStart=this.layoutParams[k].varIndicesStart<0?0:this.layoutParams[k].varIndicesStart;this.smpIndicesStart=this.layoutParams[k].smpIndicesStart<0?0:this.layoutParams[k].smpIndicesStart}else{this.varIndicesStart=this.varIndicesStart<0?0:this.varIndicesStart;this.smpIndicesStart=this.smpIndicesStart<0?0:this.smpIndicesStart}this.varIndices=[];if(this.isGroupedData){this.grpIndices=[]}else{this.smpIndices=[]}if(this.modelEvent=="local"){var f=document.getElementById(this.target+"canvasXpressMap");if(f){var n=f.childNodes;for(var h=0;h<n.length;h++){var g=this.toNumber(n[h].id.replace(this.target,"").split(","));var j=this.toNumber(n[h].coords.split(","));if((e<j[0]||e<j[2])&&b>j[0]&&(q<j[1]||q<j[3])&&p>j[1]){if(!r[g[0]]){this.varIndices.push(g[0]);r[g[0]]=1}if(!w[g[1]]){if(this.isGroupedData){this.grpIndices.push(g[1])}else{this.smpIndices.push(g[1])}w[g[1]]=1}}}}}else{for(var h=0;h<this.dataEvent.length;h++){var g=this.dataEvent[h][0];var j=this.dataEvent[h][2];if((e<j[0]||e<j[2])&&b>j[0]&&(q<j[1]||q<j[3])&&p>j[1]){if(!r[g[0]]){this.varIndices.push(g[0]);r[g[0]]=1}if(!w[g[1]]){if(this.isGroupedData){this.grpIndices.push(g[1])}else{this.smpIndices.push(g[1])}w[g[1]]=1}}}}for(var h=0;h<t.length;h++){if(t[h]==this.varIndices[0]){this.varIndicesStart+=h}}for(var h=0;h<u.length;h++){if(this.isGroupedData){if(u[h]==this.grpIndices[0]){this.smpIndicesStart+=h}}else{if(u[h]==this.smpIndices[0]){this.smpIndicesStart+=h}}}this.draw();if(this.showDataTableOnSelect){var d=this.extractDataObject(this.smpIndices,this.varIndices);this.updateDataTable(d)}this.skipClick=false};this.handleDragEventScatter=function(D,f,E,C,p,A,n){this.selectDataPoint=[];var b={v:{},s:{}};var t=0;if(D.shiftKey){if(this.modelEvent=="local"){var v=document.getElementById(this.target+"canvasXpressMap");if(v){var F=v.childNodes;for(var y=0;y<F.length;y++){var r=this.toNumber(F[y].id.replace(this.target,""));var q=this.toNumber(F[y].coords.split(","));var z=F[y].shape;if(this.isObjectInsideCoordiantes(z,q,C,p,A,n)){this.addRemoveToSelectedDataPoints(f,r);b.v[r.shift()]=1;for(var x=0;x<r.length;x++){b.s[r[x]]=1}t++}}}}else{for(var y=0;y<this.dataEvent.length;y++){var r=this.dataEvent[y][0];var z=this.dataEvent[y][1];var q=this.dataEvent[y][2];if(this.isObjectInsideCoordiantes(z,q,C,p,A,n)){this.addRemoveToSelectedDataPoints(f,r);b.v[r.shift()]=1;for(var x=0;x<r.length;x++){b.s[r[x]]=1}t++}}}if(t>0){this.isSelectDataPoints=t;this.draw();if(this.showDataTableOnSelect){var w=[];var B=[];for(y in b.v){w.push(parseInt(y))}for(y in b.s){B.push(parseInt(y))}w.sort(function(e,c){return(e-c)});B.sort(function(e,c){return(e-c)});var u=this.extractDataObject(B,w);this.updateDataTable(u)}}}else{var u=this.layoutComb?this.layoutParams[E]:this;var k=u.xAxisMin+((C-(this.marginLeft+u.offsetX+u.left))/u.xAxisUnit);var h=u.xAxisMin+((A-(this.marginLeft+u.offsetX+u.left))/u.xAxisUnit);var d=u.yAxisMax-((p-(this.marginTop+u.offsetY+u.top))/u.yAxisUnit);var g=u.yAxisMax-((n-(this.marginTop+u.offsetY+u.top))/u.yAxisUnit);if(this.validateMinMax(k,h)&&this.validateMinMax(g,d)){this.setMinX=k;this.setMaxX=h;this.setMaxY=d;this.setMinY=g;this.draw()}}};this.handleDragEventGenome=function(j,d,f,b,e){var a,h;var g=this.layoutComb?this.layoutParams[j]:this;var a=g.xAxisMin+((d-(this.marginLeft+g.offsetX+g.left))/g.xAxisUnit);var h=g.xAxisMin+((b-(this.marginLeft+g.offsetX+g.left))/g.xAxisUnit);if(this.validateMinMax(a,h)){this.setMin=a;this.setMax=h;this.draw()}};this.handleDragEventOneDimension=function(A,b,E,y,f,x,d,H){if(A.shiftKey||H){var n=[];var F=[];if(this.modelEvent=="local"){var q=document.getElementById(this.target+"canvasXpressMap");if(q){var G=q.childNodes;for(var u=1;u<G.length;u++){var h=this.toNumber(G[u].id.replace(this.target,"").split(","));var g=this.toNumber(G[u].coords.split(","));var v=G[u].shape;if(this.isObjectInsideCoordiantes(v,g,y,f,x,d)){if(!n[h[1]]){F.push(h[1]);n[h[1]]=1}}}}}else{for(var u=0;u<this.dataEvent.length;u++){var h=this.dataEvent[u][0];var v=this.dataEvent[u][1];var g=this.dataEvent[u][2];if(this.isObjectInsideCoordiantes(v,g,y,f,x,d)){if(!n[h[1]]){F.push(h[1]);n[h[1]]=1}}}}this.setSamplesVisible(F,true);this.draw();if(this.showDataTableOnSelect){var p=this.extractDataObject(F,this.varIndices);this.updateDataTable(p)}}else{var p=this.layoutComb?this.layoutParams[E]:this;var k=b=="Candlestick"&&E>0&&this.showVolume;var j=this.layoutComb&&this.layoutCurrent!=E;var r=k&&j?p.xAxis2Min:p.xAxisMin;var w=k&&j?p.xAxis2Max:p.xAxisMax;var D=this.marginLeft+p.offsetX+p.left;var C=D+p.x;var B=this.marginTop+p.offsetY+p.top;var z=B+p.y;if(this.graphOrientation=="vertical"){r=k?r+((z-d)/p.xAxis2Unit):r+((z-d)/p.xAxisUnit);w=k?w-((f-B)/p.xAxis2Unit):w-((f-B)/p.xAxisUnit)}else{r=k?r+((y-D)/p.xAxis2Unit):r+((y-D)/p.xAxisUnit);w=k?w-((C-x)/p.xAxis2Unit):w-((C-x)/p.xAxisUnit)}if(this.validateMinMax(r,w)){if(k){this.setMin2=r;this.setMax2=w}else{this.setMin=r;this.setMax=w}this.draw()}}};this.handleDragEvent=function(h,b,f,a,d){var j=this.layoutComb?this.layoutValidN:0;var g=this.layoutComb?this.layoutParams[j].graphType:this.graphType;if(g=="Network"){this.handleDragEventNetwork(h,b,f,a,d)}else{if(g=="Heatmap"){this.handleDragEventHeatmap(j,b,f,a,d)}else{if(g.match(/Scatter/)){this.handleDragEventScatter(h,g,j,b,f,a,d)}else{if(g=="Genome"){this.handleDragEventGenome(j,b,f,a,d)}else{this.handleDragEventOneDimension(h,g,j,b,f,a,d)}}}}};this.resetDragDiv=function(a){var b=document.getElementById(this.target+"canvasXpressDrag");if(b){b.style.left="0px";b.style.top="0px";b.style.width="0px";b.style.height="0px"}};this.initializeDraggingEvents=function(){if(!this.disableEvents){this.addDragDiv()}};this.initializeDraggingEvents()};CanvasXpress.prototype.initInfoEvents=function(){this.addInfoSpan=function(){if(document.getElementById(this.target+"canvasXpressInfo")){this.resetInfoSpan();return}var a=document.createElement("span");a.id=this.target+"canvasXpressInfo";a.style.color=this.skinColor;a.style.backgroundColor=this.skinBackgroundColor;a.style.margin="2px 3px";a.style.padding="2px 3px";a.style.fontSize="x-small";a.style.border="1px solid "+this.skinBorderColor;a.style.boxShadow="2px 2px 2px "+this.skinShadowColor;a.style.MozBoxShadow="2px 2px 2px "+this.skinShadowColor;a.style.borderRadius="3px";a.style.position="absolute";a.style.display="none";a.style.zIndex=29010;this.canvas.parentNode.appendChild(a)};this.resetInfoSpan=function(d,c){var b=document.getElementById(this.target+"canvasXpressInfo");if(b){var a=new Date().getTime()-this.infoStartTime;if(a>this.infoTimeIn||c){b.style.left="0px";b.style.top="0px";b.style.display="none";b.innerHTML=""}}};this.showInfoSpan=function(b,g,a){if(this.draggingOn||this.remoteUpdating){return}var j=new Date().getTime()-this.infoStartTime;var k=document.getElementById(this.target+"canvasXpressInfo");if(k&&g&&g!=""&&j>this.infoTimeIn){var h=this.adjustedCoordinates(b,k);if(h){var d=h.x;var c=b?h.y:h.y+25;if(!isNaN(g)){g=g.toString()}if(g.match(/\w/)){k.style.left=(d+5)+"px";k.style.top=(c-20)+"px";k.style.display="inline";k.innerHTML=g;this.infoStartTime=new Date().getTime();var j=this;var f=function(){this.update=function(){var m=new Date().getTime();if(m-j.infoStartTime>j.infoTimeOut){j.resetInfoSpan();clearInterval(e)}};var e=setInterval(this.update,100)};f.call()}}}};this.initializeInfoEvents=function(){if(!this.disableEvents){this.addInfoSpan()}};this.initializeInfoEvents()};CanvasXpress.prototype.initLinkEvents=function(){this.addLinkDiv=function(){if(document.getElementById(this.target+"canvasXpressLink")){this.resetLinkDiv();return}var a=document.createElement("img");a.id=this.target+"canvasXpressLinkClose";a.src=this.imageDir+"cancel1.png";a.style.cssFloat="right";a.style.cursor="default";var b=document.createElement("div");b.id=this.target+"canvasXpressLink";b.className="draggable";b.style.cursor="move";b.style.display="none";b.style.padding="10px";b.style.border="1px solid "+this.skinBorderColor;b.style.backgroundColor=this.skinBackgroundColor;b.style.boxShadow="2px 2px 2px "+this.skinShadowColor;b.style.MozBoxShadow="2px 2px 2px "+this.skinShadowColor;b.style.color=this.skinColor;b.style.borderRadius="8px";b.style.minWidth="108px";b.style.position="absolute";b.style.zIndex=10002;b.appendChild(a);b.appendChild(document.createElement("br"));this.canvas.parentNode.appendChild(b);this.addRemoveLinkListeners("addEvtListener")};this.addRemoveLinkListeners=function(b){var c=document.getElementById(this.target+"canvasXpressLink");var a=document.getElementById(this.target+"canvasXpressLinkClose");if(c&&a){this[b](c,"mousedown",this.registerMousemove,false);this[b](a,"click",this.closeLink,false)}};this.resetLinkDiv=function(b,a){var c=document.getElementById(this.target+"canvasXpressLink");if(c&&c.childNodes){while(c.childNodes.length>2){c.removeChild(c.childNodes[2])}c.style.display="none"}};this.showLinkDiv=function(k,A){var o=document.getElementById(this.target+"canvasXpressLink");var w=false;if(o){var C=B.adjustedCoordinates(k);if(C){var v=C.x;var q=C.y;for(var h=0;h<A.length;h++){var c=document.createElement("img");var r=document.createElement("a");var z=A[h].url;var c=A[h].name;var B=A[h].title;var f=A[h].icon;var D=A[h].source;var b=A[h].params;if(z){r.href=z;w=true}else{if(D&&b&&this.data.links&&this.data.links[D]){r.href=this.data.links[D].url;w=true;if(b){for(var g in b){r.href=r.href.replace("$"+b+"$",b[g])}}}}r.innerHTML=c?c:this.data.links&&D&&this.data.links[D]&&this.data.links[D].name?this.data.links[D].name:h;r.alt=B?B:this.data.links&&D&&this.data.links[D]&&this.data.links[D].title?this.data.links[D].title:"";r.title=r.alt;r.target="_blank";c.src=f?f:this.data.links&&D&&this.data.links[D]&&this.data.links[D].icon?this.data.links[D].icon:this.getPixelImage();c.height="16px";c.width="16px";o.appendChild(c);o.appendChild(r);o.appendChild(document.createElement("br"))}o.style.left=v+"px";o.style.top=q+"px";o.style.display=w?"block":"hidden"}}};this.initializeLinkEvents=function(){if(!this.disableEvents){this.addLinkDiv()}};this.initializeLinkEvents()};CanvasXpress.prototype.initImageMapEvents=function(){this.flash=function(b,o,k,e,j){var g=document.createElement("div");g.id=this.target+"canvasXpressFlash";g.style.left=(b-(k/2))+"px";g.style.top=(o-(e/2))+"px";g.style.width=k+"px";g.style.height=e+"px";g.style.opacity=0.6;g.style.filter="alpha(opacity = 60)";g.style.position="absolute";g.style.zIndex=100000;g.style.display="block";g.style.backgroundColor=j?j:this.resizerBackgroundColor;this.canvas.parentNode.appendChild(g);var f=this;var a=0;var m=function(){this.update=function(){if(a>10){f.canvas.parentNode.removeChild(g);clearInterval(c)}else{if(a%2){g.style.display="none"}else{g.style.display="block"}}a++};var c=setInterval(this.update,300)};m.call()};this.addImage=function(){if(document.getElementById(this.target+"canvasXpressImage")){return}var b=document.getElementById(this.target);var a=document.createElement("img");a.id=this.target+"canvasXpressImage";a.src=this.getPixelImage();a.width=this.width;a.height=this.height;a.useMap="#"+this.target+"canvasXpressMap";a.style.left="0px";a.style.top="0px";a.style.border="0px";a.style.position="absolute";a.style.zIndex=9000;this.canvas.parentNode.appendChild(a)};this.resizeImage=function(c){var b=document.getElementById("wrapper-"+this.target);var e=document.getElementById(this.target+"canvasXpressImage");var a=this.graphType=="Network"?0:this.marginLeft+this.offsetX+this.left;var d=this.graphType=="Network"?0:this.marginTop+this.offsetY+this.top;if(b&&e){b.style.width=this.width+"px";b.style.height=this.height+"px";e.style.left="0px";e.style.top="0px";e.style.width=this.width+"px";e.style.height=this.height+"px";if(!c){if(this.modelEvent=="global"){this.addGlobalArea(["rect",a,d,a+this.x,d+this.y])}}}};this.mousedownImage=function(a){return function(c){if(!c){c=window.event}if(c){var b;if(c.which){b=(c.which==3)}else{if(c.button){b=(c.button==2)}}if(b){if(a.Ext){return}else{}}else{if(!a.configuringOn){a.cancelEvent(c);a.registerDragDiv(c)}}}return false}}(this);this.clickImage=function(a){return function(b){if(!b){b=window.event}a.clickBuffer=function(){if(!a.doubleClick){if(!a.configuringOn){if(a.isHelp(b)){a.stopEvent(b);a.showInfoSpan(b,'Modify "helpKeyEvents"<br>&nbsp;&nbsp;&nbsp;to show or hide help<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;on key events"')}else{if(a.isAxis(b)){a.stopEvent(b)}else{if(a.axesResizerShow&&!a.resizerType){a.stopEvent(b);a.resetAxesResizer(b)}else{if(a.mobileApp){return false}else{var c=a.getEventAreaId(b);if(c&&c[0]!="canvasXpressImage"){a.handleMouseAreaEvents("click",b,c)}}}}}}else{a.resetConfigurator()}}};setTimeout(a.clickBuffer,250);setTimeout(function(){a.doubleClick=false},500)}}(this);this.dblclickImage=function(a){return function(c){if(!c){c=window.event}a.doubleClick=true;if(a.clickBuffer){clearTimeout(a.clickBuffer);a.clickBuffer=null}var b=a.getEventAreaId(c);if(b&&b[0]!="canvasXpressImage"){if(a.graphType=="Network"||a.graphType=="Genome"){a.addConfigurator(c,b)}else{a.handleMouseAreaEvents("dblclick",c,b)}}else{a.cancelEvent(c);a.addConfigurator(c)}return false}}(this);this.wheelImage=function(a){return function(b){if(!b){b=window.event}var c=0;if(!b){b=window.event}if(b.wheelDelta){c=b.wheelDelta/120;if(window.opera){c=-c}}else{if(b.detail){c=-b.detail/3}}if(c){a.handleWheelEvent(b,c)}}}(this);this.addRemoveCanvasListeners=function(b){var a=document.getElementById(this.target+"canvasXpressImage");if(a){this[b](a,"mousedown",this.mousedownImage,false);this[b](a,"click",this.clickImage,false);this[b](a,"dblclick",this.dblclickImage,false);this[b](a,"mousewheel",this.wheelImage,false);this[b](this.canvas,"click",this.clickImage,false)}};this.isVersion=function(b){if(this.showVersion){var a=this.adjustedCoordinates(b);return a&&a.x>0&&a.x<=10&&a.y>0&&a.y<=10?true:false}};this.isHelp=function(b){var a=this.adjustedCoordinates(b);return a&&a.x>0&&a.x<=10&&a.y>0&&a.y<=10?true:false};this.handleWheelEvent=function(j,k){if(this.graphType=="Network"){this.cancelEvent(j);var t=this.adjustedCoordinates(j);if(t){if(j.type=="keydown"){t.x=this.width/2;t.y=this.height/2}var b=this.scaleFactor*this.zoomStep;var p=(this.widthBounds/2)-(t.x/this.scaleFactor);var h=(this.heightBounds/2)-(t.y/this.scaleFactor);this.scaleFactor=k>0?this.scaleFactor+b:this.scaleFactor-b;this.widthBounds=this.x/this.scaleFactor;this.heightBounds=this.y/this.scaleFactor;var a=(this.widthBounds/2)-(t.x/this.scaleFactor);var n=(this.heightBounds/2)-(t.y/this.scaleFactor);this.panningX=p-a;this.panningY=h-n;if(!this.networkFreeze){b=this.zoom*this.zoomStep;this.zoom=k>0?this.zoom+b:this.zoom-b}this.draw(false,false,false,true);this.panningGlobalX+=this.panningX;this.panningGlobalY+=this.panningY}}else{if(this.graphType=="Genome"){this.cancelEvent(j);var t=this.adjustedCoordinates(j);if(t){var g=(t.x-(this.marginLeft+this.left))/this.x;var o=1-g;var s=this.xAxisRange*this.zoomStep;if(k>0){this.setMin=this.setMin!=null?this.setMin+(s*g):this.xAxisMin+(s*g);this.setMax=this.setMax!=null?this.setMax-(s*o):this.xAxisMax-(s*o)}else{this.setMin=this.setMin!=null?this.setMin-(s*g):this.xAxisMin-(s*g);this.setMax=this.setMax!=null?this.setMax+(s*o):this.xAxisMax+(s*o)}this.draw()}}else{if(this.graphType=="Heatmap"){this.cancelEvent(j);this.resetAxesResizer(j);var m=this.layoutComb?this.layoutValidN:0;var r;var q=this.layoutComb?this.layoutParams[m].varIndices:this.varIndices;var f=this.isGroupedData?this.grpIndices:this.smpIndices;if(this.isGroupedData){r=this.layoutComb?this.layoutParams[m].grpIndices:this.grpIndices}else{r=this.layoutComb?this.layoutParams[m].smpIndices:this.smpIndices}this.setOriginalIndices(m,q,r);if(k>0){if(q.length>3){this.varIndices.shift();this.varIndices.pop();if(this.varIndicesStart<0){this.varIndicesStart++}this.varIndicesStart++}if(r.length>3){f.shift();f.pop();if(this.smpIndicesStart<0){this.smpIndicesStart++}this.smpIndicesStart++}}else{if(this.varIndicesStart>0){this.varIndices.unshift(this.startingVarIndices[m][this.varIndicesStart-1]);this.varIndicesStart--}if(this.varIndicesStart>=0&&this.varIndicesStart+q.length<this.startingVarIndices[m].length){this.varIndices.push(this.startingVarIndices[m][this.varIndicesStart+q.length])}if(this.smpIndicesStart>0){f.unshift(this.startingSmpIndices[m][this.smpIndicesStart-1]);this.smpIndicesStart--}if(this.smpIndicesStart>=0&&this.smpIndicesStart+r.length<this.startingSmpIndices[m].length){f.push(this.startingSmpIndices[m][this.smpIndicesStart+r.length])}}this.draw()}}}return false};this.addMap=function(){if(document.getElementById(this.target+"canvasXpressMap")){return this.resetMap()}var a=document.createElement("map");a.name=this.target+"canvasXpressMap";a.id=this.target+"canvasXpressMap";this.canvas.parentNode.appendChild(a);this.addArea(["rect",0,0,10,10],[-1],false,0)};this.setLayoutValidIndices=function(k){if(this.layoutComb){var h=this.adjustedCoordinates(k);if(h){var a=h.x;var g=h.y;var m=0;for(var f=0;f<this.layoutRows;f++){for(var d=0;d<this.layoutCols;d++){var b=this.getBoundsXY(m);if(a>=b[0]&&a<=b[1]&&g>=b[2]&&g<=b[3]){if(this.layoutValid){this.layoutValidR=f;this.layoutValidC=d;this.layoutValidN=m}}m++}}}}};this.getNetworkEventAreaId=function(h){if(this.modelEvent=="local"){var b=h.target||h.srcElement;if(b){var c=b.id;var g;if(c.match(/-legend-/)){if(c.match(/-legend-Nodes/)){return false}else{if(c.match(/-legend-Edges/)){return false}else{return false}}}else{if(c.match(/-lab$|-dec$/)){g=this.isEvent(h);if(g){return[parseInt(g.split(/-/)[0].replace(this.target,""))]}else{return false}}else{g=this.isEvent(h);if(g){return[parseInt(g.split(/-/)[0].replace(this.target,""))]}else{return[parseInt(c.replace(this.target,""))]}}}}}else{var a=this.isEvent(h,true);var j=a[0];var d=a[1];if(j){return d&&d.match(/-legend-/)?false:j}else{return false}}};this.getEventAreaId=function(b){if(this.graphType=="Network"){return this.getNetworkEventAreaId(b)}if(this.modelEvent=="local"){var a=b.target||b.srcElement;if(a){this.setLayoutValidIndices(b);return a.id.replace(this.target,"").split(",")}else{this.setLayoutValidIndices(b);return this.isEvent(b)}}else{return this.isEvent(b)}};this.getEventAreaData=function(a){return this.extractDataObject(this.getEventAreaId(a))};this.handleMouseAreaEvents=function(b,c,a){if(a[0]==-1){this.showInfoSpan(c,"CanvasXpress ("+this.version+")")}else{var d=this.extractDataObject(a);if(this.userEvents[b]){if(typeof(this.userEvents[b])=="object"&&this.userEvents[b].handler&&this.userEvents[b].scope){if(c.ctrlKey&&b=="click"){if(c.shiftKey&&b=="click"){alert(this.prettyJSON(d))}else{if(c.shiftKey&&b=="click"){this.addRemoveToSelectedDataPoints(false,this.getEventAreaId(c));this.draw()}else{this.addRemoveToSelectedDataPoints(false,this.getEventAreaId(c));this.draw()}}}else{if(c.shiftKey&&b=="click"&&this.graphType=="Network"&&this.networkLayoutType=="radial"){this.reRootRadialNetwork(this.getEventAreaId(c))}else{if(c.shiftKey&&b=="click"){}else{if(c.altKey&&b=="click"){}else{this.userEvents[b].handler.apply(this.userEvents[b].scope,[d,c])}}}}}else{if(typeof(this.userEvents[b])=="object"&&this.userEvents[b].handler){if(c.ctrlKey&&b=="click"){if(c.shiftKey&&b=="click"){alert(this.prettyJSON(d))}else{if(c.shiftKey&&b=="click"){this.addRemoveToSelectedDataPoints(false,this.getEventAreaId(c));this.draw()}else{this.addRemoveToSelectedDataPoints(false,this.getEventAreaId(c));this.draw()}}}else{if(c.shiftKey&&b=="click"&&this.graphType=="Network"&&this.networkLayoutType=="radial"){this.reRootRadialNetwork(this.getEventAreaId(c))}else{if(c.shiftKey&&b=="click"){}else{if(c.altKey&&b=="click"){}else{this.userEvents[b].handler(d,c)}}}}}else{if(c.ctrlKey&&b=="click"){if(c.shiftKey&&b=="click"){alert(this.prettyJSON(d))}else{if(c.shiftKey&&b=="click"){this.addRemoveToSelectedDataPoints(false,this.getEventAreaId(c));this.draw()}else{this.addRemoveToSelectedDataPoints(false,this.getEventAreaId(c));this.draw()}}}else{if(c.shiftKey&&b=="click"&&this.graphType=="Network"&&this.networkLayoutType=="radial"){this.reRootRadialNetwork(this.getEventAreaId(c))}else{if(c.shiftKey&&b=="click"){}else{if(c.altKey&&b=="click"){}else{this.userEvents[b](d,c)}}}}}}}}};this.mouseoverArea=function(a){return function(c){if(!c){c=window.event}var b=a.getEventAreaId(c);if(b){a.handleMouseAreaEvents("mouseover",c,b)}}}(this);this.mouseoutArea=function(a){return function(c){if(!c){c=window.event}var b=a.getEventAreaId(c);if(b){a.handleMouseAreaEvents("mouseout",c,b)}}}(this);this.clickArea=function(a){return function(b){if(!b){b=window.event}a.clickBuffer=function(){if(!a.doubleClick){if(!a.skipClick){var c=a.getEventAreaId(b);if(c){a.handleMouseAreaEvents("click",b,c)}else{a.clickImage(b)}}}};setTimeout(a.clickBuffer,250);setTimeout(function(){a.doubleClick=false},500)}}(this);this.dblclickArea=function(a){return function(c){if(!c){c=window.event}a.doubleClick=true;if(a.clickBuffer){clearTimeout(a.clickBuffer);a.clickBuffer=null}if(!a.skipClick){var b=a.getEventAreaId(c);if(b){if(a.graphType=="Network"||a.graphType=="Genome"){a.addConfigurator(c,b)}else{a.handleMouseAreaEvents("dblclick",c,b)}}else{a.dblclickImage(c)}}}}(this);this.addRemoveImageMapListeners=function(c,b){this[c](b,"mouseover",this.mouseoverArea,false);this[c](b,"mouseout",this.mouseoutArea,false);this[c](b,"mousedown",this.mousedownImage,false);this[c](b,"click",this.clickArea,false);this[c](b,"dblclick",this.dblclickArea,false);this[c](b,"mousewheel",this.wheelImage,false)};this.formatCoords=function(j,k){var f=[];if(this.graphType!="Network"){for(var e=0;e<k.length;e++){if(e%2){f.push(sprintf("%.0f",(k[e]+this.translateY)*this.scaleY))}else{if(this.layoutValid&&j=="circle"&&e==2){f.push(sprintf("%.0f",k[e]*((this.scaleX+this.scaleY)/2)))}else{f.push(sprintf("%.0f",(k[e]+this.translateX)*this.scaleX))}}}}else{for(var e=0;e<k.length;e++){f.push(sprintf("%.0f",parseInt(k[e])))}}if(j=="rect"){var b=Math.min(f[0],f[2]);var d=Math.min(f[1],f[3]);var a=Math.max(f[0],f[2]);var g=Math.max(f[1],f[3]);f=[b,d,a,g]}return f.join(",")};this.addArea=function(o,h,k,e){if(!o||!h){return}var j=o.shift();if(j&&o){if(this.modelEvent=="local"){var d=document.getElementById(this.target+"canvasXpressMap");if(d){var g=document.createElement("area");g.shape=j;g.coords=this.formatCoords(j,o);g.id=this.target+h.join(",");g.style.cursor="default";if(k){g.id+=k}this.addRemoveImageMapListeners("addEvtListener",g);if(e!=null){var n=d.getElementsByTagName("area")[e];d.insertBefore(g,n)}else{d.appendChild(g)}}}else{this.dataEvent.push([h,j,o,k])}}};this.addGlobalArea=function(k,j){if(!k){return}var f=k.shift();if(f&&k){var h;if(j){h=0;var g=document.getElementById(this.target+"globalArea"+h);while(g){h++;g=document.getElementById(this.target+"globalArea"+h)}}else{h=""}var b=document.getElementById(this.target+"canvasXpressMap");var d=document.createElement("area");d.shape=f;d.coords=this.formatCoords(f,k);d.id=this.target+"globalArea"+h;this.addRemoveImageMapListeners("addEvtListener",d);b.appendChild(d)}};this.resetMap=function(){var b=document.getElementById(this.target+"canvasXpressMap");if(b){var d=b.childNodes;var g=[];var e=this.modelEvent=="local"?1:0;for(var f=e;f<d.length;f++){if(d[f].id){g.push(d[f])}}for(var f=0;f<g.length;f++){var c=g[f];if(c){this.addRemoveImageMapListeners("removeEvtListener",c);c.parentNode.removeChild(c)}}}this.dataEvent=[]};this.initializeImageMapEvents=function(){if(!this.disableEvents){this.addImage();this.addMap();this.addRemoveCanvasListeners("addEvtListener")}};this.initializeImageMapEvents()};CanvasXpress.prototype.initCanvasResizerEvents=function(){this.addCanvasResizerDiv=function(){if(document.getElementById(this.target+"canvasXpressCanvasResize")){return}var a=document.createElement("div");a.id=this.target+"canvasXpressCanvasResize";a.style.left="0px";a.style.top="0px";a.style.width="0.5px";a.style.height="0.5px";a.style.opacity=0.5;a.style.filter="alpha(opacity = 50)";a.style.backgroundColor=this.resizerBackgroundColor;a.style.position="absolute";a.style.display="none";a.style.zIndex=10001;this.canvas.parentNode.appendChild(a)};this.isCanvasResize=function(c){if(this.resizable){if(!c){c=window.event}var b=this.adjustedCoordinates(c);if(b){var a=b.x;var d=b.y;if(a>this.width-18&&d>this.height-18){this.resizeCanvasCursorShow="se-resize";return true}else{if(a>this.width-18){this.resizeCanvasCursorShow="e-resize";return true}else{if(d>this.height-18){this.resizeCanvasCursorShow="s-resize";return true}else{this.resizeCanvasCursorShow=false;return false}}}}}};this.updateCanvasResizerCursor=function(d){if(this.resizable){if(!d){d=window.event}var b=document.getElementById(this.target+"canvasXpressImage");if(b){var c=this.adjustedCoordinates(d);if(c){var a=c.x;var f=c.y;if(a>this.width-18&&f>this.height-18){b.style.cursor="se-resize";this.resizeCanvasCursorShow="se-resize"}else{if(a>this.width-18){b.style.cursor="e-resize";this.resizeCanvasCursorShow="e-resize"}else{if(f>this.height-18){b.style.cursor="s-resize";this.resizeCanvasCursorShow="s-resize"}else{if(!this.movingOn){b.style.cursor="default";this.resizeCanvasCursorShow=false}}}}}}}};this.updateCanvasResizer=function(g){if(this.resizingCanvasOn&&this.resizeCanvasCursorShow){document.body.style.cursor=this.resizeCanvasCursorShow;var d=document.getElementById(this.target+"canvasXpressCanvasResize");var f=d.parentNode;var c=this.adjustedCoordinates(g);var b,a;if(d&&c){if(this.resizeCanvasCursorShow=="se-resize"){a=c.x;b=c.y}else{if(this.resizeCanvasCursorShow=="e-resize"){a=c.x;b=this.height}else{if(this.resizeCanvasCursorShow=="s-resize"){a=this.width;b=c.y}}}d.style.width=a+"px";d.style.height=b+"px";while(f){if((f.style.height&&parseInt(f.style.height)<b)||(f.style.width&&parseInt(f.style.width)<a)){f.style.height=d.style.height;f.style.width=d.style.width}else{if((f.style.height&&parseInt(f.style.height)>=b)&&(f.style.width&&parseInt(f.style.width)>=a)){f=false}}if(f&&f.parentNode){f=f.parentNode}else{f=false}}d.style.display="block"}}};this.endCanvasResizer=function(d){if(this.resizingCanvasOn){var b=document.getElementById(this.target+"canvasXpressImage");var c=document.getElementById(this.target+"canvasXpressCanvasResize");if(b&&c){var a=parseInt(c.style.width.replace("px",""));var f=parseInt(c.style.height.replace("px",""));this.resetAxesResizer();this.draw(a,f);c.style.width="0.5px";c.style.height="0.5px";c.style.display="none";b.style.cursor="default";this.updateRemoteNavigationWindow();this.resizeCanvasCursorShow=false;this.resizingCanvasOn=false}}};this.initializeCanvasResizerEvents=function(){if(!this.disableEvents){this.addCanvasResizerDiv()}};this.initializeCanvasResizerEvents()};CanvasXpress.prototype.initAxisResizerEvents=function(){this.addAxesResizeDiv=function(){if(document.getElementById(this.target+"canvasXpressAxesResize")){return}var c=["Previous","Next","Current","Middle","Min","Max","Close"];var b=9001;var e=document.createElement("div");e.id=this.target+"canvasXpressAxesResize";if(this.resizerTransparency){e.style.opacity=0.85;e.style.filter="alpha(opacity = 85)"}e.style.position="absolute";e.style.display="none";e.style.zIndex=b;for(var a=0;a<c.length;a++){b++;var f=document.createElement("div");f.id=this.target+"canvasXpressAxesResize"+c[a];if(this.resizerTransparency){f.style.opacity=0.85;f.style.filter="alpha(opacity = 85)"}f.style.position="absolute";f.style.zIndex=b;e.appendChild(f)}this.canvas.parentNode.appendChild(e)};this.clickAxesResizeClose=function(a){return function(b){if(!b){b=window.event}a.stopEvent(b);a.resetAxesResizer(b);a.resetFlags(b)}}(this);this.mousemoveActiveAxesResize=function(a){return function(b){if(!b){b=window.event}a.activateDeactivateAxesResizer(b)}}(this);this.mousedownAxesResize=function(a){return function(b){if(!b){b=window.event}a.cancelEvent(b);a.registerAxesResizer(b);return false}}(this);this.mousemoveAxesResize=function(a){return function(b){if(!b){b=window.event}a.cancelEvent(b);a.updateAxesResizer(b);return false}}(this);this.mouseupAxesResize=function(a){return function(b){if(!b){b=window.event}a.stopEvent(b);a.endAxesResizer(b);return false}}(this);this.addRemoveAxesResizerListeners=function(v){var a=document.getElementById(this.target+"canvasXpressAxesResize");var d=document.getElementById(this.target+"canvasXpressAxesResizeMin");var u=document.getElementById(this.target+"canvasXpressAxesResizeMax");var e=document.getElementById(this.target+"canvasXpressAxesResizeMiddle");var q=document.getElementById(this.target+"canvasXpressAxesResizeCurrent");var k=document.getElementById(this.target+"canvasXpressAxesResizeClose");var s=document.getElementById(this.target+"canvasXpressAxesResizePrevious");var p=document.getElementById(this.target+"canvasXpressAxesResizeNext");var g=document.getElementById(this.target+"canvasXpressImage");var b=[a,d,u,e,q];if(g){this[v](g,"mousemove",this.mousemoveAxesResize,false)}if(a){this[v](a,"mousemove",this.mousemoveActiveAxesResize,false);this[v](a,"mouseout",this.mousemoveActiveAxesResize,false)}if(k){this[v](k,"click",this.clickAxesResizeClose,false)}for(var f=0;f<b.length;f++){if(b[f]){this[v](b[f],"mousedown",this.mousedownAxesResize,false);this[v](b[f],"mousemove",this.mousemoveAxesResize,false);this[v](b[f],"mouseup",this.mouseupAxesResize,false)}}};this.showAxesResizer=function(f,e,c,t,q,n,b,g,u,w,o,k,j){if(!this.axesResizerShow){var a=document.getElementById(this.target+"canvasXpressAxesResize");var m=document.getElementById(this.target+"canvasXpressAxesResizeClose");if(a&&m){this.updateResizerEventData(null,null,f,e,c,t,q,n,b,g,u,w,o,k,j);this.refreshAxesResizer();a.style.display="block";if(this.resizerType&&this.layoutValid){m.style.display="none"}this.addRemoveAxesResizerListeners("addEvtListener");if(this.layoutValid){this.layoutValidR=k;this.layoutValidC=j;this.layoutValidN=o}this.axesResizerShow=true}}};this.refreshAxesResizer=function(){if(this.resizerEventData){var b=document.getElementById(this.target+"canvasXpressAxesResize");var e=document.getElementById(this.target+"canvasXpressAxesResizeMin");var p=document.getElementById(this.target+"canvasXpressAxesResizeMax");var f=document.getElementById(this.target+"canvasXpressAxesResizeMiddle");var j=document.getElementById(this.target+"canvasXpressAxesResizeCurrent");var g=document.getElementById(this.target+"canvasXpressAxesResizeClose");var o=document.getElementById(this.target+"canvasXpressAxesResizePrevious");var k=document.getElementById(this.target+"canvasXpressAxesResizeNext");if(b&&e&&p&&j&&g&&o&&k){var t=this.resizerEventData.areas.org[1]-this.resizerEventData.areas.org[0];var q=this.resizerEventData.areas.org[3]-this.resizerEventData.areas.org[2];var d=14;var a=9;var s=parseInt(a/2);if(this.resizerEventData.pos=="h"){l=this.resizerEventData.l.match(/^t/)?"top":"bottom";b.style.left=(this.resizerEventData.areas.org[0]-s)+"px";b.style.top=this.resizerEventData.areas.org[2]+"px";b.style.width=((t+a)-1)+"px";b.style.height=d+"px";b.style.backgroundImage="url('"+this.imageDir+"scroller_empty_hor_"+l+".png')";b.style.backgroundRepeat="repeat-x";o.style.left="0px";o.style.top="0px";o.style.width=a+"px";o.style.height=d+"px";o.style.backgroundImage="url('"+this.imageDir+"prev_"+l+".png')";e.style.left=this.resizerEventData.areas.min[0]+"px";e.style.top="0px";e.style.width=a+"px";e.style.height=d+"px";e.style.cursor="e-resize";e.style.backgroundImage="url('"+this.imageDir+"handle_left_"+l+".png')";j.style.left=this.resizerEventData.areas.cur[0]+"px";j.style.top="0px";j.style.width=this.resizerEventData.areas.cur[1]+"px";j.style.height=d+"px";j.style.cursor="move";j.style.backgroundImage="url('"+this.imageDir+"scroller_body_hor_"+l+".png')";j.style.backgroundRepeat="repeat-x";p.style.left=this.resizerEventData.areas.max[0]+"px";p.style.top="0px";p.style.width=a+"px";p.style.height=d+"px";p.style.cursor="e-resize";p.style.backgroundImage="url('"+this.imageDir+"handle_right_"+l+".png')";p.style.backgroundRepeat="no-repeat";f.style.left=(this.resizerEventData.areas.min[0]+((this.resizerEventData.areas.cur[1]-1)/2))+"px";f.style.top="0px";f.style.width="8px";f.style.height=d+"px";f.style.cursor="move";f.style.backgroundImage="url('"+this.imageDir+"scroller_handle_hor_"+l+".png')";k.style.left=(t-1)+"px";k.style.top="0px";k.style.width=a+"px";k.style.height=d+"px";k.style.backgroundImage="url('"+this.imageDir+"next_"+l+".png')";g.style.left=(t+a)+"px";g.style.top="0px";g.style.width=a+"px";g.style.height=d+"px";g.style.backgroundImage="url('"+this.imageDir+"close.png')"}else{l=this.resizerEventData.l.match(/^l/)?"left":"right";b.style.left=this.resizerEventData.areas.org[0]+"px";b.style.top=(this.resizerEventData.areas.org[2]-s)+"px";b.style.width=d+"px";b.style.height=(q+a)+"px";b.style.backgroundImage="url('"+this.imageDir+"scroller_empty_ver_"+l+".png')";b.style.backgroundRepeat="repeat-y";o.style.left="0px";o.style.top=q+"px";o.style.width=d+"px";o.style.height=a+"px";o.style.backgroundImage="url('"+this.imageDir+"prev_"+l+".png')";e.style.left="0px";e.style.top=this.resizerEventData.areas.min[2]+"px";e.style.width=d+"px";e.style.height=a+"px";e.style.cursor="n-resize";e.style.backgroundImage="url('"+this.imageDir+"handle_bottom_"+l+".png')";e.style.backgroundRepeat="no-repeat";j.style.left="0px";j.style.top=this.resizerEventData.areas.cur[2]+"px";j.style.width=d+"px";j.style.height=this.resizerEventData.areas.cur[3]+"px";j.style.cursor="move";j.style.backgroundImage="url('"+this.imageDir+"scroller_body_ver_"+l+".png')";j.style.backgroundRepeat="repeat-y";p.style.left="0px";p.style.top=this.resizerEventData.areas.max[2]+"px";p.style.width=d+"px";p.style.height=a+"px";p.style.cursor="n-resize";p.style.backgroundImage="url('"+this.imageDir+"handle_top_"+l+".png')";p.style.backgroundRepeat="no-repeat";f.style.left="0px";f.style.top=(this.resizerEventData.areas.max[2]+(this.resizerEventData.areas.cur[3]/2))+"px";f.style.width=d+"px";f.style.height=d+"px";f.style.cursor="move";f.style.backgroundImage="url('"+this.imageDir+"scroller_handle_ver_"+l+".png')";f.style.backgroundRepeat="no-repeat";k.style.left="0px";k.style.top="0px";k.style.width=d+"px";k.style.height=a+"px";k.style.backgroundImage="url('"+this.imageDir+"next_"+l+".png')";g.style.left=(d+1)+"px";g.style.top=-a+"px";g.style.width=a+"px";g.style.height=d+"px";g.style.backgroundImage="url('"+this.imageDir+"close.png')"}this.drawAxesResizerMasks()}}};this.updateResizerEventData=function(h,G,A,q,o,a,W,T,J,N,H,I,y,t,r){var j,F,E,m,k,z,x,f,c,P,O,D,C,n,V;A=A?A:this.resizerEventData.axis;q=q?q:this.resizerEventData.areas.org[0];o=o?o:this.resizerEventData.areas.org[1];a=a?a:this.resizerEventData.areas.org[2];W=W?W:this.resizerEventData.areas.org[3];T=T?T:this.resizerEventData.dim;J=J?J:this.resizerEventData.pos;N=N?N:this.resizerEventData.l;H=H?H:this.resizerEventData.vals;I=I?I:this.resizerEventData.set?this.resizerEventData.set:"";y=y?y:this.resizerEventData.c,t=t?t:this.resizerEventData.i;r=r?r:this.resizerEventData.j;var R=H.graphType;var e=o-q;var b=W-a;if(R=="Heatmap"){if(T=="y"){j=this.isGroupedData?this.data.w.smps.length:this.data.y?this.data.y.smps.length:0}else{j=this.data.y?this.data.y.vars.length:0}}else{j=this.isGroupedData?this.data.w.smps.length-1:this.data.y?this.data.y.smps.length-1:0}var U=this.resizerType=="samples"||R=="Heatmap"?0:H[A+"AbsMin"];var B=this.resizerType=="samples"||R=="Heatmap"?j:H[A+"AbsMax"];var u=J=="h"?e:b;var Q=u/(B-U);if(h==null||isNaN(h)){if(this.resizerType=="samples"){h=this.isGroupedData?this.grpIndices[0]:this.smpIndices[0]}else{if(R=="Heatmap"){h=T=="y"?Math.max(0,H.smpIndicesStart):Math.max(0,H.varIndicesStart)}else{h=R.match(/Scatter/)?H["setMin"+T.toUpperCase()]:R=="BarLine"&&N.match(/b|r/)?H.setMin2:H.setMin}if(h==null||isNaN(h)){h=U}}}h=Math.max(h,U);if(G==null||isNaN(G)){if(this.resizerType=="samples"){G=this.isGroupedData?this.grpIndices[this.grpIndices.length-1]:this.smpIndices[this.smpIndices.length-1]}else{if(R=="Heatmap"){G=T=="x"?H.varIndices.length:this.isGroupedData?H.grpIndices.length:H.smpIndices.length;G+=h}else{G=R.match(/Scatter/)?H["setMax"+T.toUpperCase()]:R=="BarLine"&&N.match(/b|r/)?H.setMax2:H.setMax}if(G==null||isNaN(G)){G=B}}}G=Math.min(G,B);var w=(h-U)*Q;var S=(G-U)*Q;var M=14;var L=9;var K=parseInt(L/2);if(J=="h"){F=parseInt(w);E=L;m=0;k=M;P=parseInt(w+K+1);O=parseInt(S-(w+1));D=0;C=M;z=parseInt(S-1);x=L;f=0;c=M;n=o+(L-1);V=W}else{F=0;E=M;m=this.resizerType=="samples"||R=="Heatmap"?parseInt(S):parseInt(b-(w+1));k=L;P=0;O=M;D=this.resizerType=="samples"||R=="Heatmap"?parseInt(w+K):parseInt((b-S)+K);C=parseInt(S-w);z=0;x=M;f=this.resizerType=="samples"||R=="Heatmap"?parseInt(w+1):parseInt(b-S);c=L;n=o;V=W+(L-1)}this.resizerEventData={g:R,axis:A,dim:T,pos:J,l:N,vals:H,min:U,max:B,smin:h,smax:G,len:u,unit:Q,width:M,set:I,c:y,i:t,j:r,areas:{org:[q,o,a,W],lim:[q,n,a,V],min:[F,E,m,k],max:[z,x,f,c],cur:[P,O,D,C]}}};this.updateAxesResizer=function(v){if(this.axesResizingOn){if(!v){v=window.event}var q=this.resizerEventData.areas;var z=this.adjustedCoordinates(v);if(z){var n,A,b,c,a;var f=this.xMouseDown-z.x;var d=this.yMouseDown-z.y;var j,h;var s=null;var u=null;var w="";var E=14;var D=9-1;var B=parseInt(D/2);if(this.resizerEventData.g=="Heatmap"){if(this.resizerEventData.dim=="y"){n=this.isGroupedData?this.data.w.smps.length:this.data.y?this.data.y.smps.length:0;b=this.resizerEventData.lastMax!=null?this.resizerEventData.lastMax:this.resizerEventData.smax!=null?this.resizerEventData.smax:this.isGroupedData?this.data.w.smps.length:this.data.y.smps.length}else{n=this.data.y?this.data.y.vars.length:0;b=this.resizerEventData.lastMax!=null?this.resizerEventData.lastMax:this.resizerEventData.smax!=null?this.resizerEventData.smax:this.data.y.vars.length}A=this.resizerEventData.lastMin!=null?this.resizerEventData.lastMin:this.resizerEventData.smin!=null?this.resizerEventData.smin:0;a=this.resizerEventData.pos=="h"?(q.org[1]-q.org[0])/n:(q.org[3]-q.org[2])/n}else{n=this.isGroupedData?this.data.w.smps.length-1:this.data.y?this.data.y.smps.length-1:0;A=this.resizerEventData.lastMin!=null?this.resizerEventData.lastMin:this.resizerEventData.smin!=null?this.resizerEventData.smin:0;b=this.resizerEventData.lastMax!=null?this.resizerEventData.lastMax:this.resizerEventData.smax!=null?this.resizerEventData.smax:this.isGroupedData?this.data.w.smps.length-1:this.data.y.smps.length-1;a=this.resizerEventData.pos=="h"?(q.org[1]-q.org[0])/n:(q.org[3]-q.org[2])/n}if(this.resizerEventData.active=="min"){j=f>q.min[0]?this.xMouseDown-q.min[0]:f<(q.min[0]+q.min[1])-q.max[0]?this.xMouseDown-((q.min[0]+q.min[1])-q.max[0]):z.x;h=d>q.min[2]-(q.max[2]+q.max[3])?this.yMouseDown-(q.min[2]-(q.max[2]+q.max[3])):d<(q.lim[2]+q.min[2]+q.min[3])-q.lim[3]?(q.lim[3]-(q.lim[2]+q.min[2]+q.min[3]))+this.yMouseDown:z.y}else{if(this.resizerEventData.active=="max"){j=f>q.max[0]-(q.min[0]+q.min[1])?this.xMouseDown-(q.max[0]-(q.min[0]+q.min[1])):f<(q.lim[0]+q.max[0]+q.max[1])-q.lim[1]?(q.lim[1]-(q.lim[0]+q.max[0]+q.max[1]))+this.xMouseDown:z.x;h=d>q.max[2]?this.yMouseDown-q.max[2]:d<(q.lim[2]+q.max[2]+q.max[3])-(q.lim[2]+q.min[2])?((q.lim[2]+q.min[2])-(q.lim[2]+q.max[2]+q.max[3]))+this.yMouseDown:z.y}else{if(this.resizerEventData.active=="cur"){j=f>q.min[0]?this.xMouseDown-q.min[0]:f<(q.lim[0]+q.max[0]+q.max[1])-q.lim[1]?(q.lim[1]-(q.lim[0]+q.max[0]+q.max[1]))+this.xMouseDown:z.x;h=d>q.max[2]?this.yMouseDown-q.max[2]:d<(q.lim[2]+q.min[2]+q.min[3])-q.lim[3]?(q.lim[3]-(q.lim[2]+q.min[2]+q.min[3]))+this.yMouseDown:z.y}else{return}}}var m=j-this.xMouseDown;var k=h-this.yMouseDown;if(this.resizerType=="samples"||this.resizerEventData.g=="Heatmap"){m-=m%a;k-=k%a}var r=m/this.resizerEventData.unit;var p=k/this.resizerEventData.unit;var t=document.getElementById(this.target+"canvasXpressAxesResizeMin");var o=document.getElementById(this.target+"canvasXpressAxesResizeMax");var C=document.getElementById(this.target+"canvasXpressAxesResizeMiddle");var g=document.getElementById(this.target+"canvasXpressAxesResizeCurrent");if(t&&o&&C&&g){if(this.resizerEventData.active=="min"){if(this.resizerEventData.pos=="h"){t.style.left=(q.min[0]+m)+"px";C.style.left=((q.min[0]+m)+((q.cur[1]-m)/2))+"px";g.style.left=(q.min[0]+m+B+1)+"px";g.style.width=(q.cur[1]-m)+"px";A=parseInt((q.min[0]+D+m)/a);if(this.resizerType=="samples"){s=dateFormat(this.data.y.smps[A],this.timeFormat)}else{if(this.resizerEventData.g=="Heatmap"){s=this.resizerEventData.dim=="x"?this.data.y.vars[this.resizerEventData.vals.varIndices[A]]:this.isGroupedData?this.data.w.smps[this.resizerEventData.vals.grpIndices[A]]:this.data.y.smps[this.resizerEventData.vals.smpIndices[A]]}else{s=this.formatNumber(this.resizerEventData.smin+r)}}}else{t.style.top=(q.min[2]+k)+"px";C.style.top=((q.min[2]+k)-((q.cur[3]+k)/2))+"px";g.style.height=((q.cur[3]+k))+"px";b=parseInt((q.min[2]+D+k)/a);if(this.resizerType=="samples"){s=dateFormat(this.data.y.smps[b],this.timeFormat)}else{if(this.resizerEventData.g=="Heatmap"){s=this.resizerEventData.dim=="x"?this.data.y.vars[this.resizerEventData.vals.varIndices[b]]:this.isGroupedData?this.data.w.smps[this.resizerEventData.vals.grpIndices[b]]:this.data.y.smps[this.resizerEventData.vals.smpIndices[b]]}else{s=this.formatNumber(this.resizerEventData.smin-p)}}}this.showInfoSpan(v,s)}else{if(this.resizerEventData.active=="max"){if(this.resizerEventData.pos=="h"){o.style.left=(q.max[0]+m)+"px";C.style.left=((q.min[0]+m)+((q.cur[1]-m)/2))+"px";g.style.width=(q.cur[1]+m)+"px";b=parseInt((q.max[0]+D+m)/a);if(this.resizerType=="samples"){u=dateFormat(this.data.y.smps[b],this.timeFormat)}else{if(this.resizerEventData.g=="Heatmap"){u=this.resizerEventData.dim=="x"?this.data.y.vars[this.resizerEventData.vals.varIndices[b]]:this.isGroupedData?this.data.w.smps[this.resizerEventData.vals.grpIndices[b]]:this.data.y.smps[this.resizerEventData.vals.smpIndices[b]]}else{u=this.formatNumber(this.resizerEventData.smax+r)}}}else{o.style.top=(q.max[2]+k)+"px";C.style.top=((q.max[2]+k)+((q.cur[3]-k)/2))+"px";g.style.top=(q.max[2]+k+B)+"px";g.style.height=(q.cur[3]-k)+"px";A=parseInt((q.max[2]+D+k)/a);if(this.resizerType=="samples"){u=dateFormat(this.data.y.smps[A],this.timeFormat)}else{if(this.resizerEventData.g=="Heatmap"){u=this.resizerEventData.dim=="x"?this.data.y.vars[this.resizerEventData.vals.varIndices[A]]:this.isGroupedData?this.data.w.smps[this.resizerEventData.vals.grpIndices[A]]:this.data.y.smps[this.resizerEventData.vals.smpIndices[A]]}else{u=this.formatNumber(this.resizerEventData.smax-p)}}}this.showInfoSpan(v,u)}else{if(this.resizerEventData.active=="cur"){if(this.resizerEventData.pos=="h"){t.style.left=(q.min[0]+m)+"px";C.style.left=((q.min[0]+m)+(q.cur[1]/2))+"px";o.style.left=(q.max[0]+m)+"px";g.style.left=(q.min[0]+m+B+1)+"px";A=parseInt((q.min[0]+D+m)/a);b=parseInt((q.max[0]+D+m)/a);if(this.resizerType=="samples"){s=dateFormat(this.data.y.smps[A],this.timeFormat);u=dateFormat(this.data.y.smps[b],this.timeFormat)}else{if(this.resizerEventData.g=="Heatmap"){s=this.resizerEventData.dim=="x"?this.data.y.vars[this.resizerEventData.vals.varIndices[A]]:this.isGroupedData?this.data.w.smps[this.resizerEventData.vals.grpIndices[A]]:this.data.y.smps[this.resizerEventData.vals.smpIndices[A]];u=this.resizerEventData.dim=="x"?this.data.y.vars[this.resizerEventData.vals.varIndices[b]]:this.isGroupedData?this.data.w.smps[this.resizerEventData.vals.grpIndices[b]]:this.data.y.smps[this.resizerEventData.vals.smpIndices[b]]}else{s=this.formatNumber(this.resizerEventData.smin+r);u=this.formatNumber(this.resizerEventData.smax+r)}}this.showInfoSpan(v,s+"--"+u)}else{t.style.top=(q.min[2]+k)+"px";C.style.top=((q.max[2]+k)+(q.cur[3]/2))+"px";o.style.top=(q.max[2]+k)+"px";g.style.top=(q.max[2]+k+B)+"px";b=parseInt((q.min[2]+D+k)/a);A=parseInt((q.max[2]+D+k)/a);if(this.resizerType=="samples"){s=dateFormat(this.data.y.smps[b],this.timeFormat);u=dateFormat(this.data.y.smps[A],this.timeFormat);this.showInfoSpan(v,u+"--"+s)}else{if(this.resizerEventData.g=="Heatmap"){s=this.resizerEventData.dim=="x"?this.data.y.vars[this.resizerEventData.vals.varIndices[b]]:this.isGroupedData?this.data.w.smps[this.resizerEventData.vals.grpIndices[b]]:this.data.y.smps[this.resizerEventData.vals.smpIndices[b]];u=this.resizerEventData.dim=="x"?this.data.y.vars[this.resizerEventData.vals.varIndices[A]]:this.isGroupedData?this.data.w.smps[this.resizerEventData.vals.grpIndices[A]]:this.data.y.smps[this.resizerEventData.vals.smpIndices[A]];this.showInfoSpan(v,u+"--"+s)}else{s=this.formatNumber(this.resizerEventData.smin-p);u=this.formatNumber(this.resizerEventData.smax-p);this.showInfoSpan(v,s+"--"+u)}}}}}}this.resizerEventData.lastMin=this.resizerType=="samples"||this.resizerEventData.g=="Heatmap"?A:s;this.resizerEventData.lastMax=this.resizerType=="samples"||this.resizerEventData.g=="Heatmap"?b:u;if(this.resizerDraw){this.drawAxesResizerUpdate()}}}}};this.drawAxesResizerUpdate=function(m){var d=this.resizerEventData.lastMin!=null?parseFloat(this.resizerEventData.lastMin):parseFloat(this.resizerEventData.smin);var j=this.resizerEventData.lastMax!=null?parseFloat(this.resizerEventData.lastMax):parseFloat(this.resizerEventData.smax);var h=this.resizerEventData.c||0;if(this.resizerType=="samples"){var k=this.isGroupedData?this.data.w.smps.length-1:this.data.y.smps.length-1;var a=[];var g=[];for(var f=0;f<d;f++){g.push(true)}for(var f=d;f<=j;f++){a.push(f);g.push(false)}for(var f=j+1;f<k;f++){g.push(true)}if(this.isGroupedData){this.grpIndices=a;this.hiddenGrps=g}else{this.smpIndices=a;this.hiddenSmps=g}}else{if(this.resizerEventData.g=="Heatmap"){if(!this.startingVarIndices||!this.startingSmpIndices){this.setOriginalIndices(h)}var b=this.startingVarIndices[h];var e=this.startingSmpIndices[h];if(this.resizerEventData.dim=="y"){if(this.isGroupedData){if(this.layoutComb){this.layoutParams[h]["grpIndices"]=[];for(var f=d;f<j;f++){this.layoutParams[h]["grpIndices"].push(e[f])}this.layoutParams[h]["smpIndicesStart"]=d}else{this.grpIndices=[];for(var f=d;f<j;f++){this.grpIndices.push(e[f])}this.smpIndicesStart=d}}else{if(this.layoutComb){this.layoutParams[h]["smpIndices"]=[];for(var f=d;f<j;f++){this.layoutParams[h]["smpIndices"].push(e[f])}this.layoutParams[h]["smpIndicesStart"]=d}else{this.smpIndices=[];for(var f=d;f<j;f++){this.smpIndices.push(e[f])}this.smpIndicesStart=d}}}else{if(this.layoutComb){this.layoutParams[h]["varIndices"]=[];for(var f=d;f<j;f++){this.layoutParams[h]["varIndices"].push(b[f])}this.layoutParams[h]["varIndicesStart"]=d}else{this.varIndices=[];for(var f=d;f<j;f++){this.varIndices.push(b[f])}this.varIndicesStart=d}}}else{if(this.resizerEventData.lastMin){this["setMin"+this.resizerEventData.set]=d}if(this.resizerEventData.lastMax){this["setMax"+this.resizerEventData.set]=j}}}if(m){this.updateResizerEventData(d,j)}this.draw()};this.drawAxesResizerBackgroundData=function(d,o,b,n){if(this.resizerType&&this.resizerDataIndex>-1){this.setAllSamplesVisible();var a,j,c,m;var k=this.graphType=="Candlestick"?"close":false;var g=[];var e=[];var p=[];for(var f=0;f<this.smpIndices.length;f++){g.push(this.getDataAtPos(this.resizerDataIndex,f,k))}var h=this.range(g);if(this.resizerPosition.match(/top|bottom/)){a=b/(this.smpIndices.length-1);j=n/((h[1]-h[0])*1.2);c=(h[1]-h[0])*0.1*j;m=o+n;e.push(d);p.push(m);for(var f=0;f<g.length;f++){e.push(d);p.push(m-(((g[f]-h[0])*j)+c));d+=a}d-=a;e.push(d);p.push(m)}else{a=n/(this.smpIndices.length-1);j=b/((h[1]-h[0])*1.2);c=(h[1]-h[0])*0.1*j;e.push(d);p.push(o);for(var f=0;f<g.length;f++){e.push(d+((g[f]-h[0])*j)+c);p.push(o);o+=a}o-=a;e.push(d);p.push(o)}this.drawShape("polygon",e,p,false,false,this.resizerBackgroundColorCurrent,this.resizerBackgroundColorOutlineCurrent,"closed")}};this.drawAxesResizerMasks=function(){if(this.resizerType){var e,h,d,f;var c=this.resizerEventData.areas;var b=this.isGroupedData?this.data.w.grps.length-1:this.data.y.smps.length-1;var a=this.resizerEventData.pos=="h"?(c.org[1]-c.org[0])/b:(c.org[3]-c.org[2])/b;var g=9-1;if(this.resizerEventData.pos=="h"){if(this.resizerEventData.smin>0){e=c.org[0]-1;h=c.org[2]-this.resizerWidth;d=a*this.resizerEventData.smin;f=this.resizerWidth;this.rectangle(e,h,d,f,this.resizerBackgroundColor,this.resizerBackgroundColor);this.drawLine("line",e,h,e+d+1,h,this.foreground);this.drawLine("line",e+d,h,e+d,h+f,this.foreground)}if(this.resizerEventData.smax<b){e=c.org[0]+c.max[0]+1;h=c.org[2]-this.resizerWidth;d=(a*(b-this.resizerEventData.smax))+1;f=this.resizerWidth;this.rectangle(e,h,d,f,this.resizerBackgroundColor,this.resizerBackgroundColor);this.drawLine("line",e-1,h,e+d+2,h,this.foreground);this.drawLine("line",e-1,h,e-1,h+f,this.foreground)}e=c.org[0]+c.max[0];h=c.org[2]-1;d=c.org[0]+a*this.resizerEventData.smin;this.drawLine("line",e,h,d,h,this.foreground)}else{if(this.resizerEventData.smin>0){e=c.org[0]+14;h=c.org[2];d=this.resizerWidth;f=a*this.resizerEventData.smin;this.rectangle(e,h,d,f,this.resizerBackgroundColor,this.resizerBackgroundColor);this.drawLine("line",e,h+f,e+d,h+f,this.foreground);this.drawLine("line",e+d,h,e+d,h+f,this.foreground)}if(this.resizerEventData.smax<b){e=c.org[0]+14;h=c.org[2]+c.min[2];d=this.resizerWidth;f=(b-this.resizerEventData.smax)*a;this.rectangle(e,h,d,f,this.resizerBackgroundColor,this.resizerBackgroundColor);this.drawLine("line",e,h,e+d,h,this.foreground);this.drawLine("line",e+d,h,e+d,h+f,this.foreground)}e=c.org[0]+14;h=c.org[2]+c.min[2];f=c.org[2]+(a*this.resizerEventData.smin);this.drawLine("line",e,h,e,f,this.foreground)}}};this.registerAxesResizer=function(d){if(!d){d=window.event}var h=this.adjustedCoordinates(d);if(h){var g=h.x;var f=h.y;var c=this.resizerEventData.areas;var k=c.lim[1]-c.lim[0];var j=c.lim[3]-c.lim[2];var a=5;var b=k>j?"h":"v";if(g>=c.min[0]+c.lim[0]&&g<=c.min[0]+c.min[1]+c.lim[0]&&f>=c.min[2]+c.lim[2]&&f<=c.min[2]+c.min[3]+c.lim[2]){this.resizerEventData.active="min";this.axesResizingOn=true}else{if(g>=c.max[0]+c.lim[0]&&g<=c.max[0]+c.max[1]+c.lim[0]&&f>=c.max[2]+c.lim[2]&&f<=c.max[2]+c.max[3]+c.lim[2]){this.resizerEventData.active="max";this.axesResizingOn=true}else{if(g>=c.cur[0]+c.lim[0]&&g<=c.cur[0]+c.cur[1]+c.lim[0]&&f>=c.cur[2]+c.lim[2]&&f<=c.cur[2]+c.cur[3]+c.lim[2]){this.resizerEventData.active="cur";this.axesResizingOn=true}else{if(b=="h"){if(g>=c.lim[0]&&g<c.min[0]+c.lim[0]){this.resizerEventData.active="prev";this.axesResizingOn=true}else{if(g>c.lim[0]+c.max[0]+c.max[1]&&g<=c.lim[1]-a){this.resizerEventData.active="next";this.axesResizingOn=true}}}else{if(f>=c.lim[2]+c.min[2]+c.min[3]&&f<=c.lim[2]+c.lim[3]){this.resizerEventData.active="prev";this.axesResizingOn=true}else{if(f>=c.lim[2]&&f<=c.lim[2]+c.max[2]){this.resizerEventData.active="next";this.axesResizingOn=true}}}}}}this.xMouseDown=g;this.yMouseDown=f}};this.activateDeactivateAxesResizer=function(j){if(!j){j=window.event}var s=this.adjustedCoordinates(j);if(s){var q;var r=s.x;var m=s.y;var h=this.resizerEventData.areas;var u=h.lim[1]-h.lim[0];var t=h.lim[3]-h.lim[2];var c=5;var f=u>t?"h":"v";if(f=="h"){if(r>=h.lim[0]&&r<=h.lim[0]+h.min[0]){q="prev"}else{if(r>=h.lim[0]+h.max[0]+h.max[1]&&r<=h.lim[1]-c){q="next"}}}else{if(m>=h.lim[2]+h.min[2]+h.min[3]&&m<=h.lim[2]+h.lim[3]){q="prev"}else{if(m>=h.lim[2]&&m<=h.lim[2]+h.max[2]){q="next"}}}var d=document.getElementById(this.target+"canvasXpressAxesResizePrevious");var g=document.getElementById(this.target+"canvasXpressAxesResizeNext");if(d&&g){if(q=="prev"){var k=d.style.backgroundImage;if(j.type.match(/mouseout/i)){if(k.match(/_active.png/)){d.style.backgroundImage=k.replace("_active.png",".png")}}else{if(!k.match(/_active.png/)){d.style.backgroundImage=k.replace(".png","_active.png")}}}else{if(q=="next"){var k=g.style.backgroundImage;if(j.type.match(/mouseout/i)){if(k.match(/_active.png/)){g.style.backgroundImage=k.replace("_active.png",".png")}}else{if(!k.match(/_active.png/)){g.style.backgroundImage=k.replace(".png","_active.png")}}}else{var k=d.style.backgroundImage;if(k.match(/_active.png/)){d.style.backgroundImage=k.replace("_active.png",".png")}k=g.style.backgroundImage;if(k.match(/_active.png/)){g.style.backgroundImage=k.replace("_active.png",".png")}}}}return false}};this.moveAxesResizer=function(k){var g=this.resizerEventData.smin;var m=this.resizerEventData.smax;var c=this.resizerType=="samples"||this.resizerEventData.g=="Heatmap"?1:(m-g)/10;if((this.resizerType=="samples"||this.resizerEventData.g=="Heatmap")&&this.resizerEventData.pos=="v"){if(this.resizerEventData.active=="prev"){if(g+c<this.resizerEventData.min){c=g-this.resizerEventData.min;this.resizerEventData.lastMin=this.resizerEventData.min;this.resizerEventData.lastMax=m+c}else{this.resizerEventData.lastMin=g+c;this.resizerEventData.lastMax=m+c}}else{if(m-c>this.resizerEventData.max){c=this.resizerEventData.max-m;this.resizerEventData.lastMin=g-c;this.resizerEventData.lastMax=this.resizerEventData.max}else{this.resizerEventData.lastMin=g-c;this.resizerEventData.lastMax=m-c}}}else{if(this.resizerEventData.active=="prev"){if(g-c<this.resizerEventData.min){c=g-this.resizerEventData.min;this.resizerEventData.lastMin=this.resizerEventData.min;this.resizerEventData.lastMax=m-c}else{this.resizerEventData.lastMin=g-c;this.resizerEventData.lastMax=m-c}}else{if(m+c>this.resizerEventData.max){c=this.resizerEventData.max-m;this.resizerEventData.lastMin=g+c;this.resizerEventData.lastMax=this.resizerEventData.max}else{this.resizerEventData.lastMin=g+c;this.resizerEventData.lastMax=m+c}}}var f=this.resizerEventData.areas;var d=document.getElementById(this.target+"canvasXpressAxesResizeMin");var o=document.getElementById(this.target+"canvasXpressAxesResizeMax");var n=document.getElementById(this.target+"canvasXpressAxesResizeMiddle");var j=document.getElementById(this.target+"canvasXpressAxesResizeCurrent");var b=14;var a=9-1;var p=parseInt(a/2);var h=c*this.resizerEventData.unit;if((this.resizerEventData.pos=="h"&&this.resizerEventData.active=="prev")||(this.resizerEventData.pos=="v"&&this.resizerEventData.active=="next")){h*=-1}if(this.resizerEventData.pos=="h"){d.style.left=(f.min[0]+h+1)+"px";n.style.left=((f.min[0]+h)+(f.cur[1]/2))+"px";o.style.left=(f.max[0]+h)+"px";j.style.left=(f.min[0]+h+p+1)+"px"}else{d.style.top=(f.min[2]+h+1)+"px";n.style.top=((f.max[2]+h)+(f.cur[3]/2))+"px";o.style.top=(f.max[2]+h)+"px";j.style.top=(f.max[2]+h+p+1)+"px"}};this.getAxesVals=function(e){var d=["minData","maxData","xAxisMin","xAxisMax","xAxis2Min","xAxis2Max","yAxisMin","yAxisMax","zAxisMin","zAxisMax","xAxisUnit","xAxis2Unit","yAxisUnit","zAxisUnit","setMin","setMax","setMin2","setMax2","setMinX","setMaxX","setMinY","setMaxY","setMinZ","setMaxZ","xAxisAbsMin","xAxisAbsMax","xAxis2AbsMin","xAxis2AbsMax","yAxisAbsMin","yAxisAbsMax","zAxisAbsMin","zAxisAbsMax","graphType","x","y","varIndices","smpIndices","grpIndices","varIndicesStart","smpIndicesStart"];var b={};if(this.layoutComb){for(var a=0;a<d.length;a++){b[d[a]]=this.layoutParams[e][d[a]]}}else{for(var a=0;a<d.length;a++){b[d[a]]=this[d[a]]}}return b};this.isAxis=function(h){if(!h){h=window.event}if(this.resizerType&&this.layoutValid){return false}var s=this.adjustedCoordinates(h);if(s){var q=s.x;var o=s.y;var m=0;var r=(this.margin*1);var p=(this.margin*2);var a=18;for(var d=0;d<this.layoutRows;d++){for(var b=0;b<this.layoutCols;b++){var f=this.layoutComb?this.layoutParams[m].graphType:this.graphType;if(f.match(/Network|Pie|Venn|Stacked|Area|Correlation/)){return false}var k=this.getBoundsXY(m);if(f.match(/Scatter/)){if(q>=k[0]&&q<=k[1]&&o>=k[3]&&o<=k[3]+a){var n=this.getAxesVals(m);this.showAxesResizer("xAxis",k[0],k[1],k[3]+r,k[3]+this.getAxisFont(n.x)+p,"x","h","b",n,"X",m,d,b);return true}else{if(q>=k[0]-a&&q<=k[0]&&o>=k[2]&&o<=k[3]){var n=this.getAxesVals(m);this.showAxesResizer("yAxis",k[0]-(this.getAxisFont(n.y)+p),k[0]-r,k[2],k[3],"y","v","l",n,"Y",m,d,b);return true}}}else{if(f.match(/Heatmap/)){if(q>=k[0]-a&&q<=k[0]&&o>=k[2]&&o<=k[3]){var n=this.getAxesVals(m);this.showAxesResizer("xAxis",k[0]-(this.getAxisFont(n.y)+p),k[0]-r,k[2],k[3],"y","v","l",n,"",m,d,b);return true}else{if(q>=k[1]&&q<=k[1]+a&&o>=k[2]&&o<=k[3]){var n=this.getAxesVals(m);this.showAxesResizer("xAxis",k[1]+r,k[1]+this.getAxisFont(n.y)+p,k[2],k[3],"y","v","r",n,"",m,d,b);return true}else{if(q>=k[0]&&q<=k[1]&&o>=k[2]-a&&o<=k[2]){var n=this.getAxesVals(m);this.showAxesResizer("xAxis",k[0],k[1],k[2]-(this.getAxisFont(n.x)+p),k[2]-r,"x","h","t",n,"",m,d,b);return true}else{if(q>=k[0]&&q<=k[1]&&o>=k[3]&&o<=k[3]+a){var n=this.getAxesVals(m);this.showAxesResizer("xAxis",k[0],k[1],k[3]+r,k[3]+this.getAxisFont(n.x)+p,"x","h","b",n,"",m,d,b);return true}}}}}else{if(this.graphOrientation=="vertical"){if(q>=k[0]-a&&q<=k[0]&&o>=k[2]&&o<=k[3]){var n=this.getAxesVals(m);this.showAxesResizer("xAxis",k[0]-(this.getAxisFont(n.y)+p),k[0]-r,k[2],k[3],"y","v","l",n,"",m,d,b);return true}else{if(q>=k[1]&&q<=k[1]+a&&o>=k[2]&&o<=k[3]){var n=this.getAxesVals(m);if(f=="BarLine"){this.showAxesResizer("xAxis2",k[1]+r,k[1]+this.getAxisFont(n.y)+p,k[2],k[3],"y","v","r",n,"2",m,d,b)}else{this.showAxesResizer("xAxis",k[1]+r,k[1]+this.getAxisFont(n.y)+p,k[2],k[3],"y","v","r",n,"",m,d,b)}return true}}}else{if(q>=k[0]&&q<=k[1]&&o>=k[2]-a&&o<=k[2]){var n=this.getAxesVals(m);this.showAxesResizer("xAxis",k[0],k[1],k[2]-(this.getAxisFont(n.x)+p),k[2]-r,"x","h","t",n,"",m,d,b);return true}else{if(q>=k[0]&&q<=k[1]&&o>=k[3]&&o<=k[3]+a){var n=this.getAxesVals(m);if(f=="BarLine"){this.showAxesResizer("xAxis2",k[0],k[1],k[3]+r,k[3]+this.getAxisFont(n.x)+p,"x","h","b",n,"2",m,d,b)}else{this.showAxesResizer("xAxis",k[0],k[1],k[3]+r,k[3]+this.getAxisFont(n.x)+p,"x","h","b",n,"",m,d,b)}return true}}}}}m++}}}return false};this.endAxesResizer=function(a){if(this.axesResizingOn){this.resetInfoSpan(a);if(this.resizerEventData.active=="prev"||this.resizerEventData.active=="next"){this.moveAxesResizer(a)}this.drawAxesResizerUpdate(true);this.axesResizingOn=false}else{if(this.resizerType){this.updateResizerEventData();this.refreshAxesResizer()}}};this.resetAxesResizer=function(b){if(this.axesResizerShow){var a=document.getElementById(this.target+"canvasXpressAxesResize");if(a){this.addRemoveAxesResizerListeners("removeEvtListener");a.style.display="none";this.resizerEventData={};this.resetInfoSpan(b);this.axesResizerShow=false}}};this.initializeAxisResizerEvents=function(){if(!this.disableEvents){this.addAxesResizeDiv()}};this.initializeAxisResizerEvents()};CanvasXpress.prototype.initEvents=function(){this.cancelEvent=function(a){if(!a){a=window.event}if(a.preventDefault){a.preventDefault()}else{a.returnValue=true}};this.stopEvent=function(a){if(!a){a=window.event}if(a.stopPropagation){a.stopPropagation()}else{a.cancelBubble=true}};this.normalizeEvtName=function(a){return this.isIE?"on"+a:a};this.addEvtListener=function(d,b,g,a){if(b&&g){if(this.isIE){d.attachEvent(this.normalizeEvtName(b),g)}else{d.addEventListener(b,g,a);if(b=="mousewheel"){d.addEventListener("DOMMouseScroll",g,a)}}}};this.removeEvtListener=function(d,b,g,a){if(b&&g){if(this.isIE){d.detachEvent(this.normalizeEvtName(b),g)}else{d.removeEventListener(b,g,a);if(b=="mousewheel"){d.removeEventListener("DOMMouseScroll",g,a)}}}};this.destroy=function(a){if(a){if(CanvasXpress.references.length==1&&CanvasXpress.references[i].target==a){return this.destroy()}else{this.removeReference(a)}}else{if(this.destroyAllOnClose){while(CanvasXpress.references.length>0){a=CanvasXpress.references[0];this.removeReference(a.target)}}}};this.removeReference=function(e,b){var d=CanvasXpress.references;CanvasXpress.references=[];for(var c=0;c<d.length;c++){if(d[c].target!=e){CanvasXpress.references.push(d[c])}else{var f=d[c];f.cleanEvtListeners(b);f.removeTarget("wrapper-"+f.target);f.removeTarget(f.target+"canvasXpressLink");f.removeTarget(f.target+"canvasXpressCode");f.removeTarget(f.target+"canvasXpressInfoDiv");f.removeTarget(f.target+"canvasXpressDataTable")}}};this.cleanEvtListeners=function(b){this.addRemoveLinkListeners("removeEvtListener");this.addRemoveConfiguratorListeners("removeEvtListener");this.addRemoveDataTableListeners("removeEvtListener");this.addRemoveCanvasListeners("removeEvtListener");this.resetMap();this.addRemoveAxesResizerListeners("removeEvtListener");this.addRemoveNavigationTopListeners("removeEvtListener");this.addRemoveNavigationLeftRightListeners("removeEvtListener");this.removeEvtListener(document,"mousemove",this.mousemoveDoc,false);this.removeEvtListener(document,"mouseup",this.mouseupDoc,false);this.removeEvtListener(document,"keydown",this.keydownDoc,false);this.removeEvtListener(document,"keyup",this.keyupDoc,false);this.removeEvtListener(window,"resize",this.resizeWindow,false)};this.adjustedCoordinates=function(g,d){if(!d){d=document.getElementById(this.target+"canvasXpressImage")}if(this.isIE){if(!window.event){return}}if(d){var j={};var f=d.parentNode.getClientRects();if(f&&f[0]){var b=f[0].left;var d=f[0].top;var a=g&&g.clientX?g.clientX:g&&g[0]?g[0]:b;var h=g&&g.clientY?g.clientY:g&&g[1]?g[1]:d;j.x=document.body.scrollLeft>Math.abs(b)+a&&a>document.body.scrollLeft-b?Math.abs(b)+a:a-b;j.y=document.body.scrollTop>Math.abs(d)+h&&h>document.body.scrollTop-d?Math.abs(d)+h:(h-d)}else{j.x=0;j.y=0}return j}};this.isPointInsideArea=function(o,n,m,k){switch(o){case"rect":if(k[0]>k[2]){k[4]=k[0];k[0]=k[2];k[2]=k[4]}if(k[1]>k[3]){k[4]=k[1];k[1]=k[3];k[3]=k[4]}if(n>=k[0]&&n<=k[2]&&m>=k[1]&&m<=k[3]){return true}else{return false}case"circle":var f=k[2]/2;k[0]=parseInt(k[0]);k[1]=parseInt(k[1]);if(n>=k[0]-f&&n<=k[0]+f&&m>=k[1]-f&&m<=k[1]+f){return true}else{return false}case"poly":var d=[];var a=[];var g=false;for(var e=0;e<k.length;e++){if(e%2){a.push(k[e])}else{d.push(k[e])}}if(a[0]<a[1]){a=a.reverse();d=d.reverse()}for(var e=0,b=d.length-1;e<d.length;b=e++){if(((a[e]<=m&&m<a[b])||(a[b]<=m&&m<a[e]))&&(n<(d[b]-d[e])*(m-a[e])/(a[b]-a[e])+d[e])){g=!g}}return g}};this.isEvent=function(o,g){var u=this.adjustedCoordinates(o);if(u){var b=o.target||o.srcElement;if(b&&b.id&&b.id.match(this.target)){var t=u.x;var q=u.y;if(this.modelEvent=="local"){var h=document.getElementById(this.target+"canvasXpressMap");if(h){var r=h.childNodes;for(var j=r.length-1;j>=0;j--){var d=r[j].id.replace(this.target,"");var v=r[j].shape;var p=r[j].coords.split(",");if(this.isPointInsideArea(v,t,q,p)){return d}}}}else{var r=this.dataEvent;for(var j=r.length-1;j>=0;j--){var d=r[j][0];var v=r[j][1];var p=r[j][2];var k=r[j][3];if(this.isPointInsideArea(v,t,q,p)){if(k){k=d[0]+k}return g?[d,k]:k?[k]:d}}}}}return false};this.getBoundsXY=function(e){var d=this.layoutComb?this.layoutParams[e]:this;var a=this.graphType=="Network"?0:this.marginLeft+d.offsetX+d.left;var b=this.graphType=="Network"?0:this.marginTop+d.offsetY+d.top;return[a,a+d.x,b,b+d.y]};this.extractDataObject=function(h,b){var k=this;var D=this.layoutComb&&this.layoutValidN>-1?this.layoutParams[this.layoutValidN].graphType:this.graphType;var J=[];var H=[];var G=[];var x=function(d){var n={};for(var j in k.data.x){n[j]=[];for(var g=0;g<d.length;g++){n[j].push(k.data.x[j][d[g]])}}return n};var w=function(d){var n={};for(var j in k.data.z){n[j]=[];for(var g=0;g<d.length;g++){n[j].push(k.data.z[j][d[g]])}}return n};var E=function(d){var j=[];for(var g=0;g<d.length;g++){j.push(k.data.y.vars[d[g]])}return j};var m=function(j,p){var d=p?k.data.w.smps:k.data.y.smps;var s=[];for(var n=0;n<j.length;n++){s.push(d[j[n]])}return s};var f=function(d){var j=[];for(var g=0;g<d.length;g++){j.push(k.data.w.grps[d[g]])}return j};var e=function(g,d){var s=[];if(d){for(var p=0;p<g.length;p++){s[p]=[];for(var n=0;n<d.length;n++){s[p].push(k.data.y.data[g[p]][d[n]])}}}else{for(var p=0;p<g.length;p++){s.push(k.data.y.data[g[p]])}}return s};switch(D){case"Area":case"AreaLine":case"Bar":case"Line":case"BarLine":case"Boxplot":case"Dotplot":case"Heatmap":case"Pie":case"Stacked":case"StackedLine":case"StackedPercent":case"StackedPercentLine":case"Scatter2D":case"ScatterBubble2D":case"Scatter3D":case"Candlestick":if(!h||h.length==0||h[0]==null){return}else{if(isNaN(h[0])){if(h[0]&&h[0].match(/Dendrogram/)){var z={t:{}};var y=h[0].split("-");z.t.d=parseInt(y[1]);z.t.o=parseInt(y[2]);z.t.t=y[3];return z}else{if(h[0]&&h[0].match(/Var/)){var y=h[0].split("-");var C=parseInt(y[1]);var I=[C];I=I.concat(this.smpIndices);var z=this.extractDataObject(I);z.display=this.data.y.vars[C];return z}else{if(h[0]&&h[0].match(/Smp/)){var y=h[0].split("-");var C=parseInt(y[1]);var z=this.extractDataObject([C],this.varIndices);z.display=this.isGroupedData?this.data.w.smps[C]:this.data.y.smps[C];return z}else{return}}}}else{if(b){J=b;H=h}else{J=[h[0]];H=[];for(var C=1;C<h.length;C++){H.push(h[C])}}if(D.match(/Scatter/)){if(this.colorBy&&this.getSampleIndices(this.colorBy)>-1){H.push(this.getSampleIndices(this.colorBy))}if(this.shapeBy&&this.getSampleIndices(this.shapeBy)>-1){H.push(this.getSampleIndices(this.shapeBy))}if(this.sizeBy&&this.getSampleIndices(this.sizeBy)>-1){H.push(this.getSampleIndices(this.sizeBy))}}}}if(D.match(/Area/)){return{x:this.data.x,y:{vars:E(J),smps:this.data.y.smps,data:e(J)},z:w(J)}}else{if(this.isGroupedData){var z={x:{},w:{},z:w(J)};for(var y in this.data.w){if(y=="smps"){z.w[y]=m(H,true)}else{if(y=="grps"){z.w[y]=f(H)}else{if(y=="vars"){z.w[y]=E(J)}else{if(this.data.w[y].length>J[0]&&this.data.w[y][J[0]].length>H[0]){z.w[y]=[];z.w[y].push(this.data.w[y][J[0]][H[0]])}}}}}for(var y in this.data.x){var q=[];for(var C=0;C<z.w.grps[0].length;C++){q.push(this.data.x[y][z.w.grps[0][C]])}z.x[y]=q}}else{var z={x:x(H),y:{vars:E(J),smps:m(H)},z:w(J)};if(D=="Candlestick"){for(var y in this.data.y){if(y&&y!="vars"&&y!="smps"&&y!="desc"){z.y[y]=[];for(var C=0;C<J.length;C++){z.y[y][C]=[];for(var B=0;B<H.length;B++){z.y[y][C].push(this.data.y[y][J[C]][H[B]])}}}}}else{z.y.data=e(J,H)}}}return z;case"Correlation":if(!h||(isNaN(h[0])&&!h[0].match(/^\d/))){return}else{var F=this.isGroupedData?this.data.w.cor:this.data.y.cor}if(this.correlationAxis=="samples"){var z={x:{},y:{}};for(var y in this.data.x){var q=[];for(var C=0;C<h.length;C++){q.push(this.data.x[y][h[C]])}z.x[y]=q}z.y.smps=[this.data.y.smps[h[0]],this.data.y.smps[h[1]]]}else{var z={y:{},z:{}};for(var y in this.data.y){var c=[];for(var C=0;C<h.length;C++){c.push(this.data.y[y][h[C]])}z.z[y]=c}z.y.vars=[this.data.y.vars[h[0]],this.data.y.vars[h[1]]]}z.y.data=F[h[0]][h[1]];return z;case"Venn":var z={venn:{data:{}}};z.venn.data[this.vennCompartments[h[0]]]=this.data.venn.data[this.vennCompartments[h[0]]];return z;case"Network":var z={};if(!h||h.length==0){return}if(isNaN(h[0])){h[0]=h[0].toString();if(h[0].match(/legend/)){if(h[0].match(/Nodes/)){z={nodeLegend:this.data.legend.nodes}}else{if(h[0].match(/Edges/)){z={edgeLegend:this.data.legend.edges}}else{if(h[0].match(/Decorations/)){z={decorationLegend:this.data.legend.decorations}}else{var r=parseInt(h[0].replace("-1-legend-Text",""));z={textLegend:this.data.legend.text[r]}}}}}}else{for(var C=0;C<h.length;C++){if(h[C]>=this.data.nodes.length){if(!z.edges){z.edges=[]}z.edges.push(this.data.edges[h[C]-this.data.nodes.length])}else{if(!z.nodes){z.nodes=[]}z.nodes.push(this.data.nodes[h[C]])}}}return z;case"Genome":var D;var z=[];z[0]={};var r=0;var u=isNaN(h[0])&&h[0].match(":")?h[0].match(/:(\d+)/)[1]:false;for(var C=0;C<this.data.tracks.length;C++){if(isNaN(h[0])){if(h[0]=="track-"+C){return{name:this.data.tracks[C].name}}else{if(h[0]=="track-"+C+":"+u){return{name:this.subtracksInfo[u].name}}}continue}var A=this.data.tracks[C].data.length;r+=A;if(h[0]<r){var v=h[0]-(r-A);for(var y in this.data.tracks[C]){if(y=="data"){z[0][y]=[];z[0][y].push(this.data.tracks[C][y][v])}else{z[0][y]=this.data.tracks[C][y]}}return z}}}};this.getSummaryDataObject=function(h){if(h){switch(this.graphType){case"Bar":case"Line":case"Area":case"AreaLine":case"BarLine":case"Boxplot":case"Dotplot":case"Heatmap":case"Stacked":case"StackedLine":case"StackedPercent":case"StackedPercentLine":case"Scatter2D":case"ScatterBubble2D":case"Scatter3D":var g="";if(h.display){return"<b>"+h.display+"</b><br>"}else{if(this.isGroupedData&&h.w){g="<b>"+h.w.vars[0]+"</b><br>";if(this.summaryType=="mean"){for(var b=0;b<h.w.smps.length;b++){g+="<b>"+h.w.smps[b]+"</b>: "+h.w.mean[b]+"<br>"}}else{if(this.summaryType=="median"||this.summaryType=="iqr"){for(var b=0;b<h.w.smps.length;b++){g+="<b>"+h.w.smps[b]+"</b>: "+h.w.median[b]+"<br>"}}else{if(this.summaryType=="sum"){for(var b=0;b<h.w.smps.length;b++){g+="<b>"+h.w.smps[b]+"</b>: "+h.w.sum[b]+"<br>"}}}}}else{if(h.y){g="<b>"+h.y.vars[0]+"</b><br>";for(var b=0;b<h.y.smps.length;b++){g+="<b>"+h.y.smps[b]+"</b>: "+h.y.data[0][b]+"<br>"}}else{if(h.t){g="<b>"+h.t.t+"</b><br>Depth: "+h.t.d+"<br>"}}}}return g;case"Pie":var f="<b>"+h.y.smps[0]+"</b><br>";for(var b=0;b<h.y.vars.length;b++){var d=sprintf("%."+this.pieSegmentPrecision+"f",(h.y.data[b]/this.varPie.tot)*100);f+="<b>"+h.y.vars[b]+"</b>: "+h.y.data[b]+" ("+d+"%)<br>"}return f;case"Candlestick":return dateFormat(h.y.smps[0],this.timeFormat)+", "+h.y.close[0];case"Correlation":var f;if(this.correlationAxis=="samples"){f=h.y.smps[0]+" vs "+h.y.smps[1]}else{f=h.y.vars[0]+" vs "+h.y.vars[1]}return f;case"Venn":for(var a in h.venn.data){return a+" = "+h.venn.data[a]}case"Network":var f;if(h&&h.nodes){if(h.nodes[0]){f=h.nodes[0].hideTooltip?"":h.nodes[0].tooltip||h.nodes[0].name||h.nodes[0].label||h.nodes[0].id}}else{if(h&&h.edges){var e=this.nodes[h.edges[0].id1];var c=this.nodes[h.edges[0].id2];f=(e.label||e.id)+" - "+(c.label||c.id);f=h.edges[0].hideTooltip?"":h.edges[0].tooltip||h.edges[0].name||h.edges[0].label||f}}return f;case"Genome":return h.name||h[0].data[0].id}}else{return""}};this.setUserEvents=function(){this.userEvents={};if(this.disableEvents){return}var b=this;if(this.events&&this.events.enddragnode){this.userEvents.enddragnode=this.events.enddragnode}if(this.events&&this.events.mouseout){this.userEvents.mouseout=this.events.mouseout}else{this.userEvents.mouseout=function(f,d){b.resetInfoSpan(d)}}if(this.events&&this.events.click){this.userEvents.click=this.events.click}else{this.userEvents.click=function(f,d){if(f&&f.t){b.modifyDendrogram(f)}else{if(f.nodes&&f.nodes.length==1&&f.nodes[0].links){b.showLinkDiv(d,f.nodes[0].links)}else{b.updateDataTable(f)}}return false}}if(this.events&&this.events.dblclick){this.userEvents.dblclick=this.events.dblclick}else{this.userEvents.dblclick=function(f,d){if(f){alert(b.prettyJSON(f))}return false}}var c=["mouseover"];if(b.modelEvent!="local"){c.push("mousemove")}for(var a=0;a<c.length;a++){if(this.events&&this.events[c[a]]){this.userEvents[c[a]]=this.events[c[a]]}else{this.userEvents[c[a]]=function(g,d){var f=b.getSummaryDataObject(g);if(f&&f!=""){b.showInfoSpan(d,f)}}}}};this.resetFlags=function(a){this.resetOn=true;this.animationOn=false;this.draggingOn=false;this.movingOn=false;this.changingColorOn=false;this.xMouseDown=false;this.yMouseDown=false;this.moveNode=false;this.moveNodeIndex=false;this.moveNodeLab=false;this.moveNodeDec=false;this.moveLegend=false;this.moveNodeX=false;this.moveNodeY=false;this.moveNodeW=false;this.moveNodeH=false;this.moveGenome=false;if(a){this.stopEvent(a)}document.defaultAction=true;document.body.style.cursor="default"};this.mousemoveDoc=function(a){return function(d){if(!d){d=window.event}var b=document.getElementById(a.target+"canvasXpressImage");if(a.isVersion(d)){b.style.cursor="help";a.showInfoSpan([d.clientX,d.clientY+50],"CanvasXpress ("+a.version+")")}else{if(a.draggingTargetOn){a.preventSelection();a.updateMousemove(d)}else{if(a.resizingDataTableOn){a.preventSelection();a.updateDataTableResizerDiv(d)}else{if(a.resizingDataTableColumnOn){a.preventSelection();a.mousemoveDataTableHeader(d)}else{if(a.changingColorOn){a.preventSelection();a.updateColorValue(d)}else{if(b&&a.isInView(b)){if(!a.configuringOn){a.cancelEvent(d);if(a.draggingOn){a.updateDragDiv(d)}else{if(a.resizingCanvasOn&&a.resizeCanvasCursorShow){a.updateCanvasResizer(d)}else{a.updateCanvasResizerCursor(d)}}if(a.modelEvent!="local"){var c=a.isEvent(d);if(c){a.handleMouseAreaEvents("mousemove",d,c)}else{a.resetInfoSpan(d,true)}}}}}}}}}return false}}(this);this.preventSelection=function(){document.body.focus();document.onselectstart=function(){return false};if(document.selection){document.selection.empty()}else{if(window.getSelection){window.getSelection().removeAllRanges()}}};this.registerMousemove=function(a){return function(c){if(!c){c=window.event}var b=c.target||c.srcElement;if((c.button==1&&window.event!=null||c.button==0)&&b.className=="draggable"){a.draggableTarget=b.parentNode&&b.parentNode.className=="draggable-container"?b.parentNode:b;a.xMouseDown=c.clientX;a.yMouseDown=c.clientY;a.draggableXoffset=parseInt(a.draggableTarget.style.left)||0;a.draggableYoffset=parseInt(a.draggableTarget.style.top)||0;a.draggingTargetOn=true}}}(this);this.updateMousemove=function(b){if(!b){b=window.event}if(this.draggableTarget&&this.draggableTarget.style){var a=this.draggableXoffset+b.clientX-this.xMouseDown;var c=this.draggableYoffset+b.clientY-this.yMouseDown;this.draggableTarget.style.left=a+"px";this.draggableTarget.style.top=c+"px";this.draggableLastX=a;this.draggableLastY=c}};this.endMousemove=function(a){if(this.draggableTarget!=null){document.onselectstart=null;this.xMouseDown=null;this.yMouseDown=null;this.draggableXoffset=null;this.draggableYoffset=null;this.draggableTarget.ondragstart=null;this.draggableTarget=false;this.draggingTargetOn=false}};this.initDocEvents=function(){this.mouseupDoc=function(a){return function(b){if(!b){b=window.event}if(a.draggingTargetOn){a.endMousemove(b)}else{if(a.resizingDataTableOn){a.endDataTableResizerDiv(b)}else{if(a.resizingDataTableColumnOn){a.endDataTableColumnResize(b)}else{if(a.changingColorOn){a.endColorChange(b)}else{if(!a.configuringOn){a.stopEvent(b);a.endDragDiv(b);a.endCanvasResizer(b);a.endAxesResizer(b);a.resetFlags(b)}}}}}}}(this);this.keydownDoc=function(a){return function(c){if(!c){c=window.event}var b=document.getElementById(a.target+"canvasXpressImage");if(b&&a.isInView(b)){a.registerKey(c)}}}(this);this.keyupDoc=function(a){return function(c){if(!c){c=window.event}var b=document.getElementById(a.target+"canvasXpressImage");if(b&&a.isInView(b)){if(a.configuringOn){a.selectConfig(c)}}}}(this);this.resizeWindow=function(a){return function(b){if(!b){b=window.event}a.resizeImage(true);return false}}(this);this.addEvtListener(document,"mousemove",this.mousemoveDoc,false);this.addEvtListener(document,"mouseup",this.mouseupDoc,false);this.addEvtListener(document,"keydown",this.keydownDoc,false);this.addEvtListener(document,"keyup",this.keyupDoc,false);this.addEvtListener(window,"resize",this.resizeWindow,false)};this.initializeEvents=function(){this.setUserEvents();this.initLinkEvents();this.initConfigurator();this.initDataTable();this.initDraggingEvents();this.initCanvasResizerEvents();this.initAxisResizerEvents();this.initInfoEvents();this.initKeyEvents();this.initSelectEvents();this.initDendrogramEvents();this.initImageMapEvents();this.initCodeInfo();this.initDocEvents()};this.initializeEvents()};CanvasXpress.prototype.initAnimation=function(){this.saveSnapshot=function(){var a=this.cloneVisualData(this.data);if(a){this.snapshots.push(a)}};this.playSnapshot=function(b,d,c){if(this.snapshots.length<1){return}this.stopSnapshotPlay();var a=this;this.snapshotPlay={idx:0,time:b,task:setTimeout(function(){a.nextSnapshot(c)},0),callback:d,oldData:this.data};this.snapshotPaused=false};this.nextSnapshot=function(c){if(this.snapshotPlay.idx>=this.snapshots.length){if(this.snapshotPlay.callback){this.snapshotPlay.callback.call(this,c)}else{this.snapshotPlay.idx=0}}if(this.snapshotPlay){var b=this.snapshotPlay.time||this.snapshots[this.snapshotPlay.idx].time||50;this.loadData(this.snapshots[this.snapshotPlay.idx++],true);var a=this;this.snapshotPlay.task=setTimeout(function(){a.nextSnapshot(c)},b);this.snapshotPaused=false}};this.stopSnapshotPlay=function(a){if(!this.snapshotPlay){return}clearTimeout(this.snapshotPlay.task);this.loadData(this.snapshotPlay.oldData,a);delete this.snapshotPlay;this.snapshotPaused=false};this.clearSnapshot=function(){this.stopSnapshotPlay(true);this.snapshots=[];this.snapshotPaused=false};this.duplicateSnapshot=function(){if(this.snapshots.length<1){return}var a=(this.snapshotPlay?this.snapshotPlay.idx:this.snapshots.length)-1;var b=this.cloneVisualData(this.snapshots[a]);if(this.snapshotPlay){this.snapshots.splice(a+1,0,b);this.snapshotPlay.idx++}else{this.snapshots.push(b)}};this.makeSnapshotPlay=function(){if(!this.snapshotPlay){this.snapshotPlay={idx:this.snapshots.length,oldData:this.data}}else{this.pauseSnapshot()}};this.moveSnapshot=function(c){if(this.snapshots.length<1){return}this.makeSnapshotPlay();var b=this.snapshotPlay.idx-1,a=b+c;if(a>=0&&a<=this.snapshots.length){this.snapshots.splice(a,0,(this.snapshots.splice(b,1))[0])}this.snapshotPlay.idx=a+1};this.prevSnapshotOnce=function(){if(this.snapshots.length<2){return}this.makeSnapshotPlay();this.snapshotPlay.idx-=2;if(this.snapshotPlay.idx<0){this.snapshotPlay.idx=0}this.loadData(this.snapshots[this.snapshotPlay.idx++],true);this.snapshotPaused=true};this.nextSnapshotOnce=function(){if(!this.snapshotPlay){return}if(this.snapshotPlay.idx<this.snapshots.length){this.loadData(this.snapshots[this.snapshotPlay.idx++],true)}this.snapshotPaused=true};this.hasNextSnapshot=function(){return this.snapshots.length>1&&this.snapshotPlay&&this.snapshotPaused&&this.snapshotPlay.idx<this.snapshots.length};this.hasPrevSnapshot=function(){return this.snapshots.length>1&&(!this.snapshotPlay||(this.snapshotPlay.idx>1&&this.snapshotPaused))};this.updateSnapshot=function(){if(this.snapshotPlay){this.snapshots[this.snapshotPlay.idx-1]=this.cloneVisualData(this.data)}};this.pauseSnapshot=function(){if(!this.snapshotPlay){return}if(this.snapshotPlay.task){clearTimeout(this.snapshotPlay.task)}this.snapshotPaused=true};this.setSnapshotTime=function(a){if(a>0){this.snapshots[this.snapshotPlay.idx-1].time=a}};this.getSnapshotTime=function(){return this.snapshots[this.snapshotPlay.idx-1].time||50};this.assembleObj=function(b,k,p){var e=[];if(!k[p]){return b[p]}if(!k[p].indices){k[p].indices={}}for(var h=0;h<b[p].length;h++){var f=b[p][h],a=f.id||f.id1+"-"+f.id2;if(!k[p].deleted[a]){var m=k[p].changed[a];if(m){for(var g in m){f[g]=m[g]}}var q=k[p].indices[a]!=null?k[p].indices[a]:p=="nodes"?b.nodeIndices[a]:b.edgeIndices[a];e[q]=f;k[p].indices[a]=q}}for(var a in k[p].added){e[k[p].indices[a]]=k[p].added[a]}return e};this.assembleData=function(b,c){var a={};a.nodes=this.assembleObj(b,c,"nodes");a.nodeIndices=c.nodes&&c.nodes.indices?c.nodes.indices:b.nodeIndices;a.edges=this.assembleObj(b,c,"edges");a.legend=c.legend||b.legend;return a};this.loadData=function(d,e){this.data=d;switch(this.graphType){case"Bar":case"Line":case"BarLine":case"Dotplot":case"Scatter2D":case"ScatterBubble2D":break;case"Scatter3D":case"Area":case"AreaLine":case"Boxplot":case"Heatmap":case"Stacked":case"StackedLine":case"StackedPercent":case"StackedPercentLine":case"Candlestick":case"Correlation":case"Venn":case"Pie":case"Genome":return false;break;case"Network":if(this.data.type=="changedData"){this.data=this.assembleData(this.cloneObject(this.snapshotsBase),this.cloneObject(this.data))}this.edges=this.data.edges;var b={};for(var c=0;c<this.data.nodes.length;c++){var a=this.data.nodes[c];b[a.id]=a}this.nodes=b;break}if(e){this.draw(false,false,true)}};this.changedNodeData=function(c,g){var j={deleted:{},changed:{},added:{}};for(var b in c.nodeIndices){var k=g.nodeIndices[b];if(k==null){j.deleted[b]=1}else{var h=c.nodes[c.nodeIndices[b]],e=g.nodes[k],m={id:b},f=false;for(var a in e){if(!this.isSameObject(e[a],h[a])){m[a]=e[a];f=true}}if(f){j.changed[b]=m}}}for(var b in g.nodeIndices){if(c.nodeIndices[b]==null){j.added[b]=g.nodes[g.nodeIndices[b]]}}j.indices=this.changedIndices(c.nodeIndices,g.nodeIndices);return j};this.getEdgeIndices=function(f){var b={};if(f.edges.length){for(var a=0;a<f.edges.length;a++){var c=f.edges[a];b[c.id1+"-"+c.id2]=a}}return b};this.changedEdgeData=function(f,g){var c={deleted:{},changed:{},added:{}};if(!f.edgeIndices){f.edgeIndices=this.getEdgeIndices(f)}var e=this.getEdgeIndices(g);for(var h in f.edgeIndices){var a=e[h];if(a==null){c.deleted[h]=1}else{var b=g.edges[a];if(!this.isSameObject(f.edges[f.edgeIndices[h]],b)){c.changed[h]=b}}}for(var h in e){if(f.edgeIndices[h]==null){c.added[h]=g.edges[e[h]]}}c.indices=this.changedIndices(f.edgeIndices,e);return c};this.changedIndices=function(b,c){var a={};for(var e in c){if(b[e]==null||b[e]!=c[e]){a[e]=c[e]}}return a};this.getSnapshotChanged=function(b){var a=this.snapshotsBase;return{type:"changedData",nodes:this.changedNodeData(a,b),edges:this.changedEdgeData(a,b),legend:this.isSameObject(a.legend,b.legend)?null:b.legend}};this.cloneVisualData=function(f){switch(this.graphType){case"Bar":case"Line":case"BarLine":case"Dotplot":case"Scatter2D":case"ScatterBubble2D":return this.cloneObject(f);break;case"Scatter3D":case"Area":case"AreaLine":case"Boxplot":case"Heatmap":case"Stacked":case"StackedLine":case"StackedPercent":case"StackedPercentLine":case"Candlestick":case"Correlation":case"Venn":case"Pie":case"Genome":return false;break;case"Network":if(this.snapshotCopyChangeOnly){if(this.snapshots.length){return f.type=="changedData"?this.cloneObject(f):this.getSnapshotChanged(f)}else{this.snapshotsBase=this.cloneObject(f);return{type:"changedData"}}}if(!this.snapshotNoCopyData){return this.cloneObject(f)}var c={nodes:[],edges:[]};if(f.nodes&&f.nodes.length){for(var b=0;b<f.nodes.length;b++){var g={};var e=f.nodes[b];var h=["outline","width","height","pattern","rotate","color","shape","size","x","y","id","hideLabel","hideChildren","hideParent","label","labelX","labelY","labelSize","name","hide","anchor","parentNode","imagePath"];for(var a=0;a<h.length;a++){g[h[a]]=e[h[a]]}c.nodes.push(g)}}if(f.edges&&f.edges.length){for(var b=0;b<f.edges.length;b++){var g={};var e=f.edges[b];var h=["color","width","type","id1","id2","anchor"];for(var a=0;a<h.length;a++){g[h[a]]=e[h[a]]}c.edges.push(g)}}return c;break}};this.isValidAnimation=function(){switch(this.graphType){case"Bar":case"Line":case"BarLine":case"Dotplot":case"Scatter2D":case"ScatterBubble2D":return true;case"Scatter3D":case"Area":case"AreaLine":case"Boxplot":case"Heatmap":case"Stacked":case"StackedLine":case"StackedPercent":case"StackedPercentLine":case"Candlestick":case"Correlation":case"Venn":case"Pie":case"Genome":case"Network":return false}};this.createAnimation=function(e){switch(this.graphType){case"Bar":case"Line":case"BarLine":case"Dotplot":case"Scatter2D":case"ScatterBubble2D":this.isAnimation=true;var f=this.cloneVisualData(this.data);if(e.match(/grow|spring|random/)&&this.data.y.data){var d=this.animationCycles;for(var c=0;c<d;c++){for(var b=0;b<this.data.y.data.length;b++){for(var a=0;a<this.data.y.data[b].length;a++){if(!isNaN(this.data.y.data[b][a])){var g=this.data.y.data[b][a];if(e=="grow"){this.data.y.data[b][a]=g/d*c}else{if(e=="spring"){this.data.y.data[b][a]=g/(d-1.5)*(c+1)}else{this.data.y.data[b][a]=g/d*Math.floor(Math.random()*c)}}}}}this.saveSnapshot();this.data=this.cloneVisualData(f)}}this.data=f;this.saveSnapshot();this.playSnapshot(this.animationTime,this.stopAnimation);break;case"Scatter3D":case"Area":case"AreaLine":case"Boxplot":case"Heatmap":case"Stacked":case"StackedLine":case"StackedPercent":case"StackedPercentLine":case"Candlestick":case"Correlation":case"Venn":case"Pie":case"Genome":case"Network":return;break}};this.stopAnimation=function(){this.stopSnapshotPlay();this.snapshots=[];this.isAnimation=false};this.setSnapshotsData=function(a){this.snapshots=a.ss||a;this.snapshotsBase=a.base};this.getSnapshotsData=function(){return{base:this.snapshotsBase,ss:this.snapshots}};this.createDemoNetworkAnimation=function(h){var q=[],e={},s=[];for(var v=0;v<h;v++){var o=v+1;q.push({size:0.5,x:Math.floor(Math.random()*h*5),y:Math.floor(Math.random()*h*5),outline:"rgb(255,255,255)",color:"rgb(255,0,0)",id:o,label:o,hideLabel:true,labelSize:0.7,name:"Node "+o,pattern:"closed",shape:"star"});e[o]=v}var d={nodes:q,nodeIndices:e,edges:[],edgeIndices:{}};s.push({type:"changedData"});var t=10;var b=5;var p=255/b;var a=0.5/b;var k=5;for(var u=0;u<t;u++){var n=Math.floor(Math.random()*q.length);for(var v=0;v<b;v++){var g=Math.floor(255-(v+1)*p);var m=Math.floor((v+1)*p),w=[g,m,m];var f={};f[q[n].id]={size:0.5+a*(v+1),color:"rgb("+w.join(",")+")"};s.push({type:"changedData",nodes:{deleted:{},added:{},changed:f},time:5})}}this.setSnapshotsData({base:d,ss:s})};this.createDemoNetworkAnimation1=function(){var b=[];var m={};var p=[];var o=10;var n=200;var a="ball";var f={width:o,x:100,y:0,color:"rgb(0,255,0)",id:a,label:a,hideLabel:true,labelSize:0.7,name:a,pattern:"closed",shape:"sphere"};a="plank";var g={width:200,height:5,x:100,y:n,color:"rgb(255,255,0)",id:a,label:a,hideLabel:true,labelSize:0.7,name:a,pattern:"closed",shape:"rectangle"};a="ref";var d={width:10,x:80,y:0,color:"rgb(0,0,255)",id:a,label:a,hideLabel:true,labelSize:0.7,name:a,pattern:"closed",shape:"sphere"};var c={nodes:[f,g,d],nodeIndices:{ball:0,plank:1,ref:2},edges:[],edgeIndices:{}};p.push({type:"changedData"});for(var k=1,h=0;h<n-o/2;h+=o/2,k+=0.1){var e=k*k;p.push({type:"changedData",nodes:{deleted:{},added:{},changed:{ball:{y:h,time:25*o>h?50-h*2/o:5}}},time:100/e})}this.setSnapshotsData({base:c,ss:p})}};CanvasXpress.prototype.initData=function(a){this.exampleRawData={x:{Tissue:["Kidney","Liver","Kidney","Liver","Kidney","Liver","Kidney","Liver"],Donor:["D1","D1","D1","D1","D2","D2","D2","D2"],Time:["1h","1h","2h","2h","1h","1h","2h","2h"]},z:{Symbol:["abc","def","ghi","jkl","mno","pqr"],Cat:["A","A","B","C","D","C"],Class:["A","A","A","A","A","B"]},y:{vars:["Gene1","Gene2","Gene3","Gene4","Gene5","Gene6"],smps:["Smp1","Smp2","Smp3","Smp4","Smp5","Smp6","Smp7","Smp8"],desc:["Intensity","Normalized Intensity"],data:[[10,12,3,4,100,73,42,64],[12,4,60,5,24,14,32,13],[7,12,20,13,49,52,42,92],[21,10,30,8,65,166,47,58],[15,14,100,5,34,30,82,51],[100,82,73,4,3,4,5,2]]},a:{xAxis:["Gene1","Gene2","Gene3"],xAxis2:["Gene4","Gene5","Gene6"]},t:{vars:"((Gene6:0.2,Gene3:0.3):0.2,((Gene1:0.25,(Gene4:0.15,Gene2:0.3):0.2):0.3,Gene5:0.7):0.1)",smps:"((Smp2:0.8,(Smp4:0.7,((Smp1:0.6,(Smp6:0.2,Smp5:0.1):0.2):0.15,(Smp8:0.15,Smp3:0.05):0.1):0.15):0.2):0.05,Smp7:0.9)"},d:{nlfit:[{param:[1,100,50,1,1.23e-7],label:"Fit Example",type:"reg"}]},l:{vars:[["Gene1","Gene2","Gene3","Gene4","Gene5"],["Gene6"]],weight:[0.7,0.3],type:["Bar","Line"],desc:["Intensity","Score"]},venn:{data:{A:340,B:562,C:620,D:592,AB:639,AC:456,AD:257,BC:915,BD:354,CD:143,ABC:552,ABD:578,ACD:298,BCD:613,ABCD:148},legend:{A:"List 1",B:"List 2",C:"List 3",D:"List 4"}},nodes:[{id:"Gene1",color:"rgb(255,0,0)",shape:"square",size:1},{id:"Gene2",color:"rgb(255,0,0)",shape:"square",size:1.8},{id:"Gene3",color:"rgb(255,0,0)",shape:"square",size:1.4},{id:"Gene4",color:"rgb(255,0,0)",shape:"square",size:1.2},{id:"Gene5",color:"rgb(255,0,0)",shape:"square",size:1.3},{id:"Gene6",color:"rgb(255,0,0)",shape:"square",size:1},{id:"Gene7",color:"rgb(255,0,0)",shape:"square",size:1},{id:"Gene8",color:"rgb(255,0,0)",shape:"square",size:1},{id:"SNP1",color:"rgb(0,255,0)",shape:"sphere",size:1},{id:"SNP2",color:"rgb(0,255,0)",shape:"sphere",size:1},{id:"SNP3",color:"rgb(0,255,0)",shape:"sphere",size:1},{id:"SNP4",color:"rgb(0,255,0)",shape:"sphere",size:1.5},{id:"SNP5",color:"rgb(0,255,0)",shape:"sphere",size:1},{id:"SNP6",color:"rgb(0,255,0)",shape:"sphere",size:1},{id:"SNP7",color:"rgb(0,255,0)",shape:"sphere",size:1},{id:"SNP8",color:"rgb(0,255,0)",shape:"sphere",size:1.2},{id:"PH1",color:"rgb(0,255,255,0.5)",shape:"triangle",size:1,hideChildren:false},{id:"PH2",color:"rgb(0,255,255,0.6)",shape:"triangle",size:1,parentNode:"PH1"},{id:"PH3",color:"rgb(0,255,255,0.7)",shape:"triangle",size:1,parentNode:"PH1"},{id:"PH4",color:"rgb(0,255,255,0.8)",shape:"triangle",size:1,parentNode:"PH3"}],edges:[{id1:"Gene1",id2:"Gene2",color:"rgb(51,102,255)",width:"1",type:"line"},{id1:"Gene2",id2:"Gene3",color:"rgb(51,102,255)",width:"1",type:"arrowHeadLine"},{id1:"Gene1",id2:"Gene4",color:"rgb(51,102,255)",width:"1",type:"arrowHeadLine"},{id1:"Gene3",id2:"Gene5",color:"rgb(51,102,255)",width:"1",type:"dashedArrowHeadLine"},{id1:"Gene6",id2:"Gene5",color:"rgb(51,102,255)",width:"1",type:"arrowHeadSquareTailLine"},{id1:"Gene7",id2:"Gene5",color:"rgb(153,153,255)",width:"1",type:"dottedArrowHeadLine"},{id1:"Gene8",id2:"Gene7",color:"rgb(51,102,255)",width:"1",type:"line"},{id1:"Gene4",id2:"Gene7",color:"rgb(51,102,255)",width:"1",type:"squareHeadArrowTailLine"},{id1:"Gene1",id2:"SNP2",color:"rgb(153,102,255)",width:"1",type:"bezierLine"},{id1:"SNP1",id2:"SNP4",color:"rgb(51,102,152)",width:"1",type:"line"},{id1:"SNP5",id2:"Gene5",color:"rgb(153,102,255)",width:"1",type:"arrowHeadLine"},{id1:"SNP1",id2:"PH2",color:"rgb(51,102,152)",width:"1",type:"line"},{id1:"SNP1",id2:"Gene2",color:"rgb(51,102,152)",width:"1",type:"line"},{id1:"PH4",id2:"SNP7",color:"rgb(153,102,255)",width:"1",type:"arrowHeadLine"},{id1:"PH2",id2:"Gene5",color:"rgb(51,102,152)",width:"1",type:"line"},{id1:"PH1",id2:"Gene7",color:"rgb(153,102,255)",width:"1",type:"arrowHeadLine"},{id1:"PH3",id2:"Gene2",color:"rgb(51,102,152)",width:"1",type:"line"},{id1:"SNP6",id2:"Gene2",color:"rgb(51,102,152)",width:"1",type:"line"},{id1:"SNP3",id2:"Gene4",color:"rgb(153,102,255)",width:"1",type:"arrowHeadLine"},{id1:"SNP4",id2:"Gene5",color:"rgb(51,102,152)",width:"1",type:"line"},{id1:"SNP5",id2:"Gene7",color:"rgb(153,102,255)",width:"1",type:"arrowHeadLine"},{id1:"SNP7",id2:"Gene5",color:"rgb(153,102,255)",width:"1",type:"arrowHeadLine"},{id1:"SNP8",id2:"Gene6",color:"rgb(153,102,255)",width:"1",type:"arrowHeadLine"},{id1:"SNP8",id2:"Gene2",color:"rgb(51,102,152)",width:"1",type:"line"}],legend:{nodes:[],edges:[]},tracks:[{name:"Affy Probes",type:"box",connect:true,fill:"rgb(255,255,51)",outline:"rgb(0,0,0)",data:[{id:"123456_at",dir:"right",data:[[10,20],[30,40],[50,60],[70,80],[90,100]]},{id:"234567_at",dir:"left",data:[[135,145],[155,165],[175,185],[195,205],[215,225]]},{id:"345678_at",dir:"right",data:[[300,310],[320,330],[340,350],[360,370],[380,390]]}]},{name:"Sanger Sequencing",subtype:"DNA",type:"sequence",data:[{id:"Reference Sequence",fill:"rgb(51,255,255)",outline:"rgb(0,0,0)",dir:"right",offset:1,sequence:"TACGTACGTACGTACGTACGTACGTACGT",translate:[-1,2]},{id:"R1-0000-1234",fill:"rgb(255,255,51)",outline:"rgb(0,0,0)",dir:"right",offset:1,gaps:[[4,2],[8,1]],sequence:"TACGCGTAGTACGT",trace:{A:[15,27,47,72,93,101,93,72,47,27,15,54,120,224,350,459,502,459,350,224,120,54,3,4,6,12,24,43,67,86,94,86,67,43,24,12,6,4,3,13,26,45,69,89,97,89,69,45,26,13,13,26,46,70,92,100,92,70,46,26,13,5,12,26,48,75,99,108,99,75,48,26,12,5,2,4,10,22,41,64,83,91,83,64,41,22,10,4,2,22,55,122,226,353,462,505,462,353,226,122,55,22,4,11,24,45,70,92,100,92,70,45,24,11,4,2,3,6,13,28,50,78,102,111,102,78,50,28,13,6,3,2,6,11,26,62,135,249,388,506,553,506,388,249,135,62,26,11,6,6,8,14,26,45,68,87,95,87,68,45,26,14,8,6,11,23,43,67,88,96,88,67,43,23,11,5,6,8,15,28,48,73,94,102,94,73,48,28,15,8,6,5],C:[10,16,26,39,50,54,50,39,26,16,10,7,14,26,40,51,56,51,40,26,14,7,4,8,20,50,109,203,317,414,453,414,317,203,109,50,20,8,4,9,16,26,39,51,55,51,39,26,16,9,56,123,229,357,467,511,467,357,229,123,56,2,6,12,22,35,45,49,45,35,22,12,6,2,1,3,6,13,25,39,50,55,50,39,25,13,6,3,1,5,8,15,26,39,50,55,50,39,26,15,8,5,2,5,11,21,32,42,46,42,32,21,11,5,2,2,2,3,6,12,22,33,43,47,43,33,22,12,6,3,2,2,5,5,6,9,16,25,37,47,51,47,37,25,16,9,6,5,5,10,24,56,121,223,347,453,495,453,347,223,121,56,24,10,6,13,24,37,48,52,48,37,24,13,6,5,5,6,9,15,25,36,46,50,46,36,25,15,9,6,5,5],G:[7,10,15,20,25,27,25,20,15,10,7,4,7,13,19,25,27,25,19,13,7,4,3,3,3,5,8,14,20,25,27,25,20,14,8,5,3,3,3,56,122,226,353,461,504,461,353,226,122,56,5,8,13,19,24,26,24,19,13,8,5,22,58,130,245,383,502,549,502,383,245,130,58,22,1,1,3,7,12,18,24,26,24,18,12,7,3,1,1,3,5,8,13,19,24,26,24,19,13,8,5,3,19,51,114,213,334,437,478,437,334,213,114,51,19,2,2,3,4,8,14,21,26,29,26,21,14,8,4,3,2,2,5,5,5,7,10,15,20,25,27,25,20,15,10,7,5,5,5,5,5,7,10,15,20,25,27,25,20,15,10,7,5,5,53,119,223,349,457,500,457,349,223,119,53,5,5,5,7,10,15,21,26,28,26,21,15,10,7,5,5,5],T:[62,135,249,388,507,554,507,388,249,135,62,2,4,6,8,10,11,10,8,6,4,2,3,3,3,4,5,7,9,12,12,12,9,7,5,4,3,3,3,5,6,8,11,13,14,13,11,8,6,5,4,5,7,10,12,13,12,10,7,5,4,1,2,3,5,8,10,11,10,8,5,3,2,1,7,22,58,130,244,383,501,548,501,383,244,130,58,22,7,3,4,5,7,10,12,13,12,10,7,5,4,3,1,2,3,5,8,10,11,10,8,5,3,2,1,3,8,21,54,119,222,347,454,497,454,347,222,119,54,21,8,3,5,5,5,6,7,9,12,14,15,14,12,9,7,6,5,5,5,5,5,6,7,9,12,14,15,14,12,9,7,6,5,5,2,3,5,7,9,10,9,7,5,3,2,6,11,25,61,131,242,377,492,538,492,377,242,131,61,25,11,6],peak:[5,16,30,44,55,67,81,95,108,123,140,156,169,183]}},{id:"R1-0000-2345",fill:"rgb(255,255,102)",outline:"rgb(0,0,0)",dir:"right",offset:6,gaps:[[3,1],[10,1]],sequence:"ACGACGTACGACG",trace:{A:[49,110,206,323,424,463,424,323,206,110,49,3,5,12,24,45,69,90,98,90,69,45,24,12,5,3,5,7,14,28,49,75,97,105,97,75,49,28,14,7,5,5,10,25,61,132,245,382,499,545,499,382,245,132,61,25,10,5,7,13,27,48,74,96,105,96,74,48,27,13,7,4,6,13,25,46,70,91,100,91,70,46,25,13,6,4,4,7,14,27,49,76,99,108,99,76,49,27,14,7,4,3,8,22,57,125,234,366,479,524,479,366,234,125,57,22,8,3,5,8,15,30,52,80,104,113,104,80,52,30,15,8,5,7,13,25,44,66,86,94,86,66,44,25,13,7,23,58,127,236,368,482,527,482,368,236,127,58,23,3,4,6,13,26,47,73,95,104,95,73,47,26,13,6,4,3,5,6,9,16,30,52,79,102,111,102,79,52,30,16,9,6,5],C:[5,12,21,33,43,47,43,33,21,12,5,7,21,53,117,218,341,447,488,447,341,218,117,53,21,7,4,5,9,15,26,38,49,53,49,38,26,15,9,5,4,4,4,6,9,16,27,40,51,56,51,40,27,16,9,6,4,4,20,50,109,203,317,415,453,415,317,203,109,50,20,3,4,8,14,25,37,48,52,48,37,25,14,8,4,3,3,4,8,14,24,36,46,50,46,36,24,14,8,4,3,2,2,3,6,13,22,34,44,48,44,34,22,13,6,3,2,2,9,23,55,118,219,342,447,489,447,342,219,118,55,23,9,5,9,16,26,39,50,54,50,39,26,16,9,5,4,8,14,25,37,48,52,48,37,25,14,8,4,4,9,22,55,120,224,349,457,500,457,349,224,120,55,22,9,4,5,5,7,10,17,27,40,51,56,51,40,27,17,10,7,5,5],G:[3,6,11,17,22,24,22,17,11,6,3,2,2,4,7,12,17,22,24,22,17,12,7,4,2,2,10,24,59,129,239,373,487,533,487,373,239,129,59,24,10,4,4,4,6,9,14,20,25,27,25,20,14,9,6,4,4,4,3,5,8,13,19,24,26,24,19,13,8,5,3,9,23,59,129,239,374,489,534,489,374,239,129,59,23,9,3,3,5,8,13,18,23,25,23,18,13,8,5,3,3,2,2,2,4,7,12,17,22,24,22,17,12,7,4,2,2,2,4,4,6,9,14,19,24,26,24,19,14,9,6,4,4,22,52,113,209,325,425,465,425,325,209,113,52,22,3,5,8,13,19,24,26,24,19,13,8,5,3,3,3,3,5,8,14,20,26,28,26,20,14,8,5,3,3,3,6,11,26,62,133,246,383,501,547,501,383,246,133,62,26,11,6],T:[2,3,5,7,10,10,10,7,5,3,2,2,2,2,4,6,8,10,11,10,8,6,4,2,2,2,4,4,4,6,8,10,12,13,12,10,8,6,4,4,4,4,4,4,5,6,8,11,13,14,13,11,8,6,5,4,4,4,3,4,5,7,10,12,13,12,10,7,5,4,3,3,3,3,5,7,9,11,12,11,9,7,5,3,3,3,8,21,52,115,213,333,436,476,436,333,213,115,52,21,8,2,2,2,3,4,6,8,10,11,10,8,6,4,3,2,2,2,4,4,4,6,8,10,12,13,12,10,8,6,4,4,4,4,4,6,8,10,12,13,12,10,8,6,4,4,3,4,5,7,9,11,12,11,9,7,5,4,3,3,3,3,4,5,7,10,12,13,12,10,7,5,4,3,3,3,5,5,5,6,7,9,11,14,14,14,11,9,7,6,5,5,5],peak:[5,18,33,49,64,78,93,109,125,139,152,167,184]}},{id:"R1-0000-3456",fill:"rgb(255,51,255)",outline:"rgb(0,0,0)",dir:"left",offsetLeft:"23",gaps:[[7,2]],sequence:"GTACGTATAC",trace:{A:[4,10,22,41,64,84,92,84,64,41,22,10,4,5,8,15,29,51,79,102,111,102,79,51,29,15,8,5,11,24,58,124,228,356,465,508,465,356,228,124,58,24,11,13,25,45,69,89,97,89,69,45,25,13,1,2,4,11,24,44,69,90,99,90,69,44,24,11,4,2,1,3,6,13,26,48,75,98,107,98,75,48,26,13,6,3,11,24,58,124,228,355,464,507,464,355,228,124,58,24,11,4,7,13,27,49,75,98,107,98,75,49,27,13,7,4,7,19,50,110,206,322,421,460,421,322,206,110,50,19,7,5,8,15,28,50,76,99,108,99,76,50,28,15,8,5],C:[2,6,13,23,36,47,51,47,36,23,13,6,2,4,5,8,14,24,35,45,49,45,35,24,14,8,5,4,5,7,10,17,28,41,53,57,53,41,28,17,10,7,5,59,130,242,377,494,540,494,377,242,130,59,1,1,2,6,12,22,34,44,48,44,34,22,12,6,2,1,1,2,3,6,13,22,34,44,48,44,34,22,13,6,3,2,5,6,9,15,25,36,46,50,46,36,25,15,9,6,5,3,5,8,15,26,39,51,55,51,39,26,15,8,5,3,2,3,7,13,23,35,46,50,46,35,23,13,7,3,2,10,24,57,125,231,360,470,514,470,360,231,125,57,24,10],G:[21,54,122,228,357,467,511,467,357,228,122,54,21,4,4,6,9,14,21,26,28,26,21,14,9,6,4,4,5,6,7,11,16,23,29,31,29,23,16,11,7,6,5,5,8,13,19,24,26,24,19,13,8,5,2,7,21,56,126,236,370,485,531,485,370,236,126,56,21,7,2,2,2,4,7,13,19,24,26,24,19,13,7,4,2,2,5,6,7,11,17,24,30,32,30,24,17,11,7,6,5,3,3,5,8,13,19,24,26,24,19,13,8,5,3,3,2,3,4,8,14,21,26,29,26,21,14,8,4,3,2,4,4,6,10,15,21,27,29,27,21,15,10,6,4,4],T:[1,1,3,5,7,9,10,9,7,5,3,1,1,10,23,57,124,230,358,468,512,468,358,230,124,57,23,10,5,5,6,7,9,12,14,15,14,12,9,7,6,5,5,4,5,7,10,12,13,12,10,7,5,4,1,1,1,2,3,5,8,10,11,10,8,5,3,2,1,1,1,8,23,59,130,243,380,498,545,498,380,243,130,59,23,8,5,5,5,7,9,11,13,14,13,11,9,7,5,5,5,8,20,50,110,205,320,418,457,418,320,205,110,50,20,8,2,2,3,4,6,8,10,11,10,8,6,4,3,2,2,4,4,5,6,8,11,13,14,13,11,8,6,5,4,4],peak:[6,20,35,48,62,78,93,108,123,138]}},{id:"R1-0000-4567",fill:"rgb(255,102,255)",outline:"rgb(0,0,0)",dir:"right",offset:15,gaps:[[5,1]],sequence:"CGTACTACGTA",trace:{A:[9,16,29,51,78,100,110,100,78,51,29,16,9,15,28,50,77,100,109,100,77,50,28,15,4,5,7,13,25,44,67,86,94,86,67,44,25,13,7,5,4,4,8,21,53,115,214,335,438,479,438,335,214,115,53,21,8,4,2,3,5,11,23,42,65,85,93,85,65,42,23,11,5,3,2,8,15,29,52,80,103,113,103,80,52,29,15,8,4,9,23,57,126,233,365,477,522,477,365,233,126,57,23,9,4,2,4,10,23,42,66,87,95,87,66,42,23,10,4,2,3,5,12,25,46,71,93,101,93,71,46,25,12,5,3,4,5,8,14,28,50,76,99,108,99,76,50,28,14,8,5,4,19,49,108,202,316,413,452,413,316,202,108,49,19],C:[24,56,121,223,348,454,496,454,348,223,121,56,24,8,14,24,36,46,50,46,36,24,14,8,4,4,5,8,15,24,36,46,50,46,36,24,15,8,5,4,4,3,3,4,8,14,25,38,48,53,48,38,25,14,8,4,3,3,3,8,21,54,119,222,348,455,498,455,348,222,119,54,21,8,3,5,9,15,25,38,48,52,48,38,25,15,9,5,3,3,5,8,15,26,39,51,55,51,39,26,15,8,5,3,3,6,18,48,107,201,315,412,451,412,315,201,107,48,18,6,2,3,6,12,22,33,43,47,43,33,22,12,6,3,2,4,4,6,9,16,28,42,54,58,54,42,28,16,9,6,4,4,3,7,13,24,37,47,52,47,37,24,13,7,3],G:[6,7,11,16,23,29,31,29,23,16,11,7,6,56,121,223,348,455,498,455,348,223,121,56,4,4,5,6,10,16,23,28,31,28,23,16,10,6,5,4,4,3,3,4,5,9,14,21,26,29,26,21,14,9,5,4,3,3,2,2,2,4,7,12,18,24,26,24,18,12,7,4,2,2,2,4,6,9,14,19,24,26,24,19,14,9,6,4,3,3,3,5,8,13,19,24,26,24,19,13,8,5,3,3,3,1,2,3,7,12,19,24,27,24,19,12,7,3,2,1,7,20,51,113,211,330,432,473,432,330,211,113,51,20,7,4,4,4,6,9,15,21,26,29,26,21,15,9,6,4,4,4,3,4,8,13,20,26,28,26,20,13,8,4,3],T:[5,6,7,9,11,13,14,13,11,9,7,6,5,4,6,8,10,12,13,12,10,8,6,4,5,10,24,60,130,241,376,492,538,492,376,241,130,60,24,10,5,3,3,3,3,5,7,9,11,12,11,9,7,5,3,3,3,3,2,2,2,2,4,6,8,10,11,10,8,6,4,2,2,2,2,22,53,114,211,328,429,469,429,328,211,114,53,22,3,3,3,3,5,7,9,11,12,11,9,7,5,3,3,3,3,1,1,2,3,5,7,9,10,9,7,5,3,2,1,1,2,2,2,4,6,8,10,11,10,8,6,4,2,2,2,5,10,24,58,127,235,366,479,524,479,366,235,127,58,24,10,5,2,3,4,6,8,10,11,10,8,6,4,3,2],peak:[6,18,32,49,66,81,96,112,127,143,158]}},{id:"R1-0000-5678",fill:"rgb(51,255,255)",outline:"rgb(0,0,0)",dir:"right",offset:18,gaps:[[7,1]],sequence:"ACGTACGACGT",trace:{A:[10,25,60,131,244,380,497,544,497,380,244,131,60,25,10,5,6,8,15,28,48,73,95,103,95,73,48,28,15,8,6,5,4,6,13,26,47,72,94,102,94,72,47,26,13,6,4,6,8,15,28,49,74,95,104,95,74,49,28,15,8,6,2,7,22,58,129,243,380,498,545,498,380,243,129,58,22,7,2,11,23,43,66,86,94,86,66,43,23,11,5,8,15,28,50,77,100,109,100,77,50,28,15,8,5,6,11,24,58,125,232,361,471,515,471,361,232,125,58,24,11,6,12,24,43,66,85,93,85,66,43,24,12,14,28,50,76,99,108,99,76,50,28,14,5,7,14,27,47,72,93,101,93,72,47,27,14,7,5],C:[4,5,8,15,24,36,46,50,46,36,24,15,8,5,4,6,11,26,62,135,249,388,506,554,506,388,249,135,62,26,11,6,3,5,8,15,25,38,49,54,49,38,25,15,8,5,3,5,6,9,15,25,36,46,50,46,36,25,15,9,6,5,1,1,3,6,13,24,37,49,53,49,37,24,13,6,3,1,1,53,117,219,342,447,489,447,342,219,117,53,4,5,8,15,25,36,47,51,47,36,25,15,8,5,4,5,5,7,10,17,28,41,53,57,53,41,28,17,10,7,5,5,57,124,231,360,471,516,471,360,231,124,57,9,16,27,40,51,55,51,40,27,16,9,4,6,9,16,27,41,52,57,52,41,27,16,9,6,4],G:[4,5,6,10,16,22,28,31,28,22,16,10,6,5,4,5,5,5,7,10,15,21,26,28,26,21,15,10,7,5,5,5,8,21,53,116,216,337,440,482,440,337,216,116,53,21,8,5,6,7,11,17,23,29,32,29,23,17,11,7,6,5,1,1,1,3,6,11,17,22,24,22,17,11,6,3,1,1,1,4,8,13,20,25,27,25,20,13,8,4,9,21,52,111,206,321,420,459,420,321,206,111,52,21,9,5,5,5,7,10,16,22,27,30,27,22,16,10,7,5,5,5,5,8,14,20,25,27,25,20,14,8,5,57,124,230,358,468,512,468,358,230,124,57,4,4,6,9,14,20,25,28,25,20,14,9,6,4,4],T:[4,4,5,6,8,11,14,14,14,11,8,6,5,4,4,5,5,5,6,7,9,12,14,15,14,12,9,7,6,5,5,5,3,3,4,5,7,10,12,13,12,10,7,5,4,3,3,11,24,57,122,224,349,456,498,456,349,224,122,57,24,11,1,1,1,2,3,5,8,10,11,10,8,5,3,2,1,1,1,3,4,6,8,11,11,11,8,6,4,3,4,4,5,6,8,11,13,14,13,11,8,6,5,4,4,5,5,5,6,7,9,12,14,15,14,12,9,7,6,5,5,5,4,5,7,10,12,13,12,10,7,5,4,4,6,8,10,12,13,12,10,8,6,4,10,25,60,131,242,378,494,540,494,378,242,131,60,25,10],peak:[7,23,39,54,70,84,97,113,127,138,151]}}]},{name:"Tissue Distribution",type:"bar",height:20,fill:["rgb(255,0,0)","rgb(0,0,255)","rgb(255,255,0)"],outline:["rgb(255,0,0)","rgb(0,0,255)","rgb(255,255,0)"],data:[{id:"123456_at",offset:10,data:[25,35,46]},{id:"234567_at",offset:135,data:[80,45,10]},{id:"345678_at",offset:300,data:[65,46,29]}]}],market:[{symbol:"BMY",data:[[20100824,26.26,26.37,25.95,26.02,11625900,26.02],[20100823,26.48,26.76,26.38,26.48,12146600,26.48],[20100820,26.31,26.54,26.08,26.44,18140100,26.44],[20100819,26.2,26.29,25.81,26.06,8218000,26.06],[20100818,26.53,26.57,26.23,26.28,12235800,26.28],[20100817,26.4,26.79,26.26,26.59,12325700,26.59],[20100816,26.24,26.34,26.04,26.28,10377700,26.28],[20100813,26.24,26.46,26.1,26.32,5760100,26.32],[20100812,26.01,26.39,26,26.33,7350500,26.33],[20100811,26.32,26.5,26.15,26.25,8808100,26.25],[20100810,26.32,26.78,26.3,26.66,7009500,26.66],[20100809,26.37,26.54,26.3,26.51,6825300,26.51],[20100806,26.29,26.45,26.05,26.37,8774900,26.37],[20100805,25.83,26.38,25.8,26.38,12264600,26.38],[20100804,25.7,26.13,25.61,26.03,10233700,26.03],[20100803,25.65,25.85,25.58,25.68,6842900,25.68],[20100802,25.33,25.61,25.29,25.53,9770900,25.53],[20100730,24.98,25.13,24.78,24.92,11435700,24.92],[20100729,25.37,25.5,24.85,25.08,9463800,25.08],[20100728,25.25,25.36,25.02,25.12,8072400,25.12],[20100727,25.09,25.35,24.84,25.32,14152600,25.32],[20100726,24.57,25.03,24.57,24.97,8817400,24.97],[20100723,24.94,24.95,24.26,24.65,13043700,24.65],[20100722,24.96,25.22,24.75,24.93,10385300,24.93],[20100721,24.92,25.11,24.59,24.75,9830000,24.75],[20100720,24.65,25.09,24.46,25.02,10655500,25.02],[20100719,25.27,25.27,24.78,24.84,11804800,24.84],[20100716,25.44,25.47,25.1,25.17,13136300,25.17]]}]};this.exampleBasicData={x:{Tissue:["Kidney","Liver","Breast","Brain"],Donor:["D1","D2","D2","D1"]},z:{Symbol:["abc","def","ghi","jkl","mno","pqr"],Desc:["blah","yeah","maybe","good","bad","awsome"]},y:{vars:["Gene1","Gene2","Gene3","Gene4","Gene5","Gene6"],smps:["Smp1","Smp2","Smp3","Smp4"],desc:["Intensity"],mean:[[1,2,3,4],[2,1,3,6],[3,2,1,5],[4,2,1,3],[4,3,2,1],[9,2,7,4]],stdev:[[1,3,2,1],[2,3,2,1],[2,2,2,1],[2,3,1,1],[1,1,1,1],[3,1,3,1]],n:[[4,5,5,5],[4,5,5,5],[6,4,4,5],[6,4,5,6],[5,5,5,5],[6,5,5,5]]},a:{xAxis:["Gene1","Gene2","Gene3"],xAxis2:["Gene4","Gene5","Gene6"]}};this.isValidPlotData=function(b){var c=this.isGroupedData?this.data.w:this.data.y;if(b=="cor"&&c.cor){return true}else{if(b=="venn"&&this.data.venn){return true}else{if(b=="network"&&this.data.nodes){return true}else{if(b=="genome"&&this.data.tracks){return true}else{if(b=="sum"&&c.sum&&c.sum[0].length>0){return true}else{if(b=="mean"&&c.mean&&c.mean[0].length>0){return true}else{if(b=="median"&&c.median&&c.median[0].length>0){return true}else{if(b=="iqr"&&c.iqr1&&c.qtl1&&c.median&&c.qtl3&&c.iqr3&&c.median[0].length>0){return true}else{if(b=="candle"&&c.close&&c.open&&c.high&&c.low&&c.close[0].length>0){return true}else{if(b=="volume"&&c.volume&&c.volume[0].length>0){return true}else{if(b=="raw"&&this.isRawData){return true}else{return false}}}}}}}}}}}};this.setAllNodesVisible=function(){this.nodes={};this.data.nodeIndices={};for(var b=0;b<this.data.nodes.length;b++){var c=this.data.nodes[b];c.hide=false;this.nodes[c.id]=c;this.data.nodeIndices[c.id]=b}};this.setNodeIndices=function(){this.nodes={};this.data.nodeIndices={};for(var b=0;b<this.data.nodes.length;b++){var c=this.data.nodes[b];this.nodes[c.id]=c;this.data.nodeIndices[c.id]=b}};this.setNodes=function(){if(this.data.nodeIndices){this.nodes={};for(var b=0;b<this.data.nodes.length;b++){var c=this.data.nodes[b];this.nodes[c.id]=c}this.data.nodes=[];for(var d in this.data.nodeIndices){this.data.nodes[this.data.nodeIndices[d]]=this.nodes[d]}}else{this.setNodeIndices()}};this.hideUnhideNodes=function(d,c){c=c?true:false;if(d){if(this.isArray(d)){for(var b=0;b<d.length;b++){var f=d[b];var e=this.data.nodes[this.data.nodeIndices[f]];e.hide=c;if(this.nodes&&this.nodes[f]){this.nodes[f].hide=c}}}}else{for(var b=0;b<this.data.nodes.length;b++){var e=this.data.nodes[b];e.hide=c;e.hideChildren=c;if(this.nodes&&this.nodes[e.id]){this.nodes[e.id].hide=c;this.nodes[e.id].hideChildren=c}}}};this.hideUnhideChildrenNodes=function(e,c){c=c?true:false;if(this.nodeParentHood[e]&&this.nodeParentHood[e].children){for(var b=0;b<this.nodeParentHood[e].children.length;b++){var d=this.nodeParentHood[e].children[b];this.data.nodes[this.data.nodeIndices[d]].hiddenParent=c;this.hideUnhideChildrenNodes(d,c)}}};this.setSelectNodes=function(c){this.selectNode={};this.isSelectNodes=0;for(var b=0;b<c.length;b++){this.selectNode[c[b]]=true;this.isSelectNodes++}};this.getAnnotations=function(c){var b=[];if(c){if(this.data.z){for(var d in this.data.z){b.push(d)}}}else{if(this.data.x){for(var d in this.data.x){b.push(d)}}}return b};this.getNetworkImages=function(){var b=[];if(this.graphType=="Network"){for(var c=0;c<this.data.nodes.length;c++){var d=this.data.nodes[c];if(d.imagePath){if(!d.imagePath.match(/^http:\/\//)){d.imagePath=this.imageDir+d.imagePath}b.push(d.imagePath)}}}return b};this.setAllVariablesVisible=function(){if(this.data.y){if(!this.data.y.vars&&this.data.y.data){this.data.y.vars=[];for(var b=0;b<this.data.y.data.length;b++){this.data.y.vars.push("var"+(b+1))}}this.varIndices=[];this.hiddenVars=[];this.xAxisVarIndices=[];this.xAxis2VarIndices=[];for(var b=0;b<this.data.y.vars.length;b++){this.varIndices.push(b);this.hiddenVars.push(false)}}if(this.data.a){if(this.data.a.xAxis){this.xAxisVarIndices=this.getVariableIndices(this.data.a.xAxis)}if(this.data.a.xAxis2){this.xAxis2VarIndices=this.getVariableIndices(this.data.a.xAxis2)}}};this.resetVariablesVisibleByAxis=function(b){if(this.data.a){this.setVariablesVisibleByAxis(b,this.getVariableIndices(this.data.a[b]))}};this.setVariablesVisibleByAxis=function(e,b){var c=e+"VarIndices";this[c]=[];for(var d=0;d<b.length;d++){this[c].push(b[d])}};this.getVariablesVisibleByAxis=function(b){return this[b+"VarIndices"]};this.getVariablesByAxis=function(b){if(this.data.a&&this.data.a[b]){return this.data.a[b]}return[]};this.setVariablesVisible=function(b){this.varIndices=[];for(var c=0;c<b.length;c++){this.varIndices.push(b[c])}};this.getVariableIndices=function(b){if(b&&this.data.y.vars){var e=[];if(this.isArray(b)){if(b.length>0){for(var d=0;d<b.length;d++){for(var c=0;c<this.data.y.vars.length;c++){if(this.data.y.vars[c]==b[d]){e.push(c);break}}}return e}}else{for(var d=0;d<this.data.y.vars.length;d++){if(this.data.y.vars[d]==b){return d}}return -1}}};this.hideUnhideVars=function(g){if(g){if(this.isArray(g)){for(var d=0;d<g.length;d++){for(var c=0;c<this.data.y.vars.length;c++){if(this.data.y.vars[c]==g[d]){if(this.hiddenVars[c]){this.hiddenVars[c]=false}else{this.hiddenVars[c]=true}break}}}}else{for(var d=0;d<this.data.y.vars.length;d++){if(this.data.y.vars[d]==g){if(this.hiddenVars[d]){this.hiddenVars[d]=false}else{this.hiddenVars[d]=true}break}}}var b=[];for(var d=0;d<this.data.y.vars.length;d++){if(!this.hiddenVars[d]){b.push(d)}}this.setVariablesVisible(b);var f=["xAxis","xAxis2"];if(this.data.a){for(var d=0;d<f.length;d++){var h=this.getVariableIndices(this.data.a[f[d]]);if(h.length>0){var b=[];for(var c=0;c<h.length;c++){var e=h[c];if(!this.hiddenVars[e]){b.push(e)}}this.setVariablesVisibleByAxis(f[d],b)}}}this.draw()}};this.getVariables=function(){var e=[];for(var d=0;d<this.data.y.vars.length;d++){var b=-1;for(var c=0;c<this.varIndices.length;c++){if(this.varIndices[c]==d){b=c;break}}e.push({name:this.data.y.vars[d],hidden:this.hiddenVars[d],index:b})}return e};this.setAllSamplesVisible=function(){if(this.data.y&&this.data.y.smps){if(!this.data.y.smps&&this.data.y.data&&this.data.y.vars){this.data.y.smps=[];for(var b=0;b<this.data.y.data.vars[0].length;b++){this.data.y.smps.push("smp"+(b+1))}}this.smpIndices=[];this.hiddenSmps=[];for(var b=0;b<this.data.y.smps.length;b++){this.smpIndices.push(b);this.hiddenSmps.push(false)}}if(this.data.w&&this.data.w.smps){this.grpIndices=[];this.hiddenGrps=[];for(var b=0;b<this.data.w.smps.length;b++){this.grpIndices.push(b);this.hiddenGrps.push(false)}}};this.getSamplesByAxis=function(b){if(this[b]){return this[b]}return[]};this.setSamplesVisible=function(b,c){if(this.isGroupedData){this.grpIndices=[];for(var e=0;e<b.length;e++){this.grpIndices.push(b[e])}}else{this.smpIndices=[];for(var e=0;e<b.length;e++){this.smpIndices.push(b[e])}}if(c){var d=this.getObjectArray(b);var g=this.isGroupedData?this.data.w:this.data.y;var f=this.isGroupedData?this.hiddenGrps:this.hiddenSmps;for(var e=0;e<g.smps.length;e++){if(d.hasOwnProperty(e)){f[e]=false}else{f[e]=true}}}};this.getSampleIndices=function(b){var f=this.isGroupedData?this.data.w:this.data.y;if(b&&f.smps){var e=[];if(this.isArray(b)){if(b.length>0){for(var d=0;d<b.length;d++){for(var c=0;c<f.smps.length;c++){if(f.smps[c]==b[d]){e.push(c);break}}}return e}}else{for(var d=0;d<f.smps.length;d++){if(f.smps[d]==b){return d}}return -1}}};this.hideUnhideSmps=function(g){if(g){var h=this.isGroupedData?this.data.w:this.data.y;var e=this.isGroupedData?this.hiddenGrps:this.hiddenSmps;var f=[];if(this.isArray(g)){for(var d=0;d<g.length;d++){for(var c=0;c<h.smps.length;c++){if(h.smps[c]==g[d]){if(e[c]){e[c]=false}else{e[c]=true}break}}}}else{for(var d=0;d<h.smps.length;d++){if(h.smps[d]==g){if(e[d]){e[d]=false}else{e[d]=true}break}}}var b=[];for(var d=0;d<h.smps.length;d++){if(!e[d]){b.push(d)}}this.setSamplesVisible(b);this.draw()}};this.getSamples=function(){var d=[];var h=this.isGroupedData?this.data.w.smps:this.data.y.smps;var k=this.isGroupedData?this.data.w:this.data.y;var f=this.isGroupedData?this.hiddenGrps:this.hiddenSmps;var g=this.isGroupedData?this.grpIndices:this.smpIndices;for(var e=0;e<h.length;e++){var b=-1;for(var c=0;c<g.length;c++){if(g[c]==e){b=c;break}}d.push({name:h[e],hidden:f[e],index:b})}return d};this.setIndices=function(){if(this.graphType=="Network"){this.setNodes()}else{if(this.graphType!="Genome"&&this.graphType!="Venn"){this.setAllVariablesVisible();this.setAllSamplesVisible()}}};this.resetIndices=function(){if(this.isGroupedData){this.setIndices()}};this.setMaxSmpStringAttr=function(c,b){this.setMaxSmpStringAnnt(c,b);this.setMaxSmpStringLabel(c,b);this.setMaxSmpStringDesc(b);this.setMaxSmpStringName(b)};this.setMaxSmpStringAnnt=function(e,d){if(!d){d=this.smpLabelFont}var c=0;this.maxSmpAnnt=0;this.maxSmpAnntStr="";if(this.data.x){if(e&&this.data.x[e]){return e}else{for(var f in this.data.x){var b=this.measureText(f,d);if(b>c){c=b;this.maxSmpAnnt=f.length;this.maxSmpAnntStr=f}}}}};this.setMaxSmpStringLabel=function(f,d){if(!d){d=this.smpLabelFont}var c=0;this.maxSmpLabel=0;this.maxSmpLabelStr="";if(this.data.x){if(f&&this.data.x[f]){var h="";for(var e=0;e<this.smpIndices.length;e++){var b=this.measureText(this.data.x[f][this.smpIndices[e]],d);if(b>c){c=b;h=this.data.x[f][this.smpIndices[e]]}}return h}else{for(var g in this.data.x){for(var e=0;e<this.smpIndices.length;e++){if(this.data.x[g][this.smpIndices[e]]){var b=this.measureText(this.data.x[g][this.smpIndices[e]],d);if(b>c){c=b;this.maxSmpLabel=this.data.x[g][this.smpIndices[e]].length;this.maxSmpLabelStr=this.data.x[g][this.smpIndices[e]]}}}}}}};this.setMaxSmpStringDesc=function(d){if(!d){d=this.smpLabelFont}var c=0;this.maxSmpLabelDesc=0;this.maxSmpLabelDescStr="";if(this.data.x&&this.smpLabelDescription&&this.data.x[this.smpLabelDescription]){for(var e=0;e<this.smpIndices.length;e++){if(this.data.x[this.smpLabelDescription][this.smpIndices[e]]){var b=this.measureText(this.data.x[this.smpLabelDescription][this.smpIndices[e]],d);if(b>c){c=b;this.maxSmpLabelDesc=this.data.x[this.smpLabelDescription][this.smpIndices[e]].length;this.maxSmpLabelDescStr=this.data.x[this.smpLabelDescription][this.smpIndices[e]]}}}}};this.setMaxSmpStringName=function(d){if(!d){d=this.smpLabelFont}if(this.data.y||this.data.w){var f=this.isGroupedData?this.data.w:this.data.y;var c=0;this.maxSmpName=0;this.maxSmpNameStr="";if(this.isGroupedData){for(var e=0;e<f.smps.length;e++){var b=this.measureText(f.smps[e],d);if(b>c){c=b;this.maxSmpName=f.smps[e].length;this.maxSmpNameStr=f.smps[e]}}}else{for(var e=0;e<this.smpIndices.length;e++){var b=this.measureText(f.smps[this.smpIndices[e]],d);if(b>c){c=b;this.maxSmpName=f.smps[this.smpIndices[e]].length;this.maxSmpNameStr=f.smps[this.smpIndices[e]]}}}}};this.setMaxVarStringAttr=function(c,b){this.setMaxVarStringAnnt(c,b);this.setMaxVarStringLabel(c,b);this.setMaxVarStringDesc(b);this.setMaxVarStringName(b)};this.setMaxVarStringAnnt=function(e,d){if(!d){d=this.varLabelFont}var c=0;this.maxVarAnnt=0;this.maxVarAnntStr="";if(this.data.z){if(e&&this.data.z[e]){return e}else{for(var f in this.data.z){var b=this.measureText(f,d);if(b>c){c=b;this.maxVarAnnt=f.length;this.maxVarAnntStr=f}}}}};this.setMaxVarStringLabel=function(f,d){if(!d){d=this.varLabelFont}var c=0;this.maxVarLabel=0;this.maxVarLabelStr="";if(this.data.z){if(f&&this.data.z[f]){var h="";for(var e=0;e<this.varIndices.length;e++){var b=this.measureText(this.data.z[f][this.varIndices[e]],d);if(b>c){c=b;h=this.data.z[f][this.varIndices[e]]}}return h}else{for(var g in this.data.z){for(var e=0;e<this.varIndices.length;e++){if(this.data.z[g][this.varIndices[e]]){var b=this.measureText(this.data.z[g][this.varIndices[e]],d);if(b>c){c=b;this.maxVarLabel=this.data.z[g][this.varIndices[e]].length;this.maxVarLabelStr=this.data.z[g][this.varIndices[e]]}}}}}}};this.setMaxVarStringDesc=function(d){if(!d){d=this.varLabelFont}var c=0;this.maxVarLabelDesc=0;this.maxVarLabelDescStr="";if(this.data.z&&this.varLabelDescription&&this.data.z[this.varLabelDescription]){for(var e=0;e<this.varIndices.length;e++){if(this.data.z[this.varLabelDescription][this.varIndices[e]]){var b=this.measureText(this.data.z[this.varLabelDescription][this.varIndices[e]],d);if(b>c){c=b;this.maxVarLabelDesc=this.data.z[this.varLabelDescription][this.varIndices[e]].length;this.maxVarLabelDescStr=this.data.z[this.varLabelDescription][this.varIndices[e]]}}}}};this.setMaxVarStringName=function(d){if(!d){d=this.varLabelFont}if(this.data.y||this.data.w){var f=this.graphType.match(/BarLine|StackedLine|StackedPercentLine/)?this.data.y:this.isGroupedData?this.data.w:this.data.y;var c=0;this.maxVarName=0;this.maxVarNameStr="";if(f.vars){for(var e=0;e<this.varIndices.length;e++){var b=this.measureText(f.vars[this.varIndices[e]],d);if(b>c){c=b;this.maxVarName=f.vars[this.varIndices[e]].length;this.maxVarNameStr=f.vars[this.varIndices[e]]}}}}};this.setRangeData=function(d,e,b,u){var c=this.isGroupedData&&!e?this.data.w:this.data.y;var n=Number.MAX_VALUE;var r=Number.MAX_VALUE*-1;if(this.setMin!=null&&this.setMax!=null){this.minData=this.setMin;this.maxData=this.setMax;return}if(this.isGroupedData&&!d){d=this.summaryType}if(d=="genome"){for(var s=0;s<this.data.tracks.length;s++){for(var p=0;p<this.data.tracks[s].data.length;p++){if(this.data.tracks[s].type=="box"){for(var o=0;o<this.data.tracks[s].data[p].data.length;o++){m=this.data.tracks[s].data[p].data[o];r=Math.max(r,Math.max(m[0],m[1]));n=Math.min(n,Math.min(m[0],m[1]))}}else{if(this.data.tracks[s].type=="sequence"){m=this.data.tracks[s].data[p].offset;r=Math.max(r,m+this.data.tracks[s].data[p].sequence.length);n=Math.min(n,m)}else{if(this.data.tracks[s].type.match(/bar|heatmap|line|stacked/)){m=this.data.tracks[s].data[p].offset;r=this.data.tracks[s].autowidth?Math.max(r,m+this.data.tracks[s].data[p].data.length):Math.max(r,m);n=Math.min(n,m)}else{m=this.data.tracks[s].data[p].offset;r=Math.max(r,m);n=Math.min(n,m)}}}}}}else{if(d=="percentile"&&!e){n=0;r=100}else{if((d=="mean"||d=="median"||d=="sum")&&!e){if(u){var f=this.isGroupedData?this.grpIndices:this.smpIndices;var y=this.isTransformedData?c.trans:c[this.summaryType];for(var s=0;s<f.length;s++){var l=f[s];var h=0;for(var p=0;p<this.varIndices.length;p++){var t=this.varIndices[p];var A=y[t][l];if(!isNaN(A)&&A>0){h+=A}}r=Math.max(h,r)}n=0}else{for(var s=0;s<this.varIndices.length;s++){var l=this.varIndices[s];var m;if(this.isTransformedData){m=c.trans[l]}else{if(this.summaryType=="mean"){m=c.mean[l]}else{if(this.summaryType=="median"){m=c.median[l]}else{if(this.summaryType=="sum"){m=c.sum[l]}}}}for(var p=0;p<m.length;p++){var x;var A=m[p];if(c.stdev&&!this.isTransformedData){x=c.stdev[l][p]}else{x=Number.NaN}if(!isNaN(A)){if(!isNaN(x)){if(b){if(A>0){n=Math.min(A,n);r=Math.max(A+x,r)}}else{n=Math.min(A,n);r=Math.max(A+x,r)}}else{if(b){if(A>0){n=Math.min(A,n);r=Math.max(A,r)}}else{n=Math.min(A,n);r=Math.max(A,r)}}}}}}}else{if(d=="iqr"&&!e){if(this.isTransformedData){alert("Transformation not allowed");this.isTransformedData=false}for(var s=0;s<this.varIndices.length;s++){var l=this.varIndices[s];for(var p=0;p<c.iqr1[l].length;p++){var w=c.iqr1[l][p];var v=c.iqr3[l][p];var q=c.out[l][p];if(!isNaN(w)&&!isNaN(v)){if(b){if(w>0&&v>0){n=Math.min(w,n);r=Math.max(v,r)}}else{n=Math.min(w,n);r=Math.max(v,r)}}if(q){for(var o=0;o<q.length;o++){if(!isNaN(q[o])){if(b){if(q[o]>0){n=Math.min(q[o],n);r=Math.max(q[o],r)}}else{n=Math.min(q[o],n);r=Math.max(q[o],r)}}}}}}}else{if(d=="candle"){if(this.isTransformedData){alert("Transformation not allowed");this.isTransformedData=false}var f=this.isGroupedData?this.grpIndices:this.smpIndices;for(var s=0;s<this.varIndices.length;s++){var l=this.varIndices[s];for(var p=0;p<f.length;p++){var t=f[p];var g=c.high[l][t];var z=c.low[l][t];if(!isNaN(g)&&!isNaN(z)){n=Math.min(z,n);r=Math.max(g,r)}}}}else{if(d=="volume"){var f=this.isGroupedData?this.grpIndices:this.smpIndices;for(var s=0;s<this.varIndices.length;s++){var l=this.varIndices[s];for(var p=0;p<f.length;p++){var t=f[p];if(!isNaN(c.volume[l][t])){n=Math.min(c.volume[l][t],n);r=Math.max(c.volume[l][t],r)}}}}else{if(d=="cor"){var f=this.correlationAxis=="variables"?this.varIndices:this.isGroupedData?this.grpIndices:this.smpIndices;for(var s=0;s<f.length;s++){for(var p=0;p<f.length;p++){var A=this.isTransformedData?c.trans[s][p]:c.cor[s][p];if(!isNaN(A)){if(b){if(A>0){n=Math.min(A,n);r=Math.max(A,r)}}else{n=Math.min(A,n);r=Math.max(A,r)}}}}}else{var y=this.isTransformedData?c.trans:c.data;if(u){for(var s=0;s<this.smpIndices.length;s++){var h=0;for(var p=0;p<this.varIndices.length;p++){var A=y[this.varIndices[p]][this.smpIndices[s]];if(!isNaN(A)&&A>0){h+=A}}r=Math.max(h,r)}n=0}else{for(var s=0;s<this.varIndices.length;s++){for(var p=0;p<this.smpIndices.length;p++){var A=y[this.varIndices[s]][this.smpIndices[p]];if(!isNaN(A)){if(b){if(A>0){n=Math.min(A,n);r=Math.max(A,r)}}else{n=Math.min(A,n);r=Math.max(A,r)}}}}}}}}}}}}this.minData=this.setMin!=null?this.setMin:n;this.maxData=this.setMax!=null?this.setMax:r};this.sortIndices=function(e,c,b,h,d){var f=this;var g=this.isGroupedData?this.grpIndices:e=="vars"?this.varIndices:this.smpIndices;if(!c){c=this.sortDir}if(b&&e=="vars"&&this.data.z[b]){this.tmpAsciiArray=this.data.z[b];this.smpSort=-1;this.varSort=b}else{if(b&&e=="smps"&&this.data.x[b]){this.tmpAsciiArray=this.data.x[b];this.varSort=-1;this.smpSort=b}else{if(h){this.tmpAsciiArray=this.getDataForSmpGrpAtIndex(h-1);this.smpSort=h-1}else{if(d){this.tmpAsciiArray=this.data.y.data[d-1];this.varSort=d-1}else{this.tmpAsciiArray=this.isGroupedData?this.data.w.smps:e=="vars"?this.data.y.vars:this.data.y.smps;if(e=="vars"){this.varSort=false}else{this.smpSort=false}}}}}if(this.isAsciiArray(this.tmpAsciiArray)){g.sort(function(j,i){return f.sortAsciibetically(j,i)})}else{g.sort(function(j,i){return f.sortNumerically(j,i)})}if(c!="ascending"){g.reverse()}this.tmpAsciiArray=[]};this.isAsciiArray=function(b){for(var c=0;c<b.length;c++){if(isNaN(b[c])){return true}}return false};this.sortAsciibetically=function(d,c){return((this.tmpAsciiArray[d]>this.tmpAsciiArray[c])?1:(this.tmpAsciiArray[d]<this.tmpAsciiArray[c])?-1:0)};this.sortNumerically=function(d,c){return(this.tmpAsciiArray[d]-this.tmpAsciiArray[c])};this.radixSort=function(o){var i=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];var f=new Int32Array(o.length);var g=[].concat(i);var h=[].concat(i);var k=[].concat(i);var m=[].concat(i);var b=0;var j;var c=0;var l;var d=0;var n;var e=0;var p;var q;for(q=0;q<o.length;q++){j=o[q]&255;l=(o[q]>>8)&255;n=(o[q]>>16)&255;p=(o[q]>>24)&255^128;g[j]++;h[l]++;k[n]++;m[p]++}for(q=0;q<256;q++){j=b+g[q];l=c+h[q];n=d+k[q];p=e+m[q];g[q]=b;h[q]=c;k[q]=d;m[q]=e;b=j;c=l;d=n;e=p}for(q=0;q<o.length;q++){j=o[q]&255;f[g[j]]=o[q];g[j]++}for(q=0;q<o.length;q++){l=(f[q]>>8)&255;o[h[l]]=f[q];h[l]++}for(q=0;q<o.length;q++){n=(o[q]>>16)&255;f[k[n]]=o[q];k[n]++}for(q=0;q<o.length;q++){p=(f[q]>>24)&255^128;o[m[p]]=f[q];m[p]++}return o};this.isNumeric=function(b,f,e){if(f){for(var d=0;d<this.smpIndices.length;d++){var c=this.smpIndices[d];if(b[c]&&isNaN(b[c])){return false}}}else{if(e){for(var d=0;d<this.varIndices.length;d++){var c=this.varIndices[d];if(b[c]&&isNaN(b[c])){return false}}}else{for(var c=0;c<b.length;c++){if(b[c]&&isNaN(b[c])){return false}}}}return true};this.precedence={sin:16,cos:16,tan:16,sec:16,csc:16,cot:16,asin:16,acos:16,atan:16,asec:16,acsc:16,acot:16,sinh:16,cosh:16,tanh:16,sech:16,csch:16,coth:16,asinh:16,acosh:16,atanh:16,asech:16,acsch:16,acoth:16,exp:16,ln:16,log:16,logb:16,pow:16,sq:16,sqrt:16,abs:16,sgn:16,chs:16,floor:16,ceil:16,ip:16,fp:16,inv:16,min:16,max:16,gamma:16,fact:16,comb:16,perm:16,rand:16,gcd:16,lcm:16,prime:16,and:16,or:16,xor:16,x:16,y:16,pi:16,e:16,neg:15,not:15,"^":14,"*":13,"/":13,mod:13,div:13,"+":12,"-":12,"<":10,"<=":10,"==":10,"!=":10,">=":10,">":10,"&&":5,"||":4,",":1};this.expects={sin:1,cos:1,tan:1,sec:1,csc:1,cot:1,asin:1,acos:1,atan:1,asec:1,acsc:1,acot:1,sinh:1,cosh:1,tanh:1,sech:1,csch:1,coth:1,asinh:1,acosh:1,atanh:1,asech:1,acsch:1,acoth:1,exp:1,ln:1,log:1,logb:2,pow:2,sq:1,sqrt:1,abs:1,sgn:1,chs:1,floor:1,ceil:1,ip:1,fp:1,inv:1,min:2,max:2,gamma:1,fact:1,comb:2,perm:2,gcd:2,lcm:2,prime:1,and:2,or:2,xor:2,neg:1,not:1,"^":2,"*":2,"/":2,mod:2,div:2,"+":2,"-":2,"<":2,"<=":2,"==":2,"!=":2,">=":2,">":2,"&&":2,"||":2};this.alias={"+":"add","-":"sub","*":"mul","/":"div","!":"fact","x^y":"pow","^":"pow","10^":"pow10",div:"idiv","<":"lt","<=":"le","==":"eq","!=":"ne",">=":"ge",">":"gt","%":"pc","%ch":"pcch"};this.add=function(c,b){return new Number(b)+new Number(c)};this.sub=function(c,b){return b-c};this.mul=function(c,b){return b*c};this.div=function(c,b){return b/c};this.sin=function(b){return Math.sin(b)};this.cos=function(b){return Math.cos(b)};this.tan=function(b){return Math.tan(b)};this.sec=function(b){return 1/Math.cos(b)};this.csc=function(b){return 1/Math.sin(b)};this.cot=function(b){return 1/Math.tan(b)};this.asin=function(b){return Math.asin(b)};this.acos=function(b){return Math.acos(b)};this.atan=function(b){return Math.atan(b)};this.asec=function(b){return Math.acos(1/b)};this.acsc=function(b){return Math.asin(1/b)};this.acot=function(b){return Math.atan(1/b)};this.sinh=function(b){return(Math.exp(b)-Math.exp(-b))*0.5};this.cosh=function(b){return(Math.exp(b)+Math.exp(-b))*0.5};this.tanh=function(b){return(Math.exp(b)-Math.exp(-b))/(Math.exp(b)+Math.exp(-b))};this.sech=function(b){return 1/cosh(b)};this.csch=function(b){return 1/sinh(b)};this.coth=function(b){return 1/tanh(b)};this.asinh=function(b){return Math.log(b+Math.sqrt(b*b+1))};this.acosh=function(b){return Math.log(b+Math.sqrt(b*b-1))};this.atanh=function(b){return Math.log((1+b)/(1-b))*0.5};this.asech=function(b){return acosh(1/b)};this.acsch=function(b){return asinh(1/b)};this.acoth=function(b){return atanh(1/b)};this.exp=function(b){return Math.exp(b)};this.ln=function(b){return Math.log(b)};this.log=function(b){return Math.log(b)/Math.LN10};this.logb=function(c,b){return Math.log(b)/Math.log(c)};this.pow=function(c,b){return Math.pow(b,c)};this.pow10=function(b){return Math.pow(10,b)};this.sq=function(b){return b*b};this.sqrt=function(b){return Math.sqrt(b)};this.abs=function(b){return b>=0?b:-b};this.sgn=function(b){return b==0?0:(b>0?1:-1)};this.chs=function(b){return -b};this.neg=function(b){return -b};this.floor=function(b){return Math.floor(b)};this.ceil=function(b){return Math.ceil(b)};this.ip=function(b){return parseInt(b)};this.fp=function(b){return abs(b)-ip(abs(b))};this.inv=function(b){return 1/b};this.idiv=function(c,b){return parseInt(b/c)};this.mod=function(c,b){return b%c};this.and=function(c,b){return b&c};this.or=function(c,b){return b|c};this.xor=function(c,b){return b^c};this.not=function(b){return ~b};this.lt=function(c,b){return b<c?1:0};this.le=function(c,b){return b<=c?1:0};this.eq=function(c,b){return b==c?1:0};this.ne=function(c,b){return b!=c?1:0};this.ge=function(c,b){return b>=c?1:0};this.gt=function(c,b){return b>c?1:0};this.Min=function(c,b){return Math.min(b,c)};this.Max=function(c,b){return Math.max(b,c)};this.pc=function(c,b){return b*c/100};this.pcch=function(c,b){return 100*c/b};this.gammaConsts=new Array(76.18009172947146,-86.50532032941678,24.01409824083091,-1.231739572450155,0.001208650973866179,-0.000005395239384953);this.gammaLn=function(b){var f=new Number(b);var e=new Number(b+5.5);var c=new Number(1.000000000190015);e-=(b+0.5)*Math.log(e);for(var d in this.gammaConsts){c+=this.gammaConsts[d]/++f}return Math.log(2.5066282746310007*c/b)-e};this.gamma=function(b){return Math.exp(this.gammaLn(b))};this.fact=function(c){var b=new Number(c);if(c<=1){return 1}if(c>100||(c%1)){return Math.exp(this.gammaLn(c+1))}while(--c){b*=c}return b};this.comb=function(c,b){return Math.floor(0.5+Math.exp(this.gammaLn(b+1)-this.gammaLn(c+1)-this.gammaLn(b-c+1)))};this.perm=function(c,b){return Math.floor(0.5+Math.exp(this.gammaLn(b+1)-this.gammaLn(b-c+1)))};this.gcd=function(d,c){if(d==0){return(c||1)}return(c?this.gcd(c,d%c):d)};this.lcm=function(d,c){return(d/this.gcd(d,c))*c};this.prime=function(f){var e=new Number(5);var b=new Number(4);var c=parseInt(f/e);if(f==2||f==3||f==5){return 1}if(f<5||(f&1)==0||(f%3)==0){return 0}while(e*c<f&&e<c){c=parseInt(f/(e+=(b=6-b)))}return(e*c==f?0:1)};this.cleanArray=function(b,g,f){var d=[];if(g){for(var e=0;e<this.smpIndices.length;e++){var c=this.smpIndices[e];if(!isNaN(b[c])){d.push(b[c])}}}else{if(f){for(var e=0;e<this.varIndices.length;e++){var c=this.varIndices[e];if(!isNaN(b[c])){d.push(b[c])}}}else{for(var c=0;c<b.length;c++){if(!isNaN(b[c])){d.push(b[c])}}}}return d};this.cleanArrays=function(c,b,j,h){var g=[];var f=[];if(j){for(var e=0;e<this.smpIndices.length;e++){var d=this.smpIndices[e];if(!isNaN(c[d])&&!isNaN(b[d])){g.push(c[d]);f.push(b[d])}}}else{if(h){for(var e=0;e<this.varIndices.length;e++){var d=this.varIndices[e];if(!isNaN(c[d])&&!isNaN(b[d])){g.push(c[d]);f.push(b[d])}}}else{for(var d=0;d<c.length;d++){if(!isNaN(c[d])&&!isNaN(b[d])){g.push(c[d]);f.push(b[d])}}}}return[g,f]};this.sortArray=function(b,c){var e=[];if(b.length!=c.length){return b}for(var d=0;d<b.length;d++){if(b[c[d]]){e[d]=b[c[d]]}else{return b}}return e};this.reverseArray=function(b){var e=[];var d=0;for(var c=b.length-1;c>=0;c--){e[d]=b[c];d++}return e};this.percentile=function(e,b,f){var c=b-e;if(c==0){return 50}var d=f-e;return d*100/c};this.rank=function(b){var d=[];for(var c=0;c<b.length;c++){d.push(c)}d.sort(function(f,e){return b[f]-b[e]});return d};this.min=function(b,f,e){if(this.isArray(b)){b=this.cleanArray(b,f,e);var d=Number.MAX_VALUE;for(var c=0;c<b.length;c++){d=Math.min(d,b[c])}return d}else{return this.Min(b,f)}};this.max=function(c,f,e){if(this.isArray(c)){c=this.cleanArray(c,f,e);var b=Number.MIN_VALUE;for(var d=0;d<c.length;d++){b=Math.max(b,c[d])}return b}else{return this.Max(c,f)}};this.sum=function(b,g,f,e){b=this.cleanArray(b,g,f);var d=0;for(var c=0;c<b.length;c++){if(e){if(b[c]>0){d+=b[c]}}else{d+=b[c]}}return d};this.mean=function(b,g,e){b=this.cleanArray(b,g,e);var c=0;var f=0;for(var d=0;d<b.length;d++){if(!isNaN(b[d])){c+=b[d];f++}}if(f>0){c/=f}return c};this.range=function(c,g,f){c=this.cleanArray(c,g,f);var e=Number.MAX_VALUE;var b=Number.MAX_VALUE*-1;for(var d=0;d<c.length;d++){e=Math.min(c[d],e);b=Math.max(c[d],b)}return[e,b]};this.median=function(b,h,f){b=this.cleanArray(b,h,f);var e=[];var d=[];var g=0;e[0]=Number.NaN;e[1]=Number.NaN;for(var c=0;c<b.length;c++){d.push(b[c]);g++}if(g>0){e[1]=g;d.sort(function(j,i){return j-i});if(g%2){e[0]=d[parseInt(g/2)]}else{e[0]=(d[parseInt((g-1)/2)]+d[g/2])/2}}return e};this.meanStandardDeviationN=function(b,j,g){b=this.cleanArray(b,j,g);var f=[];var d=0;var c=0;var h=0;for(var e=0;e<b.length;e++){c+=b[e];d+=b[e]*b[e];h++}if(h>0){c/=h;d=Math.sqrt(d/h-c*c);f.push(c);f.push(d);f.push(h)}else{f.push("");f.push("");f.push("")}return f};this.quantiles=function(l,d,s){l=this.cleanArray(l,d,s);var o=[];var h=[];var e=l.length;if(e>2){var p=Math.floor(e*0.25);var k=Math.floor(e*0.5);var c=Math.floor(e*0.75);l.sort(function(n,i){return n-i});var b;var r;var q;if(e%2){r=l[k]}else{r=this.mean([l[k-1],l[k]])}if((e/2)%2){b=l[p];q=l[c]}else{b=this.mean([l[p-1],l[p]]);q=this.mean([l[c-1],l[c]])}var m=(q-b)*1.5;var g;var f;for(var j=0;j<=p;j++){if(l[j]<b-m){h.push(l[j])}else{g=l[j];break}}for(var j=e-1;j>=c;j--){if(l[j]>q+m){h.push(l[j])}else{f=l[j];break}}o.push(b);o.push(r);o.push(q);o.push(g);o.push(f);o.push(h);o.push(e)}else{if(e>1){o.push(l[0]);o.push(l[1]);o.push(l[1]);o.push(l[0]);o.push(l[1]);o.push(h);o.push(e)}else{if(e>0){o.push(l[0]);o.push(l[0]);o.push(l[0]);o.push(l[0]);o.push(l[0]);o.push(h);o.push(e)}else{o.push(Number.NaN);o.push(Number.NaN);o.push(Number.NaN);o.push(Number.NaN);o.push(Number.NaN);o.push(Number.NaN)}}}return o};this.covariance=function(g,f,b,l){var e=this.cleanArrays(g,f,b,l);g=e[0];f=e[1];var k=0;var c=0;var j=this.mean(g);var h=this.mean(f);for(var d=0;d<g.length;d++){k+=g[d]*f[d];c++}if(c>0){k/=c;return k-(j*h)}return k};this.correlation=function(h,g,c,p){var f=this.cleanArrays(h,g,c,p);h=f[0];g=f[1];var d=0;var m=0;var k=0;var b=0;var j=0;var l=this.covariance(h,g);var o=0;for(var e=0;e<h.length;e++){m+=h[e];k+=g[e];b+=h[e]*h[e];j+=g[e]*g[e];d++}if(d>0){o=(d*d)*l/Math.sqrt(((d*b)-(m*m))*((d*j)-(k*k)))}return o};this.regression=function(k,j,c,s){var h=this.cleanArrays(k,j,c,s);k=h[0];j=h[1];var d=0;var p=0;var m=0;var r=0;var b=0;var l=0;var o=this.covariance(k,j);var q=0;var g=0;var e=0;for(var f=0;f<k.length;f++){p+=k[f];m+=j[f];r+=k[f]*j[f];b+=k[f]*k[f];l+=j[f]*j[f];d++}if(d>2){g=(d*r-p*m)/(d*b-p*p);e=(m-g*p)/d;q=(d*d)*o/Math.sqrt(((d*b)-(p*p))*((d*l)-(m*m)))}return[g,e,q]};this.slope=function(c,e,b,d){return e!=d?(b-c)/(d-e):0};this.intercept=function(b,d,c){return d-(b*c)};this.slopeIntercept=function(c,f,b,e){var d=this.slope(c,f,b,e);return[d,this.intercept(c,f,d)]};this.normalize=function(f){for(var e=0;e<f.length;e++){var b=this.meanStandardDeviationN(f[e]);for(var c=0;c<f[e].length;c++){f[e][c]=(f[e][c]-b[0])/b[1]}}return f};this.euclidianDistance=function(c,b,j,h){var f=this.cleanArrays(c,b,j,h);c=f[0];b=f[1];var g=0;if(c.length==b.length){for(var e=0;e<c.length;e++){g+=Math.pow(c[e]-b[e],2)}g=Math.sqrt(g)}return g};this.manhattanDistance=function(c,b,j,h){var f=this.cleanArrays(c,b,j,h);c=f[0];b=f[1];var g=0;if(c.length==b.length){for(var e=0;e<c.length;e++){g+=Math.abs(c[e]-b[e])}}return g};this.maxDistance=function(c,b,j,h){var f=this.cleanArrays(c,b,j,h);c=f[0];b=f[1];var g=0;if(c.length==b.length){for(var e=0;e<c.length;e++){g=Math.max(g,Math.abs(c[e]-b[e]))}}return g};this.addVectors=function(d,c,h,g){var f=this.cleanArrays(d,c,h,g);d=f[0];c=f[1];var b=[];if(d.length==c.length){for(var e=0;e<d.length;e++){b.push(d[e]+c[e])}}return b};this.compareVectors=function(c,b){if(this.isArray(c)&&this.isArray(b)){if(c.length!=b.length){return false}for(var d=0;d<c.length;d++){if(this.isArray(c[d])&&this.isArray(b[d])){if(!this.compareArrays(c[d],b[d])){return false}}if(c[d]!==b[d]){return false}}return true}};this.vectorDotProduct=function(c,b,h,g){var e=this.cleanArrays(c,b,h,g);c=e[0];b=e[1];var f=0;if(c.length==b.length){for(var d=0;d<c.length;d++){f+=c[d]*b[d]}}return f};this.multiplyVectorByValue=function(b,e,f,d){b=this.cleanArray(b,f,d);for(var c=0;c<b.length;c++){b[c]*=e}return b};this.getCentroid=function(e,h,g,b){var j=[];if(h.length==b.length){var f=e+g;for(var d=0;d<h.length;d++){j.push((e*h[d]+g*b[d])/f)}}return j};this.createNode=function(j,e,f,g,i,b){var h={id:j,left:e,right:f,dist:g,centroid:i};if(b){h.mid=b}if(e==null&&f==null){h.size=1;h.depth=0}else{h.size=e.size+f.size;h.depth=1+Math.max(e.depth,f.depth)}return h};this.createRandomVectors=function(e,h){var d=h.length;if(e>d){return null}var m=[];var g=[];var b={};var o=0;var p=0;var l,c;while(p<e){if(o==d){return null}var j=Math.floor(Math.random()*d);if(j in b){continue}b[j]=1;o++;l=h[j];c=true;for(var f=0;f<p;f++){if(this.compareVectors(l,m[f])){c=false;break}}if(c){m[p]=l;g[p]=j;p++}}return{vectors:m,indices:g}};this.imputeDatum=function(b){var e=[];if(this.clusterAxis=="samples"){for(var c=0;c<this.varIndices.length;c++){var d=this.varIndices[c];e.push(this.data.y.data[d][b])}}else{for(var c=0;c<this.smpIndices.length;c++){var d=this.smpIndices[c];e.push(this.data.y.data[b][d])}}return this[this.imputeMethod](e)};this.getIdsForClustering=function(){var e=[];if(this.clusterAxis=="samples"){for(var b=0;b<this.smpIndices.length;b++){var c=this.smpIndices[b];e[b]=this.useSmpVarIndexOnClustering?c:this.data.y.smps[c]}}else{for(var b=0;b<this.varIndices.length;b++){var c=this.varIndices[b];e[b]=this.useSmpVarIndexOnClustering?c:this.data.y.vars[c]}}return e};this.getDataForClustering=function(){var k=[];var b=[];if(this.clusterAxis=="samples"){for(var e=0;e<this.smpIndices.length;e++){k[e]=[]}for(var e=0;e<this.varIndices.length;e++){var f=this.varIndices[e];for(var c=0;c<this.smpIndices.length;c++){var g=this.smpIndices[c];var h=this.data.y.data[f][g];if(isNaN(h)){if(!b[c]){b[c]=this.imputeDatum(g)}h=b[c]}k[c][e]=h}}}else{for(var e=0;e<this.varIndices.length;e++){k[e]=[]}for(var e=0;e<this.varIndices.length;e++){var f=this.varIndices[e];for(var c=0;c<this.smpIndices.length;c++){var g=this.smpIndices[c];var h=this.data.y.data[f][g];if(isNaN(h)){if(!b[e]){b[e]=this.imputeDatum(f)}h=b[e]}k[e][c]=h}}}if(this.centerData){k=this.normalize(k)}return k};this.cluster=function(){this.useSmpVarIndexOnClustering=true;var v;var o=this.getDataForClustering();var g=this.getIdsForClustering();var f=[];var e=[];var q=[];var u=[];for(var n=0;n<o.length;n++){f[n]=[]}for(var n=0;n<o.length;n++){f[n][n]=Number.POSITIVE_INFINITY;for(var k=n+1;k<o.length;k++){f[n][k]=this[this.distance+"Distance"](o[n],o[k]);f[k][n]=f[n][k]}}for(var n=0;n<o.length;n++){e[n]=0;for(var k=0;k<o.length;k++){if(f[n][e[n]]>f[n][k]){e[n]=k}}}for(var n=0;n<o.length;n++){u[n]=[];u[n][0]=this.createNode(g[n],null,null,0,o[n]);q[n]=1}for(var b=0;b<o.length-1;b++){var m=0;for(var n=0;n<o.length;n++){if(f[n][e[n]]<f[m][e[m]]){m=n}}var h=e[m];var c=u[m][0];var r=u[h][0];var t=this.getCentroid(c.size,c.centroid,r.size,r.centroid);var s=this.createNode(-1,c,r,f[m][h],t);u[m].splice(0,0,s);q[m]+=q[h];for(var k=0;k<o.length;k++){if(this.linkage=="single"){if(f[m][k]>f[h][k]){f[k][m]=f[m][k]=f[h][k]}}else{if(this.linkage=="complete"){if(f[m][k]<f[h][k]){f[k][m]=f[m][k]=f[h][k]}}else{if(this.linkage=="average"){f[k][m]=f[m][k]=(q[m]*f[m][k]+q[h]*f[h][k])/(q[m]+q[k])}}}}f[m][m]=Number.POSITIVE_INFINITY;for(var n=0;n<o.length;n++){f[n][h]=f[h][n]=Number.POSITIVE_INFINITY}for(var k=0;k<o.length;k++){if(e[k]==h){e[k]=m}if(f[m][k]<f[m][e[m]]){e[m]=k}}v=s}return this.writeNewick(v)};this.isLeafNode=function(b){if(b.left==null&&b.right==null){return true}else{return false}};this.writeNewick=function(c,j){var h="";var g="";if(this.isLeafNode(c)){h=c.id}else{var b;var d=this.writeNewick(c.left,j);var f=this.writeNewick(c.right,j);if(c.mid){for(var e=0;e<c.mid.length;e++){if(j&&c.mid[e].dist){g+=","+c.mid[e].id+":"+c.mid[e].dist}else{g+=","+c.mid[e].id}g+=c.mid[e].id}}h="("+d+g+","+f+")"}if(j&&c.dist){h+=":"+c.dist}return h};this.kmeans=function(){var m;var o=this.getDataForClustering();var c=this.getIdsForClustering();var n=[];var p=[];var r=true;var q=0;var h=null;var w=this.createRandomVectors(this.kmeansClusters,o);if(w==null){return null}else{h=w.vectors}while(r){for(var k=0;k<this.kmeansClusters;k++){p[k]=0}for(var k=0;k<o.length;k++){var s=o[k];var g=Number.MAX_VALUE;var e;for(var f=0;f<this.kmeansClusters;f++){var b=this.euclidianDistance(h[f],s);if(b<g){g=b;e=f}}p[e]++;n[k]=e}var u=[];for(var k=0;k<this.kmeansClusters;k++){u[k]=null}for(var k=0;k<o.length;k++){if(u[n[k]]==null){u[n[k]]=o[k]}else{u[n[k]]=this.addVectors(u[n[k]],o[k])}}for(var k=0;k<this.kmeansClusters;k++){u[k]=this.multiplyVectorByValue(u[k],1/p[k])}r=false;for(var k=0;k<this.kmeansClusters;k++){if(!this.compareVectors(u[k],h[k])){r=true;break}}h=u;q++;if(q>this.maxIterations){r=false}}for(var k=0;k<n.length;k++){n[k]="K-"+(n[k]+1)}return n};this.transpose=function(c,f){if(c){var g=[];for(var e=0;e<c.length;e++){for(var b=0;b<c[e].length;b++){if(!g[b]){g[b]=[]}g[b][e]=c[e][b]}}return g}else{this.ungroupSamples();this.transform("reset");if(this.data.l){delete (this.data.l)}if(this.data.d){delete (this.data.d)}if(this.data.a){delete (this.data.a)}if(this.data.t){var l=this.data.t.vars;var m=this.data.t.smps;if(l){this.data.t.smps=l}if(m){this.data.t.vars=m}}var k=this.data.x;var h=this.data.z;if(k){this.data.z=k}if(h){this.data.x=h}var m=this.data.y.smps;this.data.y.smps=this.data.y.vars;this.data.y.vars=m;var g=this.data.y.data;this.data.y.data=[];for(var e=0;e<this.data.y.vars.length;e++){this.data.y.data[e]=[];for(var b=0;b<this.data.y.smps.length;b++){this.data.y.data[e][b]=g[b][e]}}if(!f){this.initializeData(this.data);this.resetObject();this.draw()}}};this.checkObject=function(){var d=this.data.y;if(this.isGroupedData){this.data.w={};d=this.data.w}var c=["vars","smps","desc","data","mean","median","stdev","n","qtl1","qtl3","iqr1","iqr3","out","trans","cor","sum","grps","close","open","high","low","volume"];for(var b=0;b<c.length;b++){if(!d[c[b]]){d[c[b]]=[]}}};this.resetObject=function(b){var d=["mean","median","stdev","n","qtl1","qtl3","iqr1","iqr3","out","cor","sum","grps","close","open","high","low","volume"];if(this.isGroupedData){if(!this.isTransformedData){d.push("trans")}for(var c=0;c<d.length;c++){delete (this.data.y[d[c]])}delete (this.data.w)}else{if(!this.isTransformedData){d.push("trans")}if(this.isRawData){for(var c=0;c<d.length;c++){delete (this.data.y[d[c]])}}else{delete (this.data.y.data)}}if(b){this.checkObject()}};this.getDataAtPos=function(g,e,c,d,f,b){var h=Number.NaN;var k=this.isGroupedData?this.data.w:this.data.y;if(this.isGroupedData||!this.isRawData){if(this.isTransformedData){h=k.trans[g][e]}else{c=c?c:this.summaryType;if(k.hasOwnProperty(c)){h=k[c][g][e]}else{h=0}}}else{if(c&&k[c][g]){h=k[c][g][e]}else{if(this.isTransformedData){h=k.trans[g][e]}else{h=k.data[g][e]}}}if(d){if(!isNaN(h)){if(d=="log2"){h=Math.log(h)/Math.LN2}else{if(d=="log10"){h=Math.log(h)/Math.LN10}else{if(d=="exp2"){h=Math.pow(2,h)}else{if(d=="exp10"){h=Math.pow(2,h)}else{if(d=="percentile"){h=this.percentile(f,b,h)}}}}}}}return h};this.getDataForSmpGrpAtIndex=function(c,g){var b=[];if(!g){g=this.varIndices}if(this.isGroupedData||!this.isRawData){var h=this.isGroupedData?this.data.w:this.data.y;if(this.isTransformedData){b.push(h.trans[f][c])}else{var d=this.summaryType;if(h.hasOwnProperty(d)){for(var e=0;e<g.length;e++){var f=g[e];b.push(h[d][f][c])}}}}else{if(this.isTransformedData){for(var e=0;e<g.length;e++){var f=g[e];b.push(this.data.y.trans[f][c])}}else{for(var e=0;e<g.length;e++){var f=g[e];b.push(this.data.y.data[f][c])}}}return b};this.getMetaDataForVariableAtIndex=function(b){var d={};if(this.data.z){for(var c in this.data.z){d[c]=this.data.z[c][b]}}d[name]=this.data.y.vars[b];return d};this.getMetaDataForSampleAtIndex=function(b){if(this.isGroupedData){return this.getMetaDataForGrpAtIndex(b)}else{return this.getMetaDataForSmpAtIndex(b)}};this.getMetaDataForSmpAtIndex=function(b){var d={};if(this.data.x){for(var c in this.data.x){d[c]=this.data.x[c][b]}}d[name]=this.data.y.vars[b];return d};this.getMetaDataForGrpAtIndex=function(b){var e=[];for(var c=0;c<this.data.w.grps[b].length;c++){var d=this.data.w.grps[b][c];e.push(this.getMetaDataForSmpAtIndex[d])}return e};this.summarize=function(l,o){var b=this.isGroupedData?this.data.w:this.data.y;var c=this.isGroupedData?false:true;if(!this.isGroupedData){this.checkObject()}if(l=="cor"){this.isBoxPlotCalc=false;if(this.correlationAxis=="samples"){var p=this.isGroupedData?this.grpIndices:this.smpIndices;for(var e=0;e<p.length;e++){var q=p[e];var m=this.getDataForSmpGrpAtIndex(q);if(!b.cor[q]){b.cor[q]=[]}for(var d=e;d<p.length;d++){var g=p[d];if(!b.cor[g]){b.cor[g]=[]}var k=this.getDataForSmpGrpAtIndex(g);if(e==d){if(this.isTransformedData){b.trans[q][g]=1}b.cor[q][g]=1}else{b.cor[q][g]=this.correlation(m,k);b.cor[g][q]=b.cor[q][g];if(this.isTransformedData){b.trans[q][g]=b.cor[q][g];b.trans[g][q]=b.cor[g][q]}}}}}else{for(var e=0;e<this.varIndices.length;e++){var q=this.varIndices[e];if(!b.cor[q]){b.cor[q]=[]}for(var d=e;d<this.varIndices.length;d++){var g=this.varIndices[d];if(!b.cor[g]){b.cor[g]=[]}if(e==d){b.cor[q][g]=1;if(this.isTransformedData){b.trans[q][g]=1}}else{b.cor[q][g]=this.correlation(b.data[q],b.data[g],c);b.cor[g][q]=b.cor[q][g];if(this.isTransformedData){b.trans[q][g]=b.cor[q][g];b.trans[g][q]=b.cor[g][q]}}}}}}else{this.isBoxPlotCalc=l=="iqr"?true:false;for(var e=0;e<this.varIndices.length;e++){var f;var q=this.varIndices[e];if(!b.mean[q]){b.trans[q]=[];b.mean[q]=[];b.median[q]=[];b.stdev[q]=[];b.qtl1[q]=[];b.qtl3[q]=[];b.iqr1[q]=[];b.iqr3[q]=[];b.out[q]=[];b.n[q]=[];b.sum[q]=[]}if(this.isGroupedData){f=o[q]}else{b.grps=[];f=[];for(var d=0;d<this.smpIndices.length;d++){var g=this.smpIndices[d];b.grps[d]=[];b.grps[d].push(g);f[d]=[b.data[q][g]]}}if(l=="iqr"){this.summaryType="iqr";for(var d=0;d<f.length;d++){var n=this.quantiles(f[d],c);if(this.isTransformedData){b.trans[q][d]=n[1]}b.median[q][d]=n[1];b.qtl1[q][d]=n[0];b.qtl3[q][d]=n[2];b.iqr1[q][d]=n[3];b.iqr3[q][d]=n[4];b.out[q][d]=n[5];b.n[q][d]=n[6]}}else{if(l=="median"){this.summaryType="median";for(var d=0;d<f.length;d++){var n=this.median(f[d],c);if(this.isTransformedData){b.trans[q][d]=n[1]}b.median[q][d]=n[0];b.n[q][d]=n[1]}}else{if(l=="mean"){this.summaryType="mean";for(var d=0;d<f.length;d++){var n=this.meanStandardDeviationN(f[d],c);if(this.isTransformedData){b.trans[q][d]=n[1]}b.mean[q][d]=n[0];b.stdev[q][d]=n[1];b.n[q][d]=n[2]}}else{if(l=="sum"){this.summaryType="sum";for(var d=0;d<f.length;d++){var h=this.sum(f[d],c);if(this.isTransformedData){b.trans[q][d]=h}b.sum[q][d]=h;b.n[q][d]=f[d].length}}}}}}}};this.copySummarizedData=function(){var f=this.isGroupedData?this.data.w:this.data.y;var e;for(var c=0;c<this.varIndices.length;c++){var d=this.varIndices[c];f.data[d]=[];f.trans[d]=[];if(this.summaryType=="mean"){for(var b=0;b<f.mean[d].length;b++){f.data[d][b]=f.mean[d][b]}}else{if(this.summaryType=="median"||this.summaryType=="iqr"){for(var b=0;b<f.median[d].length;b++){f.data[d][b]=f.median[d][b]}}else{if(this.summaryType=="candle"){for(var b=0;b<f.close[d].length;b++){f.data[d][b]=f.close[d][b]}}else{if(this.summaryType=="volume"){for(var b=0;b<f.volume[d].length;b++){f.data[d][b]=f.volume[d][b]}}else{if(this.summaryType=="sum"){for(var b=0;b<f.volume[d].length;b++){f.data[d][b]=f.sum[d][b]}}}}}}if(!e){e=d}}return e};this.transformValue=function(c,d,b){switch(c){case"log2":return b?Math.pow(2,d):Math.log(d)/Math.LN2;case"log10":return b?Math.pow(10,d):Math.log(d)/Math.LN10;case"exp2":return b?Math.log(d)/Math.LN2:Math.pow(2,d);case"exp10":return b?Math.log(d)/Math.LN10:Math.pow(10,d);default:return d}};this.transform=function(d,c,b){var e=0;if(!this.isGroupedData){this.checkObject()}if(!this.isRawData||this.isGroupedData){e=this.copySummarizedData()}this.transformType=d;if(d=="reset"||d=="undo"){this.transformReset();this.transformType=false;this.isTransformedData=false}else{if(d=="save"){this.transformSave();this.transformType=false;this.isTransformedData=false}else{if(d=="log2"||d=="log10"||d=="exp2"||d=="exp10"){this.transformLogExp(d);this.isTransformedData=true}else{if(d=="ratio"||d=="ratio2"||d=="ratio10"){this.transformRatio(d,b);this.isTransformedData=true}else{this.transformRelative(d,c,e);this.isTransformedData=true}}}}this.draw()};this.transformReset=function(){var e=this.isGroupedData?this.data.w:this.data.y;for(var c=0;c<this.varIndices.length;c++){var d=this.varIndices[c];for(var b=0;b<e.data[d].length;b++){if(e.trans[d]&&!isNaN(e.data[d][b])){e.trans[d][b]=e.data[d][b]}}}};this.transformSave=function(){var e=this.isGroupedData?this.data.w:this.data.y;for(var c=0;c<this.varIndices.length;c++){var d=this.varIndices[c];for(var b=0;b<e.data[d].length;b++){if(!isNaN(e.data[d][b])){e.data[d][b]=e.trans[d][b]}}}};this.transformLogExp=function(e){var f=this.isGroupedData?this.data.w:this.data.y;if(e=="log"){e=this.transformBase==2?"type2":"type10"}else{if(e=="exp"){e=this.transformBase==2?"exp2":"exp10"}}for(var c=0;c<this.varIndices.length;c++){var d=this.varIndices[c];if(!f.trans[d]){f.trans[d]=[]}for(var b=0;b<f.data[d].length;b++){if(!isNaN(f.data[d][b])){if(e=="log2"){this.isLogData=true;this.transformBase=2;f.trans[d][b]=Math.log(f.data[d][b])/Math.LN2}else{if(e=="log10"){this.isLogData=true;this.transformBase=10;f.trans[d][b]=Math.log(f.data[d][b])/Math.LN10}else{if(e=="exp2"){this.isLogData=false;this.transformBase=2;f.trans[d][b]=Math.pow(2,f.data[d][b])}else{if(e=="exp10"){this.isLogData=false;this.transformBase=10;f.trans[d][b]=Math.pow(10,f.data[d][b])}}}}}}}};this.transformRatio=function(f,b){var h=this.isGroupedData?this.data.w:this.data.y;b=b?b:this.ratioReference?this.ratioReference:0;for(var d=0;d<this.varIndices.length;d++){var e=this.varIndices[d];if(!h.trans[e]){h.trans[e]=[]}for(var c=0;c<h.data[e].length;c++){if(!isNaN(h.data[e][c])&&!isNaN(h.data[e][b])){if(this.isLogData){if(f=="ratio"){f=this.transformBase==2?"ratio2":"ratio10"}var g;if(h.data[e][c]>=h.data[e][b]){g=h.data[e][c]-h.data[e][b];if(f=="ratio2"){h.trans[e][c]=Math.pow(2,g)}else{if(f=="ratio10"){h.trans[e][c]=Math.pow(10,g)}}}else{g=h.data[e][b]/h.data[e][d];if(f=="ratio2"){h.trans[e][c]=Math.pow(2,g)*-1}else{h.trans[e][c]=Math.pow(10,g)*-1}}}else{if(h.data[e][c]>=h.data[e][b]){h.trans[e][c]=h.data[e][c]/h.data[e][b]}else{h.trans[e][c]=h.data[e][b]/h.data[e][c]*-1}}}}}};this.transformRelative=function(l,d,e){var b=this.isGroupedData?this.data.w:this.data.y;var c=this.isGroupedData?false:true;d=d?d:this.zscoreAxis?this.zscoreAxis:"samples";if(d=="samples"){for(var g=0;g<b.data[e].length;g++){var h=[];for(var f=0;f<this.varIndices.length;f++){var k=this.varIndices[f];h.push(b.data[k][g])}if(l=="percentile"){var m=this.range(h,c)}else{if(l=="zscore"){var m=this.meanStandardDeviationN(h,c)}}for(var f=0;f<this.varIndices.length;f++){var k=this.varIndices[f];if(!b.trans[k]){b.trans[k]=[]}if(!isNaN(b.data[k][g])){if(l=="percentile"){b.trans[k][g]=this.percentile(m[0],m[1],b.data[k][g])}else{if(l=="zscore"){b.trans[k][g]=(b.data[k][g]-m[0])/m[1]}}}}}}else{for(var g=0;g<this.varIndices.length;g++){var n=this.varIndices[g];b.trans[n]=[];var h=b.data[n];if(l=="percentile"){var m=this.range(h,c)}else{if(l=="zscore"){var m=this.meanStandardDeviationN(h,c)}}for(var f=0;f<h.length;f++){if(!isNaN(b.data[n][f])){if(l=="percentile"){b.trans[n][f]=this.percentile(m[0],m[1],b.data[n][f])}else{if(l=="zscore"){b.trans[n][f]=(b.data[n][f]-m[0])/m[1]}}}}}}};this.sortSamples=function(e,f,b){this.sortIndices("smps",e,f,false,b);this.draw()};this.sortSamplesByCategory=function(b){this.sortIndices("smps",false,b);this.draw()};this.sortSamplesByVariable=function(b){var c=this.getVariableIndices(b);this.sortIndices("smps",false,false,false,c+1);this.draw()};this.sortVariables=function(e,f,b){this.sortIndices("vars",e,f,b);this.draw()};this.sortVariablesByCategory=function(b){this.sortIndices("vars",false,b);this.draw()};this.sortVariablesBySample=function(b){var c=this.getSampleIndices(b);this.sortIndices("vars",false,false,c+1);this.draw()};this.getGroupingFactors=function(b){if(b){return this.groupingFactors}else{return this.getObjectArray(this.groupingFactors)}};this.modifyGroupingFactors=function(c,b){this.modifyObjectArray(c,b,"groupingFactors")};this.segregateSamplesVariables=function(l,k,g,m,c){delete (this.data.l);this.deleteSubGraphAttributes();this.data.l={};this.data.l.smps=l;this.data.l.vars=k;this.data.l.weight=[];this.data.l.type=[];this.data.l.name=[];this.data.l.desc=[];var h=1/l.length;var e=1/k.length;var f=this.data.y.desc[0]?this.data.y.desc[0]:"";for(var d=0;d<k.length;d++){for(var b=0;b<l.length;b++){this.data.l.weight.push([e,h]);this.data.l.type.push(this.graphType);this.data.l.name.push([m[d],g[b]]);this.data.l.desc.push(f)}}this.layoutComb=true;this.layout=l.length+"X"+k.length;this.isValidLayout();if(!c){this.draw()}};this.desegregateSamples=function(b){this.segregateSamplesBy=false;this.showAnimation=this.showAnimationTemp;this.resetLayout();if(this.segregateVariablesBy){this.segregateVariables(this.segregateVariablesBy,b)}else{this.isValidLayout()}if(!b){this.draw()}};this.segregateSamples=function(c,e){if(this.data.x&&this.data.x[c]){delete (this.layoutParams);var d={};var b=0;var g=[];var h=[];for(var f=0;f<this.data.x[c].length;f++){var k=this.data.x[c][f];if(!d.hasOwnProperty(k)){d[k]=[];b++}d[k].push(this.data.y.smps[f])}var j=1/b;if(this.segregateVariablesBy){vars=this.data.l.vars;for(var k in d){g.push(k);h.push(d[k])}this.segregateSamplesBy=c;this.segregateSamplesVariables(h,this.data.l.vars,g,this.data.l.name,e)}else{delete (this.data.l);this.deleteSubGraphAttributes();this.data.l={};this.data.l.smps=[];this.data.l.weight=[];this.data.l.type=[];this.data.l.name=[];this.data.l.desc=[];for(var k in d){this.data.l.smps.push(d[k]);this.data.l.weight.push(j);this.data.l.type.push(this.graphType);this.data.l.name.push(k);this.data.l.desc.push(this.data.y.desc&&this.data.y.desc[0]?this.data.y.desc[0]:"")}this.segregateSamplesBy=c;this.layoutComb=true;this.showAnimationTemp=this.showAnimation;this.showAnimation=false;this.layout="1X"+this.data.l.smps.length;this.isValidLayout()}if(!e){this.draw()}}};this.desegregateVariables=function(b){this.segregateVariablesBy=false;this.showAnimation=this.showAnimationTemp;this.resetLayout();if(this.segregateSamplesBy){this.segregateSamples(this.segregateSamplesBy,b)}else{this.isValidLayout()}if(!b){this.draw()}};this.segregateVariables=function(k,d){if(this.data.z&&this.data.z[k]){delete (this.layoutParams);var c={};var b=0;var h=[];var j=[];for(var e=0;e<this.data.z[k].length;e++){var f=this.data.z[k][e];if(!c.hasOwnProperty(f)){c[f]=[];b++}c[f].push(this.data.y.vars[e])}var m=1/b;if(this.segregateSamplesBy){for(var f in c){j.push(f);h.push(c[f])}this.segregateVariablesBy=k;this.segregateSamplesVariables(this.data.l.smps,h,this.data.l.name,j,d)}else{delete (this.data.l);this.deleteSubGraphAttributes();this.data.l={};this.data.l.vars=[];this.data.l.weight=[];this.data.l.type=[];this.data.l.name=[];this.data.l.desc=[];for(var f in c){this.data.l.vars.push(c[f]);this.data.l.weight.push(m);this.data.l.type.push(this.graphType);this.data.l.name.push(f);this.data.l.desc.push(this.data.y.desc&&this.data.y.desc[0]?this.data.y.desc[0]:"")}this.segregateVariablesBy=k;this.layoutComb=true;this.showAnimationTemp=this.showAnimation;this.showAnimation=false;this.layout="1X"+this.data.l.vars.length;this.isValidLayout()}if(!d){this.draw()}}};this.deleteSubGraphAttributes=function(){if(this.layoutRows&&this.layoutCols){var e=0;for(var d=0;d<this.layoutRows;d++){for(var b=0;b<this.layoutCols;b++){delete (this["subGraphWeight"+e]);delete (this["subGraphType"+e]);delete (this["subGraphSummaryType"+e]);delete (this["subGraphTransformType"+e]);e++}}}};this.unsetAllVsAll=function(){if(this.graphType.match(/Scatter/)){if(this.xAxisTemp&&this.xAxisTemp.length>0){this.xAxis=this.xAxisTemp;this.xAxisTmp=[]}if(this.yAxisTemp&&this.yAxisTemp.length>0){this.yAxis=this.yAxisTemp;this.yAxisTmp=[]}if(this.zAxisTemp&&this.zAxisTemp.length>0){this.zAxis=this.zAxisTemp;this.zAxisTmp=[]}if(!this.xAxis||!this.yAxis){this.xAxis=[];this.yAxis=[];this.xAxisIndices=[];this.yAxisIndices=[];this.xAxis=[this.data.y.smps[0]];for(var b=1;b<this.data.y.smps.length;b++){this.yAxis.push(this.data.y.smps[b])}this.xAxisIndices=this.getSampleIndices(this.xAxis);this.yAxisIndices=this.getSampleIndices(this.yAxis);this.initAxes(true)}this.allVsAll=false;if(this.showAnimationTemp){this.showAnimation=this.showAnimationTemp}this.resetLayout();this.isValidLayout()}};this.setAllVsAll=function(){if(this.graphType.match(/Scatter/)){var e=this.data.y.data[0].length;var b=1/e;this.xAxisTemp=this.xAxisTemp||this.xAxis;this.xAxis=[];this.yAxisTemp=this.yAxisTemp||this.yAxis;this.yAxis=[];this.zAxisTemp=this.zAxisTemp||this.zAxis;this.zAxis=[];this.data.l={};this.data.l.smps=[];this.data.l.weight=[];this.data.l.type=[];this.data.l.desc=[];for(var d=0;d<e;d++){for(var c=0;c<e;c++){this.data.l.weight.push(b);this.data.l.desc.push(this.data.y.desc&&this.data.y.desc[0]?this.data.y.desc[0]:"");this.data.l.type.push(this.graphType);if(d==c){this.data.l.smps.push({})}else{if(this.allVsAllType=="upper"){if(c>d){this.data.l.smps.push({xAxis:[this.data.y.smps[c]],yAxis:[this.data.y.smps[d]]})}else{this.data.l.smps.push({})}}else{if(this.allVsAllType=="lower"){if(d>c){this.data.l.smps.push({xAxis:[this.data.y.smps[c]],yAxis:[this.data.y.smps[d]]})}else{this.data.l.smps.push({})}}else{this.data.l.smps.push({xAxis:[this.data.y.smps[c]],yAxis:[this.data.y.smps[d]]})}}}}}this.layoutComb=true;this.showAnimationTemp=this.showAnimation;this.showAnimation=false;this.layout=e+"X"+e;this.isValidLayout()}};this.setMultiplePies=function(){if(this.graphType.match(/Pie/)){var g,j;var h=this.xAxis.length;if(this.layout){var d=this.layout.split(/X/i);g=parseInt(d[0]);j=parseInt(d[1]);if(g*j<h){g=Math.ceil(Math.sqrt(h));j=Math.floor(Math.sqrt(h));this.layout=g+"X"+j}}else{g=Math.ceil(Math.sqrt(h));j=Math.floor(Math.sqrt(h));this.layout=g+"X"+j}var b=1/g;var f=1/j;delete (this.layoutParams);delete (this.data.l);this.deleteSubGraphAttributes();this.data.l={};this.data.l.smps=[];this.data.l.weight=[];this.data.l.type=[];this.data.l.desc=[];for(var e=0;e<h;e++){this.data.l.smps.push([this.xAxis[e]]);this.data.l.weight.push([f,b]);this.data.l.desc.push(this.data.y.desc&&this.data.y.desc[0]?this.data.y.desc[0]:"");this.data.l.type.push(this.graphType)}this.layoutComb=true;this.showAnimationTemp=this.showAnimation;this.showAnimation=false;this.isValidLayout()}};this.ungroupSamples=function(){this.isGroupedData=false;this.groupingFactors=[];this.grpIndices=[];this.hiddenGrps=[];this.setMaxSmpStringName();return};this.createHistogram=function(d){var n,k,h,p,q;var c=0;var o=[];var b=[];var m=[];var g={};g.y={};g.y.data=[];g.y.vars=[];g.y.smps=[];if(this.graphType.match(/Scatter/)){if(this.type2D=="XYZ"){n=d=="y"?this.yAxisIndices[this.yAxisCurrent]:this.xAxisIndices[this.xAxisCurrent];o.push(n)}else{if(this.type2D=="XY"){for(var f=0;f<this.xAxisIndices.length;f++){n=d=="y"?this.yAxisIndices[f]:this.xAxisIndices[f];o.push(n)}}else{if(this.type2D=="X"){if(d=="y"){o.push(this.yAxisIndices[this.yAxisCurrent])}else{for(var f=0;f<this.xAxisIndices.length;f++){o.push(this.xAxisIndices[f])}}}else{if(d=="y"){for(var f=0;f<this.yAxisIndices.length;f++){o.push(this.yAxisIndices[f])}}else{o.push(this.xAxisIndices[this.xAxisCurrent])}}}}for(var f=0;f<this.histogramBins;f++){g.y.vars.push("Bin"+(f+1));g.y.data[f]=[]}for(var f=0;f<o.length;f++){g.y.smps.push(this.data.y.smps[o[f]]);g.y.smps.push(this.data.y.smps[o[f]]+" counts");b.push(this.data.y.smps[o[f]]);m.push(this.data.y.smps[o[f]]+" counts");var l=[];for(var e=0;e<this.histogramBins;e++){l[e]=0}k=this.getDataForSmpGrpAtIndex(o[f]);h=this.range(k);p=((h[1]-h[0])/this.histogramBins)+(h[0]/(this.histogramBins*2));for(var e=0;e<k.length;e++){q=Math.floor((k[e]-h[0])/p);l[q]++}for(var e=0;e<this.histogramBins;e++){g.y.data[e][c]=p*(e+1)}c++;for(var e=0;e<this.histogramBins;e++){g.y.data[e][c]=l[e]}c++}this.isCreateHistogram=true;this.isHistogram=true;this.histogramBarWidthStndBy=this.histogramBarWidth;this.dataStndBy=this.data;this.data={};this.resetConfig(["graphType","isHistogram"]);this.xAxis=b;this.yAxis=m;this.showLegend=false;this.histogramBarWidth=1.5;this.initializeData(g)}};this.removeHistogram=function(){this.isCreateHistogram=false;this.histogramBarWidth=this.histogramBarWidthStndBy;this.switchData()};this.addRegressionLine=function(){var c,h,e,b,j,g,d;if(this.graphType.match(/Scatter/)){if(this.type2D=="XYZ"){c=this.xAxisIndices[this.xAxisCurrent];h=this.yAxisIndices[this.yAxisCurrent];g=this.data.y.smps[c]+" vs "+this.data.y.smps[h];e=this.getDataForSmpGrpAtIndex(c);b=this.getDataForSmpGrpAtIndex(h);j=this.regression(e,b);this.addRegressionDecoration(j,g,this.foreground)}else{if(this.type2D=="XY"){for(var f=0;f<this.xAxisIndices.length;f++){d=f%this.colors.length;c=this.xAxisIndices[f];h=this.yAxisIndices[f];g=this.data.y.smps[c]+" vs "+this.data.y.smps[h];e=this.getDataForSmpGrpAtIndex(c);b=this.getDataForSmpGrpAtIndex(h);j=this.regression(e,b);this.addRegressionDecoration(j,g,this.colors[d])}}else{if(this.type2D=="X"){h=this.yAxisIndices[this.yAxisCurrent];b=this.getDataForSmpGrpAtIndex(h);for(var f=0;f<this.xAxisIndices.length;f++){d=f%this.colors.length;c=this.xAxisIndices[f];g=this.data.y.smps[c]+" vs "+this.data.y.smps[h];e=this.getDataForSmpGrpAtIndex(c);j=this.regression(e,b);this.addRegressionDecoration(j,g,this.colors[d])}}else{c=this.xAxisIndices[this.xAxisCurrent];e=this.getDataForSmpGrpAtIndex(c);for(var f=0;f<this.yAxisIndices.length;f++){d=f%this.colors.length;h=this.yAxisIndices[f];b=this.getDataForSmpGrpAtIndex(h);g=this.data.y.smps[c]+" vs "+this.data.y.smps[h];j=this.regression(e,b);this.addRegressionDecoration(j,g,this.colors[d])}}}}}};this.addRegressionDecoration=function(d,c,b){this.showDecorations=true;if(!this.data.d){this.data.d={}}if(!this.data.d.reg){this.data.d.reg=[]}this.data.d.reg.push({slope:d[0],intercept:d[1],cor:d[2],label:c,color:b})};this.addNormalDistributionLine=function(c){var o,g,m,h,j,k,l,f,d,f,b,n;if(this.graphType.match(/Scatter/)){if(this.type2D=="XYZ"){m=c=="y"?this.yAxisIndices[this.yAxisCurrent]:this.xAxisIndices[this.xAxisCurrent];h=c=="y"?this.xAxisIndices[this.xAxisCurrent]:this.yAxisIndices[this.yAxisCurrent];j=this.getDataForSmpGrpAtIndex(m);k=this.getDataForSmpGrpAtIndex(h);l=this.max(k);f=this.data.y.smps[m];d=this.meanStandardDeviationN(j);this.addNormalDistributionDecoration(d,l,f,this.foreground,c)}else{o=c=="y"?this.yAxisIndices:this.xAxisIndices;g=c=="y"?this.xAxisIndices:this.yAxisIndices;n=c=="y"?this.xAxisCurrent:this.yAxisCurrent;for(var e=0;e<o.length;e++){b=e%this.colors.length;m=o[e];h=g[e]?g[e]:g[n];j=this.getDataForSmpGrpAtIndex(m);k=this.getDataForSmpGrpAtIndex(h);l=this.max(k);f=this.data.y.smps[m];d=this.meanStandardDeviationN(j);this.addNormalDistributionDecoration(d,l,f,this.colors[b],c)}}}};this.addNormalDistributionDecoration=function(f,b,d,c,e){this.showDecorations=true;if(!this.data.d){this.data.d={}}if(!this.data.d.nor){this.data.d.nor=[]}if(e&&e=="y"){this.data.d.nor.push({mu:f[0],sigma:f[1],yAxis:true,max:b,label:d,color:c})}else{this.data.d.nor.push({mu:f[0],sigma:f[1],max:b,label:d,color:c})}};this.createRandomData=function(){var e={};e.y={};e.y.data=[];e.y.vars=[];e.y.smps=[];for(var c=0;c<this.randomDataSamples;c++){e.y.smps[c]="Sample"+(c+1)}for(var c=0;c<this.randomDataVariables;c++){e.y.data[c]=[];e.y.vars[c]="Variable"+(c+1);for(var b=0;b<this.randomDataSamples;b++){e.y.data[c].push(Math.floor(((Math.random()*2-1)+(Math.random()*2-1)+(Math.random()*2-1))*this.randomDataSigma+this.randomDataMean))}}e.x={};var d=Math.floor(this.randomDataSamples/this.randomDataSampleAnnotationRatio);for(var c=0;c<this.randomDataSampleAnnotations;c++){e.x["Factor"+(c+1)]=[];for(var b=0;b<this.randomDataSamples;b++){e.x["Factor"+(c+1)][b]="Level"+(Math.floor(Math.random()*d)+1)}}e.z={};var d=Math.floor(this.randomDataVariables/this.randomDataVariableAnnotationRatio);for(var c=0;c<this.randomDataVariableAnnotations;c++){e.z["Annt"+(c+1)]=[];for(var b=0;b<this.randomDataVariables;b++){e.z["Annt"+(c+1)][b]="Desc"+(Math.floor(Math.random()*d)+1)}}if(this.data&&!this.dataStndBy){this.dataStndBy=this.data;this.data={}}this.resetConfig(["graphType"]);this.initializeData(e);this.draw()};this.restoreRandomData=function(){this.switchData()};this.groupSamples=function(e,p){if(e.length<1){return this.ungroupSamples()}for(var h=0;h<e.length;h++){if(!e||!this.data.x[e[h]]){return this.ungroupSamples()}}if(this.layoutComb&&this.data.l.comp){this.varIndices=[];for(var h=0;h<this.data.l.comp.length;h++){for(var g=0;g<this.data.l.comp[h].length;g++){this.varIndices.push(this.data.l.comp[h][g])}}}this.resetIndices();this.isGroupedData=true;this.groupingFactors=e;this.resetObject(true);this.hiddenGrps=[];var v={};var b=[];var d=0;for(var h=0;h<this.smpIndices.length;h++){var r=this.smpIndices[h];var u=[];var q;for(var g=0;g<e.length;g++){var l=e[g];q=this.data.x[l][r];if(!q){q="NA"}u.push(q)}q=u.join(" - ");if(!v.hasOwnProperty(q)){this.data.w.smps.push(q);b[d]=q;v[q]=[];v[q].push(r);d++}else{v[q].push(r)}}for(var h=0;h<b.length;h++){var q=b[h];this.data.w.grps.push(v[q])}this.grpIndices=[];for(var h=0;h<this.data.w.grps.length;h++){this.grpIndices.push(h);this.hiddenGrps.push(false)}for(var h=0;h<this.varIndices.length;h++){this.data.w.vars.push(this.data.y.vars[this.varIndices[h]])}var m=[];if(p){if(this.isArray(p)){m=p}else{m.push(p)}}else{p=this.graphType=="Boxplot"?"iqr":"mean";m.push(p)}for(var s=0;s<m.length;s++){var o=[];var n=m[s];if(this.isTransformedData){a=this.data.y.trans}else{if(this.isRawData){a=this.data.y.data}else{if(this.summaryType=="median"||this.summaryType=="iqr"){a=this.data.y.median}else{if(this.summaryType=="mean"){a=this.data.y.mean}else{if(this.summaryType=="cor"){a=this.data.y.cor}else{if(this.summaryType=="sum"){a=this.data.y.sum}else{a=this.data.y[this.summaryType]}}}}}}for(var h=0;h<this.varIndices.length;h++){var r=this.varIndices[h];o[r]=[];for(var g=0;g<this.data.w.grps.length;g++){o[r][g]=[];for(var f=0;f<this.data.w.grps[g].length;f++){var c=this.data.w.grps[g][f];o[r][g].push(a[r][c])}}}this.summarize(n,o)}this.setMaxVarStringName();this.setMaxSmpStringName();this.xAxisValues=[];this.xAxis2Values=[];this.yAxisValues=[];this.zAxisValues=[];if(!this.layoutComb||!this.layoutAdjust){if(typeof(this.setAxes)=="function"){this.setAxes()}}this.draw()};this.initializeDataAttributes=function(){this.setIndices();if(this.graphType!="Network"&&this.graphType!="Genome"&&this.graphType!="Venn"){this.setMaxVarStringAttr();this.setMaxSmpStringAttr()}};this.initializeData=function(b){if(a&&!b){this.isExample=false;this.data=a;delete a}else{if(b){this.isExample=false;this.data=b;delete b}else{if(!this.remoteService){this.isExample=true}this.data=this.exampleRawData}}this.validGraphTypes=[];if(this.data.y||this.data.venn||this.data.nodes||this.data.tracks||this.data.market||this.data.fx){if(this.data.fx){this.FunctionData()}if(this.data.market){this.setMarketData();this.summaryType="candle";this.validGraphTypes.push("Candlestick")}if(this.data.venn){this.summaryType="venn";this.validGraphTypes.push("Venn")}if(this.data.nodes){this.summaryType="network";this.validGraphTypes.push("Network")}if(this.data.tracks){this.summaryType="genome";this.validGraphTypes.push("Genome")}if(this.data.y){if(!this.data.y.data&&!this.data.y.mean&&!this.data.y.median&&!this.data.y.cor&&!this.data.y.sum&&!this.data.y.close){alert("Dude! there is not a valid data structure");return}else{if(this.data.y.data){this.isRawData=true;this.summaryType="raw"}else{this.isRawData=false;if(this.data.y.iqr1&&this.data.y.qtl1&&this.data.y.median&&this.data.y.qtl3&&this.data.y.iqr3){this.summaryType="iqr"}else{if(this.data.y.median){this.summaryType="median"}else{if(this.data.y.mean){this.summaryType="mean"}else{if(this.data.y.cor){this.summaryType="cor"}else{if(this.data.y.sum){this.summaryType="sum"}}}}}}}this.validGraphTypes.push("Bar");this.validGraphTypes.push("Line");this.validGraphTypes.push("Area");this.validGraphTypes.push("AreaLine");this.validGraphTypes.push("BarLine");this.validGraphTypes.push("Boxplot");this.validGraphTypes.push("Dotplot");this.validGraphTypes.push("Heatmap");this.validGraphTypes.push("Stacked");this.validGraphTypes.push("StackedLine");this.validGraphTypes.push("StackedPercent");this.validGraphTypes.push("StackedPercentLine");this.validGraphTypes.push("Pie");this.validGraphTypes.push("Correlation");if(this.data.y.smps){if(this.data.y.smps.length>2){this.validGraphTypes.push("Scatter2D");this.validGraphTypes.push("ScatterBubble2D");this.validGraphTypes.push("Scatter3D")}else{if(this.data.y.smps.length>1){this.validGraphTypes.push("Scatter2D")}}}}this.validGraphTypes.sort()}this.initializeDataAttributes()};this.setMarketTechnicalData=function(){if(this.stockIndicators.length>0){var c={};var h=false;var l={Sma5:5,Sma10:10,Sma20:20,Sma25:25,Sma50:50};var b=[];for(var g=0;g<this.stockIndicators.length;g++){if(l.hasOwnProperty(this.stockIndicators[g])){b.push(this.stockIndicators[g])}}if(b.length>0){this.stockIndicators=b;var m={};for(var g=0;g<this.stockIndicators.length;g++){var o=this.stockIndicators[g];if(l.hasOwnProperty(o)&&!this.data.y.hasOwnProperty(o)){c[o]=true;h=true;m[o]=[];this.data.y[o]=[];for(var f=0;f<this.data.y.vars.length;f++){m[o][f]=[];this.data.y[o][f]=[]}}}if(h){for(var g=0;g<this.data.y.smps.length;g++){for(var f=0;f<this.data.y.vars.length;f++){for(var d=0;d<this.stockIndicators.length;d++){var o=this.stockIndicators[d];if(c.hasOwnProperty(o)){if(!isNaN(this.data.y.close[f][g])){m[o][f].push(this.data.y.close[f][g]);if(m[o][f].length==l[o]){if(o.match(/Sma/)){this.data.y[o][f][g]=this.mean(m[o][f]);m[o][f].shift()}}}}}}}}}}};this.setMarketData=function(){if(this.data.market&&!this.isMarketDataFormated){var c=this.data.market;this.data.market={};this.data.market.smps=[];this.data.market.vars=[];this.data.market.close=[];this.data.market.open=[];this.data.market.high=[];this.data.market.low=[];this.data.market.volume=[];this.data.market.desc=["Price","Vol"];var k={};var g=0;for(var f=0;f<c.length;f++){this.data.market.vars.push(c[f].symbol);this.data.market.close[f]=[];this.data.market.open[f]=[];this.data.market.high[f]=[];this.data.market.low[f]=[];this.data.market.volume[f]=[];var h=c[f].data;for(var e=h.length-1;e>=0;e--){var l=this.parseDate(h[e][0]);var b=0;if(!k.hasOwnProperty(l)){b=g;k[l]=g;this.data.market.smps.push(l);g++}else{b=k[l]}this.data.market.open[f][b]=h[e][1];this.data.market.high[f][b]=h[e][2];this.data.market.low[f][b]=h[e][3];this.data.market.close[f][b]=h[e][4];this.data.market.volume[f][b]=h[e][5]}}}this.isMarketDataFormated=true};this.switchToMarketData=function(){var b=this.data.market;this.dataStndBy=this.data;this.data={};this.data.y=b;this.initializeDataAttributes();if(this.showVolume){this.deleteSubGraphAttributes();this.data.l={};this.data.l.vars=[this.data.y.vars,this.data.y.vars];this.data.l.weight=this.graphOrientation=="vertical"?[0.75,0.25]:[0.25,0.75];this.data.l.type=["Candlestick","Candlestick"];this.data.l.name=this.graphOrientation=="vertical"?["Price","Volume"]:["Volume","Price"];this.data.l.desc=this.graphOrientation=="vertical"?["Price","Volume"]:["Volume","Price"];this.segregateSamplesBy=false;this.segregateVariablesBy=false;this.layoutComb=true;this.layout="1X2";this.isValidLayout()}};this.switchFromMarketData=function(){this.switchData();if(this.showVolume){this.resetLayout();this.isValidLayout()}};this.switchData=function(){if(this.dataStndBy){this.initConfig();this.data=this.dataStndBy;this.initializeData(this.data)}};this.initializeData()};CanvasXpress.prototype.initRemote=function(){this.ajaxRequest=function(url,callback,format,method){format=format=="json"?"json":"text";method=method=="POST"?"POST":"GET";var http=false;if(window.XMLHttpRequest){try{http=new XMLHttpRequest()}catch(e){http=false}}else{if(typeof ActiveXObject!="undefined"){try{http=new ActiveXObject("Msxml2.XMLHTTP")}catch(e){try{http=new ActiveXObject("Microsoft.XMLHTTP")}catch(E){http=false}}}}if(http&&url&&callback){var now="uid="+new Date().getTime();url+=(url.indexOf("?")+1)?"&":"?";url+=now;http.open(method,url,true);if(method=="GET"){if(http.overrideMimeType){http.overrideMimeType("text/xml")}}else{var parameters=false;var parts=url.split("?");url=parts[0];parameters=parts[1];http.setRequestHeader("Content-type","application/x-www-form-urlencoded");http.setRequestHeader("Content-length",parameters.length);http.setRequestHeader("Connection","close")}http.onreadystatechange=function(){if(http.readyState==4){if(http.status==200){var result="";if(http.responseText){result=http.responseText}if(format=="json"){result=result.replace(/[\n\r]/g,"");result=eval("("+result+")")}if(callback){callback(result)}}else{if(error){error(http.status)}}}};http.send(parameters)}};this.requestRemoteData=function(ini){var params="index="+this.remoteDataIndex+"&dir="+this.remoteDirection;for(var p in this.remoteParams){params+="&"+p+"="+this.remoteParams[p]}if(ini){params+="&records=true"}var url=this.remoteService+"?"+params;this.ajaxRequest(url,this.updateRemoteData,"json","GET")};this.castRemoteParameters=function(o){o.remoteService=this.remoteService;o.remoteDirection=this.remoteDirection;o.remoteDataIndex=this.remoteDataIndex;o.remoteWindow=this.remoteWindow;o.remoteAutoPlay=this.remoteAutoPlay;o.remoteAutoPlayDelay=this.remoteAutoPlayDelay;for(var p in this.remoteParams){o.remoteParams[p]=this.remoteParams[p]}o.addRemoveNavigationTopListeners("addEvtListener");o.addRemoveNavigationLeftRightListeners("addEvtListener")};this.updateRemoteData=function(t){return function(res){if(res&&res.data){var d=t.appendUserConfig(res.data);var a=t.remoteDirection=="next"?true:false;var w=document.getElementById("wrapper-"+t.target);if(w){var p=w.parentNode;var r=w.getClientRects();var o=document.getElementById(t.target);var l=t.target;t.insertTarget(d.renderTo,w,o.width,o.height,a);d.hidden=true;var n=new CanvasXpress(d);t.castRemoteParameters(n);t.addSelectOptionsRemoteData(p,res.ids);t.updateSelectOptionsRemoteData(p);t.resetInfoSpan(false,true);t.animateTransition(p,r[0],l);if(t.Ext){if(!n.Ext){n.Ext={canvasId:d.renderTo,canvas:n}}}if(res.postprocess){for(var i=0;i<res.postprocess.length;i++){var fn=res.postprocess[i].func;var pr=res.postprocess[i].param;if(fn){if(pr){n[fn].apply(n,pr)}else{n[fn]()}}}}if(res.info){n.updateInfoDiv(res.info);n.showInfoDiv()}if(t.showCode){n.updateCodeDiv()}}}else{t.remoteDataIndex=t.remoteDirection=="next"?t.remoteDataIndex-1:t.remoteDataIndex+1;t.remoteUpdating=false}}}(this);this.appendUserConfig=function(d){for(var i in this.userConfig){if(!i.match(/decrease|remote/)){if(!d.config[i]){d.config[i]=this.userConfig[i]}}}return d};this.addSelectOptionsRemoteData=function(p,ids){if(ids){var s=p.parentNode.firstChild.lastChild;for(var i=0;i<ids.length;i++){var opt=document.createElement("option");opt.text=ids[i];opt.value=i;if(this.remoteDataIndex==i){opt.selected="selected"}try{s.add(opt,null)}catch(ex){s.add(opt)}}if(ids.length==1){this.hideNavigation()}else{this.showNavigation()}}};this.updateSelectOptionsRemoteData=function(p){var s=p.parentNode.firstChild.lastChild;if(s){s.selectedIndex=this.remoteDataIndex}};this.animateTransition=function(b,r,o){if(b&&r){var that=this;var step=15;var s=0;var c1=b.firstChild;var c2=b.lastChild;var w=r.width;var h=r.height;b.parentNode.style.overflow="hidden";if(this.isIE){if(this.remoteDirection=="next"){b.removeChild(c1)}else{b.removeChild(c2)}b.style.overflow="auto";b.parentNode.style.overflow="visible";this.remoteUpdating=false}else{var updater=function(){this.update=function(){var n=Math.atan((s/step)*10-5)*0.5/Math.atan(5)+0.5;var l=w*n;if(s>=step){clearInterval(clearUpdateInt);that.destroy(o);if(that.remoteDirection=="next"){c2.style.left=0+"px"}else{c1.style.left=0+"px"}b.style.overflow="auto";b.parentNode.style.overflow="visible";that.remoteUpdating=false}else{if(that.remoteDirection=="next"){c1.style.left=(l*-1)+"px";c2.style.left=(l*-1)+"px"}else{c1.style.left=(-w+l)+"px";c2.style.left=(-w+l)+"px"}c1.style.display="block";c2.style.display="block"}s++};var clearUpdateInt=setInterval(this.update,100)};updater.call()}}};this.handleRemoteSelect=function(t){return function(e){var i=t.isIE?e.srcElement.selectedIndex:e.target.selectedIndex;t.remoteDirection=i>t.remoteDataIndex?"next":"previous";t.remoteDataIndex=i;t.requestRemoteData()}}(this);this.handleRemoteClickStop=function(t){return function(e){t.remoteStop=true}}(this);this.handleRemoteClickPlay=function(t){return function(e){var s=t.isIE?e.srcElement.parentNode.lastChild:e.target.parentNode.lastChild;t.remoteDirection="next";t.remoteStop=false;t.playRemoteData(s)}}(this);this.playRemoteData=function(s){var updater=function(){that=CanvasXpress.references[0];if(that){if(!that.remoteUpdating&&!that.remoteStop){that.remoteUpdating=true;that.showInfoSpan(false,"Updating ...",true);if(s&&s.tagName.match(/select/i)&&that.remoteDataIndex>=s.length-1){that.remoteDataIndex=0}else{that.remoteDataIndex++}that.requestRemoteData()}}this.update=function(){that=CanvasXpress.references[0];if(that){if(!that.remoteUpdating&&!that.remoteStop){that.remoteUpdating=true;that.showInfoSpan(false,"Updating ...",true);if(s&&s.tagName.match(/select/i)&&that.remoteDataIndex>=s.length-1){that.remoteDataIndex=0}else{that.remoteDataIndex++}that.requestRemoteData()}if(that.remoteStop){clearInterval(cl)}}else{clearInterval(cl)}};var cl=setInterval(this.update,that.remoteAutoPlayDelay)};updater.call()};this.handleRemoteClickPrev=function(t){return function(e){if(!t.remoteUpdating){var s=t.isIE?e.srcElement.parentNode.lastChild:e.target.parentNode.lastChild;t.remoteUpdating=true;t.showInfoSpan(false,"Updating ...",true);t.remoteDirection="previous";if(s&&s.tagName.match(/select/i)&&t.remoteDataIndex<=0){t.remoteDataIndex=s.length-1}else{t.remoteDataIndex--}t.requestRemoteData()}}}(this);this.handleRemoteClickNext=function(t){return function(e){if(!t.remoteUpdating){var s=t.isIE?e.srcElement.parentNode.lastChild:e.target.parentNode.lastChild;t.remoteUpdating=true;t.showInfoSpan(false,"Updating ...",true);t.remoteDirection="next";if(s&&s.tagName.match(/select/i)&&t.remoteDataIndex>=s.length-1){t.remoteDataIndex=0}else{t.remoteDataIndex++}t.requestRemoteData()}}}(this);this.addRemoteNavigationTop=function(w){var m="3px";var n=document.createElement("div");n.id="canvasXpressRemoteWindowTopBar";n.style.position="absolute";n.style.marginLeft=w+"px";n.style.display="none";var r=document.createElement("img");r.id="canvasXpressRemoteWindowTopBarPrev";r.src=this.imageDir+this.previousButton;r.style.margin=m;n.appendChild(r);var p=document.createElement("img");p.id="canvasXpressRemoteWindowTopBarPlay";p.src=this.imageDir+this.playButton;p.style.margin=m;n.appendChild(p);var e=document.createElement("img");e.id="canvasXpressRemoteWindowTopBarStop";e.src=this.imageDir+this.stopButton;e.style.margin=m;n.appendChild(e);var f=document.createElement("img");f.id="canvasXpressRemoteWindowTopBarNext";f.src=this.imageDir+this.nextButton;f.style.margin=m;n.appendChild(f);var s=document.createElement("select");s.id="canvasXpressRemoteWindowTopBarSelect";s.style.position="absolute";s.style.fontSize="x-small";s.style.color=this.skinColor;s.style.backgroundColor=this.skinBackgroundColor;s.style.border="1px solid "+this.skinBorderColor;s.style.height="18px";s.style.marginTop="1px";n.appendChild(s);return n};this.addRemoveNavigationTopListeners=function(t){var r=document.getElementById("canvasXpressRemoteWindowTopBarPrev");var p=document.getElementById("canvasXpressRemoteWindowTopBarPlay");var e=document.getElementById("canvasXpressRemoteWindowTopBarStop");var f=document.getElementById("canvasXpressRemoteWindowTopBarNext");var s=document.getElementById("canvasXpressRemoteWindowTopBarSelect");if(r){this[t](r,"click",this.handleRemoteClickPrev,false)}if(p){this[t](p,"click",this.handleRemoteClickPlay,false)}if(e){this[t](e,"click",this.handleRemoteClickStop,false)}if(f){this[t](f,"click",this.handleRemoteClickNext,false)}if(s){this[t](s,"change",this.handleRemoteSelect,false)}};this.addRemoteNavigationBottom=function(w){var n=document.createElement("div");n.id="canvasXpressRemoteWindowBottomBar";n.style.position="absolute";n.style.marginLeft=w+"px";n.style.display="none";n.style.height="18px";return n};this.addRemoteNavigationLeftRight=function(d,w,h,m,q){var n=document.createElement("div");var i=document.createElement("img");n.style.height=(h+q)+"px";n.style.width=m+"px";n.style.top="0px";i.style.position="absolute";i.style.top=(h/2)+"px";i.style.left="1px";if(d=="l"){n.style.position="relative";n.id="canvasXpressRemoteWindowPrevBar";n.style.left="0px";n.style.display="none";i.src=this.imageDir+this.previousButton}else{n.style.position="absolute";n.id="canvasXpressRemoteWindowNextBar";n.style.left=(m+w)+"px";n.style.display="none";i.src=this.imageDir+this.nextButton}i.style.margin="auto";n.appendChild(i);return n};this.addRemoveNavigationLeftRightListeners=function(t){var p=document.getElementById("canvasXpressRemoteWindowPrevBar");var n=document.getElementById("canvasXpressRemoteWindowNextBar");if(p){this[t](p,"click",this.handleRemoteClickPrev,false)}if(n){this[t](n,"click",this.handleRemoteClickNext,false)}};this.updateRemoteNavigationWindow=function(){var c=document.getElementById(this.target);var x=18;var y=20;var l=document.getElementById("canvasXpressRemoteWindowPrevBar");var r=document.getElementById("canvasXpressRemoteWindowNextBar");var w=document.getElementById("canvasXpressRemoteWindow");var b=document.getElementById("canvasXpressRemoteWindowBuffer");if(l&&r&&w&&b){var il=l.childNodes[0];l.style.left="0px";l.style.height=(c.height+y)+"px";il.style.top=(c.height/2)+"px";var ir=r.childNodes[0];r.style.left=(c.width+x)+"px";r.style.height=(c.height+y)+"px";ir.style.top=(c.height/2)+"px";w.style.height=((y*2)+c.height)+"px";w.style.width=((x*2)+c.width)+"px";b.style.height=c.height+"px";b.style.width=(c.width*2)+"px";b.style.left=x+"px";b.style.top=y+"px";var p=w.parentNode;while(p){if(p.style.height&&parseInt(p.style.height)<(y*2)+c.height){p.style.height=w.style.height}else{if(p.style.height&&parseInt(p.style.height)>=(y*2)+c.height){p=false}}if(p&&p.parentNode){p=p.parentNode}else{p=false}}}};this.addRemoteWindow=function(){var w=document.getElementById("wrapper-"+this.target);var c=document.getElementById(this.target);var p=w.parentNode;var x=18;var y=20;if(p.id&&!p.id.match(/canvasXpressRemoteWindow/)){var d=document.createElement("div");var t=this.addRemoteNavigationTop(x);var l=this.addRemoteNavigationLeftRight("l",c.width,c.height,x,y);var v=document.createElement("div");var r=this.addRemoteNavigationLeftRight("r",c.width,c.height,x,y);var b=this.addRemoteNavigationBottom(x);d.id="canvasXpressRemoteWindow";d.style.height=(y+c.height)+"px";d.style.width=((x*2)+c.width)+"px";d.style.position="relative";v.id="canvasXpressRemoteWindowBuffer";v.style.height=c.height+"px";v.style.width=(c.width*2)+"px";v.style.position="absolute";v.style.left=x+"px";v.style.top=y+"px";v.style.overflow="hidden";d.appendChild(t);d.appendChild(l);d.appendChild(v);d.appendChild(r);d.appendChild(b);p.insertBefore(d,w);v.appendChild(w.parentNode.appendChild(w));this.addRemoveNavigationTopListeners("addEvtListener");this.addRemoveNavigationLeftRightListeners("addEvtListener");this.requestRemoteData(true);this.initialRemoteDataRequest=true;if(this.remoteAutoPlay){this.remoteUpdating=true;this.remoteDirection="next";this.remoteStop=false;this.playRemoteData(t.lastChild)}}else{this.initialRemoteDataRequest=false}};this.hideNavigation=function(){var t=document.getElementById("canvasXpressRemoteWindowTopBar");var p=document.getElementById("canvasXpressRemoteWindowPrevBar");var n=document.getElementById("canvasXpressRemoteWindowNextBar");var b=document.getElementById("canvasXpressRemoteWindowBottomBar");if(t){t.style.display="none"}if(p){p.style.display="none"}if(n){n.style.display="none"}if(b){b.style.display="none"}};this.showNavigation=function(){var t=document.getElementById("canvasXpressRemoteWindowTopBar");var p=document.getElementById("canvasXpressRemoteWindowPrevBar");var n=document.getElementById("canvasXpressRemoteWindowNextBar");var b=document.getElementById("canvasXpressRemoteWindowBottomBar");if(t){t.style.display="block"}if(p){p.style.display="block"}if(n){n.style.display="block"}if(b){b.style.display="block"}};this.initializeRemote=function(){if(this.remoteService){this.addRemoteWindow()}};this.initializeRemote()};CanvasXpress.prototype.FunctionData=function(){this.implied=function(a){if(a=="neg"){return false}return/^(\d+\.\d+|\d+\.?|\.\d+)(e[-+]?\d+)?|\w+$/.test(a)};this.tokenize=function(f){var b;var a=[];var d=new String("");var c=/(\d+\.\d+|\d+\.?|\.\d+)(e[-+]?\d+)?|[xy]|[a-z]+|[-+*\/(),^]|<=?|>=?|==|!=|&&|\|\|/g;f=f.toLowerCase();f=f.replace(/\s/g,"");f=f.replace(/\+\+/g,"+");f=f.replace(/\+-/g,"-");f=f.replace(/-\+/g,"-");f=f.replace(/--/g,"+");f=f.replace(/^\+/,"");f=f.replace(/([(*\/&\|<>=])\+/g,"$1");f=f.replace(/^-/,"neg ");f=f.replace(/([(*\/&\|<>=])-/g,"$1neg ");f=f.replace(/\)(\(|\w)/g,")*$1");f=f.replace(/(\d)\(/g,"$1*(");while(b=c.exec(f)){if(this.implied(d)&&this.implied(b[0].toString())){a.push("*")}a.push(d=b[0])}return a};this.isValidEnd=function(a){return/^(\d+\.\d+|\d+\.?|\.\d+)(e[-+]?\d+)?|[)xye]|pi|rand$/.test(a)};this.toPostFx=function(d){var b=new String();var c=new String("");var a=new Array();var e=new Array();while(b=d.shift()){if(b=="("){a.push(b)}else{if(this.precedence[b]){while(a.length&&a[a.length-1]!="("&&this.precedence[a[a.length-1]]>=this.precedence[b]){e.push(a.pop())}if(b==","&&!this.isValidEnd(c)){e.push("Unexpected: "+c)}if(b!=","){a.push(b)}}else{if(b==")"){if(!this.isValidEnd(c)){e.push("Unexpected: "+c)}while(a.length&&a[a.length-1]!="("){e.push(a.pop())}if(a.length==0){e.push("Unmatched: )")}a.pop()}else{if(/^[-+]?(\d+\.?|\d*\.\d+)(e[-+]?\d+)?$/.test(b)){e.push(b)}else{e.push("Unknown: "+b)}}}}c=b}if(!this.isValidEnd(c)){e.push("Unexpected: "+c)}while(b=a.pop()){if(b=="("){e.push("Unmatched: (")}e.push(b)}return e};this.syntaxCheck=function(d){var a=new Number(0);var c=new String();for(var b=0;b<d.length;b++,a++){if(/^Un(matched|known|expected).*/.test(c=d[b])){return c}if(this.expects[c]){if(a<this.expects[c]){return"Invalid use of: "+c}a-=this.expects[c]}}return a==1?false:(d.length?"Unused arguments":"No function")};this.evaluate=function(e,b,f){var a=new Array();var d=new String();for(var c=0;c<e.length;c++){d=e[c];if(d=="x"){a.push(b)}else{if(d=="y"){a.push(f)}else{if(d=="pi"){a.push(Math.PI)}else{if(d=="e"){a.push(Math.E)}else{if(d=="rand"){a.push(Math.random())}else{if(this[this.alias[d]||d]){a.push(this[this.alias[d]||d](a.pop(),this[this.alias[d]||d].length>1?a.pop():0))}else{a.push(d)}}}}}}if(isNaN(a[a.length-1])){return Number.NaN}}return parseFloat(a.pop())};this.set2DPlot=function(j,g){var k={vars:[],smps:["X","Y"],data:[]};var f=this.setMinX?this.setMinX:(0-1);var b=this.setMaxX?this.setMaxX:(1-0);var e=this.setMinY?this.setMinY:(0-1);var a=this.setMaxY?this.setMaxY:(1-0);var p=(b-f)/this.functionIntervals;var o=(a-e)/this.functionIntervals;var c=1;if(g==1){var m=f;for(var h=0;h<this.functionIntervals;h++){var l=this.evaluate(j,m,0);if(isNaN(l)){l=""}m+=p;k.vars.push("v"+c);k.data.push([m,l]);c++}}else{var l=e;for(var h=0;h<this.functionIntervals;h++){var m=this.evaluate(j,0,l);if(isNaN(m)){m=""}l+=o;k.vars.push("v"+c);k.data.push([m,l]);c++}}return k};this.set3DPlot=function(k){var l={vars:[],smps:["X","Y","Z"],data:[]};var f=this.setMinX?this.setMinX:-Math.PI/2;var b=this.setMaxX?this.setMaxX:Math.PI/2;var e=this.setMinY?this.setMinY:-Math.PI/2;var a=this.setMaxY?this.setMaxY:Math.PI/2;var q=this.width<=180?20:this.width<=600?30:40;var c=1;for(var h=0;h<=q;h++){var o=e+(a-e)*h/q;for(var g=0;g<=q;g++){var p=f+(b-f)*g/q;var m=this.evaluate(k,p,o);if(!isFinite(m)){m=0}l.vars.push("v"+c);l.data.push([p,m,o]);c++}}return l};this.initializeFunctionData=function(){var e=this.toPostFx(this.tokenize(this.data.fx));var c=this.syntaxCheck(e);if(c){alert(c);return}var a=0;for(var b in e){if(e[b]=="x"){a|=1}else{if(e[b]=="y"){a|=2}}}var d;if(a==0){a=1}if(a==3){this.data.y=this.set3DPlot(e);this.graphType="Scatter3D";this.colorBy="Y"}else{this.data.y=this.set2DPlot(e,a);this.graphType="Scatter2D";this.lineType="spline"}this.scatterType="function"};this.initializeFunctionData()};CanvasXpress.prototype.initGraph=function(){this.draw=function(b,d,a,c){this.setUserEvents();this.initializeGraph(true,b,d,a,c)};this.isValidGraphType=function(a){switch(a){case"Bar":case"Line":case"Area":case"AreaLine":case"Dotplot":case"Heatmap":case"Stacked":case"StackedPercent":case"Boxplot":case"Correlation":case"Pie":if(this.data.y){return true}else{return false}case"BarLine":case"StackedLine":case"StackedPercentLine":if(this.data.y&&this.data.a&&this.data.a.xAxis&&this.data.a.xAxis2){return true}else{return false}case"Scatter2D":if(this.data.y&&this.data.y.smps&&this.data.y.smps.length>1){return true}else{return false}case"ScatterBubble2D":case"Scatter3D":if(this.data.y&&this.data.y.smps&&this.data.y.smps.length>2){return true}else{return false}case"Candlestick":if(this.data.market){return true}else{return false}case"Venn":if(this.data.venn){return true}else{return false}case"Network":if(this.data.nodes){return true}else{return false}case"Genome":if(this.data.tracks){return true}else{return false}}return false};this.setColorScheme=function(){switch(this.colorScheme){case"basic":this.colors=this.colors0;break;case"dark":this.colors=this.colors1;break;case"strong":this.colors=this.colors2;break;case"light":this.colors=this.colors3;break;case"pastel":this.colors=this.colors4;break;case"user":this.colors=this.colors;break}};this.reinitializeGraph=function(){if(this.graphType=="Candlestick"){this.isGraphTime=true;if(!this.isMarketSwitched){this.switchToMarketData();this.initAxes();this.summaryType="candle";this.initializeDataAttributes();this.isMarketSwitched=true}this.setMarketTechnicalData()}else{if(this.isExample&&this.isMarketSwitched){this.switchFromMarketData();this.isMarketSwitched=false;this.summaryType=this.data.y.data?"raw":"mean";this.initializeDataAttributes();this.isGraphTime=false;if(this.showVolume){this.layoutComb=false}}else{if(this.graphType.match(/Scatter/)&&this.allVsAll){this.setAllVsAll()}else{if(this.graphType.match(/Pie/)&&this.xAxis.length>1){this.setMultiplePies()}}}}};this.initializeGraph=function(m,a,l,g,b){var d=this;var h=5;var k=0;var e=[];var j=function(){for(var n=0;n<e.length;n++){if(!CanvasXpress.cacheImages.hasOwnProperty(e[n])){return false}}return true};if(this.graphType=="Network"){e=this.getNetworkImages()}else{if(this.graphType.match(/scatter/i)){for(var c=0;c<this.images.length;c++){if(!this.images[c].match(/^http:\/\//)){this.images[c]=this.imageDir+this.images[c]}e.push(this.images[c])}}}if(this.backgroundImage){if(!this.backgroundImage.match(/^http:\/\//)){this.backgroundImage=this.imageDir+this.backgroundImage}e.push(this.backgroundImage)}if(e.length>0&&!j()){for(var c=0;c<e.length;c++){if(!CanvasXpress.cacheImages.hasOwnProperty(e[c])){CanvasXpress.cacheImages[e[c]]=true;var f=new Image;f.onload=function(){CanvasXpress.cacheImages[this.src]=this;if(k<(h*e.length)){if(j()){d.renderGraph(m,a,l,g,b)}else{k++}}else{alert("Problem loading images")}};f.src=e[c]}}}else{this.renderGraph(m,a,l,g,b)}};this.renderGraph=function(g,d,a,c,f){if(this.initialRemoteDataRequest){return}this.setColorScheme();this.reinitializeGraph();if((!this.layoutComb||!this.layoutAdjust)&&!c){if(this.graphType!="Candlestick"||(this.graphType=="Candlestick"&&!this.showVolume)){this.initAxes(g)}}if(g){this.resizeCanvas(true,d,a)}else{this.resizeCanvas(false,d,a)}if(this.isVML){this.showShadow=false}if(this.isValidAnimation()&&this.showAnimation&&!this.isAnimation){this.createAnimation(this.animationType)}else{var e=this.layoutComb?true:false;switch(this.graphType){case"Bar":case"Line":case"Area":case"AreaLine":case"BarLine":case"Dotplot":case"Heatmap":case"Stacked":case"StackedLine":case"StackedPercent":case"StackedPercentLine":case"Candlestick":if(this.isBoxPlotCalc&&this.isGroupedData){this.groupSamples(this.getGroupingFactors(true))}this.oneDPlot();break;case"Boxplot":if(!this.isBoxPlotCalc&&this.isGroupedData){this.groupSamples(this.getGroupingFactors(true))}this.oneDPlot();break;case"Scatter2D":case"ScatterBubble2D":this.Scatter2D();break;case"Scatter3D":this.Scatter3D();break;case"Correlation":this.Correlation();break;case"Venn":this.Venn();break;case"Pie":this.Pie();break;case"Network":if(f){var b=this.calculateLayout;var e=this.randomNetwork;this.calculateLayout=false;this.randomNetwork=false;this.Network();this.calculateLayout=b;this.randomNetwork=e}else{this.Network()}break;case"Genome":this.Genome();break}this.resizeImage(e);this.drawCanvasBox();if(this.showCode){this.updateCodeDiv()}if(this.showDataTable){this.updateDataTable()}else{this.hideUnhideDataTable(true)}if(this.graphType!="Network"){this.drawCitation()}}};this.initializeGraph()};CanvasXpress.prototype.initAxes=function(b,a){this.getValidAxes=function(c){var d=[];if(this.graphType=="Scatter2D"){d.push("xAxis");d.push("yAxis")}else{if(this.graphType=="ScatterBubble2D"||this.graphType=="Scatter3D"){d.push("xAxis");d.push("yAxis");d.push("zAxis")}else{if(this.graphType.match(/Network|Genome|Correlation|Venn|Heatmap|Pie/)){if(c){d.push("xAxis")}else{return false}}else{if(this.graphType.match(/BarLine|AreaLine|StackedLine|StackedPercentLine/)||(this.graphType=="Candlestick"&&this.showVolume)){d.push("xAxis");d.push("xAxis2")}else{d.push("xAxis")}}}}return d};this.addRemoveSamplesInAxis=function(e,d,c){if(this.graphType=="Scatter2D"||this.graphType=="ScatterBubble2D"){if(c){return this.removeSamplesFromAxis(e,d)}else{return this.addSamplesToAxis(e,d)}}else{if(this.graphType=="Scatter3D"||this.graphType=="Pie"){return this.switchSampleInAxis(e,d)}}};this.addSamplesToAxis=function(e,d){if(this[d]){if(this.isArray(e)){for(var c=0;c<e.length;c++){this[d].push(e[c])}}else{this[d].push(e)}return false}else{return"Not a valid axis"}};this.removeSamplesFromAxis=function(g,f){if(this[f]){if(this[f].length>1){var d={};var c=[];if(this.isArray(g)){for(var e=0;e<g.length;e++){d[g[e]]=1}}else{d[g]=1}for(var e=0;e<this[f].length;e++){if(!d.hasOwnProperty(this[f][e])){c.push(this[f][e])}}this[f]=c;return false}else{return f+" cannot be null"}}else{return"Not a valid axis"}};this.switchSampleInAxis=function(d,c){if(this[c]){this[c][0]=d;return false}else{return"Not a valid axis"}};this.addRemoveVariablesInAxis=function(e,d,c){if(c){return this.removeVariablesFromAxis(e,d)}else{return this.addVariablesToAxis(e,d)}};this.addVariablesToAxis=function(e,d){if(!this.data.a){this.data.a={}}if(!this.data.a[d]){this.data.a[d]=[]}if(this.isArray(e)){for(var c=0;c<e.length;c++){this.data.a[d].push(e[c])}}else{this.data.a[d].push(e)}this.resetVariablesVisibleByAxis(d);return false};this.removeVariablesFromAxis=function(g,f){if(this.data.a&&this.data.a[f]){var d={};var c=[];if(this.isArray(g)){for(var e=0;e<g.length;e++){d[g[e]]=1}}else{d[g]=1}for(var e=0;e<this.data.a[f].length;e++){if(!d.hasOwnProperty(this.data.a[f][e])){c.push(this.data.a[f][e])}}this.data.a[f]=c}this.resetVariablesVisibleByAxis(f);return false};this.formatAxisValue=function(d,c){if(this[c+"TickFormat"]){if(this.graphType=="Candlestick"&&this.summaryType=="volume"){if(this.xAxis2TickFormat){return sprintf(this.xAxis2TickFormat,d)}else{return sprintf(this[c+"TickFormat"],d)}}else{return sprintf(this[c+"TickFormat"],d)}}else{return this.graphType=="Candlestick"&&this.summaryType=="volume"?sprintf("%."+this.xAxis2Decs+"f",d):sprintf("%."+this[c+"Decs"]+"f",d)}};this.getAxisRangeBySample=function(c){var g=[];if(this.isArray(c)){for(var e=0;e<this.varIndices.length;e++){var f=this.varIndices[e];for(var d=0;d<c.length;d++){g.push(this.getDataAtPos(f,d))}}}else{for(var e=0;e<this.varIndices.length;e++){var f=this.varIndices[e];g.push(this.getDataAtPos(f,c))}}return this.range(g)};this.getAxisIncrements=function(f,m,n,i){if(m-f<=Number.MIN_VALUE){return 0.1}if(i){return m==f?m*this.axisExtension/n:(m-f)/n}else{var k;var l=(m-f)*this.axisExtension;var d=m==f?f-(f*this.axisExtension):f-l;var g=m==f?m+(m*this.axisExtension):m+l;var h=g-d;var j=-Math.floor(Math.log(h/n)/Math.LN10);var e=Math.pow(10,-j);var c=((h/n)/e);if(c<1.5){k=e}else{if(c<2){k=e*2}else{if(c<2.5){k=e*2.5}else{if(c<5){k=e*5}else{if(c<7.5){k=e*7.5}else{k=e*10}}}}}if(this.getAxisMin(f,k)+(k*n)<m){return this.getAxisIncrements(f,m+k,n,i)}else{return k}}};this.getAxisMin=function(c,d){var e=d*Math.floor(c/d);return e<0&&this.minData>0?0:e};this.getAxisDecimals=function(c){var d=(c-parseInt(c)).toString().replace(/\./,"").length-1;return d};this.setAxis=function(c){var d=this.isGroupedData?this.data.w:this.data.y;if(this[c].length==0){if(c=="xAxis"){this[c].push(d.smps[this.smpIndices[0]])}else{if(c=="yAxis"){if(d.smps.length>1){this[c].push(d.smps[this.smpIndices[1]])}else{this[c].push(d.smps[this.smpIndices[0]])}}else{if(c=="zAxis"){if(d.smps.length>2){this[c].push(d.smps[this.smpIndices[2]])}else{if(d.smps.length>1){this[c].push(d.smps[this.smpIndices[1]])}else{this[c].push(d.smps[this.smpIndices[0]])}}}}}}else{if(this.graphType=="Scatter3D"&&this[c].length>1){this[c]=[this[c][0]]}}};this.setAxisValues=function(e){var z,p,m,n,o,x,k,f;var d={};var h=e+"MinorValues";var l=e+"Values";var v=e+"Ticks";var w=e+"TickFormat";var u=e+"Incr";var c=e+"Decs";var q=e+"Min";var g=e+"Transform";var t=e+"MaxStrLength";if(this[g]=="percentile"){this[c]=0;this[l]=[];this[h]=[];var y=[0,25,50,75,100];for(var s=0;s<y.length;s++){z=this.formatNumber(y[s]);if(d.hasOwnProperty(z)){k=true}else{d[z]=1}this[l].push(z)}for(var s=5;s<100;s+=5){this[h].push(s)}}else{if(this[l].length==0||b){if(b){this[l]=[];this[h]=[]}z=this[q];o=this[u]/this[v];for(var s=1;s<=this[v];s++){for(var r=1;r<this[v];r++){this[h].push(z+(o*r))}z+=this[u];if(this[c]==0&&z.toString().match(/\.5$/)){this[c]=1}if(this[w]){p=sprintf(this[w],z)}else{p=this.formatNumber(sprintf("%."+this[c]+"f",z))}if(d.hasOwnProperty(p)&&!this[w]){k=true}else{d[p]=1}this[l].push(p)}}else{m=this[l];this[l]=[];for(var s=0;s<m.length;s++){z=m[s];n=parseFloat(z);if(this[w]){p=sprintf(this[w],n)}else{p=this.formatNumber(sprintf("%."+this[c]+"f",n))}if(d.hasOwnProperty(p)&&!this[w]){k=true}else{d[p]=1}this[l].push(p)}}}if(k){this[c]++;this[l]=[];this[h]=[];this.setAxisValues(e)}else{f=this.getMaxText(this[l]);if(!this[t]){this[t]=f}else{this[t]=this.getMaxText([this[t],f])}}};this.setAxisAttributes=function(h,o,r,e,n){var q=e&&e.match(/log/)?true:false;var l=h+"Ticks";var d=h+"Incr";var g=h+"Exact";var c=h+"AbsMin";var k=h+"AbsMax";var i=h+"Min";var p=h+"Max";var m=h+"Range";var j=h+"Decs";var f=h+"Transform";this.setRangeData(o,r,q,n);if(e){if(e=="log2"){this.minData=Math.log(this.minData)/Math.LN2;this.maxData=Math.log(this.maxData)/Math.LN2}else{if(e=="log10"){this.minData=Math.log(this.minData)/Math.LN10;this.maxData=Math.log(this.maxData)/Math.LN10}else{if(e=="exp2"){this.minData=Math.pow(2,this.minData);this.maxData=Math.pow(2,this.maxData)}else{if(e=="exp10"){this.minData=Math.pow(10,this.minData);this.maxData=Math.pow(10,this.maxData)}else{if(e=="percentile"){this.minData=-12.5;this.maxData=112.5}}}}}}this[c]=this.setMin==null?this.minData:this[c];this[k]=this.setMax==null?this.maxData:this[k];this[d]=this.getAxisIncrements(this.minData,this.maxData,this[l],this[g]);this[j]=this.getAxisDecimals(this[d]);if(n){this[i]=0;if(this.graphType.match(/Percent/)){this[p]=100}else{this[p]=this[i]+(this[d]*this[l])}}else{if(this[g]||(e&&e=="percentile")){this[i]=this.minData;this[p]=this.maxData}else{this[i]=this.getAxisMin(this.minData,this[d]);this[p]=this[i]+(this[d]*this[l]);if(this[p]-(this[d]*2)>this.maxData){this[i]-=this[d];this[p]-=this[d]}}}this[m]=this[p]-this[i];this.setAxisValues(h)};this.setAxes=function(){if(this.graphType.match(/Correlation/)){var c=this.isGroupedData?this.data.w:this.data.y;this.setMin=null;this.setMax=null;if(this.correlationAnchorLegend){this.setAxisAttributes("xAxis")}if(!c.cor||c.cor.length==0){this.summarize("cor");this.setRangeData("cor")}if(!this.yAxisTitle){this.yAxisTitle="Correlation"}}else{if(this.graphType.match(/Scatter|Pie/)){var f=this.smpIndices;var p=["xAxis"];var k=["X"];this.setMin=null;this.setMax=null;if(this.graphType.match(/Scatter/)){p.push("yAxis");k.push("Y")}if(this.graphType.match(/ScatterBubble2D|Scatter3D/)){p.push("zAxis");k.push("Z")}if(this.graphType=="Scatter3D"){this.xAxisTicks=10;this.yAxisTicks=10;this.zAxisTicks=10}for(var q=0;q<p.length;q++){var u=p[q]+"Indices";var n="setMin"+k[q];var o="setMax"+k[q];this.setAxis(p[q]);this[u]=this.getSampleIndices(this[p[q]]);this.setSamplesVisible(this[u]);if(this[n]){this.setMin=this[n]}if(this[o]){this.setMax=this[o]}this.setAxisAttributes(p[q],false,false,this[p[q]+"Transform"]);this.setSamplesVisible(f)}if(!this.xAxisTitle){this.xAxisTitle=this.xAxis.length==1?this.xAxis[0]:" "}if(!this.yAxisTitle){this.yAxisTitle=this.yAxis.length==1?this.yAxis[0]:" "}if(!this.zAxisTitle){this.zAxisTitle=this.zAxis.length==1?this.zAxis[0]:" "}}else{if(this.graphType.match(/Genome/)){var r=this.setMin;var t=this.setMax;this.setRangeData("genome");this.xAxisExact=true;this.xAxisTransform=false;this.xAxisAbsMin=this.minData;this.xAxisAbsMax=this.maxData;if(r!=null){this.setMin=r}if(t!=null){this.setMax=t}this.xAxisMin=this.setMin!=null?this.setMin:this.minData;this.xAxisMax=this.setMax!=null?this.setMax:this.maxData;this.xAxisDecs=0;this.xAxisRange=this.xAxisMax-this.xAxisMin;this.xAxisTicks=this.ticks;this.xAxisIncr=this.xAxisRange/this.xAxisTicks;this.setAxisValues("xAxis")}else{var h=this.smpIndices;var m=this.varIndices;var j=this.grpIndices;var e=this.varIndices;var g=this.graphType=="Dotplot"&&this.isGroupedData?true:false;var l=this.graphType.match(/Percent/)?"percentile":false;var s=this.graphType.match(/Stacked/)||(this.graphType.match(/Area/)&&this.areaIsCumulative)?true:false;var d=this.graphType=="Candlestick"?"candle":l?l:false;if(this.graphType=="Heatmap"){this.graphOrientation="horizontal";if(this.varIndicesStart>-1||this.smpIndicesStart>-1){this.setAllVariablesVisible();this.setAllSamplesVisible()}}else{if(this.graphType=="StackedPercent"||this.graphType=="StackedPercentLine"){this.setMin=null;this.setMax=null;this.axisExact=true;this.xAxisExact=true}else{if(this.graphType=="Boxplot"&&!this.isGroupedData){if(!this.data.y.median){this.summarize("iqr")}}}}if(this.graphType.match(/BarLine|AreaLine|StackedLine|StackedPercentLine/)&&this.data.a){this.setVariablesVisible(this.getVariablesVisibleByAxis("xAxis"))}this.setAxisAttributes("xAxis",d,g,l,s);this["xAxisTitle"]=!this["xAxisTitle"]&&this.data.y.desc?this.data.y.desc[0]:"";if((this.graphType.match(/BarLine|AreaLine|StackedLine|StackedPercentLine/)&&this.data.a)||(this.graphType=="Candlestick"&&this.showVolume)){d=this.graphType=="Candlestick"?"volume":false;if(this.graphType.match(/BarLine|AreaLine|StackedLine|StackedPercentLine/)){this.setVariablesVisible(e);this.setVariablesVisible(this.getVariablesVisibleByAxis("xAxis2"))}var o=this.setMax!=null?this.setMax:null;var n=this.setMin!=null?this.setMin:null;this.setMax=this.setMax2!=null?this.setMax2:null;this.setMin=this.setMin2!=null?this.setMin2:null;this.setAxisAttributes("xAxis2",d,g);this["xAxis2Title"]=!this["xAxis2Title"]&&this.data.y.desc?this.data.y.desc[1]:"";this.setMax=o!=null?o:null;this.setMin=n!=null?n:null}this.setVariablesVisible(e);this.smpIndices=h;this.varIndices=m;this.grpIndices=j}}}};this.setScatterPointSize=function(){this.scatterPointSize=this.varIndices.length>50?this.sizes[1]:this.varIndices.length>20?this.sizes[2]:this.sizes[3];if(this.layoutComb){this.scatterPointSize=Math.ceil(this.scatterPointSize/this.layoutRows)}};this.setAxisUnits=function(e,g){var f=e+"Unit";var d=e+"Range";var c=g?g:e.substring(0,1);this[f]=this[c]/this[d]};this.setAxisFont=function(h,g){var f=this.graphType=="Venn"?16:12;if(this.autoScaleFont||!this.axisTickFont||!this.decorationFont||!this.axisTitleFont){var c,e,d;if(g>=600){c=12*this.tickScaleFontFactor;d=10*this.decorationScaleFontFactor;e=this.getFontPt(this.scaleTextToFont(h,f,g-2))*this.axisTitleScaleFontFactor}else{if(g>=400){c=10*this.tickScaleFontFactor;d=8*this.decorationScaleFontFactor;e=this.getFontPt(this.scaleTextToFont(h,f,g-2))*this.axisTitleScaleFontFactor}else{if(g>=200){c=8*this.tickScaleFontFactor;d=6*this.decorationScaleFontFactor;e=8*this.axisTitleScaleFontFactor}else{c=6*this.tickScaleFontFactor;d=4*this.decorationScaleFontFactor;e=6*this.axisTitleScaleFontFactor}}}this.axisTickFont=(parseInt(c))+"Pt "+this.fontName;this.decorationFont=(parseInt(d))+"Pt "+this.fontName;this.axisTitleFont=(parseInt(e))+"Pt "+this.fontName}else{this.axisTickFont=parseInt(this.axisTickFontSize)+"Pt "+this.fontName;this.decorationFont=parseInt(this.decorationFontSize)+"Pt "+this.fontName;this.axisTitleFont=parseInt(this.axisTitleFontSize)+"Pt "+this.fontName}};this.getAxisFont=function(c){if(c>=600){return 12}else{if(c>=400){return 10}else{if(c>=200){return 8}else{return 6}}}};this.getHeatmapShades=function(d,c){switch(d){case"white":case"black":if(c&&c!="white"&&c!="black"){return this.getHeatmapShades(c)}else{return this.greys}case"grey":return this.greys;case"green":return this.greens;case"red":return this.reds;case"blue":return this.blues;case"yellow":return this.yellows;case"cyan":return this.cyans;case"purple":return this.purples}};this.setHeatmapColors=function(c){this.setRGB();var k=c?c:this.maxData-this.minData;var d=this.heatmapType.split("-");var m=256/this.indicatorBins;var l=this.getHeatmapShades(d[0],d[1]);this.heatmapColors=[];this.heatmapBin=(k?k:1)/this.indicatorBins;if(this.indicatorCenter.match("rainbow")&&d.length>1){var e=["red","purple","blue","cyan","green","yellow"];if(this.indicatorCenter=="rainbow-green"){e.reverse()}var n=null;for(var h=0;h<e.length;h++){if(e[h]==d[0]){n=h}}if(n==null){alert("Dude! "+d[0]+" ain't a valid color ... This is not looking good ...");this.heatmapColors=this.blues;return}var f=[e[n]];n++;while(f.length<6){if(n>5){n=0}f.push(e[n]);n++}n=null;for(var h=0;h<f.length;h++){if(f[h]==d[1]){n=h}}if(n==null){alert("Dude! "+d[1]+" ain't a valid color ... This is not looking good ...");this.heatmapColors=this.blues;return}for(var h=0;h<n;h++){l=this.getHeatmapShades(f[h]);for(var g=0;g<m;g++){this.heatmapColors.push(l[g])}}}else{if(d.length>1){if((d[0]=="white"&&d[1]!="black")||(d[0]=="black"&&d[1]!="white")){this.heatmapType=d[1];this.setHeatmapColors(c)}else{if(d[1]=="white"){if(d[0]=="black"){this.heatmapColors.push("rgb(0,0,0)");for(var h=m-1;h>=0;h--){this.heatmapColors.push(l[h]);this.heatmapColors.push(l[h])}}else{for(var h=0;h<m;h++){this.heatmapColors.push(l[h]);this.heatmapColors.push(l[h])}this.heatmapColors.push("rgb(255,255,255)")}}else{if(d[1]=="black"){if(d[0]=="white"){this.heatmapColors.push("rgb(255,255,255)");for(var h=0;h<m;h++){this.heatmapColors.push(l[h]);this.heatmapColors.push(l[h])}}else{for(var h=0;h<m;h++){this.heatmapColors.push(l[h]);this.heatmapColors.push(l[h])}this.heatmapColors.push("rgb(0,0,0)")}}else{for(var h=0;h<m;h++){this.heatmapColors.push(l[h])}if(this.indicatorCenter=="black"){this.heatmapColors.push("rgb(0,0,0)")}else{this.heatmapColors.push("rgb(255,255,255)")}l=this.getHeatmapShades(d[1]);for(var h=m-1;h>=0;h--){this.heatmapColors.push(l[h])}}}}}else{if(this.indicatorCenter=="black"&&color[0]!="grey"){this.heatmapColors.push("rgb(0,0,0)")}else{this.heatmapColors.push("rgb(255,255,255)")}for(var h=m-1;h>=0;h--){this.heatmapColors.push(l[h]);this.heatmapColors.push(l[h])}}}};this.initializeAxis=function(){if(!this.graphType.match(/Venn|Network/)){if(!a){this.setAxes();this.setHeatmapColors()}}};this.initializeAxis()};CanvasXpress.prototype.Pie=function(){this.setVarPie=function(){var f=[];var a=this.smpIndices[0];if(this.varIndices.length>=this.maxPieSectors-1){var e=this;this.varIndices.sort(function(g,d){return e.data.y.data[d][a]-e.data.y.data[g][a]})}for(var b=0;b<this.varIndices.length;b++){var c=this.varIndices[b];f.push(this.getDataAtPos(c,a))}this.varPie=this.setPieData(f,true)};this.getPieLegendDimensions=function(){this.setLegendFont();var e=this.getFontPt(this.legendFont);var d=this.shortenText(this.maxVarNameStr,this.maxVarStringLen);var b=this.measureText(d,this.legendFont);if(b>this.width/2){this.legendFont=this.scaleTextToFont(b,e,this.width/2)}var c=e+this.measureText(d,this.legendFont)+(this.margin*5);var f=this.varIndices.length>this.maxPieSectors?this.maxPieSectors:this.varIndices.length;var a=(f*(e+this.margin))+(this.margin*3);return([c,a])};this.setPieXYDimensions=function(){var a=this.getPieLegendDimensions();if(this.showLegend){this.right=this.layoutComb?this.layoutRight:a[0]}this.x=this.layoutComb?this.layoutWidth:this.width-(this.marginLeft+this.left+this.right+this.marginRight);this.y=this.layoutComb?this.layoutHeight:this.height-(this.marginTop+this.top+this.bottom+this.marginBottom);this.setAxisFont("Pie",this.x)};this.drawPieDataPoints=function(){var b=Math.min(this.x,this.y);var c=(b-(b/5))/2;var a=this.marginLeft+this.offsetX+this.left+(this.x/2);var d=this.marginTop+this.offsetY+this.top+(this.y/2);this.setVarPie();this.drawPie(this.varPie,a,d,c,true)};this.drawPieLegend=function(){if(this.showLegend){var k=this.getPieLegendDimensions();var l=this.getFontPt(this.legendFont);var j=l/2;var b=this.layoutComb?(this.width-(this.marginRight+k[0]))+this.marginLeft+this.left:this.marginLeft+this.left+this.x+(this.margin*2)+j;var a=b+j+this.margin;var g=this.layoutComb?(this.layoutTop+(this.margin*3)+((this.height-(this.layoutTop+this.layoutBottom))/2))-(k[1]/2):this.marginTop+this.top+((this.y/2)-(k[1]/2))+this.margin;var f=g;for(var d=0;d<this.varPie.ids.length;d++){var h=this.varPie.ids[d];var c=d%this.colors.length;var e=h>-1?this.shortenText(this.data.y.vars[h],this.maxVarStringLen):"Other";this.drawShape("square",b,f,l,l,this.colors[c],this.foreground,"closed");this.drawText(e,a,f,this.legendFont,this.legendColor,"left","middle");f+=l+this.margin}if(this.legendBox){this.rectangle(b-(this.margin*2),g-(this.margin*2),k[0]-l,k[1]-l,false,this.legendBoxColor,"open")}}};this.drawPiePlot=function(){this.setPieXYDimensions();this.drawTitle();this.drawPieDataPoints();this.drawPieLegend()};this.initializePiePlot=function(){if(this.xAxisMin<0){alert("Dude you can't draw a pie chart with negative numbers!");return}if(this.layoutValid){this.drawLayoutCompartments(this.drawPiePlot)}else{this.drawPiePlot()}};this.initializePiePlot()};CanvasXpress.prototype.Venn=function(){this.setVennXYDimensions=function(){var a;this.vennMarginLeft=0;this.vennMarginTop=0;this.setLegendFont();this.setAxisFont("Venn",this.width);if(this.showLegend){this.bottom=this.margin+((this.getFontPt(this.legendFont)+this.margin)*this.vennGroups)}if(this.width<=this.height){this.x=this.width-(this.marginLeft+this.left+this.right+this.marginRight)}else{this.x=this.height-(this.marginTop+this.top+this.bottom+this.marginBottom)}this.y=this.vennGroups==4?this.x*0.8:this.vennGroups==3?this.x*0.95:this.vennGroups==2?this.x*0.65:this.x;if(this.autoAdjust){this.height=this.marginTop+this.top+this.y+this.bottom+this.marginBottom;this.width=this.marginLeft+this.left+this.x+this.right+this.marginRight}else{this.vennMarginTop=(this.height-(this.marginTop+this.top+this.y+this.bottom+this.marginBottom))/2;this.vennMarginLeft=(this.width-(this.marginLeft+this.left+this.x+this.right+this.marginRight))/2}if(this.x<400){var b=this.getFontPt(this.axisTickFont)-2;if(this.x<200){b-=1}this.axisTickFont=b+"Pt "+this.fontName}this.resizeCanvas()};this.drawVennBubble=function(b,c,a){if(this.vennGroups==4){if(this.isIE){a=a.replace("rgb","rgba");a=a.replace(")",",0.5)");this.drawShape("ellipse2",0,0,this.x/1.4,this.x/1.4,a,this.foreground,"closed")}else{this.drawShape("ellipse2",0,0,this.x/1.4,this.x/1.4,a,this.foreground,"closed");this.ctx.globalCompositeOperation="lighter"}}else{if(this.isIE){a=a.replace("rgb","rgba");a=a.replace(")",",0.5)");this.drawShape("circle",b,c,this.x/2,this.x/2,a,this.foreground,"closed")}else{this.drawShape("circle",b,c,this.x/2,this.x/2,a,this.foreground,"closed");this.ctx.globalCompositeOperation="lighter"}}};this.drawVennLayout=function(){var g,h,b,e;var a=["A","B","C","D"];this.ctx.clearRect(0,0,this.width,this.height);if(this.vennGroups==4){this.ctx.save();g=this.vennMarginLeft+this.marginLeft+this.margin+(this.x/4.94);h=this.vennMarginTop+this.marginTop+this.top+(this.x/13);this.ctx.translate(g,h);this.ctx.rotate(Math.PI/4);this.drawVennBubble(0,0,this.vennColors.length>0&&this.validateColor(this.vennColors[0])?this.validateColor(this.vennColors[0]):"rgb(255,0,0)");g=this.x/22.4;h=this.x/-5.32;this.ctx.translate(g,h);this.drawVennBubble(0,0,this.vennColors.length>1&&this.validateColor(this.vennColors[1])?this.validateColor(this.vennColors[1]):"rgb(0,153,51)");g=this.x/1.84;h=this.x/-5.32;this.ctx.translate(g,h);this.ctx.rotate(Math.PI/2);g=this.x/-22.4;h=this.x/-5.32;this.ctx.translate(g,h);this.drawVennBubble(0,0,this.vennColors.length>2&&this.validateColor(this.vennColors[2])?this.validateColor(this.vennColors[2]):"rgb(0,0,255)");g=this.x/22.4;h=this.x/5.32;this.ctx.translate(g,h);this.drawVennBubble(0,0,this.vennColors.length>3&&this.validateColor(this.vennColors[3])?this.validateColor(this.vennColors[3]):"rgb(153,204,0)");this.ctx.restore();b=[11.2,3.05,1.46,1.08];e=[7,42,42,7]}else{if(this.vennGroups==3){this.ctx.save();g=this.vennMarginLeft+this.marginLeft+this.left+(this.x/2);h=this.vennMarginTop+this.marginTop+this.top+(this.x/2.86);this.drawVennBubble(g,h,this.vennColors.length>0&&this.validateColor(this.vennColors[0])?this.validateColor(this.vennColors[0]):"rgb(255,0,0)");h+=(this.x/3.33);g=this.vennMarginLeft+this.marginLeft+this.left+(this.x/3);this.drawVennBubble(g,h,this.vennColors.length>1&&this.validateColor(this.vennColors[1])?this.validateColor(this.vennColors[1]):"rgb(0,255,0)");g=this.vennMarginLeft+this.marginLeft+this.left+(this.x/1.5);this.drawVennBubble(g,h,this.vennColors.length>2&&this.validateColor(this.vennColors[2])?this.validateColor(this.vennColors[2]):"rgb(0,0,255)");this.ctx.restore();b=[2,8.66,1.13];e=[20,2.3,2.3]}else{if(this.vennGroups==2){this.ctx.save();g=this.vennMarginLeft+this.marginLeft+this.left+(this.x/3);h=this.vennMarginTop+this.marginTop+this.top+(this.x/2.67);this.drawVennBubble(g,h,this.vennColors.length>0&&this.validateColor(this.vennColors[0])?this.validateColor(this.vennColors[0]):"rgb(0,0,255)");g=this.vennMarginLeft+this.marginLeft+this.left+(this.x/1.5);h=this.vennMarginTop+this.marginTop+this.top+(this.x/2.67);this.drawVennBubble(g,h,this.vennColors.length>1&&this.validateColor(this.vennColors[1])?this.validateColor(this.vennColors[1]):"rgb(255,0,0)");this.ctx.restore();b=[3,1.5];e=[16,16]}else{if(this.vennGroups==1){g=this.vennMarginLeft+this.marginLeft+this.left+(this.x/2);h=this.vennMarginTop+this.marginTop+this.top+(this.x/2);this.drawShape("circle",g,h,this.x,this.x,this.vennColors.length>0&&this.validateColor(this.vennColors[0])?this.validateColor(this.vennColors[0]):"rgb(255,0,0)",this.foreground,"closed");b=[100];e=[100]}}}}for(var d=0;d<this.vennGroups;d++){var c=this.vennMarginLeft+this.marginLeft+this.left+(this.x/b[d]);var f=this.vennMarginTop+this.marginTop+this.top+(this.x/e[d]);this.drawText(a[d],c,f,this.axisTickFont,this.axisTickColor,"center","middle")}};this.drawVennDataPoints=function(){var a,e;if(this.vennGroups==4){a=[5.6,2.94,3.5,1.54,3.29,2,2.59,1.212,2,1.442,1.4,1.757,2.31,1.624,2];e=[2.94,7,3.92,7,1.89,4.06,2.66,2.94,1.54,1.89,3.92,1.729,1.729,2.66,2.03];this.y=(this.x*1.1)/1.4}else{if(this.vennGroups==3){a=[2,3.5,2.55,1.4,1.6,2,2];e=[3.6,1.54,2.07,1.54,2.07,1.54,1.83];this.y=this.x*0.95}else{if(this.vennGroups==2){a=[3.5,1.4,2];e=[2.66,2.66,2.66];this.y=this.x*0.65}else{if(this.vennGroups==1){a=[2];e=[2]}}}}for(var d=0;d<a.length;d++){var c=this.vennMarginLeft+this.marginLeft+this.left+(this.x/a[d]);var f=this.vennMarginTop+this.marginTop+this.top+(this.x/e[d]);var b=this.getFontPt(this.axisTickFont);var g=this.data.venn.data[this.vennCompartments[d]]?this.data.venn.data[this.vennCompartments[d]]:0;this.drawText(g,c,f,this.axisTickFont,this.axisTickColor,"center","middle");this.addArea(["circle",c,f,b],[d])}};this.drawVennLegend=function(){if(this.showLegend){var f=["A","B","C","D"];var h=this.getFontPt(this.legendFont);var e=this.vennMarginLeft+this.marginLeft+this.left;var c=e+(h*2);var g=this.vennMarginTop+this.marginTop+this.top+this.y+this.margin+(h/2);for(var d=0;d<this.vennGroups;d++){this.drawText(f[d]+": ",e,g,this.legendFont,this.legendColor,"left","middle");var b=this.data.venn.legend&&this.data.venn.legend[f[d]]?this.data.venn.legend[f[d]]:"N/A";var a=(this.measureText(b,this.legendFont)>this.x)?this.scaleTextToFont(b,h,this.x-this.margin):this.legendFont;this.drawText(b,c,g,a,this.legendColor,"left","middle");g+=this.margin+h}}};this.drawVennPlot=function(){this.setVennXYDimensions();this.drawTitle();this.showShadow=false;this.drawVennLayout();this.showShadow=this.tmpshowShadow;this.drawVennDataPoints();this.drawVennLegend()};this.initializeVennPlot=function(){this.transparency=null;this.tmpshowShadow=this.showShadow;this.background="rgb(255,255,255)";this.foreground="rgb(0,0,0)";this.drawVennPlot()};this.initializeVennPlot()};CanvasXpress.prototype.Correlation=function(){this.setCorrelationVarSmpLabelFont=function(b){var a=this.scaleTextToSize(b);a=this.correlationAxis=="samples"?a*this.smpLabelScaleFontFactor:a*this.varLabelScaleFontFactor;a=Math.min(a,this.maxTextSize);this.smpLabelFont=(a)+"Pt "+this.fontName;this.varLabelFont=(a)+"Pt "+this.fontName};this.getCorrelationLabelsHeight=function(){var a=0;if(this.correlationAxis=="samples"){if(this.maxSmpName>this.maxSmpStringLen){a+=this.measureText(this.maxSmpNameStr.substring(0,this.maxSmpStringLen),this.smpLabelFont)}else{a+=this.measureText(this.maxSmpNameStr,this.smpLabelFont)}}else{if(this.maxVarName>this.maxVarStringLen){a+=this.measureText(this.maxVarNameStr.substring(0,this.maxVarStringLen),this.varLabelFont)}else{a+=this.measureText(this.maxVarNameStr,this.varLabelFont)}}if(this.correlationAnchorLegend){a+=this.correlationAnchorLegendAlignWidth+this.margin}return a};this.setCorrelationXYDimensions=function(){this.corMarginLeft=0;this.corMarginTop=0;if(this.yAxisShow){this.setAxisFont(this.yAxisTitle,this.height);this.left=this.margin+this.getFontPt(this.axisTitleFont)+this.margin}if(this.width<=this.height){this.x=this.width-(this.marginLeft+this.left+this.right+this.marginRight)}else{this.x=this.height-(this.marginTop+this.top+this.bottom+this.marginBottom)}var a=this.correlationAxis=="variables"?this.varIndices.length:this.isGroupedData?this.grpIndices.length:this.smpIndices.length;this.diamondSize=this.x/a;this.setCorrelationVarSmpLabelFont(a);this.y=this.x/2+(this.diamondSize/2);if(this.xAxisShow){this.top+=this.margin+this.getCorrelationLabelsHeight()+this.margin}if(this.autoAdjust){this.height=this.marginTop+this.top+this.y+this.bottom+this.marginBottom;this.width=this.marginLeft+this.left+this.x+this.right+this.marginRight}else{this.corMarginTop=(this.height-(this.marginTop+this.top+this.y+this.bottom+this.marginBottom))/2;this.corMarginLeft=(this.width-(this.marginLeft+this.left+this.x+this.right+this.marginRight))/2}this.resizeCanvas()};this.drawCorrelationLayout=function(){if(this.yAxisShow){this.drawText(this.yAxisTitle,this.corMarginLeft+this.marginLeft+this.left/2,this.marginTop+this.top+(this.y/2),this.axisTitleFont,this.axisTitleColor,"center","middle",-Math.PI/2)}if(this.xAxisShow){var c=this.corMarginLeft+this.marginLeft+this.left+(this.diamondSize/2);var o=(this.corMarginTop+this.marginTop+this.top)-this.margin;var n=(this.corMarginTop+this.marginTop+this.top)-(this.getCorrelationLabelsHeight()+this.margin);var m=n+this.correlationAnchorLegendAlignWidth;var k,f,h;var a=this.isGroupedData?this.data.w:this.data.y;var q=this.correlationAxis=="variables"?this.varIndices:this.isGroupedData?this.grpIndices:this.smpIndices;var l=this.correlationAxis=="samples"?this.maxSmpStringLen:this.maxVarStringLen;if(this.correlationAnchorLegend){h=this.correlationAxis=="samples"?a.data[0]:this.getDataForSmpGrpAtIndex(0);q.sort(function(r,i){return h[r]-h[i]});this.setAxisUnits("xAxis")}if(this.correlationAxis=="samples"){k=a.smps;f=this.smpLabelFont}else{k=a.vars;f=this.varLabelFont}for(var g=0;g<q.length;g++){var p=q[g];var j=this.shortenText(k[p],l);var e=this.correlationAxis=="samples"?this.getSmpColor(k[p]):this.getVarColor(k[p]);if(q.length<100){this.drawText(j,c,o,f,e,"left","middle",-Math.PI/2)}else{if(g%2){this.drawText(j,c,o,f,e,"left","middle",-Math.PI/2)}}if(this.correlationAnchorLegend){var d=h[p];var b=this.corMarginLeft+this.marginLeft+this.left+((d-this.xAxisMin)*this.xAxisUnit);this.drawLine("line",b,n-this.margin,b,n,e);this.drawLine("line",b,n,c,m,e)}c+=this.diamondSize}}c=(this.corMarginLeft+this.marginLeft+this.left+(this.x/3))-(this.heatmapColors.length*this.indicatorWidth);o=this.corMarginTop+this.marginTop+this.top+(this.y*7/8);if(this.correlationAnchorLegend){this.setRangeData("cor")}if(this.minData==null||this.maxData==null){this.setRangeData("cor")}this.drawColorIndicator(c,o,this.minData,this.maxData,2)};this.drawCorrelationDataPoints=function(){var c,o,b,n;var r=this.diamondSize/2;var h=this.isGroupedData?this.data.w.cor:this.data.y.cor;var q=this.correlationAxis=="variables"?this.varIndices:this.isGroupedData?this.grpIndices:this.smpIndices;c=this.corMarginLeft+this.marginLeft+this.left+r;o=this.corMarginTop+this.marginTop+this.top+r;for(var l=0;l<Math.ceil(q.length/2);l++){var p=q[l];b=c+(this.diamondSize*l);n=o;for(var g=l;g<q.length-l;g++){var m=q[g];var e=h[p][m];var d=this.getHeatmapColor(this.minData,this.maxData,e);if(isNaN(e)){this.addArea(this.drawShape("diamond",b,n,this.diamondSize,this.diamondSize,this.missingDataColor,this.missingDataColor,"closed"),[p,m])}else{this.addArea(this.drawShape("diamond",b,n,this.diamondSize,this.diamondSize,d,d,"closed"),[p,m])}b+=r;n+=r}n-=this.diamondSize;for(var f=g-2;f>=l;f--){var a=q[(q.length-f)-1];var e=h[a][m];var d=this.getHeatmapColor(this.minData,this.maxData,e);if(isNaN(e)){this.addArea(this.drawShape("diamond",b,n,this.diamondSize,this.diamondSize,this.missingDataColor,this.missingDataColor,"closed"),[a,m])}else{this.addArea(this.drawShape("diamond",b,n,this.diamondSize,this.diamondSize,d,d,"closed"),[a,m])}b+=r;n-=r}}this.drawLine("line",this.corMarginLeft+this.marginLeft+this.left,this.corMarginTop+this.marginTop+this.top+r,this.corMarginLeft+this.marginLeft+this.left+(this.x/2),this.corMarginTop+this.marginTop+this.top+this.y,this.foreground,false,"butt");this.drawLine("line",this.corMarginLeft+this.marginLeft+this.left+this.x,this.corMarginTop+this.marginTop+this.top+r,this.corMarginLeft+this.marginLeft+this.left+(this.x/2),this.corMarginTop+this.marginTop+this.top+this.y,this.foreground,false,"butt");c=this.corMarginLeft+this.marginLeft+this.left+r;o=this.corMarginTop+this.marginTop+this.top;b=c+(this.x/2);n=(this.corMarginTop+this.marginTop+this.top+this.y)-r;for(var l=0;l<q.length;l++){this.drawLine("line",c,o,b,n,this.foreground,false,"butt");c+=this.diamondSize;b+=r;n-=r}c=(this.corMarginLeft+this.marginLeft+this.left+this.x)-r;o=this.corMarginTop+this.marginTop+this.top;b=(this.corMarginLeft+this.marginLeft+this.left+(this.x/2))-r;n=(this.corMarginTop+this.marginTop+this.top+this.y)-r;for(var l=0;l<q.length;l++){this.drawLine("line",c,o,b,n,this.foreground,false,"butt");c-=this.diamondSize;b-=r;n-=r}};this.drawCorrelationPlot=function(){this.setCorrelationXYDimensions();this.drawCorrelationLayout();this.drawTitle();this.drawCorrelationDataPoints()};this.initializeCorrelationPlot=function(){this.drawCorrelationPlot()};this.initializeCorrelationPlot()};CanvasXpress.prototype.Scatter2D=function(){this.get2DYAxisWidth=function(){if(this.allVsAll){return this.yAxisShow?this.measureText(this.yAxisMaxStrLength,this.axisTickFont)+(this.margin*3):this.margin}else{return this.yAxisShow?this.getFontPt(this.axisTitleFont)+this.measureText(this.yAxisMaxStrLength,this.axisTickFont)+(this.margin*5):this.margin}};this.get2DXAxisHeight=function(){if(this.allVsAll){return this.xAxisShow?this.getFontPt(this.axisTitleFont)+(this.margin*5):this.margin}else{return this.xAxisShow?this.getFontPt(this.axisTickFont)+this.getFontPt(this.axisTitleFont)+(this.margin*5):this.margin}};this.set2DType=function(){if(this.graphType=="ScatterBubble2D"&&this.xAxisIndices.length>1&&this.xAxisIndices.length==this.yAxisIndices.length&&this.xAxisIndices.length==this.zAxisIndices.length){this.type2D="XYZ"}else{if(this.xAxisIndices.length>1&&this.xAxisIndices.length==this.yAxisIndices.length){this.type2D="XY"}else{if(this.xAxisIndices.length>this.yAxisIndices.length){this.type2D="X"}else{this.type2D="Y"}}}};this.set2DText=function(){var b=this.xAxisTitle.length>this.yAxisTitle.length?this.xAxisTitle:this.yAxisTitle;var a=this.layoutComb?Math.min(this.layoutWidth,this.layoutHeight):Math.min(this.width,this.height);this.setAxisFont(b,a)};this.setDecorationsLegendPositions=function(){if(this.showDecorations){this.setDecorationLegendDimension();if(this.showLegend){if(this.legendPosition=="bottom"){this.decorationsPosition="right"}else{this.decorationsPosition="bottom"}}}};this.set2DXYDimensions=function(){this.setDecorationsLegendPositions();this.setLegendDimensions();this.right=0;if(this.showLegend||this.showIndicators){this.right=this.legendWidth}if(this.showDecorations&&this.decorationsPosition=="right"){this.right+=this.legendDecorationWidth+(this.margin*2)}if(this.graphType=="ScatterBubble2D"&&this.zAxisShow){this.right+=this.getFontPt(this.axisTitleFont)+this.margin}else{this.right+=this.margin}this.left=this.get2DYAxisWidth();this.bottom=this.get2DXAxisHeight();if(this.showLegend||this.showIndicators){this.bottom+=this.legendHeight}if(this.showDecorations&&this.decorationsPosition=="bottom"){this.bottom+=this.legendDecorationHeight+(this.margin*2)}this.x=this.layoutComb?this.layoutWidth-(this.left+this.right):this.width-(this.marginLeft+this.left+this.right+this.marginRight);this.y=this.layoutComb?this.layoutHeight-(this.top+this.bottom):this.height-(this.marginTop+this.top+this.bottom+this.marginBottom);this.setScatterPointSize();this.setAxisUnits("xAxis");this.setAxisUnits("yAxis")};this.set2DWireFrame=function(){var d,f,b,e,a,g;d=this.marginLeft+this.offsetX+this.left;b=d+this.x;a=this.yAxisTickStyle=="dotted"?"dottedLine":"line";if(this.yAxisMinorTicks){for(var c=0;c<this.yAxisMinorValues.length;c++){g=parseFloat(this.yAxisMinorValues[c]);f=(this.marginTop+this.offsetY+this.top+this.y)-((g-this.yAxisMin)*this.yAxisUnit);this.drawLine(a,d,f,b,f,this.yAxisTickColor,this.outlineWidth/3,"butt")}}for(var c=0;c<this.yAxisValues.length;c++){g=parseFloat(this.yAxisValues[c]);f=(this.marginTop+this.offsetY+this.top+this.y)-((g-this.yAxisMin)*this.yAxisUnit);this.drawLine(a,d,f,b,f,this.yAxisTickColor,false,"butt")}f=this.marginTop+this.offsetY+this.top;e=f+this.y;a=this.xAxisTickStyle=="dotted"?"dottedLine":"line";if(this.xAxisMinorTicks){for(var c=0;c<this.xAxisMinorValues.length;c++){g=parseFloat(this.xAxisMinorValues[c]);d=(this.marginLeft+this.offsetX+this.left)+((g-this.xAxisMin)*this.xAxisUnit);this.drawLine(a,d,f,d,e,this.xAxisTickColor,this.outlineWidth/3,"butt")}}for(var c=0;c<this.xAxisValues.length;c++){g=parseFloat(this.xAxisValues[c]);d=(this.marginLeft+this.offsetX+this.left)+((g-this.xAxisMin)*this.xAxisUnit);this.drawLine(a,d,f,d,e,this.xAxisTickColor,false,"butt")}};this.set2DLayout=function(){var b=this.marginLeft+this.offsetX+this.margin+(this.getFontPt(this.axisTitleFont)/2);var c=this.marginTop+this.offsetY+this.top+(this.y/2);if(this.yAxisShow&&!this.allVsAll){this.drawText(this.yAxisTitle,b,c,this.axisTitleFont,this.axisTitleColor,"center","middle",-Math.PI/2)}b=this.marginLeft+this.offsetX+this.left-this.margin;for(var a=0;a<this.yAxisValues.length-1;a++){var e=parseFloat(this.yAxisValues[a]);var d=this.yAxisTransform&&!this.yAxisTransformTicks?this.formatAxisValue(this.transformValue(this.yAxisTransform,e,true),"yAxis"):this.formatAxisValue(e,"yAxis");c=(this.marginTop+this.offsetY+this.top+this.y)-((e-this.yAxisMin)*this.yAxisUnit);if(this.yAxisShow){this.drawText(d,b,c,this.axisTickFont,this.axisTickColor,"right","middle")}}b=this.marginLeft+this.offsetX+this.left+(this.x/2);c=this.marginTop+this.offsetY+this.top+this.y+this.margin+this.margin+this.getFontPt(this.axisTickFont)+this.margin+this.margin+(this.getFontPt(this.axisTitleFont)/2);if(this.xAxisShow&&!this.allVsAll){this.drawText(this.xAxisTitle,b,c,this.axisTitleFont,this.axisTitleColor,"center","middle")}c=this.marginTop+this.offsetY+this.top+this.y+this.margin+this.margin+(this.getFontPt(this.axisTickFont)/2);for(var a=0;a<this.xAxisValues.length-1;a++){var e=parseFloat(this.xAxisValues[a]);var d=this.xAxisTransform&&!this.xAxisTransformTicks?this.formatAxisValue(this.transformValue(this.xAxisTransform,e,true),"xAxis"):this.formatAxisValue(e,"xAxis");b=(this.marginLeft+this.offsetX+this.left)+((e-this.xAxisMin)*this.xAxisUnit);if(this.xAxisShow){this.drawText(d,b,c,this.axisTickFont,this.axisTickColor,"center","middle")}}if(this.graphType=="ScatterBubble2D"){if(this.zAxisShow){b=this.marginLeft+this.offsetX+this.left+this.x+this.margin;c=this.marginTop+this.offsetY+this.top+(this.y/2);this.drawText(this.zAxisTitle,b,c,this.axisTitleFont,this.axisTitleColor,"center","bottom",Math.PI/2)}}this.rectangle(this.marginLeft+this.offsetX+this.left,this.marginTop+this.offsetY+this.top,this.x,this.y,false,this.foreground,"open")};this.draw2DDataPoints=function(){var H,e,E,c;var q,J,I;var A,b,a;var G,h,f;var d=[];var w=[];var v=false;if(this.type2D=="XYZ"){var t=this.xAxisIndices[this.xAxisCurrent];var K=this.yAxisIndices[this.yAxisCurrent];var l=this.zAxisIndices[this.zAxisCurrent];var M=t+":"+K;if(this.xAxisTransform=="percentile"){q=this.getAxisRangeBySample(this.xAxisIndices);I=q[0];J=q[1]}if(this.yAxisTransform=="percentile"){A=this.getAxisRangeBySample(this.yAxisIndices);a=A[0];b=A[1]}G=this.getAxisRangeBySample(this.zAxisIndices);f=G[0];h=G[1];for(var B=0;B<this.varIndices.length;B++){var F=this.varIndices[B];var o=this.getDataAtPos(F,t,false,this.xAxisTransform,I,J);var n=this.getDataAtPos(F,K,false,this.yAxisTransform,a,b);var m=this.getDataAtPos(F,l,false,"percentile",f,h);var s=this.sizeBy?this.dataSizes[B]:this.sizes[Math.floor(m/10)+1];var k=this.colorBy?this.dataColors[B]:this.colors[0];var u=this.shapeBy?this.dataShapes[B]:this.shapes[0];var L=this.scatterType&&this.scatterType.match(/image/i)?this.images[B]:false;var D=L?"image":u;H=(this.marginLeft+this.offsetX+this.left)+((o-this.xAxisMin)*this.xAxisUnit);e=(this.marginTop+this.offsetY+this.top+this.y)-((n-this.yAxisMin)*this.yAxisUnit);if(this.isVisibleSelectedDataPoint(F,M)){if(!this.scatterType||this.scatterType!="function"){this.drawSelectedBackground(F,M,u,H,e,s,s,false,true);this.addArea(this.drawShape(D,H,e,s,s,k,this.foreground,"closed",false,false,true,false,false,false,L),[F,t,K,l])}if(this.scatterType&&this.scatterType.match(/line|functio/i)&&B<this.varIndices.length-1&&this.isVisibleSelectedDataPoint(this.varIndices[B+1],M)){F=this.varIndices[B+1];o=this.getDataAtPos(F,t,false,this.xAxisTransform,I,J);n=this.getDataAtPos(F,K,false,this.yAxisTransform,a,b);E=(this.marginLeft+this.offsetX+this.left)+((o-this.xAxisMin)*this.xAxisUnit);c=(this.marginTop+this.offsetY+this.top+this.y)-((n-this.yAxisMin)*this.yAxisUnit);if(this.lineType=="spline"){d.push(H);w.push(e)}else{this.drawLine("line",H,e,E,c,this.colors[0])}}}}if(this.scatterType&&this.scatterType.match(/line|functio/i)&&this.lineType=="spline"){d.push(E);w.push(c);this.drawLine("spline",d,w,false,false,this.colors[0]);d=[];w=[]}}else{if(this.type2D=="XY"){for(var C=0;C<this.xAxisIndices.length;C++){var k=C%this.colors.length;var t=this.xAxisIndices[C];var K=this.yAxisIndices[C];var l;var M=t+":"+K;if(this.xAxisTransform=="percentile"){q=this.getAxisRangeBySample(t);I=q[0];J=q[1]}if(this.yAxisTransform=="percentile"){A=this.getAxisRangeBySample(K);a=A[0];b=A[1]}if(this.graphType=="ScatterBubble2D"&&!this.sizeBy){if(this.zAxisIndices[this.zAxisCurrent]){l=this.zAxisIndices[this.zAxisCurrent];G=this.getAxisRangeBySample(l);f=G[0];h=G[1]}}for(var B=0;B<this.varIndices.length;B++){var F=this.varIndices[B];var o=this.getDataAtPos(F,t,false,this.xAxisTransform,I,J);var n=this.getDataAtPos(F,K,false,this.yAxisTransform,a,b);var m;var u=this.shapeBy?this.dataShapes[B]:this.shapes[0];var s=this.scatterPointSize;var L=this.scatterType&&this.scatterType.match(/image/i)?this.images[B]:false;var D=L?"image":u;if(this.sizeBy){s=this.dataSizes[B]}else{if(this.graphType=="ScatterBubble2D"){if(this.zAxisIndices[C]){m=this.getDataAtPos(F,l,false,"percentile",f,h);s=this.sizes[Math.floor(m/10)+1]}}}H=(this.marginLeft+this.offsetX+this.left)+((o-this.xAxisMin)*this.xAxisUnit);e=(this.marginTop+this.offsetY+this.top+this.y)-((n-this.yAxisMin)*this.yAxisUnit);if(this.isHistogram){c=(this.marginTop+this.offsetY+this.top+this.y)-e;if(this.isVisibleSelectedDataPoint(F,M)){this.drawSelectedBackground(F,M,"rectangle",H-this.histogramBarWidth,e-this.histogramBarWidth,this.histogramBarWidth*2,c,false,true);this.addArea(this.rectangle(H-this.histogramBarWidth,e,this.histogramBarWidth*2,c,this.colors[k],false,"closed",false,false,true),[F,t,K])}}else{if(this.isVisibleSelectedDataPoint(F,M)){if(!this.scatterType||this.scatterType!="function"){this.drawSelectedBackground(F,M,u,H,e,s,s,false,true);if(this.graphType=="ScatterBubble2D"){if(this.colorBy){this.addArea(this.drawShape(D,H,e,s,s,this.dataColors[B],this.colors[k],"closed",false,false,true,false,false,false,L),[F,t,K,l])}else{this.addArea(this.drawShape(D,H,e,s,s,this.colors[k],this.foreground,"closed",false,false,true,false,false,false,L),[F,t,K,l])}}else{if(this.colorBy){this.addArea(this.drawShape(D,H,e,s,s,this.dataColors[B],this.colors[k],"closed",false,false,true,false,false,false,L),[F,t,K])}else{this.addArea(this.drawShape(D,H,e,s,s,this.colors[k],this.foreground,"closed",false,false,true,false,false,false,L),[F,t,K])}}}if(this.scatterType&&this.scatterType.match(/line|functio/i)&&B<this.varIndices.length-1&&this.isVisibleSelectedDataPoint(this.varIndices[B+1],M)){F=this.varIndices[B+1];v=true}if(v){o=this.getDataAtPos(F,t,false,this.xAxisTransform,I,J);n=this.getDataAtPos(F,K,false,this.yAxisTransform,a,b);E=(this.marginLeft+this.offsetX+this.left)+((o-this.xAxisMin)*this.xAxisUnit);c=(this.marginTop+this.offsetY+this.top+this.y)-((n-this.yAxisMin)*this.yAxisUnit);if(this.lineType=="spline"){d.push(H);w.push(e)}else{this.drawLine("line",H,e,E,c,this.colors[k])}v=false}}}}if(this.scatterType&&this.scatterType.match(/line|functio/i)&&this.lineType=="spline"){d.push(E);w.push(c);this.drawLine("spline",d,w,false,false,this.colors[k]);d=[];w=[]}}}else{if(this.type2D=="X"){var r=this.yAxisIndices[this.yAxisCurrent];if(this.yAxisTransform=="percentile"){A=this.getAxisRangeBySample(r);a=A[0];b=A[1]}var g;if(this.graphType=="ScatterBubble2D"&&!this.sizeBy){if(this.zAxisIndices[this.zAxisCurrent]){g=this.zAxisIndices[this.zAxisCurrent];G=this.getAxisRangeBySample(g);f=G[0];h=G[1]}}for(var C=0;C<this.xAxisIndices.length;C++){var k=C%this.colors.length;var p=this.xAxisIndices[C];var M=p+":"+r;if(this.xAxisTransform=="percentile"){q=this.getAxisRangeBySample(p);I=q[0];J=q[1]}for(var B=0;B<this.varIndices.length;B++){var F=this.varIndices[B];var o=this.getDataAtPos(F,p,false,this.xAxisTransform,I,J);var n=this.getDataAtPos(F,r,false,this.yAxisTransform,a,b);var m;var s=this.scatterPointSize;var u=this.shapeBy?this.dataShapes[B]:this.shapes[0];var L=this.scatterType&&this.scatterType.match(/image/i)?this.images[B]:false;var D=L?"image":u;if(this.sizeBy){s=this.dataSizes[B]}else{if(this.graphType=="ScatterBubble2D"){if(this.zAxisIndices[this.zAxisCurrent]){m=this.getDataAtPos(F,g,false,"percentile",f,h);s=this.sizes[Math.floor(m/10)+1]}}}H=(this.marginLeft+this.offsetX+this.left)+((o-this.xAxisMin)*this.xAxisUnit);e=(this.marginTop+this.offsetY+this.top+this.y)-((n-this.yAxisMin)*this.yAxisUnit);if(this.isHistogram){c=(this.marginTop+this.offsetY+this.top+this.y)-e;if(this.isVisibleSelectedDataPoint(F,M)){this.drawSelectedBackground(F,M,"rectangle",H-this.histogramBarWidth,e-this.histogramBarWidth,this.histogramBarWidth*2,c,false,true);this.addArea(this.rectangle(H-this.histogramBarWidth,e,this.histogramBarWidth*2,c,this.colors[k],false,"closed",false,false,true),[F,p,r])}}else{if(this.isVisibleSelectedDataPoint(F,M)){if(!this.scatterType||this.scatterType!="function"){this.drawSelectedBackground(F,M,u,H,e,s,s,false,true);if(this.graphType=="ScatterBubble2D"){if(this.colorBy){this.addArea(this.drawShape(D,H,e,s,s,this.dataColors[B],this.colors[k],"closed",false,false,true,false,false,false,L),[F,p,r,g])}else{this.addArea(this.drawShape(D,H,e,s,s,this.colors[k],this.foreground,"closed",false,false,true,false,false,false,L),[F,p,r,g])}}else{if(this.colorBy){this.addArea(this.drawShape(D,H,e,s,s,this.dataColors[B],this.colors[k],"closed",false,false,true,false,false,false,L),[F,p,r])}else{this.addArea(this.drawShape(D,H,e,s,s,this.colors[k],this.foreground,"closed",false,false,true,false,false,false,L),[F,p,r])}}}if(this.scatterType&&this.scatterType.match(/line|functio/i)&&B<this.varIndices.length-1&&this.isVisibleSelectedDataPoint(this.varIndices[B+1],M)){F=this.varIndices[B+1];v=true}if(v){o=this.getDataAtPos(F,p,false,this.xAxisTransform,I,J);n=this.getDataAtPos(F,r,false,this.yAxisTransform,a,b);E=(this.marginLeft+this.offsetX+this.left)+((o-this.xAxisMin)*this.xAxisUnit);c=(this.marginTop+this.offsetY+this.top+this.y)-((n-this.yAxisMin)*this.yAxisUnit);if(this.lineType=="spline"){d.push(H);w.push(e)}else{this.drawLine("line",H,e,E,c,this.colors[k])}}}}}if(this.scatterType&&this.scatterType.match(/line|functio/i)&&this.lineType=="spline"){d.push(E);w.push(c);this.drawLine("spline",d,w,false,false,this.colors[k]);d=[];w=[]}}}else{var r=this.xAxisIndices[this.xAxisCurrent];if(this.xAxisTransform=="percentile"){q=this.getAxisRangeBySample(r);I=q[0];J=q[1]}var g;if(this.graphType=="ScatterBubble2D"&&!this.sizeBy){if(this.zAxisIndices[this.zAxisCurrent]){g=this.zAxisIndices[this.zAxisCurrent];G=this.getAxisRangeBySample(g);f=G[0];h=G[1]}}for(var C=0;C<this.yAxisIndices.length;C++){var k=this.colors[C%this.colors.length];var p=this.yAxisIndices[C];var M=r+":"+p;if(this.yAxisTransform=="percentile"){A=this.getAxisRangeBySample(p);a=A[0];b=A[1]}for(var B=0;B<this.varIndices.length;B++){var F=this.varIndices[B];var o=this.getDataAtPos(F,r,false,this.xAxisTransform,I,J);var n=this.getDataAtPos(F,p,false,this.yAxisTransform,a,b);var m;var u=this.shapeBy?this.dataShapes[B]:this.shapes[0];var s=this.scatterPointSize;var L=this.scatterType&&this.scatterType.match(/image/i)?this.images[B]:false;var D=L?"image":u;if(this.colorBy){k=this.dataColors[B]}if(this.sizeBy){s=this.dataSizes[B]}else{if(this.graphType=="ScatterBubble2D"){if(this.zAxisIndices[this.yAxisCurrent]){m=this.getDataAtPos(F,g,false,"percentile",f,h);s=this.sizes[Math.floor(m/10)+1]}}}H=(this.marginLeft+this.offsetX+this.left)+((o-this.xAxisMin)*this.xAxisUnit);e=(this.marginTop+this.offsetY+this.top+this.y)-((n-this.yAxisMin)*this.yAxisUnit);if(this.isHistogram){c=(this.marginTop+this.offsetY+this.top+this.y)-e;if(this.isVisibleSelectedDataPoint(F,M)){this.drawSelectedBackground(F,M,"rectangle",H-this.histogramBarWidth,e-this.histogramBarWidth,this.histogramBarWidth*2,c,false,true);this.addArea(this.rectangle(H-this.histogramBarWidth,e,this.histogramBarWidth*2,c,k,false,"closed",false,false,true),[F,r,p])}}else{if(this.isVisibleSelectedDataPoint(F,M)){if(!this.scatterType||this.scatterType!="function"){this.drawSelectedBackground(F,M,u,H,e,s,s,false,true);if(this.graphType=="ScatterBubble2D"){this.addArea(this.drawShape(D,H,e,s,s,k,this.foreground,"closed",false,false,true,false,false,false,L),[F,r,p,g])}else{this.addArea(this.drawShape(D,H,e,s,s,k,this.foreground,"closed",false,false,true,false,false,false,L),[F,r,p])}}if(this.scatterType&&this.scatterType.match(/line|functio/i)&&B<this.varIndices.length-1&&this.isVisibleSelectedDataPoint(this.varIndices[B+1],M)){F=this.varIndices[B+1];v=true}if(v){o=this.getDataAtPos(F,r,false,this.xAxisTransform,I,J);n=this.getDataAtPos(F,p,false,this.yAxisTransform,a,b);E=(this.marginLeft+this.offsetX+this.left)+((o-this.xAxisMin)*this.xAxisUnit);c=(this.marginTop+this.offsetY+this.top+this.y)-((n-this.yAxisMin)*this.yAxisUnit);if(this.lineType=="spline"){d.push(H);w.push(e)}else{this.drawLine("line",H,e,E,c,this.colors[C%this.colors.length])}}}}}if(this.scatterType&&this.scatterType.match(/line|functio/i)&&this.lineType=="spline"){d.push(E);w.push(c);this.drawLine("spline",d,w,false,false,this.colors[C%this.colors.length]);d=[];w=[]}}}}}};this.draw2DLegend=function(){if(this.showLegend){this.drawScatterLegend()}if(this.showDecorations){this.drawDecorationLegend()}};this.set2DprivateParams=function(){this.set2DType();this.set2DText()};this.draw2DPlot=function(){if(this.xAxis&&this.yAxis){this.setDataColorShapeSize()}this.set2DprivateParams();this.set2DXYDimensions();if(this.xAxis&&this.yAxis){this.drawPlotWindow();this.set2DWireFrame();this.draw2DDataPoints();this.maskPlotArea();this.set2DLayout();this.drawTitle();this.drawDecorationData();this.draw2DLegend()}};this.initializeScatter2D=function(){if(this.scatterSeries=="x"){this.transpose(false,true);this.scatterSeries="y"}if(this.layoutValid&&this.allVsAll){this.drawLayoutCompartments(this.draw2DPlot)}else{if(!this.allVsAll){this.unsetAllVsAll()}this.draw2DPlot()}};this.initializeScatter2D()};CanvasXpress.prototype.Scatter3D=function(){this.set3DText=function(){this.setAxisFont(false,this.x)};this.equalizeMargins=function(){var a=Math.max(this.marginLeft,Math.max(this.marginRight,Math.max(this.marginTop,this.marginBottom)));this.marginLeft=a;this.marginRight=a;this.marginTop=a;this.marginBottom=a};this.set3DXYDimensions=function(){this.equalizeMargins();var a=Math.min(this.height,this.width)-40;this.height=a;this.width=a;this.x=this.width-(this.marginTop+this.top);this.y=this.height-(this.marginTop+this.top);this.left=this.top;if(this.showLegend||this.showIndicators){this.setLegendDimensions();var a=Math.max(this.legendWidth,this.legendHeight)/2;this.x-=a;this.y-=a;this.width=this.x+this.legendWidth+this.marginLeft+this.marginRight;this.height=this.y+this.legendHeight+this.marginTop+this.marginBottom}this.resizeCanvas();this.setScatterPointSize()};this.draw3DLayout=function(h,a,n,j,b,o,f,c){var e,q,d,p,m;var g=this.marginLeft+this.offsetX+this.left;var r=this.marginTop+this.offsetY+this.top;for(var k=0;k<h.length;k++){m=this.get3DTransfrom(h[k],a[k],n[k]);e=m[0]+g;q=m[1]+r;m=this.get3DTransfrom(j[k],b[k],o[k]);d=m[0]+g;p=m[1]+r;if(c=="dotted"){this.drawLine("dottedLine",e,q,d,p,f[k],false,"butt")}else{this.drawLine("line",e,q,d,p,f[k],false,"butt")}}};this.draw3DBar=function(q,o,n,v,Q,S){var I=this.marginLeft+this.offsetX+this.left;var E=this.marginTop+this.offsetY+this.top;var k=I+(this.x/2);var g=E+(this.y/2);var M=v/2;var N=[[[q-v,o,n-v],[q+v,o,n-v],[q+v,M,n-v],[q-v,M,n-v]],[[q+v,o,n-v],[q+v,o,n+v],[q+v,M,n+v],[q+v,M,n-v]],[[q-v,o,n+v],[q+v,o,n+v],[q+v,M,n+v],[q-v,M,n+v]],[[q-v,o,n-v],[q-v,o,n+v],[q-v,M,n+v],[q-v,M,n-v]],[[q-v,o,n-v],[q+v,o,n-v],[q+v,o,n+v],[q-v,o,n+v]]];var P=[];var R=[];var O=[];var H=[];for(var L=0;L<N.length;L++){P[L]=[];for(var K=0;K<N[L].length;K++){var G=this.xAxisMin<0?0:this.xAxisMin;var D=this.yAxisMin<0?0:this.yAxisMin;var C=this.zAxisMin<0?0:this.zAxisMin;var A=((N[L][K][0]-G)*this.xAxisUnit)-this.xAxisOffset;var u=this.yAxisOffset-((N[L][K][1]-D)*this.yAxisUnit);var p=((N[L][K][2]-C)*this.zAxisUnit)-this.zAxisOffset;P[L].push(this.get3DTransfrom(A,u,p))}H.push(L);O.push(this.euclidianDistance([(P[L][0][0]+P[L][2][0])/2,(P[L][0][1]+P[L][2][1])/2,(P[L][0][2]+P[L][2][2])/2],[this.zero3DPoint[0],this.zero3DPoint[1],-this.x]))}H.sort(function(d,c){return O[c]-O[d]});for(var B=1;B<P.length;B++){var L=H[B];var F=B<3?this.darkenLightenColor(Q,-B*30):Q;var m=[];var J=[];for(var K=0;K<P[L].length;K++){m.push(P[L][K][0]+I);J.push(P[L][K][1]+E)}this.addArea(this.drawShape("polygon",m,J,false,false,F,this.foreground,"closed"),S)}};this.set3DXLayout=function(){var w=[],c=[],m=[],v=[],b=[],j=[],d=[];var u,k,o,a,z,q,h,g;var e=this.len/15;var p=(15*-e)+e;var f=this.xAxisTitle?this.xAxisTitle:this.data.y.smps[this.xAxisIndex];var r=this.marginLeft+this.offsetX+this.left;var n=this.marginTop+this.offsetY+this.top;if(this.show3DGrid){o=p;u=0;k=0;while(o<this.len){if((u+1)%3){w[k]=o;c[k]=-this.len;m[k]=this.len;v[k]=o;b[k]=this.len;j[k]=this.len;d.push(this.xAxisTickColor);k++;w[k]=-this.len;c[k]=o;m[k]=this.len;v[k]=this.len;b[k]=o;j[k]=this.len;d.push(this.xAxisTickColor);k++}o+=e;u++}this.draw3DLayout(w,c,m,v,b,j,d,this.xAxisTickStyle);w=[],c=[],m=[],v=[],b=[],j=[],d=[];o=p;u=0;k=0;z=this.xAxisIncr;while(o<this.len){if(!((u+1)%3)){w[k]=o;c[k]=-this.len;m[k]=this.len;v[k]=o;b[k]=this.len;j[k]=this.len;d.push(this.foreground);k++;w[k]=-this.len;c[k]=o;m[k]=this.len;v[k]=this.len;b[k]=o;j[k]=this.len;d.push(this.foreground);a=this.get3DTransfrom(o,this.len,-this.len);h=a[0]+r;g=a[1]+n;q=this.formatAxisValue(this.xAxisMin+z,"xAxis");z+=this.xAxisIncr;if(this.xAxisShow){this.drawText(q,h,g+5,this.axisTickFont,this.axisTickColor,"right",false,-Math.PI/2)}k++}o+=e;u++}this.draw3DLayout(w,c,m,v,b,j,d,this.xAxisTickStyle)}if(this.xAxisShow){this.draw3DAxisTitle(p-(e*2),this.len+e,this.len+(e*4),this.len+(e*4),-this.len-(e*4),-this.len-(e*4),f,"x")}w=[-this.len,-this.len,this.len,-this.len];c=[-this.len,-this.len,-this.len,this.len];m=[this.len,this.len,this.len,this.len];v=[-this.len,this.len,this.len,this.len];b=[this.len,-this.len,this.len,this.len];j=[this.len,this.len,this.len,this.len];d=[this.foreground,this.foreground,this.foreground,this.foreground];this.draw3DLayout(w,c,m,v,b,j,d,this.xAxisTickStyle)};this.set3DYLayout=function(){var A=[],c=[],m=[],z=[],b=[],j=[],d=[];var v,k,p,a,B,r,h,g;var e=this.len/15;var w=this.yAxisLen/30;var q=(15*-e)+e;var f=this.yAxisTitle?this.yAxisTitle:this.data.y.smps[this.yAxisIndex];var u=this.marginLeft+this.offsetX+this.left;var n=this.marginTop+this.offsetY+this.top;var o=[];if(this.show3DGrid){p=q;v=0;k=0;B=this.yAxisIncr;while(p<this.len){if((v+1)%3){A[k]=-this.len;c[k]=-this.len;m[k]=p;z[k]=-this.len;b[k]=this.len;j[k]=p;d.push(this.yAxisTickColor);k++;A[k]=-this.len;c[k]=p;m[k]=-this.len;z[k]=-this.len;b[k]=p;j[k]=this.len;d.push(this.yAxisTickColor);k++}else{o.push(B);B+=this.yAxisIncr}p+=e;v++}this.draw3DLayout(A,c,m,z,b,j,d,this.yAxisTickStyle);A=[],c=[],m=[],z=[],b=[],j=[],d=[];p=q;v=0;k=0;while(p<this.len){if(!((v+1)%3)){A[k]=-this.len;c[k]=-this.len;m[k]=p;z[k]=-this.len;b[k]=this.len;j[k]=p;d.push(this.foreground);k++;A[k]=-this.len;c[k]=p;m[k]=-this.len;z[k]=-this.len;b[k]=p;j[k]=this.len;d.push(this.foreground);a=this.get3DTransfrom(-this.len,p,-this.len);h=a[0]+u;g=a[1]+n;B=o.pop();r=this.formatAxisValue(this.yAxisMin+B,"yAxis");if(this.yAxisShow){if(this.yRotate>=45&&this.xRotate>=45){this.drawText(r,h,g+5,this.axisTickFont,this.axisTickColor,"right",false,-Math.PI/2)}else{this.drawText(r,h-5,g,this.axisTickFont,this.axisTickColor,"right")}}k++}p+=e;v++}this.draw3DLayout(A,c,m,z,b,j,d,this.yAxisTickStyle)}if(this.yAxisShow){this.draw3DAxisTitle(-this.len-(e*4),-this.len-(e*4),q-(e*2),this.len+e,-this.len-(e*4),-this.len-(e*4),f,"y")}A=[-this.len,-this.len,-this.len,-this.len];c=[-this.len,-this.len,-this.len,this.len];m=[-this.len,this.len,this.len,this.len];z=[-this.len,-this.len,-this.len,-this.len];b=[this.len,-this.len,this.len,this.len];j=[-this.len,-this.len,this.len,-this.len];d=[this.foreground,this.foreground,this.foreground,this.foreground];this.draw3DLayout(A,c,m,z,b,j,d,this.yAxisTickStyle)};this.set3DZLayout=function(){var w=[],c=[],m=[],v=[],b=[],j=[],d=[];var u,k,o,a,z,q,h,g;var e=this.len/15;var p=(15*-e)+e;var f=this.zAxisTitle?this.zAxisTitle:this.data.y.smps[this.zAxisIndex];var r=this.marginLeft+this.offsetX+this.left;var n=this.marginTop+this.offsetY+this.top;if(this.show3DGrid){o=p;u=0;k=0;while(o<this.len){if((u+1)%3){w[k]=-this.len;c[k]=this.len;m[k]=o;v[k]=this.len;b[k]=this.len;j[k]=o;d.push(this.zAxisTickColor);k++;w[k]=o;c[k]=this.len;m[k]=-this.len;v[k]=o;b[k]=this.len;j[k]=this.len;d.push(this.zAxisTickColor);k++}o+=e;u++}this.draw3DLayout(w,c,m,v,b,j,d,this.zAxisTickStyle);w=[],c=[],m=[],v=[],b=[],j=[],d=[];o=p;u=0;k=0;z=this.zAxisIncr;while(o<this.len){if(!((u+1)%3)){w[k]=-this.len;c[k]=this.len;m[k]=o;v[k]=this.len;b[k]=this.len;j[k]=o;d.push(this.foreground);k++;w[k]=o;c[k]=this.len;m[k]=-this.len;v[k]=o;b[k]=this.len;j[k]=this.len;d.push(this.foreground);a=this.get3DTransfrom(this.len,this.len,o);h=a[0]+r;g=a[1]+n;q=this.formatAxisValue(this.zAxisMin+z,"zAxis");z+=this.zAxisIncr;if(this.zAxisShow){if(this.xRotate>=45){if(this.yRotate>=45){this.drawText(q,h+5,g,this.axisTickFont,this.axisTickColor,"left")}else{this.drawText(q,h,g+5,this.axisTickFont,this.axisTickColor,"right",false,-Math.PI/2)}}else{this.drawText(q,h+5,g,this.axisTickFont,this.axisTickColor,"left")}}k++}o+=e;u++}this.draw3DLayout(w,c,m,v,b,j,d,this.zAxisTickStyle)}if(this.zAxisShow){this.draw3DAxisTitle(this.len+(e*6),this.len+(e*6),this.len+(e*6),this.len+(e*6),p-(e*2),this.len+e,f,"z")}w=[-this.len,-this.len,this.len,-this.len];c=[this.len,this.len,this.len,this.len];m=[-this.len,this.len,-this.len,-this.len];v=[-this.len,this.len,this.len,this.len];b=[this.len,this.len,this.len,this.len];j=[this.len,this.len,this.len,-this.len];d=[this.foreground,this.foreground,this.foreground,this.foreground];this.draw3DLayout(w,c,m,v,b,j,d,this.zAxisTickStyle)};this.draw3DAxisTitle=function(u,s,d,c,j,h,m,b){var o=this.measureText(m);var q=o/2;var v=m.split("");var g=(u+s)/2;var f=(d+c)/2;var e=(j+h)/2;var p=this.marginLeft+this.offsetX;var k=this.marginTop+this.offsetY;var n=this.xRotate>=45||this.yRotate>=45?4:0;if(this.xRotate>=45||this.yRotate>=45){o+=v.length*4;q=o/2}if(b=="x"){g-=q;for(var r=0;r<v.length;r++){var a=this.get3DTransfrom(g,f,e);this.drawText(v[r],p+a[0],k+a[1],this.axisTitleFont,this.axisTitleColor,"left","top");g+=this.measureText(v[r])+n}}else{if(b=="y"){f+=q;for(var r=0;r<v.length;r++){var a=this.get3DTransfrom(g,f,e);this.drawText(v[r],p+a[0],k+a[1],this.axisTitleFont,this.axisTitleColor,"left","bottom",-Math.PI/2);f-=this.measureText(v[r])+n}}else{if(b=="z"){e-=q;for(var r=0;r<v.length;r++){var a=this.get3DTransfrom(g,f,e);this.drawText(v[r],p+a[0],k+a[1],this.axisTitleFont,this.axisTitleColor,"left","bottom");e+=this.measureText(v[r])+n}}}}};this.set3DLayout=function(){this.set3DXLayout();this.set3DYLayout();this.set3DZLayout()};this.set3DAxes=function(){var b=["x","y","z"];for(var a=0;a<b.length;a++){var c=this.smpIndices;this[b[a]+"AxisIndex"]=this.getSampleIndices([this[b[a]+"Axis"]])[0];this.setSamplesVisible([this[b[a]+"AxisIndex"]]);this.setRangeData();this[b[a]+"AxisMin"]=this.minData;this[b[a]+"AxisMax"]=this.maxData;this[b[a]+"AxisIncr"]=this.getAxisIncrements(this[b[a]+"AxisMin"],this[b[a]+"AxisMax"],10);this[b[a]+"AxisDecs"]=this.getAxisDecimals(this[b[a]+"AxisIncr"]);this[b[a]+"AxisMin"]=this.getAxisMin(this.minData,this[b[a]+"AxisIncr"]);this[b[a]+"AxisMax"]=this[b[a]+"AxisMin"]+(this[b[a]+"AxisIncr"]*10);this[b[a]+"AxisRange"]=this[b[a]+"AxisMax"]-this[b[a]+"AxisMin"];this[b[a]+"AxisUnit"]=this.len*2/this[b[a]+"AxisRange"];this[b[a]+"AxisOffset"]=(this[b[a]+"AxisMin"]+(this[b[a]+"AxisRange"]/2))*this[b[a]+"AxisUnit"];if(this[b[a]+"AxisOffset"]>this.len*2){this[b[a]+"AxisOffset"]=this.len}this.setSamplesVisible(c)}this.set3DCenter()};this.set3DCenter=function(){var e=this.xAxisMin<0?0:this.xAxisMin;var c=this.yAxisMin<0?0:this.yAxisMin;var b=this.zAxisMin<0?0:this.zAxisMin;var a=((((this.xAxisMin+this.xAxisMax)/2)-e)*this.xAxisUnit)-this.xAxisOffset;var f=this.yAxisOffset-((((this.yAxisMin+this.yAxisMax)/2)-c)*this.yAxisUnit);var d=((((this.zAxisMin+this.zAxisMax)/2)-b)*this.zAxisUnit)-this.zAxisOffset;this.zero3DPoint=this.get3DTransfrom(a,f,d)};this.draw3DDataPoints=function(){var T=this.marginLeft+this.offsetX+this.left;var M=this.marginTop+this.offsetY+this.top;var C=this.xAxisIndex+":"+this.yAxisIndex+":"+this.zAxisIndex;var B=[];var m=[];var D=[];var N=[];var e=[];for(var W=0;W<this.varIndices.length;W++){var G=this.varIndices[W];var L=this.getDataAtPos(G,this.xAxisIndex);var K=this.getDataAtPos(G,this.yAxisIndex);var J=this.getDataAtPos(G,this.zAxisIndex);var u=this.xAxisMin<0?0:this.xAxisMin;var r=this.yAxisMin<0?0:this.yAxisMin;var o=this.zAxisMin<0?0:this.zAxisMin;var k=((L-u)*this.xAxisUnit)-this.xAxisOffset;var h=this.scatterType&&this.scatterType.match(/bar/)?0:this.yAxisOffset-((K-r)*this.yAxisUnit);var f=((J-o)*this.zAxisUnit)-this.zAxisOffset;B.push([L,K,J]);m.push(this.get3DTransfrom(k,h,f));if(this.scatterType!="function"){N.push(W);e.push(this.euclidianDistance([m[W][0],m[W][1],m[W][2]],[this.zero3DPoint[0],this.zero3DPoint[1],-this.x]))}}if(this.scatterType&&this.scatterType=="function"){var S=Math.sqrt(m.length);var G=0;var F=[];for(var W=1;W<S;W++){for(var U=0;U<S-1;U++){var V=((W-1)*S)+U;var d=(W*S)+U;var R=((W-1)*S)+U+1;var Y=(W*S)+U+1;var H=[m[V][0],m[d][0],m[Y][0],m[R][0]];var v=[m[V][1],m[d][1],m[Y][1],m[R][1]];var ab=[m[V][2],m[d][2],m[Y][2],m[R][2]];var I=this.colorBy?this.legendColorRange:false;var E=this.colorBy?this.getHeatmapColor(I[0],I[1],this.mean([B[V][1],B[d][1],B[Y][1],B[R][1]])):false;N.push(G++);e.push(this.euclidianDistance([this.mean(H),this.mean(v),this.mean(ab)],[this.zero3DPoint[0],this.zero3DPoint[1],-this.x]));F.push([H,v,E])}}N.sort(function(g,c){return e[c]-e[g]});for(var G=0;G<F.length;G++){var W=N[G];var aa=[W,this.xAxisIndex,this.yAxisIndex,this.zAxisIndex];if(this.colorBy){this.addArea(this.drawShape("polygon",F[W][0],F[W][1],false,false,F[W][2],this.foreground,"close"),aa)}else{this.addArea(this.drawShape("polygon",F[W][0],F[W][1],false,false,false,this.foreground,"open"),aa)}}}else{N.sort(function(g,c){return e[c]-e[g]});for(var G=0;G<m.length;G++){var W=N[G];var Z=this.colorBy?this.dataColors[W]:this.colors[0];var X=this.scatterType&&this.scatterType.match(/image/i)?this.images[U]:false;var aa=[W,this.xAxisIndex,this.yAxisIndex,this.zAxisIndex];if(this.isVisibleSelectedDataPoint(W,C)){if(this.scatterType&&this.scatterType.match(/bar/)){var O=this.isInSelectedDataPoints(W,C)?this.selectedBackgroundColor:Z;this.draw3DBar(B[W][0],B[W][1],B[W][2],this.scatterPointSize/3,O,aa)}else{var Q=this.shapeBy?this.dataShapes[W]:this.shapes[0];var P=X?"image":Q;var O=this.sizeBy?this.dataSizes[W]:this.scatterPointSize;var L=this.xAxisMin<0?(T+m[W][0]):(T+m[W][0]);var K=M+m[W][1];this.drawSelectedBackground(W,C,Q,L,K,O,O);this.addArea(this.drawShape(P,L,K,O,O,Z,this.foreground,"closed",false,false,false,false,false,false,X),aa);if(this.scatterType&&this.scatterType.match(/line/)){D[W]=L}}}}if(this.scatterType&&this.scatterType.match(/line/)&&D.length>0){for(var W=0;W<D.length-1;W++){if(this.isVisibleSelectedDataPoint(W,C)&&this.isVisibleSelectedDataPoint(W+1,C)){var A=T+D[W][0];var b=M+D[W][1];var w=T+D[W+1][0];var ac=M+D[W+1][1];this.drawLine("line",A,b,w,ac,this.colors[0])}}}}};this.set3DprivateParams=function(){this.set3DText();this.set3DParams()};this.draw3DPlot=function(){this.setDataColorShapeSize();this.set3DXYDimensions();this.set3DprivateParams();this.set3DRotation();this.set3DAxes();this.set3DLayout();this.drawTitle();this.draw3DDataPoints();this.drawScatterLegend()};this.initializeScatter3D=function(){if(this.layoutValid){this.drawLayoutCompartments(this.draw3DPlot)}else{this.draw3DPlot()}};this.initializeScatter3D()};CanvasXpress.prototype.oneDPlot=function(){this.getShapeSize=function(){if(this.x<100||this.y<100){return this.rowBlockSize/6}else{if(this.x<200||this.y<200){return this.rowBlockSize/3}else{return this.rowBlockSize/1.5}}};this.setRowColBlocks=function(){var c=this.isGroupedData?this.grpIndices.length:this.smpIndices.length;this.rowBlocks=0;if(this.graphType=="Line"||this.graphType=="Area"||this.graphType=="AreaLine"||this.graphType=="Heatmap"||this.graphType=="Stacked"||this.graphType=="StackedLine"||this.graphType=="StackedPercent"||this.graphType=="StackedPercentLine"){this.rowBlocks=c;if(this.graphType=="Heatmap"){this.colBlocks=this.varIndices.length}else{this.colBlocks=1}}else{if(this.graphType=="BarLine"&&this.data.a){var b=this.getVariablesVisibleByAxis("xAxis");this.rowBlocks=b.length*c;this.colBlocks=1}else{this.rowBlocks=this.varIndices.length*c;this.colBlocks=1}}};this.set1DVarSmpLabelFont=function(){var b,a;if(this.autoScaleFont){if(this.data.l&&this.data.l.vars&&this.data.l.smps&&this.graphOrientation=="vertical"){b=this.scaleTextToSize(this.layoutMaxSamples*2)}else{var c=Math.abs(this.smpLabelRotate==90)?6:2;b=this.isGraphTime?this.scaleTextToSize(this.timeValues.length*c):this.scaleTextToSize(this.smpIndices.length*c)}a=this.scaleTextToSize(this.varIndices.length*2);if(this.graphType=="Heatmap"&&this.autoAdjust){b=Math.min(b,a);a=b}}else{b=this.smpLabelFontSize;a=this.varLabelFontSize}this.smpLabelFont=parseInt(b*this.smpLabelScaleFontFactor)+"Pt "+this.fontName;this.varLabelFont=parseInt(a*this.varLabelScaleFontFactor)+"Pt "+this.fontName};this.set1DText=function(){var a;if(!this.layoutComb){if(this.data.y.desc){if(this.data.y.desc.length>1){if(this.data.y.desc[0].length>this.data.y.desc[1].length){a=this.data.y.desc[0]}else{a=this.data.y.desc[1]}}else{a=this.data.y.desc[0]}}else{a="NA"}}if(this.layoutComb){this.setAxisFont(this.minLayoutAxisTitle,this.minLayoutAxis)}else{if(this.graphOrientation=="vertical"){this.setAxisFont(a,this.y)}else{this.setAxisFont(a,this.x)}}};this.getVariableTitleHeight=function(){if(this.varTitle){return parseInt(this.varTitleFontSize*this.varTitleScaleFontFactor)+this.margin}else{return 0}};this.getVariableLabelLength=function(){if(this.showVariableNames){if(this.varLabelRotate&&Math.abs(this.varLabelRotate)==90){return this.getFontPt(this.varLabelFont)+this.margin}else{return this.measureText(this.maxVarNameStr,this.varLabelFont)+this.margin}}else{return 0}};this.getVariableLabelDescLength=function(){if(this.showVariableNames&&this.varLabelDescription){if(this.maxVarLabelDesc>this.maxVarStringLen){return this.measureText(this.maxVarLabelDescStr.substring(0,this.maxVarStringLen),this.varLabelFont)+(this.margin*2)}else{return this.measureText(this.maxVarLabelDescStr,this.varLabelFont)+(this.margin*2)}}else{return 0}};this.getSampleTitleHeight=function(){if(this.smpTitle){return parseInt(this.smpTitleFontSize*this.smpTitleScaleFontFactor)+this.margin}else{return 0}};this.getSampleLabelLength=function(){if(this.showSampleNames){if(this.smpLabelRotate&&Math.abs(this.smpLabelRotate)==90){return this.getFontPt(this.smpLabelFont)+(this.margin*2)}else{if(this.isGraphTime){return this.measureText(this.getMaxText(this.timeValues),this.smpLabelFont)+(this.margin*2)}else{if(this.maxSmpName>this.maxSmpStringLen){return this.measureText(this.maxSmpNameStr.substring(0,this.maxSmpStringLen),this.smpLabelFont)+(this.margin*2)}else{return this.measureText(this.maxSmpNameStr,this.smpLabelFont)+(this.margin*2)}}}}else{return 0}};this.getSampleLabelDescLength=function(){if(this.showSampleNames&&this.smpLabelDescription){if(this.maxSmpLabelDesc>this.maxSmpStringLen){return this.measureText(this.maxSmpLabelDescStr.substring(0,this.maxSmpStringLen),this.smpLabelFont)+(this.margin*2)}else{return this.measureText(this.maxSmpLabelDescStr,this.smpLabelFont)+(this.margin*2)}}else{return 0}};this.getSmpOverlaysLength=function(){var b=0;if(this.showOverlays){if(!this.isGroupedData){for(var a=0;a<this.smpOverlays.length;a++){if(this.data.x.hasOwnProperty(this.smpOverlays[a])){b++}}if(b>0){b=(b*this.overlaysWidth)+this.margin}}}return b};this.getSmpOverlaysStrLength=function(){var b=0;if(this.showOverlays){if(this.graphType=="Heatmap"){for(var a=0;a<this.smpOverlays.length;a++){if(this.data.x.hasOwnProperty(this.smpOverlays[a])){b=Math.max(b,this.measureText(this.smpOverlays[a],this.overlayFont)+this.margin)}}}}return b};this.getVarOverlaysHeight=function(){var b=0;if(this.showOverlays){if(this.graphType=="Heatmap"){for(var a=0;a<this.varOverlays.length;a++){if(this.data.z.hasOwnProperty(this.varOverlays[a])){b++}}if(b>0){b=(b*this.overlaysWidth)+this.margin}}}return b};this.getVarOverlaysLength=function(){var b=0;if(this.showOverlays){if(this.graphType=="Heatmap"){for(var a=0;a<this.varOverlays.length;a++){if(this.data.z.hasOwnProperty(this.varOverlays[a])){b=Math.max(b,this.measureText(this.varOverlays[a],this.overlayFont)+this.margin)}}}}return b};this.getAxisTitleTickLength=function(){if(this.graphOrientation=="vertical"){var a;if(this.tickRotate&&Math.abs(this.tickRotate)==90){a=this.getFontPt(this.axisTickFont)}else{if(this.graphType=="Candlestick"){if(this.showVolume){a=Math.max(this.measureText(this.xAxisMaxStrLength,this.axisTickFont),this.measureText(this.xAxis2MaxStrLength,this.axisTickFont))}else{if(this.summaryType=="candle"){a=this.measureText(this.xAxisMaxStrLength,this.axisTickFont)}else{a=this.measureText(this.xAxis2MaxStrLength,this.axisTickFont)}}}else{a=this.measureText(this.xAxisMaxStrLength,this.axisTickFont)}}return this.getFontPt(this.axisTitleFont)+a+(this.margin*3)}else{return this.getFontPt(this.axisTitleFont)+this.getFontPt(this.axisTickFont)+(this.margin*5)}};this.getHeatmapIndicatorHeight=function(){return this.indicatorHeight+(this.margin*4)+this.getFontPt(this.legendFont)};this.getLegendHeight=function(c){if(this.graphType=="Heatmap"){return 0}else{if(this.colorBy&&this.graphType=="Bar"){if(this.legendColorsN>0){return this.legendColorHeight+this.margin}else{return this.legendPosition=="right"?this.legendColorIndicatorWidth:this.legendColorIndicatorHeight}}else{var a=Math.min(this.getFontPt(this.legendFont),this.maxTextSize);var b=this.layoutComb&&!c?this.layoutMaxVarLegend:this.varIndices.length;return(b*a*1.5)+(a/2)+this.margin}}};this.getLegendWidth=function(){if(this.graphType=="Heatmap"){return 0}else{if(this.colorBy&&this.graphType=="Bar"){if(this.legendColorsN>0){return this.legendColorWidth+this.margin}else{return this.legendPosition=="right"?this.legendColorIndicatorHeight:this.legendColorIndicatorWidth}}else{var b=Math.min(this.getFontPt(this.legendFont),this.maxTextSize);var a=this.layoutComb?this.layoutMaxVarLegendLabel:this.maxVarNameStr;var c=a.length>this.maxVarStringLen?a.substring(0,this.maxVarStringLen):a;return(b*2)+this.measureText(c,this.legendFont)+(this.margin*6)}}};this.getVarTreeHeight=function(){var a=0;if(this.graphType=="Heatmap"&&this.showVarDendrogram&&this.varDendrogram){a=((this.varDendrogram.depth+1)*this.dendrogramSpace)+this.margin}return a};this.getSmpTreeWidthHeight=function(){var a=0;if(this.showSmpDendrogram&&this.smpDendrogram&&!this.isGroupedData){a=((this.smpDendrogram.depth+1)*this.dendrogramSpace)+this.margin}return a};this.set1DXYDimensionsLeft=function(){if(this.graphOrientation=="vertical"){this.left=this.margin+this.getAxisTitleTickLength()}else{if(this.smpDendrogramPosition=="right"){this.left=this.margin+this.getSampleTitleHeight()+this.getSampleLabelLength()+this.getSmpOverlaysLength()}else{this.left=this.margin+this.getSampleTitleHeight()+this.getSmpTreeWidthHeight()+this.getSampleLabelLength()+this.getSmpOverlaysLength()}}};this.set1DXYDimensionsRight=function(){if(this.graphOrientation=="vertical"){this.right=this.margin+this.getAxisTitleTickLength()}else{if(this.smpDendrogramPosition=="right"){this.right=this.margin+this.getSmpTreeWidthHeight()}else{this.right=this.margin}}if(this.showLegend&&this.legendPosition=="right"){this.right+=this.getLegendWidth()}if(this.graphType=="Heatmap"){var b=this.getSampleLabelDescLength();var a=0;if(this.showOverlays){a=this.getVarOverlaysLength()}this.right+=Math.max(b,a)}};this.set1DXYDimensionsTop=function(){this.top=this.margin;if(this.title){this.top+=this.titleHeight+this.margin;if(this.subtitle){this.top+=this.subtitleHeight+this.margin}}if(this.graphOrientation=="vertical"){if(this.smpDendrogramPosition!="bottom"){this.top+=this.getSmpTreeWidthHeight()}}else{if(this.graphType=="Heatmap"){this.top+=this.getHeatmapIndicatorHeight();if(this.varDendrogramPosition!="bottom"){this.top+=this.getVarTreeHeight()}if(this.varTitleLabelOverlayPosition!="bottom"){this.top+=this.getVariableTitleHeight();this.top+=this.getVariableLabelLength();this.top+=this.getVarOverlaysHeight()}else{this.top+=this.getVariableLabelDescLength()}}else{this.top+=this.getAxisTitleTickLength()}}};this.set1DXYDimensionsBottom=function(){this.bottom=this.margin;if(this.graphOrientation=="vertical"){this.bottom+=this.getSampleTitleHeight()+this.getSampleLabelLength()+this.getSmpOverlaysLength();if(this.smpDendrogramPosition=="bottom"){this.bottom+=this.getSmpTreeWidthHeight()}if(this.showLegend&&this.legendPosition=="bottom"){this.bottom+=this.getLegendHeight()}}else{if(this.graphType=="Heatmap"){if(this.varTitleLabelOverlayPosition=="bottom"){this.bottom+=this.getVarOverlaysHeight();this.bottom+=this.getVariableLabelLength();this.bottom+=this.getVariableTitleHeight()}else{this.bottom+=Math.max(this.getVariableLabelDescLength(),this.getSmpOverlaysStrLength())}if(this.varDendrogramPosition=="bottom"){this.bottom+=this.getVarTreeHeight()}}else{this.bottom+=this.getAxisTitleTickLength();if(this.showLegend&&this.legendPosition=="bottom"){this.bottom+=this.getLegendHeight()}}}};this.set1DXYDimensions=function(a){if(this.isGraphTime){if(!this.showVolume||(this.layoutComb&&this.layoutCurrent==0)){this.setTimeAxis()}}if(!a){this.setRowColBlocks();this.set1DVarSmpLabelFont()}if(this.graphOrientation=="vertical"){this.set1DXYDimensionsTop();this.set1DXYDimensionsBottom();if(this.autoAdjust){this.y=this.layoutComb?this.layoutHeight-(this.top+this.bottom):this.height-(this.marginTop+this.top+this.bottom+this.marginBottom)}if(this.y<0){this.showLegend=false;this.smpLabelDescription=false;this.varLabelDescription=false;this.set1DXYDimensionsTop();this.set1DXYDimensionsBottom();this.y=this.layoutComb?this.layoutHeight-(this.top+this.bottom):this.height-(this.marginTop+this.top+this.bottom+this.marginBottom);if(this.debug){if(this.y<0){if(!this.onceIsEnough){alert("Dude this text size doesn't fit in the graph. Either make it smaller or make the graph bigger!\nYou can also reduce the maximum length for the text string!")}this.onceIsEnough=true}else{alert("Dude the legend and/or the description were taken out because they didn't fit in the graph!")}}}this.set1DText();this.set1DXYDimensionsLeft();this.set1DXYDimensionsRight();if(this.autoAdjust){this.x=this.layoutComb?this.layoutWidth-(this.left+this.right):this.width-(this.marginLeft+this.left+this.right+this.marginRight)}if(this.x<0){this.showLegend=false;this.smpLabelDescription=false;this.varLabelDescription=false;this.set1DXYDimensionsLeft();this.set1DXYDimensionsRight();this.x=this.layoutComb?this.layoutWidth-(this.left+this.right):this.width-(this.marginLeft+this.left+this.right+this.marginRight);if(this.debug){if(this.x<0){if(!this.onceIsEnough){alert("Dude this text size doesn't fit in the graph. Either make it smaller or make the graph bigger!\nYou can also reduce the maximum length for the text string!")}this.onceIsEnough=true}else{alert("Dude the legend and/or the description were taken out because they didn't fit in the graph!")}}}}else{this.set1DXYDimensionsLeft();this.set1DXYDimensionsRight();if(this.autoAdjust){this.x=this.layoutComb?this.layoutWidth-(this.left+this.right):this.width-(this.marginLeft+this.left+this.right+this.marginRight)}if(this.x<0){this.showLegend=false;this.smpLabelDescription=false;this.varLabelDescription=false;this.set1DXYDimensionsLeft();this.set1DXYDimensionsRight();this.x=this.layoutComb?this.layoutWidth-(this.left+this.right):this.width-(this.marginLeft+this.left+this.right+this.marginRight);if(this.debug){if(this.x<0){if(!this.onceIsEnough){alert("Dude this text size doesn't fit in the graph. Either make it smaller or make the graph bigger!\nYou can also reduce the maximum length for the text string!")}this.onceIsEnough=true}else{alert("Dude the legend and/or the description were taken out because they didn't fit in the graph!")}}}this.set1DText();this.set1DXYDimensionsTop();this.set1DXYDimensionsBottom();if(this.autoAdjust){this.y=this.layoutComb?this.layoutHeight-(this.top+this.bottom):this.height-(this.marginTop+this.top+this.bottom+this.marginBottom)}if(this.y<0){this.showLegend=false;this.smpLabelDescription=false;this.varLabelDescription=false;this.set1DXYDimensionsTop();this.set1DXYDimensionsBottom();this.y=this.layoutComb?this.layoutHeight-(this.top+this.bottom):this.height-(this.marginTop+this.top+this.bottom+this.marginBottom);if(this.debug){if(this.y<0){if(!this.onceIsEnough){alert("Dude this text size doesn't fit in the graph. Either make it smaller or make the graph bigger!\nYou can also reduce the maximum length for the text string!")}this.onceIsEnough=true}else{alert("Dude the legend and/or the description were taken out because they didn't fit in the graph!")}}}if(this.graphType=="Heatmap"&&!this.layoutComb&&this.autoAdjust){if(this.bottom>this.y*0.5){if(this.dendrogramSpace>2){this.dendrogramSpace-=2}var b=this.getFontPt(this.varLabelFont)-1;this.varLabelFont=b.toString()+"pt "+this.fontName;this.resizeCanvas(true);this.set1DXYDimensions(true)}}if(this.left>this.x*0.5&&!this.layoutComb&&this.autoAdjust){if(this.dendrogramSpace>2){this.dendrogramSpace-=2}var b=this.getFontPt(this.smpLabelFont)-1;this.smpLabelFont=b.toString()+"pt "+this.fontName;this.resizeCanvas(true);this.set1DXYDimensions(true)}this.onceIsEnough=false}};this.set1DPrivateParams=function(){var a=this.isGroupedData?this.grpIndices.length:this.smpIndices.length;if(!this.autoAdjust){this.rowBlockSize=this.scaleTextToSize(this.rowBlocks)+this.scaleTextConstantAdd;this.rowBlockSize*=this.blockFactor;if(this.graphType=="Heatmap"){if(this.colBlocks<20){this.colBlockSize=this.scaleTextToSize(this.colBlocks)+this.scaleTextConstantAdd+(this.scaleTextConstantAdd*3)}else{this.colBlockSize=(parseInt(1/Math.sqrt(this.colBlocks)*this.scaleTextConstantMult))+1}this.colBlockSize*=this.blockFactor;this.blockSeparation=this.rowBlockSize/2;this.y=this.rowBlockSize*this.rowBlocks;this.x=this.colBlockSize*this.colBlocks}else{this.blockSeparation=this.rowBlockSize*this.blockSeparationFactor;if(this.graphOrientation=="vertical"){if(this.graphType.match(/Area/)){this.x=(this.rowBlockSize*(this.rowBlocks-1))+(this.blockSeparation*(a-1))}else{this.x=(this.rowBlockSize*this.rowBlocks)+(this.blockSeparation*a)+this.blockSeparation}}else{if(this.graphType.match(/Area/)){this.y=(this.rowBlockSize*(this.rowBlocks-1))+(this.blockSeparation*(a-1))}else{this.y=(this.rowBlockSize*this.rowBlocks)+(this.blockSeparation*a)+this.blockSeparation}}this.colBlockSize=1}this.width=this.marginLeft+((this.left+this.x+this.right)*this.layoutCols)+this.marginRight;this.height=this.marginTop+((this.top+this.y+this.bottom)*this.layoutRows)+this.marginBottom;this.resizeCanvas()}else{if(this.graphType=="Heatmap"){this.rowBlockSize=this.y/this.rowBlocks;this.blockSeparation=this.rowBlockSize;this.colBlockSize=this.x/this.varIndices.length}else{if(this.graphType.match(/Area/)){this.rowBlockSize=this.graphOrientation=="vertical"?this.x/(this.rowBlocks+a-2):this.y/(this.rowBlocks+a-2)}else{this.rowBlockSize=this.graphOrientation=="vertical"?this.x/(this.rowBlocks+a+1):this.y/(this.rowBlocks+a+1)}this.blockSeparation=this.rowBlockSize;this.colBlockSize=1}}};this.setTrees=function(){if(this.showSmpDendrogram&&this.data.t.smps){this.smpDendrogram={};this.smpDendrogram.data=[];this.smpDendrogram.nodes=[];this.smpDendrogram.idxs=[];this.smpDendrogram.heights=[];this.parseNewick(this.data.t.smps,"smpDendrogram")}if(this.showVarDendrogram&&this.data.t.vars){this.varDendrogram={};this.varDendrogram.data=[];this.varDendrogram.nodes=[];this.varDendrogram.idxs=[];this.varDendrogram.heights=[];this.parseNewick(this.data.t.vars,"varDendrogram")}};this.parseNewick=function(b,d){var o=b.split(/,/);var u=0;var e=0;var f=0;var l=1;var k=0;var t=0;var a=0;var h=0;for(var r=0;r<o.length;r++){var p=o[r];var g=p.split(/:(?=[0-9\.]+)/);var v=g.shift();v=v.replace(/[\(\)]/g,"");if(this.useSmpVarIndexOnClustering){this[d].nodes.push(d=="smpDendrogram"?this.data.y.smps[v]:this.data.y.vars[v]);this[d].idxs.push(v)}else{this[d].nodes.push(v);this[d].idxs.push(d=="smpDendrogram"?this.getSampleIndices(v):this.getVariableIndices(v))}for(var q=0;q<g.length;q++){var c=g[q].replace(/[\(\)]/g,"");t=Math.max(t,c);this[d].heights.push(c)}this[d].max=t;var s=o[r].split("");e=0;for(var q=0;q<s.length;q++){if(s[q]=="("){u++;e++}if(s[q]==")"){u--;e--}}h+=e;if(f>u){this[d].data.push([l,f,e,h])}else{this[d].data.push([l,u,e,h])}f=u;a=Math.max(a,f);k+=e;l++}this[d].unit=t>0?(a*this.dendrogramSpace)/t:0;this[d].depth=a;if(k>0){alert("Dude! Malformed newick tree. There are "+k+" additional right parenthesis!")}else{if(k<0){alert("Dude! Malformed newick tree. There are "+Math.abs(k)+" additional left parenthesis!")}}if(d=="varDendrogram"){if(this.varIndicesStart<0){if(this[d].nodes.length!=this.data.y.vars.length){alert("Dude! The length of the variable nodes in the dendrogram ("+this[d].nodes.length+") is different to that one in the data ("+this.data.y.vars.length+"). This ain't gonna work!");this.showVarDendrogram=false}else{if(this[d].nodes.length!=this.varIndices.length){alert("Ooops! Cannot show dendrogram with "+this[d].nodes.length+" nodes when only "+this.varIndices.length+" variables are visible.");this.showVarDendrogram=false}else{this.varIndices=this[d].idxs}}}else{var m=this.varIndicesStart+this.varIndices.length;this.varIndices=[];for(var r=this.varIndicesStart;r<m;r++){this.varIndices.push(this[d].idxs[r])}}}else{if(this.smpIndicesStart<0){if(this[d].nodes.length!=this.data.y.smps.length){alert("Dude! The length of the sample nodes in the dendrogram ("+this[d].nodes.length+") is different to that one in the data ("+this.data.y.smps.length+"). This ain't gonna work!");this.showSmpDendrogram=false}else{if(this[d].nodes.length!=this.smpIndices.length){alert("Ooops! Cannot show dendrogram with "+this[d].nodes.length+" nodes when only "+this.smpIndices.length+" samples visible.");this.showSmpDendrogram=false}else{this.smpIndices=this[d].idxs}}}else{var m=this.smpIndicesStart+this.smpIndices.length;this.smpIndices=[];for(var r=this.smpIndicesStart;r<m;r++){this.smpIndices.push(this[d].idxs[r])}}}};this.setOverlayColors=function(){var l=0;if(this.smpOverlays.length>0&&!this.isGroupedData){this.smpOverlayColors=[];for(var g=0;g<this.smpOverlays.length;g++){var a={};this.smpOverlayColors[g]=[];var f=this.smpOverlays[g];if(this.data.x.hasOwnProperty(f)){if(this.isNumeric(this.data.x[f],true)){var h=this.range(this.data.x[f],true);for(var e=0;e<this.smpIndices.length;e++){var k=this.smpIndices[e];var d=this.data.x[f][k];var c=!isNaN(d)?this.getHeatmapColor(h[0],h[1],d):this.missingDataColor;this.smpOverlayColors[g].push(c)}}else{for(var e=0;e<this.smpIndices.length;e++){var k=this.smpIndices[e];var b=this.data.x[f][k];if(!a.hasOwnProperty(b)){a[b]=l%this.colors.length;l++}this.smpOverlayColors[g].push(this.colors[a[b]])}}}}}l=0;if(this.varOverlays.length>0&&this.graphType=="Heatmap"){this.varOverlayColors=[];for(var g=0;g<this.varOverlays.length;g++){var a={};this.varOverlayColors[g]=[];var f=this.varOverlays[g];if(this.data.z.hasOwnProperty(f)){if(this.isNumeric(this.data.z[f],true)){var h=this.range(this.data.z[f],true);for(var e=0;e<this.varIndices.length;e++){var k=this.varIndices[e];var d=this.data.z[f][k];var c=!isNaN(d)?this.getHeatmapColor(h[0],h[1],d):this.missingDataColor;this.varOverlayColors[g].push(c)}}else{for(var e=0;e<this.varIndices.length;e++){var k=this.varIndices[e];var b=this.data.z[f][k];if(!a.hasOwnProperty(b)){a[b]=l%this.colors.length;l++}this.varOverlayColors[g].push(this.colors[a[b]])}}}}}};this.setOverlayFont=function(){var a=Math.min(this.overlayScaleFontFactor*this.overlayFontSize,this.maxTextSize);a=parseInt(Math.max(a,this.minTextSize));this.overlayFont=(a)+"Pt "+this.fontName};this.set1DAttributes=function(){this.setLegendFont();this.setTrees();this.setOverlayColors();this.setOverlayFont();this.setDataColor(true)};this.set1DXAxis=function(){var a=this.graphOrientation=="vertical"?"y":"x";this.setAxisUnits("xAxis",a);if((this.graphType.match(/BarLine|AreaLine|StackedLine|StackedPercentLine/)&&this.data.a)||(this.graphType=="Candlestick"&&this.showVolume)){this.setAxisUnits("xAxis2",a)}};this.draw1DWireFrame=function(){var s,d,r,c,q,a,e,h,p;var f=this.isGroupedData?this.grpIndices:this.smpIndices;var u=this.xAxisTickStyle=="dotted"||this.yAxisTickStyle=="dotted"?"dottedLine":"line";var v=this.smpHairline=="dotted"?"dottedLine":"line";var m=this.marginLeft+this.offsetX+this.left;var k=this.marginTop+this.offsetY+this.top;if(this.graphType!="Heatmap"){if(this.graphType=="BarLine"&&this.data.a&&this.data.y.desc[1]){var b=this.getVariablesVisibleByAxis("xAxis");p=b.length}else{if(this.graphType.match(/Stacked|Line|Area/)){p=1}else{p=this.varIndices.length}}h=p*this.rowBlockSize;if(this.graphOrientation=="vertical"){if(this.isGraphTime){var g=(this.x-this.blockSeparation)/f.length;var n=g/2;var j=this.graphType.match(/Area/)?0:m+(this.blockSeparation*0.5)+n;d=k;c=k+this.y;for(var o=0;o<this.timeValueIndices.length;o++){s=(this.timeValueIndices[o]*g)+j;if(this.smpHairline){this.drawLine(v,s,d,s,c,this.smpHairlineColor,false,"butt")}}}else{s=this.graphType.match(/Area/)?m:m+this.blockSeparation+(h/2);r=m;q=this.graphType.match(/Area/)?m+this.blockSeparation+h:m+(this.blockSeparation*1.5)+h;d=k;c=k+this.y;for(var o=0;o<f.length;o++){if(this.blockContrast){e=o%2?this.evenColor:this.oddColor;this.ctx.save();this.rectangle(r,d,q,c,e,e);this.ctx.restore();r=q;q=r+this.blockSeparation+h}if(this.smpHairline){if(this.graphType.match(/Area/)&&(o==0||o==f.length-1)){s+=this.blockSeparation+h;continue}this.drawLine(v,s,d,s,c,this.smpHairlineColor,false,"butt")}s+=this.blockSeparation+h}}if((this.xAxisMinorTicks||this.xAxis2MinorTicks)&&this.summaryType!="volume"){for(var o=0;o<this.xAxisMinorValues.length;o++){var w=parseFloat(this.xAxisMinorValues[o]);d=this.marginTop+this.offsetY+this.top+this.y-((w-this.xAxisMin)*this.xAxisUnit);this.drawLine(u,m,d,m+this.x,d,this.xAxisTickColor,this.outlineWidth/3,"butt")}}s=this.marginLeft+this.offsetX+this.left-(this.margin*2);for(var o=0;o<this.xAxisValues.length;o++){var w=parseFloat(this.xAxisValues[o]);d=this.marginTop+this.offsetY+this.top+this.y-((w-this.xAxisMin)*this.xAxisUnit);this.drawLine(u,m,d,m+this.x,d,this.xAxisTickColor,false,"butt")}}else{if(this.isGraphTime){var g=(this.y-this.blockSeparation)/f.length;var n=g/2;var j=this.graphType.match(/Area/)?0:k+(this.blockSeparation*0.5)+n;s=m;r=m+this.x;for(var o=0;o<this.timeValueIndices.length;o++){d=(this.timeValueIndices[o]*g)+j;if(this.smpHairline){this.drawLine(v,s,d,r,d,this.smpHairlineColor,false,"butt")}}}else{s=m;r=m+this.x;d=this.graphType.match(/Area/)?k:k+this.blockSeparation+(h/2);c=k;a=this.graphType.match(/Area/)?k+this.blockSeparation+h:k+(this.blockSeparation*1.5)+h;for(var o=0;o<f.length;o++){if(this.blockContrast){e=o%2?this.evenColor:this.oddColor;this.ctx.save();this.rectangle(s,c,r,a,e,e);this.ctx.restore();c=a;a=c+this.blockSeparation+h}if(this.smpHairline){if(this.graphType.match(/Area/)&&(o==0||o==f.length-1)){d+=this.blockSeparation+h;continue}this.drawLine(v,s,d,r,d,this.smpHairlineColor,false,"butt")}d+=this.blockSeparation+h}}if((this.xAxisMinorTicks||this.xAxis2MinorTicks)&&this.summaryType!="volume"){for(var o=0;o<this.xAxisMinorValues.length;o++){var w=parseFloat(this.xAxisMinorValues[o]);s=m+((w-this.xAxisMin)*this.xAxisUnit);this.drawLine(u,s,k,s,k+this.y,this.xAxisTickColor,this.outlineWidth/3,"butt")}}d=this.marginTop+this.offsetY+this.top-((this.margin*2)+(this.getFontPt(this.axisTickFont)/2));for(var o=0;o<this.xAxisValues.length;o++){var w=parseFloat(this.xAxisValues[o]);s=m+((w-this.xAxisMin)*this.xAxisUnit);this.drawLine(u,s,k,s,k+this.y,this.xAxisTickColor,false,"butt")}}}};this.drawTrees=function(){if(!this.isGroupedData){this.drawDendrogram("smpDendrogram");if(this.graphType=="Heatmap"){this.drawDendrogram("varDendrogram")}this.maskTreeArea()}};this.getMaxDepthDendrogramXYs=function(c){if(c.length>0){var a=[];for(var b=0;b<c.length;b++){a.push(c[b][1])}a.sort(function(e,d){return d-e});for(var b=0;b<c.length;b++){if(c[b][1]==a[0]){return b}}}else{return -1}};this.drawDendrogram=function(F){var Y=this.marginLeft+this.offsetX+this.left;var T=this.marginTop+this.offsetY+this.top;var K=F=="varDendrogram"?"showVarDendrogram":"showSmpDendrogram";var f=F=="varDendrogram"?this.varIndices:this.smpIndices;var B,a,A,ag,ae,G;var E=false;var W=this.dendrogramSpace/2;if(this.graphType!="Heatmap"){if(this.graphType=="BarLine"&&this.data.a&&this.data.y.desc[1]){var F=this.getVariablesVisibleByAxis("xAxis");G=F.length}else{if(this.graphType.match(/Stacked|Line|Area/)){G=1}else{G=this.varIndices.length}}ae=G*this.rowBlockSize}else{ae=0}if(this[K]&&this[F]){var D=this[F].data;var af=this[F].idxs;var G=this[F].depth;var o=this.getMaxDepthDendrogramXYs(D);var g=this[F].heights;var e=this[F].max;var m={};var v={};var d=[];if(F=="varDendrogram"){for(var ad=0;ad<D.length;ad++){d[ad]=this.createNode(this.data.y.vars[af[ad]],null,null,0,null)}}else{for(var ad=0;ad<D.length;ad++){d[ad]=this.createNode(this.data.y.smps[af[ad]],null,null,0,null)}}while(D.length>1){ad=o;var k=[ad];var P=D[ad][0];var O=D[ad][1];var N=D[ad][2];var R=D[ad][3];var q=[P];var p=[O];var n=[N];var s=[R];var H={};var V="";var C=N;H[ad]=1;for(var ab=ad+1;ab<D.length;ab++){var aa=D[ab][0];var Z=D[ab][1];var X=D[ab][2];var ac=D[ab][3];if(Z==O&&((X==0&&ac<=R)||(ac<R))){q.push(aa);p.push(Z);n.push(X);s.push(ac);C+=X;H[ab]=1;k.push(ab)}else{break}}if(q.length>1){if(F=="varDendrogram"){var h=this.colBlockSize/2;var Q;if(this.varDendrogramPosition=="bottom"){if(this.varTitleLabelOverlayPosition!="bottom"){Q=(T+this.y+this.bottom)-(this.margin+(this.dendrogramSpace*(G+1)))}else{Q=(T+this.y+this.bottom)-(this.margin+(this.dendrogramSpace*(G+1))+this.getVariableTitleHeight())}}else{if(this.varTitleLabelOverlayPosition!="bottom"){Q=T-(this.getVarOverlaysHeight()+this.getVariableLabelLength()+this.getVarTreeHeight())}else{Q=T-(this.margin+this.getVarTreeHeight()+this.getVariableLabelDescLength())}}if(!E&&this.modelEvent=="global"){this.addGlobalArea(["rect",Y,Q,Y+this.x,Q+this.getVarTreeHeight()],true);E=true}for(var ad=0;ad<q.length;ad++){d[k[ad]].dist=g[k[ad]];B=(Y+h)+(this.colBlockSize*(q[ad]-1));B=this.varIndicesStart>-1?B-(this.colBlockSize*this.varIndicesStart):B;if(this.varDendrogramPosition=="bottom"){if(this.varTitleLabelOverlayPosition!="bottom"){ag=this.height-(this.marginBottom+this.margin+(this.dendrogramSpace*p[ad]))}else{ag=this.height-(this.marginBottom+this.margin+(this.dendrogramSpace*p[ad])+this.getVariableTitleHeight())}if(this.dendrogramHeight){}else{if(this.isLeafNode(d[k[ad]])&&!this.dendrogramHang){a=Q}else{a=ag-this.dendrogramSpace}}}else{a=Q+(this.dendrogramSpace*p[ad]);if(this.dendrogramHeight){}else{if(this.isLeafNode(d[k[ad]])&&!this.dendrogramHang){ag=Q+(this.dendrogramSpace*(G+1))}else{ag=a+this.dendrogramSpace}}}this.drawLine("line",B,a,B,ag,this.foreground,false,"butt",false,false,true,[0,0,this.width,this.height]);if(!m.hasOwnProperty(R)){m[R]=0}if(!this.isLeafNode(d[k[ad]])){this.addArea(["rect",B-W,ag-W,B+W,ag+W],[-R],"-"+m[R]+"-varDendrogram");m[R]++}if(ad<q.length-1){A=(Y+h)+(this.colBlockSize*(q[ad+1]-1));A=this.varIndicesStart>-1?A-(this.colBlockSize*this.varIndicesStart):A;if(this.varDendrogramPosition=="bottom"){this.drawLine("line",B,ag,A,ag,this.foreground,false,"butt",false,false,true,[0,0,this.width,this.height])}else{this.drawLine("line",B,a,A,a,this.foreground,false,"butt",false,false,true,[0,0,this.width,this.height])}}}}else{if(this.graphOrientation=="vertical"){var Q;if(this.smpDendrogramPosition=="bottom"){Q=(T+this.y+this.bottom)-(this.margin+this.getSampleTitleHeight()+(this.dendrogramSpace*(G+1)));if(this.showLegend&&this.legendPosition=="bottom"){Q-=this.getLegendHeight()}}else{Q=T-this.getSmpTreeWidthHeight()}if(!E&&this.modelEvent=="global"){this.addGlobalArea(["rect",Y,Q,Y+this.x,Q+this.getSmpTreeWidthHeight()],true);E=true}for(var ad=0;ad<q.length;ad++){d[k[ad]].dist=g[k[ad]];B=(Y+this.blockSeparation+(ae/2))+((this.blockSeparation+ae)*(q[ad]-1));B=this.smpIndicesStart>-1?B-((this.blockSeparation+ae)*this.smpIndicesStart):B;if(this.smpDendrogramPosition=="bottom"){ag=this.height-(this.marginBottom+this.margin+(this.dendrogramSpace*p[ad]));if(this.showLegend&&this.legendPosition=="bottom"){ag-=this.getLegendHeight()}if(this.dendrogramHeight){}else{if(this.isLeafNode(d[k[ad]])&&!this.dendrogramHang){a=Q}else{a=ag-this.dendrogramSpace}}}else{a=Q+(this.dendrogramSpace*p[ad]);if(this.dendrogramHeight){}else{if(this.isLeafNode(d[k[ad]])&&!this.dendrogramHang){ag=Q+(this.dendrogramSpace*(G+1))}else{ag=a+this.dendrogramSpace}}}this.drawLine("line",B,a,B,ag,this.foreground,false,"butt",false,false,true,[0,0,this.width,this.height]);if(!m.hasOwnProperty(R)){m[R]=0}if(!this.isLeafNode(d[k[ad]])){this.addArea(["rect",B-W,ag-W,B+W,ag+W],[-R],"-"+m[R]+"-smpDendrogram");m[R]++}if(ad<q.length-1){A=(Y+this.blockSeparation+(ae/2))+((this.blockSeparation+ae)*(q[ad+1]-1));A=this.smpIndicesStart>-1?A-((this.blockSeparation+ae)*this.smpIndicesStart):A;if(this.smpDendrogramPosition=="bottom"){this.drawLine("line",B,ag,A,ag,this.foreground,false,"butt",false,false,true,[0,0,this.width,this.height])}else{this.drawLine("line",B,a,A,a,this.foreground,false,"butt",false,false,true,[0,0,this.width,this.height])}}}}else{if(this.smpDendrogramPosition=="right"){Q=Y+this.x+this.getSampleLabelDescLength()+this.margin}else{Q=this.marginLeft+this.offsetX+this.margin+this.getSampleTitleHeight()}if(!E&&this.modelEvent=="global"){this.addGlobalArea(["rect",Q,T,Q+this.getSmpTreeWidthHeight(),T+this.y],true);E=true}for(var ad=0;ad<q.length;ad++){d[k[ad]].dist=g[k[ad]];if(this.smpDendrogramPosition=="right"){A=(Y+this.x+this.getSampleLabelDescLength()+this.margin)+((this.dendrogramSpace*(G+1))-(this.dendrogramSpace*p[ad]))}else{B=this.marginLeft+this.offsetX+this.margin+this.getSampleTitleHeight()+(this.dendrogramSpace*p[ad])}if(this.graphType=="Heatmap"){a=(T+this.blockSeparation)+(this.rowBlockSize*(q[ad]-1));a=this.smpIndicesStart>-1?a-(this.rowBlockSize*this.smpIndicesStart):a;if(this.autoAdjust){a-=this.blockSeparation/2}}else{a=(T+this.blockSeparation+(ae/2))+((this.blockSeparation+ae)*(q[ad]-1));a=this.smpIndicesStart>-1?a-((this.blockSeparation+ae)*this.smpIndicesStart):a}if(this.smpDendrogramPosition=="right"){if(this.dendrogramHeight){}else{if(this.isLeafNode(d[k[ad]])&&!this.dendrogramHang){B=Y+this.x+this.getSampleLabelDescLength()+this.margin}else{B=A-this.dendrogramSpace}}}else{if(this.dendrogramHeight){}else{if(this.isLeafNode(d[k[ad]])&&!this.dendrogramHang){A=this.marginLeft+this.offsetX+this.margin+this.getSampleTitleHeight()+(this.dendrogramSpace*(G+1))}else{A=B+this.dendrogramSpace}}}this.drawLine("line",B,a,A,a,this.foreground,false,"butt",false,false,true,[0,0,this.width,this.height]);if(!m.hasOwnProperty(R)){m[R]=0}if(!this.isLeafNode(d[k[ad]])){this.addArea(["rect",A-W,a-W,A+W,a+W],[-R],"-"+m[R]+"-smpDendrogram");m[R]++}if(ad<q.length-1){if(this.graphType=="Heatmap"){ag=(T+this.blockSeparation)+(this.rowBlockSize*(q[ad+1]-1));ag=this.smpIndicesStart>-1?ag-(this.rowBlockSize*this.smpIndicesStart):ag;if(this.autoAdjust){ag-=this.blockSeparation/2}}else{ag=(T+this.blockSeparation+(ae/2))+((this.blockSeparation+ae)*(q[ad+1]-1));ag=this.smpIndicesStart>-1?ag-((this.blockSeparation+ae)*this.smpIndicesStart):ag}if(this.smpDendrogramPosition=="right"){this.drawLine("line",A,a,A,ag,this.foreground,false,"butt",false,false,true,[0,0,this.width,this.height])}else{this.drawLine("line",B,a,B,ag,this.foreground,false,"butt",false,false,true,[0,0,this.width,this.height])}}}}}var J,M;var b=[];var I=[];var S=[];var L=[];var u=this.mean(q);var c=false;if(!v.hasOwnProperty(R)){v[R]=0}V=(R-1)+"-"+v[R];for(var U in H){L.push(d[U])}for(var ab=0;ab<D.length;ab++){if(!H.hasOwnProperty(ab)){b.push(D[ab]);I.push(d[ab])}else{if(!c){b.push([u,O-1,C,s[s.length-1]]);J=L.shift();M=L.pop();if(L.length>0){I.push(this.createNode(V,J,M,0,null,L))}else{I.push(this.createNode(V,J,M,0,null))}v[R]++;c=true}}}for(var ab=0;ab<g.length;ab++){if(!H.hasOwnProperty(ab)){S.push(g[ab])}}D=b;d=I;g=S;o=this.getMaxDepthDendrogramXYs(D)}}this[F].object=d[0]}};this.draw1DYLayout=function(){var D,d,C,c,B,b,m,z;var u=this.marginLeft+this.offsetX+this.left;var p=this.marginTop+this.offsetY+this.top;if(this.smpTitle){var r=(parseInt(this.smpTitleFontSize*this.smpTitleScaleFontFactor))+"Pt "+this.fontName;if(this.graphOrientation=="vertical"){D=u+(this.x/2);d=(p+this.y+this.bottom)-(this.margin+(parseInt(this.smpTitleFontSize*this.smpTitleScaleFontFactor)/2));if(this.legendPosition=="bottom"){d-=this.getLegendHeight()}this.drawText(this.smpTitle,D,d,r,this.smpTitleFontColor,"center","middle")}else{D=this.marginLeft+this.offsetX+(parseInt(this.smpTitleFontSize*this.smpTitleScaleFontFactor)/2);d=p+(this.y/2);this.drawText(this.smpTitle,D,d,r,this.smpTitleColor,"center","middle",-Math.PI/2)}}if(this.showSampleNames){var g=this.isGroupedData?this.grpIndices:this.smpIndices;var q=this.isGroupedData?this.data.w.smps:this.data.y.smps;if(this.graphType=="Heatmap"){var x=Math.abs(this.smpLabelRotate)==90?"center":"right";if(this.isGraphTime){var h=this.y/g.length;var w=h/2;var n=p+w;D=(u)-(this.margin*2);C=u+this.x+this.margin;for(var y=0;y<this.timeValueIndices.length;y++){d=(this.timeValueIndices[y]*h)+n;if(this.smpLabelRotate){this.addArea(this.drawText(this.timeValues[y],D-this.margin,d,this.smpLabelFont,e,x,"middle",this.smpLabelRotate*Math.PI/180),["Smp-"+y])}else{this.addArea(this.drawText(this.timeValues[y],D,d,this.smpLabelFont,e,"right","middle"),["Smp-"+y])}if(this.smpLabelDescription){var k=this.shortenText(this.data.x[this.smpLabelDescription][g[y]],this.maxSmpStringLen);this.drawText(k,C,d,this.smpLabelFont,e,"right","middle")}}}else{D=u;C=u+this.x+this.margin;d=p+this.blockSeparation;d-=this.blockSeparation/2;z=1;var f=this.getSmpOverlaysLength();for(var y=0;y<g.length;y++){var o=g[y];var k=this.shortenText(q[o],this.maxSmpStringLen);var A=(this.margin*2)+f;var e=this.getSmpColor(q[o]);if(this.smpLabelRotate){this.addArea(this.drawText(k,D-(A+this.margin),d,this.smpLabelFont,e,x,"middle",this.smpLabelRotate*Math.PI/180),["Smp-"+o])}else{this.addArea(this.drawText(k,D-A,d,this.smpLabelFont,e,"right","middle"),["Smp-"+o])}if(this.smpLabelDescription){var k=this.shortenText(this.data.x[this.smpLabelDescription][o],this.maxSmpStringLen);this.drawText(k,C,d,this.smpLabelFont,e,"left","middle")}d+=this.rowBlockSize}}var w=this.colBlockSize/2;D=u+w;if(this.varTitleLabelOverlayPosition!="bottom"){var x=Math.abs(this.varLabelRotate)==90?"center":"left";d=p;d-=(this.margin+this.getVarOverlaysHeight());c=p+this.y+this.margin;for(var y=0;y<this.varIndices.length;y++){var o=this.varIndices[y];var s=this.shortenText(this.data.y.vars[o],this.maxVarStringLen);var e=this.getVarColor(this.data.y.vars[o]);if(this.varLabelRotate){this.addArea(this.drawText(s,D,d,this.varLabelFont,e,x,"middle",-Math.PI/2+(this.varLabelRotate*Math.PI/180)),["Var-"+o])}else{this.addArea(this.drawText(s,D,d,this.varLabelFont,e,"left","middle",-Math.PI/2),["Var-"+o])}if(this.varLabelDescription){var s=this.shortenText(this.data.z[this.varLabelDescription][o],this.maxVarStringLen);this.drawText(s,D,c,this.varLabelFont,e,"right","middle",-Math.PI/2)}D+=this.colBlockSize}}else{var x=Math.abs(this.varLabelRotate)==90?"center":"right";d=p+this.y+this.margin;if(this.varOverlays.length>0){d+=(this.varOverlays.length*this.overlaysWidth)+this.margin}c=p-this.margin;for(var y=0;y<this.varIndices.length;y++){var o=this.varIndices[y];var s=this.shortenText(this.data.y.vars[o],this.maxVarStringLen);var e=this.getVarColor(this.data.y.vars[o]);if(this.varLabelRotate){this.addArea(this.drawText(s,D,d+this.margin,this.varLabelFont,e,x,"middle",-Math.PI/2+(this.varLabelRotate*Math.PI/180)),["Var-"+o])}else{this.addArea(this.drawText(s,D,d,this.varLabelFont,e,"right","middle",-Math.PI/2),["Var-"+o])}if(this.varLabelDescription){var s=this.shortenText(this.data.z[this.varLabelDescription][o],this.maxVarStringLen);this.drawText(s,D,c,this.varLabelFont,e,"left","middle",-Math.PI/2)}D+=this.colBlockSize}}if(this.varTitle){var r=(parseInt(this.varTitleFontSize*this.varTitleScaleFontFactor))+"Pt "+this.fontName;D=u+(this.x/2);if(this.varTitleLabelOverlayPosition!="bottom"){d=this.offsetY+(this.margin*2)+this.top;d-=this.getVariableLabelLength();d-=this.getVarOverlaysHeight();if(this.varDendrogramPosition=="top"){d-=this.getVarTreeHeight()}}else{d=(p+this.y+this.bottom)-this.margin}this.drawText(this.varTitle,D,d,r,this.varTitleColor,"center","bottom")}}else{if(this.graphType=="BarLine"&&this.data.a&&this.data.y.desc[1]){var a=this.getVariablesVisibleByAxis("xAxis");z=a.length}else{if(this.graphType.match(/Stacked|Line|Area/)){z=1}else{z=this.varIndices.length}}m=z*this.rowBlockSize;if(this.graphOrientation=="vertical"){var x=Math.abs(this.smpLabelRotate)==90?"center":"right";if(this.isGraphTime){var h=(this.x-this.blockSeparation)/g.length;var w=h/2;var n=this.graphType.match(/Area/)?0:u+(this.blockSeparation*0.5)+w;d=p+this.y+this.getSmpOverlaysLength()+this.margin+this.margin;for(var y=0;y<this.timeValueIndices.length;y++){D=(this.timeValueIndices[y]*h)+n;if(this.smpHairline){if(this.smpLabelRotate){this.addArea(this.drawText(this.timeValues[y],D,d+this.margin,this.smpLabelFont,e,x,"middle",-Math.PI/2+(this.smpLabelRotate*Math.PI/180)),["Smp-"+y])}else{this.addArea(this.drawText(this.timeValues[y],D,d,this.smpLabelFont,e,"right","middle",-Math.PI/2),["Smp-"+y])}}}}else{D=this.graphType.match(/Area/)?u:u+this.blockSeparation+(m/2);d=p;c=p+this.y;b=c+this.getSmpOverlaysLength()+this.margin+this.margin;for(var y=0;y<g.length;y++){var o=g[y];var k=this.shortenText(q[o],this.maxSmpStringLen);var e=this.getSmpColor(q[o]);if(this.smpLabelRotate){this.addArea(this.drawText(k,D,b+this.margin,this.smpLabelFont,e,x,"middle",-Math.PI/2+(this.smpLabelRotate*Math.PI/180)),["Smp-"+o])}else{this.addArea(this.drawText(k,D,b,this.smpLabelFont,e,"right","middle",-Math.PI/2),["Smp-"+o])}D+=this.blockSeparation+m}}}else{if(this.isGraphTime){var h=(this.y-this.blockSeparation)/g.length;var w=h/2;var n=this.graphType.match(/Area/)?0:p+(this.blockSeparation*0.5)+w;D=(u)-(this.margin*2);for(var y=0;y<this.timeValueIndices.length;y++){d=(this.timeValueIndices[y]*h)+n;if(this.smpLabelRotate){this.addArea(this.drawText(this.timeValues[y],D-this.margin,d,this.smpLabelFont,e,x,"middle",this.smpLabelRotate*Math.PI/180),["Smp-"+y])}else{this.addArea(this.drawText(this.timeValues[y],D,d,this.smpLabelFont,e,"right","middle"),["Smp-"+y])}}}else{D=u;C=u+this.x;B=D-(this.getSmpOverlaysLength()+(this.margin*2));d=this.graphType.match(/Area/)?p:p+this.blockSeparation+(m/2);for(var y=0;y<g.length;y++){var o=g[y];var k=this.shortenText(q[o],this.maxSmpStringLen);var e=this.getSmpColor(q[o]);if(this.smpLabelRotate){this.addArea(this.drawText(k,B-this.margin,d,this.smpLabelFont,e,x,"middle",this.smpLabelRotate*Math.PI/180),["Smp-"+o])}else{this.addArea(this.drawText(k,B,d,this.smpLabelFont,e,"right","middle"),["Smp-"+o])}d+=this.blockSeparation+m}}}}}if(this.showOverlays){if(this.smpOverlays.length>0&&!this.isGroupedData){m=z*this.rowBlockSize;if(this.graphOrientation=="vertical"){D=u;C=m;c=this.overlaysWidth;if(this.graphType!="Heatmap"){D+=this.blockSeparation/2;C+=this.blockSeparation}for(var y=0;y<this.smpIndices.length;y++){d=p+this.y+this.margin;for(var v=0;v<this.smpOverlays.length;v++){this.rectangle(D,d,C,c,this.smpOverlayColors[v][y]);if(m>this.overlaysWidth){this.drawText(this.data.x[this.smpOverlays[v]][this.smpIndices[y]],D+(C/2),d+(c/2),this.overlayFont,this.overlayFontColor,"center","middle",false,m-2)}else{this.drawText(this.data.x[this.smpOverlays[v]][this.smpIndices[y]],D+(C/2),d+(c/2),this.overlayFont,this.overlayFontColor,"center","middle",-Math.PI/2,this.overlaysWidth-2)}d+=c}D+=C}D=u+this.x;d=p+this.y+this.margin+(c/2);for(var y=0;y<this.smpOverlays.length;y++){this.drawText(this.smpOverlays[y],D,d,this.overlayFont,this.overlayFontColor,"left","middle",false,m*2);d+=c}}else{C=this.overlaysWidth;d=p;c=m;if(this.graphType!="Heatmap"){d+=this.blockSeparation/2;c+=this.blockSeparation}for(var y=0;y<this.smpIndices.length;y++){D=u-(this.margin+(this.smpOverlays.length*this.overlaysWidth)+this.margin);for(var v=0;v<this.smpOverlays.length;v++){this.rectangle(D,d,C,c,this.smpOverlayColors[v][y]);if(m>this.overlaysWidth){this.drawText(this.data.x[this.smpOverlays[v]][this.smpIndices[y]],D+(C/2),d+(c/2),this.overlayFont,this.overlayFontColor,"center","middle",-Math.PI/2,m-2)}else{this.drawText(this.data.x[this.smpOverlays[v]][this.smpIndices[y]],D+(C/2),d+(c/2),this.overlayFont,this.overlayFontColor,"center","middle",false,this.overlaysWidth-2)}D+=C}d+=c}D=(u+(C/2))-(this.margin+(this.smpOverlays.length*this.overlaysWidth)+this.margin);d=p+this.y;if(this.graphType=="Heatmap"){d+=this.margin}for(var y=0;y<this.smpOverlays.length;y++){this.drawText(this.smpOverlays[y],D,d,this.overlayFont,this.overlayFontColor,"right","middle",-Math.PI/2,m*2);D+=C}}}if(this.varOverlays.length>0&&this.graphType=="Heatmap"){D=u+(this.colBlockSize/2);c=this.overlaysWidth;for(var y=0;y<this.varIndices.length;y++){if(this.varTitleLabelOverlayPosition!="bottom"){d=p-(this.margin+this.overlaysWidth)}else{d=p+this.y+this.margin}for(var v=0;v<this.varOverlays.length;v++){this.rectangle(D-(this.colBlockSize/2),d,this.colBlockSize,c,this.varOverlayColors[v][y]);if(this.colBlockSize>this.overlaysWidth){this.drawText(this.data.z[this.varOverlays[v]][this.varIndices[y]],D,d+(c/2),this.overlayFont,this.overlayFontColor,"center","middle",false,this.colBlockSize-2)}else{this.drawText(this.data.z[this.varOverlays[v]][this.varIndices[y]],D,d+(c/2),this.overlayFont,this.overlayFontColor,"center","middle",-Math.PI/2,this.overlaysWidth-2)}d+=this.overlaysWidth}D+=this.colBlockSize}D=u+this.x+this.margin;if(this.varTitleLabelOverlayPosition!="bottom"){d=(p+(c/2))-(this.margin+this.overlaysWidth)}else{d=p+this.y+this.margin+(c/2)}for(var y=0;y<this.varOverlays.length;y++){this.drawText(this.varOverlays[y],D,d,this.overlayFont,this.overlayFontColor,"left","middle",false,this.colBlockSize*2);d+=c}}}};this.draw1DXLayout=function(){var d=this.marginLeft+this.offsetX+this.left;var m=this.marginTop+this.offsetY+this.top;if(!this.layoutValid){this.layoutAxis=3}if(this.graphType=="Heatmap"){var b=(d+(this.x/2))-(this.heatmapColors.length*this.indicatorWidth/2);var k=m-this.getHeatmapIndicatorHeight();if(this.varDendrogramPosition=="top"){k-=this.getVarTreeHeight()}if(this.varTitleLabelOverlayPosition!="bottom"){k-=this.getVariableTitleHeight();k-=this.getVariableLabelLength();k-=this.getVarOverlaysHeight()}else{k-=this.getVariableLabelDescLength()}this.drawColorIndicator(b,k,this.minData,this.maxData,this.xAxisDecs)}else{var f;var j;if(this.graphOrientation=="vertical"){if(this.layoutAxis==1||this.layoutAxis==3){var b=this.marginLeft+this.offsetX+this.margin+(this.getFontPt(this.axisTitleFont)/2);var k=m+(this.y/2);f=this.graphType=="Candlestick"&&this.summaryType=="volume"?this.xAxis2Title:this.xAxisTitle?this.xAxisTitle:this.data.y.desc&&this.data.y.desc[0]?this.data.y.desc[0]:this.yAxisTitle?this.yAxisTitle:"";if(this.graphType=="BarLine"&&this.data.a&&this.data.y.desc&&this.data.y.desc[1]){this.drawText(f+" (Bars)",b,k,this.axisTitleFont,this.axisTitleColor,"center","middle",-Math.PI/2)}else{if(this.graphType=="AreaLine"&&this.data.a&&this.data.y.desc&&this.data.y.desc[1]){this.drawText(f+" (Area)",b,k,this.axisTitleFont,this.axisTitleColor,"center","middle",-Math.PI/2)}else{this.drawText(f,b,k,this.axisTitleFont,this.axisTitleColor,"center","middle",-Math.PI/2)}}var g=Math.abs(this.tickRotate)==90?"center":"right";j=this.graphType=="Candlestick"&&this.summaryType=="volume"?this.xAxis2Values:this.xAxisValues;b=d-(this.margin*2);for(var e=0;e<j.length-1;e++){var c=parseFloat(j[e]);var h=this.formatAxisValue(c,"xAxis");k=this.graphType=="Candlestick"&&this.summaryType=="volume"?m+this.y-((c-this.xAxis2Min)*this.xAxis2Unit):m+this.y-((c-this.xAxisMin)*this.xAxisUnit);if(this.tickRotate){this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,g,"middle",this.tickRotate*Math.PI/180)}else{this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,"right","middle")}}}if(this.layoutAxis==2||this.layoutAxis==3){var g=Math.abs(this.tickRotate)==90?"center":"left";b=d+this.x+(this.margin*2);if(this.graphType.match(/BarLine|AreaLine|StackedLine|StackedPercentLine/)&&this.data.a&&this.data.y.desc&&this.data.y.desc[1]){for(var e=0;e<this.xAxis2Values.length-1;e++){var c=parseFloat(this.xAxis2Values[e]);var h=this.formatAxisValue(c,"xAxis2");k=m+this.y-((c-this.xAxis2Min)*this.xAxis2Unit);if(this.tickRotate){this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,g,"middle",this.tickRotate*Math.PI/180)}else{this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,"left","middle")}}if(this.graphType.match(/Stacked/)){f=this.data.y.desc&&this.data.y.desc[1]?this.data.y.desc[1]:""}else{f=this.data.y.desc&&this.data.y.desc[1]?this.data.y.desc[1]+" (Lines)":""}}else{j=this.graphType=="Candlestick"&&this.summaryType=="volume"?this.xAxis2Values:this.xAxisValues;for(var e=0;e<j.length-1;e++){var c=parseFloat(j[e]);var h=this.formatAxisValue(c,"xAxis");k=this.graphType=="Candlestick"&&this.summaryType=="volume"?m+this.y-((c-this.xAxis2Min)*this.xAxis2Unit):m+this.y-((c-this.xAxisMin)*this.xAxisUnit);if(this.tickRotate){this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,g,"middle",this.tickRotate*Math.PI/180)}else{this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,"left","middle")}}f=this.graphType=="Candlestick"&&this.summaryType=="volume"?this.xAxis2Title:this.xAxisTitle?this.xAxisTitle:this.data.y.desc&&this.data.y.desc[0]?this.data.y.desc[0]:this.yAxisTitle?this.yAxisTitle:""}b=(d+this.x+this.right)-(this.margin+(this.getFontPt(this.axisTitleFont)/2));if(this.showLegend&&this.legendPosition=="right"){b-=this.getLegendWidth()}k=m+(this.y/2);this.drawText(f,b,k,this.axisTitleFont,this.axisTitleColor,"center","middle",-Math.PI/2)}}else{if(this.layoutAxis==1||this.layoutAxis==3){var b=d+(this.x/2);var k=m-((this.margin*4)+this.getFontPt(this.axisTickFont)+(this.getFontPt(this.axisTitleFont)/2));f=this.graphType=="Candlestick"&&this.summaryType=="volume"?this.xAxis2Title:this.xAxisTitle?this.xAxisTitle:this.data.y.desc&&this.data.y.desc[0]?this.data.y.desc[0]:this.yAxisTitle?this.yAxisTitle:"";if(this.graphType=="BarLine"&&this.data.a&&this.data.y.desc&&this.data.y.desc[1]){this.drawText(f+" (Bars)",b,k,this.axisTitleFont,this.axisTitleColor,"center","middle")}else{if(this.graphType=="AreaLine"&&this.data.a&&this.data.y.desc&&this.data.y.desc[1]){this.drawText(f+" (Area)",b,k,this.axisTitleFont,this.axisTitleColor,"center","middle")}else{this.drawText(f,b,k,this.axisTitleFont,this.axisTitleColor,"center","middle")}}j=this.graphType=="Candlestick"&&this.summaryType=="volume"?this.xAxis2Values:this.xAxisValues;k=m-((this.margin*2)+(this.getFontPt(this.axisTickFont)/2));for(var e=0;e<j.length-1;e++){var c=parseFloat(j[e]);var h=this.formatAxisValue(c,"xAxis");b=this.graphType=="Candlestick"&&this.summaryType=="volume"?d+((c-this.xAxis2Min)*this.xAxis2Unit):d+((c-this.xAxisMin)*this.xAxisUnit);if(this.tickRotate){this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,"center","middle",this.tickRotate*Math.PI/180)}else{this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,"center","middle")}}}if(this.layoutAxis==2||this.layoutAxis==3){k=m+this.y+(this.margin*2)+(this.getFontPt(this.axisTickFont)/2);if(this.graphType.match(/BarLine|AreaLine|StackedLine|StackedPercentLine/)&&this.data.a&&this.data.y.desc&&this.data.y.desc[1]){for(var e=0;e<this.xAxis2Values.length-1;e++){var c=parseFloat(this.xAxis2Values[e]);var h=this.formatAxisValue(c,"xAxis2");b=d+((c-this.xAxis2Min)*this.xAxis2Unit);this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,"center","middle")}if(this.graphType.match(/Stacked/)){f=this.data.y.desc&&this.data.y.desc[1]?this.data.y.desc[1]:""}else{f=this.data.y.desc&&this.data.y.desc[1]?this.data.y.desc[1]+" (Lines)":""}}else{j=this.graphType=="Candlestick"&&this.summaryType=="volume"?this.xAxis2Values:this.xAxisValues;for(var e=0;e<j.length-1;e++){var c=parseFloat(j[e]);var h=this.formatAxisValue(c,"xAxis");b=this.graphType=="Candlestick"&&this.summaryType=="volume"?d+((c-this.xAxis2Min)*this.xAxis2Unit):d+((c-this.xAxisMin)*this.xAxisUnit);if(this.tickRotate){this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,"center","middle",this.tickRotate*Math.PI/180)}else{this.drawText(h,b,k,this.axisTickFont,this.axisTickColor,"center","middle")}}f=this.graphType=="Candlestick"&&this.summaryType=="volume"?this.xAxis2Title:this.xAxisTitle?this.xAxisTitle:this.data.y.desc&&this.data.y.desc[0]?this.data.y.desc[0]:this.yAxisTitle?this.yAxisTitle:""}b=d+(this.x/2);k=m+this.y+(this.margin*4)+this.getFontPt(this.axisTickFont)+(this.getFontPt(this.axisTitleFont)/2);this.drawText(f,b,k,this.axisTitleFont,this.axisTitleColor,"center","middle")}}var a=this.backgroundType.match(/window/i)?this.foregroundWindow:this.foreground;this.rectangle(d,m,this.x,this.y,false,a,"open",false,this.outlineWidth)}};this.draw1DDataPoints=function(){switch(this.graphType){case"Bar":this.draw1DBarDataPoints(this.varIndices,"xAxis");return true;case"Line":this.draw1DLineDataPoints(this.varIndices,"xAxis");return true;case"BarLine":this.draw1DBarDataPoints(this.xAxisVarIndices,"xAxis");this.draw1DLineDataPoints(this.xAxis2VarIndices,"xAxis2");return true;case"Stacked":case"StackedPercent":this.draw1DStackedDataPoints();return true;case"StackedLine":case"StackedPercentLine":this.draw1DStackedDataPoints();this.draw1DLineDataPoints(this.xAxis2VarIndices,"xAxis2");return true;case"Area":this.draw1DAreaDataPoints(this.varIndices,"xAxis");return true;case"AreaLine":this.draw1DAreaDataPoints(this.xAxisVarIndices,"xAxis");this.draw1DAreaDataPoints(this.xAxis2VarIndices,"xAxis2",true);return true;case"Boxplot":this.draw1DBoxplotDataPoints();return true;case"Candlestick":this.draw1DCandlestickDataPoints();return true;case"Dotplot":this.draw1DDotplotDataPoints();return true;case"Heatmap":this.draw1DHeatmapDataPoints();return true}throw'Illegal graph type "'+this.graphType+'"'};this.draw1DBarDataPoints=function(y,w){var b=this.isGroupedData?this.grpIndices:this.smpIndices;var B=b.length;var r=this.xAxisMin<0?Math.abs(this.xAxisMin)*this.xAxisUnit:0;var g=this.marginLeft+this.offsetX+this.left;var A=this.marginTop+this.offsetY+this.top;var f=this.blockSeparation+(this.rowBlockSize*y.length);if(this.graphOrientation=="vertical"){g+=this.blockSeparation;A=(A+this.y)-r}else{g+=r;A+=this.blockSeparation}for(var k=0;k<y.length;k++){var p=[];var o=[];var q=[];var u=[];for(var h=0;h<B;h++){q.push(this.colorBy&&this.legendColorsN?this.dataColors[h]:this.colors[k%this.colors.length]);p.push(this.getDataAtPos(y[k],b[h]));if(this.isGroupedData||this.data.y.hasOwnProperty("stdev")){o.push(this.getDataAtPos(y[k],b[h],"stdev"))}u.push([y[k],b[h]])}this.drawBarPlot(p,o,g,A,this.rowBlockSize,f,this[w+"Unit"],r,this[w+"Min"],this.graphOrientation,q,u);if(this.graphOrientation=="vertical"){g+=this.rowBlockSize}else{A+=this.rowBlockSize}}};this.draw1DLineDataPoints=function(D,C){var h=this.isGroupedData?this.grpIndices:this.smpIndices;var F=h.length;var q=this.marginLeft+this.offsetX+this.left;var E=this.marginTop+this.offsetY+this.top;var b=this.graphType=="BarLine"?true:false;var g=b?this.blockSeparation+(this.xAxisVarIndices.length*this.rowBlockSize):this.blockSeparation+this.rowBlockSize;var k=this.blockSeparation+(this.rowBlockSize/2);if(this.graphOrientation=="vertical"){q+=k;E+=this.y}else{E+=k}for(var w=0;w<D.length;w++){var z=[];var y=[];var A=this.coordinateLineColor?this.colors[w%this.colors.length]:this.colors[(w+D.length)%this.colors.length];var f=this.lineDecoration=="symbol"?this.shapes[w%this.shapes.length]:"sphere";var B=[];for(var u=0;u<F;u++){z.push(this.getDataAtPos(D[w],h[u]));if(this.isGroupedData||this.data.y.hasOwnProperty("stdev")){y.push(this.getDataAtPos(D[w],h[u],"stdev"))}B.push([D[w],h[u]])}this.drawLinePlot(z,y,q,E,this.rowBlockSize,g,this[C+"Unit"],this[C+"Min"],this.graphOrientation,A,f,B);if(b&&this.xAxisVarIndices.length==this.xAxis2VarIndices.length){if(this.graphOrientation=="vertical"){q+=this.rowBlockSize}else{E+=this.rowBlockSize}}}};this.draw1DStackedDataPoints=function(){var e=this.isGroupedData?this.grpIndices:this.smpIndices;var B=e.length;var h=this.marginLeft+this.offsetX+this.left;var A=this.marginTop+this.offsetY+this.top;var f=this.blockSeparation+this.rowBlockSize;var z=this.graphType.match(/Line/)?this.xAxisVarIndices:this.varIndices;var y=this.graphType=="StackedPercentLine"?this.xAxisVarIndices:false;var b=this.graphType.match(/Percent/)?true:false;if(this.graphOrientation=="vertical"){h+=this.blockSeparation;A+=this.y}else{A+=this.blockSeparation}for(var o=0;o<B;o++){var q=this.sum(this.getDataForSmpGrpAtIndex(e[o],y));var r=[];var u=[];var x=[];for(var k=0;k<z.length;k++){r.push(this.getDataAtPos(z[k],e[o]));u.push(this.colors[k%this.colors.length]);x.push([z[k],e[o]])}this.drawStackedPlot(r,h,A,this.rowBlockSize,b,q,this.xAxisUnit,this.graphOrientation,u,x);if(this.graphOrientation=="vertical"){h+=f}else{A+=f}}};this.draw1DAreaDataPoints=function(B,A,p){var e=this.isGroupedData?this.grpIndices:this.smpIndices;var D=e.length;var h=this.marginLeft+this.offsetX+this.left;var C=this.marginTop+this.offsetY+this.top;var g=this.rowBlockSize+this.blockSeparation;var r=[];var w=[];var y=[];if(this.graphOrientation=="vertical"){C+=this.y}for(var o=0;o<B.length;o++){var u=[];var b=!this.coordinateLineColor&&A=="xAxis2"?this.colors[(o+B.length)%this.colors.length]:this.colors[(o+this[A].length)%this.colors.length];for(var k=0;k<D;k++){u.push(this.getDataAtPos(B[o],e[k]))}r.push(u);w.push(b);y.push([B[o]])}this.drawAreaPlot(r,h,C,this.x,this.y,g,this[A+"Unit"],this[A+"Min"],this.graphOrientation,p,w,y)};this.draw1DBoxplotDataPoints=function(){var e=this.isGroupedData?this.grpIndices:this.smpIndices;var B=e.length;var y=this.varIndices;var g=this.marginLeft+this.offsetX+this.left;var A=this.marginTop+this.offsetY+this.top;var f=this.blockSeparation+(this.rowBlockSize*y.length);if(this.graphOrientation=="vertical"){g+=this.blockSeparation;A+=this.y}else{A+=this.blockSeparation}for(var p=0;p<y.length;p++){var q=[];var w=this.colors[p%this.colors.length];var x=[];for(var o=0;o<B;o++){var b=["iqr1","iqr3","qtl1","qtl3","median","out"];var u=[];for(var h=0;h<b.length;h++){u.push(this.getDataAtPos(y[p],e[o],b[h]))}q.push(u);x.push([y[p],e[o]])}this.drawBoxPlot(q,g,A,this.rowBlockSize,f,this.xAxisUnit,this.xAxisMin,this.graphOrientation,w,x);if(this.graphOrientation=="vertical"){g+=this.rowBlockSize}else{A+=this.rowBlockSize}}};this.draw1DCandlestickDataPoints=function(){var B=this.isGroupedData?this.grpIndices:this.smpIndices;var w=B.length;var g=this.varIndices;var D=this.marginLeft+this.offsetX+this.left;var q=this.marginTop+this.offsetY+this.top;var C=this.blockSeparation+(this.rowBlockSize*g.length);var A=this.summaryType=="candle"?true:false;var o=A?this.xAxisUnit:this.xAxis2Unit;var f=A?this.xAxisMin:this.xAxis2Min;var H=this.rowBlockSize/2;if(this.graphOrientation=="vertical"){D+=this.blockSeparation;q+=this.y}else{q+=this.blockSeparation}for(var G=0;G<g.length;G++){var I=[];var J=this.colors[G%this.colors.length];var L=[];for(var F=0;F<w;F++){var y=A?["open","close","high","low"]:["volume"];var e=[];for(var E=0;E<y.length;E++){e.push(this.getDataAtPos(g[G],B[F],y[E]))}I.push(e);L.push([g[G],B[F]])}this.drawCandlestickPlot(I,D,q,this.rowBlockSize,C,o,f,A,this.graphOrientation,J,L);if(this.stockIndicators.length>0){for(var F=0;F<this.stockIndicators.length;F++){var K=this.getTechnicalIndicatorColor(this.stockIndicators[F]);var I=[];for(var E=0;E<w;E++){I.push(this.getDataAtPos(g[G],B[E],this.stockIndicators[F]))}if(this.graphOrientation=="vertical"){this.drawLinePlot(I,[],D+H,q,this.rowBlockSize,C,o,f,this.graphOrientation,K,false,[])}else{this.drawLinePlot(I,[],D,q+H,this.rowBlockSize,C,o,f,this.graphOrientation,K,false,[])}}}if(this.graphOrientation=="vertical"){D+=this.rowBlockSize}else{q+=this.rowBlockSize}}};this.draw1DDotplotDataPoints=function(){var h=this.isGroupedData?this.grpIndices:this.smpIndices;var H=h.length;var F=this.varIndices;var r=this.marginLeft+this.offsetX+this.left;var G=this.marginTop+this.offsetY+this.top;var D=this.blockSeparation+(this.rowBlockSize/2);var o=this.blockSeparation+(this.rowBlockSize*F.length);var f=this.getShapeSize();if(this.graphOrientation=="vertical"){r+=D;G+=this.y}else{G+=D}for(var x=0;x<F.length;x++){var A=[];var y=[];var C=this.colors[x%this.colors.length];var g=this.shapes[parseInt(x/this.colors.length)];var E=[];for(var w=0;w<H;w++){if(this.isGroupedData){var B=[];for(var u=0;u<this.data.w.grps[h[w]].length;u++){B.push(this.data.y.data[F[x]][this.data.w.grps[h[w]][u]])}A.push(B)}else{A.push([this.getDataAtPos(F[x],h[w])]);if(this.data.y.hasOwnProperty("stdev")){y.push(this.getDataAtPos(F[x],h[w],"stdev"))}}E.push([F[x],h[w]])}this.drawDotPlot(A,y,r,G,this.rowBlockSize,this.blockSeparation,o,this.xAxisUnit,this.xAxisMin,f,this.graphOrientation,C,g,E);if(this.graphOrientation=="vertical"){r+=this.rowBlockSize}else{G+=this.rowBlockSize}}};this.draw1DHeatmapDataPoints=function(){var b=this.isGroupedData?this.grpIndices:this.smpIndices;var p=b.length;var c=this.marginLeft+this.offsetX+this.left;var o=this.marginTop+this.offsetY+this.top;var h=this.varIndices.length*5>this.x?true:false;for(var g=0;g<p;g++){var k=[];var m=[];for(var f=0;f<this.varIndices.length;f++){k.push(this.getDataAtPos(this.varIndices[f],b[g]));m.push([this.varIndices[f],b[g]])}this.drawHeatmap(k,c,o,this.colBlockSize,this.rowBlockSize,this.minData,this.maxData,h,m);o+=this.rowBlockSize}};this.drawStockIndicatorsLegend=function(){var d=this.marginLeft+this.offsetX+this.left;var n=this.marginTop+this.offsetY+this.top;if(this.summaryType=="candle"&&this.stockIndicators.length>0){var a=this.getFontPt(this.legendFont);var f=a/2;var b=this.measureText(this.getMaxText(this.stockIndicators),this.legendFont)+a+(this.margin*2);var k=this.graphOrientation=="vertical"?d+(this.margin*2):d+this.x-b;var j=n+this.margin+a;for(var e=0;e<this.stockIndicators.length;e++){var g=this.getTechnicalIndicatorColor(this.stockIndicators[e]);this.drawLine("line",k+f,j+f,k+f+a,j+f,g,false,"butt",false,false,true);this.drawText(this.stockIndicators[e],k+a+this.margin,j+f,this.legendFont,g,"left","middle");j+=this.margin+a}}};this.draw1DLegend=function(){var f=this.marginLeft+this.offsetX+this.left;var w=this.marginTop+this.offsetY+this.top;var q=this.getFontPt(this.legendFont);var j=q/2;var o=q*2;if(this.layoutValid){if(this.legendPosition=="bottom"){w+=this.margin}else{f+=this.margin}}this.drawStockIndicatorsLegend();if(this.showLegend&&this.graphType!="Heatmap"){if(this.colorBy&&this.graphType=="Bar"){if(this.legendPosition=="right"){if(this.legendColorsN>0){f=(f+this.x+this.right)-(this.legendColorWidth+this.margin);w+=(this.y-this.legendColorHeight)/2;this.drawColorLegend(f,w)}else{f=(f+this.x+this.right)-this.legendColorIndicatorHeight;w+=((this.y-this.legendColorIndicatorWidth)/2)+this.legendColorIndicatorWidth;this.drawColorIndicator(f,w,this.legendColorRange[0],this.legendColorRange[1],this.legendColorDecs)}}else{if(this.legendColorsN>0){f+=(this.x-this.legendColorWidth)/2;w=(w+this.y+this.bottom)-(this.legendColorHeight+this.margin);this.drawColorLegend(f,w)}else{f+=((this.x-this.legendColorIndicatorWidth)/2);w=(w+this.y+this.bottom)-this.legendColorIndicatorHeight;this.drawColorIndicator(f,w,this.legendColorRange[0],this.legendColorRange[1],this.legendColorDecs)}}}else{if(this.graphType=="BarLine"||this.graphType=="AreaLine"||this.graphType=="StackedLine"||this.graphType=="StackedPercentLine"){var x=this.maxVarName>this.maxVarStringLen?this.maxVarNameStr.substring(0,this.maxVarStringLen):this.maxVarNameStr;var e=this.legendPosition=="right"?f+this.x+(this.margin*4):(f+(this.x/2))-((this.measureText(x,this.legendFont)+q)/2);var u=this.legendPosition=="right"?(w+(this.y/2))-(this.getLegendHeight(true)/2):w+this.y;if(this.smpDendrogramPosition=="right"){e+=this.getSmpTreeWidthHeight()}if(this.legendPosition=="bottom"){if(this.graphOrientation=="vertical"){u+=this.getSampleTitleHeight()+this.getSampleLabelLength()+this.getSmpOverlaysLength()+this.margin}else{u+=this.getAxisTitleTickLength()+this.margin}if(this.showSmpDendrogram&&this.smpDendrogramPosition=="bottom"){u+=this.getSmpTreeWidthHeight()}}else{if(this.graphOrientation=="vertical"){e+=this.getAxisTitleTickLength()}}var r=u-this.margin;if(this.legendBox&&this.legendBackgroundColor){var x=this.maxVarName>this.maxVarStringLen?this.maxVarNameStr.substring(0,this.maxVarStringLen):this.maxVarNameStr;var n=((this.xAxisVarIndices.length+this.xAxis2VarIndices.length)*q*1.5)+this.margin;var d=(this.margin*3)+o+this.measureText(x,this.legendFont);this.rectangle(e-this.margin*2,r,d,n,this.legendBackgroundColor,this.legendBoxColor)}for(var g=0;g<this.xAxisVarIndices.length;g++){var v=this.xAxisVarIndices[g];var m=this.colors[g%this.colors.length];var x=this.shortenText(this.data.y.vars[v],this.maxVarStringLen);this.addArea(this.rectangle(e,u,q,q,m,m),["Var-"+v]);this.addArea(this.drawText(x,e+o,u+j,this.legendFont,this.getVarColor(this.data.y.vars[v]),"left","middle"),["Var-"+v]);u+=q*1.5}for(var g=0;g<this.xAxis2VarIndices.length;g++){var v=this.xAxis2VarIndices[g];var m=this.coordinateLineColor?this.colors[g%this.colors.length]:this.colors[(g+this.xAxisVarIndices.length)%this.colors.length];var x=this.shortenText(this.data.y.vars[v],this.maxVarStringLen);var k=this.getFontPt(this.legendFont)/2;if(this.lineDecoration){if(this.lineDecoration=="symbol"){this.drawLine("line",e,u+j,e+q,u+j,m);this.addArea(this.drawShape(this.shapes[g%this.shapes.length],e+j,u+j,k,k,m,m),["Var-"+v])}else{if(this.lineDecoration=="dot"){this.drawLine("line",e,u+j,e+q,u+j,m);this.addArea(this.drawShape("circle",e+j,u+j,k,k,m,m),["Var-"+v])}}}else{this.addArea(this.drawLine("line",e,u+j,e+q,u+j,m),["Var-"+v])}this.addArea(this.drawText(x,e+o,u+j,this.legendFont,this.getVarColor(this.data.y.vars[v]),"left","middle"),["Var-"+v]);u+=q*1.5}if(this.legendBox){var x=this.maxVarName>this.maxVarStringLen?this.maxVarNameStr.substring(0,this.maxVarStringLen):this.maxVarNameStr;var n=((u-r)-j)+this.margin;var d=(this.margin*3)+o+this.measureText(x,this.legendFont);this.rectangle(e-this.margin*2,r,d,n,false,this.legendBoxColor,"open")}}else{var x=this.maxVarName>this.maxVarStringLen?this.maxVarNameStr.substring(0,this.maxVarStringLen):this.maxVarNameStr;var e=this.legendPosition=="right"?f+this.x+(this.margin*4):(f+(this.x/2))-((this.measureText(x,this.legendFont)+q)/2);var u=this.legendPosition=="right"?(w+(this.y/2))-(this.getLegendHeight(true)/2):w+this.y;if(this.legendPosition=="bottom"){if(this.graphOrientation=="vertical"){u+=this.getSampleTitleHeight()+this.getSampleLabelLength()+this.getSmpOverlaysLength()+this.margin+this.margin}else{u+=this.getAxisTitleTickLength()+this.margin}if(this.showSmpDendrogram&&this.smpDendrogramPosition=="bottom"){u+=this.getSmpTreeWidthHeight()}}else{if(this.graphOrientation=="vertical"){e+=this.getAxisTitleTickLength()}}if(this.smpDendrogramPosition=="right"&&this.showLegend&&this.legendPosition=="right"){e+=this.getSmpTreeWidthHeight()}var r=u-this.margin;if(this.legendBox&&this.legendBackgroundColor){var x=this.maxVarName>this.maxVarStringLen?this.maxVarNameStr.substring(0,this.maxVarStringLen):this.maxVarNameStr;var n=((this.varIndices.length*q*1.5))+this.margin;var d=(this.margin*3)+o+this.measureText(x,this.legendFont);this.disableGradientTransparency();this.rectangle(e-this.margin*2,r,d,n,this.legendBackgroundColor,this.legendBoxColor);this.enableGradientTransparency()}for(var g=0;g<this.varIndices.length;g++){var v=this.varIndices[g];var m=this.colors[g%this.colors.length];var a=this.shapes[g%this.shapes.length];var x=this.shortenText(this.data.y.vars[v],this.maxVarStringLen);var k=this.getFontPt(this.legendFont)/2;if(this.graphType=="Line"){if(this.lineDecoration){if(this.lineDecoration=="symbol"){this.drawLine("line",e,u+j,e+q,u+j,m);this.addArea(this.drawShape(a,e+j,u+j,k,k,m,m),["Var-"+v])}else{if(this.lineDecoration=="dot"){this.drawLine("line",e,u+j,e+q,u+j,m);this.addArea(this.drawShape("circle",e+j,u+j,k,k,m,m),["Var-"+v])}}}else{this.addArea(this.drawLine("line",e,u+j,e+q,u+j,m),["Var-"+v])}}else{if(this.graphType=="Dotplot"){a=this.shapes[parseInt(g/this.colors.length)];this.addArea(this.drawShape(a,e+j,u+j,q,q,m,m),["Var-"+v])}else{this.addArea(this.rectangle(e,u,q,q,m,m),["Var-"+v])}}this.addArea(this.drawText(x,e+o,u+j,this.legendFont,this.getVarColor(this.data.y.vars[v]),"left","middle"),["Var-"+v]);u+=q*1.5}if(this.legendBox){var x=this.maxVarName>this.maxVarStringLen?this.maxVarNameStr.substring(0,this.maxVarStringLen):this.maxVarNameStr;var n=((u-r)-j)+this.margin;var d=(this.margin*3)+o+this.measureText(x,this.legendFont);this.rectangle(e-this.margin*2,r,d,n,false,this.legendBoxColor,"open")}}}}};this.setIndicatorsLegendPositions=function(){if(this.colorBy&&this.graphType=="Bar"){this.indicatorsPosition=this.legendPosition}};this.draw1DLayout=function(){this.drawTrees();this.draw1DXLayout();this.draw1DYLayout()};this.draw1DData=function(){this.drawPlotWindow();this.draw1DWireFrame();this.draw1DDataPoints();this.maskPlotArea();this.draw1DLayout();this.draw1DLegend();this.drawTitle()};this.draw1DPlot=function(){this.setIndicatorsLegendPositions();this.set1DAttributes();this.set1DXYDimensions();this.set1DPrivateParams();this.set1DXAxis();this.draw1DData()};this.checkSegregation=function(){if(this.graphType!="Candlestick"){if(this.data.l){if(!this.segregateSamplesBy){this.desegregateSamples(true)}else{if(!this.data.l.smps){this.segregateSamples(this.segregateSamplesBy,true)}}if(!this.segregateVariablesBy){this.desegregateVariables(true)}else{if(!this.data.l.vars){this.segregateVariables(this.segregateVariablesBy,true)}}}else{if(this.segregateSamplesBy){this.segregateSamples(this.segregateSamplesBy,true)}if(this.segregateVariablesBy){this.segregateVariables(this.segregateVariablesBy,true)}}}};this.initialize1DPlot=function(){this.checkSegregation();if(this.layoutValid){this.drawLayoutCompartments(this.draw1DPlot)}else{this.draw1DPlot()}};this.initialize1DPlot()};CanvasXpress.prototype.Network=function(){this.findXYCoordinates=function(b){var a=this.adjustedCoordinates(b);var d={};d.x=(a.x/this.scaleFactor||1)-this.offsetX;d.y=(a.y/this.scaleFactor||1)-this.offsetY;return d};this.addNode=function(d,c){if(d){if(!d.id){var a=0;var e="id"+a;while(this.nodes.hasOwnProperty(e)){a++;e="id"+a}d.id=e}if(!d.color){d.color=this.colors[0]}if(!d.shape){d.shape=this.shapes[0]}if(!d.size){d.size=1}if(c){var b=this.findXYCoordinates(c);d.x=b.x;d.y=b.y}this.data.nodeIndices[d.id]=this.data.nodes.length;this.data.nodes.push(d);this.nodes[d.id]=d;return d}};this.getNodeConfigurableProperties=function(a){var c=this.getObjectArray(this.nodeConfigurableProperties);if(a){for(var b in this.data.nodes[a]){c[b]=true}}return this.getKeys(c)};this.getEdgeConfigurableProperties=function(b){var c=this.getObjectArray(this.edgeConfigurableProperties);if(b){for(var a in this.data.edges[b]){c[a]=true}}return this.getKeys(c)};this.removeNode=function(d,k){if(d&&d.id){var a=k?this.getObjectArray(this.findChildrenNodeIndices(d.id)):false;var g=[];var b=0;if(this.nodeParentHood[d.id]){for(var h=0;h<this.nodeParentHood[d.id].children.length;h++){var l=this.nodeParentHood[d.id].children[h];delete (this.data.nodes[this.data.nodeIndices[l]].parentNode)}}this.data.nodeIndices={};for(var h=0;h<this.data.nodes.length;h++){if(this.data.nodes[h].id!=d.id){if(a&&a.hasOwnProperty(h)){var f=this.edgesForNode(this.data.edges,this.data.nodes[h].id);for(var e=0;e<f.length;e++){this.removeEdge(f[e])}}else{g.push(this.data.nodes[h]);this.data.nodeIndices[this.data.nodes[h].id]=b;b++}}else{var f=this.edgesForNode(this.data.edges,d.id);for(var e=0;e<f.length;e++){this.removeEdge(f[e])}}}this.data.nodes=g}};this.addEdge=function(a){if(a&&a.id1&&a.id2){if(!a.color){a.color=this.colors[0]}if(!a.width){a.width=1}if(!a.type){a.type="line"}this.data.edges.push(a)}};this.removeEdge=function(c){if(c&&c.id1&&c.id2){var b=[];for(var a=0;a<this.data.edges.length;a++){if(this.data.edges[a].id1!=c.id1||this.data.edges[a].id2!=c.id2){b.push(this.data.edges[a])}}this.data.edges=b}};this.getAllObjectAttributes=function(c){var d=[];if(this.data[c]){for(var b=0;b<this.data[c].length;b++){for(var a in this.data[c][b]){if(d.hasOwnProperty(a)){d[a]++}else{d[a]=1}}}}return d};this.setAllObjectAttributes=function(l,m,p,e){if(this.data[l]){var n=this.getAllObjectAttributeValues(l,p);if(n){if(this.isNumeric(n)){var j=this.range(n);if(m=="color"){this.setHeatmapColors(j[1]-j[0]);for(var g=0;g<this.data[l].length;g++){if(this.data[l][g].hasOwnProperty(p)){var d=this.data[l][g][p];var c=this.getHeatmapColor(j[0],j[1],d);this.data[l][g][m]=c}else{this.data[l][g][m]=this.missingDataColor}}}else{if(m=="size"){for(var g=0;g<this.data[l].length;g++){if(this.data[l][g].hasOwnProperty(p)){var d=this.data[l][g][p];var f=this.percentile(j[0],j[1],d);var b=parseInt(f*25/10);if(e){this.data[l][g]["decorationSize"]=1+(b/25)}else{this.data[l][g][m]=1+(b/100)}}else{if(e){this.data[l][g]["decorationSize"]=0.1}else{this.data[l][g][m]=0.1}}}}else{if(m=="shape"){if(l=="nodes"){var r="square";for(var g=0;g<this.data[l].length;g++){if(this.data[l][g].hasOwnProperty(p)){var d=this.data[l][g][p];var f=this.percentile(j[0],j[1],d);var q=parseInt(f/10);if(q>0){q--}this.data[l][g][m]="pie"+q}else{this.data[l][g][m]=r}}}else{if(l=="edges"){for(var g=0;g<this.data[l].length;g++){if(this.data[l][g].hasOwnProperty(p)){var d=this.data[l][g][p];var f=this.percentile(j[0],j[1],d);var q=parseInt(f/10);if(q>0){q--}this.data[l][g]["type"]=this.lines[q]}else{this.data[l][g]["type"]=this.lines[10]}}}}}}}}else{var o=0;var h=0;var k=0.1;var a={color:{},shape:{},size:{}};for(var g=0;g<n.length;g++){if(!a.color.hasOwnProperty(n[g])){a.color[n[g]]=this.colors[o%this.colors.length];o++}if(l=="nodes"){if(!a.shape.hasOwnProperty(n[g])){a.shape[n[g]]=this.shapes[h%this.shapes.length];h++}}else{if(!a.shape.hasOwnProperty(n[g])){a.lines[n[g]]=this.lines[h%this.lines.length];h++}}if(!a.size.hasOwnProperty(n[g])){a.size[n[g]]=k;k+=0.1}}for(var g=0;g<this.data[l].length;g++){if(this.data[l][g].hasOwnProperty(p)){var d=this.data[l][g][p];this.data[l][g][m]=a[m][d]}}}}}};this.getAllObjectAttributeValues=function(c,a){var d=[];if(this.data[c]){for(var b=0;b<this.data[c].length;b++){if(this.data[c][b].hasOwnProperty(a)){d.push(this.data[c][b][a])}}}return d};this.modifyNodeSize=function(d,a,b){var c=this.data.nodes[this.data.nodeIndices[d]];delete (c.size);c.width=a;c.height=b};this.modifyXYNode=function(g,c,a){var f=this.data.nodes[this.data.nodeIndices[g]];f.x-=c;f.y-=a;if(f.labelX!=null&&f.labelY!=null){this.modifyXYNodeLab(g,c,a)}if(this.networkLayoutType!="radial"){if(this.nodeParentHood[f.id]&&this.nodeParentHood[f.id]["children"]){for(var e=0;e<this.nodeParentHood[f.id]["children"].length;e++){var b=this.nodeParentHood[f.id]["children"][e];var d=this.data.nodes[this.data.nodeIndices[b]];this.modifyXYNode(b,c,a)}}}};this.modifyXYNodeLab=function(c,i,h){var d=this.data.nodes[this.data.nodeIndices[c]];var f=d.label!=null?d.label:d.name?d.name:d.id;var a=this.measureText(f,this.nodeFont);var g=this.nodeFontSize;var e=d.width?d.width:d.size?(this.nodeSize*d.size):this.nodeSize;var b=d.height?d.height:d.size?(this.nodeSize*d.size):this.nodeSize;if(d.labelX!=null&&d.labelY!=null){d.labelX-=i;d.labelY-=h}else{if(this.rangeX>this.rangeY){d.labelX=(d.x-(a/2))-i;d.labelY=(d.y+(b/1.3))-h}else{d.labelX=(d.x+(e/1.3))-i;d.labelY=(d.y-(g/2))-h}}};this.modifyXYNodeDec=function(d,b,a){var c=this.data.nodes[this.data.nodeIndices[d]];c.decorationsX-=b;c.decorationsY-=a};this.getHiddenNodes=function(){var b=[];if(this.data.nodes){for(var a=0;a<this.data.nodes.length;a++){if(this.data.nodes[a].hide){b.push(this.data.nodes[a])}}}return b};this.sendNodeToBack=function(c){var b=[c];for(var a=0;a<this.data.nodes.length;a++){if(this.data.nodes[a].id!=c.id){b.push(this.data.nodes[a])}}this.data.nodes=b;this.setNodeIndices()};this.sendNodeBackward=function(d){var c=[];var a=this.data.nodeIndices[d.id];if(a>0){for(var b=0;b<a-1;b++){c.push(this.data.nodes[b])}c.push(this.data.nodes[a]);c.push(this.data.nodes[a-1]);for(var b=a+1;b<this.data.nodes.length;b++){c.push(this.data.nodes[b])}this.data.nodes=c;this.setNodeIndices()}};this.bringNodeToFront=function(c){var b=[];for(var a=0;a<this.data.nodes.length;a++){if(this.data.nodes[a].id!=c.id){b.push(this.data.nodes[a])}}b.push(c);this.data.nodes=b;this.setNodeIndices()};this.bringNodeForward=function(d){var c=[];var a=this.data.nodeIndices[d.id];if(this.data.nodes.length-1>a){for(var b=0;b<a;b++){c.push(this.data.nodes[b])}c.push(this.data.nodes[a+1]);c.push(this.data.nodes[a]);for(var b=a+2;b<this.data.nodes.length;b++){c.push(this.data.nodes[b])}this.data.nodes=c;this.setNodeIndices()}};this.flashNode=function(b){var e=this.data.nodes[this.data.nodeIndices[b]];var a=e.width?e.width:e.size?e.size:this.nodeSize;var d=e.height?e.height:e.size?e.size:this.nodeSize;var c=this.adjustNetworkObjects(["circle",e.x,e.y,1]);this.flash(c[1],c[2],a*this.scaleFactor,d*this.scaleFactor,this.nodeHighlightColor)};this.highlightNodes=function(a){if(this.isArray(a)){this.highlightNode=this.highlightNode.concat(a)}else{this.highlightNode.push(a)}this.draw()};this.unHighlightNodes=function(a){var d=[];a=this.toArray(a);for(var c=0;c<this.highlightNode.length;c++){var e=false;for(var b=0;b<a.length;b++){if(this.highlightNode[c]==a[b]){e=true;break}}if(!e){d.push(this.highlightNode[c])}}this.highlightNode=d;this.draw()};this.addToNetworkStack=function(a){if(!a){a=0}if(this.networkStack[a].length>=this.networkStackStates){this.networkStack[a].shift()}this.networkStack[a].push(this.cloneObject(this.data))};this.undoNetworkOp=function(){if(this.networkStack[0].length>0){this.addToNetworkStack(1);this.nodes={};this.updateData(this.networkStack[0].pop())}else{if(this.debug){alert("No data in Undo Stack")}}};this.canNetworkUndoOp=function(){return this.networkStack[0].length>0?true:false};this.redoNetworkOp=function(){if(this.networkStack[1].length>0){this.addToNetworkStack(0);this.nodes={};this.updateData(this.networkStack[1].pop())}else{if(this.debug){alert("No data in Redo Stack")}}};this.canNetworkRedoOp=function(){return this.networkStack[1].length>0?true:false};this.addLegend=function(a,d,c){this.inititalizeNetworkLegend();if(a&&d){if(c&&a=="text"){var b=this.findXYCoordinates(c);d.x=b.x;d.y=b.y}this.data.legend[a].push(d);return d}};this.deleteLegend=function(c,d){if(c&&d&&d.id){var b=[];for(var a=0;a<this.data.legend[c].length;a++){if(this.data.legend[c][a].id!=d.id){b.push(this.data.legend[c][a])}}this.data.legend[c]=b;delete this.data.legend.ids[c][d.id]}};this.alignDistributeSelectedNodes=function(j,b){var f,a,h,p,g;var k=this.getSelectedNodeCoordinates();if(k||b==89|b==90){this.cancelEvent(j);this.stopEvent(j);if(b!=90||(b==90&&j.shiftKey)){this.addToNetworkStack(0)}if(b==84){f=this.min(k.y);for(var g in this.selectNode){var d=this.data.nodes[this.data.nodeIndices[g]];d.y=f}}else{if(b==82){f=this.max(k.x);for(var g in this.selectNode){var d=this.data.nodes[this.data.nodeIndices[g]];d.x=f}}else{if(b==66){f=this.max(k.y);for(var g in this.selectNode){var d=this.data.nodes[this.data.nodeIndices[g]];d.y=f}}else{if(b==76){f=this.min(k.x);for(var g in this.selectNode){var d=this.data.nodes[this.data.nodeIndices[g]];d.x=f}}else{if(b==86){a=this.range(k.y);h=this.rank(k.y);p=(a[1]-a[0])/(this.isSelectNodes-1);f=a[0];for(var l=0;l<h.length;l++){g=k.i[h[l]];var d=this.data.nodes[this.data.nodeIndices[g]];d.y=f+(l*p)}}else{if(b==72){a=this.range(k.x);h=this.rank(k.x);p=(a[1]-a[0])/(this.isSelectNodes-1);f=a[0];for(var l=0;l<h.length;l++){g=k.i[h[l]];var d=this.data.nodes[this.data.nodeIndices[g]];d.x=f+(l*p)}}else{if(b==90&&!j.shiftKey){if(this.canNetworkUndoOp){this.addToNetworkStack(1);this.resetSelectedNodes();this.undoNetworkOp()}return false}else{if(b==89||b==90){if(this.canNetworkRedoOp){if(!this.canNetworkUndoOp){this.addToNetworkStack(0)}this.resetSelectedNodes();this.redoNetworkOp()}return false}}}}}}}}this.draw(false,false,false,true)}return false};this.getSelectedNodeCoordinates=function(){var f={x:[],y:[],i:[]};var b=false;for(var d in this.selectNode){var e=this.data.nodes[this.data.nodeIndices[d]];f.x.push(e.x);f.y.push(e.y);f.i.push(d);b=true}return b?f:false};this.findNodesBy=function(g){var a=[];var k=0;for(var b in g){g[b]=this.toArray(g[b]);k++}for(var h=0;h<this.data.nodes.length;h++){var d=this.data.nodes[h];var e=0;for(var b in g){var l=g[b];for(var f=0;f<l.length;f++){if(d[b]&&d[b]==l[f]){e++}}}if(e==k){a.push(d)}}return a};this.setNetworkDimensions=function(){this.left=0;this.top=0;this.x=this.width;this.y=this.height};this.setNetworkPrivateParams=function(){if(this.data.nodes.length>0){this.layoutDone=false;this.x=this.width;this.y=this.height;if(this.networkLayoutType=="radial"){var a=this.width;var b=this.height;if(this.width>this.height){this.width=this.height}else{this.height=this.width}this.x=this.width;this.y=this.height;this.networkXCenter=this.x/2;this.networkYCenter=this.y/2;this.width=a;this.height=b}else{this.x=this.width;this.y=this.height;this.set3DParams();this.area=this.x*this.y;if(this.networkForceConstant!=null&&this.networkForceConstantOriginal!=null){this.networkForceConstantOriginal=this.networkForceConstant}if(this.temperature!=null&&this.temperatureOriginal!=null){this.temperatureOriginal=this.temperature}if(this.initialTemperature!=null&&this.initialTemperatureOriginal!=null){this.initialTemperatureOriginal=this.initialTemperature}this.networkForceConstant=this.networkForceConstant?this.networkForceConstant:Math.sqrt(this.area/this.data.nodes.length);this.temperature=this.temperature?this.temperature:this.data.nodes.length+Math.floor(Math.sqrt(this.data.edges.length));this.minimumTemperature=1;this.initialTemperature=this.initialTemperature?this.initialTemperature:this.temperature;this.iteration=0;if(this.networkForceConstant<0.001){this.networkForceConstant=0.001}}if(this.x<=400||this.y<=400){this.nodeSize-=4;this.nodeFont=(this.nodeSize-6)+"Pt "+this.fontName;this.showAnimationFont=this.nodeFont+"Pt "+this.fontName}else{this.edgeWidth=2}}else{this.layoutDone=true}};this.networkContains=function(a,b){return this.findNode(a,b)!=null};this.findNode=function(b,d){for(var c in b){var a=b[c];if(d.call(a)){return a}}return null};this.filterEdges=function(b,e){var d=[];for(var c in b){var a=b[c];if(e.call(a)){d.push(a)}}return d};this.reduceNetwork=function(a,e,c){var d=null;for(var b in a){if(d==null){if(c){d=c.apply(c,[a[b]])}else{d=a[b]}}else{d=e.apply(a[b],[d,a[b]])}}return d};this.vectorDifference=function(e,d){var c=e.x-d.x;var g=e.y-d.y;var f=e.z-d.z;if(c==0){c=0.01+Math.random()}if(g==0){g=0.01+Math.random()}if(this.is3DNetwork){if(f==0){f=0.01+Math.random()}}return{x:c,y:g,z:f}};this.vectorMagnitude=function(b){var a;if(this.is3DNetwork){a=Math.sqrt((b.x*b.x)+(b.y*b.y)+(b.z*b.z))}else{a=Math.sqrt((b.x*b.x)+(b.y*b.y))}return isNaN(a)?0:a};this.normalizeGraph=function(h){var g=[];var a={};var j=this;for(var e in h.nodes){if(!a.hasOwnProperty(h.nodes[e].id)){var d=h.nodes[e];var c=[];a[d.id]=1;if(!this.networkContains(c,function(){return j.networkContains(this.nodes,function(){return this.id=d.id})})){var b={};b.nodes=[];b.edges=[];this.addNodeToGraph(d,b,h);if(b.nodes.length>0){g.push(b)}for(var f=0;f<b.nodes.length;f++){a[b.nodes[f].id]=1}}}}return g};this.addNodeToGraph=function(c,e,d){if(this.findNodeForId(c.id,e)==null){e.nodes.push(c);var a=this.edgesForNode(d.edges,c.id);for(edgeIndex in a){var b=a[edgeIndex];e.edges.push(b);if(b.id1==c.id){this.addNodeToGraph(this.findNodeForId(b.id2,d),e,d)}else{this.addNodeToGraph(this.findNodeForId(b.id1,d),e,d)}}}};this.findNodeForId=function(b,a){return this.findNode(a.nodes,function(){return b==this.id})};this.edgesForNode=function(a,b){return this.filterEdges(a,function(c){return(this.id1==b||this.id2==b)})};this.attractiveForce=function(a,b){switch(this.attractiveForceFunction){case"FruchtermanReingold":return(a*a)/b;case"Eades":return b*Math.log(a)}};this.repulsiveForce=function(a,b){return(b*b)/a};this.storePositions=function(){var d={};for(var b=0;b<this.data.nodes.length;b++){var c=this.data.nodes[b];if(!c.hide&&!c.hiddenParent){var a={x:c.x,y:c.y,z:c.z};d[c.id]=a}}return d};this.calculateRepulsiveDisplacement=function(d){var c=this;var a=function(h,r,g){var q=g*g;for(var o=0;o<r.length;o++){var u=c.data.nodes[c.data.nodeIndices[r[o]]];var n=h[u.id];for(var l=0;l<r.length;l++){if(o!=l){var t=c.data.nodes[c.data.nodeIndices[r[l]]];var f=h[t.id];if(!u.hide&&!u.hiddenParent&&!t.hide&&!t.hiddenParent){var s=c.vectorDifference(u,t);var e=c.networkLayoutType=="organic"?Math.max(c.vectorMagnitude(s)-(c.nodeSize*2),c.networkNodeMinDistance):c.vectorMagnitude(s);var p=q/e;if(!u.fixed){n.x+=(s.x/e)*p;n.y+=(s.y/e)*p;n.z+=(s.z/e)*p}if(!t.fixed&&c.networkLayoutType=="organic"){f.x-=(s.x/e)*p;f.y-=(s.y/e)*p;f.z-=(s.z/e)*p}}}}}};if(this.subNetworks){for(var b=0;b<this.subNetworks.length;b++){a(d[b],this.subNetworks[b].nodes,this.subNetworks[b].networkForceConstant)}}else{a(d,this.getKeys(this.data.nodeIndices),this.networkForceConstant)}};this.calculateAttractiveDisplacement=function(d){var c=this;var a=function(p,o,h){for(var j=0;j<o.length;j++){var l=o[j];if(!c.nodes||!c.nodes[l.id1]||!c.nodes[l.id2]){alert('Nodes "'+l.id1+'" and/or "'+l.id2+'" are missing!');return}if(c.nodes&&!c.nodes[l.id1].hide&&!c.nodes[l.id2].hide&&!c.nodes[l.id1].hiddenParent&&!c.nodes[l.id2].hiddenParent){var n=c.vectorDifference(c.nodes[l.id1],c.nodes[l.id2]);var f=c.networkLayoutType=="organic"?Math.max(c.vectorMagnitude(n)-(c.nodeSize*2),c.networkNodeMinDistance):Math.max(c.vectorMagnitude(n),c.networkNodeMinDistance);var g=c.attractiveForce(f,h);if(!c.nodes[l.id1].fixed){p[l.id1].x-=(n.x/f)*g;p[l.id1].y-=(n.y/f)*g;p[l.id1].z-=(n.z/f)*g}if(!c.nodes[l.id2].fixed){p[l.id2].x+=(n.x/f)*g;p[l.id2].y+=(n.y/f)*g;p[l.id2].z+=(n.z/f)*g}}}};if(this.subNetworks){for(var b=0;b<this.subNetworks.length;b++){a(d[b],this.subNetworks[b].edges,this.subNetworks[b].networkForceConstant)}}else{a(d,this.data.edges,this.networkForceConstant)}};this.applyDisplacement=function(d){var c=this;var b=function(i,f){for(var j in i){var g=c.nodes[j];if(!g.fixed){var h=i[j];var e=Math.max(c.vectorMagnitude(h),0.001);g.x+=(h.x/e)*Math.min(f,Math.abs(h.x));g.y+=(h.y/e)*Math.min(f,Math.abs(h.y));g.z+=(h.z/e)*Math.min(f,Math.abs(h.z))}}};if(this.nodes){if(this.subNetworks){for(var a=0;a<this.subNetworks.length;a++){b(d[a],this.subNetworks[a].temperature)}}else{b(d,this.temperature)}}};this.isLayoutDone=function(){var e=this;var d=this.storePositions();var f=0;var b=0;var a=function(g,k){var v=0;var l=0;var q={x:Number.MAX_VALUE,y:Number.MAX_VALUE};var u={x:Number.MAX_VALUE*-1,y:Number.MAX_VALUE*-1};for(var r=0;r<g.length;r++){var m=e.data.nodes[e.data.nodeIndices[g[r]]];if(!m.hide&&!m.hiddenParent&&!m.fixed){var j=d[m.id];q.x=Math.min(q.x,j.x);q.y=Math.min(q.y,j.y);q.z=Math.min(q.z,j.z);u.x=Math.max(u.x,j.x);u.y=Math.max(u.y,j.y);u.z=Math.max(u.z,j.z)}v+=Math.abs(e.vectorMagnitude(e.vectorDifference(e.previousNodePositions[m.id],j)));l++}var t=v/l;var s=Math.abs(e.vectorMagnitude(e.vectorDifference(q,u)));var h=Math.abs(e.vectorMagnitude({x:k.x,y:k.y,z:parseInt((k.x+k.y)/2)}));k.minimumTemperature=s/h;k.layoutDone=t<k.minimumTemperature;if(k.layoutDone){b++}if(k.initialProgress==null&&k.temperature<=k.minimumTemperature){k.initialProgress=t-(k.minimumTemperature/2)}if(k.initialProgress!=null){k.layoutProgress=Math.max(k.layoutProgress,1-((t-(k.minimumTemperature/2))/k.initialProgress))}f+=k.layoutProgress};if(this.subNetworks){for(var c=0;c<this.subNetworks.length;c++){a(this.subNetworks[c].nodes,this.subNetworks[c])}this.layoutProgress=f/this.subNetworks.length;this.layoutDone=b==this.subNetworks.length?true:false}else{a(this.getKeys(this.data.nodeIndices),this)}this.previousNodePositions=d};this.setInitialForceDirectedLayout=function(){var c=this;var a=function(h,d,g){for(var e=0;e<h.length;e++){var f=c.data.nodes[c.data.nodeIndices[h[e]]];if(!f.hide&&!f.hiddenParent){f.x=Math.floor(Math.random()*d);f.y=Math.floor(Math.random()*g);f.z=this.is3DNetwork?Math.floor(Math.random()*parseInt((d+g)/2)):0}}};this.layoutProgress=0;if(this.subNetworks){for(var b=0;b<this.subNetworks.length;b++){a(this.subNetworks[b].nodes,this.subNetworks[b].x,this.subNetworks[b].y)}}else{a(this.getKeys(this.data.nodeIndices),this.x,this.y)}this.previousNodePositions=this.storePositions()};this.setInitialNodeDisplacement=function(){var c=this.subNetworks?[]:{};if(this.subNetworks){for(var b=0;b<this.subNetworks.length;b++){c[b]={};for(var a=0;a<this.subNetworks[b].nodes.length;a++){c[b][this.subNetworks[b].nodes[a]]={x:0,y:0,z:0}}}}else{for(var b=0;b<this.data.nodes.length;b++){c[this.data.nodes[b].id]={x:0,y:0,z:0}}}return c};this.updateForceDirectedLayout=function(c){var e=new Date().getTime();var b=e;if(this.data.edges.length>1){if(!this.layoutDone){while(b-e<c){var d=this.setInitialNodeDisplacement();this.calculateRepulsiveDisplacement(d);this.calculateAttractiveDisplacement(d);this.applyDisplacement(d);if(this.subNetworks){for(var a=0;a<this.subNetworks.length;a++){this.subNetworks[a].temperature=Math.max(this.subNetworks[a].temperature-(this.subNetworks[a].initialTemperature/100),this.subNetworks[a].minimumTemperature)}}else{this.temperature=Math.max(this.temperature-(this.initialTemperature/100),this.minimumTemperature)}this.isLayoutDone();this.iteration++;b=new Date().getTime()}}}else{this.layoutDone=true}return this.layoutDone};this.renderNetwork=function(){this.ctx.shadowOffsetX=this.shadowOffsetX;this.ctx.shadowOffsetY=this.shadowOffsetY;this.ctx.shadowBlur=this.shadowBlur;this.ctx.shadowColor=this.shadowColor;this.setNetworkRotation();this.resizeCanvas();if(!this.layoutDone&&!this.showAnimation){this.drawNetworkProgressBar(true);return}if(this.data.nodes.length>0){if(this.layoutDone){this.setXYNodePrecision()}this.setNetworkMinMaxRangeXY();this.setNetworkScaleFactor();if(this.scaleFactor){if(this.showAnimation){if(this.preScaleNetwork){this.centerNetwork();this.ctx.save();this.ctx.scale(1/this.scaleFactor,1/this.scaleFactor);this.ctx.translate(this.offsetX,this.offsetY);this.ctx.restore();if(this.networkNodesOnTop){this.drawNetworkEdges();this.drawNetworkNodes()}else{this.drawNetworkNodes();this.drawNetworkEdges()}if(this.layoutDone){this.drawNetworkLegend()}this.ctx.save();this.ctx.translate(-this.offsetX,-this.offsetY);this.ctx.scale(this.scaleFactor,this.scaleFactor);this.ctx.restore()}else{this.ctx.scale(this.scaleFactor,this.scaleFactor);this.ctx.translate(this.offsetX,this.offsetY);if(this.networkLayoutType=="radial"&&this.showNetworkRadialLayout){this.renderRadialLayout()}if(this.networkNodesOnTop){this.drawNetworkEdges();this.drawNetworkNodes()}else{this.drawNetworkNodes();this.drawNetworkEdges()}if(this.layoutDone){this.drawNetworkDecorations();this.drawNetworkLegend()}this.ctx.translate(-this.offsetX,-this.offsetY);this.ctx.scale(1/this.scaleFactor,1/this.scaleFactor)}this.drawCitation();this.drawTitle()}else{this.drawCitation();this.drawTitle();if(this.preScaleNetwork){this.centerNetwork();this.ctx.save();this.ctx.scale(this.scaleFactor,this.scaleFactor);this.ctx.translate(this.offsetX,this.offsetY);this.ctx.restore()}else{this.ctx.scale(this.scaleFactor,this.scaleFactor);this.ctx.translate(this.offsetX,this.offsetY)}if(this.networkLayoutType=="radial"&&this.showNetworkRadialLayout){for(var a=1;a<this.networkDepth;a++){this.drawShape("circle",this.networkXCenter,this.networkYCenter,a*this.networkLevelSize*2,a*this.networkLevelSize*2,this.background,this.infoAreaColor,"open")}}if(this.networkNodesOnTop){this.drawNetworkEdges();this.drawNetworkNodes()}else{this.drawNetworkNodes();this.drawNetworkEdges()}if(this.layoutDone){this.drawNetworkDecorations();this.drawNetworkLegend()}}this.drawNetworkProgressBar()}}};this.reRootRadialNetwork=function(e){var d=this.data.nodes[e].id;this.networkCurrentAngle=this.getAngle(this.finalRadialNodePositions[d].x,this.finalRadialNodePositions[d].y,this.finalRadialNodePositions[this.networkRoot].x,this.finalRadialNodePositions[this.networkRoot].y,0)+180;this.orderRadialNetwork={};var b=this.data.nodeIndices[d];var c=0;for(var a=b;a<this.data.nodes.length;a++){this.orderRadialNetwork[this.data.nodes[a].id]=c;c++}for(var a=0;a<b;a++){this.orderRadialNetwork[this.data.nodes[a].id]=c;c++}this.networkXCenter=this.finalRadialNodePositions[d].x;this.networkYCenter=this.finalRadialNodePositions[d].y;this.networkRoot=d;this.layoutDone=false;this.draw()};this.renderRadialLayout=function(){var a=this.data.nodes[this.data.nodeIndices[this.networkRoot]];for(var b=1;b<this.networkDepth;b++){this.drawShape("circle",a.x,a.y,b*this.networkLevelSize*2,b*this.networkLevelSize*2,this.background,this.infoAreaColor,"open")}};this.centerNetwork=function(){for(var a=0;a<this.data.nodes.length;a++){var b=this.data.nodes[a];if(!b.hide&&!b.hiddenParent){b.x=(this.offsetX+b.x)*this.scaleFactor;b.y=(this.offsetY+b.y)*this.scaleFactor}}this.scaleFactor=0.9;this.offsetX=this.x*0.05;this.offsetY=this.y*0.05};this.adjustNetworkObjects=function(b){if(b){if(b[0]=="circle"){b[1]=(this.offsetX+b[1])*this.scaleFactor;b[2]=(this.offsetY+b[2])*this.scaleFactor;b[3]=b[3]*this.scaleFactor}else{for(var a=1;a<b.length;a++){if(a%2){b[a]=(this.offsetX+b[a])*this.scaleFactor}else{b[a]=(this.offsetY+b[a])*this.scaleFactor}}}}else{return false}return b};this.setXYNodePrecision=function(){if(this.approximateNodePositions){for(var a=0;a<this.data.nodes.length;a++){var b=this.data.nodes[a];if(b.x){b.x=parseInt(b.x);this.nodes[b.id].x=b.x}if(b.y){b.y=parseInt(b.y);this.nodes[b.id].y=b.y}if(b.z){b.z=parseInt(b.z);this.nodes[b.id].z=b.z}}}};this.getLengthToNodeBoundary=function(c,i,b,h,e,d){if(e){var g=e.size?e.size:1;var a=d&&e.height?e.height:e.width?e.width:this.nodeSize*g;var f=d&&e.width?e.width:e.height?e.height:this.nodeSize*g;var j=this.clip("line",[c,i,b,h],[c-(a/2),i-(f/2),a,f]);return this.lineLength(j[0],j[1],j[2],j[3])+(this.margin*2)}else{return this.margin*2}};this.drawNetworkEdges=function(){if(this.nodes){var a={};var b=1;var f=this.foreground;for(var q=0;q<this.data.edges.length;q++){var g=this.data.edges[q];var p=this.nodes[g.id1];var o=this.nodes[g.id2];var u=false;if(!p.hide&&!p.hiddenParent&&!o.hide&&!o.hiddenParent&&!g.anchor){u=true}else{if(this.showHiddenChildEdges){if(p.hide||p.hiddenParent||(p.parentNode&&this.nodes[p.parentNode].hideChildren)){p=this.findVisibleParentNode(g.id1);if(p){u=true}}if(o.hide||o.hiddenParent||(o.parentNode&&this.nodes[o.parentNode].hideChildren)){o=this.findVisibleParentNode(g.id2);if(o){u=true}}}}var w=p.id+":"+o.id;if(u){if(!a.hasOwnProperty(w)){var c=this.selectNode.hasOwnProperty(p.id)&&this.selectNode.hasOwnProperty(o.id)?this.nodeHighlightColor:g.color?g.color:f;var j=g.width?g.width:1;var h=g.cap?g.cap:false;var d=g.exact?g.exact:false;var m,k,s,r;if(this.is3DNetwork){m=p.x3d;k=p.y3d;s=o.x3d;r=o.y3d}else{m=p.x;k=p.y;s=o.x;r=o.y}var l=g.type?g.type:"line";var n=l.match(/curved/)?true:false;var v=d?0:this.getLengthToNodeBoundary(m,k,s,r,p,n);var e=d?0:this.getLengthToNodeBoundary(s,r,m,k,o,n);var t=this.drawLine(l,m,k,s,r,c,j,h,Math.max(0,v),Math.max(0,e));if(this.layoutDone&&!this.isAnimation){if(this.preScaleNetwork){this.addArea(t,[q+this.data.nodes.length])}else{this.addArea(this.adjustNetworkObjects(t),[q+this.data.nodes.length])}b++}this.ctx.lineWidth=1;a[w]=1}}}}};this.drawNetworkNodes=function(){var o=this.data.nodes.length/this.zoom<this.showNodeNameThreshold?true:false;var k=this.foreground;var D=this.shapes[0];var b=6001;var l=this.rangeX>this.rangeY?"bottom":"right";var a=this.autoHideOnDecorationsCenter&&this.decorationsPosition=="center"&&this.decorations.length>0?true:false;for(var E=0;E<this.data.nodes.length;E++){var B=this.data.nodes[E];if(!B.hide&&!B.hiddenParent&&!B.anchor){var s=this.is3DNetwork?B.x3d:B.x;var H=this.is3DNetwork?B.y3d:B.y;var x=B.shape?B.shape:D;var j=this.selectNode.hasOwnProperty(B.id)?this.nodeHighlightColor:B.color?B.color:k;var F=B.outline?B.outline:this.foreground;var G=B.size?B.size:1;var r=B.width?B.width:this.nodeSize*G;var A=B.height?B.height:this.nodeSize*G;var t=B.pattern?B.pattern:"closed";var n=B.rotate?B.rotate*Math.PI/180:false;var z=B.outlineWidth?B.outlineWidth:false;var h=B.imagePath?B.imagePath:false;var d=B.zIndex?B.zIndex:h?b:false;var v=B.eventless?false:true;var I=this.drawShape(x,s,H,r,A,j,F,t,n,z,false,false,false,false,h,d);if(this.layoutDone&&!this.isAnimation){if(v||this.overrideEventlessNodes){if(this.preScaleNetwork){this.addArea(I,[E])}else{this.addArea(this.adjustNetworkObjects(I),[E])}}if(o&&!B.hideLabel){var f,e;var m=B.label?B.label:B.name?B.name:B.id;var C=this.getNodeColor(B.id,B.labelColor);var g=B.labelSize?this.nodeFontSize*B.labelSize*this.nodeScaleFontFactor:this.nodeFontSize*this.nodeScaleFontFactor;var u=(parseInt(g))+"Pt "+this.fontName;var y=this.measureText(m,u);var w=g;if(B.labelX!=null&&B.labelY!=null){f=B.labelX-(y/2);e=B.labelY-(w/2);this.drawText(m,B.labelX,B.labelY,u,C,"center","middle")}else{var q=this.isMultipleLines(m);var c=parseInt(g)+4;if(q){if(q%2){H+=(parseInt(q/2)*c)+(c/2)}else{H=(H+parseInt(q/2)*c)}}if(B.labelPosition){switch(B.labelPosition){case"top":f=s-(y/2);e=H-((A/1.3)+w);this.drawText(m,s,e,u,C,"center","top");break;case"bottom":f=s-(y/2);e=H+(A/1.3);this.drawText(m,s,e,u,C,"center","top");break;case"right":f=s+(r/1.3);e=H-(w/2);this.drawText(m,f,H,u,C,"left","middle");break;case"left":f=s-((r/1.3)+y);e=H-(w/2);this.drawText(m,f,H,u,C,"left","middle");break;case"center":this.drawText(m,s,H,u,C,"center","middle");break}}else{if(l=="right"){f=s+(r/1.3);e=H-(w/2);this.drawText(m,f,H,u,C,"left","middle")}else{f=s-(y/2);e=H+(A/1.3);this.drawText(m,s,e,u,C,"center","top")}}}var p=["rect",f,e,f+y,e+w];if(v||this.overrideEventlessNodes){if(this.preScaleNetwork&&!this.isAnimation){this.addArea(p,[E],"-lab")}else{this.addArea(this.adjustNetworkObjects(p),[E],"-lab")}}}}b++}}};this.drawNetworkDecorations=function(){if(this.showDecorations&&this.decorations.length>0){var H=this.decorations.length*this.decorationsWidth;var Q=H/2;var h=this.decorationsHeight/2;var V=this.decorationsHeight*2/3;var n=this.decorationsHeight/3;this.setHeatmapColors(this.decorationsRange[1]-this.decorationsRange[0]);for(var M=0;M<this.data.nodes.length;M++){var I=this.data.nodes[M];var R=[];var U=[];var b=[];var A=false;var F=this.sizeDecorationBy&&I.decorationSize?I.decorationSize:h;if(!I.hide&&!I.hiddenParent&&!I.anchor){var u=this.is3DNetwork?I.x3d:I.x;var O=this.is3DNetwork?I.y3d:I.y;var W=I.size?this.nodeSize*I.size:this.nodeSize;var e=W/2;var P,g,N,f,E,m,y;switch(this.decorationsPosition){case"top":P=this.decorationsType=="pie"?u:u-Q;g=O-(e+this.decorationsHeight+this.decorationsWidth);g=this.decorationsType=="pie"?g-h:g;break;case"bottom":P=this.decorationsType=="pie"?u:u-Q;g=O+(e+this.decorationsHeight+this.decorationsWidth);g=this.decorationsType=="pie"?g+h:g;break;case"right":P=u+e+this.decorationsWidth;g=this.decorationsType=="pie"?O:O-h;P=this.decorationsType=="pie"?P+h:P;break;case"left":P=u-(e+(this.decorationsWidth*(this.decorations.length+1)));g=this.decorationsType=="pie"?O:O-h;P=this.decorationsType=="pie"?P-h:P;break;case"center":P=this.decorationsType=="pie"?u:u-Q;g=this.decorationsType=="pie"?O:O-h;break}if(I.decorationsX!=null&&I.decorationsY!=null){P=I.decorationsX;g=I.decorationsY}if(this.preScaleNetwork&&!this.isAnimation){this.addArea(["rect",P,g,P+H,g-this.decorationsHeight],[M],"-dec")}else{this.addArea(this.adjustNetworkObjects(["rect",P,g,P+H,g-this.decorationsHeight]),[M],"-dec")}if(this.decorationsType=="bar"){y=this.decorationsRange[1]<0?g:this.decorationsRange[0]>=0?g+this.decorationsHeight:(g+this.decorationsHeight)-Math.abs(this.decorationsRange[0]*this.decorationsUnits);for(var L=0;L<this.decorations.length;L++){E=this.decorations[L];if(I[E]&&!isNaN(I[E])){this.rectangle(P,y,this.decorationsWidth,-I[E]*this.decorationsUnits,this.decorationsColors[L])}else{if(I.decorations&&I.decorations[E]&&!isNaN(I.decorations[E])){this.rectangle(P,y,this.decorationsWidth,-I.decorations[E]*this.decorationsUnits,this.decorationsColors[L])}}P+=this.decorationsWidth}}else{if(this.decorationsType=="heatmap"){for(var L=0;L<this.decorations.length;L++){var x=I[this.decorations[L]]?I[this.decorations[L]]:I.decorations?I.decorations[this.decorations[L]]:false;if(this.isObject(x)){A={};for(var K=0;K<this.decorations.length;K++){var t=I[this.decorations[K]]?I[this.decorations[K]]:I.decorations?I.decorations[this.decorations[K]]:{};for(var J in t){A[J]=true}}A=this.getKeys(A);R=[];for(o=0;o<A.length;o++){R[o]=[]}break}}}for(var L=0;L<this.decorations.length;L++){if(A||I[this.decorations[L]]!=null||(I.decorations&&I.decorations[this.decorations[L]]!=null)){var x=I[this.decorations[L]]?I[this.decorations[L]]:I.decorations?I.decorations[this.decorations[L]]:{};if(this.isObject(x)||A){if(this.decorationsType.match(/stacked/)){var o=[];for(var K in x){if(!isNaN(x[K])){o.push(x[K])}}R.push(o)}else{if(this.decorationsType=="heatmap"){for(o=0;o<A.length;o++){K=A[o];R[o].push(x&&x[K]?x[K]:"NA")}}}}else{R.push(I[this.decorations[L]]?I[this.decorations[L]]:I.decorations?I.decorations[this.decorations[L]]:"NA")}U.push([M]);if(this.decorationsType=="pie"){var C=this.decorations[L];b.push(this.decorationsProperties[C]&&this.decorationsProperties[C].color?this.decorationsProperties[C].color:this.colors[L%this.colors.length])}}else{R.push(false);U.push([M])}}if(R.length>0){if(this.decorationsType.match(/stacked/)){var G=this.decorationsType.match(/percent/)?true:false;for(var L=0;L<this.decorations.length;L++){if(R[L]){var o=[];var D=0;var C=this.decorations[L];var x=I[this.decorations[L]]?I[this.decorations[L]]:I.decorations?I.decorations[this.decorations[L]]:{};for(var K in x){var T=this.decorationsProperties[K]&&this.decorationsProperties[K].color?this.decorationsProperties[K].color:this.decorationsColors[this.decorations.length+D];o.push(T);D++}this.drawStackedPlot(R[L],P,g,this.decorationsWidth,G,this.sum(R[L]),this.decorationsUnits,"vertical",o,U[L]);var T=this.decorationsProperties[C]&&this.decorationsProperties[C].color?this.decorationsProperties[C].color:this.decorationsColors[L];var B=this.decorationsProperties[C]&&this.decorationsProperties[C].shape?this.decorationsProperties[C].shape:"circle";this.drawShape(B,P+this.decorationsWidth/2,g+n,n/1.3,n/1.3,T,this.foreground,"closed");P+=this.decorationsWidth}}}else{if(this.decorationsType=="heatmap"){if(A){V=this.decorationsHeight/R.length;for(var L=0;L<R.length;L++){if(R[L]){var C=A[L];this.drawHeatmap(R[L],P,g,this.decorationsWidth,V,this.decorationsRange[0],this.decorationsRange[1],false,U,"-dec");var T=this.decorationsProperties[C]&&this.decorationsProperties[C].color?this.decorationsProperties[C].color:this.decorationsColors[this.decorations.length+L];var B=this.decorationsProperties[C]&&this.decorationsProperties[C].shape?this.decorationsProperties[C].shape:"square";this.drawShape(B,P-n,g+(V/2),n/2,n/2,T,this.foreground,"closed")}g+=V}for(var L=0;L<this.decorations.length;L++){var C=this.decorations[L];var T=this.decorationsProperties[C]&&this.decorationsProperties[C].color?this.decorationsProperties[C].color:this.decorationsColors[L];var B=this.decorationsProperties[C]&&this.decorationsProperties[C].shape?this.decorationsProperties[C].shape:"circle";this.drawShape(B,P+this.decorationsWidth/2,g+n,n/1.3,n/1.3,T,this.foreground,"closed");P+=this.decorationsWidth}}else{if(R[0]){this.drawHeatmap(R,P,g,this.decorationsWidth,V,this.decorationsRange[0],this.decorationsRange[1],false,U,"-dec");for(var L=0;L<this.decorations.length;L++){var C=this.decorations[L];var T=this.decorationsProperties[C]&&this.decorationsProperties[C].color?this.decorationsProperties[C].color:this.decorationsColors[L];var B=this.decorationsProperties[C]&&this.decorationsProperties[C].shape?this.decorationsProperties[C].shape:"circle";this.drawShape(B,P+this.decorationsWidth/2,(g+this.decorationsHeight+(n/3)),n/1.3,n/1.3,T,this.foreground,"closed");P+=this.decorationsWidth}}}}else{var S=this.colors;this.colors=b;this.drawPie(this.setPieData(R),P,g,F);this.colors=S}}}}}}}};this.getLegendId=function(b,c){if(b){if(!c){var a=0;c=b+"LegendId"+a;while(this.data.legend.ids[b].hasOwnProperty(c)){a++;c=b+"LegendId"+a}}this.data.legend.ids[b][c]=true;return c}};this.findNetworkXYRange=function(b){var a=Number.MAX_VALUE;var f=Number.MAX_VALUE*-1;var g=Number.MAX_VALUE;var e=Number.MAX_VALUE*-1;if(!b){b=this.getKeys(this.data.nodeIndices)}if(b&&b.length>0){if(this.is3DNetwork&&this.layoutDone&&this.scaleFactor){for(var c=0;c<b.length;c++){var d=this.data.nodes[this.data.nodeIndices[b[c]]];if(!d.hide&&!d.hiddenParent&&!d.anchor){a=Math.min(a,d.x3d);f=Math.max(f,d.x3d);g=Math.min(g,d.y3d);e=Math.max(e,d.y3d)}}}else{for(var c=0;c<b.length;c++){var d=this.data.nodes[this.data.nodeIndices[b[c]]];if(!d.hide&&!d.hiddenParent&&!d.anchor){a=Math.min(a,d.x);f=Math.max(f,d.x);g=Math.min(g,d.y);e=Math.max(e,d.y)}}}}return({minX:a,maxX:f,minY:g,maxY:e})};this.inititalizeNetworkLegend=function(){if(!this.data.legend){this.data.legend={}}if(!this.data.legend.pos){this.data.legend.pos={}}if(!this.data.legend.pos.nodes){this.data.legend.pos.nodes={x:false,y:false}}if(!this.data.legend.pos.edges){this.data.legend.pos.edges={x:false,y:false}}if(!this.data.legend.pos.decorations){this.data.legend.pos.decorations={x:false,y:false}}if(!this.data.legend.ids){this.data.legend.ids={nodes:{},edges:{},text:{},decorations:{}}}};this.drawNetworkLegend=function(){if(this.showLegend){this.inititalizeNetworkLegend();var a=this.findNetworkXYRange();this.curLegendX=a.minX;this.curLegendY=a.minY;if(this.showNetworkNodesLegend){this.drawNetworkLegendNodes()}if(this.showNetworkEdgesLegend){this.drawNetworkLegendEdges()}if(this.showNetworkTextLegend){this.drawNetworkLegendText()}if(this.showNetworkDecorationsLegend){this.drawNetworkLegendDecorations()}}};this.drawNetworkLegendNodes=function(){if(this.data.legend.nodes&&this.data.legend.nodes.length>0){var f=this.data.legend.pos.nodes.x!=null?this.data.legend.pos.nodes.x:this.curLegendX;var d=this.data.legend.pos.nodes.y!=null?this.data.legend.pos.nodes.y:this.curLegendY;this.data.legend.pos.nodes.x=parseInt(f);this.data.legend.pos.nodes.y=parseInt(d);var u=0;var t=0;for(var v=0;v<this.data.legend.nodes.length;v++){this.data.legend.nodes[v].id=this.getLegendId("nodes",this.data.legend.nodes[v].id);var s=this.data.legend.nodes[v].color||this.nodeFontColor;var w=this.data.legend.nodes[v].outline?this.data.legend.nodes[v].outline:this.foreground;var a=this.data.legend.nodes[v].shape||this.shapes[0];var o=this.data.legend.nodes[v].size?this.data.legend.nodes[v].size*this.nodeFontSize:this.nodeFontSize;var k=this.data.legend.nodes[v].width?this.data.legend.nodes[v].width:o;var q=this.data.legend.nodes[v].height?this.data.legend.nodes[v].height:o;var l=this.data.legend.nodes[v].pattern?this.data.legend.nodes[v].pattern:"closed";var j=this.data.legend.nodes[v].rotate?this.data.legend.nodes[v].rotate*Math.PI/180:false;var r=this.data.legend.nodes[v].outlineWidth?this.data.legend.nodes[v].outlineWidth:false;var g=this.data.legend.nodes[v].imagePath?this.data.legend.nodes[v].imagePath:false;var b=this.data.legend.nodes[v].zIndex?this.data.legend.nodes[v].zIndex:false;var h=this.data.legend.nodes[v].font?this.data.legend.nodes[v].font*this.nodeFontSize*this.nodeScaleFontFactor:this.nodeFontSize*this.nodeScaleFontFactor;var n=(parseInt(h))+"Pt "+this.fontName;var m=this.data.legend.nodes[v].text?this.data.legend.nodes[v].text:"";var p=this.measureText(m,n);o=parseFloat(sprintf("%.1f",o));u=Math.max(u,(this.margin*3)+o+p);t=o/2;d+=t;this.drawShape(a,this.margin+f+t,this.margin+d+t,k,q,s,w,l,j,r,false,false,false,false,g,b);this.drawText(m,(this.margin*2)+f+o,this.margin+d+t,n,this.nodeFontColor,"left","middle");d+=o}d+=this.margin+t;var y=this.data.legend.pos.nodes.x;var e=this.data.legend.pos.nodes.y;var x=u;var c=d-this.data.legend.pos.nodes.y;if(this.legendBox){this.rectangle(y,e,x,c,false,this.legendBoxColor,"open")}var z=["rect",y,e,y+x,e+c];if(this.preScaleNetwork){this.addArea(z,[-1],"-legend-Nodes")}else{this.addArea(this.adjustNetworkObjects(z),[-1],"-legend-Nodes")}this.curLegendX=f;this.curLegendY=d}};this.drawNetworkLegendEdges=function(){if(this.data.legend.edges&&this.data.legend.edges.length>0){var d=this.data.legend.pos.edges.x!=null?this.data.legend.pos.edges.x:this.curLegendX;var b=this.data.legend.pos.edges.y!=null?this.data.legend.pos.edges.y:this.curLegendY;this.data.legend.pos.edges.x=parseInt(d);this.data.legend.pos.edges.y=parseInt(b);var n=0;var m=0;for(var o=0;o<this.data.legend.edges.length;o++){this.data.legend.edges[o].id=this.getLegendId("edges",this.data.legend.edges[o].id);var l=this.data.legend.edges[o].color||this.nodeFontColor;var f=this.data.legend.edges[o].type||"line";var k=this.data.legend.edges[o].width||1;var j=this.data.legend.edges[o].size?this.data.legend.edges[o].size*this.nodeFontSize:this.nodeFontSize;var e=this.data.legend.edges[o].font?this.data.legend.edges[o].font*this.nodeFontSize*this.nodeScaleFontFactor:this.nodeFontSize*this.nodeScaleFontFactor;var h=(parseInt(e))+"Pt "+this.fontName;var g=this.data.legend.edges[o].text||"";var p=this.measureText(g,h);j=parseFloat(sprintf("%.1f",j));n=Math.max(n,(this.margin*3)+j+p);m=e/2;b+=m;this.ctx.lineWidth=k*this.edgeWidth;this.drawLine(f,this.margin+d,this.margin+b+m,d+j,this.margin+b+m,l,false,false,0,0);this.drawText(g,(this.margin*2)+d+j,this.margin+b+m,h,this.nodeFontColor,"left","middle");b+=e}b+=this.margin+m;var r=this.data.legend.pos.edges.x;var c=this.data.legend.pos.edges.y;var q=n;var a=b-this.data.legend.pos.edges.y;if(this.legendBox){this.rectangle(r,c,q,a,false,this.legendBoxColor,"open")}var s=["rect",r,c,r+q,c+a];if(this.preScaleNetwork){this.addArea(s,[-1],"-legend-Edges")}else{this.addArea(this.adjustNetworkObjects(s),[-1],"-legend-Edges")}this.curLegendX=d;this.curLegendY=b}};this.drawNetworkLegendText=function(){if(this.data.legend.text&&this.data.legend.text.length>0){var r=0;for(var l=0;l<this.data.legend.text.length;l++){this.data.legend.text[l].id=this.getLegendId("text",this.data.legend.text[l].id);var j=this.data.legend.text[l].x!=null?this.data.legend.text[l].x:this.curLegendX;var f=this.data.legend.text[l].y!=null?this.data.legend.text[l].y:this.curLegendY;this.data.legend.text[l].x=parseInt(j);this.data.legend.text[l].y=parseInt(f);var d=this.data.legend.text[l].boxed||this.legendBox;var g=this.data.legend.text[l].margin||this.margin;var m=this.setNetworkLegendMargins(g);var h=this.data.legend.text[l].color||this.nodeFontColor;var q=this.data.legend.text[l].text||"";var o=this.data.legend.text[l].font?this.data.legend.text[l].font*this.nodeFontSize*this.nodeScaleFontFactor:this.nodeFontSize*this.nodeScaleFontFactor;o=parseInt(o);var e=(o)+"Pt "+this.fontName;var c=this.measureText(q,e);r=o/2;this.drawText(q,m[3]+j,m[0]+f+r,e,h,"left","middle");var b=this.data.legend.text[l].x;var p=this.data.legend.text[l].y;var a=m[1]+m[3]+c;var n=m[0]+m[2]+o;if(d){this.rectangle(b,p,a,n,false,this.legendBoxColor,"open")}f+=m[0]+m[2]+o;var k=["rect",b,p,b+a,p+n];if(this.preScaleNetwork){this.addArea(k,[-1],"-legend-Text"+l)}else{this.addArea(this.adjustNetworkObjects(k),[-1],"-legend-Text"+l)}this.curLegendX=j;this.curLegendY=f}}};this.drawNetworkLegendDecorations=function(){if(this.data.legend.decorations&&this.data.legend.decorations.length>0){var e=this.data.legend.pos.decorations.x!=null?this.data.legend.pos.decorations.x:this.curLegendX;var c=this.data.legend.pos.decorations.y!=null?this.data.legend.pos.decorations.y:this.curLegendY;this.data.legend.pos.decorations.x=parseInt(e);this.data.legend.pos.decorations.y=parseInt(c);var s=0;var r=0;for(var t=0;t<this.data.legend.decorations.length;t++){this.data.legend.decorations[t].id=this.getLegendId("decorations",this.data.legend.decorations[t].id);var q=this.data.legend.decorations[t].color||this.nodeFontColor;var u=this.data.legend.decorations[t].outline?this.data.legend.decorations[t].outline:this.foreground;var a=this.data.legend.decorations[t].shape||this.shapes[0];var m=this.data.legend.decorations[t].size?this.data.legend.decorations[t].size*this.nodeFontSize:this.nodeFontSize;var h=this.data.legend.decorations[t].width?this.data.legend.decorations[t].width:m;var o=this.data.legend.decorations[t].height?this.data.legend.decorations[t].height:m;var j=this.data.legend.decorations[t].pattern?this.data.legend.decorations[t].pattern:"closed";var g=this.data.legend.decorations[t].rotate?this.data.legend.decorations[t].rotate*Math.PI/180:false;var p=this.data.legend.decorations[t].outlineWidth?this.data.legend.decorations[t].otlineWidth:false;var f=this.data.legend.decorations[t].font?this.data.legend.decorations[t].font*this.nodeFontSize*this.nodeScaleFontFactor:this.nodeFontSize*this.nodeScaleFontFactor;var l=(parseInt(f))+"Pt "+this.fontName;var k=this.data.legend.decorations[t].text?this.data.legend.decorations[t].text:"";var n=this.measureText(k,l);m=parseFloat(sprintf("%.1f",m));s=Math.max(s,(this.margin*3)+m+n);r=m/2;c+=r;this.drawShape(a,this.margin+e+r,this.margin+c+r,h,o,q,u,j,g,p);this.drawText(k,(this.margin*2)+e+m,this.margin+c+r,l,this.nodeFontColor,"left","middle");c+=m}c+=this.margin+r;var w=this.data.legend.pos.decorations.x;var d=this.data.legend.pos.decorations.y;var v=s;var b=c-this.data.legend.pos.decorations.y;if(this.legendBox){this.rectangle(w,d,v,b,false,this.legendBoxColor,"open")}var x=["rect",w,d,w+v,d+b];if(this.preScaleNetwork){this.addArea(x,[-1],"-legend-Decorations")}else{this.addArea(this.adjustNetworkObjects(x),[-1],"-legend-Decorations")}this.curLegendX=e;this.curLegendY=c}};this.setNetworkLegendMargins=function(a){if(isNaN(a)){var b=a.split(/[,\s]+/);if(b.length>3){return[parseInt(b[0]),parseInt(b[1]),parseInt(b[2]),parseInt(b[3])]}else{if(b.length==3){return[parseInt(b[0]),parseInt(b[1]),parseInt(b[2]),parseInt(b[1])]}else{if(b.length==2){return[parseInt(b[0]),parseInt(b[1]),parseInt(b[0]),parseInt(b[1])]}else{return[parseInt(b[0]),parseInt(b[0]),parseInt(b[0]),parseInt(b[0])]}}}}else{return[parseInt(a),parseInt(a),parseInt(a),parseInt(a)]}};this.drawNetworkProgressBar=function(b){if(!this.layoutDone){this.ctx.save();this.ctx.fillStyle="#fff";this.ctx.strokeStyle="#fff";var a=(new Date().getTime()-this.preUpdateTime)/(this.layoutTime*1000);a=Math.max(a,this.layoutProgress);if(b){this.ctx.strokeRect((this.width/2)-50,(this.height/2)-5,100,10);this.ctx.fillRect((this.width/2)-50,(this.height/2)-5,a*100,10);this.drawText("Calculating ...",(this.width/2)-50,(this.height/2)+10,this.showAnimationFont,this.showAnimationFontColor,"left","top")}else{this.ctx.strokeRect(this.width-110,this.height-20,100,10);this.ctx.fillRect(this.width-110,this.height-20,a*100,10)}this.ctx.restore()}};this.packSubNetworks=function(){var l=this;var q=function(t,s,a){for(var u=0;u<t.length;u++){l.modifyXYNode(t[u],s,a)}};var c=function(a,t,i,s){this.x=a;this.y=t;this.w=i;this.h=s};c.prototype.fits=function(a){return a.w>=this.w&&a.h>=this.h};c.prototype.sameSize=function(a){return a.w==this.w&&a.h==this.h};var e=function(){this.l=null;this.r=null;this.a=null;this.f=false};e.prototype.insert=function(i){if(this.l!=null){return this.l.insert(i)||this.r.insert(i)}if(this.f){return null}if(!i.fits(this.a)){return null}if(i.sameSize(this.a)){this.f=true;return this}this.l=new e();this.r=new e();var s=this.a.w-i.w;var u=this.a.h-i.h;var t=this.a;if(s>u){this.l.a=new c(t.x,t.y,i.w,t.h);this.r.a=new c(t.x+i.w,t.y,t.w-i.w,t.h)}else{this.l.a=new c(t.x,t.y,t.w,i.h);this.r.a=new c(t.x,t.y+i.h,t.w,t.h-i.h)}return this.l.insert(i)};for(var k=0;k<this.subNetworks.length;k++){this.subNetworks[k].mnm=this.findNetworkXYRange(this.subNetworks[k].nodes);this.subNetworks[k].w=(this.subNetworks[k].mnm.maxX-this.subNetworks[k].mnm.minX);this.subNetworks[k].h=(this.subNetworks[k].mnm.maxY-this.subNetworks[k].mnm.minY);q(this.subNetworks[k].nodes,this.subNetworks[k].mnm.minX,this.subNetworks[k].mnm.minY)}var r=this.subNetworks[1];for(var k=0;k<this.subNetworks.length;k++){this.subNetworks[k].w+=(r.w*0.5);this.subNetworks[k].h+=(r.h*0.5)}var d=this.subNetworks[0];var b=d.nodes.length/this.data.nodes.length;var h=((2+b)*((this.x/this.y)*d.w));var g=((2+b)*((this.y/this.x)*d.h));var m=new e();var o,n;m.a=new c(0,0,h,g);for(var k=0;k<this.subNetworks.length;k++){var f=this.subNetworks[k];var p=new c(0,0,f.w,f.h);var j=m.insert(p);q(this.subNetworks[k].nodes,-j.a.x,-j.a.y)}this.scaleFactor*=0.1};this.setNetworkMinMaxRangeXY=function(){if(!this.networkFreeze||(this.rangeX==null||this.rangeY==null)){if(this.subNetworks&&!this.isAnimation){this.packSubNetworks();if(!this.isAnimation){this.subNetworks=false}}this.minX=Number.MAX_VALUE;this.minY=Number.MAX_VALUE;this.maxX=0;this.maxY=0;if(this.is3DNetwork&&this.layoutDone){for(var b=0;b<this.data.nodes.length;b++){var d=this.data.nodes[b];var a=d.width?d.width:d.size?(this.nodeSize*d.size):this.nodeSize;var c=d.height?d.height:d.size?(this.nodeSize*d.size):this.nodeSize;if(!d.hide){this.minX=Math.min(this.minX,d.x3d-a/2);this.minY=Math.min(this.minY,d.y3d-c/2);this.maxX=Math.max(this.maxX,d.x3d+a/2);this.maxY=Math.max(this.maxY,d.y3d+c/2)}}}else{for(var b=0;b<this.data.nodes.length;b++){var d=this.data.nodes[b];var a=d.width?d.width:d.size?(this.nodeSize*d.size):this.nodeSize;var c=d.height?d.height:d.size?(this.nodeSize*d.size):this.nodeSize;if(!d.hide){this.minX=Math.min(this.minX,d.x-a/2);this.minY=Math.min(this.minY,d.y-c/2);this.maxX=Math.max(this.maxX,d.x+a/2);this.maxY=Math.max(this.maxY,d.y+c/2)}}}this.minX-=(this.nodeSize*3);this.minY-=(this.nodeSize*3);this.maxX+=(this.nodeSize*3);this.maxY+=(this.nodeSize*3);this.rangeX=this.maxX-this.minX;this.rangeY=this.maxY-this.minY}};this.setNetworkRotation=function(){if(this.is3DNetwork&&this.layoutDone){var e=[];var b=[];var k=[];this.set3DRotation();for(var c=0;c<this.data.nodes.length;c++){b.push(c);var a=this.data.nodes[c];var d=this.get3DTransfrom(a.x,a.y,a.z);a.x3d=d[0];a.y3d=d[1];a.z3d=d[2];e.push(Math.sqrt((a.x3d*a.x3d)+(a.y3d*a.y3d)+(a.z3d*a.z3d)))}b.sort(function(l,i){return e[i]-e[l]});for(var j=0;j<this.data.nodes.length;j++){var c=b[j];var a=this.data.nodes[c];k.push(a)}this.data.nodes=k;this.setNodeIndices()}else{if(this.network2DRotate!=0){if(this.network2DRotate>=Math.abs(360)){this.network2DRotate=0}var f=Math.PI*this.network2DRotate/360;for(var c=0;c<this.data.nodes.length;c++){var a=this.data.nodes[c];if(a.x!=null&&a.y!=null){var h=a.x;var g=a.y;a.x=(h*Math.cos(f))-(g*Math.sin(f));a.y=(g*Math.cos(f))+(h*Math.sin(f))}}if(this.data.legend.pos.nodes.x&&this.data.legend.pos.nodes.y){var h=this.data.legend.pos.nodes.x;var g=this.data.legend.pos.nodes.y;this.data.legend.pos.nodes.x=(h*Math.cos(f))-(g*Math.sin(f));this.data.legend.pos.nodes.y=(g*Math.cos(f))+(h*Math.sin(f))}if(this.data.legend.pos.edges.x&&this.data.legend.pos.edges.y){var h=this.data.legend.pos.edges.x;var g=this.data.legend.pos.edges.y;this.data.legend.pos.edges.x=(h*Math.cos(f))-(g*Math.sin(f));this.data.legend.pos.edges.y=(g*Math.cos(f))+(h*Math.sin(f))}if(this.data.legend.text){for(var c=0;c<this.data.legend.text.length;c++){var h=this.data.legend.text[c].x;var g=this.data.legend.text[c].y;this.data.legend.text[c].x=(h*Math.cos(f))-(g*Math.sin(f));this.data.legend.text[c].y=(g*Math.cos(f))+(h*Math.sin(f))}}this.network2DRotate=0}}};this.setNetworkScaleFactor=function(){if(!this.networkFreeze||this.scaleFactor==null){this.scaleFactor=this.networkLayoutType=="radial"?0.3:Math.min(this.x/(this.maxX-this.minX),this.y/(this.maxY-this.minY))}this.scaleFactor*=this.zoom;if(this.networkFreeze){this.zoomGlobal*=this.zoom;this.zoom=1}this.widthBounds=this.x/this.scaleFactor;this.heightBounds=this.y/this.scaleFactor;this.offsetX=((this.widthBounds/2)-((this.minX+this.maxX)/2))+this.panningX+this.panningGlobalX;this.offsetY=((this.heightBounds/2)-((this.minY+this.maxY)/2))+this.panningY+this.panningGlobalY};this.optimizeNetworkLayout=function(){if(this.data.nodes.length>0){this.isAnimation=true;this.setInitialForceDirectedLayout();this.preUpdateTime=new Date().getTime();var a=this.layoutTime*1000;var b=this.maxIterations*this.nodes.length;var c=this;var d=function(){this.update=function(){var f=new Date().getTime();if(c.updateForceDirectedLayout(30)||(f-c.preUpdateTime>a)||c.iteration>b){c.layoutDone=true;clearInterval(e);c.isAnimation=false;c.iteration=0}c.renderNetwork()};var e=setInterval(this.update,30)};d.call()}};this.getAngle=function(e,g,c,f,d){var b=(Math.atan2(f-g,c-e)*180/Math.PI)%360;if(!d){d=0}while(b<d){b+=360}while(b>=(d+360)){b-=360}return b};this.getPolar=function(c,b){return{x:this.networkXCenter+c*Math.cos(b*Math.PI/180),y:this.networkYCenter+c*Math.sin(b*Math.PI/180)}};this.setNodePositions=function(a){for(var c in a){var b=this.data.nodes[this.data.nodeIndices[c]];b.x=a[c].x;b.y=a[c].y}};this.animateRadialNodePositions=function(){this.isAnimation=true;var e=this;var d=50;var c=0;var b=0;for(var g in e.finalRadialNodePositions){if(this.initialRadialNodePositions[g].r==0){this.initialRadialNodePositions[g].a=this.finalRadialNodePositions[g].a}if(this.finalRadialNodePositions[g].r==0){this.finalRadialNodePositions[g].a=this.initialRadialNodePositions[g].a}var a=(this.finalRadialNodePositions[g].a-this.initialRadialNodePositions[g].a);if(a<0){a+=360}if(a>360){a-=360}if(a>180){a-=360}this.finalRadialNodePositions[g].a=(this.initialRadialNodePositions[g].a+a)}var f=function(){this.update=function(){var j={};var q=Math.atan((c/d)*10-5)*0.5/Math.atan(5)+0.5;var m=1-q;for(var l in e.finalRadialNodePositions){var i=((m*e.initialRadialNodePositions[l].a)+(q*e.finalRadialNodePositions[l].a));var k=((m*e.initialRadialNodePositions[l].r)+(q*e.finalRadialNodePositions[l].r));var p=e.getPolar(k,i);j[l]={x:p.x,y:p.y}}if(c>=d){clearInterval(h);e.isAnimation=false;j=e.finalRadialNodePositions}c++;e.setNodePositions(j);e.renderNetwork()};var h=setInterval(this.update,50)};f.call()};this.setFinalRadialNodePositions=function(e,d){if(!this.finalRadialNodePositions){this.finalRadialNodePositions={}}if(!this.nodeParentHood.drawn.hasOwnProperty(e)){var m,o,g,n,b;var f=this.data.nodes[this.data.nodeIndices[e]];if(!f.hide&&!f.hiddenParent){if(this.nodeParentHood[e].children.length>1&&!d){var k=[];var j=this;if(this.orderRadialNetwork){this.nodeParentHood[e].children.sort(function(i,c){return j.orderRadialNetwork[i]-j.orderRadialNetwork[c]})}for(var h=0;h<this.nodeParentHood[e].children.length;h++){if(this.nodeParentHood[this.nodeParentHood[e].children[h]].level>this.nodeParentHood[e].level){this.setFinalRadialNodePositions(this.nodeParentHood[e].children[h]);k.push(this.nodeParentHood[this.nodeParentHood[e].children[h]].angle)}}if(k.length>0){if(k.length==1){n=k[0]}else{if(k[0]>k[k.length-1]){n=((k[0]+k[k.length-1])%360)/2}else{n=(k[0]+k[k.length-1])/2}}}else{this.setFinalRadialNodePositions(e,true)}}else{n=this.networkCurrentAngle;this.networkCurrentAngle=(this.networkCurrentAngle+this.networkAngleStep)}g=(this.networkDepth-1)-this.nodeParentHood[e].level;m=this.getPolar(this.networkRadialRadius,n);o=this.shortenLine(this.networkXCenter,this.networkYCenter,m.x,m.y,0,this.networkLevelSize*g,"line");b=this.lineLength(this.networkXCenter,this.networkYCenter,o[2],o[3]);if(this.nodeParentHood[e].level==0){n=0;b=0}this.finalRadialNodePositions[f.id]={x:o[2],y:o[3],r:b,a:n%360};this.nodeParentHood.drawn[e]=true;this.nodeParentHood[e].angle=n}}};this.setInitialRadialNodePositions=function(){if(!this.initialRadialNodePositions){this.initialRadialNodePositions={};for(var a=0;a<this.data.nodes.length;a++){if(!this.data.nodes[a].hide&&!this.data.nodes[a].hiddenParent){var b=this.data.nodes[a];this.initialRadialNodePositions[b.id]={x:this.networkXCenter,y:this.networkYCenter,r:0,a:0}}}}else{this.initialRadialNodePositions=this.finalRadialNodePositions;this.finalRadialNodePositions=false}};this.setRadialNetwrorkLayout=function(){if(this.data.nodes.length>0){this.networkLevelSize=this.x*4/(this.networkDepth*2);this.networkAngleStep=360/this.networkDivisions;this.networkCurrentAngle=this.networkCurrentAngle?this.networkCurrentAngle:0;this.networkRadialRadius=this.networkLevelSize*(this.networkDepth-1);this.setInitialRadialNodePositions();this.setFinalRadialNodePositions(this.networkRoot);this.layoutDone=true;if(this.showAnimation){this.animateRadialNodePositions()}else{this.setNodePositions(this.finalRadialNodePositions);this.renderNetwork()}}};this.createRandomNetwork=function(t){var l={};var a={};if(t){l=this.createMesh()}else{l.nodes=[];var d=Math.floor(Math.random()*this.randomNetworkNodes)+1;for(var m=0;m<d;m++){var g={};var r=Math.floor(Math.random()*this.shapes.length);var e=Math.floor(Math.random()*this.colors.length);g.id="id"+m;g.shape=this.shapes[r];g.color=this.colors[e];g.size=1;l.nodes.push(g)}l.edges=[];for(var m=0;m<l.nodes.length;m++){var f=l.nodes[m];var k=[];for(var h=0;h<Math.floor(Math.random()*this.randomNetworkNodeEdgesMax)-1;h++){k.push(Math.floor(Math.random()*d))}for(var h=0;h<k.length;h++){var c=l.nodes[k[h]];var q=m+":"+k[h];var p=k[h]+":"+m;if(f.id!=c.id&&!a.hasOwnProperty(q)&&!a.hasOwnProperty(q)){var b={};var s=Math.floor(Math.random()*this.lines.length);var e=Math.floor(Math.random()*this.colors.length);b.id1=f.id;b.id2=c.id;b.width=1;b.type=this.lines[s];b.color=this.colors[e];l.edges.push(b);a[q]=1;a[p]=1}}}}if(this.reduceRandomNetwork){var o=this.normalizeGraph(l);l=this.reduceNetwork(o,function(j,i){if(j.nodes&&i.nodes){if(j.nodes.length>=i.nodes.length){return j}else{return i}}else{if(j.nodes){return j}else{if(i.nodes){return i}else{return null}}}})}if(l.nodes.length<5){return this.createRandomNetwork(true)}else{var k=[];for(var m=0;m<l.edges.length;m++){if(l.edges[m].id1&&l.edges[m].id2){k.push(l.edges[m])}}l.edges=k;return l}};this.createMesh=function(){var f={};f.nodes=[];f.edges=[];var e=7;var a=this;for(var h=0;h<e*e;h++){var c={};var g=Math.floor(Math.random()*this.shapes.length);var b=Math.floor(Math.random()*this.colors.length);c.id="id"+h;c.shape=this.shapes[g];c.color=this.colors[b];c.size=1;f.nodes.push(c)}var d=function(m,l){var k={};var i=Math.floor(Math.random()*a.lines.length);var j=Math.floor(Math.random()*a.colors.length);k.id1=f.nodes[m].id;k.id2=f.nodes[l].id;k.width=1;k.type=a.lines[i];k.color=a.colors[j];return k};for(var h=0;h<f.nodes.length;h++){if(Math.floor(Math.random()*e)!=0){if(h+1<f.nodes.length&&(h+1)%e!=0){f.edges.push(d(h,h+1))}if(h+e<f.nodes.length){f.edges.push(d(h,h+e))}}}return f};this.setNodeChildren=function(f,b,g){this.networkDepth=b>this.networkDepth?b:this.networkDepth;var d=this.data.nodes[this.data.nodeIndices[f]];if(!d.hide&&!d.hiddenParent){var a=this.edgesForNode(this.data.edges,f);if(!this.nodeParentHood.hasOwnProperty(f)){if(a.length==1){this.networkDivisions++}if(a.length>0){for(var c=0;c<a.length;c++){if(!this.nodeParentHood[f]){this.nodeParentHood[f]={};this.nodeParentHood[f].children=[];this.nodeParentHood[f].level=b;this.nodeParentHood[f].angle=0;this.nodeParentHood[f].parent=g}this.nodeParentHood[f].level=b<this.nodeParentHood[f].level?b:this.nodeParentHood[f].level;if(a[c].id1==f){this.nodeParentHood[f].children.push(a[c].id2);this.setNodeChildren(a[c].id2,b+1,f)}else{if(a[c].id2==f){this.nodeParentHood[f].children.push(a[c].id1);this.setNodeChildren(a[c].id1,b+1,f)}}}}}else{this.nodeParentHood[f].level=b<this.nodeParentHood[f].level?b:this.nodeParentHood[f].level;for(var c=0;c<this.nodeParentHood[f].children.length;c++){var e=this.nodeParentHood[f].children[c];if(this.nodeParentHood[e]){if((b+1)<this.nodeParentHood[e].level){this.nodeParentHood[e].level=b+1;this.nodeParentHood[e].parent=f}}}}}};this.setNodeParentHood=function(){this.nodeParentHood={};if(this.networkLayoutType=="radial"){if(!this.networkRoot){this.networkRoot=this.data.nodes[0].id}this.nodeParentHood.drawn={};this.networkDepth=0;this.networkDivisions=0;this.setNodeChildren(this.networkRoot,0,false)}else{for(var a=0;a<this.data.nodes.length;a++){if(!this.data.nodes[a].hide){if(this.data.nodes[a].parentNode||this.data.nodes[a].hideChildren){if(this.data.nodes[a].parentNode&&!this.nodeParentHood.hasOwnProperty(this.data.nodes[a].parentNode)){this.nodeParentHood[this.data.nodes[a].parentNode]={}}if(this.data.nodes[a].parentNode){if(!this.nodeParentHood[this.data.nodes[a].parentNode].children){this.nodeParentHood[this.data.nodes[a].parentNode].children=[]}this.nodeParentHood[this.data.nodes[a].parentNode].children.push(this.data.nodes[a].id);if(this.data.nodes[this.data.nodeIndices[this.data.nodes[a].parentNode]].hideChildren){this.data.nodes[a].hiddenParent=true}}if(this.data.nodes[a].hideChildren){if(!this.nodeParentHood.hasOwnProperty(this.data.nodes[a].id)){this.nodeParentHood[this.data.nodes[a].id]={}}this.nodeParentHood[this.data.nodes[a].id].hideChildren=true}}}}for(var b in this.nodeParentHood){if(this.data.nodes[this.data.nodeIndices[b]].hideChildren||this.isParentHidden(b)){this.hideUnhideChildrenNodes(b,true)}else{if(this.nodeParentHood[b].children){this.hideUnhideChildrenNodes(b,false)}}}}};this.isParentHidden=function(c){var b=this.findParentNodes(c);if(b){for(var a=0;a<b.length;a++){if(this.data.nodes[this.data.nodeIndices[b[a]]].hideChildren){return true}}}return false};this.findParentNodes=function(c,a){if(this.data.nodes[this.data.nodeIndices[c]].parentNode){var b=this.data.nodes[this.data.nodeIndices[c]].parentNode;if(!a){a=[]}a.push(b);a=this.findParentNodes(b,a);return a}else{return a?a.reverse():false}};this.findChildrenNodeIndices=function(c,b){if(!b){b=[]}if(this.nodeParentHood[c]&&this.nodeParentHood[c]["children"]){for(var a=0;a<this.nodeParentHood[c]["children"].length;a++){b.push(this.data.nodeIndices[this.nodeParentHood[c]["children"][a]]);b=this.findChildrenNodeIndices(this.nodeParentHood[c]["children"][a],b)}}return b.length>0?b:false};this.hasChildren=function(a){return this.nodeParentHood[a]&&this.nodeParentHood[a].children};this.findVisibleParentNode=function(c){var b=this.findParentNodes(c);if(b){b.reverse();for(var a=0;a<b.length;a++){if(!this.nodes[b[a]].hide&&!this.nodes[b[a]].hiddenParent){return this.nodes[b[a]]}}}return false};this.collateNetworks=function(){if(this.data.nodes.length>0){var k=this.normalizeGraph({nodes:this.data.nodes,edges:this.data.edges});if(k.length>1){var a=[];for(var g=0;g<k.length;g++){a.push(g)}a.sort(function(j,i){return k[i].nodes.length-k[j].nodes.length});this.subNetworks=[];for(var o=0;o<k.length;o++){var g=a[o];var c=[];var l=[];var f=k[g].nodes.length;var h=k[g].edges.length;var b=f/this.data.nodes.length;var n=b*(this.x*Math.log(k.length));var m=b*(this.y*Math.log(k.length));var d=n*m;for(var e=0;e<k[g].nodes.length;e++){c.push(k[g].nodes[e].id)}for(var e=0;e<k[g].edges.length;e++){if(typeof k[g].edges[e]!="function"){l.push(k[g].edges[e])}}this.subNetworks.push({nodes:c,edges:l,x:n,y:m,area:d,networkForceConstant:Math.sqrt(d/f),temperature:f+Math.floor(Math.sqrt(h)),minimumTemperature:1,initialTemperature:f+Math.floor(Math.sqrt(h)),initialProgress:null,layoutProgress:0,layoutDone:false})}}}};this.setObjectAttributes=function(){if(this.colorNodeBy){this.setAllObjectAttributes("nodes","color",this.colorNodeBy)}if(this.shapeNodeBy){this.setAllObjectAttributes("nodes","shape",this.shapeNodeBy)}if(this.sizeNodeBy){this.setAllObjectAttributes("nodes","size",this.sizeNodeBy)}if(this.sizeDecorationBy){this.setAllObjectAttributes("nodes","size",this.sizeDecorationBy,true)}if(this.colorEdgeBy){this.setAllObjectAttributes("edges","color",this.colorEdgeBy)}if(this.shapeEdgeBy){this.setAllObjectAttributes("edges","shape",this.shapeEdgeBy)}if(this.sizeEdgeBy){this.setAllObjectAttributes("edges","size",this.sizeEdgeBy)}};this.setDecorationsRangeUnits=function(){this.decorationsRange=[];var b={};var c={};if(this.showDecorations&&this.decorations.length>0){var m=[];for(var h=0;h<this.data.nodes.length;h++){var e=this.data.nodes[h];for(var g=0;g<this.decorations.length;g++){if(e[this.decorations[g]]||(e.decorations&&e.decorations[this.decorations[g]])){var n=e[this.decorations[g]]?e[this.decorations[g]]:e.decorations[this.decorations[g]];if(this.isObject(n)){if(this.decorationsType=="stacked"){var p=0;for(var f in n){if(!isNaN(n[f])){c[f]=true;p+=n[f]}}m.push(p)}else{if(this.decorationsType=="stackedpercent"){for(var f in n){if(!isNaN(n[f])){c[f]=true}}m=[0,100]}else{if(this.decorationsType=="heatmap"){for(var f in n){if(!isNaN(n[f])){c[f]=true;m.push(n[f])}}}else{alert("Ooops! canvasXpress does not support "+this.decorationsType+" for this multidimensional plotting");return}}}}else{if(!isNaN(e[this.decorations[g]])||(e.decorations&&!isNaN(e.decorations[this.decorations[g]]))){m.push(e[this.decorations[g]]?e[this.decorations[g]]:e.decorations[this.decorations[g]])}}}}}this.decorationsRange=this.range(m);if(this.decorationsType=="stacked"){this.decorationsRange[0]=0}var a=this.decorationsRange[1]-this.decorationsRange[0];if(a==0){this.decorationsRange[1]=this.max(m)+1}var l=this.decorationsType.match(/stacked/)?this.decorationsRange[0]:this.decorationsRange[0]-(a*0.05);if(l>0){this.decorationsRange[0]=l;a=this.decorationsRange[1]-this.decorationsRange[0]}this.decorationsUnits=this.decorationsHeight/a;if(!this.data.legend){this.data.legend={}}this.data.legend.decorations=[];for(var h=0;h<this.decorations.length;h++){if(this.decorationsColors[h]){b[this.decorationsColors[h]]=true;this.data.legend.decorations.push({shape:this.decorationsProperties[this.decorations[h]]&&this.decorationsProperties[this.decorations[h]].shape?this.decorationsProperties[this.decorations[h]].shape:"circle",color:this.decorationsProperties[this.decorations[h]]&&this.decorationsProperties[this.decorations[h]].color?this.decorationsProperties[this.decorations[h]].color:this.decorationsColors[h],text:this.decorations[h],size:0.5,font:0.5})}else{for(var g=0;g<this.colors.length;g++){if(!b.hasOwnProperty(this.colors[g])){var d=this.decorationsProperties[this.decorations[h]]&&this.decorationsProperties[this.decorations[h]].color?this.decorationsProperties[this.decorations[h]].color:this.colors[g];var o=this.decorationsProperties[this.decorations[h]]&&this.decorationsProperties[this.decorations[h]].shape?this.decorationsProperties[this.decorations[h]].shape:"circle";this.decorationsColors[h]=d;b[d]=true;this.data.legend.decorations.push({shape:o,color:d,text:this.decorations[h],size:0.5,font:0.5});break}}}}var h=this.decorations.length;for(var f in c){if(this.decorationsColors[h]){b[this.decorationsColors[h]]=true;this.data.legend.decorations.push({shape:this.decorationsProperties[f]&&this.decorationsProperties[f].shape?this.decorationsProperties[f].shape:"square",color:this.decorationsProperties[f]&&this.decorationsProperties[f].color?this.decorationsProperties[f].color:this.decorationsColors[h],text:f,size:0.5,font:0.5})}else{for(var g=0;g<this.colors.length;g++){if(!b.hasOwnProperty(this.colors[g])){var d=this.decorationsProperties[f]&&this.decorationsProperties[f].color?this.decorationsProperties[f].color:this.colors[g];var o=this.decorationsProperties[f]&&this.decorationsProperties[f].shape?this.decorationsProperties[f].shape:"square";this.decorationsColors[h]=d;b[d]=true;this.data.legend.decorations.push({shape:o,color:d,text:f,size:0.5,font:0.5});break}}}h++}}};this.recalculateLayout=function(){this.calculateLayout=true;this.initializeNetwork()};this.drawNetworkPlot=function(){this.showAnimationFont=(this.showAnimationFontSize)+"Pt "+this.fontName;this.setNodeParentHood();this.setObjectAttributes();this.setDecorationsRangeUnits();if(this.calculateLayout){this.collateNetworks();this.setNetworkPrivateParams();if(this.networkLayoutType=="radial"){this.setRadialNetwrorkLayout()}else{this.optimizeNetworkLayout()}this.calculateLayout=false}else{this.layoutDone=true;this.renderNetwork()}if(this.networkFreezeOnLoad&&this.layoutDone){this.networkFreezeOnLoad=false;this.networkFreeze=true}};this.initializeNetwork=function(){this.setNetworkDimensions();if(!this.nodes&&this.data.nodes){this.setNodes()}if(this.randomNetwork){var a=this.createRandomNetwork();this.data.nodes=a.nodes;this.data.edges=a.edges;this.setAllNodesVisible();this.setNodes();this.layoutDone=false}this.drawNetworkPlot()};this.initializeNetwork()};CanvasXpress.prototype.Genome=function(){this.setGenomeSubtracks=function(){this.subtracks=[];this.subtracksInfo=[];this.y=this.margin;var d=0;for(var k=0;k<this.data.tracks.length;k++){var b=this.data.tracks[k];var n=b.type?b.type:this.featureTypeDefault;var p=b.height?b.height:this.featureHeightDefault;if(!b.hide){var l=true;if(b.name){this.y+=this.trackNameFontSize+(this.margin*2)}b.startY=this.marginTop+this.top+this.y;this.subtracks[k]={features:[],cur:[]};this.subtracks[k].cur[0]=-3;this.subtracks[k].features[0]=[];for(var g=0;g<b.data.length;g++){var q=b.data[g];var m=this.measureText(q.id,this.featureNameFont);var h=q.data;if(!q.hide){q.index=g;if(this.featureStaggered&&l){this.y+=this.featureNameFontSize+this.margin;this.y+=p+this.margin;if(n=="sequence"){this.y+=this.getSequenceFeatureHeight(q)}l=false}var c=0;var a,f;q.counter=d++;if(this.featureStaggered){if(n=="box"){a=h[0][0]*this.xAxisUnit;f=h[h.length-1][1]*this.xAxisUnit}else{if(n=="sequence"){var e=this.setGenomeGaps(q.gaps,q.sequence.length,q.dir);if(q.offsetLeft&&!q.offset){q.offset=(q.offsetLeft-(q.sequence.length+e.total))+1}a=q.offset*this.xAxisUnit;f=a+((q.sequence.length+e.total)*this.xAxisUnit)}else{a=q.offset*this.xAxisUnit;f=b.autowidth&&this.isArray(q.data)?a+(q.data.length*this.xAxisUnit):a+b.width?b.width:this.featureWidthDefault}}var o=q.dir?Math.max(a+m+(this.margin*3),f):Math.max(a+m,f);while(a<(this.subtracks[k].cur[c]+2)){c++;if(!this.subtracks[k].cur[c]){this.y+=this.featureNameFontSize+this.margin;this.y+=p+this.margin;if(n=="sequence"){this.y+=this.getSequenceFeatureHeight(q)}this.subtracks[k].cur[c]=-3;this.subtracks[k].features[c]=[]}}this.subtracks[k].features[c].push(g);this.subtracks[k].cur[c]=o}else{this.subtracks[k].features[g]=[g];this.y+=p+this.margin;this.y+=this.getSequenceFeatureHeight(q)}}}b.endY=this.y;this.y+=(this.margin*2)}}};this.drawGenomeLabels=function(){if(!this.featureStaggered){var u=this.marginLeft;var c=this.marginTop+this.top+this.margin;var b=this.featureNameFontSize/2;var a=0;for(var t=0;t<this.data.tracks.length;t++){var n=this.data.tracks[t];var d=n.type?n.type:this.featureTypeDefault;var h=n.height?n.height:this.featureHeightDefault;if(!n.hide){if(n.name){c+=this.trackNameFontSize+(this.margin*2)}for(var r=0;r<this.subtracks[t].features.length;r++){var v=this.subtracks[t].features[r];for(var p=0;p<v.length;p++){var g=v[p];var e=n.data[g];var s=e.counter;var q=e.fill?e.fill:n.fill?n.fill:this.foreground;var f=this.measureText(e.id,this.featureNameFont)+this.margin;this.subtracksInfo[s]={track:t,subtrack:r,index:e.index,name:e.id,start:c};this.addArea(this.drawText(e.id,this.marginLeft,c+(h/2),this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+t+":"+s]);if(d=="box"||d=="sequence"){if(e.dir=="right"){this.drawShape("polygon",[u+f,u+f+(this.margin*2),u+f],[c,c+b,c+(b*2)],false,false,q,q,"closed")}else{if(e.dir=="left"){this.drawShape("polygon",[u+f,u+f+(this.margin*2),u+f+(this.margin*2)],[c+b,c,c+(b*2)],false,false,q,q,"closed")}}if(d=="sequence"){if(e.translate&&this.genomeResolution=="high"){a=-4;if(e.trace&&this.featureTracesShow){a+=this.featureTraceHeight}if(e.translate&&this.featureTranslateShow){for(var o=0;o<e.translate.length;o++){var m="+"+e.translate[o];if(m=="+1"){this.drawText(m,this.marginLeft+f,c+a+(h/2),this.featureNameFont,this.featureNameFontColor,"left","middle");a+=this.featureTranslateHeight}else{if(m=="+2"){this.drawText(m,this.marginLeft+f,c+a+(h/2),this.featureNameFont,this.featureNameFontColor,"left","middle");a+=this.featureTranslateHeight}else{if(m=="+3"){this.drawText(m,this.marginLeft+f,c+a+(h/2),this.featureNameFont,this.featureNameFontColor,"left","middle");a+=this.featureTranslateHeight}}}}a+=this.sequenceFontSize+2;for(var o=0;o<e.translate.length;o++){var m=e.translate[o];if(m=="-1"){this.drawText(m,this.marginLeft+f,c+a+(h/2),this.featureNameFont,this.featureNameFontColor,"left","middle");a+=this.featureTranslateHeight}else{if(m=="-2"){this.drawText(m,this.marginLeft+f,c+a+(h/2),this.featureNameFont,this.featureNameFontColor,"left","middle");a+=this.featureTranslateHeight}else{if(m=="-3"){this.drawText(m,this.marginLeft+f,c+a+(h/2),this.featureNameFont,this.featureNameFontColor,"left","middle");a+=this.featureTranslateHeight}}}}}}c+=this.getSequenceFeatureHeight(e)}}c+=h+this.margin;this.subtracksInfo[s].end=c}}c+=(this.margin*2)}}}};this.plotGenomeData=function(){var w,X,v,u;var I=this.marginLeft+this.left;var a=this.marginTop+this.top;for(var R=0;R<this.data.tracks.length;R++){var x=I;var A=this.data.tracks[R];var W=A.type?A.type:this.featureTypeDefault;var e=A.height?A.height:this.featureHeightDefault;var o=W.match(/bar|heatmap|line/)?this.getGenomeRange(A.data):false;var y=W.match(/bar|line|box/)&&A.fill?A.fill:false;var B=W.match(/bar|line|box/)&&A.outline?A.outline:this.foreground;var n=y?"closed":"open";if(!A.hide){if(A.name){this.addArea(this.drawText(A.name,x,a+(this.trackNameFontSize/2),this.trackNameFont,this.trackNameFontColor,"left","middle"),["track-"+R]);a+=this.trackNameFontSize+(this.margin*2)}if(A.highlight&&this.genomeResolution!="low"){var S=A.highlight;for(var Q=0;Q<S.length;Q++){if(S[Q].offset){var V=S[Q].color?S[Q].color:this.colors[R%this.colors.length];x=this.marginLeft+this.left+(((S[Q].offset-0.5)-this.xAxisMin)*this.xAxisUnit);w=S[Q].width?S[Q].width*this.xAxisUnit:this.xAxisUnit;this.rectangle(x,A.startY,w,A.endY-A.startY,V,V)}}}for(var Q=0;Q<this.subtracks[R].features.length;Q++){var q=this.subtracks[R].features[Q];for(var P=0;P<q.length;P++){var U=q[P];var K=A.data[U];var T=K.data;var r=K.id;if(W=="box"){y=K.fill?K.fill:y;B=K.outline?K.outline:B;n=y?"closed":"open";if(T.length>0){x=((T[0][0]-this.xAxisMin)*this.xAxisUnit);w=((T[T.length-1][1]-this.xAxisMin)*this.xAxisUnit);X=this.featureNameFontSize/2;if(this.featureStaggered){var C=this.measureText(r,this.featureNameFont)+this.margin;if(T[0][0]>=this.xAxisMin&&T[T.length-1][1]<=this.xAxisMax){x=I+x;this.addArea(this.drawText(r,x,a+X,this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+R+":"+K.counter])}else{if(T[0][0]<=this.xAxisMin&&T[T.length-1][1]>=this.xAxisMin){x=I;this.addArea(this.drawText(r,x,a+X,this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+R+":"+K.counter])}else{if((T[0][0]<=this.xAxisMax&&T[T.length-1][1]>=this.xAxisMax)){x=I+x;this.addArea(this.drawText(r,x,a+X,this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+R+":"+K.counter])}else{x=I+x}}}if(K.dir=="right"){this.drawShape("polygon",[x+C,x+C+(this.margin*2),x+C],[a-1,a+X-1,a+(X*2)-1],false,false,y,y,"closed")}else{if(K.dir=="left"){this.drawShape("polygon",[x+C,x+C+(this.margin*2),x+C+(this.margin*2)],[a+X-1,a-1,a+(X*2)-1],false,false,y,y,"closed")}}a+=this.featureNameFontSize+this.margin}this.addArea(["rect",x,a,I+w,a+e],[K.counter]);for(var O=0;O<T.length;O++){x=((T[O][0]-this.xAxisMin)*this.xAxisUnit);w=((T[O][1]-this.xAxisMin)*this.xAxisUnit)-x;if(A.connect){if(O<T.length-1){var N=O+1;X=a+(e/2);v=((T[N][0]-this.xAxisMin)*this.xAxisUnit);u=(x+w+v)/2;this.drawLine("line",I+x+w,X,I+u,a,y,false,"butt");this.drawLine("line",I+u,a,I+v,X,y,false,"butt")}}this.addArea(this.rectangle(I+x,a,w,e,y,B,n),[K.counter])}}}else{if(W=="sequence"){var t=this.setGenomeGaps(K.gaps,K.sequence.length,K.dir);if(K.offsetLeft&&!K.offset){K.offset=(K.offsetLeft-(K.sequence.length+t.total))+1}if(this.featureStaggered){x=((K.offset-this.xAxisMin)*this.xAxisUnit);var C=this.measureText(r,this.featureNameFont)+this.margin;var F=K.sequence.length+t.total;X=this.featureNameFontSize/2;if(K.offset>=this.xAxisMin&&(K.offset+F)<=this.xAxisMax){x=I+x;this.addArea(this.drawText(r,x,a+X,this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+R+":"+K.counter])}else{if(K.offset<=this.xAxisMin&&(K.offset+F)>=this.xAxisMin){x=I;this.addArea(this.drawText(r,x,a+X,this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+R+":"+K.counter])}else{if((K.offset<=this.xAxisMax&&(K.offset+F)>=this.xAxisMax)){x=I+x;this.addArea(this.drawText(r,x,a+X,this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+R+":"+K.counter])}else{x=I+x}}}if(K.dir=="right"){this.drawShape("polygon",[x+C,x+C+(this.margin*2),x+C],[a-1,a+X-1,a+(X*2)-1],false,false,K.fill,K.fill,"closed")}else{if(K.dir=="left"){this.drawShape("polygon",[x+C,x+C+(this.margin*2),x+C+(this.margin*2)],[a+X-1,a-1,a+(X*2)-1],false,false,K.fill,K.fill,"closed")}}a+=this.featureNameFontSize+this.margin}if(this.genomeResolution=="high"){if(K.trace&&this.featureTracesShow){this.drawGenomeTrace(a,K.counter,this.featureTraceHeight-1,K.offset,K.trace,t,K.dir);a+=this.featureTraceHeight}var J=this.browser=="Chrome"?3:4;this.drawGenomeSequence(a+J,this.featureNameFontSize,e,t,K,A);a+=e;if(K.translate&&this.featureTranslateShow){for(var O=0;O<K.translate.length;O++){a+=this.featureTranslateHeight}}if(K.quality&&this.featureQualityShow){this.drawGenomeQuality(a,this.featureNameFontSize,K.counter,this.featureQualityHeight-1,K.offset,K.quality,t,K.dir,A);a+=this.featureQualityHeight}if(K.signalToNoise&&this.featureSignalToNoiseShow){this.drawGenomeSignalToNoise(a,this.featureNameFontSize,K.counter,this.featureSignalToNoiseHeight-1,K.offset,K.signalToNoise,t,K.dir,A);a+=this.featureQualityHeight}var J=this.browser=="Chrome"?-5:-3;if(K.coordinate&&this.featureCoordinateShow){this.drawGenomeCoordinate(a+J,this.featureCoordinateHeight,K.counter,K.offset,K.coordinate,K.sequence.length,t,K.dir,A);a+=this.featureCoordinateHeight}a-=e}else{if(this.genomeResolution=="medium"){if(K.trace&&this.featureTracesShow){this.drawGenomeTrace(a,K.counter,this.featureTraceHeight-1,K.offset,K.trace,t,K.dir);a+=this.featureTraceHeight}this.drawGenomeSequence(a,this.featureNameFontSize,e,t,K,A);var J=this.browser=="Chrome"?1:0;this.drawGenomeCoordinate(a-J,this.featureNameFontSize,K.counter,K.offset,K.coordinate,K.sequence.length,t,K.dir,A)}else{this.drawGenomeSequence(a,this.featureNameFontSize,e,t,K,A);this.drawGenomeCoordinate(a,this.featureNameFontSize,K.counter,K.offset,K.coordinate,K.sequence.length,t,K.dir,A)}}}else{if(W=="bar"){var f=A.autowidth?this.xAxisUnit:K.width?K.width:A.width?A.width:this.featureWidthDefault;x=this.marginLeft+this.left+((K.offset-this.xAxisMin)*this.xAxisUnit);if(this.featureStaggered){this.addArea(this.drawText(r,x,a+(this.featureNameFontSize/2),this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+R+":"+K.counter]);a+=this.featureNameFontSize+this.margin}this.addArea(["rect",x,a,x+(T.length*f),a+e],[K.counter]);w=x;var M=o[1]-o[0];var d=o[0]-(M*0.05);if(d>0){o[0]=d;M=o[1]-o[0]}var z=e/M;var b=o[1]<0?a:o[0]>=0?a+e:(a+e)-Math.abs(o[0]*z);for(var L=0;L<T.length;L++){var H=this.isArray(y)&&y.length==T.length?y[L]:this.isArray(y)?y[0]:this.foreground;var p=this.isArray(B)&&B.length==T.length?B[L]:this.isArray(B)?B[0]:this.foreground;var S=T[L]*z;this.rectangle(w,b,f,-S,H,p);if(A.autowidth){w+=f}else{w+=f+2}}}else{if(W=="heatmap"){var f=A.autowidth?this.xAxisUnit:K.width?K.width:A.width?A.width:this.featureWidthDefault;x=this.marginLeft+this.left+((K.offset-this.xAxisMin)*this.xAxisUnit);if(this.featureStaggered){this.addArea(this.drawText(r,x,a+(this.featureNameFontSize/2),this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+R+":"+K.counter]);a+=this.featureNameFontSize+this.margin}this.addArea(["rect",x,a,x+f,a+e],[K.counter]);var S=A.autowidth?e:e/T.length;X=a;for(var L=0;L<T.length;L++){var E=T[L];var g=this.getHeatmapColor(o[0],o[1],E);if(isNaN(E)){this.rectangle(x,X,f,S,this.missingDataColor,this.missingDataColor)}else{this.rectangle(x,X,f,S,g,g)}if(A.autowidth){x+=f}else{X+=S}}}else{if(W=="line"){var f=A.autowidth?this.xAxisUnit:K.width?K.width:A.width?A.width:this.featureWidthDefault;x=this.marginLeft+this.left+((K.offset-this.xAxisMin)*this.xAxisUnit);if(this.featureStaggered){this.addArea(this.drawText(r,x,a+(this.featureNameFontSize/2),this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+R+":"+K.counter]);a+=this.featureNameFontSize+this.margin}this.addArea(["rect",x,a,x+(T.length*f),a+e],[K.counter]);X=a+e;var M=o[1]-o[0];var z=e/M;var p=this.isArray(B)?B[0]:this.foreground;for(var L=1;L<T.length;L++){var G=T[L-1]*z;var D=T[L]*z;this.drawLine("line",x,(e*2)+X-G,x+f,(e*2)+X-D,p,false,"butt");if(A.autowidth){x+=f}else{x+=f+2}}}else{if(W=="triangle"){x=this.marginLeft+this.left+((K.offset-this.xAxisMin)*this.xAxisUnit);y=K.fill?K.fill:this.foreground;B=K.outline?K.outline:this.foreground;if(this.featureStaggered){this.addArea(this.drawText(r,x,a+(this.featureNameFontSize/2),this.featureNameFont,this.featureNameFontColor,"left","middle"),["track-"+R+":"+K.counter]);a+=this.featureNameFontSize+this.margin}this.addArea(this.drawShape("triangle",x,a+(e/2),e,e,y,B,"closed"),[K.counter])}}}}}}if(this.featureStaggered){a-=(e+this.featureNameFontSize+this.margin+this.margin)}a+=e+this.margin}if(this.featureStaggered){a+=(e+this.featureNameFontSize+this.margin+this.margin)}}a+=this.margin*2}}};this.setGenomeGaps=function(e,a,b){var d=0;var f={total:d};if(e&&this.isArray(e)&&e.length>0){for(var c=0;c<e.length;c++){var h=b=="left"?a-e[c][0]:e[c][0];f[h]=e[c][1];d+=e[c][1]}f.total=d}return f};this.getSequenceFeatureHeight=function(b){var c=0;if(this.genomeResolution=="high"){if(b.trace&&this.featureTracesShow){c+=this.featureTraceHeight}if(b.translate&&this.featureTranslateShow){for(var a=0;a<b.translate.length;a++){c+=this.featureTranslateHeight}}if(b.quality&&this.featureQualityShow){c+=this.featureQualityHeight}if(b.signalToNoise&&this.featureSignalToNoiseShow){c+=this.featureSignalToNoiseHeight}if(b.coordinate&&this.featureCoordinateShow){c+=this.featureCoordinateHeight}}else{if(this.genomeResolution=="medium"){if(b.trace&&this.featureTracesShow){c+=this.featureTraceHeight}}}return c};this.getGenomeRange=function(a){var e=[];for(var c=0;c<a.length;c++){var d=a[c].data;for(var b=0;b<d.length;b++){e=e.concat(d[b])}}return this.range(e)};this.getReverseComplement=function(d){var b=d.split("");var a=[];for(var c=0;c<b.length;c++){a.unshift(this.reverseComplement[b[c]])}return a.join("")};this.translate=function(b,g){var a={top:[],bottom:[]};var m=g.split("");var e=this.getReverseComplement(g).split("").reverse();for(var h=0;h<b.length;h++){var l=b[h];var f={seq:[],off:0,rf:b[h]};if(l=="-1"){f.off=e.length%3;for(var d=e.length-1;d>=0;d-=3){var n=e[d]+e[d-1]+e[d-2];var k=this.codon[n.toUpperCase()];f.seq.unshift(k?k[0]:"")}a.bottom.push(f)}else{if(l=="-2"){f.off=(e.length-1)%3;for(var d=e.length-2;d>=0;d-=3){var n=e[d]+e[d-1]+e[d-2];var k=this.codon[n.toUpperCase()];f.seq.unshift(k?k[0]:"")}a.bottom.push(f)}else{if(l=="-3"){f.off=(e.length-2)%3;for(var d=e.length-3;d>=0;d-=3){var n=e[d]+e[d-1]+e[d-2];var k=this.codon[n.toUpperCase()];f.seq.unshift(k?k[0]:"")}a.bottom.push(f)}else{if(l=="1"){f.off=0;for(var d=0;d<m.length;d+=3){var n=m[d]+m[d+1]+m[d+2];var k=this.codon[n.toUpperCase()];f.seq.push(k?k[0]:"")}a.top.push(f)}else{if(l=="2"){f.off=1;for(var d=1;d<m.length;d+=3){var n=m[d]+m[d+1]+m[d+2];var k=this.codon[n.toUpperCase()];f.seq.push(k?k[0]:"")}a.top.push(f)}else{if(l=="3"){f.off=2;for(var d=2;d<m.length;d+=3){var n=m[d]+m[d+1]+m[d+2];var k=this.codon[n.toUpperCase()];f.seq.push(k?k[0]:"")}a.top.push(f)}}}}}}}return a};this.setReverseTrace=function(j){if(!j.reversed){var d=j.A.length;var b=j.T.reverse();var m=j.G.reverse();var h=j.C.reverse();var f=j.A.reverse();var k=[];for(var e=0;e<j.peak.length;e++){k.unshift(d-j.peak[e])}j.A=b;j.C=m;j.G=h;j.T=f;j.peak=k;j.reversed=true}};this.getCoordinateStep=function(){if(this.xAxisUnit*0.2>this.sequenceFontSize){return 1}else{if(this.xAxisUnit*0.5>this.sequenceFontSize){return 5}else{if(this.xAxisUnit*1>this.sequenceFontSize){return 10}else{if(this.xAxisUnit*200>this.sequenceFontSize){return 20}else{if(this.xAxisUnit*500>this.sequenceFontSize){return 50}else{if(this.xAxisUnit*1000>this.sequenceFontSize){return 100}else{if(this.xAxisUnit*2500>this.sequenceFontSize){return 250}else{if(this.xAxisUnit*5000>this.sequenceFontSize){return 500}else{if(this.xAxisUnit*2000>this.sequenceFontSize){return 1000}else{if(this.xAxisUnit*10000>this.sequenceFontSize){return 5000}else{if(this.xAxisUnit*20000>this.sequenceFontSize){return 10000}else{if(this.xAxisUnit*100000>this.sequenceFontSize){return 50000}else{if(this.xAxisUnit*200000>this.sequenceFontSize){return 100000}else{if(this.xAxisUnit*2000000>this.sequenceFontSize){return 1000000}else{if(this.xAxisUnit*20000000>this.sequenceFontSize){return 10000000}else{if(this.xAxisUnit*200000000>this.sequenceFontSize){return 100000000}else{if(this.xAxisUnit*2000000000>this.sequenceFontSize){return 1000000000}else{return 10000000000}}}}}}}}}}}}}}}}}};this.drawGenomeTrace=function(b,h,p,e,y,s,q){if(this.genomeResolution!="low"){if(q=="left"&&!y.reversed){this.setReverseTrace(y)}var n=[];var f=["A","C","G","T"];var C=this.marginLeft+this.left+(((e-1)-this.xAxisMin)*this.xAxisUnit);var t=this.marginLeft+this.left;var o=this.marginLeft+this.left+this.x;var a=b+p;if(y.max==null){for(var z=0;z<f.length;z++){n=n.concat(y[f[z]])}if(this.browser=="Chrome"||this.isIE){n.sort(function(j,i){return j-i})}else{n=this.radixSort(n)}var A=Math.floor(n.length*this.featureTraceTrim/100);y.max=n[n.length-(A+1)]}var u=p/y.max;for(var z=0;z<f.length;z++){var c=0;var g=[];var x=[];var B=C;var d="sequence"+f[z].toUpperCase()+"Color";for(var w=0;w<y.peak.length;w++){if(B>t-this.xAxisUnit&&B<o){var m=this.xAxisUnit/(y.peak[w]-c);if(s[w]){var D=Math.floor((y.peak[w]-c)/2);for(var v=c;v<(y.peak[w]-D);v++){g.push(B);x.push(a-(Math.min(y.max,y[f[z]][v])*u));B+=m}c+=D;if(g.length>1&&x.length>1){this.drawShape("path",g,x,false,false,this[d],this[d],"open")}g=[];x=[];for(var v=0;v<s[w];v++){B+=this.xAxisUnit}}for(var v=c;v<=y.peak[w];v++){g.push(B);x.push(a-(Math.min(y.max,y[f[z]][v])*u));B+=m}B-=m;c=y.peak[w]}else{if(s[w]){for(var v=0;v<s[w];v++){B+=this.xAxisUnit}}c=y.peak[w];B+=this.xAxisUnit}}if(B>t-this.xAxisUnit&&B<o){for(var v=c;v<y[f[z]].length;v++){g.push(B);x.push(a-(Math.min(y.max,y[f[z]][v])*u));B+=m}}if(g.length>1&&x.length>1){this.drawShape("path",g,x,false,false,this[d],this[d],"open")}}}};this.drawGenomeSequence=function(a,z,d,m,y,u){var e=y.counter;var t=y.fill?y.fill:u.fill?u.fill:false;var v=y.outline;var j=t?"closed":"open";var E=y.offset;var O=y.sequence;var R=y.sequenceRC;var D=y.translate;var N=y.translateRF;var Q=y.dir;if(Q=="left"&&!R){R=O;O=this.getReverseComplement(O)}if(D&&!N){N=D;D=this.translate(D,O)}var f=O.split("");var q=this.marginLeft+this.left+((E-this.xAxisMin)*this.xAxisUnit);var K=this.marginLeft+this.left;var I=this.marginLeft+this.left+this.x;var p=(f.length+m.total)*this.xAxisUnit;var J=0;var H=u.subtype.match(/DNA|RNA/)?1:3;var G=this.xAxisUnit*4;var M=this.xAxisUnit/2;var P=-2;var w={};var S=a;var C=0;var A=0;var B=this;var F=function(l){if(D.top&&D.top.length>0){for(var n=0;n<D.top.length;n++){S=a-(((D.top.length-n)*B.featureTranslateHeight)+3);var h=D.top[n];if(P-h.off>=0&&(P-h.off)%3==0){var r=h.seq[Math.floor((P-h.off)/3)];var c=P%2?B.oddColor:B.evenColor;if(r=="M"){c=B.sequenceStartColor}else{if(r=="*"){c=B.sequenceEndColor}}if(!w[h.rf]){w[h.rf]=o-(B.xAxisUnit*(l+2.5))}p=(o-w[h.rf])+M;B.rectangle(w[h.rf],S,p,B.featureTranslateHeight,c,v);B.drawText(r,w[h.rf]+(p/2),S+(B.featureTranslateHeight/2)+1,B.sequenceFont,B.foreground,"center","middle");w[h.rf]=o+M}}}};var k=function(l){if(D.bottom&&D.bottom.length>0){for(var n=0;n<D.bottom.length;n++){S=a+(((n+1)*B.featureTranslateHeight)-3);var h=D.bottom[n];if(P-h.off>=0&&(P-h.off)%3==0){var r=h.seq[Math.floor((P+h.off+1)/3)];var c=P%2?B.oddColor:B.evenColor;if(r=="M"){c=B.sequenceStartColor}else{if(r=="*"){c=B.sequenceEndColor}}if(!w[h.rf]){w[h.rf]=o-(B.xAxisUnit*(l+2.5))}p=(o-w[h.rf])+M;B.rectangle(w[h.rf],S,p,B.featureTranslateHeight,c,v);B.drawText(r,w[h.rf]+(p/2),S+(B.featureTranslateHeight/2)+1,B.sequenceFont,B.foreground,"center","middle");w[h.rf]=o+M}}}};if(this.genomeResolution=="high"){var o=q+(J*this.xAxisUnit);if(D){a+=D.top.length*this.featureTranslateHeight}while(f.length>0){if(o>K-G&&o<I+G){var b=f.shift();if(b=="["){b=f.shift();var x=[];while(b!="]"){x.push(b);b=f.shift()}this.drawText(x.join("/"),q+(J*this.xAxisUnit),a+(z/2),this.sequenceFont,this.sequenceMColor,"center","middle")}else{var g="sequence"+b.toUpperCase()+"Color";if(D){F(A);this.drawText(b,o,a+(z/2),this.sequenceFont,this[g],"center","middle");k(A)}else{this.drawText(b,o,a+(z/2),this.sequenceFont,this[g],"center","middle")}}J+=H;o=q+((J+C)*this.xAxisUnit);P++;A=0;if(m[parseInt(J/H)]){for(var L=0;L<m[parseInt(J/H)];L++){this.drawText("-",o,a+(z/2),this.sequenceFont,this.missingDataColor,"center","middle");C++;A++;o=q+((J+C)*this.xAxisUnit)}}}else{f.shift();J+=H;o=q+((J+C)*this.xAxisUnit);P++;A=0;if(m[parseInt(J/H)]){for(var L=0;L<m[parseInt(J/H)];L++){C++;A++;o=q+((J+C)*this.xAxisUnit)}}}}}else{q=this.marginLeft+this.left+(((E-0.5)-this.xAxisMin)*this.xAxisUnit);this.rectangle(q,a,p,d,t,v);for(var L in m){q=this.marginLeft+this.left+((((E-0.5)+parseInt(L))-this.xAxisMin)*this.xAxisUnit);p=m[L]*this.xAxisUnit;this.rectangle(q,a,p,d,this.missingDataColor,v,j)}}this.addArea(["rect",q,a,p,a+d],[e])};this.drawGenomeQuality=function(a,C,f,p,d,c,v,q,t){if(this.genomeResolution!="low"){var h=q=="left"?this.cloneObject(c).reverse():c;var m=this.range(h);var B=this.marginLeft+this.left+(((d-0.5)-this.xAxisMin)*this.xAxisUnit);var x=this.marginLeft+this.left;var o=this.marginLeft+this.left+this.x;var A=B;var u=0;var k=t.subtype.match(/DNA|RNA/)?1:3;var g=k*this.xAxisUnit;var e=(this.featureQualityHeight-2)+"Pt "+this.fontName;for(var z=0;z<h.length;z++){if(B<o){if(v[z]){for(var y=0;y<v[z];y++){A+=g}}var b=this.getHeatmapColor(m[0],m[1],h[z]);this.rectangle(A,a,g,p,b,b);if(A>x&&this.genomeResolution=="high"&&this.featureQualityValues){this.drawText(h[z],A+(g/2),a+(p/2),e,this.foreground,"center","middle")}A+=g}}this.addArea(["rect",B,a,B+A,a+p],[f])}};this.drawGenomeCoordinate=function(a,x,f,e,z,b,p,k,m){if(this.genomeResolution!="low"){var v=this.marginLeft+this.left+((e-this.xAxisMin)*this.xAxisUnit);var q=this.marginLeft+this.left;var j=this.marginLeft+this.left+this.x;var o=0;var i=m.subtype.match(/DNA|RNA/)?1:3;var g=i*this.xAxisUnit;var y=this.getCoordinateStep();var h=z+b;if(k=="left"){var u=v+(b*g);while(z<h){if(p[b-z]){u-=(g*p[b-z])}if(u>q&&u<j){if(z%y==0&&!p[b-z]){this.drawText(z,u,a+x,this.sequenceFont,this.foreground,"center","middle")}}u-=g;z++}}else{var u=v;while(z<h){if(p[z]){u+=(g*p[z])}if(u>q&&u<j){if(z%y==0&&!p[z]){this.drawText(z,u,a+x,this.sequenceFont,this.foreground,"center","middle")}}u+=g;z++}}}};this.setGenomeWireFrame=function(){var b=this.marginLeft+this.left;var a=this.marginLeft+this.left+this.x;var f=this.getCoordinateStep();var g=Math.floor(this.xAxisMin);var e=this.getFontPt(this.featureNameFont)/2;if(this.genomeResolution=="low"){f*=5}while(b<=a){b=this.marginLeft+this.left+((g-this.xAxisMin)*this.xAxisUnit);if(g%f==0){if(this.xAxisTickStyle=="dotted"){this.drawLine("dottedLine",b,this.marginTop+this.top,b,this.marginTop+this.top+this.y,this.wireColor,false,"butt")}else{this.drawLine("line",b,this.marginTop+this.top,b,this.marginTop+this.top+this.y,this.wireColor,false,"butt")}}g++}};this.setGenomeTicks=function(){var e=this.marginLeft+this.left;var b=this.marginLeft+this.left+this.x;var f=this.marginLeft+this.left;var h=this.getCoordinateStep();var i=Math.floor(this.xAxisMin);var g=this.getFontPt(this.featureNameFont)/2;if(this.genomeResolution=="low"){h*=5}while(e<=b){e=this.marginLeft+this.left+((i-this.xAxisMin)*this.xAxisUnit);if(i%h==0){var a=this.measureText(this.formatNumber(i),this.featureNameFont);if(e>=f){this.drawText(this.formatNumber(i),e,this.marginTop+this.top+this.y+this.margin+g,this.featureNameFont,this.xAxisTickColor,"center","middle");f=e+a}}i++}};this.setGenomeLeftDimentions=function(){var e=[];for(var d=0;d<this.data.tracks.length;d++){var a=this.data.tracks[d];for(var b=0;b<a.data.length;b++){var c=a.data[b];e.push(c.id)}}return this.measureText(this.shortenText(this.getMaxText(e),this.maxFeatureStringLen),this.featureNameFont)+(this.margin*4)};this.setGenomeYDimentions=function(){this.bottom+=this.margin+this.getFontPt(this.featureNameFont);if(this.autoAdjust||this.height<(this.marginTop+this.top+this.y+this.bottom+this.marginBottom)){this.height=this.marginTop+this.top+this.y+this.bottom+this.marginBottom}this.resizeCanvas()};this.setGenomeAxisUnits=function(){this.setAxisUnits("xAxis");this.genomeResolution=this.xAxisUnit>this.sequenceFontSize?"high":this.xAxisUnit*5>this.sequenceFontSize?"medium":"low"};this.setGenomeXDimentions=function(){if(this.featureStaggered){if(this.width){this.x=this.width-(this.marginLeft+this.left+this.right+this.marginRight)}else{this.width=this.marginLeft+this.left+this.x+this.right+this.marginRight}}else{this.left=this.setGenomeLeftDimentions();if(this.width){this.x=this.width-(this.marginLeft+this.left+this.right+this.marginRight)}else{this.width=this.marginLeft+this.left+this.x+this.right+this.marginRight}}};this.setGenomeFontsColors=function(){this.trackNameFont=(this.trackNameFontSize)+"Pt "+this.fontName;this.featureNameFont=(this.featureNameFontSize)+"Pt "+this.fontName;this.sequenceFont=(this.sequenceFontSize)+"Pt "+this.fontName;if(!this.wireColor.match(/,0.1\)$/)){this.wireColor=this.wireColor.replace(/\)$/,",0.1)")}};this.drawGenome=function(){this.setGenomeFontsColors();this.setGenomeXDimentions();this.setGenomeAxisUnits();this.setGenomeSubtracks();this.setGenomeYDimentions();this.setGenomeWireFrame();this.plotGenomeData();this.maskPlotArea();this.drawGenomeLabels();this.setGenomeTicks()};this.initializeGenome=function(){this.drawGenome()};this.initializeGenome()};CanvasXpress.doc={F:{fill:{M:"Genome",T:"color",C:"Color for the feature"},id:{M:"Genome",T:"string",C:"Feature id"}},M:{Overlays:{D:"Colored boxes to help in the visualization of samples and variables",P:["overlayFont","overlayFontColor","overlayFontSize","overlayScaleFontFactor","overlaysWidth","showOverlays","smpOverlays","varOverlays"],B:["showOverlays","smpOverlays","varOverlays"],U:{StackedPercent:"true",Bar:"true",Correletion:"true",Pie:"true",ScatterBubble2D:"true",Barline:"true",StackedLine:"true",Scatter2D:"true",Dotplot:"true",Boxplot:"true",StackedPercentLine:"true",Candlestick:"true",Scatter3D:"true",Area:"true",Line:"true",Stacked:"true",Heatmap:"true",AreaLine:"true"}},Axes:{D:"Axes parameters",P:["axisExact","axisExtension","setMax","setMax2","setMaxX","setMaxY","setMaxZ","setMin","setMin2","setMinX","setMinY","setMinZ","ticks","timeTicksFirst","timeValueIndices","timeValues","xAxis","xAxis2","xAxis2AbsMax","xAxis2AbsMin","xAxis2Exact","xAxis2MaxStrLength","xAxis2MinorTicks","xAxis2MinorValues","xAxis2TickFormat","xAxis2Ticks","xAxis2Values","xAxisAbsMax","xAxisAbsMin","xAxisCurrent","xAxisExact","xAxisMaxStrLength","xAxisMinorTicks","xAxisMinorValues","xAxisShow","xAxisTickColor","xAxisTickFormat","xAxisTickStyle","xAxisTicks","xAxisTitle","xAxisTransform","xAxisTransformTicks","xAxisValues","yAxis","yAxisAbsMax","yAxisAbsMin","yAxisCurrent","yAxisExact","yAxisMaxStrLength","yAxisMinorTicks","yAxisMinorValues","yAxisShow","yAxisTickColor","yAxisTickFormat","yAxisTickStyle","yAxisTicks","yAxisTitle","yAxisTransform","yAxisTransformTicks","yAxisValues","zAxis","zAxisAbsMax","zAxisAbsMin","zAxisCurrent","zAxisExact","zAxisMaxStrLength","zAxisMinorTicks","zAxisMinorValues","zAxisShow","zAxisTickColor","zAxisTickFormat","zAxisTickStyle","zAxisTicks","zAxisTitle","zAxisTransform","zAxisTransformTicks","zAxisValues"],B:["xAxisShow","xAxisTickColor","xAxisTitle","xAxisTransform","xAxisTransformTicks","yAxisShow","yAxisTickColor","yAxisTitle","yAxisTransform","yAxisTransformTicks","zAxisShow","zAxisTickColor","zAxisTitle","zAxisTransform","zAxisTransformTicks"],U:{StackedPercent:"true",Bar:"true",Correletion:"true",Pie:"true",ScatterBubble2D:"true",Barline:"true",StackedLine:"true",Scatter2D:"true",Dotplot:"true",Boxplot:"true",StackedPercentLine:"true",Candlestick:"true",Scatter3D:"true",Area:"true",Line:"true",Stacked:"true",Heatmap:"true",AreaLine:"true"}},Clustering:{D:"Paremeters used in clustering",P:["centerData","clusterAxis","distance","imputeMethod","kmeansClusters","linkage","maxIterations","useSmpVarIndexOnClustering"],B:["centerData","clusterAxis","distance","imputeMethod","kmeansClusters","linkage","maxIterations","useSmpVarIndexOnClustering"],U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Candlestick:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},Indicators:{D:"Legends for color, shape and size in visualizations",P:["indicatorsPosition","showIndicators"],B:["indicatorsPosition","showIndicators"],U:{StackedPercent:"true",Bar:"true",Correletion:"true",Pie:"true",ScatterBubble2D:"true",Barline:"true",StackedLine:"true",Scatter2D:"true",Dotplot:"true",Boxplot:"true",StackedPercentLine:"true",Candlestick:"true",Scatter3D:"true",Area:"true",Line:"true",Stacked:"true",Heatmap:"true",AreaLine:"true"}},"2D Scatter Plot":{D:"General parameters in 2d scatter plots",P:["allVsAll","allVsAllType","functionIntervals","histogramBarWidth","histogramBins","isCreateHistogram","isHistogram"],B:["allVsAll","allVsAllType"],U:{ScatterBubble2D:"true",Scatter2D:"true"}},Text:{D:"Properties associated with text attributes :",P:["align","autoScaleFont","baseline","font","fontName","fontSize","fontStyle","fonts","maxTextSize","minTextSize","scaleTextConstantAdd","scaleTextConstantMult"]},"Axis Resizer":{D:"Parameters used when resizing graphs",P:["resizerBackgroundColor","resizerBackgroundColorCurrent","resizerBackgroundColorOutlineCurrent","resizerBackgroundImage","resizerDraw","resizerPosition","resizerTransparency","resizerType","resizerWidth"],U:{StackedPercent:"true",Bar:"true",Correletion:"true",Pie:"true",ScatterBubble2D:"true",Barline:"true",StackedLine:"true",Scatter2D:"true",Dotplot:"true",Boxplot:"true",StackedPercentLine:"true",Candlestick:"true",Scatter3D:"true",Area:"true",Line:"true",Stacked:"true",Heatmap:"true",AreaLine:"true"}},Variables:{D:"Properties associated with variables",P:["highlightVar","maxVarStringLen","showVariableNames","varHighlightColor","varLabelColor","varLabelDescription","varLabelFont","varLabelFontSize","varLabelRotate","varLabelScaleFontFactor","varTitle","varTitleColor","varTitleFont","varTitleFontSize","varTitleLabelOverlayPosition","varTitleScaleFontFactor"],B:["highlightVar","maxVarStringLen","showVariableNames","varHighlightColor","varLabelColor","varLabelDescription","varLabelRotate","varLabelScaleFontFactor","varTitle","varTitleColor","varTitleLabelOverlayPosition","varTitleScaleFontFactor"],U:{StackedPercent:"true",Bar:"true",Correletion:"true",Pie:"true",ScatterBubble2D:"true",Barline:"true",StackedLine:"true",Scatter2D:"true",Dotplot:"true",Boxplot:"true",StackedPercentLine:"true",Candlestick:"true",Scatter3D:"true",Area:"true",Line:"true",Stacked:"true",Heatmap:"true",AreaLine:"true"}},"Venn Diagrams":{D:"General paremeters in Venn diagrams",P:["vennColors","vennCompartments","vennGroups"],B:["vennGroups"],U:{Venn:"true"}},"Ticks and Axis Titles":{D:"Attributes for ticks and titles in axes in one and two dimensional plots",P:["axisTickColor","axisTickFont","axisTickFontSize","axisTitleColor","axisTitleFont","axisTitleFontSize","axisTitleScaleFontFactor","tickRotate","tickScaleFontFactor"],B:["axisTickColor","axisTitleColor","axisTitleScaleFontFactor","tickRotate","tickScaleFontFactor"],U:{StackedPercent:"true",Bar:"true",Correletion:"true",Pie:"true",ScatterBubble2D:"true",Barline:"true",StackedLine:"true",Scatter2D:"true",Dotplot:"true",Boxplot:"true",StackedPercentLine:"true",Candlestick:"true",Scatter3D:"true",Area:"true",Line:"true",Stacked:"true",Heatmap:"true",AreaLine:"true"}},Dendrograms:{D:"General parameters in dendrograms",P:["dendrogramHang","dendrogramHeight","dendrogramSpace","showSmpDendrogram","showVarDendrogram","smpDendrogramPosition","varDendrogramPosition"],B:["dendrogramHang","dendrogramHeight","dendrogramSpace","showSmpDendrogram","showVarDendrogram","smpDendrogramPosition","varDendrogramPosition"],U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Candlestick:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},"Candlestick Plots":{D:"General parameters in candlestick plots",P:["showVolume","sma10Color","sma20Color","sma25Color","sma50Color","sma5Color","stockIndicators"],B:["showVolume","sma10Color","sma20Color","sma25Color","sma50Color","sma5Color","stockIndicators"],U:{Candlestick:"true"}},"Area Graphs":{D:"General parameters in area graphs",P:["areaIsCumulative"],B:["areaIsCumulative"],U:{Area:"true",AreaLine:"true"}},"Pie Charts":{D:"General parameters in pie charts",P:["maxPieSectors","pieSegmentLabels","pieSegmentPrecision","pieSegmentSeparation","pieType","showPieGrid","showPieSampleLabel","showPieValues","startPieSectors"],B:["maxPieSectors","pieSegmentLabels","pieSegmentPrecision","pieSegmentSeparation","pieType","showPieGrid","showPieSampleLabel","showPieValues","startPieSectors"],U:{Pie:"true"}},General:{D:"General properties used in most visualizations :",P:["autoAdjust","background","backgroundGradient1Color","backgroundGradient2Color","backgroundImage","backgroundType","backgroundWindow","backgroundWindowGradient1Color","backgroundWindowGradient2Color","backgroundWindowGradientOrientation","canvasBox","canvasBoxColor","foreground","foregroundWindow","functions","gradient","gradientOrientation","gradientRatio","gradientType","graphOrientation","graphType","margin","marginBottom","marginLeft","marginRight","marginTop","shadowBlur","shadowColor","shadowOffsetX","shadowOffsetY","showShadow","transparency"],B:["background","backgroundGradient1Color","backgroundGradient2Color","backgroundImage","backgroundType","canvasBox","canvasBoxColor","foreground","functions","graphOrientation","graphType","margin","marginBottom","marginLeft","marginRight","marginTop","showShadow"]},"Bar Graphs":{D:"General parameters in bar graphs",P:["showDataValues"],B:["showDataValues"],U:{Bar:"true",BarLine:"true"}},"Heatmaps and Networks":{D:"General parameters in heatmaps, correlations and networks",P:["heatmapType","indicatorCenter","indicatorHeight","indicatorWidth"],B:["heatmapType","indicatorCenter","indicatorHeight","indicatorWidth"],U:{Network:"true",Correlation:"true",Heatmap:"true"}},"Line Graphs":{D:"General parameters in line graphs",P:["coordinateLineColor","lineDecoration","lineTickness","lineType","tension"],B:["coordinateLineColor","lineDecoration","lineType"],U:{StackedLine:"true",Line:"true",StackedPercentLine:"true",BarLine:"true",AreaLine:"true"}},Attributes:{D:"Lines, Colors, Shapes, Sizes and Time :",P:["arrowPointSize","capType","colorHSV","colorRGB","colorScheme","colors","dashLength","dotLength","evenColor","images","lines","oddColor","outlineWidth","shapes","sizes","timeFormat"],B:["colorScheme","colors","evenColor","oddColor"]},"Remote Procedures":{D:"Parameters used when getting data remotely :",P:["remoteAutoPlay","remoteAutoPlayDelay","remoteDataIndex","remoteDirection","remoteParams","remoteService","remoteUpdating","remoteWindow"]},Animation:{D:"Amination parameters :",P:["animationCycles","animationTime","animationType","showAnimation","showAnimationFont","showAnimationFontColor","showAnimationFontSize","snapshotCopyChangeOnly"]},Events:{D:"Event parameters :",P:["broadcast","broadcastType","configuratorWidth","dataEvent","destroyAllOnClose","disableConfigurator","disableEvents","eventArrowKeys","eventKeys","eventPlusMinusKeys","helpKeyEvents","infoTimeIn","infoTimeOut","modelEvent","resizable","showAdvancedConfiguration","this"],B:["showAdvancedConfiguration"]},Images:{D:"General parameters with images :",P:["imageDir","nextButton","playButton","previousButton","stopButton"]},"Combination Plots":{D:"Parameters used in complex plots :",P:["layout","layoutAdjust","layoutAxis","layoutComb","layoutCurrent","layoutHeight","layoutMaxVarLegend","layoutMulticolor","layoutWidth","offsetX","offsetY","scaleX","scaleY","translateX","translateY","weight"]},"Network Graphs":{D:"General parameters used in networks",P:["approximateNodePositions","attractiveForceFunction","autoHideOnDecorationsCenter","calculateLayout","colorEdgeBy","colorNodeBy","edgeConfigurableProperties","edgeWidth","highlightNode","initialTemperature","is3DNetwork","isSelectNodes","layoutTime","network2DRotate","networkDepth","networkDivisions","networkForceConstant","networkFreeze","networkFreezeOnLoad","networkLayoutType","networkNodeMinDistance","networkNodesOnTop","networkRoot","networkStack","networkStackStates","nodeConfigurableProperties","nodeFont","nodeFontColor","nodeFontSize","nodeHighlightColor","nodeScaleFontFactor","nodeSize","overrideEventlessNodes","preScaleNetwork","randomNetwork","randomNetworkNodeEdgesMax","randomNetworkNodes","reduceRandomNetwork","repulsiveForceFunction","selectNode","shapeEdgeBy","shapeNodeBy","showHiddenChildEdges","showNetworkDecorationsLegend","showNetworkEdgesLegend","showNetworkNodesLegend","showNetworkRadialLayout","showNetworkTextLegend","showNodeNameThreshold","sizeDecorationBy","sizeEdgeBy","sizeNodeBy","skipClick","subNetworks","temperature"],B:["autoHideOnDecorationsCenter","calculateLayout","colorEdgeBy","colorNodeBy","edgeWidth","highlightNode","is3DNetwork","networkLayoutType","networkNodesOnTop","networkRoot","nodeFontColor","nodeHighlightColor","nodeScaleFontFactor","nodeSize","shapeEdgeBy","shapeNodeBy","showHiddenChildEdges","showNetworkRadialLayout","showNodeNameThreshold","sizeDecorationBy","sizeEdgeBy","sizeNodeBy"],U:{Network:"true"}},"Data table":{D:"Paremters associated with the data table :",P:["colWidth","dataTableColumnWidth","dataTableTransposed","freezeColLeft","freezeColRight","freezeRowBottom","freezeRowTop","maxCols","maxRows","networkShowDataTable","refresehDataTableOnDraw","rowHeight","showDataTable","showDataTableOnSelect","startCol","startRow"],B:["dataTableColumnWidth"]},"Genome Browser":{D:"General paremeters used in genome browser",P:["featrureCoordinateHeight","featrureQualityHeight","featrureSignalToNoiseHeight","featrureTranslateHeight","featureConfigurableProperties","featureCoodinateShow","featureHeightDefault","featureNameFont","featureNameFontColor","featureNameFontSize","featureQualityShow","featureQualityValues","featureSignalToNoiseShow","featureSignalToNoiseValues","featureStaggered","featureTraceHeight","featureTraceTrim","featureTracesShow","featureTranslateShow","featureTypeDefault","featureWidthDefault","genomeResolution","maxFeatureStringLen","periodTicksLabels","sequenceAColor","sequenceCColor","sequenceEndColor","sequenceFont","sequenceFontSize","sequenceGColor","sequenceMColor","sequenceStartColor","sequenceTColor","showFeatureNameThereshold","trackConfigurableProperties","trackNameFont","trackNameFontColor","trackNameFontSize","wireColor"],B:["featureCoodinateShow","featureNameFontColor","featureQualityShow","featureQualityValues","featureSignalToNoiseShow","featureSignalToNoiseValues","featureStaggered","featureTracesShow","featureTranslateShow","featureTypeDefault","maxFeatureStringLen","sequenceAColor","sequenceCColor","sequenceEndColor","sequenceGColor","sequenceMColor","sequenceStartColor","sequenceTColor","showFeatureNameThereshold","trackNameFontColor"],U:{Genome:"true"}},Skins:{D:"Parameters to change the skin of the application widgets :",P:["selectedBackgroundColor","skin","skinProperties","skinPropertiesBlue","skinPropertiesGrey"]},Samples:{D:"Properties associated with samples",P:["highlightSmp","maxSmpStringLen","showSampleNames","smpHighlightColor","smpLabelColor","smpLabelDescription","smpLabelFont","smpLabelFontSize","smpLabelRotate","smpLabelScaleFontFactor","smpTitle","smpTitleColor","smpTitleFont","smpTitleFontSize","smpTitleScaleFontFactor"],B:["highlightSmp","maxSmpStringLen","showSampleNames","smpHighlightColor","smpLabelColor","smpLabelDescription","smpLabelRotate","smpLabelScaleFontFactor","smpTitle","smpTitleColor","smpTitleScaleFontFactor"],U:{StackedPercent:"true",Bar:"true",Correletion:"true",Pie:"true",ScatterBubble2D:"true",Barline:"true",StackedLine:"true",Scatter2D:"true",Dotplot:"true",Boxplot:"true",StackedPercentLine:"true",Candlestick:"true",Scatter3D:"true",Area:"true",Line:"true",Stacked:"true",Heatmap:"true",AreaLine:"true"}},"Zooming and Panning":{D:"Parameters associated with zooming and panning :",P:["panningGlobalX","panningGlobalY","panningStep","panningX","panningY","zoom","zoomGlobal","zoomStep"]},Snapshots:{D:"Paremeters used in snapshots",P:["isAnimation","snapshots"],U:{Network:"true"}},Titles:{D:"Properties used to manipulate general title, subtitle and citation :",P:["citation","citationColor","citationFont","smpTitleFontSize","subtitle","subtitleHeight","title","titleColor","titleHeight"],B:["citation","citationColor","smpTitleFontSize","subtitle","subtitleHeight","title","titleColor","titleHeight"]},Debug:{D:"Debugging parameters :",P:["checkGoogleChromeFrame","codeType","debug","showCode","showVersion"]},Legends:{D:"Legends for variables and samples",P:["legendBackgroundColor","legendBox","legendBoxColor","legendColor","legendFont","legendFontSize","legendPosition","legendScaleFontFactor","showLegend"],B:["legendBackgroundColor","legendBox","legendBoxColor","legendColor","legendPosition","legendScaleFontFactor","showLegend"],U:{StackedPercent:"true",Bar:"true",Correletion:"true",Pie:"true",ScatterBubble2D:"true",Barline:"true",StackedLine:"true",Scatter2D:"true",Dotplot:"true",Boxplot:"true",StackedPercentLine:"true",Candlestick:"true",Scatter3D:"true",Area:"true",Line:"true",Stacked:"true",Heatmap:"true",AreaLine:"true"}},Decorations:{D:"Additional elements added to graphs to increase data understanding",P:["decorationFont","decorationFontSize","decorationScaleFontFactor","decorations","decorationsColor","decorationsColors","decorationsHeight","decorationsPosition","decorationsProperties","decorationsType","decorationsWidth","showDecorations"],U:{Scatter3D:"true",ScatterBubble2D:"true",Scatter2D:"true"}},"Scatter Plots":{D:"General parameters in scatter plots",P:["colorBy","isSelectDataPoints","scatterSeries","scatterType","selectDataPoint","shapeBy","sizeBy"],B:["colorBy","scatterSeries","scatterType","shapeBy","sizeBy"],U:{Scatter3D:"true",ScatterBubble2D:"true",Scatter2D:"true"}},"3D Scatter Plot and Networks":{D:"General parameters in 3d scatter plots and neworks",P:["maxRotate","minRotate","rotationDelay","rotationSensitivity","rotationStep","show3DGrid","xRotate","yRotate","zRotate"],U:{Network:"true",Scatter3D:"true"}},"Correlation Graphs":{D:"General parameters for correlation",P:["correlationAnchorLegend","correlationAnchorLegendAlignWidth","correlationAxis"],B:["correlationAxis"],U:{Correlation:"true"}},Functions:{D:"Functions exposed in the configurator :",P:["addNormalDistributionLine","addRegressionLine","clusterSamples","clusterVariables","createHistogram","createRandomData","desegregateSamples","desegregateVariables","draw","hideCodeDiv","hideInfoDiv","hideUnhideSmps","hideUnhideVars","kmeansSamples","kmeansVariables","recalculateLayout","removeHistogram","reset","segregateSamples","segregateVariables","setSkin","showCodeDiv","showInfoDiv","sortSamplesByCategory","sortSamplesByVariable","sortVariablesByCategory","transform","transpose","ungroupSamples","updateCodeDiv"],B:["addNormalDistributionLine","addRegressionLine","clusterSamples","clusterVariables","createRandomData","desegregateSamples","desegregateVariables","draw","hideUnhideSmps","hideUnhideVars","kmeansSamples","kmeansVariables","recalculateLayout","removeHistogram","reset","segregateSamples","segregateVariables","setSkin","sortSamplesByCategory","sortSamplesByVariable","sortVariablesByCategory","transform","transpose","ungroupSamples"]},Heatmaps:{D:"General paremters for heatmaps",P:["smpIndicesStart","varIndicesStart"],U:{Heatmap:"true"}},"One dimentional plots":{D:"General parameters for one dimensional plots",P:["blockContrast","blockFactor","blockSeparationFactor","seriesSeparationFactor","smpHairline","smpHairlineColor"],B:["blockContrast","seriesSeparationFactor","smpHairline","smpHairlineColor"],U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Candlestick:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},Data:{D:"Data related parameters",P:["groupingFactors","isBoxPlotCalc","isGraphTime","isGroupedData","isLogData","isMarketDataFormated","isMarketSwitched","isTransformedData","missingDataColor","randomData","randomDataMean","randomDataSampleAnnotationRatio","randomDataSampleAnnotations","randomDataSamples","randomDataSigma","randomDataVariableAnnotationRatio","randomDataVariableAnnotations","randomDataVariables","randomMissingDataPercentage","ratioReference","segregateSamplesBy","segregateVariablesBy","showErrorBars","smpSort","sortDir","tmpAsciiArray","transformBase","transformType","varSort","zscoreAxis"],B:["groupingFactors","isLogData","missingDataColor","ratioReference","segregateSamplesBy","segregateVariablesBy","showErrorBars","sortDir","transformBase","transformType","zscoreAxis"],U:{StackedPercent:"true",Bar:"true",Correletion:"true",Pie:"true",ScatterBubble2D:"true",Barline:"true",StackedLine:"true",Scatter2D:"true",Dotplot:"true",Boxplot:"true",StackedPercentLine:"true",Candlestick:"true",Scatter3D:"true",Area:"true",Line:"true",Stacked:"true",Heatmap:"true",AreaLine:"true"}}},N:{zIndex:{M:"Network",T:"integer",C:"Css property for the imagePath"},x:{M:"Network",T:"float",C:"X coordinate"},outline:{M:"Network",T:"color",C:"Color for the outline of the node"},imagePath:{M:"Network",T:"url",C:"Url for the node image"},eventless:{M:"Network",T:"boolean",C:"Flag to disable all events in the node"},y:{M:"Network",T:"float",C:"Y coordinate"},color:{M:"Network",T:"color",C:"Color for the node"},pattern:{O:"open, closed",M:"Network",T:"option",C:"Whether to draw a solid shape or just an outline"},rotate:{M:"Network",T:"integer",C:"Number of degrees to rotate the shape"},shape:{M:"Network",T:"string",C:"Shape for the node. One of the ones defined in shapes"},z:{M:"Network",T:"float",C:"Z coordinate"},outlineWidth:{M:"Network",T:"integer",C:"Pixels used to raw the outline of the node"}},P:{yAxisTransform:{O:["false","log2","log10","exp2","exp10","percentile"],M:"Axes",T:"option",C:"Tranformation for the values in the Y axis.",D:"false"},vennCompartments:{A:"true",Z:"true",M:"Venn Diagrams",T:"array",C:"Name for the compartments in the the Venn diagrams"},setMaxX:{A:"true",M:"Axes",T:"float",C:"Maximum value to set the data in the X axis",D:"null"},pieSegmentLabels:{O:["inside","outside"],M:"Pie Charts",T:"option",C:"Location for the values in the pie charts",D:"inside"},shapeBy:{O:["false","variable"],M:"Scatter Plots",T:"option",C:"Name of a variable annotation or a sample name or the string 'variable' to shape the variables.",D:"false",X:"getZData"},featrureQualityHeight:{A:"true",M:"Genome Browser",T:"integer",C:"Default size in pixels of the quality height",D:"12"},xAxis2Exact:{A:"true",M:"Axes",T:"boolean",C:"Flag to force exact values for the data in the 2nd X axis",D:"false"},sequenceFont:{A:"true",Z:"true",M:"Genome Browser",T:"font",C:"Font for the text of the sequence in the genome browser"},networkStack:{A:"true",Z:"true",M:"Network Graphs",T:"array",C:"Array to keep state of the network after a drag or move"},desegregateSamples:{S:["segregateSamples"],M:"Functions",T:"void",C:"Desegreagate samples previously segregated based on a sample category (data.x  object)",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},is3DNetwork:{M:"Network Graphs",T:"boolean",C:"Flag to create or not a 3D network",D:"false"},backgroundWindow:{A:"true",S:["backgroundType"],M:"General",T:"color",C:"Background color of the canvas window when the background type is a type of window.",D:"rgb(220,220,220)"},varDendrogramPosition:{M:"Dendrograms",T:"option",C:"Position for the variable dendrogram in the plot. It could be top, bottom, right or left depending on the orientation of the graph.",D:"top"},calculateLayout:{M:"Network Graphs",T:"boolean",C:"Flag to force or not to calculate the network layout.",D:"true"},shapes:{A:"true",O:["sphere","square","triangle","star","rhombus","octagon","oval","plus","minus","pacman","mdavid","rect2","rect3","arc","rectangle","image"],M:"Attributes",T:"array",C:"Shapes used in network graphs"},yAxisMinorValues:{A:"true",M:"Axes",T:"array",C:"Values for the minor ticks in the Y axis",D:"[]"},sequenceTColor:{M:"Genome Browser",T:"color",C:"Color for the thymidines in the genome browser",D:"rgb(255,0,0)"},nodeFontColor:{M:"Network Graphs",T:"color",C:"Color for the network text",D:"background color"},networkNodeMinDistance:{A:"true",M:"Network Graphs",T:"integer",C:"Minimum distance between nodes in forceDirected and organic layouts",D:"2"},title:{S:["titleHeight","titleColor"],M:"Titles",T:"string",C:"Title of the graph.",D:"false"},featrureTranslateHeight:{A:"true",M:"Genome Browser",T:"integer",C:"Default size in pixels of the translation height",D:"12"},featureCoodinateShow:{M:"Genome Browser",T:"boolean",C:"Flag use to show coordinates",D:"true"},zAxisMaxStrLength:{A:"true",Z:"true",M:"Axes",T:"string",C:"Longest string for ticks in the Z axis"},yAxisExact:{A:"true",M:"Axes",T:"boolean",C:"Flag to force exact values for the data in the Y axis",D:"false"},showShadow:{S:["shadowOffsetX","shadowOffsetY","this.shadowBlur","shadowColor"],M:"General",T:"boolean",C:"Flag used to add  shadows to all element in the canvas. It will be forced to false if the browser is IE.",D:"false"},colorScheme:{S:["colors"],O:["user","basic","dark","strong","light","pastel"],M:"Attributes",T:"option",C:"Color schemes can be user defined which will take the colors in the color property or one provided in canvasXpress. The order of the colors will be used to sequentially select when a different color is needed in a particular visualization.",D:"basic"},remoteWindow:{A:"true",M:"Remote Procedures",T:"integer",C:"Number of plots to show  when requesting remote data",D:"1"},showNetworkDecorationsLegend:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to show node legends in the networks",D:"true"},zAxisTickFormat:{A:"true",M:"Axes",T:"string",C:"Format for the tick values in the Z axis",D:"false"},xAxisMinorValues:{A:"true",M:"Axes",T:"array",C:"Values for the minor ticks in the X axis",D:"[]"},isMarketDataFormated:{A:"true",Z:"true",M:"Data",T:"boolean",C:"Flag to indicate if the data has been formated to display Candlestick."},segregateSamples:{S:["ungroupSamples"],M:"Functions",T:"option",C:"Group samples based on a sample category (data.x object) @param (array} groupSamples",X:"getXData",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},skin:{A:"true",O:["blue","grey"],M:"Skins",T:"option",C:"Skin for the application",D:"blue"},isTransformedData:{A:"true",Z:"true",M:"Data",T:"boolean",C:"Flag to indicate if the data is transformed."},background:{S:["backgroundType"],M:"General",T:"color",C:"Background color for the canvas.",D:"rgb(255,255,255)"},resizerTransparency:{A:"true",M:"Axis Resizer",T:"boolean",C:"Flag to make the axis resizers transparent",D:"true"},hideUnhideVars:{M:"Functions",T:"array",C:"Hide or unhide variables. It works like a switch",X:"getVariablesAsArray",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},periodTicksLabels:{A:"true",M:"Genome Browser",T:"integer",C:"Number of ticks to skip between values in the genome browser",D:"5"},colWidth:{A:"true",M:"Data table",T:"integer",C:"Mumber of pixels for the width of cells in the data table",D:"100"},scaleY:{A:"true",Z:"true",M:"Combination Plots",T:"float",C:"Scale factor for the Y axis"},seriesSeparationFactor:{M:"One dimentional plots",T:"float",C:"Factor to adjust the spacing between the series in the bar graphs",D:"2"},varLabelFont:{A:"true",Z:"true",M:"Variables",T:"font",C:"Font for the variable labels in one dimensional plots"},startCol:{A:"true",Z:"true",M:"Data table",T:"boolean",C:"Starting column in the data table"},xAxisTransform:{O:["false","log2","log10","exp2","exp10","percentile"],M:"Axes",T:"option",C:"Tranformation for the values in the X axis.",D:"false"},ratioReference:{M:"Data",T:"integer",C:"Default index of sample used in ratio transformation.",D:"0"},citationColor:{S:["citation"],M:"Titles",T:"color",C:"Color for a reference citation of the graph",D:"rgb(0,0,0)"},decorationsPosition:{A:"true",O:["bottom","right"],M:"Decorations",T:"option",C:"Position for the decorations in scatter plots and network graphs",D:"bottom"},eventPlusMinusKeys:{A:"true",M:"Events",T:"boolean",C:"Flag to enable plus / minus key binding events.",D:"true"},resizerBackgroundColorCurrent:{A:"true",M:"Axis Resizer",T:"color",C:"Color for the div that shows up the current area selected in the axes in the canvas",D:"rgb(153,187,232)"},correlationAnchorLegend:{A:"true",M:"Correlation Graphs",T:"boolean",C:"Flag to show a region above the correlation plot that anchror a sample/variable to a position",D:"false"},minRotate:{A:"true",M:"3D Scatter Plot and Networks",T:"float",C:"Minimum number of degrees to rotate graph arround axes",D:"false"},axisTitleColor:{M:"Ticks and Axis Titles",T:"color",C:"Color for the axis title in one and two dimensional plots",D:"foregroung color"},xAxis2AbsMax:{A:"true",Z:"true",M:"Axes",T:"float",C:"Maximum unfiltered value for the 2nd X axis"},panningGlobalX:{A:"true",Z:"true",M:"Zooming and Panning",T:"float",C:"Cumulative number of unit to pan the network in the X dimension"},xAxis:{A:"true",M:"Axes",T:"array",C:"Name of the samples groups or variables to be displayed in the X axis",D:"[]",X:"getSamplesAsArray"},featureNameFont:{A:"true",Z:"true",M:"Genome Browser",T:"font",C:"Font for the text of the features in the genome browser"},scatterSeries:{O:["x","y"],M:"Scatter Plots",T:"option",C:"Axis that contain the series in the scatter plots",D:"y"},offsetY:{A:"true",Z:"true",M:"Combination Plots",T:"float",C:"Additional amount to move for the Y axis."},selectNode:{A:"true",Z:"true",M:"Network Graphs",T:"object",C:"Name of nodes (in the data object) to select.",D:"{}"},isGraphTime:{A:"true",M:"Data",T:"boolean",C:"Flag to indicate if the data is a time series so ther is no need to plot every time interval",D:"false"},featureTraceHeight:{A:"true",M:"Genome Browser",T:"integer",C:"Default size in pixels of the trace height",D:"40"},featureQualityShow:{M:"Genome Browser",T:"boolean",C:"Flag use to show quality",D:"true"},lineDecoration:{O:["false","dot","symbol"],M:"Line Graphs",T:"option",C:"Lines decorations in the line graphs",D:"sybol"},kmeansVariables:{S:["kmeansClusters","maxIterations"],M:"Functions",T:"void",C:"Cluster variables using kmeans",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",StackedPercentLine:"true",Area:"true",Line:"true",StackedLine:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},xAxisValues:{A:"true",M:"Axes",T:"array",C:"Values for the ticks in the X axis",D:"[]"},clusterAxis:{S:["distance","linkage","imputeMethod","centerData","clusterSamples","clusterVariables"],O:["samples","variables"],M:"Clustering",T:"option",C:"Default axis to use when clustering data.",D:"samples"},rotationDelay:{A:"true",M:"3D Scatter Plot and Networks",T:"integer",C:"Time in milliseconds to wait between rendering the plot when dragging the mouse.",D:"100"},varLabelScaleFontFactor:{M:"Variables",T:"float",C:"Scaling factor used to increse or decrease variable font size in the canvas.",D:"1"},maxVarStringLen:{M:"Variables",T:"integer",C:"Maximum length in characters a variable label or description can have so anything above is truncated.",D:"30"},varLabelRotate:{M:"Variables",T:"integer",C:"Rotation for variable labels in degrees It could be positive or negative.",D:"0"},networkNodesOnTop:{M:"Network Graphs",T:"boolean",C:"Order to use when drawing nodes and edges in the networks",D:"true"},colorRGB:{A:"true",Z:"true",M:"Attributes",T:"array",C:"Color RGB. Red, Green, Blue used in the configurator"},setMaxZ:{A:"true",M:"Axes",T:"float",C:"Maximum value to set the data in the Z axis",D:"null"},dendrogramHeight:{M:"Dendrograms",T:"boolean",C:"Flag to size the branches of the dendrogram.",D:"false"},showFeatureNameThereshold:{M:"Genome Browser",T:"integer",C:"Threshehold used to set te limit when there are too many features in the genome browser",D:"20"},zAxisAbsMin:{A:"true",Z:"true",M:"Axes",T:"float",C:"Minimum unfiltered value for the Z axis"},setMinZ:{A:"true",M:"Axes",T:"float",C:"Minimum value to set the data in the Z axis",D:"null"},varTitleFontSize:{A:"true",M:"Variables",T:"integer",C:"Size for the variable title in one dimensional plots",D:"10"},reduceRandomNetwork:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to create or not a single random network for debug and demonstraion purposes",D:"false"},edgeWidth:{M:"Network Graphs",T:"integer",C:"Default width for the edges in the networks",D:"1"},maxIterations:{S:["kmeansClusters","kmeansSamples","kmeansVariables"],M:"Clustering",T:"integer",C:"Number of maximum iterations when clustering data with kmeans for one dimensional graphs or maximum number of iterations when calculating force direct layout networks.",D:"10"},sortDir:{O:["ascending","descending"],M:"Data",T:"option",C:"Default direction for data sorting.",D:"ascending"},featrureSignalToNoiseHeight:{A:"true",M:"Genome Browser",T:"integer",C:"Default size in pixels of the quality height",D:"12"},smpTitleColor:{M:"Samples",T:"color",C:"Font color for the sample title in one dimensional plots",D:"foreground color"},showOverlays:{M:"Overlays",T:"boolean",C:"Flag to indicate to show or not the overlays in one dimensional plots",D:"true"},graphOrientation:{O:["horizontal","vertical"],M:"General",T:"option",C:"Orientation of the graph when plotting one dimensional graphs",D:"horizontal"},outlineWidth:{A:"true",M:"Attributes",T:"integer",C:"Default width in pixels for the lines",D:"1"},randomDataVariableAnnotationRatio:{A:"true",M:"Data",T:"integer",C:"Approximate number of classes in each variable annotation when creating random data",D:"2"},marginRight:{M:"General",T:"integer",C:"Length in pixels for the right margin in the canvas",D:"0"},align:{A:"true",O:["right","center","left"],M:"Text",T:"option",C:"Default horizontal alignment for drawing text.",D:"center"},dataTableTransposed:{A:"true",M:"Data table",T:"boolean",C:"Flag to transpose the data in the data table",D:"true"},showDataTableOnSelect:{A:"true",M:"Data table",T:"boolean",C:"Flag to indicate to show data after selecting data in the plot",D:"true"},wireColor:{A:"true",M:"Genome Browser",T:"color",C:"Color for the ticks in the genome browser",D:"rgba(220,220,220,0.1)"},marginTop:{M:"General",T:"integer",C:"Length in pixels for the top margin in the canvas",D:"0"},setMin:{A:"true",M:"Axes",T:"float",C:"Minimum value to set the data",D:"null"},animationCycles:{A:"true",M:"Animation",T:"integer",C:"Number of cycles to plot the graph for the animations.",D:"20"},shapeNodeBy:{M:"Network Graphs",T:"string",C:"Name of the attribute to shape the nods.",D:"false"},xAxisShow:{M:"Axes",T:"boolean",C:"Flag to show on not the values of the ticks in the X axis",D:"true"},skinPropertiesGrey:{A:"true",Z:"true",M:"Skins",T:"array",C:"Values for the grey skin",D:"[]"},canvasBoxColor:{S:["canvasBox"],M:"General",T:"color",C:"Color for the box around the canvas",D:"rgb(0,0,0)"},subtitleHeight:{S:["subtitle","subtitleColor"],M:"Titles",T:"integer",C:"Height for the subtitle of the graph. The font height will be adjusted automatically to fit in the canvas.",D:"16"},indicatorsPosition:{O:["bottom","right"],M:"Indicators",T:"option",C:"Position for the color, shape and size indicators in several visualizations",D:"bottom"},featureConfigurableProperties:{A:"true",F:"id:[string];Feature id;[],fill:[color];Color for the feature;[]",M:"Genome Browser",T:"array",C:"Feature configurable properties",D:["'id'","'fill'","'outline'","'dir'","'offset'","'data'","'subtype'","'quality'","'signalToNoise'","'coordinate'","'sequence'","'trace'","'gaps'","'translate'","'hide'","'counter'"]},titleHeight:{S:["title","titleColor"],M:"Titles",T:"integer",C:"Height for the title of the graph. The font height will be adjusted automatically to fit in the canvas.",D:"30"},sizes:{A:"true",O:["4","6","8","10","12","14","16","18","20","22","24","26","28","30","32","34"],M:"Attributes",T:"array",C:"Sizes used invisualizations"},infoTimeIn:{A:"true",M:"Events",T:"integer",C:"Time in milliseconds to start showing info after a mouse over",D:"3000"},layoutHeight:{A:"true",Z:"true",M:"Combination Plots",T:"float",C:"Height of the current segment of the canvas when there are multiple graphs."},sizeEdgeBy:{M:"Network Graphs",T:"string",C:"Name of the attribute to size the edges.",D:"false"},foregroundWindow:{A:"true",S:["backgroundType"],M:"General",T:"color",C:"Foreground color of the canvas window when the background type is a type of window.",D:"rgb(0,0,0)"},colorBy:{O:["false","variable"],M:"Scatter Plots",T:"option",C:"Name of a variable annotation or a sample name or the string 'variable' to color the variables.",D:"false",X:"getZData"},randomNetworkNodeEdgesMax:{A:"true",M:"Network Graphs",T:"integer",C:"Default number of maximum edges when creating random networks",D:"5"},scaleTextConstantAdd:{A:"true",Z:"true",M:"Text",T:"float",C:"Constants to autoscale text (extra)",D:"2.5"},transformBase:{O:["2","10"],M:"Data",T:"integer",C:"Default log or exponential transformation.",D:"2"},centerData:{S:["distance","linkage","clusterAxis","imputeMethod","clusterSamples","clusterVariables"],M:"Clustering",T:"boolean",C:"Flag to indicate whether to center data when clustering",D:"false"},missingDataColor:{M:"Data",T:"color",C:"Color for the missing data",D:"rgb(255,255,0)"},offsetX:{A:"true",Z:"true",M:"Combination Plots",T:"float",C:"Additional amount to move for the X axis"},zAxisTickStyle:{A:"true",O:["solid","dotted"],M:"Axes",T:"option",C:"Style for the tick lines in the Z axis",D:"solid"},showNodeNameThreshold:{M:"Network Graphs",T:"integer",C:"Thereshold used to set the limit to hide or display the name of nodes in a network. If the number of nodes exceed this thereshold then the name will not be shown.",D:"50"},isSelectDataPoints:{A:"true",Z:"true",M:"Scatter Plots",T:"integer",C:"Number of selected data points (in the data object).",D:"0"},randomDataSampleAnnotations:{A:"true",M:"Data",T:"integer",C:"Default number of sample annotations when creating random data",D:"3"},smpLabelRotate:{M:"Samples",T:"integer",C:"Rotation for sample labels in degrees. It could be positive or negative.",D:"0"},resizerWidth:{A:"true",M:"Axis Resizer",T:"integer",C:"Length in pixels for the width of the visible axis resizer",D:"18"},showNetworkRadialLayout:{M:"Network Graphs",T:"boolean",C:"Flag to show or not a radial layout wire.",D:"false"},infoTimeOut:{A:"true",M:"Events",T:"integer",C:"Time in milliseconds to wait between updates for the mouse over info to show up",D:"3000"},overlayFont:{A:"true",Z:"true",M:"Overlays",T:"font",C:"Font for the overlays in one dimensional plots"},setMinY:{A:"true",M:"Axes",T:"float",C:"Minimum value to set the data in the Y axis",D:"null"},showNetworkEdgesLegend:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to show edge legends in the networks",D:"true"},panningGlobalY:{A:"true",Z:"true",M:"Zooming and Panning",T:"float",C:"Cumulative umber of unit to pan the network in the Y dimension"},featureHeightDefault:{A:"true",M:"Genome Browser",T:"integer",C:"Default size in pixels of the feature height",D:"14"},zAxisTicks:{A:"true",M:"Axes",T:"integer",C:"Number of ticks in the Z axis",D:"5"},freezeColLeft:{A:"true",M:"Data table",T:"integer",C:"Number of columns to freeze in the left side of the data table",D:"0"},yAxisTickFormat:{A:"true",M:"Axes",T:"string",C:"Format for the tick values in the Y axis",D:"false"},setMin2:{A:"true",M:"Axes",T:"float",C:"Minimum value to set the data in the 2nd axis",D:"null"},isGroupedData:{A:"true",Z:"true",M:"Data",T:"boolean",C:"Flag to indicate if the data is grouped."},zoomGlobal:{A:"true",Z:"true",M:"Zooming and Panning",T:"float",C:"Cumulative zoom factor for the networks."},decorationsType:{A:"true",O:["pie","bar","heatmap","stacked","stackedpercent"],M:"Decorations",T:"option",C:"Type for the decorations in the networks. The types stacked and stackedpercent must be two dimensional. Heatmap could be one or two dimensional",D:"bar"},showVersion:{A:"true",M:"Debug",T:"boolean",C:"Flag to show version when mouse over top-left corner of the canvas.",D:"true"},networkDepth:{A:"true",Z:"true",M:"Network Graphs",T:"integer",C:"Depth of the radial network."},showHiddenChildEdges:{M:"Network Graphs",T:"boolean",C:"Flag to show or not children nodes when the parent node is hidden.",D:"true"},randomDataSigma:{A:"true",M:"Data",T:"integer",C:"Sigma value when creating random data",D:"100"},nodeConfigurableProperties:{A:"true",M:"Network Graphs",T:"array",C:"Node configurable properties",N:"x:[float];X coordinate;[],y:[float];Y coordinate;[],z:[float];Z coordinate;[],shape:[string];Shape for the node. One of the ones defined in shapes;[shapes],color:[color];Color for the node;[],outline:[color];Color for the outline of the node;[],pattern:[open|closed];Whether to draw a solid shape or just an outline;[],rotate:[integer];Number of degrees to rotate the shape;[],outlineWidth:[integer];Pixels used to raw the outline of the node;[],imagePath:[url];Url for the node image;[],zIndex:[integer];Css property for the imagePath;[],eventless:[boolean];Flag to disable all events in the node;[overrideEventlessNodes]",D:["'x'","'y'","'z'","'shape'","'color'","'outline'","'size'","'width'","'height'","'pattern'","'rotate'","'outlineWidth'","'imagePath'","'zIndex'","'eventless'"]},zoomStep:{A:"true",M:"Zooming and Panning",T:"float",C:"Percentage step for zooming networks and genome panel.",D:"0.2"},axisTitleScaleFontFactor:{M:"Ticks and Axis Titles",T:"float",C:"Scaling factor used to increse or decrease title font size in the canvas in one and two dimensional plots",D:"1"},zAxisExact:{A:"true",M:"Axes",T:"boolean",C:"Flag to force exact values for the data in the Z axis",D:"false"},featureSignalToNoiseValues:{M:"Genome Browser",T:"boolean",C:"Flag use to show values for the quality",D:"false"},tickScaleFontFactor:{M:"Ticks and Axis Titles",T:"float",C:"Scaling factor used to increse or decrease tick font size in the canvas in one and two dimensional plots",D:"1"},showNetworkTextLegend:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to show node legends in the networks",D:"true"},showIndicators:{M:"Indicators",T:"boolean",C:"Flag to show color, shape and size indicators in several visualizations",D:"true"},createHistogram:{A:"true",O:["x","y"],M:"Functions",T:"option",C:"Create a histogram in 2D-Scatter plots in the 'x' axis or the 'y' axis",U:{Scatter3D:"true",ScatterBubble2D:"true",Scatter2D:"true"}},sma20Color:{M:"Candlestick Plots",T:"color",C:"The color for the 25 day single moving average",D:"rgb(0,0,255)"},smpHairlineColor:{M:"One dimentional plots",T:"color",C:"The color for the thin line that appears in the middle of the bar graphs",D:"rgb(220,220,220)"},axisTitleFont:{A:"true",Z:"true",M:"Ticks and Axis Titles",T:"font",C:"Font for the axis titles in one and two dimensional plots"},functions:{Z:"true",M:"General",T:"array",C:"Functions exposed to the api"},decorationsProperties:{A:"true",M:"Decorations",T:"object",C:"Object to assign properties like color for the network decorations",D:"{}"},ticks:{A:"true",M:"Axes",T:"integer",C:"Number of ticks in the genome browser",D:"50"},showAnimationFont:{A:"true",Z:"true",M:"Animation",T:"font",C:"Font for the text in animations"},nodeFontSize:{A:"true",M:"Network Graphs",T:"integer",C:"Size in pixels for the font size of text in the networks",D:"node width"},sortSamplesByVariable:{S:["sortDir","sortSamplesByCategory"],M:"Functions",T:"option",C:"Sort the samples by the value of a variable",X:"getVariablesAsArray",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},resizerBackgroundImage:{Z:"true",A:"true",M:"Axis Resizer",T:"url",C:"Object to store data when the canvas is zoomed with the axis resizer resizerEventData @type {object}",D:"-1"},sizeDecorationBy:{M:"Network Graphs",T:"string",C:"Name of the attribute to size the network decoration.",D:"false"},setSkin:{O:["blue","grey"],M:"Functions",T:"option",C:"Change the skin of the application"},trackConfigurableProperties:{A:"true",M:"Genome Browser",T:"array",C:"Track configurable properties",D:["'name'","'type'","'height'","'fill'","'outline'","'data'","'hide'","'connect'","'highlight'"],G:"name:[string];Track name;[]"},xAxisTickColor:{M:"Axes",T:"color",C:"Color for the tick lines in the X axis",D:"rgb(220,220,220)"},yAxisTickColor:{M:"Axes",T:"color",C:"Color for the tick lines in the Y axis",D:"rgb(220,220,220)"},isAnimation:{A:"true",Z:"true",M:"Snapshots",T:"boolean",C:"Flag to indicate if there is an active animation"},pieSegmentPrecision:{M:"Pie Charts",T:"integer",C:"Number of decimals for values in the Pie charts",D:"0"},layoutMulticolor:{A:"true",M:"Combination Plots",T:"boolean",C:"Flag to cycle colors when displaying multiple graps in the canvas. If set to false the color will be reseted for every graph.",D:"true"},decorationScaleFontFactor:{A:"true",M:"Decorations",T:"float",C:"Scaling factor used to increse or decrease decoration font size in the canvas.",D:"1"},previousButton:{A:"true",M:"Images",T:"image",C:"Relative path to an image file to the previous button (not including the image directory)",D:"rewind.png"},panningY:{A:"true",M:"Zooming and Panning",T:"float",C:"Number of unit to pan the network in the Y dimension",D:"0"},varTitleColor:{M:"Variables",T:"color",C:"Font color for the variable titles in one dimensional plots",D:"foreground color"},randomDataMean:{A:"true",M:"Data",T:"integer",C:"Mean value when creating random data",D:"100"},transpose:{M:"Functions",T:"void",C:"Transpose the data. It takes no parameters",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",StackedPercentLine:"true",Area:"true",Line:"true",StackedLine:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},smpLabelScaleFontFactor:{M:"Samples",T:"float",C:"Scaling factor used to increse or decrease sample label font size in the canvas.",D:"1"},debug:{A:"true",M:"Debug",T:"boolean",C:"Flag to turn on alerts.",D:"true"},citation:{S:["citationColor"],M:"Titles",T:"string",C:"A reference citation of the graph which is placed at the bottom right corner",D:"false"},smpSort:{A:"true",Z:"true",M:"Data",T:"integer",C:"Sample index used in sorting the data."},resizerBackgroundColorOutlineCurrent:{A:"true",M:"Axis Resizer",T:"color",C:"Color for the div that shows up the current area selected in the axes in the canvas",D:"rgb(153,187,232)"},showAnimation:{A:"true",M:"Animation",T:"boolean",C:"Flag to show or not animation for the graphs",D:"false"},networkFreezeOnLoad:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to prevent autoscaling for the network layout after loading.",D:"false"},layoutTime:{A:"true",M:"Network Graphs",T:"integer",C:"Time in milliseconds used to calculate the layout for the network",D:"15"},xAxisAbsMax:{A:"true",Z:"true",M:"Axes",T:"float",C:"Maximum unfiltered value for the X axis"},isLogData:{M:"Data",T:"boolean",C:"Flag to indicate if the data is Log transformed.",D:"false"},tension:{A:"true",M:"Line Graphs",T:"float",C:"Curvature for the splines",D:"0.3"},axisTickColor:{M:"Ticks and Axis Titles",T:"color",C:"Color for the axis ticks in one and two dimensional plots",D:"foregroung color"},resizerBackgroundColor:{A:"true",M:"Axis Resizer",T:"color",C:"Color for the div that shows up when resizing the axes in the canvas or the whole canvas",D:"rgb(220,220,220)"},zRotate:{A:"true",M:"3D Scatter Plot and Networks",T:"float",C:"Number of degrees to rotate graph arround the Z axis",D:"0"},remoteDirection:{A:"true",O:["next","prev"],M:"Remote Procedures",T:"option",C:"Direction parameter used to obtain data remotely.",D:"next"},featureWidthDefault:{A:"true",M:"Genome Browser",T:"integer",C:"Default size in pixels of the feature width",D:"3"},skinPropertiesBlue:{A:"true",Z:"true",M:"Skins",T:"array",C:"Values for the blue skin",D:"[]"},showVariableNames:{M:"Variables",T:"boolean",C:"Flag to show the variable names in one dimensional plots",D:"true"},lineTickness:{A:"true",M:"Line Graphs",T:"float",C:"Thickness in pixels for line plots",D:"1"},decorationFontSize:{A:"true",M:"Decorations",T:"font",C:"Font size for the decorations in scatter plots and network graphs",D:"10"},fontSize:{A:"true",M:"Text",T:"integer",C:"Font size for text in complex plot only. See other categories to modify specific font sizes.",D:"12"},imageDir:{A:"true",M:"Images",T:"url",C:"Relative path to a directory contaioning images",D:"http://canvasxpress.org/images/"},animationTime:{A:"true",M:"Animation",T:"integer",C:"Time in milliseconds to wait between rendering the plot when showing the animation.",D:"30"},layoutMaxVarLegend:{A:"true",Z:"true",M:"Combination Plots",T:"integer",C:"Maximum length of legend when multiple graphs are displayed in the canvas."},resizable:{A:"true",M:"Events",T:"boolean",C:"Flag to disable resizing the canvas by dragging the mouse over the edges",D:"true"},attractiveForceFunction:{A:"true",O:["Eades","FruchtermanReingold"],M:"Network Graphs",T:"option",C:"Type of function to apply when calculating attractive force in forceDirected network layouts",D:"FruchtermanReingold"},rotationStep:{A:"true",M:"3D Scatter Plot and Networks",T:"integer",C:"Number of degrees used when the plot is automatically rotated",D:"2"},xAxis2Ticks:{A:"true",M:"Axes",T:"integer",C:"Number of ticks in the 2nd X axis",D:"5"},layoutCurrent:{A:"true",Z:"true",M:"Combination Plots",T:"integer",C:"Integer to identify the current graph being displayed in the canvas."},graphType:{O:["Bar","Line","Area","AreaLine","BarLine","Boxplot","Dotplot","Heatmap","Candlestick","Stacked","StackedLine","StackedPercent","StackedPercentLine","Scatter2D","ScatterBubble2D","Scatter3D","Correlation","Pie","Venn","Network","Genome"],M:"General",T:"option",C:"Type of graph",D:"Bar"},distance:{S:["linkage","clusterAxis","centerData","clusterSamples","clusterVariables"],O:["euclidian","manhattan","max"],M:"Clustering",T:"option",C:"Distance metric to use when clustering data.",D:"euclidian"},featureSignalToNoiseShow:{M:"Genome Browser",T:"boolean",C:"Flag use to show quality",D:"true"},layout:{A:"true",M:"Combination Plots",T:"string",C:"Topology of the canvas. Number of rows and columns.",D:"1X1"},marginBottom:{M:"General",T:"integer",C:"Length in pixels for the bottom margin in the canvas",D:"0"},showPieValues:{M:"Pie Charts",T:"float",C:"A flag to show the values for the pie",D:"true"},smpTitleFontSize:{A:"true",M:"Samples",T:"integer",C:"Size for the sample title in one dimensional plots",D:"10"},edgeConfigurableProperties:{A:"true",M:"Network Graphs",T:"array",C:"Edge configurable properties",D:["'width'","'cap'","'exact'","'type'"],E:"width:[integer];Pixel width for the edges between nodes;[],cap:[butt|round|square];Type of cap for the end of the lines;[capType],exact:[boolean];Flag to indicate to create the edge between nodes without substracting the size of the nodes;[],type:[string];Type of line use to join the nodes;[lines]"},decorationsColor:{A:"true",M:"Decorations",T:"color",C:"Color for the decorations in scatter plots and network graphs",D:"foreground color"},freezeRowTop:{A:"true",M:"Data table",T:"integer",C:"Number of rows to freeze at the top of the data table",D:"0"},nodeHighlightColor:{M:"Network Graphs",T:"color",C:"The color for the highlighted nodes.",D:"rgb(255,0,0)"},oddColor:{M:"Attributes",T:"color",C:"The color for the odd numbers in samples or sequences",D:"background color"},capType:{A:"true",O:["butt","round","square"],M:"Attributes",T:"option",C:"Default type of cap for lines.",D:"butt"},showAnimationFontColor:{A:"true",M:"Animation",T:"color",C:"Color for the animation text",D:"background color"},canvasBox:{S:["canvasBoxColor"],M:"General",T:"boolean",C:"Flag to create a box around the canvas",D:"true"},updateCodeDiv:{A:"true",M:"Functions",T:"void",C:"Update the code to generate the plot"},randomNetwork:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to create or not random network for debug and demonstraion purposes",D:"false"},layoutWidth:{A:"true",Z:"true",M:"Combination Plots",T:"float",C:"Width of the current segment of the canvas when there are multiple graphs."},histogramBarWidth:{A:"true",M:"2D Scatter Plot",T:"float",C:"Length in pixels for half of the bar width in the 2D sccaterplot histogram",D:"0.5"},correlationAxis:{O:["samples","variables"],M:"Correlation Graphs",T:"option",C:"Axis used for the correlation.",D:"samples"},zAxisTransformTicks:{M:"Axes",T:"boolean",C:"Flag to transform the values of the ticks in the Z axis",D:"true"},shadowOffsetX:{A:"true",S:["showShadow"],M:"General",T:"integer",C:"Length in pixels for the shadow offset in the X axis.",D:"3"},xAxisTicks:{A:"true",M:"Axes",T:"integer",C:"Number of ticks in the X axis",D:"5"},skinProperties:{A:"true",Z:"true",M:"Skins",T:"array",C:"Properties for the skin",D:["'skinBackgroundColor'","'skinBorderColor'","'skinColor'","'skinShadowColor'"]},setMaxY:{A:"true",M:"Axes",T:"float",C:"Maximum value to set the data in the Y axis",D:"null"},ungroupSamples:{S:["groupSamples"],M:"Functions",T:"void",C:"Ungroup samples previously grouped according to a sample category (data.x  object)",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},legendFontSize:{A:"true",S:["autoScaleFont","legendScaleFontFactor"],M:"Legends",T:"integer",C:"Font size for the legends. Be aware that auto scaling font must be turned off for this property to take effect. A more convenient way to modify the size is to use the legend scaling factor",D:"10"},randomDataSamples:{A:"true",M:"Data",T:"integer",C:"Default number of samples when creating random data",D:"50"},indicatorHeight:{M:"Heatmaps and Networks",T:"integer",C:"Length in pixels for the heatmap indicator",D:"8"},marginLeft:{M:"General",T:"integer",C:"Length in pixels for the left margin in the canvas",D:"0"},xAxis2:{A:"true",M:"Axes",T:"array",C:"Name of the samples groups or variables to be displayed in the 2nd X axis",X:"getSamplesAsArray",D:"[]"},layoutComb:{A:"true",M:"Combination Plots",T:"boolean",C:"Flag that identify that multiple graphs will be displayed in the canvas.",D:"false"},broadcast:{A:"true",M:"Events",T:"boolean",C:"Flag to enable broadcasting to other canvasXpress objects in the page",D:"true"},yAxisTitle:{M:"Axes",T:"string",C:"Title for the Y axis",D:"false"},eventKeys:{A:"true",M:"Events",T:"boolean",C:"Flag to enable key binding events. This prevent some default browser shortcuts and it is system specific. Please see the Event section bellow.",D:"true"},yRotate:{A:"true",M:"3D Scatter Plot and Networks",T:"float",C:"Number of degrees to rotate graph arround the Y axis",D:"0"},featureTraceTrim:{A:"true",M:"Genome Browser",T:"integer",C:"Default triming for nucleotide values in the traces (expressed in percent)",D:"1"},smpTitleFont:{A:"true",Z:"true",M:"Samples",T:"font",C:"Font for the sample title in one dimensional plots"},nextButton:{A:"true",M:"Images",T:"image",C:"Relative path to an image file to the next button (not including the image directory)",D:"fast_forward.png"},sequenceCColor:{M:"Genome Browser",T:"color",C:"Color for the cytosines in the genome browser",D:"rgb(0,255,255)"},segregateVariablesBy:{O:["false","string"],M:"Data",T:"option",C:"String to indicate the annotation used to segregate the variables. It must be a category in the 'data.z' object",D:"false"},yAxisMaxStrLength:{A:"true",Z:"true",M:"Axes",T:"string",C:"Longest string for ticks in the Y axis"},showSmpDendrogram:{M:"Dendrograms",T:"boolean",C:"Flag to show or not the sample dendrogram",D:"false"},showAdvancedConfiguration:{M:"Events",T:"boolean",C:"Flag to show advanced configuration properties.",D:"false"},disableEvents:{A:"true",M:"Events",T:"boolean",C:"Flag to disable all events.",D:"false"},showVarDendrogram:{M:"Dendrograms",T:"boolean",C:"Flag to show or not the variable dendrogram",D:"false"},freezeColRight:{A:"true",M:"Data table",T:"integer",C:"Number of columns to freeze in the right side of the data table",D:"0"},featrureCoordinateHeight:{A:"true",M:"Genome Browser",T:"integer",C:"Default size in pixels of the coordinates height",D:"12"},pieType:{O:["separated","solid"],M:"Pie Charts",T:"option",C:"Position for the pices of the pie",D:"separated"},fonts:{A:"true",Z:"true",M:"Text",T:"array",C:"Font name. It will be set depending on the browser. It could be Optimer, Helvetiker, Gentilis or Verdana, sans-serif"},reset:{M:"Functions",T:"void",C:"Print the canvas"},remoteDataIndex:{A:"true",Z:"true",M:"Remote Procedures",T:"integer",C:"Index of the canvasXpress object requested"},smpLabelColor:{M:"Samples",T:"color",C:"Font color for the sample labels in one dimensional plots",D:"foreground color"},showDecorations:{A:"true",M:"Decorations",T:"boolean",C:"Flag to show or not extra decorations like (regression lines, splines, etc) in scatter plots and (heatmaps, pie charts or stacked bar graphs in) network graphs",D:"false"},approximateNodePositions:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to force approximate X, Y node positions.",D:"false"},heatmapType:{O:["blue","blue-green","blue-red","blue-yellow","blue-cyan","blue-purple","green","green-blue","green-red","green-yellow","green-cyan","green-purple","red","red-blue","red-green","red-yellow","red-cyan","red-purple","yellow","yellow-green","yellow-red","yellow-yellow","yellow-cyan","yellow-purple","cyan","cyan-green","cyan-red","cyan-cyan","cyan-cyan","cyan-purple","purple","purple-green","purple-red","purple-purple","purple-cyan","purple-purple"],M:"Heatmaps and Networks",T:"option",C:"Color shades for the heatmap. It could be red, blue, green, yellow, cyan, purple or any combination of two colors separated by a dash",D:"blue-red"},hideInfoDiv:{A:"true",M:"Functions",T:"void",C:"Hide additional information"},smpTitleScaleFontFactor:{M:"Samples",T:"float",C:"Scaling factor used to increse or decrease sample title font size in the canvas",D:"1"},xAxisTickStyle:{A:"true",O:["solid","dotted"],M:"Axes",T:"option",C:"Style for the tick lines in the X axis",D:"solid"},axisExact:{A:"true",M:"Axes",T:"boolean",C:"Flag to force exact values for the data",D:"false"},selectDataPoint:{A:"true",Z:"true",M:"Scatter Plots",T:"array",C:"Ids of data points (in the data object) to select.",D:"[]"},subtitle:{S:["subtitleHeight","subtitleColor"],M:"Titles",T:"string",C:"Title of the graph.",D:"rgb(0,0,0)"},animationType:{A:"true",O:["grow","spring","random"],M:"Animation",T:"option",C:"Type of animation",D:"grow"},showErrorBars:{M:"Data",T:"boolean",C:"Flag to indicate whether to show or not error bars in the graphs.",D:"true"},colorEdgeBy:{M:"Network Graphs",T:"string",C:"Name of the attribute to color the edges.",D:"false"},margin:{M:"General",T:"integer",C:"Length in pixels for the distance between many areas in the graphs",D:"5"},checkGoogleChromeFrame:{A:"true",M:"Debug",T:"boolean",C:"Flag to check for Google chrome frame if the browser is IE",D:"true"},xAxisMaxStrLength:{A:"true",Z:"true",M:"Axes",T:"string",C:"Longest string for ticks in the X axis"},broadcastType:{A:"true",O:["var","comb"],M:"Events",T:"option",C:"Model for broadcasting to identify either variables or a combination of variable and samples",D:"var"},segregateSamplesBy:{O:["false","string"],M:"Data",T:"option",C:"String to indicate the annotation used to segregate the samples. It must be a category in the 'data.x' object",D:"false"},backgroundType:{S:["backgroundImage","gradientOrientation","backgroundGradient1Color","backgroundGradient2Color"],O:["solid","gradient","window","windowGradient","windowGradient2","windowSolidGradient","image","windowImage"],M:"General",T:"option",C:"Type of background for the canvas. The canvas may have a window for plotting the data which may be a gradient, a solid pattern or an image.",D:"solid"},maxSmpStringLen:{M:"Samples",T:"integer",C:"Maximum length in characters a sample label or description can have so anything above is truncated.",D:"50"},showAnimationFontSize:{A:"true",M:"Animation",T:"integer",C:"Size in pixels for the font size of text involved in the animation",D:"10"},axisExtension:{A:"true",M:"Axes",T:"float",C:"Percentage to extend the values in the data",D:"0.1"},autoAdjust:{A:"true",M:"General",T:"boolean",C:"Flag to automaticaly adjust the size of the canvas in most visualizations. If set to 'false' you can easily adjust the rows and columns in the heatmap visualizations",D:"true"},sequenceMColor:{M:"Genome Browser",T:"color",C:"Color for the degenerate nucleotide sequences in the genome browser",D:"rgb(255,0,255)"},randomDataVariableAnnotations:{A:"true",M:"Data",T:"integer",C:"Default number of variable annotations when creating random data",D:"2"},xAxis2AbsMin:{A:"true",Z:"true",M:"Axes",T:"float",C:"Minimum unfiltered value for the 2nd X axis"},subNetworks:{A:"true",Z:"true",M:"Network Graphs",T:"array",C:"Array to keep independent networks"},showInfoDiv:{A:"true",M:"Functions",T:"void",C:"Show additional information"},yAxisAbsMin:{A:"true",Z:"true",M:"Axes",T:"float",C:"Minimum unfiltered value for the Y axis"},blockContrast:{M:"One dimentional plots",T:"boolean",C:"A flag to creates a shade between the samples so there are two backgrounds, one for the odd samples and one for the even samples.",D:"false"},xAxisExact:{A:"true",M:"Axes",T:"boolean",C:"Flag to force exact values for the data in the X axis",D:"false"},legendBox:{S:["legendBoxColor","legendBackgroundColor"],M:"Legends",T:"boolean",C:"Flag to create a box around the legend",D:"true"},showDataTable:{A:"true",M:"Data table",T:"boolean",C:"Flag to indicate to show the data table",D:"false"},remoteService:{A:"true",M:"Remote Procedures",T:"url",C:"Url used to obtain data remotely. It expects and array of canvasXpress objects",D:"false"},randomDataVariables:{A:"true",M:"Data",T:"integer",C:"Default number of variables when creating random data",D:"50"},gradientRatio:{A:"true",S:["gradientType"],M:"General",T:"float",C:"Ratio used to generate the linear gradients applied to all elements in the visualizations",D:"1.3"},decorationFont:{A:"true",Z:"true",M:"Decorations",T:"font",C:"Font for the decoration in scatter plots and network graphs"},playButton:{A:"true",M:"Images",T:"image",C:"Relative path to an image file to the play button (not including the image directory)",D:"play.png"},zAxisShow:{M:"Axes",T:"boolean",C:"Flag to show on not the values of the ticks in the Z axis",D:"true"},smpOverlays:{M:"Overlays",T:"array",C:"Sample annotations included in the 'data.x' object used in one dimensional plots",D:"[]",X:"getXData"},axisTitleFontSize:{A:"true",S:["autoScaleFont","axisTitleScaleFontFactor"],M:"Ticks and Axis Titles",T:"integer",C:"Font size for the axis titles in one and two dimensional plots. Be aware that auto scaling font must be turned off for this property to take effect. A more convenient way to modify the size is to use the axis title scaling factor",D:"10"},translateY:{A:"true",Z:"true",M:"Combination Plots",T:"float",C:"Amount to translate for the Y axis."},draw:{M:"Functions",T:"void",C:"Redraw the canvas",U:{Network:"true"}},featureNameFontSize:{A:"true",M:"Genome Browser",T:"integer",C:"Size in pixels for the font size of text of the features in the genome browser",D:"8"},xAxisTickFormat:{A:"true",M:"Axes",T:"string",C:"Format for the tick values in the X axis",D:"false"},addRegressionLine:{M:"Functions",T:"void",C:"Add regression line(s) to a 2D-Scatter plot",U:{Scatter3D:"true",ScatterBubble2D:"true",Scatter2D:"true"}},varLabelColor:{M:"Variables",T:"color",C:"Font color for the variable labels in one dimensional plots",D:"foreground color"},nodeSize:{M:"Network Graphs",T:"integer",C:"Length in pixels for the size of the nodes in the network",D:"10 | 20"},maxRows:{A:"true",M:"Data table",T:"integer",C:"Maximum number of rows to display in the data table",D:"10"},yAxisShow:{M:"Axes",T:"boolean",C:"Flag to show on not the values of the ticks in the Y axis",D:"true"},zAxisMinorTicks:{A:"true",M:"Axes",T:"boolean",C:"A flag to show minor tick lines in the Z axis",D:"false"},axisTickFont:{A:"true",Z:"true",M:"Ticks and Axis Titles",T:"font",C:"Font for the axis ticks in one and two dimensional plots"},baseline:{A:"true",O:["top","middle","bottom"],M:"Text",T:"option",C:"Default vertical alignment for drawing text.",D:"right"},smpDendrogramPosition:{M:"Dendrograms",T:"option",C:"Position for the sample dendrogram in the plot. It could be top, bottom, right or left depending on the orientation of the graph.",D:"left"},destroyAllOnClose:{A:"true",M:"Events",T:"boolean",C:"Flag to destroy all canvasXpress objects when removing instances",D:"true"},removeHistogram:{M:"Functions",T:"void",C:"Remove histogram from a 2D-Scatter plot",U:{Scatter3D:"true",ScatterBubble2D:"true",Scatter2D:"true"}},createRandomData:{M:"Functions",T:"void",C:"Create a random data set"},yAxisMinorTicks:{A:"true",M:"Axes",T:"boolean",C:"A flag to show minor tick lines in the Y axis",D:"true"},helpKeyEvents:{A:"true",M:"Events",T:"boolean",C:"Flag to enable help on key events.",D:"true"},shadowOffsetY:{A:"true",S:["showShadow"],M:"General",T:"integer",C:"Length in pixels for the shadow offset in the Y axis.",D:"3"},varSort:{A:"true",Z:"true",M:"Data",T:"integer",C:"Variable index used in sorting the data."},yAxisTicks:{A:"true",M:"Axes",T:"integer",C:"Number of ticks in the Y axis",D:"5"},decorations:{A:"true",M:"Decorations",T:"array",C:"Name of the node properties to include in the network decorations in the 'data.nodes' object",D:"[]"},showCode:{A:"true",M:"Debug",T:"boolean",C:"Flag to show code for the canvas.",D:"false"},autoHideOnDecorationsCenter:{M:"Network Graphs",T:"boolean",C:"Flag to hide node when decorations are positioned on the center",D:"false"},colors:{S:["colorScheme"],M:"Attributes",T:"array",C:"Colors.",D:"colors"},showSampleNames:{M:"Samples",T:"boolean",C:"Flag to show the sample names in one dimensional plots.",D:"true"},panningX:{A:"true",M:"Zooming and Panning",T:"float",C:"Number of unit to pan the network in the X dimension",D:"0"},yAxisCurrent:{A:"true",M:"Axes",T:"integer",C:"Index of the sample that is currently displayed displayed in the Y axis",D:"0"},shadowColor:{A:"true",S:["showShadow"],M:"General",T:"color",C:"Color for the shadow.",D:"rgba(0,0,0,0.5)"},showCodeDiv:{A:"true",M:"Functions",T:"void",C:"Show the code for the plot"},dendrogramSpace:{M:"Dendrograms",T:"integer",C:"Length in pixels to space the branches in the dendrograms.",D:"6"},addNormalDistributionLine:{M:"Functions",T:"void",C:"Add a normaldistribution line(s) to a 2D-Scatter plot",U:{Scatter3D:"true",ScatterBubble2D:"true",Scatter2D:"true"}},kmeansSamples:{S:["kmeansClusters","maxIterations"],M:"Functions",T:"void",C:"Cluster samples using kmeans",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",StackedPercentLine:"true",Area:"true",Line:"true",StackedLine:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},maxTextSize:{A:"true",M:"Text",T:"integer",C:"Maximum size for any text in the canvas.",D:"14"},eventArrowKeys:{A:"true",M:"Events",T:"boolean",C:"Flag to enable arrow key binding events.",D:"true"},xAxisTitle:{M:"Axes",T:"string",C:"Title for the X axis",D:"false"},functionIntervals:{A:"true",M:"2D Scatter Plot",T:"integer",C:"Number of intervals to use when drawing functions in the decorations",D:"20"},gradient:{A:"true",S:["gradientType"],M:"General",T:"boolean",C:"Flag used to apply gradients to all elements ploted in the visualizations according to their corresponding color",D:"false"},genomeResolution:{A:"true",Z:"true",O:["low","medium","high"],M:"Genome Browser",T:"option",C:"Number to adjust the splines curvature"},sma5Color:{M:"Candlestick Plots",T:"color",C:"The color for the 5 day single moving average",D:"rgb(255,0,0)"},nodeFont:{A:"true",Z:"true",M:"Network Graphs",T:"font",C:"Font for the text in networks"},maxCols:{A:"true",M:"Data table",T:"integer",C:"Maximum number of columns to display in the data table",D:"8"},disableConfigurator:{A:"true",M:"Events",T:"boolean",C:"Flag to disable configurator.",D:"false"},colorHSV:{A:"true",Z:"true",M:"Attributes",T:"array",C:"Color HSV. Hue, Saturation and Value used in the configurator"},smpTitle:{M:"Samples",T:"string",C:"Title for the sample axis in one dimensional plots",D:"false"},correlationAnchorLegendAlignWidth:{A:"true",M:"Correlation Graphs",T:"integer",C:"Length in pixels of the height of the correlation anchor legend",D:"40"},shapeEdgeBy:{M:"Network Graphs",T:"string",C:"Name of the attribute to shape the nods.",D:"false"},xAxis2MaxStrLength:{A:"true",Z:"true",M:"Axes",T:"string",C:"Longest string for ticks in the 2nd X axis"},show3DGrid:{A:"true",M:"3D Scatter Plot and Networks",T:"boolean",C:"Flag to show the X,Y,Z grid in scatter 3D plots",D:"true"},randomNetworkNodes:{A:"true",M:"Network Graphs",T:"integer",C:"Default number of nodes when creating random networks",D:"50"},codeType:{A:"true",O:["pretty","compact","tab"],M:"Debug",T:"option",C:"Output type for the JSON code",D:"pretty"},xAxis2MinorValues:{A:"true",M:"Axes",T:"array",C:"Values for the minor ticks in the 2nd X axis",D:"[]"},fontName:{A:"true",O:["Gentilis","Helvetiker","Optimer","Verdana, sans-serif"],M:"Text",T:"font",C:"Font name. It will be set depending on the browser. It could be Optimer, Helvetiker, Gentilis or Verdana, sans-serif",D:"Verdana, sans-serif"},decorationsHeight:{A:"true",M:"Decorations",T:"integer",C:"Length in pixels of the height for the decorations in the networks",D:"20"},highlightSmp:{M:"Samples",T:"array",C:"Name of samples in the 'data.y' object to highlight.",D:"[]",X:"getSamplesAsArray"},dataTableColumnWidth:{Z:"true",M:"Data table",T:"array",C:"Initialize general attributes, shapes, lines etc"},segregateVariables:{S:["segregateVariables"],M:"Functions",T:"option",C:"Segregate variables based on a variable category (data.z object)",X:"getZData",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},coordinateLineColor:{M:"Line Graphs",T:"boolean",C:"Flag to used same color in BarLine plots. If set to true the color of the bars and the lines will be the same",D:"true"},smpIndicesStart:{A:"true",Z:"true",M:"Heatmaps",T:"integer",C:"Number that indicates starting point for samples in heatmaps when the canvas is zoom in."},layoutAxis:{A:"true",Z:"true",O:["1","2","3"],M:"Combination Plots",T:"option",C:"Flag to indicated whether to print axes values when multiple graphs are displayed in the canvas. The possible values are: 1: horizontal, 2: vertical, 3: both"},xAxisCurrent:{A:"true",M:"Axes",T:"integer",C:"Index of the sample that is currently displayed displayed in the X axis",D:"0"},zAxisCurrent:{A:"true",M:"Axes",T:"integer",C:"Index of the sample that is currently displayed displayed in the Z axis",D:"0"},nodeScaleFontFactor:{M:"Network Graphs",T:"float",C:"Scaling factor used to increse or decrease network text font size in the canvas.",D:"1"},evenColor:{M:"Attributes",T:"color",C:"The color for the even numbers in samples or sequences",D:"rgb(240,240,240)"},backgroundWindowGradient2Color:{A:"true",S:["backgroundType"],M:"General",T:"color",C:"The second color of the gradient if the background is a type of window gradient.",D:"rgb(0,0,36)"},startPieSectors:{M:"Pie Charts",T:"float",C:"Starting degrees for pie sectors. 0 is equivalent to 3:00 oclock",D:"0"},legendBoxColor:{S:["legendBox"],M:"Legends",T:"color",C:"Color for the box around the legend",D:"rgb(0,0,0)"},rotationSensitivity:{A:"true",M:"3D Scatter Plot and Networks",T:"integer",C:"Factor to adjust the sensitivity of the mouse when rotating the  graph",D:"45"},font:{A:"true",Z:"true",M:"Text",T:"font",C:"The combination of font name style and size.",D:"Verdana, sans-serif 12pt"},skipClick:{A:"true",Z:"true",M:"Network Graphs",T:"boolean",C:"Flag to skip click events after a mouse down event in the networks when the eventModel is global"},trackNameFontColor:{M:"Genome Browser",T:"color",C:"Color for the text of the tracks in the genome browser",D:"background color"},scaleTextConstantMult:{A:"true",Z:"true",M:"Text",T:"integer",C:"Constants to autoscale text",D:"40"},varLabelDescription:{M:"Variables",T:"string",C:"Variable label description is a valid sample classification included in the 'data.z' object used in heatmaps",D:"false"},images:{A:"true",S:["scatterType"],M:"Attributes",T:"array",C:"Array of urls of images used in scatter plots.",D:"[]"},linkage:{S:["distance","clusterAxis","imputeMethod","centerData","clusterSamples","clusterVariables"],O:["single","complete","average"],M:"Clustering",T:"option",C:"Linkage type to use when clustering data.",D:"single"},smpLabelDescription:{M:"Samples",T:"string",C:"Sample label description is a valid sample classification included in the 'data.x' object used in heatmaps",D:"false"},sequenceStartColor:{M:"Genome Browser",T:"color",C:"Color for the start codon in the genome browser",D:"rgb(0,255,0)"},backgroundGradient1Color:{S:["backgroundType","backgroundGradient2Color"],M:"General",T:"color",C:"The first color of the gradient if the background is a type of gradient.",D:"rgb(0,0,200)"},smpLabelFont:{A:"true",Z:"true",M:"Samples",T:"font",C:"Font for the sample labels in one dimensional plots"},timeValueIndices:{A:"true",M:"Axes",T:"array",C:"Array containig the indices of the values when the the graph is a time series",D:"[]"},legendColor:{M:"Legends",T:"color",C:"Color for the legends",D:"foregroung color"},layoutAdjust:{A:"true",M:"Combination Plots",T:"boolean",C:"Flag to force recalculating the ranges in the axes when multiple graphs are displayed in the canvas.",D:"false"},featureNameFontColor:{M:"Genome Browser",T:"color",C:"Color for the text of the features in the genome browser",D:"background color"},isSelectNodes:{A:"true",Z:"true",M:"Network Graphs",T:"integer",C:"Number of selected nodes (in the data object).",D:"0"},varHighlightColor:{M:"Variables",T:"color",C:"The color for the highlighted variables.",D:"rgb(255,0,0)"},startRow:{A:"true",Z:"true",M:"Data table",T:"boolean",C:"Starting row in the data table"},kmeansClusters:{S:["maxIterations","kmeansSamples","kmeansVariables"],M:"Clustering",T:"integer",C:"Number of clusters when clustering data with kmeans.",D:"3"},remoteAutoPlayDelay:{A:"true",M:"Remote Procedures",T:"integer",C:"Time in milliseconds to wait between iterations over remote data sets",D:"1000"},lines:{A:"true",Z:"true",O:["","dashed","dotted","bezierY","bezierX","curved + arrow","arrowHead","arrowTail","arrowHeadSquareTail","arrowTailSquareHead","square","squareHead","squareTail","squareHeadArrowTail","squareTailArrowHead"],M:"Attributes",T:"array",C:"Line types available network graphs The patterns can be: '', 'dashed', 'dotted', 'bezierY', 'bezierX' and 'curved'. The end could be: 'arrow', 'arrowHead', 'arrowTail', 'arrowHeadSquareTail', 'arrowTailSquareHead', 'square', 'squareHead', 'squareTail', 'squareHeadArrowTail' or 'squareTailArrowHead'."},varTitleScaleFontFactor:{M:"Variables",T:"float",C:"Scaling factor used to increse or decrease variable font size in the canvas.",D:"1"},xAxis2MinorTicks:{A:"true",M:"Axes",T:"boolean",C:"A flag to show minor tick lines in the 2nd X axis",D:"true"},showPieGrid:{M:"Pie Charts",T:"float",C:"A flag to show the labels for the grid when plotting multiple pies",D:"true"},timeFormat:{A:"true",O:["default","shortDate","mediumDate","longDate","fullDate","shortTime","mediumTime","longTime","isoDate","isoTime","isoDateTime","isoUtcDateTime"],M:"Attributes",T:"option",C:"Time Format according to date.format.js Steven Levithan <stevenlevithan.com>",D:"isoDate"},networkStackStates:{A:"true",M:"Network Graphs",T:"integer",C:"Number of states to keep in the network stack after a drag or move",D:"5"},hideCodeDiv:{A:"true",M:"Functions",T:"void",C:"Hide the code for the plot"},sequenceEndColor:{M:"Genome Browser",T:"color",C:"Color for the end codon in the genome browser",D:"rgb(255,0,0)"},trackNameFontSize:{A:"true",M:"Genome Browser",T:"integer",C:"Size in pixels for the font size of text of the tracks in the genome browser",D:"10"},legendFont:{A:"true",Z:"true",M:"Legends",T:"font",C:"Font for the legends"},randomDataSampleAnnotationRatio:{A:"true",M:"Data",T:"integer",C:"Approximate number of classes in each sample annotation when creating random data",D:"2"},xAxis2Values:{A:"true",M:"Axes",T:"array",C:"Values for the ticks in the 2nd X axis",D:"[]"},xAxisTransformTicks:{M:"Axes",T:"boolean",C:"Flag to transform the values of the ticks in the X axis",D:"true"},overrideEventlessNodes:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to override nodes that do not take events to be able to edit them",D:"false"},freezeRowBottom:{A:"true",M:"Data table",T:"integer",C:"Number of rows to freeze at the bottom of the data table",D:"0"},legendScaleFontFactor:{M:"Legends",T:"float",C:"Scaling factor used to increse or decrease legend font size in the canvas.",D:"1"},tmpAsciiArray:{A:"true",Z:"true",M:"Data",T:"array",C:"A temporary array to enable sorting data asciibetically."},sma50Color:{M:"Candlestick Plots",T:"color",C:"The color for the 50 day single moving average",D:"rgb(0,0,0)"},areaIsCumulative:{M:"Area Graphs",T:"boolean",C:"Flag to treat area graphs as cumulative values",D:"false"},stopButton:{A:"true",M:"Images",T:"image",C:"Relative path to an image file to the stop button (not including the image directory)",D:"stop.png"},randomData:{A:"true",M:"Data",T:"boolean",C:"Flag to create or not random data for debug and demonstraion purposes",D:"false"},networkDivisions:{A:"true",Z:"true",M:"Network Graphs",T:"integer",C:"Number of angular divisions in the radial network."},trackNameFont:{A:"true",Z:"true",M:"Genome Browser",T:"font",C:"Font for the text of the tracks in the genome browser"},resizerDraw:{A:"true",M:"Axis Resizer",T:"boolean",C:"Flag to make the axis resizers draw the canvas as they move",D:"true"},temperature:{A:"true",M:"Network Graphs",T:"integer",C:"Temperature to limit displacement at later stages of forceDirected and organic layouts. A value based on the number of node and edges will be assigned if not specified",D:"0"},indicatorWidth:{M:"Heatmaps and Networks",T:"integer",C:"Length in pixels for the heatmap indicator line width used for increase the size of the indicator",D:"1"},panningStep:{A:"true",M:"Zooming and Panning",T:"float",C:"Percentage step for panning networks.",D:"0.2"},featureTypeDefault:{O:["box","bar","heatmap","sequence","triangle","line"],M:"Genome Browser",T:"option",C:"Default type for the feature in the genome browser",D:"line"},sequenceFontSize:{A:"true",M:"Genome Browser",T:"integer",C:"Size in pixels for the font size of text of the sequence in the genome browser",D:"10"},zAxisValues:{A:"true",M:"Axes",T:"array",C:"Values for the ticks in the Z axis",D:"[]"},allVsAllType:{O:["both","upper","lower"],M:"2D Scatter Plot",T:"option",C:"Type for the n-1 x n-1 matrix of 2D sccaterplots",D:"both"},overlayFontSize:{A:"true",M:"Overlays",T:"integer",C:"Font size for the overlays in one dimensional plots",D:"6"},yAxisTransformTicks:{M:"Axes",T:"boolean",C:"Flag to transform the values of the ticks in the Y axis",D:"true"},backgroundWindowGradientOrientation:{A:"true",S:["backgroundType"],O:["vertical","horizontal"],M:"General",T:"string",C:"The orientation for the gradient if the background type is windowGradient or windowGradient2.",D:"vertical"},zAxisTransform:{O:["false","log2","log10","exp2","exp10","percentile"],M:"Axes",T:"option",C:"Tranformation for the values in the Z axis.",D:"false"},isCreateHistogram:{A:"true",Z:"true",M:"2D Scatter Plot",T:"boolean",C:"Flag to indicate there is a histogram",D:"false"},autoScaleFont:{A:"true",S:["smpLabelFontSize","varLabelFontSize","legendFontSize","axisTickFontSize","axisTitleFontSize"],M:"Text",T:"boolean",C:"Flag to automatically adjust the font size in many visualization. Please be aware that scaling factors can still modify the font size. This flag needs to be false for the text to accept the specified font size.",D:"true"},varIndicesStart:{A:"true",Z:"true",M:"Heatmaps",T:"integer",C:"Number that indicates starting point for variables in heatmaps when the canvas is zoom in."},backgroundGradient2Color:{S:["backgroundType","backgroundGradient1Color"],M:"General",T:"color",C:"The second color of the gradient if the background is a type of gradient.",D:"rgb(0,0,36)"},transparency:{A:"true",M:"General",T:"float",C:"Percentage of transparency applied to all elements in the visualiztionss",D:"null"},zAxisTickColor:{M:"Axes",T:"color",C:"Color for the tick lines in the Z axis",D:"rgb(220,220,220)"},useSmpVarIndexOnClustering:{M:"Clustering",T:"boolean",C:"Flag to indicate to use variable or sample index rather than names when clustering. This allows to use '(', ')' and ':' in the variable or sample name",D:"false"},transform:{S:["transformType","transformBase","ratioReference","zscoreAxis"],O:["false","log2","log10","exp2","exp10","percentile","zscore","ratio","ratio2","ratio10","save","reset","undo"],M:"Functions",T:"option",C:"Transform all the data. Warning: the option 'save' overwrites the original data",U:{StackedPercent:"true",Bar:"true",Correletion:"true",Pie:"true",ScatterBubble2D:"true",Barline:"true",StackedLine:"true",Scatter2D:"true",Dotplot:"true",Boxplot:"true",StackedPercentLine:"true",Scatter3D:"true",Area:"true",Line:"true",Stacked:"true",Heatmap:"true",AreaLine:"true"}},transformType:{O:["false","log2","log10","exp2","exp10","percentile","zscore","ratio","ratio2","ratio10","save","reset","undo"],M:"Data",T:"option",C:"Default transformation type.",D:"false"},timeValues:{A:"true",M:"Axes",T:"array",C:"Array containig the tick values when the the graph is a time series",D:"[]"},backgroundWindowGradient1Color:{A:"true",S:["backgroundType"],M:"General",T:"color",C:"The first color of the gradient if the background is a type of window gradient.",D:"rgb(0,0,200)"},maxFeatureStringLen:{M:"Genome Browser",T:"integer",C:"Maximum length in characters a feature label can have so anything above is truncated.",D:"50"},yAxis:{A:"true",M:"Axes",T:"array",C:"Name of the samples groups or variables to be displayed in the Y axis",X:"getSamplesAsArray",D:"[]"},setMinX:{A:"true",M:"Axes",T:"float",C:"Minimum value to set the data in the X axis",D:"null"},sizeBy:{O:["false","variable"],M:"Scatter Plots",T:"option",C:"Name of a variable annotation or a sample name or the string 'variable' to size the variables.",D:"false",X:"getZData"},featureTranslateShow:{M:"Genome Browser",T:"boolean",C:"Flag use to show tranlation",D:"true"},varTitleFont:{A:"true",Z:"true",M:"Variables",T:"font",C:"Font for the variable titles in one dimensional plots"},preScaleNetwork:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to prescale or not the network. This is a aesthetic parameter to make the graph look nicer... Sometimes...",D:"false"},isHistogram:{A:"true",M:"2D Scatter Plot",T:"boolean",C:"Flag to convert the 2D scatter plot into a histogram. That is, the points in the scatter plot are converted to bars that start at the bottom of the Y axis. It is useful to represent proteomics spectra or histograms.",D:"false"},xRotate:{A:"true",M:"3D Scatter Plot and Networks",T:"float",C:"Number of degrees to rotate graph arround the X axis",D:"45"},showLegend:{M:"Legends",T:"boolean",C:"Flag to show or not the legend in the graphs",D:"true"},indicatorCenter:{O:["white","black","rainbow","rainbow-red","rainbow-green"],M:"Heatmaps and Networks",T:"option",C:"Color for the center of the heatmap indicator. If rainbow-red is specified the order of the colors to generate the gradient will be: red - blue - green. If rainbow-green is specified then the order of the colors to generate the gradient will be: green - blue - red. The option rainbow is an alias for rainbow-red.",D:"white"},weight:{A:"true",Z:"true",M:"Combination Plots",T:"float",C:"Fraction of the canvas to be used (a value between 0 and 1). Used when multiple graphs are displayed in one canvas. Could be an number or an array of numbers."},histogramBins:{A:"true",M:"2D Scatter Plot",T:"integer",C:"Number of bins in histogram",D:"20"},yAxisTickStyle:{A:"true",O:["solid","dotted"],M:"Axes",T:"option",C:"Style for the tick lines in the Y axis",D:"solid"},varTitle:{M:"Variables",T:"integer",C:"Title for the sample axis in one dimensional plots",D:"10"},networkFreeze:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to prevent autoscaling for the network layout.",D:"false"},stockIndicators:{O:["Sma5","Sma10","Sma20","Sma25","Sma50"],M:"Candlestick Plots",T:"array",C:"Stock technical indicators",D:"[]"},colorNodeBy:{M:"Network Graphs",T:"string",C:"Name of the attribute to color the nodes.",D:"false"},backgroundImage:{S:["backgroundType"],M:"General",T:"url",C:"Url for the background image",D:"false"},showPieSampleLabel:{M:"Pie Charts",T:"float",C:"A flag to show the sample label when plotting mutliple pies",D:"true"},minTextSize:{A:"true",M:"Text",T:"integer",C:"Minimum size for any text in the canvas.",D:"4"},isBoxPlotCalc:{A:"true",Z:"true",M:"Data",T:"boolean",C:"Flag to indicate if the iqr has been calculated if the graph type is Boxplot."},blockFactor:{A:"true",S:["autoAdjust","blockSeparationFactor"],M:"One dimentional plots",T:"int",C:"Factor to adjust the size of the sample blocks in the one dimensional graphs. The default is 1. If you want to make the blocks wider then increase this parameter (2 is twice as big). This only works if the auto adjust property is set to 'false'",D:"1"},pieSegmentSeparation:{M:"Pie Charts",T:"integer",C:"Length in pixels for the separation of the pieces of the pie charts",D:"3"},timeTicksFirst:{A:"true",M:"Axes",T:"boolean",C:"Flag to indicate whether to use the first date on a time graph or the last",D:"false"},zAxisMinorValues:{A:"true",M:"Axes",T:"array",C:"Values for the minor ticks in the Z axis",D:"[]"},dotLength:{A:"true",M:"Attributes",T:"integer",C:"Size in pixels of the length between dots in the doted lines.",D:"5"},remoteParams:{A:"true",M:"Remote Procedures",T:"object",C:"Object to hold parameters used to obtain data remotely. The target property will be always added to the method as well as the direction [next|prev] (see below.",D:"{}"},smpHighlightColor:{M:"Samples",T:"color",C:"The color for the higlighted samples.",D:"rgb(255,0,0)"},network2DRotate:{A:"true",Z:"true",M:"Network Graphs",T:"integer",C:"Number of degrees to rotate network arround the X axis"},clusterSamples:{S:["distance","linkage","clusterAxis","imputeMethod","centerData"],M:"Functions",T:"void",C:"Cluster samples based on data and generate a dendrogram on the sample axis. It takes no parameters",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",StackedPercentLine:"true",Area:"true",Line:"true",StackedLine:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},arrowPointSize:{A:"true",M:"Attributes",T:"integer",C:"Size in pixels of the arrow head in arrow lines.",D:"10"},yAxisValues:{A:"true",M:"Axes",T:"array",C:"Values for the ticks in the Y axis",D:"[]"},sma25Color:{M:"Candlestick Plots",T:"color",C:"The color for the 25 day single moving average",D:"rgb(255,0,255)"},titleColor:{S:["subtitle","subtitleHeight"],M:"Titles",T:"color",C:"Color for the subtitle",D:"rgb(0,0,0)"},setMax2:{A:"true",M:"Axes",T:"float",C:"Maximum value to set the data in the 2nd axis",D:"null"},sortVariablesByCategory:{S:["sortDir","sortVariablesByCategory"],M:"Functions",T:"option",C:"Sort the variables by the value of a sample",X:"getSamplesAsArray",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},desegregateVariables:{S:["segregateVariables"],M:"Functions",T:"void",C:"Desegregate variables previously segregated based on a variable category (data.z  object)",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},setMax:{A:"true",M:"Axes",T:"float",C:"Maximum value to set the data",D:"null"},tickRotate:{M:"Ticks and Axis Titles",T:"integer",C:"Rotation for graph ticks in degrees. It could be positive or negative.",D:"0"},networkLayoutType:{O:["forceDirected","organic","radial"],M:"Network Graphs",T:"option",C:"Type of network layout.",D:"forceDirected"},zoom:{A:"true",M:"Zooming and Panning",T:"float",C:"Zoom factor for the networks. A number greater than zero",D:"1"},legendBackgroundColor:{S:["legendBox"],M:"Legends",T:"color",C:"Color for the legend background",D:"background color"},citationFont:{A:"true",Z:"true",M:"Titles",T:"font",C:"Font for the reference citation"},initialTemperature:{A:"true",M:"Network Graphs",T:"integer",C:"Initial temperature to limit displacement at later stages of forceDirected and organic layouts. A value based on the number of node and edges will be assigned if not specified",D:"0"},overlayScaleFontFactor:{A:"true",M:"Overlays",T:"float",C:"Scaling factor used to increse or decrease overlays font size in the canvas in one dimensional plots",D:"1"},showNetworkNodesLegend:{A:"true",M:"Network Graphs",T:"boolean",C:"Flag to show node legends in the networks",D:"true"},shadowBlur:{A:"true",S:["showShadow"],M:"General",T:"integer",C:"Amount in blur for the shadow.",D:"2"},varTitleLabelOverlayPosition:{O:["botom","top"],M:"Variables",T:"option",C:"Position for variable labels in heatmaps",D:"bottom"},remoteAutoPlay:{A:"true",M:"Remote Procedures",T:"boolean",C:"Flag to iterate over remote data sets",D:"false"},recalculateLayout:{M:"Functions",T:"void",C:"Recalculate the network layout",U:{Scatter3D:"true",ScatterBubble2D:"true",Scatter2D:"true"}},overlayFontColor:{A:"true",M:"Overlays",T:"color",C:"Color for the overlays in one dimensional plots",D:"foregroung color"},sizeNodeBy:{M:"Network Graphs",T:"string",C:"Name of the attribute to size the nodes.",D:"false"},axisTickFontSize:{A:"true",S:["autoScaleFont","tickScaleFontFactor"],M:"Ticks and Axis Titles",T:"integer",C:"Font size for the axis ticks in one and two dimensional plots. Be aware that auto scaling font must be turned off for this property to take effect. A more convenient way to modify the size is to use the tick scaling factor",D:"10"},snapshotCopyChangeOnly:{A:"true",M:"Animation",T:"boolean",C:"Flag to indicate whether to copy all or only the changed attributes in the network animation. This optimizes memory usage for snapshots.",D:"true"},xAxisMinorTicks:{A:"true",M:"Axes",T:"boolean",C:"A flag to show minor tick lines in the X axis",D:"true"},sequenceGColor:{M:"Genome Browser",T:"color",C:"Color for the guanines in the genome browser",D:"rgb(0,255,0)"},dashLength:{A:"true",M:"Attributes",T:"integer",C:"Size in pixels of the length of the dashes and the separation between the dashes in the dashed lines.",D:"8"},legendPosition:{O:["right","bottom"],M:"Legends",T:"option",C:"Position for the legend in the graphs",D:"right"},zAxisTitle:{M:"Axes",T:"string",C:"Title for the Z axis",D:"false"},groupingFactors:{M:"Data",T:"array",C:"An array that holds the group names used for grouping the data. It must be a category in the 'data.x' object",D:"[]",X:"getXData"},configuratorWidth:{A:"true",M:"Events",T:"integer",C:"Size in pixels for the configurator.",D:"300"},networkRoot:{M:"Network Graphs",T:"string",C:"Node Id of the network root.",D:"false"},translateX:{A:"true",Z:"true",M:"Combination Plots",T:"float",C:"Amount to translate for the X axis."},varOverlays:{M:"Overlays",T:"array",C:"Variable annotations included in the 'data.z' object used in one dimensional plots",D:"[]",X:"getZData"},foreground:{M:"General",T:"color",C:"Foreground color for the canvas",D:"rgb(0,0,0)"},remoteUpdating:{A:"true",Z:"true",M:"Remote Procedures",T:"boolean",C:"Flag to indicate that updating data is in progress"},rowHeight:{A:"true",M:"Data table",T:"integer",C:"Mumber of pixels for the height of cells in the data table",D:"100"},blockSeparationFactor:{A:"true",S:["autoAdjust","blockFactor"],M:"One dimentional plots",T:"int",C:"Factor to adjust the spacing between the sample blocks in the one dimensional graphs. The default is 1. If you  want to make the blocks wider apart then increse this parameter (2 is twice as much). This only works if the auto adjust property is set to 'false'",D:"1"},scatterType:{O:["false","line","bar","image","lineImage"],M:"Scatter Plots",T:"option",C:"Type of scatter plot",D:"false"},dendrogramHang:{M:"Dendrograms",T:"boolean",C:"Flag to show or not the nodes in the dendrogram as hanging or not similar to that one in R",D:"false"},featureQualityValues:{M:"Genome Browser",T:"boolean",C:"Flag use to show values for the quality",D:"false"},repulsiveForceFunction:{A:"true",O:["square","log","pow","sqrt"],M:"Network Graphs",T:"option",C:"Type of function to apply when calculating repulsive force in forceDirected network layouts",D:"square"},resizerPosition:{A:"true",O:["top","rigth","bottom","left"],M:"Axis Resizer",T:"option",C:"Position for the axis resizer in complex plots",D:"bottom"},vennGroups:{M:"Venn Diagrams",T:"integer",C:"Number of groups in the Venn diagram",D:"4"},zAxis:{A:"true",M:"Axes",T:"array",C:"Name of the samples groups or variables to be displayed in the Z axis",X:"getSamplesAsArray",D:"[]"},lineType:{O:["rect","spline"],M:"Line Graphs",T:"option",C:"Type of line used to join the points in line graphs",D:"rect"},zscoreAxis:{O:["samples","variables"],M:"Data",T:"option",C:"Default axis to use to zsore the data.",D:"samples"},decorationsWidth:{A:"true",M:"Decorations",T:"integer",C:"Length in pixels of the width for the decorations in the networks",D:"10"},featureStaggered:{M:"Genome Browser",T:"boolean",C:"Flag use to stagger the features in the genome panel",D:"false"},yAxisAbsMax:{A:"true",Z:"true",M:"Axes",T:"float",C:"Maximum unfiltered value for the Y axis"},maxPieSectors:{M:"Pie Charts",T:"float",C:"Max pie sectors. After that number the sectors will be put in a sector named 'other'.",D:"20"},xAxisAbsMin:{A:"true",Z:"true",M:"Axes",T:"float",C:"Minimum unfiltered value for the X axis"},networkForceConstant:{A:"true",M:"Network Graphs",T:"float",C:"Constant used for calculating attractive and repulsive forces in forcedDirected and organic layouts. A value based on the average area per node will be assigned if not specified",D:"0"},selectedBackgroundColor:{A:"true",M:"Skins",T:"color",C:"Color for the selected objects in the canvas",D:"rgb(208,222,240)"},networkShowDataTable:{A:"true",O:["nodes","edges"],M:"Data table",T:"option",C:"Show nodes or edges on data table",D:"nodes"},vennColors:{A:"true",S:["colors"],M:"Venn Diagrams",T:"array",C:"Colors for the Venn bubles. If not specified the colors will be chosen from the colors array. Colors in this array need to be at least the same number of groups in the Venn diagram",D:"[]"},overlaysWidth:{A:"true",M:"Overlays",T:"integer",C:"Length in pixels of the width for the colored boxes to clasify samples and or variables in one dimensional plots",D:"30"},scaleX:{A:"true",Z:"true",M:"Combination Plots",T:"float",C:"Scale factor for the X axis"},gradientType:{A:"true",S:["gradient"],O:["linear","radial"],M:"General",T:"option",C:"Type of patern used for the gradients applied to all elements in the visualizations",D:"radial"},"this":{A:"true",Z:"true",M:"Events",T:"time",C:"Time in milliseconds to keep track of time"},showDataValues:{M:"Bar Graphs",T:"boolean",C:"Flag to indicate whether to show data values in the one bar graphs.",D:"false"},allVsAll:{M:"2D Scatter Plot",T:"boolean",C:"Flag to plot an n-1 x n-1 matrix of 2D sccaterplots",D:"false"},resizerType:{A:"true",O:["false","samples","box"],M:"Axis Resizer",T:"option",C:"String to indicate the type of axis resizer in complex plots",D:"false"},featureTracesShow:{M:"Genome Browser",T:"boolean",C:"Flag use to show traces",D:"true"},hideUnhideSmps:{M:"Functions",T:"array",C:"Hide or unhide samples. It works like a switch",X:"getSamplesAsArray",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},decorationsColors:{A:"true",M:"Decorations",T:"array",C:"Array of colors used for selection in network decorations not to be confused by its singular form 'decorationsColor' above",D:"[]"},zAxisAbsMax:{A:"true",Z:"true",M:"Axes",T:"float",C:"Maximum unfiltered value for the Z axis"},imputeMethod:{S:["distance","linkage","clusterAxis","centerData","clusterSamples","clusterVariables"],O:["mean","median"],M:"Clustering",T:"option",C:"Imputation method for missing data when clustering",D:"mean"},isMarketSwitched:{A:"true",Z:"true",M:"Data",T:"boolean",C:"Flag to indicate if the data is a Candlestick."},randomMissingDataPercentage:{A:"true",M:"Data",T:"integer",C:"Default percentege of missing values when creating random data",D:"0"},highlightVar:{M:"Variables",T:"array",C:"Name of variables in the 'data.y' object to highlight.",D:"[]",X:"getVariablesAsArray"},smpHairline:{O:["false","solid","dotted"],M:"One dimentional plots",T:"option",C:"This is a thin line that appears in the middle of the bar graphs just for aesthetics.",D:"dotted"},sortSamplesByCategory:{S:["sortDir","sortSamplesByVariable"],M:"Functions",T:"option",C:"Sort the samples by a sample category (data.x  object)",X:"getXData",U:{StackedPercent:"true",Boxplot:"true",Bar:"true",Correletion:"true",StackedPercentLine:"true",Pie:"true",Barline:"true",Area:"true",StackedLine:"true",Line:"true",Dotplot:"true",AreaLine:"true",Heatmap:"true",Stacked:"true"}},fontStyle:{A:"true",O:["false","bold","italic"],M:"Text",T:"option",C:"Font style. Not implemented yet.",D:"false"},showVolume:{M:"Candlestick Plots",T:"boolean",C:"Flag to show or not volume in the candlestick graphs",D:"true"},modelEvent:{A:"true",O:["global","local"],M:"Events",T:"option",C:"Model to handle the events. Experimental",D:"global"},sma10Color:{M:"Candlestick Plots",T:"color",C:"The color for the 5 day single moving average",D:"rgb(0,255,0)"},gradientOrientation:{A:"true",S:["backgroundType"],O:["vertical","horizontal"],M:"General",T:"option",C:"The orientation for the gradient if the background type is windowGradient or windowGradient2.",D:"vertical"},refresehDataTableOnDraw:{A:"true",M:"Data table",T:"boolean",C:"Flag to indicate to refresh data after drawing the plot",D:"true"},smpLabelFontSize:{A:"true",S:["autoScaleFont","smpLabelScaleFontFactor"],M:"Samples",T:"integer",C:"Size for the sample labels in one dimensional plots. Be aware that auto scaling font must be turned off for this property to take effect. A more convenient way to modify the size is to use the sample label scaling factor",D:"10"},varLabelFontSize:{A:"true",S:["autoScaleFont","varLabelScaleFontFactor"],M:"Variables",T:"integer",C:"Size for the variable labels in one dimensional plots. Be aware that auto scaling font must be turned off for this property to take effect. A more convenient way to modify the size is to use the variable label scaling factor",D:"10"},maxRotate:{A:"true",M:"3D Scatter Plot and Networks",T:"float",C:"Maximum number of degrees to rotate graph arround axes",D:"false"},sequenceAColor:{M:"Genome Browser",T:"color",C:"Color for the adenines in the genome browser",D:"rgb(255,255,0)"},clusterVariables:{S:["distance","linkage","clusterAxis","imputeMethod","centerData"],M:"Functions",T:"void",C:"Cluster variables based on data and generate a dendrogram on the variable axis. It takes no parameters",U:{Heatmap:"true"}},xAxis2TickFormat:{A:"true",M:"Axes",T:"string",C:"Format for the tick values in the second X axis",D:"false"},highlightNode:{M:"Network Graphs",T:"array",C:"Name of nodes in the 'data.nodes' object to highlight.",D:"[]"},dataEvent:{A:"true",Z:"true",M:"Events",T:"array",C:"Array to store the areas that will trigger an event"},snapshots:{A:"true",Z:"true",M:"Snapshots",T:"array",C:"Array to hold the data used in the animation"}},G:{name:{M:"Genome",T:"string",C:"Track name"}},E:{cap:{O:"butt, round, square",M:"Network",T:"option",C:"Type of cap for the end of the lines"},width:{M:"Network",T:"integer",C:"Pixel width for the edges between nodes"},exact:{M:"Network",T:"boolean",C:"Flag to indicate to create the edge between nodes without substracting the size of the nodes"},type:{M:"Network",T:"string",C:"Type of line use to join the nodes"}}};